function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var jsxRuntime = {exports: {}};

var reactJsxRuntime_development = {};

var react = {exports: {}};

var react_development = {exports: {}};

react_development.exports;

var hasRequiredReact_development;

function requireReact_development () {
	if (hasRequiredReact_development) return react_development.exports;
	hasRequiredReact_development = 1;
	(function (module, exports) {
		var define_process_env_default = {};
		/**
		 * @license React
		 * react.development.js
		 *
		 * Copyright (c) Facebook, Inc. and its affiliates.
		 *
		 * This source code is licensed under the MIT license found in the
		 * LICENSE file in the root directory of this source tree.
		 */
		if (define_process_env_default.NODE_ENV !== "production") {
		  (function() {
		    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
		      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
		    }
		    var ReactVersion = "18.2.0";
		    var REACT_ELEMENT_TYPE = Symbol.for("react.element");
		    var REACT_PORTAL_TYPE = Symbol.for("react.portal");
		    var REACT_FRAGMENT_TYPE = Symbol.for("react.fragment");
		    var REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode");
		    var REACT_PROFILER_TYPE = Symbol.for("react.profiler");
		    var REACT_PROVIDER_TYPE = Symbol.for("react.provider");
		    var REACT_CONTEXT_TYPE = Symbol.for("react.context");
		    var REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref");
		    var REACT_SUSPENSE_TYPE = Symbol.for("react.suspense");
		    var REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list");
		    var REACT_MEMO_TYPE = Symbol.for("react.memo");
		    var REACT_LAZY_TYPE = Symbol.for("react.lazy");
		    var REACT_OFFSCREEN_TYPE = Symbol.for("react.offscreen");
		    var MAYBE_ITERATOR_SYMBOL = Symbol.iterator;
		    var FAUX_ITERATOR_SYMBOL = "@@iterator";
		    function getIteratorFn(maybeIterable) {
		      if (maybeIterable === null || typeof maybeIterable !== "object") {
		        return null;
		      }
		      var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
		      if (typeof maybeIterator === "function") {
		        return maybeIterator;
		      }
		      return null;
		    }
		    var ReactCurrentDispatcher = {
		      /**
		       * @internal
		       * @type {ReactComponent}
		       */
		      current: null
		    };
		    var ReactCurrentBatchConfig = {
		      transition: null
		    };
		    var ReactCurrentActQueue = {
		      current: null,
		      // Used to reproduce behavior of `batchedUpdates` in legacy mode.
		      isBatchingLegacy: false,
		      didScheduleLegacyUpdate: false
		    };
		    var ReactCurrentOwner = {
		      /**
		       * @internal
		       * @type {ReactComponent}
		       */
		      current: null
		    };
		    var ReactDebugCurrentFrame = {};
		    var currentExtraStackFrame = null;
		    function setExtraStackFrame(stack) {
		      {
		        currentExtraStackFrame = stack;
		      }
		    }
		    {
		      ReactDebugCurrentFrame.setExtraStackFrame = function(stack) {
		        {
		          currentExtraStackFrame = stack;
		        }
		      };
		      ReactDebugCurrentFrame.getCurrentStack = null;
		      ReactDebugCurrentFrame.getStackAddendum = function() {
		        var stack = "";
		        if (currentExtraStackFrame) {
		          stack += currentExtraStackFrame;
		        }
		        var impl = ReactDebugCurrentFrame.getCurrentStack;
		        if (impl) {
		          stack += impl() || "";
		        }
		        return stack;
		      };
		    }
		    var enableScopeAPI = false;
		    var enableCacheElement = false;
		    var enableTransitionTracing = false;
		    var enableLegacyHidden = false;
		    var enableDebugTracing = false;
		    var ReactSharedInternals = {
		      ReactCurrentDispatcher,
		      ReactCurrentBatchConfig,
		      ReactCurrentOwner
		    };
		    {
		      ReactSharedInternals.ReactDebugCurrentFrame = ReactDebugCurrentFrame;
		      ReactSharedInternals.ReactCurrentActQueue = ReactCurrentActQueue;
		    }
		    function warn(format) {
		      {
		        {
		          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
		            args[_key - 1] = arguments[_key];
		          }
		          printWarning("warn", format, args);
		        }
		      }
		    }
		    function error(format) {
		      {
		        {
		          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
		            args[_key2 - 1] = arguments[_key2];
		          }
		          printWarning("error", format, args);
		        }
		      }
		    }
		    function printWarning(level, format, args) {
		      {
		        var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
		        var stack = ReactDebugCurrentFrame2.getStackAddendum();
		        if (stack !== "") {
		          format += "%s";
		          args = args.concat([stack]);
		        }
		        var argsWithFormat = args.map(function(item) {
		          return String(item);
		        });
		        argsWithFormat.unshift("Warning: " + format);
		        Function.prototype.apply.call(console[level], console, argsWithFormat);
		      }
		    }
		    var didWarnStateUpdateForUnmountedComponent = {};
		    function warnNoop(publicInstance, callerName) {
		      {
		        var _constructor = publicInstance.constructor;
		        var componentName = _constructor && (_constructor.displayName || _constructor.name) || "ReactClass";
		        var warningKey = componentName + "." + callerName;
		        if (didWarnStateUpdateForUnmountedComponent[warningKey]) {
		          return;
		        }
		        error("Can't call %s on a component that is not yet mounted. This is a no-op, but it might indicate a bug in your application. Instead, assign to `this.state` directly or define a `state = {};` class property with the desired state in the %s component.", callerName, componentName);
		        didWarnStateUpdateForUnmountedComponent[warningKey] = true;
		      }
		    }
		    var ReactNoopUpdateQueue = {
		      /**
		       * Checks whether or not this composite component is mounted.
		       * @param {ReactClass} publicInstance The instance we want to test.
		       * @return {boolean} True if mounted, false otherwise.
		       * @protected
		       * @final
		       */
		      isMounted: function(publicInstance) {
		        return false;
		      },
		      /**
		       * Forces an update. This should only be invoked when it is known with
		       * certainty that we are **not** in a DOM transaction.
		       *
		       * You may want to call this when you know that some deeper aspect of the
		       * component's state has changed but `setState` was not called.
		       *
		       * This will not invoke `shouldComponentUpdate`, but it will invoke
		       * `componentWillUpdate` and `componentDidUpdate`.
		       *
		       * @param {ReactClass} publicInstance The instance that should rerender.
		       * @param {?function} callback Called after component is updated.
		       * @param {?string} callerName name of the calling function in the public API.
		       * @internal
		       */
		      enqueueForceUpdate: function(publicInstance, callback, callerName) {
		        warnNoop(publicInstance, "forceUpdate");
		      },
		      /**
		       * Replaces all of the state. Always use this or `setState` to mutate state.
		       * You should treat `this.state` as immutable.
		       *
		       * There is no guarantee that `this.state` will be immediately updated, so
		       * accessing `this.state` after calling this method may return the old value.
		       *
		       * @param {ReactClass} publicInstance The instance that should rerender.
		       * @param {object} completeState Next state.
		       * @param {?function} callback Called after component is updated.
		       * @param {?string} callerName name of the calling function in the public API.
		       * @internal
		       */
		      enqueueReplaceState: function(publicInstance, completeState, callback, callerName) {
		        warnNoop(publicInstance, "replaceState");
		      },
		      /**
		       * Sets a subset of the state. This only exists because _pendingState is
		       * internal. This provides a merging strategy that is not available to deep
		       * properties which is confusing. TODO: Expose pendingState or don't use it
		       * during the merge.
		       *
		       * @param {ReactClass} publicInstance The instance that should rerender.
		       * @param {object} partialState Next partial state to be merged with state.
		       * @param {?function} callback Called after component is updated.
		       * @param {?string} Name of the calling function in the public API.
		       * @internal
		       */
		      enqueueSetState: function(publicInstance, partialState, callback, callerName) {
		        warnNoop(publicInstance, "setState");
		      }
		    };
		    var assign = Object.assign;
		    var emptyObject = {};
		    {
		      Object.freeze(emptyObject);
		    }
		    function Component(props, context, updater) {
		      this.props = props;
		      this.context = context;
		      this.refs = emptyObject;
		      this.updater = updater || ReactNoopUpdateQueue;
		    }
		    Component.prototype.isReactComponent = {};
		    Component.prototype.setState = function(partialState, callback) {
		      if (typeof partialState !== "object" && typeof partialState !== "function" && partialState != null) {
		        throw new Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");
		      }
		      this.updater.enqueueSetState(this, partialState, callback, "setState");
		    };
		    Component.prototype.forceUpdate = function(callback) {
		      this.updater.enqueueForceUpdate(this, callback, "forceUpdate");
		    };
		    {
		      var deprecatedAPIs = {
		        isMounted: ["isMounted", "Instead, make sure to clean up subscriptions and pending requests in componentWillUnmount to prevent memory leaks."],
		        replaceState: ["replaceState", "Refactor your code to use setState instead (see https://github.com/facebook/react/issues/3236)."]
		      };
		      var defineDeprecationWarning = function(methodName, info) {
		        Object.defineProperty(Component.prototype, methodName, {
		          get: function() {
		            warn("%s(...) is deprecated in plain JavaScript React classes. %s", info[0], info[1]);
		            return void 0;
		          }
		        });
		      };
		      for (var fnName in deprecatedAPIs) {
		        if (deprecatedAPIs.hasOwnProperty(fnName)) {
		          defineDeprecationWarning(fnName, deprecatedAPIs[fnName]);
		        }
		      }
		    }
		    function ComponentDummy() {
		    }
		    ComponentDummy.prototype = Component.prototype;
		    function PureComponent(props, context, updater) {
		      this.props = props;
		      this.context = context;
		      this.refs = emptyObject;
		      this.updater = updater || ReactNoopUpdateQueue;
		    }
		    var pureComponentPrototype = PureComponent.prototype = new ComponentDummy();
		    pureComponentPrototype.constructor = PureComponent;
		    assign(pureComponentPrototype, Component.prototype);
		    pureComponentPrototype.isPureReactComponent = true;
		    function createRef() {
		      var refObject = {
		        current: null
		      };
		      {
		        Object.seal(refObject);
		      }
		      return refObject;
		    }
		    var isArrayImpl = Array.isArray;
		    function isArray(a) {
		      return isArrayImpl(a);
		    }
		    function typeName(value) {
		      {
		        var hasToStringTag = typeof Symbol === "function" && Symbol.toStringTag;
		        var type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
		        return type;
		      }
		    }
		    function willCoercionThrow(value) {
		      {
		        try {
		          testStringCoercion(value);
		          return false;
		        } catch (e) {
		          return true;
		        }
		      }
		    }
		    function testStringCoercion(value) {
		      return "" + value;
		    }
		    function checkKeyStringCoercion(value) {
		      {
		        if (willCoercionThrow(value)) {
		          error("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value));
		          return testStringCoercion(value);
		        }
		      }
		    }
		    function getWrappedName(outerType, innerType, wrapperName) {
		      var displayName = outerType.displayName;
		      if (displayName) {
		        return displayName;
		      }
		      var functionName = innerType.displayName || innerType.name || "";
		      return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
		    }
		    function getContextName(type) {
		      return type.displayName || "Context";
		    }
		    function getComponentNameFromType(type) {
		      if (type == null) {
		        return null;
		      }
		      {
		        if (typeof type.tag === "number") {
		          error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue.");
		        }
		      }
		      if (typeof type === "function") {
		        return type.displayName || type.name || null;
		      }
		      if (typeof type === "string") {
		        return type;
		      }
		      switch (type) {
		        case REACT_FRAGMENT_TYPE:
		          return "Fragment";
		        case REACT_PORTAL_TYPE:
		          return "Portal";
		        case REACT_PROFILER_TYPE:
		          return "Profiler";
		        case REACT_STRICT_MODE_TYPE:
		          return "StrictMode";
		        case REACT_SUSPENSE_TYPE:
		          return "Suspense";
		        case REACT_SUSPENSE_LIST_TYPE:
		          return "SuspenseList";
		      }
		      if (typeof type === "object") {
		        switch (type.$$typeof) {
		          case REACT_CONTEXT_TYPE:
		            var context = type;
		            return getContextName(context) + ".Consumer";
		          case REACT_PROVIDER_TYPE:
		            var provider = type;
		            return getContextName(provider._context) + ".Provider";
		          case REACT_FORWARD_REF_TYPE:
		            return getWrappedName(type, type.render, "ForwardRef");
		          case REACT_MEMO_TYPE:
		            var outerName = type.displayName || null;
		            if (outerName !== null) {
		              return outerName;
		            }
		            return getComponentNameFromType(type.type) || "Memo";
		          case REACT_LAZY_TYPE: {
		            var lazyComponent = type;
		            var payload = lazyComponent._payload;
		            var init = lazyComponent._init;
		            try {
		              return getComponentNameFromType(init(payload));
		            } catch (x) {
		              return null;
		            }
		          }
		        }
		      }
		      return null;
		    }
		    var hasOwnProperty = Object.prototype.hasOwnProperty;
		    var RESERVED_PROPS = {
		      key: true,
		      ref: true,
		      __self: true,
		      __source: true
		    };
		    var specialPropKeyWarningShown, specialPropRefWarningShown, didWarnAboutStringRefs;
		    {
		      didWarnAboutStringRefs = {};
		    }
		    function hasValidRef(config) {
		      {
		        if (hasOwnProperty.call(config, "ref")) {
		          var getter = Object.getOwnPropertyDescriptor(config, "ref").get;
		          if (getter && getter.isReactWarning) {
		            return false;
		          }
		        }
		      }
		      return config.ref !== void 0;
		    }
		    function hasValidKey(config) {
		      {
		        if (hasOwnProperty.call(config, "key")) {
		          var getter = Object.getOwnPropertyDescriptor(config, "key").get;
		          if (getter && getter.isReactWarning) {
		            return false;
		          }
		        }
		      }
		      return config.key !== void 0;
		    }
		    function defineKeyPropWarningGetter(props, displayName) {
		      var warnAboutAccessingKey = function() {
		        {
		          if (!specialPropKeyWarningShown) {
		            specialPropKeyWarningShown = true;
		            error("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
		          }
		        }
		      };
		      warnAboutAccessingKey.isReactWarning = true;
		      Object.defineProperty(props, "key", {
		        get: warnAboutAccessingKey,
		        configurable: true
		      });
		    }
		    function defineRefPropWarningGetter(props, displayName) {
		      var warnAboutAccessingRef = function() {
		        {
		          if (!specialPropRefWarningShown) {
		            specialPropRefWarningShown = true;
		            error("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
		          }
		        }
		      };
		      warnAboutAccessingRef.isReactWarning = true;
		      Object.defineProperty(props, "ref", {
		        get: warnAboutAccessingRef,
		        configurable: true
		      });
		    }
		    function warnIfStringRefCannotBeAutoConverted(config) {
		      {
		        if (typeof config.ref === "string" && ReactCurrentOwner.current && config.__self && ReactCurrentOwner.current.stateNode !== config.__self) {
		          var componentName = getComponentNameFromType(ReactCurrentOwner.current.type);
		          if (!didWarnAboutStringRefs[componentName]) {
		            error('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', componentName, config.ref);
		            didWarnAboutStringRefs[componentName] = true;
		          }
		        }
		      }
		    }
		    var ReactElement = function(type, key, ref, self, source, owner, props) {
		      var element = {
		        // This tag allows us to uniquely identify this as a React Element
		        $$typeof: REACT_ELEMENT_TYPE,
		        // Built-in properties that belong on the element
		        type,
		        key,
		        ref,
		        props,
		        // Record the component responsible for creating this element.
		        _owner: owner
		      };
		      {
		        element._store = {};
		        Object.defineProperty(element._store, "validated", {
		          configurable: false,
		          enumerable: false,
		          writable: true,
		          value: false
		        });
		        Object.defineProperty(element, "_self", {
		          configurable: false,
		          enumerable: false,
		          writable: false,
		          value: self
		        });
		        Object.defineProperty(element, "_source", {
		          configurable: false,
		          enumerable: false,
		          writable: false,
		          value: source
		        });
		        if (Object.freeze) {
		          Object.freeze(element.props);
		          Object.freeze(element);
		        }
		      }
		      return element;
		    };
		    function createElement(type, config, children) {
		      var propName;
		      var props = {};
		      var key = null;
		      var ref = null;
		      var self = null;
		      var source = null;
		      if (config != null) {
		        if (hasValidRef(config)) {
		          ref = config.ref;
		          {
		            warnIfStringRefCannotBeAutoConverted(config);
		          }
		        }
		        if (hasValidKey(config)) {
		          {
		            checkKeyStringCoercion(config.key);
		          }
		          key = "" + config.key;
		        }
		        self = config.__self === void 0 ? null : config.__self;
		        source = config.__source === void 0 ? null : config.__source;
		        for (propName in config) {
		          if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
		            props[propName] = config[propName];
		          }
		        }
		      }
		      var childrenLength = arguments.length - 2;
		      if (childrenLength === 1) {
		        props.children = children;
		      } else if (childrenLength > 1) {
		        var childArray = Array(childrenLength);
		        for (var i = 0; i < childrenLength; i++) {
		          childArray[i] = arguments[i + 2];
		        }
		        {
		          if (Object.freeze) {
		            Object.freeze(childArray);
		          }
		        }
		        props.children = childArray;
		      }
		      if (type && type.defaultProps) {
		        var defaultProps = type.defaultProps;
		        for (propName in defaultProps) {
		          if (props[propName] === void 0) {
		            props[propName] = defaultProps[propName];
		          }
		        }
		      }
		      {
		        if (key || ref) {
		          var displayName = typeof type === "function" ? type.displayName || type.name || "Unknown" : type;
		          if (key) {
		            defineKeyPropWarningGetter(props, displayName);
		          }
		          if (ref) {
		            defineRefPropWarningGetter(props, displayName);
		          }
		        }
		      }
		      return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
		    }
		    function cloneAndReplaceKey(oldElement, newKey) {
		      var newElement = ReactElement(oldElement.type, newKey, oldElement.ref, oldElement._self, oldElement._source, oldElement._owner, oldElement.props);
		      return newElement;
		    }
		    function cloneElement(element, config, children) {
		      if (element === null || element === void 0) {
		        throw new Error("React.cloneElement(...): The argument must be a React element, but you passed " + element + ".");
		      }
		      var propName;
		      var props = assign({}, element.props);
		      var key = element.key;
		      var ref = element.ref;
		      var self = element._self;
		      var source = element._source;
		      var owner = element._owner;
		      if (config != null) {
		        if (hasValidRef(config)) {
		          ref = config.ref;
		          owner = ReactCurrentOwner.current;
		        }
		        if (hasValidKey(config)) {
		          {
		            checkKeyStringCoercion(config.key);
		          }
		          key = "" + config.key;
		        }
		        var defaultProps;
		        if (element.type && element.type.defaultProps) {
		          defaultProps = element.type.defaultProps;
		        }
		        for (propName in config) {
		          if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
		            if (config[propName] === void 0 && defaultProps !== void 0) {
		              props[propName] = defaultProps[propName];
		            } else {
		              props[propName] = config[propName];
		            }
		          }
		        }
		      }
		      var childrenLength = arguments.length - 2;
		      if (childrenLength === 1) {
		        props.children = children;
		      } else if (childrenLength > 1) {
		        var childArray = Array(childrenLength);
		        for (var i = 0; i < childrenLength; i++) {
		          childArray[i] = arguments[i + 2];
		        }
		        props.children = childArray;
		      }
		      return ReactElement(element.type, key, ref, self, source, owner, props);
		    }
		    function isValidElement(object) {
		      return typeof object === "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
		    }
		    var SEPARATOR = ".";
		    var SUBSEPARATOR = ":";
		    function escape(key) {
		      var escapeRegex = /[=:]/g;
		      var escaperLookup = {
		        "=": "=0",
		        ":": "=2"
		      };
		      var escapedString = key.replace(escapeRegex, function(match) {
		        return escaperLookup[match];
		      });
		      return "$" + escapedString;
		    }
		    var didWarnAboutMaps = false;
		    var userProvidedKeyEscapeRegex = /\/+/g;
		    function escapeUserProvidedKey(text) {
		      return text.replace(userProvidedKeyEscapeRegex, "$&/");
		    }
		    function getElementKey(element, index) {
		      if (typeof element === "object" && element !== null && element.key != null) {
		        {
		          checkKeyStringCoercion(element.key);
		        }
		        return escape("" + element.key);
		      }
		      return index.toString(36);
		    }
		    function mapIntoArray(children, array, escapedPrefix, nameSoFar, callback) {
		      var type = typeof children;
		      if (type === "undefined" || type === "boolean") {
		        children = null;
		      }
		      var invokeCallback = false;
		      if (children === null) {
		        invokeCallback = true;
		      } else {
		        switch (type) {
		          case "string":
		          case "number":
		            invokeCallback = true;
		            break;
		          case "object":
		            switch (children.$$typeof) {
		              case REACT_ELEMENT_TYPE:
		              case REACT_PORTAL_TYPE:
		                invokeCallback = true;
		            }
		        }
		      }
		      if (invokeCallback) {
		        var _child = children;
		        var mappedChild = callback(_child);
		        var childKey = nameSoFar === "" ? SEPARATOR + getElementKey(_child, 0) : nameSoFar;
		        if (isArray(mappedChild)) {
		          var escapedChildKey = "";
		          if (childKey != null) {
		            escapedChildKey = escapeUserProvidedKey(childKey) + "/";
		          }
		          mapIntoArray(mappedChild, array, escapedChildKey, "", function(c) {
		            return c;
		          });
		        } else if (mappedChild != null) {
		          if (isValidElement(mappedChild)) {
		            {
		              if (mappedChild.key && (!_child || _child.key !== mappedChild.key)) {
		                checkKeyStringCoercion(mappedChild.key);
		              }
		            }
		            mappedChild = cloneAndReplaceKey(
		              mappedChild,
		              // Keep both the (mapped) and old keys if they differ, just as
		              // traverseAllChildren used to do for objects as children
		              escapedPrefix + // $FlowFixMe Flow incorrectly thinks React.Portal doesn't have a key
		              (mappedChild.key && (!_child || _child.key !== mappedChild.key) ? (
		                // $FlowFixMe Flow incorrectly thinks existing element's key can be a number
		                // eslint-disable-next-line react-internal/safe-string-coercion
		                escapeUserProvidedKey("" + mappedChild.key) + "/"
		              ) : "") + childKey
		            );
		          }
		          array.push(mappedChild);
		        }
		        return 1;
		      }
		      var child;
		      var nextName;
		      var subtreeCount = 0;
		      var nextNamePrefix = nameSoFar === "" ? SEPARATOR : nameSoFar + SUBSEPARATOR;
		      if (isArray(children)) {
		        for (var i = 0; i < children.length; i++) {
		          child = children[i];
		          nextName = nextNamePrefix + getElementKey(child, i);
		          subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
		        }
		      } else {
		        var iteratorFn = getIteratorFn(children);
		        if (typeof iteratorFn === "function") {
		          var iterableChildren = children;
		          {
		            if (iteratorFn === iterableChildren.entries) {
		              if (!didWarnAboutMaps) {
		                warn("Using Maps as children is not supported. Use an array of keyed ReactElements instead.");
		              }
		              didWarnAboutMaps = true;
		            }
		          }
		          var iterator = iteratorFn.call(iterableChildren);
		          var step;
		          var ii = 0;
		          while (!(step = iterator.next()).done) {
		            child = step.value;
		            nextName = nextNamePrefix + getElementKey(child, ii++);
		            subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
		          }
		        } else if (type === "object") {
		          var childrenString = String(children);
		          throw new Error("Objects are not valid as a React child (found: " + (childrenString === "[object Object]" ? "object with keys {" + Object.keys(children).join(", ") + "}" : childrenString) + "). If you meant to render a collection of children, use an array instead.");
		        }
		      }
		      return subtreeCount;
		    }
		    function mapChildren(children, func, context) {
		      if (children == null) {
		        return children;
		      }
		      var result = [];
		      var count = 0;
		      mapIntoArray(children, result, "", "", function(child) {
		        return func.call(context, child, count++);
		      });
		      return result;
		    }
		    function countChildren(children) {
		      var n = 0;
		      mapChildren(children, function() {
		        n++;
		      });
		      return n;
		    }
		    function forEachChildren(children, forEachFunc, forEachContext) {
		      mapChildren(children, function() {
		        forEachFunc.apply(this, arguments);
		      }, forEachContext);
		    }
		    function toArray(children) {
		      return mapChildren(children, function(child) {
		        return child;
		      }) || [];
		    }
		    function onlyChild(children) {
		      if (!isValidElement(children)) {
		        throw new Error("React.Children.only expected to receive a single React element child.");
		      }
		      return children;
		    }
		    function createContext(defaultValue) {
		      var context = {
		        $$typeof: REACT_CONTEXT_TYPE,
		        // As a workaround to support multiple concurrent renderers, we categorize
		        // some renderers as primary and others as secondary. We only expect
		        // there to be two concurrent renderers at most: React Native (primary) and
		        // Fabric (secondary); React DOM (primary) and React ART (secondary).
		        // Secondary renderers store their context values on separate fields.
		        _currentValue: defaultValue,
		        _currentValue2: defaultValue,
		        // Used to track how many concurrent renderers this context currently
		        // supports within in a single renderer. Such as parallel server rendering.
		        _threadCount: 0,
		        // These are circular
		        Provider: null,
		        Consumer: null,
		        // Add these to use same hidden class in VM as ServerContext
		        _defaultValue: null,
		        _globalName: null
		      };
		      context.Provider = {
		        $$typeof: REACT_PROVIDER_TYPE,
		        _context: context
		      };
		      var hasWarnedAboutUsingNestedContextConsumers = false;
		      var hasWarnedAboutUsingConsumerProvider = false;
		      var hasWarnedAboutDisplayNameOnConsumer = false;
		      {
		        var Consumer = {
		          $$typeof: REACT_CONTEXT_TYPE,
		          _context: context
		        };
		        Object.defineProperties(Consumer, {
		          Provider: {
		            get: function() {
		              if (!hasWarnedAboutUsingConsumerProvider) {
		                hasWarnedAboutUsingConsumerProvider = true;
		                error("Rendering <Context.Consumer.Provider> is not supported and will be removed in a future major release. Did you mean to render <Context.Provider> instead?");
		              }
		              return context.Provider;
		            },
		            set: function(_Provider) {
		              context.Provider = _Provider;
		            }
		          },
		          _currentValue: {
		            get: function() {
		              return context._currentValue;
		            },
		            set: function(_currentValue) {
		              context._currentValue = _currentValue;
		            }
		          },
		          _currentValue2: {
		            get: function() {
		              return context._currentValue2;
		            },
		            set: function(_currentValue2) {
		              context._currentValue2 = _currentValue2;
		            }
		          },
		          _threadCount: {
		            get: function() {
		              return context._threadCount;
		            },
		            set: function(_threadCount) {
		              context._threadCount = _threadCount;
		            }
		          },
		          Consumer: {
		            get: function() {
		              if (!hasWarnedAboutUsingNestedContextConsumers) {
		                hasWarnedAboutUsingNestedContextConsumers = true;
		                error("Rendering <Context.Consumer.Consumer> is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?");
		              }
		              return context.Consumer;
		            }
		          },
		          displayName: {
		            get: function() {
		              return context.displayName;
		            },
		            set: function(displayName) {
		              if (!hasWarnedAboutDisplayNameOnConsumer) {
		                warn("Setting `displayName` on Context.Consumer has no effect. You should set it directly on the context with Context.displayName = '%s'.", displayName);
		                hasWarnedAboutDisplayNameOnConsumer = true;
		              }
		            }
		          }
		        });
		        context.Consumer = Consumer;
		      }
		      {
		        context._currentRenderer = null;
		        context._currentRenderer2 = null;
		      }
		      return context;
		    }
		    var Uninitialized = -1;
		    var Pending = 0;
		    var Resolved = 1;
		    var Rejected = 2;
		    function lazyInitializer(payload) {
		      if (payload._status === Uninitialized) {
		        var ctor = payload._result;
		        var thenable = ctor();
		        thenable.then(function(moduleObject2) {
		          if (payload._status === Pending || payload._status === Uninitialized) {
		            var resolved = payload;
		            resolved._status = Resolved;
		            resolved._result = moduleObject2;
		          }
		        }, function(error2) {
		          if (payload._status === Pending || payload._status === Uninitialized) {
		            var rejected = payload;
		            rejected._status = Rejected;
		            rejected._result = error2;
		          }
		        });
		        if (payload._status === Uninitialized) {
		          var pending = payload;
		          pending._status = Pending;
		          pending._result = thenable;
		        }
		      }
		      if (payload._status === Resolved) {
		        var moduleObject = payload._result;
		        {
		          if (moduleObject === void 0) {
		            error("lazy: Expected the result of a dynamic import() call. Instead received: %s\n\nYour code should look like: \n  const MyComponent = lazy(() => import('./MyComponent'))\n\nDid you accidentally put curly braces around the import?", moduleObject);
		          }
		        }
		        {
		          if (!("default" in moduleObject)) {
		            error("lazy: Expected the result of a dynamic import() call. Instead received: %s\n\nYour code should look like: \n  const MyComponent = lazy(() => import('./MyComponent'))", moduleObject);
		          }
		        }
		        return moduleObject.default;
		      } else {
		        throw payload._result;
		      }
		    }
		    function lazy(ctor) {
		      var payload = {
		        // We use these fields to store the result.
		        _status: Uninitialized,
		        _result: ctor
		      };
		      var lazyType = {
		        $$typeof: REACT_LAZY_TYPE,
		        _payload: payload,
		        _init: lazyInitializer
		      };
		      {
		        var defaultProps;
		        var propTypes;
		        Object.defineProperties(lazyType, {
		          defaultProps: {
		            configurable: true,
		            get: function() {
		              return defaultProps;
		            },
		            set: function(newDefaultProps) {
		              error("React.lazy(...): It is not supported to assign `defaultProps` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it.");
		              defaultProps = newDefaultProps;
		              Object.defineProperty(lazyType, "defaultProps", {
		                enumerable: true
		              });
		            }
		          },
		          propTypes: {
		            configurable: true,
		            get: function() {
		              return propTypes;
		            },
		            set: function(newPropTypes) {
		              error("React.lazy(...): It is not supported to assign `propTypes` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it.");
		              propTypes = newPropTypes;
		              Object.defineProperty(lazyType, "propTypes", {
		                enumerable: true
		              });
		            }
		          }
		        });
		      }
		      return lazyType;
		    }
		    function forwardRef(render) {
		      {
		        if (render != null && render.$$typeof === REACT_MEMO_TYPE) {
		          error("forwardRef requires a render function but received a `memo` component. Instead of forwardRef(memo(...)), use memo(forwardRef(...)).");
		        } else if (typeof render !== "function") {
		          error("forwardRef requires a render function but was given %s.", render === null ? "null" : typeof render);
		        } else {
		          if (render.length !== 0 && render.length !== 2) {
		            error("forwardRef render functions accept exactly two parameters: props and ref. %s", render.length === 1 ? "Did you forget to use the ref parameter?" : "Any additional parameter will be undefined.");
		          }
		        }
		        if (render != null) {
		          if (render.defaultProps != null || render.propTypes != null) {
		            error("forwardRef render functions do not support propTypes or defaultProps. Did you accidentally pass a React component?");
		          }
		        }
		      }
		      var elementType = {
		        $$typeof: REACT_FORWARD_REF_TYPE,
		        render
		      };
		      {
		        var ownName;
		        Object.defineProperty(elementType, "displayName", {
		          enumerable: false,
		          configurable: true,
		          get: function() {
		            return ownName;
		          },
		          set: function(name) {
		            ownName = name;
		            if (!render.name && !render.displayName) {
		              render.displayName = name;
		            }
		          }
		        });
		      }
		      return elementType;
		    }
		    var REACT_MODULE_REFERENCE;
		    {
		      REACT_MODULE_REFERENCE = Symbol.for("react.module.reference");
		    }
		    function isValidElementType(type) {
		      if (typeof type === "string" || typeof type === "function") {
		        return true;
		      }
		      if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || enableDebugTracing || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || enableLegacyHidden || type === REACT_OFFSCREEN_TYPE || enableScopeAPI || enableCacheElement || enableTransitionTracing) {
		        return true;
		      }
		      if (typeof type === "object" && type !== null) {
		        if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || // This needs to include all possible module reference object
		        // types supported by any Flight configuration anywhere since
		        // we don't know which Flight build this will end up being used
		        // with.
		        type.$$typeof === REACT_MODULE_REFERENCE || type.getModuleId !== void 0) {
		          return true;
		        }
		      }
		      return false;
		    }
		    function memo(type, compare) {
		      {
		        if (!isValidElementType(type)) {
		          error("memo: The first argument must be a component. Instead received: %s", type === null ? "null" : typeof type);
		        }
		      }
		      var elementType = {
		        $$typeof: REACT_MEMO_TYPE,
		        type,
		        compare: compare === void 0 ? null : compare
		      };
		      {
		        var ownName;
		        Object.defineProperty(elementType, "displayName", {
		          enumerable: false,
		          configurable: true,
		          get: function() {
		            return ownName;
		          },
		          set: function(name) {
		            ownName = name;
		            if (!type.name && !type.displayName) {
		              type.displayName = name;
		            }
		          }
		        });
		      }
		      return elementType;
		    }
		    function resolveDispatcher() {
		      var dispatcher = ReactCurrentDispatcher.current;
		      {
		        if (dispatcher === null) {
		          error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.");
		        }
		      }
		      return dispatcher;
		    }
		    function useContext(Context) {
		      var dispatcher = resolveDispatcher();
		      {
		        if (Context._context !== void 0) {
		          var realContext = Context._context;
		          if (realContext.Consumer === Context) {
		            error("Calling useContext(Context.Consumer) is not supported, may cause bugs, and will be removed in a future major release. Did you mean to call useContext(Context) instead?");
		          } else if (realContext.Provider === Context) {
		            error("Calling useContext(Context.Provider) is not supported. Did you mean to call useContext(Context) instead?");
		          }
		        }
		      }
		      return dispatcher.useContext(Context);
		    }
		    function useState(initialState) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useState(initialState);
		    }
		    function useReducer(reducer, initialArg, init) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useReducer(reducer, initialArg, init);
		    }
		    function useRef(initialValue) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useRef(initialValue);
		    }
		    function useEffect(create, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useEffect(create, deps);
		    }
		    function useInsertionEffect(create, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useInsertionEffect(create, deps);
		    }
		    function useLayoutEffect(create, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useLayoutEffect(create, deps);
		    }
		    function useCallback(callback, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useCallback(callback, deps);
		    }
		    function useMemo(create, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useMemo(create, deps);
		    }
		    function useImperativeHandle(ref, create, deps) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useImperativeHandle(ref, create, deps);
		    }
		    function useDebugValue(value, formatterFn) {
		      {
		        var dispatcher = resolveDispatcher();
		        return dispatcher.useDebugValue(value, formatterFn);
		      }
		    }
		    function useTransition() {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useTransition();
		    }
		    function useDeferredValue(value) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useDeferredValue(value);
		    }
		    function useId() {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useId();
		    }
		    function useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
		      var dispatcher = resolveDispatcher();
		      return dispatcher.useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
		    }
		    var disabledDepth = 0;
		    var prevLog;
		    var prevInfo;
		    var prevWarn;
		    var prevError;
		    var prevGroup;
		    var prevGroupCollapsed;
		    var prevGroupEnd;
		    function disabledLog() {
		    }
		    disabledLog.__reactDisabledLog = true;
		    function disableLogs() {
		      {
		        if (disabledDepth === 0) {
		          prevLog = console.log;
		          prevInfo = console.info;
		          prevWarn = console.warn;
		          prevError = console.error;
		          prevGroup = console.group;
		          prevGroupCollapsed = console.groupCollapsed;
		          prevGroupEnd = console.groupEnd;
		          var props = {
		            configurable: true,
		            enumerable: true,
		            value: disabledLog,
		            writable: true
		          };
		          Object.defineProperties(console, {
		            info: props,
		            log: props,
		            warn: props,
		            error: props,
		            group: props,
		            groupCollapsed: props,
		            groupEnd: props
		          });
		        }
		        disabledDepth++;
		      }
		    }
		    function reenableLogs() {
		      {
		        disabledDepth--;
		        if (disabledDepth === 0) {
		          var props = {
		            configurable: true,
		            enumerable: true,
		            writable: true
		          };
		          Object.defineProperties(console, {
		            log: assign({}, props, {
		              value: prevLog
		            }),
		            info: assign({}, props, {
		              value: prevInfo
		            }),
		            warn: assign({}, props, {
		              value: prevWarn
		            }),
		            error: assign({}, props, {
		              value: prevError
		            }),
		            group: assign({}, props, {
		              value: prevGroup
		            }),
		            groupCollapsed: assign({}, props, {
		              value: prevGroupCollapsed
		            }),
		            groupEnd: assign({}, props, {
		              value: prevGroupEnd
		            })
		          });
		        }
		        if (disabledDepth < 0) {
		          error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
		        }
		      }
		    }
		    var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher;
		    var prefix;
		    function describeBuiltInComponentFrame(name, source, ownerFn) {
		      {
		        if (prefix === void 0) {
		          try {
		            throw Error();
		          } catch (x) {
		            var match = x.stack.trim().match(/\n( *(at )?)/);
		            prefix = match && match[1] || "";
		          }
		        }
		        return "\n" + prefix + name;
		      }
		    }
		    var reentry = false;
		    var componentFrameCache;
		    {
		      var PossiblyWeakMap = typeof WeakMap === "function" ? WeakMap : Map;
		      componentFrameCache = new PossiblyWeakMap();
		    }
		    function describeNativeComponentFrame(fn, construct) {
		      if (!fn || reentry) {
		        return "";
		      }
		      {
		        var frame = componentFrameCache.get(fn);
		        if (frame !== void 0) {
		          return frame;
		        }
		      }
		      var control;
		      reentry = true;
		      var previousPrepareStackTrace = Error.prepareStackTrace;
		      Error.prepareStackTrace = void 0;
		      var previousDispatcher;
		      {
		        previousDispatcher = ReactCurrentDispatcher$1.current;
		        ReactCurrentDispatcher$1.current = null;
		        disableLogs();
		      }
		      try {
		        if (construct) {
		          var Fake = function() {
		            throw Error();
		          };
		          Object.defineProperty(Fake.prototype, "props", {
		            set: function() {
		              throw Error();
		            }
		          });
		          if (typeof Reflect === "object" && Reflect.construct) {
		            try {
		              Reflect.construct(Fake, []);
		            } catch (x) {
		              control = x;
		            }
		            Reflect.construct(fn, [], Fake);
		          } else {
		            try {
		              Fake.call();
		            } catch (x) {
		              control = x;
		            }
		            fn.call(Fake.prototype);
		          }
		        } else {
		          try {
		            throw Error();
		          } catch (x) {
		            control = x;
		          }
		          fn();
		        }
		      } catch (sample) {
		        if (sample && control && typeof sample.stack === "string") {
		          var sampleLines = sample.stack.split("\n");
		          var controlLines = control.stack.split("\n");
		          var s = sampleLines.length - 1;
		          var c = controlLines.length - 1;
		          while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
		            c--;
		          }
		          for (; s >= 1 && c >= 0; s--, c--) {
		            if (sampleLines[s] !== controlLines[c]) {
		              if (s !== 1 || c !== 1) {
		                do {
		                  s--;
		                  c--;
		                  if (c < 0 || sampleLines[s] !== controlLines[c]) {
		                    var _frame = "\n" + sampleLines[s].replace(" at new ", " at ");
		                    if (fn.displayName && _frame.includes("<anonymous>")) {
		                      _frame = _frame.replace("<anonymous>", fn.displayName);
		                    }
		                    {
		                      if (typeof fn === "function") {
		                        componentFrameCache.set(fn, _frame);
		                      }
		                    }
		                    return _frame;
		                  }
		                } while (s >= 1 && c >= 0);
		              }
		              break;
		            }
		          }
		        }
		      } finally {
		        reentry = false;
		        {
		          ReactCurrentDispatcher$1.current = previousDispatcher;
		          reenableLogs();
		        }
		        Error.prepareStackTrace = previousPrepareStackTrace;
		      }
		      var name = fn ? fn.displayName || fn.name : "";
		      var syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
		      {
		        if (typeof fn === "function") {
		          componentFrameCache.set(fn, syntheticFrame);
		        }
		      }
		      return syntheticFrame;
		    }
		    function describeFunctionComponentFrame(fn, source, ownerFn) {
		      {
		        return describeNativeComponentFrame(fn, false);
		      }
		    }
		    function shouldConstruct(Component2) {
		      var prototype = Component2.prototype;
		      return !!(prototype && prototype.isReactComponent);
		    }
		    function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
		      if (type == null) {
		        return "";
		      }
		      if (typeof type === "function") {
		        {
		          return describeNativeComponentFrame(type, shouldConstruct(type));
		        }
		      }
		      if (typeof type === "string") {
		        return describeBuiltInComponentFrame(type);
		      }
		      switch (type) {
		        case REACT_SUSPENSE_TYPE:
		          return describeBuiltInComponentFrame("Suspense");
		        case REACT_SUSPENSE_LIST_TYPE:
		          return describeBuiltInComponentFrame("SuspenseList");
		      }
		      if (typeof type === "object") {
		        switch (type.$$typeof) {
		          case REACT_FORWARD_REF_TYPE:
		            return describeFunctionComponentFrame(type.render);
		          case REACT_MEMO_TYPE:
		            return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
		          case REACT_LAZY_TYPE: {
		            var lazyComponent = type;
		            var payload = lazyComponent._payload;
		            var init = lazyComponent._init;
		            try {
		              return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
		            } catch (x) {
		            }
		          }
		        }
		      }
		      return "";
		    }
		    var loggedTypeFailures = {};
		    var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
		    function setCurrentlyValidatingElement(element) {
		      {
		        if (element) {
		          var owner = element._owner;
		          var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
		          ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
		        } else {
		          ReactDebugCurrentFrame$1.setExtraStackFrame(null);
		        }
		      }
		    }
		    function checkPropTypes(typeSpecs, values, location, componentName, element) {
		      {
		        var has = Function.call.bind(hasOwnProperty);
		        for (var typeSpecName in typeSpecs) {
		          if (has(typeSpecs, typeSpecName)) {
		            var error$1 = void 0;
		            try {
		              if (typeof typeSpecs[typeSpecName] !== "function") {
		                var err = Error((componentName || "React class") + ": " + location + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
		                err.name = "Invariant Violation";
		                throw err;
		              }
		              error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
		            } catch (ex) {
		              error$1 = ex;
		            }
		            if (error$1 && !(error$1 instanceof Error)) {
		              setCurrentlyValidatingElement(element);
		              error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location, typeSpecName, typeof error$1);
		              setCurrentlyValidatingElement(null);
		            }
		            if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
		              loggedTypeFailures[error$1.message] = true;
		              setCurrentlyValidatingElement(element);
		              error("Failed %s type: %s", location, error$1.message);
		              setCurrentlyValidatingElement(null);
		            }
		          }
		        }
		      }
		    }
		    function setCurrentlyValidatingElement$1(element) {
		      {
		        if (element) {
		          var owner = element._owner;
		          var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
		          setExtraStackFrame(stack);
		        } else {
		          setExtraStackFrame(null);
		        }
		      }
		    }
		    var propTypesMisspellWarningShown;
		    {
		      propTypesMisspellWarningShown = false;
		    }
		    function getDeclarationErrorAddendum() {
		      if (ReactCurrentOwner.current) {
		        var name = getComponentNameFromType(ReactCurrentOwner.current.type);
		        if (name) {
		          return "\n\nCheck the render method of `" + name + "`.";
		        }
		      }
		      return "";
		    }
		    function getSourceInfoErrorAddendum(source) {
		      if (source !== void 0) {
		        var fileName = source.fileName.replace(/^.*[\\\/]/, "");
		        var lineNumber = source.lineNumber;
		        return "\n\nCheck your code at " + fileName + ":" + lineNumber + ".";
		      }
		      return "";
		    }
		    function getSourceInfoErrorAddendumForProps(elementProps) {
		      if (elementProps !== null && elementProps !== void 0) {
		        return getSourceInfoErrorAddendum(elementProps.__source);
		      }
		      return "";
		    }
		    var ownerHasKeyUseWarning = {};
		    function getCurrentComponentErrorInfo(parentType) {
		      var info = getDeclarationErrorAddendum();
		      if (!info) {
		        var parentName = typeof parentType === "string" ? parentType : parentType.displayName || parentType.name;
		        if (parentName) {
		          info = "\n\nCheck the top-level render call using <" + parentName + ">.";
		        }
		      }
		      return info;
		    }
		    function validateExplicitKey(element, parentType) {
		      if (!element._store || element._store.validated || element.key != null) {
		        return;
		      }
		      element._store.validated = true;
		      var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);
		      if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
		        return;
		      }
		      ownerHasKeyUseWarning[currentComponentErrorInfo] = true;
		      var childOwner = "";
		      if (element && element._owner && element._owner !== ReactCurrentOwner.current) {
		        childOwner = " It was passed a child from " + getComponentNameFromType(element._owner.type) + ".";
		      }
		      {
		        setCurrentlyValidatingElement$1(element);
		        error('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);
		        setCurrentlyValidatingElement$1(null);
		      }
		    }
		    function validateChildKeys(node, parentType) {
		      if (typeof node !== "object") {
		        return;
		      }
		      if (isArray(node)) {
		        for (var i = 0; i < node.length; i++) {
		          var child = node[i];
		          if (isValidElement(child)) {
		            validateExplicitKey(child, parentType);
		          }
		        }
		      } else if (isValidElement(node)) {
		        if (node._store) {
		          node._store.validated = true;
		        }
		      } else if (node) {
		        var iteratorFn = getIteratorFn(node);
		        if (typeof iteratorFn === "function") {
		          if (iteratorFn !== node.entries) {
		            var iterator = iteratorFn.call(node);
		            var step;
		            while (!(step = iterator.next()).done) {
		              if (isValidElement(step.value)) {
		                validateExplicitKey(step.value, parentType);
		              }
		            }
		          }
		        }
		      }
		    }
		    function validatePropTypes(element) {
		      {
		        var type = element.type;
		        if (type === null || type === void 0 || typeof type === "string") {
		          return;
		        }
		        var propTypes;
		        if (typeof type === "function") {
		          propTypes = type.propTypes;
		        } else if (typeof type === "object" && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
		        // Inner props are checked in the reconciler.
		        type.$$typeof === REACT_MEMO_TYPE)) {
		          propTypes = type.propTypes;
		        } else {
		          return;
		        }
		        if (propTypes) {
		          var name = getComponentNameFromType(type);
		          checkPropTypes(propTypes, element.props, "prop", name, element);
		        } else if (type.PropTypes !== void 0 && !propTypesMisspellWarningShown) {
		          propTypesMisspellWarningShown = true;
		          var _name = getComponentNameFromType(type);
		          error("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", _name || "Unknown");
		        }
		        if (typeof type.getDefaultProps === "function" && !type.getDefaultProps.isReactClassApproved) {
		          error("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
		        }
		      }
		    }
		    function validateFragmentProps(fragment) {
		      {
		        var keys = Object.keys(fragment.props);
		        for (var i = 0; i < keys.length; i++) {
		          var key = keys[i];
		          if (key !== "children" && key !== "key") {
		            setCurrentlyValidatingElement$1(fragment);
		            error("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", key);
		            setCurrentlyValidatingElement$1(null);
		            break;
		          }
		        }
		        if (fragment.ref !== null) {
		          setCurrentlyValidatingElement$1(fragment);
		          error("Invalid attribute `ref` supplied to `React.Fragment`.");
		          setCurrentlyValidatingElement$1(null);
		        }
		      }
		    }
		    function createElementWithValidation(type, props, children) {
		      var validType = isValidElementType(type);
		      if (!validType) {
		        var info = "";
		        if (type === void 0 || typeof type === "object" && type !== null && Object.keys(type).length === 0) {
		          info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
		        }
		        var sourceInfo = getSourceInfoErrorAddendumForProps(props);
		        if (sourceInfo) {
		          info += sourceInfo;
		        } else {
		          info += getDeclarationErrorAddendum();
		        }
		        var typeString;
		        if (type === null) {
		          typeString = "null";
		        } else if (isArray(type)) {
		          typeString = "array";
		        } else if (type !== void 0 && type.$$typeof === REACT_ELEMENT_TYPE) {
		          typeString = "<" + (getComponentNameFromType(type.type) || "Unknown") + " />";
		          info = " Did you accidentally export a JSX literal instead of a component?";
		        } else {
		          typeString = typeof type;
		        }
		        {
		          error("React.createElement: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", typeString, info);
		        }
		      }
		      var element = createElement.apply(this, arguments);
		      if (element == null) {
		        return element;
		      }
		      if (validType) {
		        for (var i = 2; i < arguments.length; i++) {
		          validateChildKeys(arguments[i], type);
		        }
		      }
		      if (type === REACT_FRAGMENT_TYPE) {
		        validateFragmentProps(element);
		      } else {
		        validatePropTypes(element);
		      }
		      return element;
		    }
		    var didWarnAboutDeprecatedCreateFactory = false;
		    function createFactoryWithValidation(type) {
		      var validatedFactory = createElementWithValidation.bind(null, type);
		      validatedFactory.type = type;
		      {
		        if (!didWarnAboutDeprecatedCreateFactory) {
		          didWarnAboutDeprecatedCreateFactory = true;
		          warn("React.createFactory() is deprecated and will be removed in a future major release. Consider using JSX or use React.createElement() directly instead.");
		        }
		        Object.defineProperty(validatedFactory, "type", {
		          enumerable: false,
		          get: function() {
		            warn("Factory.type is deprecated. Access the class directly before passing it to createFactory.");
		            Object.defineProperty(this, "type", {
		              value: type
		            });
		            return type;
		          }
		        });
		      }
		      return validatedFactory;
		    }
		    function cloneElementWithValidation(element, props, children) {
		      var newElement = cloneElement.apply(this, arguments);
		      for (var i = 2; i < arguments.length; i++) {
		        validateChildKeys(arguments[i], newElement.type);
		      }
		      validatePropTypes(newElement);
		      return newElement;
		    }
		    function startTransition(scope, options) {
		      var prevTransition = ReactCurrentBatchConfig.transition;
		      ReactCurrentBatchConfig.transition = {};
		      var currentTransition = ReactCurrentBatchConfig.transition;
		      {
		        ReactCurrentBatchConfig.transition._updatedFibers = /* @__PURE__ */ new Set();
		      }
		      try {
		        scope();
		      } finally {
		        ReactCurrentBatchConfig.transition = prevTransition;
		        {
		          if (prevTransition === null && currentTransition._updatedFibers) {
		            var updatedFibersCount = currentTransition._updatedFibers.size;
		            if (updatedFibersCount > 10) {
		              warn("Detected a large number of updates inside startTransition. If this is due to a subscription please re-write it to use React provided hooks. Otherwise concurrent mode guarantees are off the table.");
		            }
		            currentTransition._updatedFibers.clear();
		          }
		        }
		      }
		    }
		    var didWarnAboutMessageChannel = false;
		    var enqueueTaskImpl = null;
		    function enqueueTask(task) {
		      if (enqueueTaskImpl === null) {
		        try {
		          var requireString = ("require" + Math.random()).slice(0, 7);
		          var nodeRequire = module && module[requireString];
		          enqueueTaskImpl = nodeRequire.call(module, "timers").setImmediate;
		        } catch (_err) {
		          enqueueTaskImpl = function(callback) {
		            {
		              if (didWarnAboutMessageChannel === false) {
		                didWarnAboutMessageChannel = true;
		                if (typeof MessageChannel === "undefined") {
		                  error("This browser does not have a MessageChannel implementation, so enqueuing tasks via await act(async () => ...) will fail. Please file an issue at https://github.com/facebook/react/issues if you encounter this warning.");
		                }
		              }
		            }
		            var channel = new MessageChannel();
		            channel.port1.onmessage = callback;
		            channel.port2.postMessage(void 0);
		          };
		        }
		      }
		      return enqueueTaskImpl(task);
		    }
		    var actScopeDepth = 0;
		    var didWarnNoAwaitAct = false;
		    function act(callback) {
		      {
		        var prevActScopeDepth = actScopeDepth;
		        actScopeDepth++;
		        if (ReactCurrentActQueue.current === null) {
		          ReactCurrentActQueue.current = [];
		        }
		        var prevIsBatchingLegacy = ReactCurrentActQueue.isBatchingLegacy;
		        var result;
		        try {
		          ReactCurrentActQueue.isBatchingLegacy = true;
		          result = callback();
		          if (!prevIsBatchingLegacy && ReactCurrentActQueue.didScheduleLegacyUpdate) {
		            var queue = ReactCurrentActQueue.current;
		            if (queue !== null) {
		              ReactCurrentActQueue.didScheduleLegacyUpdate = false;
		              flushActQueue(queue);
		            }
		          }
		        } catch (error2) {
		          popActScope(prevActScopeDepth);
		          throw error2;
		        } finally {
		          ReactCurrentActQueue.isBatchingLegacy = prevIsBatchingLegacy;
		        }
		        if (result !== null && typeof result === "object" && typeof result.then === "function") {
		          var thenableResult = result;
		          var wasAwaited = false;
		          var thenable = {
		            then: function(resolve, reject) {
		              wasAwaited = true;
		              thenableResult.then(function(returnValue2) {
		                popActScope(prevActScopeDepth);
		                if (actScopeDepth === 0) {
		                  recursivelyFlushAsyncActWork(returnValue2, resolve, reject);
		                } else {
		                  resolve(returnValue2);
		                }
		              }, function(error2) {
		                popActScope(prevActScopeDepth);
		                reject(error2);
		              });
		            }
		          };
		          {
		            if (!didWarnNoAwaitAct && typeof Promise !== "undefined") {
		              Promise.resolve().then(function() {
		              }).then(function() {
		                if (!wasAwaited) {
		                  didWarnNoAwaitAct = true;
		                  error("You called act(async () => ...) without await. This could lead to unexpected testing behaviour, interleaving multiple act calls and mixing their scopes. You should - await act(async () => ...);");
		                }
		              });
		            }
		          }
		          return thenable;
		        } else {
		          var returnValue = result;
		          popActScope(prevActScopeDepth);
		          if (actScopeDepth === 0) {
		            var _queue = ReactCurrentActQueue.current;
		            if (_queue !== null) {
		              flushActQueue(_queue);
		              ReactCurrentActQueue.current = null;
		            }
		            var _thenable = {
		              then: function(resolve, reject) {
		                if (ReactCurrentActQueue.current === null) {
		                  ReactCurrentActQueue.current = [];
		                  recursivelyFlushAsyncActWork(returnValue, resolve, reject);
		                } else {
		                  resolve(returnValue);
		                }
		              }
		            };
		            return _thenable;
		          } else {
		            var _thenable2 = {
		              then: function(resolve, reject) {
		                resolve(returnValue);
		              }
		            };
		            return _thenable2;
		          }
		        }
		      }
		    }
		    function popActScope(prevActScopeDepth) {
		      {
		        if (prevActScopeDepth !== actScopeDepth - 1) {
		          error("You seem to have overlapping act() calls, this is not supported. Be sure to await previous act() calls before making a new one. ");
		        }
		        actScopeDepth = prevActScopeDepth;
		      }
		    }
		    function recursivelyFlushAsyncActWork(returnValue, resolve, reject) {
		      {
		        var queue = ReactCurrentActQueue.current;
		        if (queue !== null) {
		          try {
		            flushActQueue(queue);
		            enqueueTask(function() {
		              if (queue.length === 0) {
		                ReactCurrentActQueue.current = null;
		                resolve(returnValue);
		              } else {
		                recursivelyFlushAsyncActWork(returnValue, resolve, reject);
		              }
		            });
		          } catch (error2) {
		            reject(error2);
		          }
		        } else {
		          resolve(returnValue);
		        }
		      }
		    }
		    var isFlushing = false;
		    function flushActQueue(queue) {
		      {
		        if (!isFlushing) {
		          isFlushing = true;
		          var i = 0;
		          try {
		            for (; i < queue.length; i++) {
		              var callback = queue[i];
		              do {
		                callback = callback(true);
		              } while (callback !== null);
		            }
		            queue.length = 0;
		          } catch (error2) {
		            queue = queue.slice(i + 1);
		            throw error2;
		          } finally {
		            isFlushing = false;
		          }
		        }
		      }
		    }
		    var createElement$1 = createElementWithValidation;
		    var cloneElement$1 = cloneElementWithValidation;
		    var createFactory = createFactoryWithValidation;
		    var Children = {
		      map: mapChildren,
		      forEach: forEachChildren,
		      count: countChildren,
		      toArray,
		      only: onlyChild
		    };
		    exports.Children = Children;
		    exports.Component = Component;
		    exports.Fragment = REACT_FRAGMENT_TYPE;
		    exports.Profiler = REACT_PROFILER_TYPE;
		    exports.PureComponent = PureComponent;
		    exports.StrictMode = REACT_STRICT_MODE_TYPE;
		    exports.Suspense = REACT_SUSPENSE_TYPE;
		    exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ReactSharedInternals;
		    exports.cloneElement = cloneElement$1;
		    exports.createContext = createContext;
		    exports.createElement = createElement$1;
		    exports.createFactory = createFactory;
		    exports.createRef = createRef;
		    exports.forwardRef = forwardRef;
		    exports.isValidElement = isValidElement;
		    exports.lazy = lazy;
		    exports.memo = memo;
		    exports.startTransition = startTransition;
		    exports.unstable_act = act;
		    exports.useCallback = useCallback;
		    exports.useContext = useContext;
		    exports.useDebugValue = useDebugValue;
		    exports.useDeferredValue = useDeferredValue;
		    exports.useEffect = useEffect;
		    exports.useId = useId;
		    exports.useImperativeHandle = useImperativeHandle;
		    exports.useInsertionEffect = useInsertionEffect;
		    exports.useLayoutEffect = useLayoutEffect;
		    exports.useMemo = useMemo;
		    exports.useReducer = useReducer;
		    exports.useRef = useRef;
		    exports.useState = useState;
		    exports.useSyncExternalStore = useSyncExternalStore;
		    exports.useTransition = useTransition;
		    exports.version = ReactVersion;
		    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
		      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
		    }
		  })();
		} 
	} (react_development, react_development.exports));
	return react_development.exports;
}

var react_production_min = {};

/**
 * @license React
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReact_production_min;

function requireReact_production_min () {
	if (hasRequiredReact_production_min) return react_production_min;
	hasRequiredReact_production_min = 1;
var l=Symbol.for("react.element"),n=Symbol.for("react.portal"),p=Symbol.for("react.fragment"),q=Symbol.for("react.strict_mode"),r=Symbol.for("react.profiler"),t=Symbol.for("react.provider"),u=Symbol.for("react.context"),v=Symbol.for("react.forward_ref"),w=Symbol.for("react.suspense"),x=Symbol.for("react.memo"),y=Symbol.for("react.lazy"),z=Symbol.iterator;function A(a){if(null===a||"object"!==typeof a)return null;a=z&&a[z]||a["@@iterator"];return "function"===typeof a?a:null}
	var B={isMounted:function(){return !1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},C=Object.assign,D={};function E(a,b,e){this.props=a;this.context=b;this.refs=D;this.updater=e||B;}E.prototype.isReactComponent={};
	E.prototype.setState=function(a,b){if("object"!==typeof a&&"function"!==typeof a&&null!=a)throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");this.updater.enqueueSetState(this,a,b,"setState");};E.prototype.forceUpdate=function(a){this.updater.enqueueForceUpdate(this,a,"forceUpdate");};function F(){}F.prototype=E.prototype;function G(a,b,e){this.props=a;this.context=b;this.refs=D;this.updater=e||B;}var H=G.prototype=new F;
	H.constructor=G;C(H,E.prototype);H.isPureReactComponent=!0;var I=Array.isArray,J=Object.prototype.hasOwnProperty,K={current:null},L={key:!0,ref:!0,__self:!0,__source:!0};
	function M(a,b,e){var d,c={},k=null,h=null;if(null!=b)for(d in void 0!==b.ref&&(h=b.ref),void 0!==b.key&&(k=""+b.key),b)J.call(b,d)&&!L.hasOwnProperty(d)&&(c[d]=b[d]);var g=arguments.length-2;if(1===g)c.children=e;else if(1<g){for(var f=Array(g),m=0;m<g;m++)f[m]=arguments[m+2];c.children=f;}if(a&&a.defaultProps)for(d in g=a.defaultProps,g)void 0===c[d]&&(c[d]=g[d]);return {$$typeof:l,type:a,key:k,ref:h,props:c,_owner:K.current}}
	function N(a,b){return {$$typeof:l,type:a.type,key:b,ref:a.ref,props:a.props,_owner:a._owner}}function O(a){return "object"===typeof a&&null!==a&&a.$$typeof===l}function escape(a){var b={"=":"=0",":":"=2"};return "$"+a.replace(/[=:]/g,function(a){return b[a]})}var P=/\/+/g;function Q(a,b){return "object"===typeof a&&null!==a&&null!=a.key?escape(""+a.key):b.toString(36)}
	function R(a,b,e,d,c){var k=typeof a;if("undefined"===k||"boolean"===k)a=null;var h=!1;if(null===a)h=!0;else switch(k){case "string":case "number":h=!0;break;case "object":switch(a.$$typeof){case l:case n:h=!0;}}if(h)return h=a,c=c(h),a=""===d?"."+Q(h,0):d,I(c)?(e="",null!=a&&(e=a.replace(P,"$&/")+"/"),R(c,b,e,"",function(a){return a})):null!=c&&(O(c)&&(c=N(c,e+(!c.key||h&&h.key===c.key?"":(""+c.key).replace(P,"$&/")+"/")+a)),b.push(c)),1;h=0;d=""===d?".":d+":";if(I(a))for(var g=0;g<a.length;g++){k=
	a[g];var f=d+Q(k,g);h+=R(k,b,e,f,c);}else if(f=A(a),"function"===typeof f)for(a=f.call(a),g=0;!(k=a.next()).done;)k=k.value,f=d+Q(k,g++),h+=R(k,b,e,f,c);else if("object"===k)throw b=String(a),Error("Objects are not valid as a React child (found: "+("[object Object]"===b?"object with keys {"+Object.keys(a).join(", ")+"}":b)+"). If you meant to render a collection of children, use an array instead.");return h}
	function S(a,b,e){if(null==a)return a;var d=[],c=0;R(a,d,"","",function(a){return b.call(e,a,c++)});return d}function T(a){if(-1===a._status){var b=a._result;b=b();b.then(function(b){if(0===a._status||-1===a._status)a._status=1,a._result=b;},function(b){if(0===a._status||-1===a._status)a._status=2,a._result=b;});-1===a._status&&(a._status=0,a._result=b);}if(1===a._status)return a._result.default;throw a._result;}
	var U={current:null},V={transition:null},W={ReactCurrentDispatcher:U,ReactCurrentBatchConfig:V,ReactCurrentOwner:K};react_production_min.Children={map:S,forEach:function(a,b,e){S(a,function(){b.apply(this,arguments);},e);},count:function(a){var b=0;S(a,function(){b++;});return b},toArray:function(a){return S(a,function(a){return a})||[]},only:function(a){if(!O(a))throw Error("React.Children.only expected to receive a single React element child.");return a}};react_production_min.Component=E;react_production_min.Fragment=p;
	react_production_min.Profiler=r;react_production_min.PureComponent=G;react_production_min.StrictMode=q;react_production_min.Suspense=w;react_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=W;
	react_production_min.cloneElement=function(a,b,e){if(null===a||void 0===a)throw Error("React.cloneElement(...): The argument must be a React element, but you passed "+a+".");var d=C({},a.props),c=a.key,k=a.ref,h=a._owner;if(null!=b){void 0!==b.ref&&(k=b.ref,h=K.current);void 0!==b.key&&(c=""+b.key);if(a.type&&a.type.defaultProps)var g=a.type.defaultProps;for(f in b)J.call(b,f)&&!L.hasOwnProperty(f)&&(d[f]=void 0===b[f]&&void 0!==g?g[f]:b[f]);}var f=arguments.length-2;if(1===f)d.children=e;else if(1<f){g=Array(f);
	for(var m=0;m<f;m++)g[m]=arguments[m+2];d.children=g;}return {$$typeof:l,type:a.type,key:c,ref:k,props:d,_owner:h}};react_production_min.createContext=function(a){a={$$typeof:u,_currentValue:a,_currentValue2:a,_threadCount:0,Provider:null,Consumer:null,_defaultValue:null,_globalName:null};a.Provider={$$typeof:t,_context:a};return a.Consumer=a};react_production_min.createElement=M;react_production_min.createFactory=function(a){var b=M.bind(null,a);b.type=a;return b};react_production_min.createRef=function(){return {current:null}};
	react_production_min.forwardRef=function(a){return {$$typeof:v,render:a}};react_production_min.isValidElement=O;react_production_min.lazy=function(a){return {$$typeof:y,_payload:{_status:-1,_result:a},_init:T}};react_production_min.memo=function(a,b){return {$$typeof:x,type:a,compare:void 0===b?null:b}};react_production_min.startTransition=function(a){var b=V.transition;V.transition={};try{a();}finally{V.transition=b;}};react_production_min.unstable_act=function(){throw Error("act(...) is not supported in production builds of React.");};
	react_production_min.useCallback=function(a,b){return U.current.useCallback(a,b)};react_production_min.useContext=function(a){return U.current.useContext(a)};react_production_min.useDebugValue=function(){};react_production_min.useDeferredValue=function(a){return U.current.useDeferredValue(a)};react_production_min.useEffect=function(a,b){return U.current.useEffect(a,b)};react_production_min.useId=function(){return U.current.useId()};react_production_min.useImperativeHandle=function(a,b,e){return U.current.useImperativeHandle(a,b,e)};
	react_production_min.useInsertionEffect=function(a,b){return U.current.useInsertionEffect(a,b)};react_production_min.useLayoutEffect=function(a,b){return U.current.useLayoutEffect(a,b)};react_production_min.useMemo=function(a,b){return U.current.useMemo(a,b)};react_production_min.useReducer=function(a,b,e){return U.current.useReducer(a,b,e)};react_production_min.useRef=function(a){return U.current.useRef(a)};react_production_min.useState=function(a){return U.current.useState(a)};react_production_min.useSyncExternalStore=function(a,b,e){return U.current.useSyncExternalStore(a,b,e)};
	react_production_min.useTransition=function(){return U.current.useTransition()};react_production_min.version="18.2.0";
	return react_production_min;
}

var define_process_env_default$5 = {};
if (define_process_env_default$5.NODE_ENV === "production") {
  react.exports = requireReact_production_min();
} else {
  react.exports = requireReact_development();
}

var reactExports = react.exports;
const React = /*@__PURE__*/getDefaultExportFromCjs(reactExports);

var hasRequiredReactJsxRuntime_development;

function requireReactJsxRuntime_development () {
	if (hasRequiredReactJsxRuntime_development) return reactJsxRuntime_development;
	hasRequiredReactJsxRuntime_development = 1;
	var define_process_env_default = {};
	/**
	 * @license React
	 * react-jsx-runtime.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */
	if (define_process_env_default.NODE_ENV !== "production") {
	  (function() {
	    var React = reactExports;
	    var REACT_ELEMENT_TYPE = Symbol.for("react.element");
	    var REACT_PORTAL_TYPE = Symbol.for("react.portal");
	    var REACT_FRAGMENT_TYPE = Symbol.for("react.fragment");
	    var REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode");
	    var REACT_PROFILER_TYPE = Symbol.for("react.profiler");
	    var REACT_PROVIDER_TYPE = Symbol.for("react.provider");
	    var REACT_CONTEXT_TYPE = Symbol.for("react.context");
	    var REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref");
	    var REACT_SUSPENSE_TYPE = Symbol.for("react.suspense");
	    var REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list");
	    var REACT_MEMO_TYPE = Symbol.for("react.memo");
	    var REACT_LAZY_TYPE = Symbol.for("react.lazy");
	    var REACT_OFFSCREEN_TYPE = Symbol.for("react.offscreen");
	    var MAYBE_ITERATOR_SYMBOL = Symbol.iterator;
	    var FAUX_ITERATOR_SYMBOL = "@@iterator";
	    function getIteratorFn(maybeIterable) {
	      if (maybeIterable === null || typeof maybeIterable !== "object") {
	        return null;
	      }
	      var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
	      if (typeof maybeIterator === "function") {
	        return maybeIterator;
	      }
	      return null;
	    }
	    var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
	    function error(format) {
	      {
	        {
	          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	            args[_key2 - 1] = arguments[_key2];
	          }
	          printWarning("error", format, args);
	        }
	      }
	    }
	    function printWarning(level, format, args) {
	      {
	        var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
	        var stack = ReactDebugCurrentFrame2.getStackAddendum();
	        if (stack !== "") {
	          format += "%s";
	          args = args.concat([stack]);
	        }
	        var argsWithFormat = args.map(function(item) {
	          return String(item);
	        });
	        argsWithFormat.unshift("Warning: " + format);
	        Function.prototype.apply.call(console[level], console, argsWithFormat);
	      }
	    }
	    var enableScopeAPI = false;
	    var enableCacheElement = false;
	    var enableTransitionTracing = false;
	    var enableLegacyHidden = false;
	    var enableDebugTracing = false;
	    var REACT_MODULE_REFERENCE;
	    {
	      REACT_MODULE_REFERENCE = Symbol.for("react.module.reference");
	    }
	    function isValidElementType(type) {
	      if (typeof type === "string" || typeof type === "function") {
	        return true;
	      }
	      if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || enableDebugTracing || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || enableLegacyHidden || type === REACT_OFFSCREEN_TYPE || enableScopeAPI || enableCacheElement || enableTransitionTracing) {
	        return true;
	      }
	      if (typeof type === "object" && type !== null) {
	        if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || // This needs to include all possible module reference object
	        // types supported by any Flight configuration anywhere since
	        // we don't know which Flight build this will end up being used
	        // with.
	        type.$$typeof === REACT_MODULE_REFERENCE || type.getModuleId !== void 0) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function getWrappedName(outerType, innerType, wrapperName) {
	      var displayName = outerType.displayName;
	      if (displayName) {
	        return displayName;
	      }
	      var functionName = innerType.displayName || innerType.name || "";
	      return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
	    }
	    function getContextName(type) {
	      return type.displayName || "Context";
	    }
	    function getComponentNameFromType(type) {
	      if (type == null) {
	        return null;
	      }
	      {
	        if (typeof type.tag === "number") {
	          error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue.");
	        }
	      }
	      if (typeof type === "function") {
	        return type.displayName || type.name || null;
	      }
	      if (typeof type === "string") {
	        return type;
	      }
	      switch (type) {
	        case REACT_FRAGMENT_TYPE:
	          return "Fragment";
	        case REACT_PORTAL_TYPE:
	          return "Portal";
	        case REACT_PROFILER_TYPE:
	          return "Profiler";
	        case REACT_STRICT_MODE_TYPE:
	          return "StrictMode";
	        case REACT_SUSPENSE_TYPE:
	          return "Suspense";
	        case REACT_SUSPENSE_LIST_TYPE:
	          return "SuspenseList";
	      }
	      if (typeof type === "object") {
	        switch (type.$$typeof) {
	          case REACT_CONTEXT_TYPE:
	            var context = type;
	            return getContextName(context) + ".Consumer";
	          case REACT_PROVIDER_TYPE:
	            var provider = type;
	            return getContextName(provider._context) + ".Provider";
	          case REACT_FORWARD_REF_TYPE:
	            return getWrappedName(type, type.render, "ForwardRef");
	          case REACT_MEMO_TYPE:
	            var outerName = type.displayName || null;
	            if (outerName !== null) {
	              return outerName;
	            }
	            return getComponentNameFromType(type.type) || "Memo";
	          case REACT_LAZY_TYPE: {
	            var lazyComponent = type;
	            var payload = lazyComponent._payload;
	            var init = lazyComponent._init;
	            try {
	              return getComponentNameFromType(init(payload));
	            } catch (x) {
	              return null;
	            }
	          }
	        }
	      }
	      return null;
	    }
	    var assign = Object.assign;
	    var disabledDepth = 0;
	    var prevLog;
	    var prevInfo;
	    var prevWarn;
	    var prevError;
	    var prevGroup;
	    var prevGroupCollapsed;
	    var prevGroupEnd;
	    function disabledLog() {
	    }
	    disabledLog.__reactDisabledLog = true;
	    function disableLogs() {
	      {
	        if (disabledDepth === 0) {
	          prevLog = console.log;
	          prevInfo = console.info;
	          prevWarn = console.warn;
	          prevError = console.error;
	          prevGroup = console.group;
	          prevGroupCollapsed = console.groupCollapsed;
	          prevGroupEnd = console.groupEnd;
	          var props = {
	            configurable: true,
	            enumerable: true,
	            value: disabledLog,
	            writable: true
	          };
	          Object.defineProperties(console, {
	            info: props,
	            log: props,
	            warn: props,
	            error: props,
	            group: props,
	            groupCollapsed: props,
	            groupEnd: props
	          });
	        }
	        disabledDepth++;
	      }
	    }
	    function reenableLogs() {
	      {
	        disabledDepth--;
	        if (disabledDepth === 0) {
	          var props = {
	            configurable: true,
	            enumerable: true,
	            writable: true
	          };
	          Object.defineProperties(console, {
	            log: assign({}, props, {
	              value: prevLog
	            }),
	            info: assign({}, props, {
	              value: prevInfo
	            }),
	            warn: assign({}, props, {
	              value: prevWarn
	            }),
	            error: assign({}, props, {
	              value: prevError
	            }),
	            group: assign({}, props, {
	              value: prevGroup
	            }),
	            groupCollapsed: assign({}, props, {
	              value: prevGroupCollapsed
	            }),
	            groupEnd: assign({}, props, {
	              value: prevGroupEnd
	            })
	          });
	        }
	        if (disabledDepth < 0) {
	          error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
	        }
	      }
	    }
	    var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
	    var prefix;
	    function describeBuiltInComponentFrame(name, source, ownerFn) {
	      {
	        if (prefix === void 0) {
	          try {
	            throw Error();
	          } catch (x) {
	            var match = x.stack.trim().match(/\n( *(at )?)/);
	            prefix = match && match[1] || "";
	          }
	        }
	        return "\n" + prefix + name;
	      }
	    }
	    var reentry = false;
	    var componentFrameCache;
	    {
	      var PossiblyWeakMap = typeof WeakMap === "function" ? WeakMap : Map;
	      componentFrameCache = new PossiblyWeakMap();
	    }
	    function describeNativeComponentFrame(fn, construct) {
	      if (!fn || reentry) {
	        return "";
	      }
	      {
	        var frame = componentFrameCache.get(fn);
	        if (frame !== void 0) {
	          return frame;
	        }
	      }
	      var control;
	      reentry = true;
	      var previousPrepareStackTrace = Error.prepareStackTrace;
	      Error.prepareStackTrace = void 0;
	      var previousDispatcher;
	      {
	        previousDispatcher = ReactCurrentDispatcher.current;
	        ReactCurrentDispatcher.current = null;
	        disableLogs();
	      }
	      try {
	        if (construct) {
	          var Fake = function() {
	            throw Error();
	          };
	          Object.defineProperty(Fake.prototype, "props", {
	            set: function() {
	              throw Error();
	            }
	          });
	          if (typeof Reflect === "object" && Reflect.construct) {
	            try {
	              Reflect.construct(Fake, []);
	            } catch (x) {
	              control = x;
	            }
	            Reflect.construct(fn, [], Fake);
	          } else {
	            try {
	              Fake.call();
	            } catch (x) {
	              control = x;
	            }
	            fn.call(Fake.prototype);
	          }
	        } else {
	          try {
	            throw Error();
	          } catch (x) {
	            control = x;
	          }
	          fn();
	        }
	      } catch (sample) {
	        if (sample && control && typeof sample.stack === "string") {
	          var sampleLines = sample.stack.split("\n");
	          var controlLines = control.stack.split("\n");
	          var s = sampleLines.length - 1;
	          var c = controlLines.length - 1;
	          while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
	            c--;
	          }
	          for (; s >= 1 && c >= 0; s--, c--) {
	            if (sampleLines[s] !== controlLines[c]) {
	              if (s !== 1 || c !== 1) {
	                do {
	                  s--;
	                  c--;
	                  if (c < 0 || sampleLines[s] !== controlLines[c]) {
	                    var _frame = "\n" + sampleLines[s].replace(" at new ", " at ");
	                    if (fn.displayName && _frame.includes("<anonymous>")) {
	                      _frame = _frame.replace("<anonymous>", fn.displayName);
	                    }
	                    {
	                      if (typeof fn === "function") {
	                        componentFrameCache.set(fn, _frame);
	                      }
	                    }
	                    return _frame;
	                  }
	                } while (s >= 1 && c >= 0);
	              }
	              break;
	            }
	          }
	        }
	      } finally {
	        reentry = false;
	        {
	          ReactCurrentDispatcher.current = previousDispatcher;
	          reenableLogs();
	        }
	        Error.prepareStackTrace = previousPrepareStackTrace;
	      }
	      var name = fn ? fn.displayName || fn.name : "";
	      var syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
	      {
	        if (typeof fn === "function") {
	          componentFrameCache.set(fn, syntheticFrame);
	        }
	      }
	      return syntheticFrame;
	    }
	    function describeFunctionComponentFrame(fn, source, ownerFn) {
	      {
	        return describeNativeComponentFrame(fn, false);
	      }
	    }
	    function shouldConstruct(Component) {
	      var prototype = Component.prototype;
	      return !!(prototype && prototype.isReactComponent);
	    }
	    function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
	      if (type == null) {
	        return "";
	      }
	      if (typeof type === "function") {
	        {
	          return describeNativeComponentFrame(type, shouldConstruct(type));
	        }
	      }
	      if (typeof type === "string") {
	        return describeBuiltInComponentFrame(type);
	      }
	      switch (type) {
	        case REACT_SUSPENSE_TYPE:
	          return describeBuiltInComponentFrame("Suspense");
	        case REACT_SUSPENSE_LIST_TYPE:
	          return describeBuiltInComponentFrame("SuspenseList");
	      }
	      if (typeof type === "object") {
	        switch (type.$$typeof) {
	          case REACT_FORWARD_REF_TYPE:
	            return describeFunctionComponentFrame(type.render);
	          case REACT_MEMO_TYPE:
	            return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
	          case REACT_LAZY_TYPE: {
	            var lazyComponent = type;
	            var payload = lazyComponent._payload;
	            var init = lazyComponent._init;
	            try {
	              return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
	            } catch (x) {
	            }
	          }
	        }
	      }
	      return "";
	    }
	    var hasOwnProperty = Object.prototype.hasOwnProperty;
	    var loggedTypeFailures = {};
	    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
	    function setCurrentlyValidatingElement(element) {
	      {
	        if (element) {
	          var owner = element._owner;
	          var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
	          ReactDebugCurrentFrame.setExtraStackFrame(stack);
	        } else {
	          ReactDebugCurrentFrame.setExtraStackFrame(null);
	        }
	      }
	    }
	    function checkPropTypes(typeSpecs, values, location, componentName, element) {
	      {
	        var has = Function.call.bind(hasOwnProperty);
	        for (var typeSpecName in typeSpecs) {
	          if (has(typeSpecs, typeSpecName)) {
	            var error$1 = void 0;
	            try {
	              if (typeof typeSpecs[typeSpecName] !== "function") {
	                var err = Error((componentName || "React class") + ": " + location + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
	                err.name = "Invariant Violation";
	                throw err;
	              }
	              error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
	            } catch (ex) {
	              error$1 = ex;
	            }
	            if (error$1 && !(error$1 instanceof Error)) {
	              setCurrentlyValidatingElement(element);
	              error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location, typeSpecName, typeof error$1);
	              setCurrentlyValidatingElement(null);
	            }
	            if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
	              loggedTypeFailures[error$1.message] = true;
	              setCurrentlyValidatingElement(element);
	              error("Failed %s type: %s", location, error$1.message);
	              setCurrentlyValidatingElement(null);
	            }
	          }
	        }
	      }
	    }
	    var isArrayImpl = Array.isArray;
	    function isArray(a) {
	      return isArrayImpl(a);
	    }
	    function typeName(value) {
	      {
	        var hasToStringTag = typeof Symbol === "function" && Symbol.toStringTag;
	        var type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
	        return type;
	      }
	    }
	    function willCoercionThrow(value) {
	      {
	        try {
	          testStringCoercion(value);
	          return false;
	        } catch (e) {
	          return true;
	        }
	      }
	    }
	    function testStringCoercion(value) {
	      return "" + value;
	    }
	    function checkKeyStringCoercion(value) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
	    var RESERVED_PROPS = {
	      key: true,
	      ref: true,
	      __self: true,
	      __source: true
	    };
	    var specialPropKeyWarningShown;
	    var specialPropRefWarningShown;
	    var didWarnAboutStringRefs;
	    {
	      didWarnAboutStringRefs = {};
	    }
	    function hasValidRef(config) {
	      {
	        if (hasOwnProperty.call(config, "ref")) {
	          var getter = Object.getOwnPropertyDescriptor(config, "ref").get;
	          if (getter && getter.isReactWarning) {
	            return false;
	          }
	        }
	      }
	      return config.ref !== void 0;
	    }
	    function hasValidKey(config) {
	      {
	        if (hasOwnProperty.call(config, "key")) {
	          var getter = Object.getOwnPropertyDescriptor(config, "key").get;
	          if (getter && getter.isReactWarning) {
	            return false;
	          }
	        }
	      }
	      return config.key !== void 0;
	    }
	    function warnIfStringRefCannotBeAutoConverted(config, self) {
	      {
	        if (typeof config.ref === "string" && ReactCurrentOwner.current && self && ReactCurrentOwner.current.stateNode !== self) {
	          var componentName = getComponentNameFromType(ReactCurrentOwner.current.type);
	          if (!didWarnAboutStringRefs[componentName]) {
	            error('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', getComponentNameFromType(ReactCurrentOwner.current.type), config.ref);
	            didWarnAboutStringRefs[componentName] = true;
	          }
	        }
	      }
	    }
	    function defineKeyPropWarningGetter(props, displayName) {
	      {
	        var warnAboutAccessingKey = function() {
	          if (!specialPropKeyWarningShown) {
	            specialPropKeyWarningShown = true;
	            error("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
	          }
	        };
	        warnAboutAccessingKey.isReactWarning = true;
	        Object.defineProperty(props, "key", {
	          get: warnAboutAccessingKey,
	          configurable: true
	        });
	      }
	    }
	    function defineRefPropWarningGetter(props, displayName) {
	      {
	        var warnAboutAccessingRef = function() {
	          if (!specialPropRefWarningShown) {
	            specialPropRefWarningShown = true;
	            error("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName);
	          }
	        };
	        warnAboutAccessingRef.isReactWarning = true;
	        Object.defineProperty(props, "ref", {
	          get: warnAboutAccessingRef,
	          configurable: true
	        });
	      }
	    }
	    var ReactElement = function(type, key, ref, self, source, owner, props) {
	      var element = {
	        // This tag allows us to uniquely identify this as a React Element
	        $$typeof: REACT_ELEMENT_TYPE,
	        // Built-in properties that belong on the element
	        type,
	        key,
	        ref,
	        props,
	        // Record the component responsible for creating this element.
	        _owner: owner
	      };
	      {
	        element._store = {};
	        Object.defineProperty(element._store, "validated", {
	          configurable: false,
	          enumerable: false,
	          writable: true,
	          value: false
	        });
	        Object.defineProperty(element, "_self", {
	          configurable: false,
	          enumerable: false,
	          writable: false,
	          value: self
	        });
	        Object.defineProperty(element, "_source", {
	          configurable: false,
	          enumerable: false,
	          writable: false,
	          value: source
	        });
	        if (Object.freeze) {
	          Object.freeze(element.props);
	          Object.freeze(element);
	        }
	      }
	      return element;
	    };
	    function jsxDEV(type, config, maybeKey, source, self) {
	      {
	        var propName;
	        var props = {};
	        var key = null;
	        var ref = null;
	        if (maybeKey !== void 0) {
	          {
	            checkKeyStringCoercion(maybeKey);
	          }
	          key = "" + maybeKey;
	        }
	        if (hasValidKey(config)) {
	          {
	            checkKeyStringCoercion(config.key);
	          }
	          key = "" + config.key;
	        }
	        if (hasValidRef(config)) {
	          ref = config.ref;
	          warnIfStringRefCannotBeAutoConverted(config, self);
	        }
	        for (propName in config) {
	          if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
	            props[propName] = config[propName];
	          }
	        }
	        if (type && type.defaultProps) {
	          var defaultProps = type.defaultProps;
	          for (propName in defaultProps) {
	            if (props[propName] === void 0) {
	              props[propName] = defaultProps[propName];
	            }
	          }
	        }
	        if (key || ref) {
	          var displayName = typeof type === "function" ? type.displayName || type.name || "Unknown" : type;
	          if (key) {
	            defineKeyPropWarningGetter(props, displayName);
	          }
	          if (ref) {
	            defineRefPropWarningGetter(props, displayName);
	          }
	        }
	        return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
	      }
	    }
	    var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
	    var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
	    function setCurrentlyValidatingElement$1(element) {
	      {
	        if (element) {
	          var owner = element._owner;
	          var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
	          ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
	        } else {
	          ReactDebugCurrentFrame$1.setExtraStackFrame(null);
	        }
	      }
	    }
	    var propTypesMisspellWarningShown;
	    {
	      propTypesMisspellWarningShown = false;
	    }
	    function isValidElement(object) {
	      {
	        return typeof object === "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
	      }
	    }
	    function getDeclarationErrorAddendum() {
	      {
	        if (ReactCurrentOwner$1.current) {
	          var name = getComponentNameFromType(ReactCurrentOwner$1.current.type);
	          if (name) {
	            return "\n\nCheck the render method of `" + name + "`.";
	          }
	        }
	        return "";
	      }
	    }
	    function getSourceInfoErrorAddendum(source) {
	      {
	        if (source !== void 0) {
	          var fileName = source.fileName.replace(/^.*[\\\/]/, "");
	          var lineNumber = source.lineNumber;
	          return "\n\nCheck your code at " + fileName + ":" + lineNumber + ".";
	        }
	        return "";
	      }
	    }
	    var ownerHasKeyUseWarning = {};
	    function getCurrentComponentErrorInfo(parentType) {
	      {
	        var info = getDeclarationErrorAddendum();
	        if (!info) {
	          var parentName = typeof parentType === "string" ? parentType : parentType.displayName || parentType.name;
	          if (parentName) {
	            info = "\n\nCheck the top-level render call using <" + parentName + ">.";
	          }
	        }
	        return info;
	      }
	    }
	    function validateExplicitKey(element, parentType) {
	      {
	        if (!element._store || element._store.validated || element.key != null) {
	          return;
	        }
	        element._store.validated = true;
	        var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);
	        if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
	          return;
	        }
	        ownerHasKeyUseWarning[currentComponentErrorInfo] = true;
	        var childOwner = "";
	        if (element && element._owner && element._owner !== ReactCurrentOwner$1.current) {
	          childOwner = " It was passed a child from " + getComponentNameFromType(element._owner.type) + ".";
	        }
	        setCurrentlyValidatingElement$1(element);
	        error('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);
	        setCurrentlyValidatingElement$1(null);
	      }
	    }
	    function validateChildKeys(node, parentType) {
	      {
	        if (typeof node !== "object") {
	          return;
	        }
	        if (isArray(node)) {
	          for (var i = 0; i < node.length; i++) {
	            var child = node[i];
	            if (isValidElement(child)) {
	              validateExplicitKey(child, parentType);
	            }
	          }
	        } else if (isValidElement(node)) {
	          if (node._store) {
	            node._store.validated = true;
	          }
	        } else if (node) {
	          var iteratorFn = getIteratorFn(node);
	          if (typeof iteratorFn === "function") {
	            if (iteratorFn !== node.entries) {
	              var iterator = iteratorFn.call(node);
	              var step;
	              while (!(step = iterator.next()).done) {
	                if (isValidElement(step.value)) {
	                  validateExplicitKey(step.value, parentType);
	                }
	              }
	            }
	          }
	        }
	      }
	    }
	    function validatePropTypes(element) {
	      {
	        var type = element.type;
	        if (type === null || type === void 0 || typeof type === "string") {
	          return;
	        }
	        var propTypes;
	        if (typeof type === "function") {
	          propTypes = type.propTypes;
	        } else if (typeof type === "object" && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
	        // Inner props are checked in the reconciler.
	        type.$$typeof === REACT_MEMO_TYPE)) {
	          propTypes = type.propTypes;
	        } else {
	          return;
	        }
	        if (propTypes) {
	          var name = getComponentNameFromType(type);
	          checkPropTypes(propTypes, element.props, "prop", name, element);
	        } else if (type.PropTypes !== void 0 && !propTypesMisspellWarningShown) {
	          propTypesMisspellWarningShown = true;
	          var _name = getComponentNameFromType(type);
	          error("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", _name || "Unknown");
	        }
	        if (typeof type.getDefaultProps === "function" && !type.getDefaultProps.isReactClassApproved) {
	          error("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
	        }
	      }
	    }
	    function validateFragmentProps(fragment) {
	      {
	        var keys = Object.keys(fragment.props);
	        for (var i = 0; i < keys.length; i++) {
	          var key = keys[i];
	          if (key !== "children" && key !== "key") {
	            setCurrentlyValidatingElement$1(fragment);
	            error("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", key);
	            setCurrentlyValidatingElement$1(null);
	            break;
	          }
	        }
	        if (fragment.ref !== null) {
	          setCurrentlyValidatingElement$1(fragment);
	          error("Invalid attribute `ref` supplied to `React.Fragment`.");
	          setCurrentlyValidatingElement$1(null);
	        }
	      }
	    }
	    function jsxWithValidation(type, props, key, isStaticChildren, source, self) {
	      {
	        var validType = isValidElementType(type);
	        if (!validType) {
	          var info = "";
	          if (type === void 0 || typeof type === "object" && type !== null && Object.keys(type).length === 0) {
	            info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
	          }
	          var sourceInfo = getSourceInfoErrorAddendum(source);
	          if (sourceInfo) {
	            info += sourceInfo;
	          } else {
	            info += getDeclarationErrorAddendum();
	          }
	          var typeString;
	          if (type === null) {
	            typeString = "null";
	          } else if (isArray(type)) {
	            typeString = "array";
	          } else if (type !== void 0 && type.$$typeof === REACT_ELEMENT_TYPE) {
	            typeString = "<" + (getComponentNameFromType(type.type) || "Unknown") + " />";
	            info = " Did you accidentally export a JSX literal instead of a component?";
	          } else {
	            typeString = typeof type;
	          }
	          error("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", typeString, info);
	        }
	        var element = jsxDEV(type, props, key, source, self);
	        if (element == null) {
	          return element;
	        }
	        if (validType) {
	          var children = props.children;
	          if (children !== void 0) {
	            if (isStaticChildren) {
	              if (isArray(children)) {
	                for (var i = 0; i < children.length; i++) {
	                  validateChildKeys(children[i], type);
	                }
	                if (Object.freeze) {
	                  Object.freeze(children);
	                }
	              } else {
	                error("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
	              }
	            } else {
	              validateChildKeys(children, type);
	            }
	          }
	        }
	        if (type === REACT_FRAGMENT_TYPE) {
	          validateFragmentProps(element);
	        } else {
	          validatePropTypes(element);
	        }
	        return element;
	      }
	    }
	    function jsxWithValidationStatic(type, props, key) {
	      {
	        return jsxWithValidation(type, props, key, true);
	      }
	    }
	    function jsxWithValidationDynamic(type, props, key) {
	      {
	        return jsxWithValidation(type, props, key, false);
	      }
	    }
	    var jsx = jsxWithValidationDynamic;
	    var jsxs = jsxWithValidationStatic;
	    reactJsxRuntime_development.Fragment = REACT_FRAGMENT_TYPE;
	    reactJsxRuntime_development.jsx = jsx;
	    reactJsxRuntime_development.jsxs = jsxs;
	  })();
	}
	return reactJsxRuntime_development;
}

var reactJsxRuntime_production_min = {};

/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReactJsxRuntime_production_min;

function requireReactJsxRuntime_production_min () {
	if (hasRequiredReactJsxRuntime_production_min) return reactJsxRuntime_production_min;
	hasRequiredReactJsxRuntime_production_min = 1;
var f=reactExports,k=Symbol.for("react.element"),l=Symbol.for("react.fragment"),m=Object.prototype.hasOwnProperty,n=f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,p={key:!0,ref:!0,__self:!0,__source:!0};
	function q(c,a,g){var b,d={},e=null,h=null;void 0!==g&&(e=""+g);void 0!==a.key&&(e=""+a.key);void 0!==a.ref&&(h=a.ref);for(b in a)m.call(a,b)&&!p.hasOwnProperty(b)&&(d[b]=a[b]);if(c&&c.defaultProps)for(b in a=c.defaultProps,a)void 0===d[b]&&(d[b]=a[b]);return {$$typeof:k,type:c,key:e,ref:h,props:d,_owner:n.current}}reactJsxRuntime_production_min.Fragment=l;reactJsxRuntime_production_min.jsx=q;reactJsxRuntime_production_min.jsxs=q;
	return reactJsxRuntime_production_min;
}

var define_process_env_default$4 = {};
if (define_process_env_default$4.NODE_ENV === "production") {
  jsxRuntime.exports = requireReactJsxRuntime_production_min();
} else {
  jsxRuntime.exports = requireReactJsxRuntime_development();
}

var jsxRuntimeExports = jsxRuntime.exports;

var client = {};

var reactDom = {exports: {}};

var reactDom_development = {};

var scheduler = {exports: {}};

var scheduler_development = {};

var hasRequiredScheduler_development;

function requireScheduler_development () {
	if (hasRequiredScheduler_development) return scheduler_development;
	hasRequiredScheduler_development = 1;
	(function (exports) {
		var define_process_env_default = {};
		/**
		 * @license React
		 * scheduler.development.js
		 *
		 * Copyright (c) Facebook, Inc. and its affiliates.
		 *
		 * This source code is licensed under the MIT license found in the
		 * LICENSE file in the root directory of this source tree.
		 */
		if (define_process_env_default.NODE_ENV !== "production") {
		  (function() {
		    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
		      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
		    }
		    var enableSchedulerDebugging = false;
		    var enableProfiling = false;
		    var frameYieldMs = 5;
		    function push(heap, node) {
		      var index = heap.length;
		      heap.push(node);
		      siftUp(heap, node, index);
		    }
		    function peek(heap) {
		      return heap.length === 0 ? null : heap[0];
		    }
		    function pop(heap) {
		      if (heap.length === 0) {
		        return null;
		      }
		      var first = heap[0];
		      var last = heap.pop();
		      if (last !== first) {
		        heap[0] = last;
		        siftDown(heap, last, 0);
		      }
		      return first;
		    }
		    function siftUp(heap, node, i) {
		      var index = i;
		      while (index > 0) {
		        var parentIndex = index - 1 >>> 1;
		        var parent = heap[parentIndex];
		        if (compare(parent, node) > 0) {
		          heap[parentIndex] = node;
		          heap[index] = parent;
		          index = parentIndex;
		        } else {
		          return;
		        }
		      }
		    }
		    function siftDown(heap, node, i) {
		      var index = i;
		      var length = heap.length;
		      var halfLength = length >>> 1;
		      while (index < halfLength) {
		        var leftIndex = (index + 1) * 2 - 1;
		        var left = heap[leftIndex];
		        var rightIndex = leftIndex + 1;
		        var right = heap[rightIndex];
		        if (compare(left, node) < 0) {
		          if (rightIndex < length && compare(right, left) < 0) {
		            heap[index] = right;
		            heap[rightIndex] = node;
		            index = rightIndex;
		          } else {
		            heap[index] = left;
		            heap[leftIndex] = node;
		            index = leftIndex;
		          }
		        } else if (rightIndex < length && compare(right, node) < 0) {
		          heap[index] = right;
		          heap[rightIndex] = node;
		          index = rightIndex;
		        } else {
		          return;
		        }
		      }
		    }
		    function compare(a, b) {
		      var diff = a.sortIndex - b.sortIndex;
		      return diff !== 0 ? diff : a.id - b.id;
		    }
		    var ImmediatePriority = 1;
		    var UserBlockingPriority = 2;
		    var NormalPriority = 3;
		    var LowPriority = 4;
		    var IdlePriority = 5;
		    function markTaskErrored(task, ms) {
		    }
		    var hasPerformanceNow = typeof performance === "object" && typeof performance.now === "function";
		    if (hasPerformanceNow) {
		      var localPerformance = performance;
		      exports.unstable_now = function() {
		        return localPerformance.now();
		      };
		    } else {
		      var localDate = Date;
		      var initialTime = localDate.now();
		      exports.unstable_now = function() {
		        return localDate.now() - initialTime;
		      };
		    }
		    var maxSigned31BitInt = 1073741823;
		    var IMMEDIATE_PRIORITY_TIMEOUT = -1;
		    var USER_BLOCKING_PRIORITY_TIMEOUT = 250;
		    var NORMAL_PRIORITY_TIMEOUT = 5e3;
		    var LOW_PRIORITY_TIMEOUT = 1e4;
		    var IDLE_PRIORITY_TIMEOUT = maxSigned31BitInt;
		    var taskQueue = [];
		    var timerQueue = [];
		    var taskIdCounter = 1;
		    var currentTask = null;
		    var currentPriorityLevel = NormalPriority;
		    var isPerformingWork = false;
		    var isHostCallbackScheduled = false;
		    var isHostTimeoutScheduled = false;
		    var localSetTimeout = typeof setTimeout === "function" ? setTimeout : null;
		    var localClearTimeout = typeof clearTimeout === "function" ? clearTimeout : null;
		    var localSetImmediate = typeof setImmediate !== "undefined" ? setImmediate : null;
		    typeof navigator !== "undefined" && navigator.scheduling !== void 0 && navigator.scheduling.isInputPending !== void 0 ? navigator.scheduling.isInputPending.bind(navigator.scheduling) : null;
		    function advanceTimers(currentTime) {
		      var timer = peek(timerQueue);
		      while (timer !== null) {
		        if (timer.callback === null) {
		          pop(timerQueue);
		        } else if (timer.startTime <= currentTime) {
		          pop(timerQueue);
		          timer.sortIndex = timer.expirationTime;
		          push(taskQueue, timer);
		        } else {
		          return;
		        }
		        timer = peek(timerQueue);
		      }
		    }
		    function handleTimeout(currentTime) {
		      isHostTimeoutScheduled = false;
		      advanceTimers(currentTime);
		      if (!isHostCallbackScheduled) {
		        if (peek(taskQueue) !== null) {
		          isHostCallbackScheduled = true;
		          requestHostCallback(flushWork);
		        } else {
		          var firstTimer = peek(timerQueue);
		          if (firstTimer !== null) {
		            requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
		          }
		        }
		      }
		    }
		    function flushWork(hasTimeRemaining, initialTime2) {
		      isHostCallbackScheduled = false;
		      if (isHostTimeoutScheduled) {
		        isHostTimeoutScheduled = false;
		        cancelHostTimeout();
		      }
		      isPerformingWork = true;
		      var previousPriorityLevel = currentPriorityLevel;
		      try {
		        var currentTime; if (enableProfiling) ; else {
		          return workLoop(hasTimeRemaining, initialTime2);
		        }
		      } finally {
		        currentTask = null;
		        currentPriorityLevel = previousPriorityLevel;
		        isPerformingWork = false;
		      }
		    }
		    function workLoop(hasTimeRemaining, initialTime2) {
		      var currentTime = initialTime2;
		      advanceTimers(currentTime);
		      currentTask = peek(taskQueue);
		      while (currentTask !== null && !enableSchedulerDebugging) {
		        if (currentTask.expirationTime > currentTime && (!hasTimeRemaining || shouldYieldToHost())) {
		          break;
		        }
		        var callback = currentTask.callback;
		        if (typeof callback === "function") {
		          currentTask.callback = null;
		          currentPriorityLevel = currentTask.priorityLevel;
		          var didUserCallbackTimeout = currentTask.expirationTime <= currentTime;
		          var continuationCallback = callback(didUserCallbackTimeout);
		          currentTime = exports.unstable_now();
		          if (typeof continuationCallback === "function") {
		            currentTask.callback = continuationCallback;
		          } else {
		            if (currentTask === peek(taskQueue)) {
		              pop(taskQueue);
		            }
		          }
		          advanceTimers(currentTime);
		        } else {
		          pop(taskQueue);
		        }
		        currentTask = peek(taskQueue);
		      }
		      if (currentTask !== null) {
		        return true;
		      } else {
		        var firstTimer = peek(timerQueue);
		        if (firstTimer !== null) {
		          requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
		        }
		        return false;
		      }
		    }
		    function unstable_runWithPriority(priorityLevel, eventHandler) {
		      switch (priorityLevel) {
		        case ImmediatePriority:
		        case UserBlockingPriority:
		        case NormalPriority:
		        case LowPriority:
		        case IdlePriority:
		          break;
		        default:
		          priorityLevel = NormalPriority;
		      }
		      var previousPriorityLevel = currentPriorityLevel;
		      currentPriorityLevel = priorityLevel;
		      try {
		        return eventHandler();
		      } finally {
		        currentPriorityLevel = previousPriorityLevel;
		      }
		    }
		    function unstable_next(eventHandler) {
		      var priorityLevel;
		      switch (currentPriorityLevel) {
		        case ImmediatePriority:
		        case UserBlockingPriority:
		        case NormalPriority:
		          priorityLevel = NormalPriority;
		          break;
		        default:
		          priorityLevel = currentPriorityLevel;
		          break;
		      }
		      var previousPriorityLevel = currentPriorityLevel;
		      currentPriorityLevel = priorityLevel;
		      try {
		        return eventHandler();
		      } finally {
		        currentPriorityLevel = previousPriorityLevel;
		      }
		    }
		    function unstable_wrapCallback(callback) {
		      var parentPriorityLevel = currentPriorityLevel;
		      return function() {
		        var previousPriorityLevel = currentPriorityLevel;
		        currentPriorityLevel = parentPriorityLevel;
		        try {
		          return callback.apply(this, arguments);
		        } finally {
		          currentPriorityLevel = previousPriorityLevel;
		        }
		      };
		    }
		    function unstable_scheduleCallback(priorityLevel, callback, options) {
		      var currentTime = exports.unstable_now();
		      var startTime2;
		      if (typeof options === "object" && options !== null) {
		        var delay = options.delay;
		        if (typeof delay === "number" && delay > 0) {
		          startTime2 = currentTime + delay;
		        } else {
		          startTime2 = currentTime;
		        }
		      } else {
		        startTime2 = currentTime;
		      }
		      var timeout;
		      switch (priorityLevel) {
		        case ImmediatePriority:
		          timeout = IMMEDIATE_PRIORITY_TIMEOUT;
		          break;
		        case UserBlockingPriority:
		          timeout = USER_BLOCKING_PRIORITY_TIMEOUT;
		          break;
		        case IdlePriority:
		          timeout = IDLE_PRIORITY_TIMEOUT;
		          break;
		        case LowPriority:
		          timeout = LOW_PRIORITY_TIMEOUT;
		          break;
		        case NormalPriority:
		        default:
		          timeout = NORMAL_PRIORITY_TIMEOUT;
		          break;
		      }
		      var expirationTime = startTime2 + timeout;
		      var newTask = {
		        id: taskIdCounter++,
		        callback,
		        priorityLevel,
		        startTime: startTime2,
		        expirationTime,
		        sortIndex: -1
		      };
		      if (startTime2 > currentTime) {
		        newTask.sortIndex = startTime2;
		        push(timerQueue, newTask);
		        if (peek(taskQueue) === null && newTask === peek(timerQueue)) {
		          if (isHostTimeoutScheduled) {
		            cancelHostTimeout();
		          } else {
		            isHostTimeoutScheduled = true;
		          }
		          requestHostTimeout(handleTimeout, startTime2 - currentTime);
		        }
		      } else {
		        newTask.sortIndex = expirationTime;
		        push(taskQueue, newTask);
		        if (!isHostCallbackScheduled && !isPerformingWork) {
		          isHostCallbackScheduled = true;
		          requestHostCallback(flushWork);
		        }
		      }
		      return newTask;
		    }
		    function unstable_pauseExecution() {
		    }
		    function unstable_continueExecution() {
		      if (!isHostCallbackScheduled && !isPerformingWork) {
		        isHostCallbackScheduled = true;
		        requestHostCallback(flushWork);
		      }
		    }
		    function unstable_getFirstCallbackNode() {
		      return peek(taskQueue);
		    }
		    function unstable_cancelCallback(task) {
		      task.callback = null;
		    }
		    function unstable_getCurrentPriorityLevel() {
		      return currentPriorityLevel;
		    }
		    var isMessageLoopRunning = false;
		    var scheduledHostCallback = null;
		    var taskTimeoutID = -1;
		    var frameInterval = frameYieldMs;
		    var startTime = -1;
		    function shouldYieldToHost() {
		      var timeElapsed = exports.unstable_now() - startTime;
		      if (timeElapsed < frameInterval) {
		        return false;
		      }
		      return true;
		    }
		    function requestPaint() {
		    }
		    function forceFrameRate(fps) {
		      if (fps < 0 || fps > 125) {
		        console["error"]("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported");
		        return;
		      }
		      if (fps > 0) {
		        frameInterval = Math.floor(1e3 / fps);
		      } else {
		        frameInterval = frameYieldMs;
		      }
		    }
		    var performWorkUntilDeadline = function() {
		      if (scheduledHostCallback !== null) {
		        var currentTime = exports.unstable_now();
		        startTime = currentTime;
		        var hasTimeRemaining = true;
		        var hasMoreWork = true;
		        try {
		          hasMoreWork = scheduledHostCallback(hasTimeRemaining, currentTime);
		        } finally {
		          if (hasMoreWork) {
		            schedulePerformWorkUntilDeadline();
		          } else {
		            isMessageLoopRunning = false;
		            scheduledHostCallback = null;
		          }
		        }
		      } else {
		        isMessageLoopRunning = false;
		      }
		    };
		    var schedulePerformWorkUntilDeadline;
		    if (typeof localSetImmediate === "function") {
		      schedulePerformWorkUntilDeadline = function() {
		        localSetImmediate(performWorkUntilDeadline);
		      };
		    } else if (typeof MessageChannel !== "undefined") {
		      var channel = new MessageChannel();
		      var port = channel.port2;
		      channel.port1.onmessage = performWorkUntilDeadline;
		      schedulePerformWorkUntilDeadline = function() {
		        port.postMessage(null);
		      };
		    } else {
		      schedulePerformWorkUntilDeadline = function() {
		        localSetTimeout(performWorkUntilDeadline, 0);
		      };
		    }
		    function requestHostCallback(callback) {
		      scheduledHostCallback = callback;
		      if (!isMessageLoopRunning) {
		        isMessageLoopRunning = true;
		        schedulePerformWorkUntilDeadline();
		      }
		    }
		    function requestHostTimeout(callback, ms) {
		      taskTimeoutID = localSetTimeout(function() {
		        callback(exports.unstable_now());
		      }, ms);
		    }
		    function cancelHostTimeout() {
		      localClearTimeout(taskTimeoutID);
		      taskTimeoutID = -1;
		    }
		    var unstable_requestPaint = requestPaint;
		    var unstable_Profiling = null;
		    exports.unstable_IdlePriority = IdlePriority;
		    exports.unstable_ImmediatePriority = ImmediatePriority;
		    exports.unstable_LowPriority = LowPriority;
		    exports.unstable_NormalPriority = NormalPriority;
		    exports.unstable_Profiling = unstable_Profiling;
		    exports.unstable_UserBlockingPriority = UserBlockingPriority;
		    exports.unstable_cancelCallback = unstable_cancelCallback;
		    exports.unstable_continueExecution = unstable_continueExecution;
		    exports.unstable_forceFrameRate = forceFrameRate;
		    exports.unstable_getCurrentPriorityLevel = unstable_getCurrentPriorityLevel;
		    exports.unstable_getFirstCallbackNode = unstable_getFirstCallbackNode;
		    exports.unstable_next = unstable_next;
		    exports.unstable_pauseExecution = unstable_pauseExecution;
		    exports.unstable_requestPaint = unstable_requestPaint;
		    exports.unstable_runWithPriority = unstable_runWithPriority;
		    exports.unstable_scheduleCallback = unstable_scheduleCallback;
		    exports.unstable_shouldYield = shouldYieldToHost;
		    exports.unstable_wrapCallback = unstable_wrapCallback;
		    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
		      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
		    }
		  })();
		} 
	} (scheduler_development));
	return scheduler_development;
}

var scheduler_production_min = {};

/**
 * @license React
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredScheduler_production_min;

function requireScheduler_production_min () {
	if (hasRequiredScheduler_production_min) return scheduler_production_min;
	hasRequiredScheduler_production_min = 1;
	(function (exports) {
function f(a,b){var c=a.length;a.push(b);a:for(;0<c;){var d=c-1>>>1,e=a[d];if(0<g(e,b))a[d]=b,a[c]=e,c=d;else break a}}function h(a){return 0===a.length?null:a[0]}function k(a){if(0===a.length)return null;var b=a[0],c=a.pop();if(c!==b){a[0]=c;a:for(var d=0,e=a.length,w=e>>>1;d<w;){var m=2*(d+1)-1,C=a[m],n=m+1,x=a[n];if(0>g(C,c))n<e&&0>g(x,C)?(a[d]=x,a[n]=c,d=n):(a[d]=C,a[m]=c,d=m);else if(n<e&&0>g(x,c))a[d]=x,a[n]=c,d=n;else break a}}return b}
		function g(a,b){var c=a.sortIndex-b.sortIndex;return 0!==c?c:a.id-b.id}if("object"===typeof performance&&"function"===typeof performance.now){var l=performance;exports.unstable_now=function(){return l.now()};}else {var p=Date,q=p.now();exports.unstable_now=function(){return p.now()-q};}var r=[],t=[],u=1,v=null,y=3,z=!1,A=!1,B=!1,D="function"===typeof setTimeout?setTimeout:null,E="function"===typeof clearTimeout?clearTimeout:null,F="undefined"!==typeof setImmediate?setImmediate:null;
		"undefined"!==typeof navigator&&void 0!==navigator.scheduling&&void 0!==navigator.scheduling.isInputPending&&navigator.scheduling.isInputPending.bind(navigator.scheduling);function G(a){for(var b=h(t);null!==b;){if(null===b.callback)k(t);else if(b.startTime<=a)k(t),b.sortIndex=b.expirationTime,f(r,b);else break;b=h(t);}}function H(a){B=!1;G(a);if(!A)if(null!==h(r))A=!0,I(J);else {var b=h(t);null!==b&&K(H,b.startTime-a);}}
		function J(a,b){A=!1;B&&(B=!1,E(L),L=-1);z=!0;var c=y;try{G(b);for(v=h(r);null!==v&&(!(v.expirationTime>b)||a&&!M());){var d=v.callback;if("function"===typeof d){v.callback=null;y=v.priorityLevel;var e=d(v.expirationTime<=b);b=exports.unstable_now();"function"===typeof e?v.callback=e:v===h(r)&&k(r);G(b);}else k(r);v=h(r);}if(null!==v)var w=!0;else {var m=h(t);null!==m&&K(H,m.startTime-b);w=!1;}return w}finally{v=null,y=c,z=!1;}}var N=!1,O=null,L=-1,P=5,Q=-1;
		function M(){return exports.unstable_now()-Q<P?!1:!0}function R(){if(null!==O){var a=exports.unstable_now();Q=a;var b=!0;try{b=O(!0,a);}finally{b?S():(N=!1,O=null);}}else N=!1;}var S;if("function"===typeof F)S=function(){F(R);};else if("undefined"!==typeof MessageChannel){var T=new MessageChannel,U=T.port2;T.port1.onmessage=R;S=function(){U.postMessage(null);};}else S=function(){D(R,0);};function I(a){O=a;N||(N=!0,S());}function K(a,b){L=D(function(){a(exports.unstable_now());},b);}
		exports.unstable_IdlePriority=5;exports.unstable_ImmediatePriority=1;exports.unstable_LowPriority=4;exports.unstable_NormalPriority=3;exports.unstable_Profiling=null;exports.unstable_UserBlockingPriority=2;exports.unstable_cancelCallback=function(a){a.callback=null;};exports.unstable_continueExecution=function(){A||z||(A=!0,I(J));};
		exports.unstable_forceFrameRate=function(a){0>a||125<a?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):P=0<a?Math.floor(1E3/a):5;};exports.unstable_getCurrentPriorityLevel=function(){return y};exports.unstable_getFirstCallbackNode=function(){return h(r)};exports.unstable_next=function(a){switch(y){case 1:case 2:case 3:var b=3;break;default:b=y;}var c=y;y=b;try{return a()}finally{y=c;}};exports.unstable_pauseExecution=function(){};
		exports.unstable_requestPaint=function(){};exports.unstable_runWithPriority=function(a,b){switch(a){case 1:case 2:case 3:case 4:case 5:break;default:a=3;}var c=y;y=a;try{return b()}finally{y=c;}};
		exports.unstable_scheduleCallback=function(a,b,c){var d=exports.unstable_now();"object"===typeof c&&null!==c?(c=c.delay,c="number"===typeof c&&0<c?d+c:d):c=d;switch(a){case 1:var e=-1;break;case 2:e=250;break;case 5:e=1073741823;break;case 4:e=1E4;break;default:e=5E3;}e=c+e;a={id:u++,callback:b,priorityLevel:a,startTime:c,expirationTime:e,sortIndex:-1};c>d?(a.sortIndex=c,f(t,a),null===h(r)&&a===h(t)&&(B?(E(L),L=-1):B=!0,K(H,c-d))):(a.sortIndex=e,f(r,a),A||z||(A=!0,I(J)));return a};
		exports.unstable_shouldYield=M;exports.unstable_wrapCallback=function(a){var b=y;return function(){var c=y;y=b;try{return a.apply(this,arguments)}finally{y=c;}}}; 
	} (scheduler_production_min));
	return scheduler_production_min;
}

var hasRequiredScheduler;

function requireScheduler () {
	if (hasRequiredScheduler) return scheduler.exports;
	hasRequiredScheduler = 1;
	var define_process_env_default = {};
	if (define_process_env_default.NODE_ENV === "production") {
	  scheduler.exports = requireScheduler_production_min();
	} else {
	  scheduler.exports = requireScheduler_development();
	}
	return scheduler.exports;
}

var hasRequiredReactDom_development;

function requireReactDom_development () {
	if (hasRequiredReactDom_development) return reactDom_development;
	hasRequiredReactDom_development = 1;
	var define_process_env_default = {};
	/**
	 * @license React
	 * react-dom.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */
	if (define_process_env_default.NODE_ENV !== "production") {
	  (function() {
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
	    }
	    var React = reactExports;
	    var Scheduler = requireScheduler();
	    var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
	    var suppressWarning = false;
	    function setSuppressWarning(newSuppressWarning) {
	      {
	        suppressWarning = newSuppressWarning;
	      }
	    }
	    function warn(format) {
	      {
	        if (!suppressWarning) {
	          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
	            args[_key - 1] = arguments[_key];
	          }
	          printWarning("warn", format, args);
	        }
	      }
	    }
	    function error(format) {
	      {
	        if (!suppressWarning) {
	          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	            args[_key2 - 1] = arguments[_key2];
	          }
	          printWarning("error", format, args);
	        }
	      }
	    }
	    function printWarning(level, format, args) {
	      {
	        var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
	        var stack = ReactDebugCurrentFrame2.getStackAddendum();
	        if (stack !== "") {
	          format += "%s";
	          args = args.concat([stack]);
	        }
	        var argsWithFormat = args.map(function(item) {
	          return String(item);
	        });
	        argsWithFormat.unshift("Warning: " + format);
	        Function.prototype.apply.call(console[level], console, argsWithFormat);
	      }
	    }
	    var FunctionComponent = 0;
	    var ClassComponent = 1;
	    var IndeterminateComponent = 2;
	    var HostRoot = 3;
	    var HostPortal = 4;
	    var HostComponent = 5;
	    var HostText = 6;
	    var Fragment = 7;
	    var Mode = 8;
	    var ContextConsumer = 9;
	    var ContextProvider = 10;
	    var ForwardRef = 11;
	    var Profiler = 12;
	    var SuspenseComponent = 13;
	    var MemoComponent = 14;
	    var SimpleMemoComponent = 15;
	    var LazyComponent = 16;
	    var IncompleteClassComponent = 17;
	    var DehydratedFragment = 18;
	    var SuspenseListComponent = 19;
	    var ScopeComponent = 21;
	    var OffscreenComponent = 22;
	    var LegacyHiddenComponent = 23;
	    var CacheComponent = 24;
	    var TracingMarkerComponent = 25;
	    var enableClientRenderFallbackOnTextMismatch = true;
	    var enableNewReconciler = false;
	    var enableLazyContextPropagation = false;
	    var enableLegacyHidden = false;
	    var enableSuspenseAvoidThisFallback = false;
	    var disableCommentsAsDOMContainers = true;
	    var enableCustomElementPropertySupport = false;
	    var warnAboutStringRefs = false;
	    var enableSchedulingProfiler = true;
	    var enableProfilerTimer = true;
	    var enableProfilerCommitHooks = true;
	    var allNativeEvents = /* @__PURE__ */ new Set();
	    var registrationNameDependencies = {};
	    var possibleRegistrationNames = {};
	    function registerTwoPhaseEvent(registrationName, dependencies) {
	      registerDirectEvent(registrationName, dependencies);
	      registerDirectEvent(registrationName + "Capture", dependencies);
	    }
	    function registerDirectEvent(registrationName, dependencies) {
	      {
	        if (registrationNameDependencies[registrationName]) {
	          error("EventRegistry: More than one plugin attempted to publish the same registration name, `%s`.", registrationName);
	        }
	      }
	      registrationNameDependencies[registrationName] = dependencies;
	      {
	        var lowerCasedName = registrationName.toLowerCase();
	        possibleRegistrationNames[lowerCasedName] = registrationName;
	        if (registrationName === "onDoubleClick") {
	          possibleRegistrationNames.ondblclick = registrationName;
	        }
	      }
	      for (var i = 0; i < dependencies.length; i++) {
	        allNativeEvents.add(dependencies[i]);
	      }
	    }
	    var canUseDOM = !!(typeof window !== "undefined" && typeof window.document !== "undefined" && typeof window.document.createElement !== "undefined");
	    var hasOwnProperty = Object.prototype.hasOwnProperty;
	    function typeName(value) {
	      {
	        var hasToStringTag = typeof Symbol === "function" && Symbol.toStringTag;
	        var type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
	        return type;
	      }
	    }
	    function willCoercionThrow(value) {
	      {
	        try {
	          testStringCoercion(value);
	          return false;
	        } catch (e) {
	          return true;
	        }
	      }
	    }
	    function testStringCoercion(value) {
	      return "" + value;
	    }
	    function checkAttributeStringCoercion(value, attributeName) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided `%s` attribute is an unsupported type %s. This value must be coerced to a string before before using it here.", attributeName, typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    function checkKeyStringCoercion(value) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    function checkPropStringCoercion(value, propName) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided `%s` prop is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    function checkCSSPropertyStringCoercion(value, propName) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided `%s` CSS property is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    function checkHtmlStringCoercion(value) {
	      {
	        if (willCoercionThrow(value)) {
	          error("The provided HTML markup uses a value of unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    function checkFormFieldValueStringCoercion(value) {
	      {
	        if (willCoercionThrow(value)) {
	          error("Form field values (value, checked, defaultValue, or defaultChecked props) must be strings, not %s. This value must be coerced to a string before before using it here.", typeName(value));
	          return testStringCoercion(value);
	        }
	      }
	    }
	    var RESERVED = 0;
	    var STRING = 1;
	    var BOOLEANISH_STRING = 2;
	    var BOOLEAN = 3;
	    var OVERLOADED_BOOLEAN = 4;
	    var NUMERIC = 5;
	    var POSITIVE_NUMERIC = 6;
	    var ATTRIBUTE_NAME_START_CHAR = ":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD";
	    var ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + "\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040";
	    var VALID_ATTRIBUTE_NAME_REGEX = new RegExp("^[" + ATTRIBUTE_NAME_START_CHAR + "][" + ATTRIBUTE_NAME_CHAR + "]*$");
	    var illegalAttributeNameCache = {};
	    var validatedAttributeNameCache = {};
	    function isAttributeNameSafe(attributeName) {
	      if (hasOwnProperty.call(validatedAttributeNameCache, attributeName)) {
	        return true;
	      }
	      if (hasOwnProperty.call(illegalAttributeNameCache, attributeName)) {
	        return false;
	      }
	      if (VALID_ATTRIBUTE_NAME_REGEX.test(attributeName)) {
	        validatedAttributeNameCache[attributeName] = true;
	        return true;
	      }
	      illegalAttributeNameCache[attributeName] = true;
	      {
	        error("Invalid attribute name: `%s`", attributeName);
	      }
	      return false;
	    }
	    function shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag) {
	      if (propertyInfo !== null) {
	        return propertyInfo.type === RESERVED;
	      }
	      if (isCustomComponentTag) {
	        return false;
	      }
	      if (name.length > 2 && (name[0] === "o" || name[0] === "O") && (name[1] === "n" || name[1] === "N")) {
	        return true;
	      }
	      return false;
	    }
	    function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
	      if (propertyInfo !== null && propertyInfo.type === RESERVED) {
	        return false;
	      }
	      switch (typeof value) {
	        case "function":
	        case "symbol":
	          return true;
	        case "boolean": {
	          if (isCustomComponentTag) {
	            return false;
	          }
	          if (propertyInfo !== null) {
	            return !propertyInfo.acceptsBooleans;
	          } else {
	            var prefix2 = name.toLowerCase().slice(0, 5);
	            return prefix2 !== "data-" && prefix2 !== "aria-";
	          }
	        }
	        default:
	          return false;
	      }
	    }
	    function shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag) {
	      if (value === null || typeof value === "undefined") {
	        return true;
	      }
	      if (shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag)) {
	        return true;
	      }
	      if (isCustomComponentTag) {
	        return false;
	      }
	      if (propertyInfo !== null) {
	        switch (propertyInfo.type) {
	          case BOOLEAN:
	            return !value;
	          case OVERLOADED_BOOLEAN:
	            return value === false;
	          case NUMERIC:
	            return isNaN(value);
	          case POSITIVE_NUMERIC:
	            return isNaN(value) || value < 1;
	        }
	      }
	      return false;
	    }
	    function getPropertyInfo(name) {
	      return properties.hasOwnProperty(name) ? properties[name] : null;
	    }
	    function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL2, removeEmptyString) {
	      this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN;
	      this.attributeName = attributeName;
	      this.attributeNamespace = attributeNamespace;
	      this.mustUseProperty = mustUseProperty;
	      this.propertyName = name;
	      this.type = type;
	      this.sanitizeURL = sanitizeURL2;
	      this.removeEmptyString = removeEmptyString;
	    }
	    var properties = {};
	    var reservedProps = [
	      "children",
	      "dangerouslySetInnerHTML",
	      // TODO: This prevents the assignment of defaultValue to regular
	      // elements (not just inputs). Now that ReactDOMInput assigns to the
	      // defaultValue property -- do we need this?
	      "defaultValue",
	      "defaultChecked",
	      "innerHTML",
	      "suppressContentEditableWarning",
	      "suppressHydrationWarning",
	      "style"
	    ];
	    reservedProps.forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        RESERVED,
	        false,
	        // mustUseProperty
	        name,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(_ref) {
	      var name = _ref[0], attributeName = _ref[1];
	      properties[name] = new PropertyInfoRecord(
	        name,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        BOOLEANISH_STRING,
	        false,
	        // mustUseProperty
	        name.toLowerCase(),
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        BOOLEANISH_STRING,
	        false,
	        // mustUseProperty
	        name,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "allowFullScreen",
	      "async",
	      // Note: there is a special case that prevents it from being written to the DOM
	      // on the client side because the browsers are inconsistent. Instead we call focus().
	      "autoFocus",
	      "autoPlay",
	      "controls",
	      "default",
	      "defer",
	      "disabled",
	      "disablePictureInPicture",
	      "disableRemotePlayback",
	      "formNoValidate",
	      "hidden",
	      "loop",
	      "noModule",
	      "noValidate",
	      "open",
	      "playsInline",
	      "readOnly",
	      "required",
	      "reversed",
	      "scoped",
	      "seamless",
	      // Microdata
	      "itemScope"
	    ].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        BOOLEAN,
	        false,
	        // mustUseProperty
	        name.toLowerCase(),
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "checked",
	      // Note: `option.selected` is not updated if `select.multiple` is
	      // disabled with `removeAttribute`. We have special logic for handling this.
	      "multiple",
	      "muted",
	      "selected"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        BOOLEAN,
	        true,
	        // mustUseProperty
	        name,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "capture",
	      "download"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        OVERLOADED_BOOLEAN,
	        false,
	        // mustUseProperty
	        name,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "cols",
	      "rows",
	      "size",
	      "span"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        POSITIVE_NUMERIC,
	        false,
	        // mustUseProperty
	        name,
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    ["rowSpan", "start"].forEach(function(name) {
	      properties[name] = new PropertyInfoRecord(
	        name,
	        NUMERIC,
	        false,
	        // mustUseProperty
	        name.toLowerCase(),
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    var CAMELIZE = /[\-\:]([a-z])/g;
	    var capitalize = function(token) {
	      return token[1].toUpperCase();
	    };
	    [
	      "accent-height",
	      "alignment-baseline",
	      "arabic-form",
	      "baseline-shift",
	      "cap-height",
	      "clip-path",
	      "clip-rule",
	      "color-interpolation",
	      "color-interpolation-filters",
	      "color-profile",
	      "color-rendering",
	      "dominant-baseline",
	      "enable-background",
	      "fill-opacity",
	      "fill-rule",
	      "flood-color",
	      "flood-opacity",
	      "font-family",
	      "font-size",
	      "font-size-adjust",
	      "font-stretch",
	      "font-style",
	      "font-variant",
	      "font-weight",
	      "glyph-name",
	      "glyph-orientation-horizontal",
	      "glyph-orientation-vertical",
	      "horiz-adv-x",
	      "horiz-origin-x",
	      "image-rendering",
	      "letter-spacing",
	      "lighting-color",
	      "marker-end",
	      "marker-mid",
	      "marker-start",
	      "overline-position",
	      "overline-thickness",
	      "paint-order",
	      "panose-1",
	      "pointer-events",
	      "rendering-intent",
	      "shape-rendering",
	      "stop-color",
	      "stop-opacity",
	      "strikethrough-position",
	      "strikethrough-thickness",
	      "stroke-dasharray",
	      "stroke-dashoffset",
	      "stroke-linecap",
	      "stroke-linejoin",
	      "stroke-miterlimit",
	      "stroke-opacity",
	      "stroke-width",
	      "text-anchor",
	      "text-decoration",
	      "text-rendering",
	      "underline-position",
	      "underline-thickness",
	      "unicode-bidi",
	      "unicode-range",
	      "units-per-em",
	      "v-alphabetic",
	      "v-hanging",
	      "v-ideographic",
	      "v-mathematical",
	      "vector-effect",
	      "vert-adv-y",
	      "vert-origin-x",
	      "vert-origin-y",
	      "word-spacing",
	      "writing-mode",
	      "xmlns:xlink",
	      "x-height"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(attributeName) {
	      var name = attributeName.replace(CAMELIZE, capitalize);
	      properties[name] = new PropertyInfoRecord(
	        name,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName,
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "xlink:actuate",
	      "xlink:arcrole",
	      "xlink:role",
	      "xlink:show",
	      "xlink:title",
	      "xlink:type"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(attributeName) {
	      var name = attributeName.replace(CAMELIZE, capitalize);
	      properties[name] = new PropertyInfoRecord(
	        name,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName,
	        "http://www.w3.org/1999/xlink",
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    [
	      "xml:base",
	      "xml:lang",
	      "xml:space"
	      // NOTE: if you add a camelCased prop to this list,
	      // you'll need to set attributeName to name.toLowerCase()
	      // instead in the assignment below.
	    ].forEach(function(attributeName) {
	      var name = attributeName.replace(CAMELIZE, capitalize);
	      properties[name] = new PropertyInfoRecord(
	        name,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName,
	        "http://www.w3.org/XML/1998/namespace",
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    ["tabIndex", "crossOrigin"].forEach(function(attributeName) {
	      properties[attributeName] = new PropertyInfoRecord(
	        attributeName,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName.toLowerCase(),
	        // attributeName
	        null,
	        // attributeNamespace
	        false,
	        // sanitizeURL
	        false
	      );
	    });
	    var xlinkHref = "xlinkHref";
	    properties[xlinkHref] = new PropertyInfoRecord(
	      "xlinkHref",
	      STRING,
	      false,
	      // mustUseProperty
	      "xlink:href",
	      "http://www.w3.org/1999/xlink",
	      true,
	      // sanitizeURL
	      false
	    );
	    ["src", "href", "action", "formAction"].forEach(function(attributeName) {
	      properties[attributeName] = new PropertyInfoRecord(
	        attributeName,
	        STRING,
	        false,
	        // mustUseProperty
	        attributeName.toLowerCase(),
	        // attributeName
	        null,
	        // attributeNamespace
	        true,
	        // sanitizeURL
	        true
	      );
	    });
	    var isJavaScriptProtocol = /^[\u0000-\u001F ]*j[\r\n\t]*a[\r\n\t]*v[\r\n\t]*a[\r\n\t]*s[\r\n\t]*c[\r\n\t]*r[\r\n\t]*i[\r\n\t]*p[\r\n\t]*t[\r\n\t]*\:/i;
	    var didWarn = false;
	    function sanitizeURL(url) {
	      {
	        if (!didWarn && isJavaScriptProtocol.test(url)) {
	          didWarn = true;
	          error("A future version of React will block javascript: URLs as a security precaution. Use event handlers instead if you can. If you need to generate unsafe HTML try using dangerouslySetInnerHTML instead. React was passed %s.", JSON.stringify(url));
	        }
	      }
	    }
	    function getValueForProperty(node, name, expected, propertyInfo) {
	      {
	        if (propertyInfo.mustUseProperty) {
	          var propertyName = propertyInfo.propertyName;
	          return node[propertyName];
	        } else {
	          {
	            checkAttributeStringCoercion(expected, name);
	          }
	          if (propertyInfo.sanitizeURL) {
	            sanitizeURL("" + expected);
	          }
	          var attributeName = propertyInfo.attributeName;
	          var stringValue = null;
	          if (propertyInfo.type === OVERLOADED_BOOLEAN) {
	            if (node.hasAttribute(attributeName)) {
	              var value = node.getAttribute(attributeName);
	              if (value === "") {
	                return true;
	              }
	              if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
	                return value;
	              }
	              if (value === "" + expected) {
	                return expected;
	              }
	              return value;
	            }
	          } else if (node.hasAttribute(attributeName)) {
	            if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
	              return node.getAttribute(attributeName);
	            }
	            if (propertyInfo.type === BOOLEAN) {
	              return expected;
	            }
	            stringValue = node.getAttribute(attributeName);
	          }
	          if (shouldRemoveAttribute(name, expected, propertyInfo, false)) {
	            return stringValue === null ? expected : stringValue;
	          } else if (stringValue === "" + expected) {
	            return expected;
	          } else {
	            return stringValue;
	          }
	        }
	      }
	    }
	    function getValueForAttribute(node, name, expected, isCustomComponentTag) {
	      {
	        if (!isAttributeNameSafe(name)) {
	          return;
	        }
	        if (!node.hasAttribute(name)) {
	          return expected === void 0 ? void 0 : null;
	        }
	        var value = node.getAttribute(name);
	        {
	          checkAttributeStringCoercion(expected, name);
	        }
	        if (value === "" + expected) {
	          return expected;
	        }
	        return value;
	      }
	    }
	    function setValueForProperty(node, name, value, isCustomComponentTag) {
	      var propertyInfo = getPropertyInfo(name);
	      if (shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag)) {
	        return;
	      }
	      if (shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag)) {
	        value = null;
	      }
	      if (isCustomComponentTag || propertyInfo === null) {
	        if (isAttributeNameSafe(name)) {
	          var _attributeName = name;
	          if (value === null) {
	            node.removeAttribute(_attributeName);
	          } else {
	            {
	              checkAttributeStringCoercion(value, name);
	            }
	            node.setAttribute(_attributeName, "" + value);
	          }
	        }
	        return;
	      }
	      var mustUseProperty = propertyInfo.mustUseProperty;
	      if (mustUseProperty) {
	        var propertyName = propertyInfo.propertyName;
	        if (value === null) {
	          var type = propertyInfo.type;
	          node[propertyName] = type === BOOLEAN ? false : "";
	        } else {
	          node[propertyName] = value;
	        }
	        return;
	      }
	      var attributeName = propertyInfo.attributeName, attributeNamespace = propertyInfo.attributeNamespace;
	      if (value === null) {
	        node.removeAttribute(attributeName);
	      } else {
	        var _type = propertyInfo.type;
	        var attributeValue;
	        if (_type === BOOLEAN || _type === OVERLOADED_BOOLEAN && value === true) {
	          attributeValue = "";
	        } else {
	          {
	            {
	              checkAttributeStringCoercion(value, attributeName);
	            }
	            attributeValue = "" + value;
	          }
	          if (propertyInfo.sanitizeURL) {
	            sanitizeURL(attributeValue.toString());
	          }
	        }
	        if (attributeNamespace) {
	          node.setAttributeNS(attributeNamespace, attributeName, attributeValue);
	        } else {
	          node.setAttribute(attributeName, attributeValue);
	        }
	      }
	    }
	    var REACT_ELEMENT_TYPE = Symbol.for("react.element");
	    var REACT_PORTAL_TYPE = Symbol.for("react.portal");
	    var REACT_FRAGMENT_TYPE = Symbol.for("react.fragment");
	    var REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode");
	    var REACT_PROFILER_TYPE = Symbol.for("react.profiler");
	    var REACT_PROVIDER_TYPE = Symbol.for("react.provider");
	    var REACT_CONTEXT_TYPE = Symbol.for("react.context");
	    var REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref");
	    var REACT_SUSPENSE_TYPE = Symbol.for("react.suspense");
	    var REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list");
	    var REACT_MEMO_TYPE = Symbol.for("react.memo");
	    var REACT_LAZY_TYPE = Symbol.for("react.lazy");
	    var REACT_SCOPE_TYPE = Symbol.for("react.scope");
	    var REACT_DEBUG_TRACING_MODE_TYPE = Symbol.for("react.debug_trace_mode");
	    var REACT_OFFSCREEN_TYPE = Symbol.for("react.offscreen");
	    var REACT_LEGACY_HIDDEN_TYPE = Symbol.for("react.legacy_hidden");
	    var REACT_CACHE_TYPE = Symbol.for("react.cache");
	    var REACT_TRACING_MARKER_TYPE = Symbol.for("react.tracing_marker");
	    var MAYBE_ITERATOR_SYMBOL = Symbol.iterator;
	    var FAUX_ITERATOR_SYMBOL = "@@iterator";
	    function getIteratorFn(maybeIterable) {
	      if (maybeIterable === null || typeof maybeIterable !== "object") {
	        return null;
	      }
	      var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
	      if (typeof maybeIterator === "function") {
	        return maybeIterator;
	      }
	      return null;
	    }
	    var assign = Object.assign;
	    var disabledDepth = 0;
	    var prevLog;
	    var prevInfo;
	    var prevWarn;
	    var prevError;
	    var prevGroup;
	    var prevGroupCollapsed;
	    var prevGroupEnd;
	    function disabledLog() {
	    }
	    disabledLog.__reactDisabledLog = true;
	    function disableLogs() {
	      {
	        if (disabledDepth === 0) {
	          prevLog = console.log;
	          prevInfo = console.info;
	          prevWarn = console.warn;
	          prevError = console.error;
	          prevGroup = console.group;
	          prevGroupCollapsed = console.groupCollapsed;
	          prevGroupEnd = console.groupEnd;
	          var props = {
	            configurable: true,
	            enumerable: true,
	            value: disabledLog,
	            writable: true
	          };
	          Object.defineProperties(console, {
	            info: props,
	            log: props,
	            warn: props,
	            error: props,
	            group: props,
	            groupCollapsed: props,
	            groupEnd: props
	          });
	        }
	        disabledDepth++;
	      }
	    }
	    function reenableLogs() {
	      {
	        disabledDepth--;
	        if (disabledDepth === 0) {
	          var props = {
	            configurable: true,
	            enumerable: true,
	            writable: true
	          };
	          Object.defineProperties(console, {
	            log: assign({}, props, {
	              value: prevLog
	            }),
	            info: assign({}, props, {
	              value: prevInfo
	            }),
	            warn: assign({}, props, {
	              value: prevWarn
	            }),
	            error: assign({}, props, {
	              value: prevError
	            }),
	            group: assign({}, props, {
	              value: prevGroup
	            }),
	            groupCollapsed: assign({}, props, {
	              value: prevGroupCollapsed
	            }),
	            groupEnd: assign({}, props, {
	              value: prevGroupEnd
	            })
	          });
	        }
	        if (disabledDepth < 0) {
	          error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
	        }
	      }
	    }
	    var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
	    var prefix;
	    function describeBuiltInComponentFrame(name, source, ownerFn) {
	      {
	        if (prefix === void 0) {
	          try {
	            throw Error();
	          } catch (x) {
	            var match = x.stack.trim().match(/\n( *(at )?)/);
	            prefix = match && match[1] || "";
	          }
	        }
	        return "\n" + prefix + name;
	      }
	    }
	    var reentry = false;
	    var componentFrameCache;
	    {
	      var PossiblyWeakMap = typeof WeakMap === "function" ? WeakMap : Map;
	      componentFrameCache = new PossiblyWeakMap();
	    }
	    function describeNativeComponentFrame(fn, construct) {
	      if (!fn || reentry) {
	        return "";
	      }
	      {
	        var frame = componentFrameCache.get(fn);
	        if (frame !== void 0) {
	          return frame;
	        }
	      }
	      var control;
	      reentry = true;
	      var previousPrepareStackTrace = Error.prepareStackTrace;
	      Error.prepareStackTrace = void 0;
	      var previousDispatcher;
	      {
	        previousDispatcher = ReactCurrentDispatcher.current;
	        ReactCurrentDispatcher.current = null;
	        disableLogs();
	      }
	      try {
	        if (construct) {
	          var Fake = function() {
	            throw Error();
	          };
	          Object.defineProperty(Fake.prototype, "props", {
	            set: function() {
	              throw Error();
	            }
	          });
	          if (typeof Reflect === "object" && Reflect.construct) {
	            try {
	              Reflect.construct(Fake, []);
	            } catch (x) {
	              control = x;
	            }
	            Reflect.construct(fn, [], Fake);
	          } else {
	            try {
	              Fake.call();
	            } catch (x) {
	              control = x;
	            }
	            fn.call(Fake.prototype);
	          }
	        } else {
	          try {
	            throw Error();
	          } catch (x) {
	            control = x;
	          }
	          fn();
	        }
	      } catch (sample) {
	        if (sample && control && typeof sample.stack === "string") {
	          var sampleLines = sample.stack.split("\n");
	          var controlLines = control.stack.split("\n");
	          var s = sampleLines.length - 1;
	          var c = controlLines.length - 1;
	          while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
	            c--;
	          }
	          for (; s >= 1 && c >= 0; s--, c--) {
	            if (sampleLines[s] !== controlLines[c]) {
	              if (s !== 1 || c !== 1) {
	                do {
	                  s--;
	                  c--;
	                  if (c < 0 || sampleLines[s] !== controlLines[c]) {
	                    var _frame = "\n" + sampleLines[s].replace(" at new ", " at ");
	                    if (fn.displayName && _frame.includes("<anonymous>")) {
	                      _frame = _frame.replace("<anonymous>", fn.displayName);
	                    }
	                    {
	                      if (typeof fn === "function") {
	                        componentFrameCache.set(fn, _frame);
	                      }
	                    }
	                    return _frame;
	                  }
	                } while (s >= 1 && c >= 0);
	              }
	              break;
	            }
	          }
	        }
	      } finally {
	        reentry = false;
	        {
	          ReactCurrentDispatcher.current = previousDispatcher;
	          reenableLogs();
	        }
	        Error.prepareStackTrace = previousPrepareStackTrace;
	      }
	      var name = fn ? fn.displayName || fn.name : "";
	      var syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
	      {
	        if (typeof fn === "function") {
	          componentFrameCache.set(fn, syntheticFrame);
	        }
	      }
	      return syntheticFrame;
	    }
	    function describeClassComponentFrame(ctor, source, ownerFn) {
	      {
	        return describeNativeComponentFrame(ctor, true);
	      }
	    }
	    function describeFunctionComponentFrame(fn, source, ownerFn) {
	      {
	        return describeNativeComponentFrame(fn, false);
	      }
	    }
	    function shouldConstruct(Component) {
	      var prototype = Component.prototype;
	      return !!(prototype && prototype.isReactComponent);
	    }
	    function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
	      if (type == null) {
	        return "";
	      }
	      if (typeof type === "function") {
	        {
	          return describeNativeComponentFrame(type, shouldConstruct(type));
	        }
	      }
	      if (typeof type === "string") {
	        return describeBuiltInComponentFrame(type);
	      }
	      switch (type) {
	        case REACT_SUSPENSE_TYPE:
	          return describeBuiltInComponentFrame("Suspense");
	        case REACT_SUSPENSE_LIST_TYPE:
	          return describeBuiltInComponentFrame("SuspenseList");
	      }
	      if (typeof type === "object") {
	        switch (type.$$typeof) {
	          case REACT_FORWARD_REF_TYPE:
	            return describeFunctionComponentFrame(type.render);
	          case REACT_MEMO_TYPE:
	            return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
	          case REACT_LAZY_TYPE: {
	            var lazyComponent = type;
	            var payload = lazyComponent._payload;
	            var init = lazyComponent._init;
	            try {
	              return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
	            } catch (x) {
	            }
	          }
	        }
	      }
	      return "";
	    }
	    function describeFiber(fiber) {
	      fiber._debugOwner ? fiber._debugOwner.type : null;
	      fiber._debugSource;
	      switch (fiber.tag) {
	        case HostComponent:
	          return describeBuiltInComponentFrame(fiber.type);
	        case LazyComponent:
	          return describeBuiltInComponentFrame("Lazy");
	        case SuspenseComponent:
	          return describeBuiltInComponentFrame("Suspense");
	        case SuspenseListComponent:
	          return describeBuiltInComponentFrame("SuspenseList");
	        case FunctionComponent:
	        case IndeterminateComponent:
	        case SimpleMemoComponent:
	          return describeFunctionComponentFrame(fiber.type);
	        case ForwardRef:
	          return describeFunctionComponentFrame(fiber.type.render);
	        case ClassComponent:
	          return describeClassComponentFrame(fiber.type);
	        default:
	          return "";
	      }
	    }
	    function getStackByFiberInDevAndProd(workInProgress2) {
	      try {
	        var info = "";
	        var node = workInProgress2;
	        do {
	          info += describeFiber(node);
	          node = node.return;
	        } while (node);
	        return info;
	      } catch (x) {
	        return "\nError generating stack: " + x.message + "\n" + x.stack;
	      }
	    }
	    function getWrappedName(outerType, innerType, wrapperName) {
	      var displayName = outerType.displayName;
	      if (displayName) {
	        return displayName;
	      }
	      var functionName = innerType.displayName || innerType.name || "";
	      return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
	    }
	    function getContextName(type) {
	      return type.displayName || "Context";
	    }
	    function getComponentNameFromType(type) {
	      if (type == null) {
	        return null;
	      }
	      {
	        if (typeof type.tag === "number") {
	          error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue.");
	        }
	      }
	      if (typeof type === "function") {
	        return type.displayName || type.name || null;
	      }
	      if (typeof type === "string") {
	        return type;
	      }
	      switch (type) {
	        case REACT_FRAGMENT_TYPE:
	          return "Fragment";
	        case REACT_PORTAL_TYPE:
	          return "Portal";
	        case REACT_PROFILER_TYPE:
	          return "Profiler";
	        case REACT_STRICT_MODE_TYPE:
	          return "StrictMode";
	        case REACT_SUSPENSE_TYPE:
	          return "Suspense";
	        case REACT_SUSPENSE_LIST_TYPE:
	          return "SuspenseList";
	      }
	      if (typeof type === "object") {
	        switch (type.$$typeof) {
	          case REACT_CONTEXT_TYPE:
	            var context = type;
	            return getContextName(context) + ".Consumer";
	          case REACT_PROVIDER_TYPE:
	            var provider = type;
	            return getContextName(provider._context) + ".Provider";
	          case REACT_FORWARD_REF_TYPE:
	            return getWrappedName(type, type.render, "ForwardRef");
	          case REACT_MEMO_TYPE:
	            var outerName = type.displayName || null;
	            if (outerName !== null) {
	              return outerName;
	            }
	            return getComponentNameFromType(type.type) || "Memo";
	          case REACT_LAZY_TYPE: {
	            var lazyComponent = type;
	            var payload = lazyComponent._payload;
	            var init = lazyComponent._init;
	            try {
	              return getComponentNameFromType(init(payload));
	            } catch (x) {
	              return null;
	            }
	          }
	        }
	      }
	      return null;
	    }
	    function getWrappedName$1(outerType, innerType, wrapperName) {
	      var functionName = innerType.displayName || innerType.name || "";
	      return outerType.displayName || (functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName);
	    }
	    function getContextName$1(type) {
	      return type.displayName || "Context";
	    }
	    function getComponentNameFromFiber(fiber) {
	      var tag = fiber.tag, type = fiber.type;
	      switch (tag) {
	        case CacheComponent:
	          return "Cache";
	        case ContextConsumer:
	          var context = type;
	          return getContextName$1(context) + ".Consumer";
	        case ContextProvider:
	          var provider = type;
	          return getContextName$1(provider._context) + ".Provider";
	        case DehydratedFragment:
	          return "DehydratedFragment";
	        case ForwardRef:
	          return getWrappedName$1(type, type.render, "ForwardRef");
	        case Fragment:
	          return "Fragment";
	        case HostComponent:
	          return type;
	        case HostPortal:
	          return "Portal";
	        case HostRoot:
	          return "Root";
	        case HostText:
	          return "Text";
	        case LazyComponent:
	          return getComponentNameFromType(type);
	        case Mode:
	          if (type === REACT_STRICT_MODE_TYPE) {
	            return "StrictMode";
	          }
	          return "Mode";
	        case OffscreenComponent:
	          return "Offscreen";
	        case Profiler:
	          return "Profiler";
	        case ScopeComponent:
	          return "Scope";
	        case SuspenseComponent:
	          return "Suspense";
	        case SuspenseListComponent:
	          return "SuspenseList";
	        case TracingMarkerComponent:
	          return "TracingMarker";
	        case ClassComponent:
	        case FunctionComponent:
	        case IncompleteClassComponent:
	        case IndeterminateComponent:
	        case MemoComponent:
	        case SimpleMemoComponent:
	          if (typeof type === "function") {
	            return type.displayName || type.name || null;
	          }
	          if (typeof type === "string") {
	            return type;
	          }
	          break;
	      }
	      return null;
	    }
	    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
	    var current = null;
	    var isRendering = false;
	    function getCurrentFiberOwnerNameInDevOrNull() {
	      {
	        if (current === null) {
	          return null;
	        }
	        var owner = current._debugOwner;
	        if (owner !== null && typeof owner !== "undefined") {
	          return getComponentNameFromFiber(owner);
	        }
	      }
	      return null;
	    }
	    function getCurrentFiberStackInDev() {
	      {
	        if (current === null) {
	          return "";
	        }
	        return getStackByFiberInDevAndProd(current);
	      }
	    }
	    function resetCurrentFiber() {
	      {
	        ReactDebugCurrentFrame.getCurrentStack = null;
	        current = null;
	        isRendering = false;
	      }
	    }
	    function setCurrentFiber(fiber) {
	      {
	        ReactDebugCurrentFrame.getCurrentStack = fiber === null ? null : getCurrentFiberStackInDev;
	        current = fiber;
	        isRendering = false;
	      }
	    }
	    function getCurrentFiber() {
	      {
	        return current;
	      }
	    }
	    function setIsRendering(rendering) {
	      {
	        isRendering = rendering;
	      }
	    }
	    function toString(value) {
	      return "" + value;
	    }
	    function getToStringValue(value) {
	      switch (typeof value) {
	        case "boolean":
	        case "number":
	        case "string":
	        case "undefined":
	          return value;
	        case "object":
	          {
	            checkFormFieldValueStringCoercion(value);
	          }
	          return value;
	        default:
	          return "";
	      }
	    }
	    var hasReadOnlyValue = {
	      button: true,
	      checkbox: true,
	      image: true,
	      hidden: true,
	      radio: true,
	      reset: true,
	      submit: true
	    };
	    function checkControlledValueProps(tagName, props) {
	      {
	        if (!(hasReadOnlyValue[props.type] || props.onChange || props.onInput || props.readOnly || props.disabled || props.value == null)) {
	          error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`.");
	        }
	        if (!(props.onChange || props.readOnly || props.disabled || props.checked == null)) {
	          error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.");
	        }
	      }
	    }
	    function isCheckable(elem) {
	      var type = elem.type;
	      var nodeName = elem.nodeName;
	      return nodeName && nodeName.toLowerCase() === "input" && (type === "checkbox" || type === "radio");
	    }
	    function getTracker(node) {
	      return node._valueTracker;
	    }
	    function detachTracker(node) {
	      node._valueTracker = null;
	    }
	    function getValueFromNode(node) {
	      var value = "";
	      if (!node) {
	        return value;
	      }
	      if (isCheckable(node)) {
	        value = node.checked ? "true" : "false";
	      } else {
	        value = node.value;
	      }
	      return value;
	    }
	    function trackValueOnNode(node) {
	      var valueField = isCheckable(node) ? "checked" : "value";
	      var descriptor = Object.getOwnPropertyDescriptor(node.constructor.prototype, valueField);
	      {
	        checkFormFieldValueStringCoercion(node[valueField]);
	      }
	      var currentValue = "" + node[valueField];
	      if (node.hasOwnProperty(valueField) || typeof descriptor === "undefined" || typeof descriptor.get !== "function" || typeof descriptor.set !== "function") {
	        return;
	      }
	      var get2 = descriptor.get, set2 = descriptor.set;
	      Object.defineProperty(node, valueField, {
	        configurable: true,
	        get: function() {
	          return get2.call(this);
	        },
	        set: function(value) {
	          {
	            checkFormFieldValueStringCoercion(value);
	          }
	          currentValue = "" + value;
	          set2.call(this, value);
	        }
	      });
	      Object.defineProperty(node, valueField, {
	        enumerable: descriptor.enumerable
	      });
	      var tracker = {
	        getValue: function() {
	          return currentValue;
	        },
	        setValue: function(value) {
	          {
	            checkFormFieldValueStringCoercion(value);
	          }
	          currentValue = "" + value;
	        },
	        stopTracking: function() {
	          detachTracker(node);
	          delete node[valueField];
	        }
	      };
	      return tracker;
	    }
	    function track(node) {
	      if (getTracker(node)) {
	        return;
	      }
	      node._valueTracker = trackValueOnNode(node);
	    }
	    function updateValueIfChanged(node) {
	      if (!node) {
	        return false;
	      }
	      var tracker = getTracker(node);
	      if (!tracker) {
	        return true;
	      }
	      var lastValue = tracker.getValue();
	      var nextValue = getValueFromNode(node);
	      if (nextValue !== lastValue) {
	        tracker.setValue(nextValue);
	        return true;
	      }
	      return false;
	    }
	    function getActiveElement(doc) {
	      doc = doc || (typeof document !== "undefined" ? document : void 0);
	      if (typeof doc === "undefined") {
	        return null;
	      }
	      try {
	        return doc.activeElement || doc.body;
	      } catch (e) {
	        return doc.body;
	      }
	    }
	    var didWarnValueDefaultValue = false;
	    var didWarnCheckedDefaultChecked = false;
	    var didWarnControlledToUncontrolled = false;
	    var didWarnUncontrolledToControlled = false;
	    function isControlled(props) {
	      var usesChecked = props.type === "checkbox" || props.type === "radio";
	      return usesChecked ? props.checked != null : props.value != null;
	    }
	    function getHostProps(element, props) {
	      var node = element;
	      var checked = props.checked;
	      var hostProps = assign({}, props, {
	        defaultChecked: void 0,
	        defaultValue: void 0,
	        value: void 0,
	        checked: checked != null ? checked : node._wrapperState.initialChecked
	      });
	      return hostProps;
	    }
	    function initWrapperState(element, props) {
	      {
	        checkControlledValueProps("input", props);
	        if (props.checked !== void 0 && props.defaultChecked !== void 0 && !didWarnCheckedDefaultChecked) {
	          error("%s contains an input of type %s with both checked and defaultChecked props. Input elements must be either controlled or uncontrolled (specify either the checked prop, or the defaultChecked prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component", props.type);
	          didWarnCheckedDefaultChecked = true;
	        }
	        if (props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValueDefaultValue) {
	          error("%s contains an input of type %s with both value and defaultValue props. Input elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component", props.type);
	          didWarnValueDefaultValue = true;
	        }
	      }
	      var node = element;
	      var defaultValue = props.defaultValue == null ? "" : props.defaultValue;
	      node._wrapperState = {
	        initialChecked: props.checked != null ? props.checked : props.defaultChecked,
	        initialValue: getToStringValue(props.value != null ? props.value : defaultValue),
	        controlled: isControlled(props)
	      };
	    }
	    function updateChecked(element, props) {
	      var node = element;
	      var checked = props.checked;
	      if (checked != null) {
	        setValueForProperty(node, "checked", checked, false);
	      }
	    }
	    function updateWrapper(element, props) {
	      var node = element;
	      {
	        var controlled = isControlled(props);
	        if (!node._wrapperState.controlled && controlled && !didWarnUncontrolledToControlled) {
	          error("A component is changing an uncontrolled input to be controlled. This is likely caused by the value changing from undefined to a defined value, which should not happen. Decide between using a controlled or uncontrolled input element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components");
	          didWarnUncontrolledToControlled = true;
	        }
	        if (node._wrapperState.controlled && !controlled && !didWarnControlledToUncontrolled) {
	          error("A component is changing a controlled input to be uncontrolled. This is likely caused by the value changing from a defined to undefined, which should not happen. Decide between using a controlled or uncontrolled input element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components");
	          didWarnControlledToUncontrolled = true;
	        }
	      }
	      updateChecked(element, props);
	      var value = getToStringValue(props.value);
	      var type = props.type;
	      if (value != null) {
	        if (type === "number") {
	          if (value === 0 && node.value === "" || // We explicitly want to coerce to number here if possible.
	          // eslint-disable-next-line
	          node.value != value) {
	            node.value = toString(value);
	          }
	        } else if (node.value !== toString(value)) {
	          node.value = toString(value);
	        }
	      } else if (type === "submit" || type === "reset") {
	        node.removeAttribute("value");
	        return;
	      }
	      {
	        if (props.hasOwnProperty("value")) {
	          setDefaultValue(node, props.type, value);
	        } else if (props.hasOwnProperty("defaultValue")) {
	          setDefaultValue(node, props.type, getToStringValue(props.defaultValue));
	        }
	      }
	      {
	        if (props.checked == null && props.defaultChecked != null) {
	          node.defaultChecked = !!props.defaultChecked;
	        }
	      }
	    }
	    function postMountWrapper(element, props, isHydrating2) {
	      var node = element;
	      if (props.hasOwnProperty("value") || props.hasOwnProperty("defaultValue")) {
	        var type = props.type;
	        var isButton = type === "submit" || type === "reset";
	        if (isButton && (props.value === void 0 || props.value === null)) {
	          return;
	        }
	        var initialValue = toString(node._wrapperState.initialValue);
	        if (!isHydrating2) {
	          {
	            if (initialValue !== node.value) {
	              node.value = initialValue;
	            }
	          }
	        }
	        {
	          node.defaultValue = initialValue;
	        }
	      }
	      var name = node.name;
	      if (name !== "") {
	        node.name = "";
	      }
	      {
	        node.defaultChecked = !node.defaultChecked;
	        node.defaultChecked = !!node._wrapperState.initialChecked;
	      }
	      if (name !== "") {
	        node.name = name;
	      }
	    }
	    function restoreControlledState(element, props) {
	      var node = element;
	      updateWrapper(node, props);
	      updateNamedCousins(node, props);
	    }
	    function updateNamedCousins(rootNode, props) {
	      var name = props.name;
	      if (props.type === "radio" && name != null) {
	        var queryRoot = rootNode;
	        while (queryRoot.parentNode) {
	          queryRoot = queryRoot.parentNode;
	        }
	        {
	          checkAttributeStringCoercion(name, "name");
	        }
	        var group = queryRoot.querySelectorAll("input[name=" + JSON.stringify("" + name) + '][type="radio"]');
	        for (var i = 0; i < group.length; i++) {
	          var otherNode = group[i];
	          if (otherNode === rootNode || otherNode.form !== rootNode.form) {
	            continue;
	          }
	          var otherProps = getFiberCurrentPropsFromNode(otherNode);
	          if (!otherProps) {
	            throw new Error("ReactDOMInput: Mixing React and non-React radio inputs with the same `name` is not supported.");
	          }
	          updateValueIfChanged(otherNode);
	          updateWrapper(otherNode, otherProps);
	        }
	      }
	    }
	    function setDefaultValue(node, type, value) {
	      if (
	        // Focused number inputs synchronize on blur. See ChangeEventPlugin.js
	        type !== "number" || getActiveElement(node.ownerDocument) !== node
	      ) {
	        if (value == null) {
	          node.defaultValue = toString(node._wrapperState.initialValue);
	        } else if (node.defaultValue !== toString(value)) {
	          node.defaultValue = toString(value);
	        }
	      }
	    }
	    var didWarnSelectedSetOnOption = false;
	    var didWarnInvalidChild = false;
	    var didWarnInvalidInnerHTML = false;
	    function validateProps(element, props) {
	      {
	        if (props.value == null) {
	          if (typeof props.children === "object" && props.children !== null) {
	            React.Children.forEach(props.children, function(child) {
	              if (child == null) {
	                return;
	              }
	              if (typeof child === "string" || typeof child === "number") {
	                return;
	              }
	              if (!didWarnInvalidChild) {
	                didWarnInvalidChild = true;
	                error("Cannot infer the option value of complex children. Pass a `value` prop or use a plain string as children to <option>.");
	              }
	            });
	          } else if (props.dangerouslySetInnerHTML != null) {
	            if (!didWarnInvalidInnerHTML) {
	              didWarnInvalidInnerHTML = true;
	              error("Pass a `value` prop if you set dangerouslyInnerHTML so React knows which value should be selected.");
	            }
	          }
	        }
	        if (props.selected != null && !didWarnSelectedSetOnOption) {
	          error("Use the `defaultValue` or `value` props on <select> instead of setting `selected` on <option>.");
	          didWarnSelectedSetOnOption = true;
	        }
	      }
	    }
	    function postMountWrapper$1(element, props) {
	      if (props.value != null) {
	        element.setAttribute("value", toString(getToStringValue(props.value)));
	      }
	    }
	    var isArrayImpl = Array.isArray;
	    function isArray(a) {
	      return isArrayImpl(a);
	    }
	    var didWarnValueDefaultValue$1;
	    {
	      didWarnValueDefaultValue$1 = false;
	    }
	    function getDeclarationErrorAddendum() {
	      var ownerName = getCurrentFiberOwnerNameInDevOrNull();
	      if (ownerName) {
	        return "\n\nCheck the render method of `" + ownerName + "`.";
	      }
	      return "";
	    }
	    var valuePropNames = ["value", "defaultValue"];
	    function checkSelectPropTypes(props) {
	      {
	        checkControlledValueProps("select", props);
	        for (var i = 0; i < valuePropNames.length; i++) {
	          var propName = valuePropNames[i];
	          if (props[propName] == null) {
	            continue;
	          }
	          var propNameIsArray = isArray(props[propName]);
	          if (props.multiple && !propNameIsArray) {
	            error("The `%s` prop supplied to <select> must be an array if `multiple` is true.%s", propName, getDeclarationErrorAddendum());
	          } else if (!props.multiple && propNameIsArray) {
	            error("The `%s` prop supplied to <select> must be a scalar value if `multiple` is false.%s", propName, getDeclarationErrorAddendum());
	          }
	        }
	      }
	    }
	    function updateOptions(node, multiple, propValue, setDefaultSelected) {
	      var options2 = node.options;
	      if (multiple) {
	        var selectedValues = propValue;
	        var selectedValue = {};
	        for (var i = 0; i < selectedValues.length; i++) {
	          selectedValue["$" + selectedValues[i]] = true;
	        }
	        for (var _i = 0; _i < options2.length; _i++) {
	          var selected = selectedValue.hasOwnProperty("$" + options2[_i].value);
	          if (options2[_i].selected !== selected) {
	            options2[_i].selected = selected;
	          }
	          if (selected && setDefaultSelected) {
	            options2[_i].defaultSelected = true;
	          }
	        }
	      } else {
	        var _selectedValue = toString(getToStringValue(propValue));
	        var defaultSelected = null;
	        for (var _i2 = 0; _i2 < options2.length; _i2++) {
	          if (options2[_i2].value === _selectedValue) {
	            options2[_i2].selected = true;
	            if (setDefaultSelected) {
	              options2[_i2].defaultSelected = true;
	            }
	            return;
	          }
	          if (defaultSelected === null && !options2[_i2].disabled) {
	            defaultSelected = options2[_i2];
	          }
	        }
	        if (defaultSelected !== null) {
	          defaultSelected.selected = true;
	        }
	      }
	    }
	    function getHostProps$1(element, props) {
	      return assign({}, props, {
	        value: void 0
	      });
	    }
	    function initWrapperState$1(element, props) {
	      var node = element;
	      {
	        checkSelectPropTypes(props);
	      }
	      node._wrapperState = {
	        wasMultiple: !!props.multiple
	      };
	      {
	        if (props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValueDefaultValue$1) {
	          error("Select elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled select element and remove one of these props. More info: https://reactjs.org/link/controlled-components");
	          didWarnValueDefaultValue$1 = true;
	        }
	      }
	    }
	    function postMountWrapper$2(element, props) {
	      var node = element;
	      node.multiple = !!props.multiple;
	      var value = props.value;
	      if (value != null) {
	        updateOptions(node, !!props.multiple, value, false);
	      } else if (props.defaultValue != null) {
	        updateOptions(node, !!props.multiple, props.defaultValue, true);
	      }
	    }
	    function postUpdateWrapper(element, props) {
	      var node = element;
	      var wasMultiple = node._wrapperState.wasMultiple;
	      node._wrapperState.wasMultiple = !!props.multiple;
	      var value = props.value;
	      if (value != null) {
	        updateOptions(node, !!props.multiple, value, false);
	      } else if (wasMultiple !== !!props.multiple) {
	        if (props.defaultValue != null) {
	          updateOptions(node, !!props.multiple, props.defaultValue, true);
	        } else {
	          updateOptions(node, !!props.multiple, props.multiple ? [] : "", false);
	        }
	      }
	    }
	    function restoreControlledState$1(element, props) {
	      var node = element;
	      var value = props.value;
	      if (value != null) {
	        updateOptions(node, !!props.multiple, value, false);
	      }
	    }
	    var didWarnValDefaultVal = false;
	    function getHostProps$2(element, props) {
	      var node = element;
	      if (props.dangerouslySetInnerHTML != null) {
	        throw new Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
	      }
	      var hostProps = assign({}, props, {
	        value: void 0,
	        defaultValue: void 0,
	        children: toString(node._wrapperState.initialValue)
	      });
	      return hostProps;
	    }
	    function initWrapperState$2(element, props) {
	      var node = element;
	      {
	        checkControlledValueProps("textarea", props);
	        if (props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValDefaultVal) {
	          error("%s contains a textarea with both value and defaultValue props. Textarea elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled textarea and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component");
	          didWarnValDefaultVal = true;
	        }
	      }
	      var initialValue = props.value;
	      if (initialValue == null) {
	        var children = props.children, defaultValue = props.defaultValue;
	        if (children != null) {
	          {
	            error("Use the `defaultValue` or `value` props instead of setting children on <textarea>.");
	          }
	          {
	            if (defaultValue != null) {
	              throw new Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
	            }
	            if (isArray(children)) {
	              if (children.length > 1) {
	                throw new Error("<textarea> can only have at most one child.");
	              }
	              children = children[0];
	            }
	            defaultValue = children;
	          }
	        }
	        if (defaultValue == null) {
	          defaultValue = "";
	        }
	        initialValue = defaultValue;
	      }
	      node._wrapperState = {
	        initialValue: getToStringValue(initialValue)
	      };
	    }
	    function updateWrapper$1(element, props) {
	      var node = element;
	      var value = getToStringValue(props.value);
	      var defaultValue = getToStringValue(props.defaultValue);
	      if (value != null) {
	        var newValue = toString(value);
	        if (newValue !== node.value) {
	          node.value = newValue;
	        }
	        if (props.defaultValue == null && node.defaultValue !== newValue) {
	          node.defaultValue = newValue;
	        }
	      }
	      if (defaultValue != null) {
	        node.defaultValue = toString(defaultValue);
	      }
	    }
	    function postMountWrapper$3(element, props) {
	      var node = element;
	      var textContent = node.textContent;
	      if (textContent === node._wrapperState.initialValue) {
	        if (textContent !== "" && textContent !== null) {
	          node.value = textContent;
	        }
	      }
	    }
	    function restoreControlledState$2(element, props) {
	      updateWrapper$1(element, props);
	    }
	    var HTML_NAMESPACE = "http://www.w3.org/1999/xhtml";
	    var MATH_NAMESPACE = "http://www.w3.org/1998/Math/MathML";
	    var SVG_NAMESPACE = "http://www.w3.org/2000/svg";
	    function getIntrinsicNamespace(type) {
	      switch (type) {
	        case "svg":
	          return SVG_NAMESPACE;
	        case "math":
	          return MATH_NAMESPACE;
	        default:
	          return HTML_NAMESPACE;
	      }
	    }
	    function getChildNamespace(parentNamespace, type) {
	      if (parentNamespace == null || parentNamespace === HTML_NAMESPACE) {
	        return getIntrinsicNamespace(type);
	      }
	      if (parentNamespace === SVG_NAMESPACE && type === "foreignObject") {
	        return HTML_NAMESPACE;
	      }
	      return parentNamespace;
	    }
	    var createMicrosoftUnsafeLocalFunction = function(func) {
	      if (typeof MSApp !== "undefined" && MSApp.execUnsafeLocalFunction) {
	        return function(arg0, arg1, arg2, arg3) {
	          MSApp.execUnsafeLocalFunction(function() {
	            return func(arg0, arg1, arg2, arg3);
	          });
	        };
	      } else {
	        return func;
	      }
	    };
	    var reusableSVGContainer;
	    var setInnerHTML = createMicrosoftUnsafeLocalFunction(function(node, html) {
	      if (node.namespaceURI === SVG_NAMESPACE) {
	        if (!("innerHTML" in node)) {
	          reusableSVGContainer = reusableSVGContainer || document.createElement("div");
	          reusableSVGContainer.innerHTML = "<svg>" + html.valueOf().toString() + "</svg>";
	          var svgNode = reusableSVGContainer.firstChild;
	          while (node.firstChild) {
	            node.removeChild(node.firstChild);
	          }
	          while (svgNode.firstChild) {
	            node.appendChild(svgNode.firstChild);
	          }
	          return;
	        }
	      }
	      node.innerHTML = html;
	    });
	    var ELEMENT_NODE = 1;
	    var TEXT_NODE = 3;
	    var COMMENT_NODE = 8;
	    var DOCUMENT_NODE = 9;
	    var DOCUMENT_FRAGMENT_NODE = 11;
	    var setTextContent = function(node, text) {
	      if (text) {
	        var firstChild = node.firstChild;
	        if (firstChild && firstChild === node.lastChild && firstChild.nodeType === TEXT_NODE) {
	          firstChild.nodeValue = text;
	          return;
	        }
	      }
	      node.textContent = text;
	    };
	    var shorthandToLonghand = {
	      animation: ["animationDelay", "animationDirection", "animationDuration", "animationFillMode", "animationIterationCount", "animationName", "animationPlayState", "animationTimingFunction"],
	      background: ["backgroundAttachment", "backgroundClip", "backgroundColor", "backgroundImage", "backgroundOrigin", "backgroundPositionX", "backgroundPositionY", "backgroundRepeat", "backgroundSize"],
	      backgroundPosition: ["backgroundPositionX", "backgroundPositionY"],
	      border: ["borderBottomColor", "borderBottomStyle", "borderBottomWidth", "borderImageOutset", "borderImageRepeat", "borderImageSlice", "borderImageSource", "borderImageWidth", "borderLeftColor", "borderLeftStyle", "borderLeftWidth", "borderRightColor", "borderRightStyle", "borderRightWidth", "borderTopColor", "borderTopStyle", "borderTopWidth"],
	      borderBlockEnd: ["borderBlockEndColor", "borderBlockEndStyle", "borderBlockEndWidth"],
	      borderBlockStart: ["borderBlockStartColor", "borderBlockStartStyle", "borderBlockStartWidth"],
	      borderBottom: ["borderBottomColor", "borderBottomStyle", "borderBottomWidth"],
	      borderColor: ["borderBottomColor", "borderLeftColor", "borderRightColor", "borderTopColor"],
	      borderImage: ["borderImageOutset", "borderImageRepeat", "borderImageSlice", "borderImageSource", "borderImageWidth"],
	      borderInlineEnd: ["borderInlineEndColor", "borderInlineEndStyle", "borderInlineEndWidth"],
	      borderInlineStart: ["borderInlineStartColor", "borderInlineStartStyle", "borderInlineStartWidth"],
	      borderLeft: ["borderLeftColor", "borderLeftStyle", "borderLeftWidth"],
	      borderRadius: ["borderBottomLeftRadius", "borderBottomRightRadius", "borderTopLeftRadius", "borderTopRightRadius"],
	      borderRight: ["borderRightColor", "borderRightStyle", "borderRightWidth"],
	      borderStyle: ["borderBottomStyle", "borderLeftStyle", "borderRightStyle", "borderTopStyle"],
	      borderTop: ["borderTopColor", "borderTopStyle", "borderTopWidth"],
	      borderWidth: ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth"],
	      columnRule: ["columnRuleColor", "columnRuleStyle", "columnRuleWidth"],
	      columns: ["columnCount", "columnWidth"],
	      flex: ["flexBasis", "flexGrow", "flexShrink"],
	      flexFlow: ["flexDirection", "flexWrap"],
	      font: ["fontFamily", "fontFeatureSettings", "fontKerning", "fontLanguageOverride", "fontSize", "fontSizeAdjust", "fontStretch", "fontStyle", "fontVariant", "fontVariantAlternates", "fontVariantCaps", "fontVariantEastAsian", "fontVariantLigatures", "fontVariantNumeric", "fontVariantPosition", "fontWeight", "lineHeight"],
	      fontVariant: ["fontVariantAlternates", "fontVariantCaps", "fontVariantEastAsian", "fontVariantLigatures", "fontVariantNumeric", "fontVariantPosition"],
	      gap: ["columnGap", "rowGap"],
	      grid: ["gridAutoColumns", "gridAutoFlow", "gridAutoRows", "gridTemplateAreas", "gridTemplateColumns", "gridTemplateRows"],
	      gridArea: ["gridColumnEnd", "gridColumnStart", "gridRowEnd", "gridRowStart"],
	      gridColumn: ["gridColumnEnd", "gridColumnStart"],
	      gridColumnGap: ["columnGap"],
	      gridGap: ["columnGap", "rowGap"],
	      gridRow: ["gridRowEnd", "gridRowStart"],
	      gridRowGap: ["rowGap"],
	      gridTemplate: ["gridTemplateAreas", "gridTemplateColumns", "gridTemplateRows"],
	      listStyle: ["listStyleImage", "listStylePosition", "listStyleType"],
	      margin: ["marginBottom", "marginLeft", "marginRight", "marginTop"],
	      marker: ["markerEnd", "markerMid", "markerStart"],
	      mask: ["maskClip", "maskComposite", "maskImage", "maskMode", "maskOrigin", "maskPositionX", "maskPositionY", "maskRepeat", "maskSize"],
	      maskPosition: ["maskPositionX", "maskPositionY"],
	      outline: ["outlineColor", "outlineStyle", "outlineWidth"],
	      overflow: ["overflowX", "overflowY"],
	      padding: ["paddingBottom", "paddingLeft", "paddingRight", "paddingTop"],
	      placeContent: ["alignContent", "justifyContent"],
	      placeItems: ["alignItems", "justifyItems"],
	      placeSelf: ["alignSelf", "justifySelf"],
	      textDecoration: ["textDecorationColor", "textDecorationLine", "textDecorationStyle"],
	      textEmphasis: ["textEmphasisColor", "textEmphasisStyle"],
	      transition: ["transitionDelay", "transitionDuration", "transitionProperty", "transitionTimingFunction"],
	      wordWrap: ["overflowWrap"]
	    };
	    var isUnitlessNumber = {
	      animationIterationCount: true,
	      aspectRatio: true,
	      borderImageOutset: true,
	      borderImageSlice: true,
	      borderImageWidth: true,
	      boxFlex: true,
	      boxFlexGroup: true,
	      boxOrdinalGroup: true,
	      columnCount: true,
	      columns: true,
	      flex: true,
	      flexGrow: true,
	      flexPositive: true,
	      flexShrink: true,
	      flexNegative: true,
	      flexOrder: true,
	      gridArea: true,
	      gridRow: true,
	      gridRowEnd: true,
	      gridRowSpan: true,
	      gridRowStart: true,
	      gridColumn: true,
	      gridColumnEnd: true,
	      gridColumnSpan: true,
	      gridColumnStart: true,
	      fontWeight: true,
	      lineClamp: true,
	      lineHeight: true,
	      opacity: true,
	      order: true,
	      orphans: true,
	      tabSize: true,
	      widows: true,
	      zIndex: true,
	      zoom: true,
	      // SVG-related properties
	      fillOpacity: true,
	      floodOpacity: true,
	      stopOpacity: true,
	      strokeDasharray: true,
	      strokeDashoffset: true,
	      strokeMiterlimit: true,
	      strokeOpacity: true,
	      strokeWidth: true
	    };
	    function prefixKey(prefix2, key) {
	      return prefix2 + key.charAt(0).toUpperCase() + key.substring(1);
	    }
	    var prefixes = ["Webkit", "ms", "Moz", "O"];
	    Object.keys(isUnitlessNumber).forEach(function(prop) {
	      prefixes.forEach(function(prefix2) {
	        isUnitlessNumber[prefixKey(prefix2, prop)] = isUnitlessNumber[prop];
	      });
	    });
	    function dangerousStyleValue(name, value, isCustomProperty) {
	      var isEmpty = value == null || typeof value === "boolean" || value === "";
	      if (isEmpty) {
	        return "";
	      }
	      if (!isCustomProperty && typeof value === "number" && value !== 0 && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name])) {
	        return value + "px";
	      }
	      {
	        checkCSSPropertyStringCoercion(value, name);
	      }
	      return ("" + value).trim();
	    }
	    var uppercasePattern = /([A-Z])/g;
	    var msPattern = /^ms-/;
	    function hyphenateStyleName(name) {
	      return name.replace(uppercasePattern, "-$1").toLowerCase().replace(msPattern, "-ms-");
	    }
	    var warnValidStyle = function() {
	    };
	    {
	      var badVendoredStyleNamePattern = /^(?:webkit|moz|o)[A-Z]/;
	      var msPattern$1 = /^-ms-/;
	      var hyphenPattern = /-(.)/g;
	      var badStyleValueWithSemicolonPattern = /;\s*$/;
	      var warnedStyleNames = {};
	      var warnedStyleValues = {};
	      var warnedForNaNValue = false;
	      var warnedForInfinityValue = false;
	      var camelize = function(string) {
	        return string.replace(hyphenPattern, function(_, character) {
	          return character.toUpperCase();
	        });
	      };
	      var warnHyphenatedStyleName = function(name) {
	        if (warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name]) {
	          return;
	        }
	        warnedStyleNames[name] = true;
	        error(
	          "Unsupported style property %s. Did you mean %s?",
	          name,
	          // As Andi Smith suggests
	          // (http://www.andismith.com/blog/2012/02/modernizr-prefixed/), an `-ms` prefix
	          // is converted to lowercase `ms`.
	          camelize(name.replace(msPattern$1, "ms-"))
	        );
	      };
	      var warnBadVendoredStyleName = function(name) {
	        if (warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name]) {
	          return;
	        }
	        warnedStyleNames[name] = true;
	        error("Unsupported vendor-prefixed style property %s. Did you mean %s?", name, name.charAt(0).toUpperCase() + name.slice(1));
	      };
	      var warnStyleValueWithSemicolon = function(name, value) {
	        if (warnedStyleValues.hasOwnProperty(value) && warnedStyleValues[value]) {
	          return;
	        }
	        warnedStyleValues[value] = true;
	        error(`Style property values shouldn't contain a semicolon. Try "%s: %s" instead.`, name, value.replace(badStyleValueWithSemicolonPattern, ""));
	      };
	      var warnStyleValueIsNaN = function(name, value) {
	        if (warnedForNaNValue) {
	          return;
	        }
	        warnedForNaNValue = true;
	        error("`NaN` is an invalid value for the `%s` css style property.", name);
	      };
	      var warnStyleValueIsInfinity = function(name, value) {
	        if (warnedForInfinityValue) {
	          return;
	        }
	        warnedForInfinityValue = true;
	        error("`Infinity` is an invalid value for the `%s` css style property.", name);
	      };
	      warnValidStyle = function(name, value) {
	        if (name.indexOf("-") > -1) {
	          warnHyphenatedStyleName(name);
	        } else if (badVendoredStyleNamePattern.test(name)) {
	          warnBadVendoredStyleName(name);
	        } else if (badStyleValueWithSemicolonPattern.test(value)) {
	          warnStyleValueWithSemicolon(name, value);
	        }
	        if (typeof value === "number") {
	          if (isNaN(value)) {
	            warnStyleValueIsNaN(name, value);
	          } else if (!isFinite(value)) {
	            warnStyleValueIsInfinity(name, value);
	          }
	        }
	      };
	    }
	    var warnValidStyle$1 = warnValidStyle;
	    function createDangerousStringForStyles(styles) {
	      {
	        var serialized = "";
	        var delimiter = "";
	        for (var styleName in styles) {
	          if (!styles.hasOwnProperty(styleName)) {
	            continue;
	          }
	          var styleValue = styles[styleName];
	          if (styleValue != null) {
	            var isCustomProperty = styleName.indexOf("--") === 0;
	            serialized += delimiter + (isCustomProperty ? styleName : hyphenateStyleName(styleName)) + ":";
	            serialized += dangerousStyleValue(styleName, styleValue, isCustomProperty);
	            delimiter = ";";
	          }
	        }
	        return serialized || null;
	      }
	    }
	    function setValueForStyles(node, styles) {
	      var style2 = node.style;
	      for (var styleName in styles) {
	        if (!styles.hasOwnProperty(styleName)) {
	          continue;
	        }
	        var isCustomProperty = styleName.indexOf("--") === 0;
	        {
	          if (!isCustomProperty) {
	            warnValidStyle$1(styleName, styles[styleName]);
	          }
	        }
	        var styleValue = dangerousStyleValue(styleName, styles[styleName], isCustomProperty);
	        if (styleName === "float") {
	          styleName = "cssFloat";
	        }
	        if (isCustomProperty) {
	          style2.setProperty(styleName, styleValue);
	        } else {
	          style2[styleName] = styleValue;
	        }
	      }
	    }
	    function isValueEmpty(value) {
	      return value == null || typeof value === "boolean" || value === "";
	    }
	    function expandShorthandMap(styles) {
	      var expanded = {};
	      for (var key in styles) {
	        var longhands = shorthandToLonghand[key] || [key];
	        for (var i = 0; i < longhands.length; i++) {
	          expanded[longhands[i]] = key;
	        }
	      }
	      return expanded;
	    }
	    function validateShorthandPropertyCollisionInDev(styleUpdates, nextStyles) {
	      {
	        if (!nextStyles) {
	          return;
	        }
	        var expandedUpdates = expandShorthandMap(styleUpdates);
	        var expandedStyles = expandShorthandMap(nextStyles);
	        var warnedAbout = {};
	        for (var key in expandedUpdates) {
	          var originalKey = expandedUpdates[key];
	          var correctOriginalKey = expandedStyles[key];
	          if (correctOriginalKey && originalKey !== correctOriginalKey) {
	            var warningKey = originalKey + "," + correctOriginalKey;
	            if (warnedAbout[warningKey]) {
	              continue;
	            }
	            warnedAbout[warningKey] = true;
	            error("%s a style property during rerender (%s) when a conflicting property is set (%s) can lead to styling bugs. To avoid this, don't mix shorthand and non-shorthand properties for the same value; instead, replace the shorthand with separate values.", isValueEmpty(styleUpdates[originalKey]) ? "Removing" : "Updating", originalKey, correctOriginalKey);
	          }
	        }
	      }
	    }
	    var omittedCloseTags = {
	      area: true,
	      base: true,
	      br: true,
	      col: true,
	      embed: true,
	      hr: true,
	      img: true,
	      input: true,
	      keygen: true,
	      link: true,
	      meta: true,
	      param: true,
	      source: true,
	      track: true,
	      wbr: true
	      // NOTE: menuitem's close tag should be omitted, but that causes problems.
	    };
	    var voidElementTags = assign({
	      menuitem: true
	    }, omittedCloseTags);
	    var HTML = "__html";
	    function assertValidProps(tag, props) {
	      if (!props) {
	        return;
	      }
	      if (voidElementTags[tag]) {
	        if (props.children != null || props.dangerouslySetInnerHTML != null) {
	          throw new Error(tag + " is a void element tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
	        }
	      }
	      if (props.dangerouslySetInnerHTML != null) {
	        if (props.children != null) {
	          throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
	        }
	        if (typeof props.dangerouslySetInnerHTML !== "object" || !(HTML in props.dangerouslySetInnerHTML)) {
	          throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
	        }
	      }
	      {
	        if (!props.suppressContentEditableWarning && props.contentEditable && props.children != null) {
	          error("A component is `contentEditable` and contains `children` managed by React. It is now your responsibility to guarantee that none of those nodes are unexpectedly modified or duplicated. This is probably not intentional.");
	        }
	      }
	      if (props.style != null && typeof props.style !== "object") {
	        throw new Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
	      }
	    }
	    function isCustomComponent(tagName, props) {
	      if (tagName.indexOf("-") === -1) {
	        return typeof props.is === "string";
	      }
	      switch (tagName) {
	        case "annotation-xml":
	        case "color-profile":
	        case "font-face":
	        case "font-face-src":
	        case "font-face-uri":
	        case "font-face-format":
	        case "font-face-name":
	        case "missing-glyph":
	          return false;
	        default:
	          return true;
	      }
	    }
	    var possibleStandardNames = {
	      // HTML
	      accept: "accept",
	      acceptcharset: "acceptCharset",
	      "accept-charset": "acceptCharset",
	      accesskey: "accessKey",
	      action: "action",
	      allowfullscreen: "allowFullScreen",
	      alt: "alt",
	      as: "as",
	      async: "async",
	      autocapitalize: "autoCapitalize",
	      autocomplete: "autoComplete",
	      autocorrect: "autoCorrect",
	      autofocus: "autoFocus",
	      autoplay: "autoPlay",
	      autosave: "autoSave",
	      capture: "capture",
	      cellpadding: "cellPadding",
	      cellspacing: "cellSpacing",
	      challenge: "challenge",
	      charset: "charSet",
	      checked: "checked",
	      children: "children",
	      cite: "cite",
	      class: "className",
	      classid: "classID",
	      classname: "className",
	      cols: "cols",
	      colspan: "colSpan",
	      content: "content",
	      contenteditable: "contentEditable",
	      contextmenu: "contextMenu",
	      controls: "controls",
	      controlslist: "controlsList",
	      coords: "coords",
	      crossorigin: "crossOrigin",
	      dangerouslysetinnerhtml: "dangerouslySetInnerHTML",
	      data: "data",
	      datetime: "dateTime",
	      default: "default",
	      defaultchecked: "defaultChecked",
	      defaultvalue: "defaultValue",
	      defer: "defer",
	      dir: "dir",
	      disabled: "disabled",
	      disablepictureinpicture: "disablePictureInPicture",
	      disableremoteplayback: "disableRemotePlayback",
	      download: "download",
	      draggable: "draggable",
	      enctype: "encType",
	      enterkeyhint: "enterKeyHint",
	      for: "htmlFor",
	      form: "form",
	      formmethod: "formMethod",
	      formaction: "formAction",
	      formenctype: "formEncType",
	      formnovalidate: "formNoValidate",
	      formtarget: "formTarget",
	      frameborder: "frameBorder",
	      headers: "headers",
	      height: "height",
	      hidden: "hidden",
	      high: "high",
	      href: "href",
	      hreflang: "hrefLang",
	      htmlfor: "htmlFor",
	      httpequiv: "httpEquiv",
	      "http-equiv": "httpEquiv",
	      icon: "icon",
	      id: "id",
	      imagesizes: "imageSizes",
	      imagesrcset: "imageSrcSet",
	      innerhtml: "innerHTML",
	      inputmode: "inputMode",
	      integrity: "integrity",
	      is: "is",
	      itemid: "itemID",
	      itemprop: "itemProp",
	      itemref: "itemRef",
	      itemscope: "itemScope",
	      itemtype: "itemType",
	      keyparams: "keyParams",
	      keytype: "keyType",
	      kind: "kind",
	      label: "label",
	      lang: "lang",
	      list: "list",
	      loop: "loop",
	      low: "low",
	      manifest: "manifest",
	      marginwidth: "marginWidth",
	      marginheight: "marginHeight",
	      max: "max",
	      maxlength: "maxLength",
	      media: "media",
	      mediagroup: "mediaGroup",
	      method: "method",
	      min: "min",
	      minlength: "minLength",
	      multiple: "multiple",
	      muted: "muted",
	      name: "name",
	      nomodule: "noModule",
	      nonce: "nonce",
	      novalidate: "noValidate",
	      open: "open",
	      optimum: "optimum",
	      pattern: "pattern",
	      placeholder: "placeholder",
	      playsinline: "playsInline",
	      poster: "poster",
	      preload: "preload",
	      profile: "profile",
	      radiogroup: "radioGroup",
	      readonly: "readOnly",
	      referrerpolicy: "referrerPolicy",
	      rel: "rel",
	      required: "required",
	      reversed: "reversed",
	      role: "role",
	      rows: "rows",
	      rowspan: "rowSpan",
	      sandbox: "sandbox",
	      scope: "scope",
	      scoped: "scoped",
	      scrolling: "scrolling",
	      seamless: "seamless",
	      selected: "selected",
	      shape: "shape",
	      size: "size",
	      sizes: "sizes",
	      span: "span",
	      spellcheck: "spellCheck",
	      src: "src",
	      srcdoc: "srcDoc",
	      srclang: "srcLang",
	      srcset: "srcSet",
	      start: "start",
	      step: "step",
	      style: "style",
	      summary: "summary",
	      tabindex: "tabIndex",
	      target: "target",
	      title: "title",
	      type: "type",
	      usemap: "useMap",
	      value: "value",
	      width: "width",
	      wmode: "wmode",
	      wrap: "wrap",
	      // SVG
	      about: "about",
	      accentheight: "accentHeight",
	      "accent-height": "accentHeight",
	      accumulate: "accumulate",
	      additive: "additive",
	      alignmentbaseline: "alignmentBaseline",
	      "alignment-baseline": "alignmentBaseline",
	      allowreorder: "allowReorder",
	      alphabetic: "alphabetic",
	      amplitude: "amplitude",
	      arabicform: "arabicForm",
	      "arabic-form": "arabicForm",
	      ascent: "ascent",
	      attributename: "attributeName",
	      attributetype: "attributeType",
	      autoreverse: "autoReverse",
	      azimuth: "azimuth",
	      basefrequency: "baseFrequency",
	      baselineshift: "baselineShift",
	      "baseline-shift": "baselineShift",
	      baseprofile: "baseProfile",
	      bbox: "bbox",
	      begin: "begin",
	      bias: "bias",
	      by: "by",
	      calcmode: "calcMode",
	      capheight: "capHeight",
	      "cap-height": "capHeight",
	      clip: "clip",
	      clippath: "clipPath",
	      "clip-path": "clipPath",
	      clippathunits: "clipPathUnits",
	      cliprule: "clipRule",
	      "clip-rule": "clipRule",
	      color: "color",
	      colorinterpolation: "colorInterpolation",
	      "color-interpolation": "colorInterpolation",
	      colorinterpolationfilters: "colorInterpolationFilters",
	      "color-interpolation-filters": "colorInterpolationFilters",
	      colorprofile: "colorProfile",
	      "color-profile": "colorProfile",
	      colorrendering: "colorRendering",
	      "color-rendering": "colorRendering",
	      contentscripttype: "contentScriptType",
	      contentstyletype: "contentStyleType",
	      cursor: "cursor",
	      cx: "cx",
	      cy: "cy",
	      d: "d",
	      datatype: "datatype",
	      decelerate: "decelerate",
	      descent: "descent",
	      diffuseconstant: "diffuseConstant",
	      direction: "direction",
	      display: "display",
	      divisor: "divisor",
	      dominantbaseline: "dominantBaseline",
	      "dominant-baseline": "dominantBaseline",
	      dur: "dur",
	      dx: "dx",
	      dy: "dy",
	      edgemode: "edgeMode",
	      elevation: "elevation",
	      enablebackground: "enableBackground",
	      "enable-background": "enableBackground",
	      end: "end",
	      exponent: "exponent",
	      externalresourcesrequired: "externalResourcesRequired",
	      fill: "fill",
	      fillopacity: "fillOpacity",
	      "fill-opacity": "fillOpacity",
	      fillrule: "fillRule",
	      "fill-rule": "fillRule",
	      filter: "filter",
	      filterres: "filterRes",
	      filterunits: "filterUnits",
	      floodopacity: "floodOpacity",
	      "flood-opacity": "floodOpacity",
	      floodcolor: "floodColor",
	      "flood-color": "floodColor",
	      focusable: "focusable",
	      fontfamily: "fontFamily",
	      "font-family": "fontFamily",
	      fontsize: "fontSize",
	      "font-size": "fontSize",
	      fontsizeadjust: "fontSizeAdjust",
	      "font-size-adjust": "fontSizeAdjust",
	      fontstretch: "fontStretch",
	      "font-stretch": "fontStretch",
	      fontstyle: "fontStyle",
	      "font-style": "fontStyle",
	      fontvariant: "fontVariant",
	      "font-variant": "fontVariant",
	      fontweight: "fontWeight",
	      "font-weight": "fontWeight",
	      format: "format",
	      from: "from",
	      fx: "fx",
	      fy: "fy",
	      g1: "g1",
	      g2: "g2",
	      glyphname: "glyphName",
	      "glyph-name": "glyphName",
	      glyphorientationhorizontal: "glyphOrientationHorizontal",
	      "glyph-orientation-horizontal": "glyphOrientationHorizontal",
	      glyphorientationvertical: "glyphOrientationVertical",
	      "glyph-orientation-vertical": "glyphOrientationVertical",
	      glyphref: "glyphRef",
	      gradienttransform: "gradientTransform",
	      gradientunits: "gradientUnits",
	      hanging: "hanging",
	      horizadvx: "horizAdvX",
	      "horiz-adv-x": "horizAdvX",
	      horizoriginx: "horizOriginX",
	      "horiz-origin-x": "horizOriginX",
	      ideographic: "ideographic",
	      imagerendering: "imageRendering",
	      "image-rendering": "imageRendering",
	      in2: "in2",
	      in: "in",
	      inlist: "inlist",
	      intercept: "intercept",
	      k1: "k1",
	      k2: "k2",
	      k3: "k3",
	      k4: "k4",
	      k: "k",
	      kernelmatrix: "kernelMatrix",
	      kernelunitlength: "kernelUnitLength",
	      kerning: "kerning",
	      keypoints: "keyPoints",
	      keysplines: "keySplines",
	      keytimes: "keyTimes",
	      lengthadjust: "lengthAdjust",
	      letterspacing: "letterSpacing",
	      "letter-spacing": "letterSpacing",
	      lightingcolor: "lightingColor",
	      "lighting-color": "lightingColor",
	      limitingconeangle: "limitingConeAngle",
	      local: "local",
	      markerend: "markerEnd",
	      "marker-end": "markerEnd",
	      markerheight: "markerHeight",
	      markermid: "markerMid",
	      "marker-mid": "markerMid",
	      markerstart: "markerStart",
	      "marker-start": "markerStart",
	      markerunits: "markerUnits",
	      markerwidth: "markerWidth",
	      mask: "mask",
	      maskcontentunits: "maskContentUnits",
	      maskunits: "maskUnits",
	      mathematical: "mathematical",
	      mode: "mode",
	      numoctaves: "numOctaves",
	      offset: "offset",
	      opacity: "opacity",
	      operator: "operator",
	      order: "order",
	      orient: "orient",
	      orientation: "orientation",
	      origin: "origin",
	      overflow: "overflow",
	      overlineposition: "overlinePosition",
	      "overline-position": "overlinePosition",
	      overlinethickness: "overlineThickness",
	      "overline-thickness": "overlineThickness",
	      paintorder: "paintOrder",
	      "paint-order": "paintOrder",
	      panose1: "panose1",
	      "panose-1": "panose1",
	      pathlength: "pathLength",
	      patterncontentunits: "patternContentUnits",
	      patterntransform: "patternTransform",
	      patternunits: "patternUnits",
	      pointerevents: "pointerEvents",
	      "pointer-events": "pointerEvents",
	      points: "points",
	      pointsatx: "pointsAtX",
	      pointsaty: "pointsAtY",
	      pointsatz: "pointsAtZ",
	      prefix: "prefix",
	      preservealpha: "preserveAlpha",
	      preserveaspectratio: "preserveAspectRatio",
	      primitiveunits: "primitiveUnits",
	      property: "property",
	      r: "r",
	      radius: "radius",
	      refx: "refX",
	      refy: "refY",
	      renderingintent: "renderingIntent",
	      "rendering-intent": "renderingIntent",
	      repeatcount: "repeatCount",
	      repeatdur: "repeatDur",
	      requiredextensions: "requiredExtensions",
	      requiredfeatures: "requiredFeatures",
	      resource: "resource",
	      restart: "restart",
	      result: "result",
	      results: "results",
	      rotate: "rotate",
	      rx: "rx",
	      ry: "ry",
	      scale: "scale",
	      security: "security",
	      seed: "seed",
	      shaperendering: "shapeRendering",
	      "shape-rendering": "shapeRendering",
	      slope: "slope",
	      spacing: "spacing",
	      specularconstant: "specularConstant",
	      specularexponent: "specularExponent",
	      speed: "speed",
	      spreadmethod: "spreadMethod",
	      startoffset: "startOffset",
	      stddeviation: "stdDeviation",
	      stemh: "stemh",
	      stemv: "stemv",
	      stitchtiles: "stitchTiles",
	      stopcolor: "stopColor",
	      "stop-color": "stopColor",
	      stopopacity: "stopOpacity",
	      "stop-opacity": "stopOpacity",
	      strikethroughposition: "strikethroughPosition",
	      "strikethrough-position": "strikethroughPosition",
	      strikethroughthickness: "strikethroughThickness",
	      "strikethrough-thickness": "strikethroughThickness",
	      string: "string",
	      stroke: "stroke",
	      strokedasharray: "strokeDasharray",
	      "stroke-dasharray": "strokeDasharray",
	      strokedashoffset: "strokeDashoffset",
	      "stroke-dashoffset": "strokeDashoffset",
	      strokelinecap: "strokeLinecap",
	      "stroke-linecap": "strokeLinecap",
	      strokelinejoin: "strokeLinejoin",
	      "stroke-linejoin": "strokeLinejoin",
	      strokemiterlimit: "strokeMiterlimit",
	      "stroke-miterlimit": "strokeMiterlimit",
	      strokewidth: "strokeWidth",
	      "stroke-width": "strokeWidth",
	      strokeopacity: "strokeOpacity",
	      "stroke-opacity": "strokeOpacity",
	      suppresscontenteditablewarning: "suppressContentEditableWarning",
	      suppresshydrationwarning: "suppressHydrationWarning",
	      surfacescale: "surfaceScale",
	      systemlanguage: "systemLanguage",
	      tablevalues: "tableValues",
	      targetx: "targetX",
	      targety: "targetY",
	      textanchor: "textAnchor",
	      "text-anchor": "textAnchor",
	      textdecoration: "textDecoration",
	      "text-decoration": "textDecoration",
	      textlength: "textLength",
	      textrendering: "textRendering",
	      "text-rendering": "textRendering",
	      to: "to",
	      transform: "transform",
	      typeof: "typeof",
	      u1: "u1",
	      u2: "u2",
	      underlineposition: "underlinePosition",
	      "underline-position": "underlinePosition",
	      underlinethickness: "underlineThickness",
	      "underline-thickness": "underlineThickness",
	      unicode: "unicode",
	      unicodebidi: "unicodeBidi",
	      "unicode-bidi": "unicodeBidi",
	      unicoderange: "unicodeRange",
	      "unicode-range": "unicodeRange",
	      unitsperem: "unitsPerEm",
	      "units-per-em": "unitsPerEm",
	      unselectable: "unselectable",
	      valphabetic: "vAlphabetic",
	      "v-alphabetic": "vAlphabetic",
	      values: "values",
	      vectoreffect: "vectorEffect",
	      "vector-effect": "vectorEffect",
	      version: "version",
	      vertadvy: "vertAdvY",
	      "vert-adv-y": "vertAdvY",
	      vertoriginx: "vertOriginX",
	      "vert-origin-x": "vertOriginX",
	      vertoriginy: "vertOriginY",
	      "vert-origin-y": "vertOriginY",
	      vhanging: "vHanging",
	      "v-hanging": "vHanging",
	      videographic: "vIdeographic",
	      "v-ideographic": "vIdeographic",
	      viewbox: "viewBox",
	      viewtarget: "viewTarget",
	      visibility: "visibility",
	      vmathematical: "vMathematical",
	      "v-mathematical": "vMathematical",
	      vocab: "vocab",
	      widths: "widths",
	      wordspacing: "wordSpacing",
	      "word-spacing": "wordSpacing",
	      writingmode: "writingMode",
	      "writing-mode": "writingMode",
	      x1: "x1",
	      x2: "x2",
	      x: "x",
	      xchannelselector: "xChannelSelector",
	      xheight: "xHeight",
	      "x-height": "xHeight",
	      xlinkactuate: "xlinkActuate",
	      "xlink:actuate": "xlinkActuate",
	      xlinkarcrole: "xlinkArcrole",
	      "xlink:arcrole": "xlinkArcrole",
	      xlinkhref: "xlinkHref",
	      "xlink:href": "xlinkHref",
	      xlinkrole: "xlinkRole",
	      "xlink:role": "xlinkRole",
	      xlinkshow: "xlinkShow",
	      "xlink:show": "xlinkShow",
	      xlinktitle: "xlinkTitle",
	      "xlink:title": "xlinkTitle",
	      xlinktype: "xlinkType",
	      "xlink:type": "xlinkType",
	      xmlbase: "xmlBase",
	      "xml:base": "xmlBase",
	      xmllang: "xmlLang",
	      "xml:lang": "xmlLang",
	      xmlns: "xmlns",
	      "xml:space": "xmlSpace",
	      xmlnsxlink: "xmlnsXlink",
	      "xmlns:xlink": "xmlnsXlink",
	      xmlspace: "xmlSpace",
	      y1: "y1",
	      y2: "y2",
	      y: "y",
	      ychannelselector: "yChannelSelector",
	      z: "z",
	      zoomandpan: "zoomAndPan"
	    };
	    var ariaProperties = {
	      "aria-current": 0,
	      // state
	      "aria-description": 0,
	      "aria-details": 0,
	      "aria-disabled": 0,
	      // state
	      "aria-hidden": 0,
	      // state
	      "aria-invalid": 0,
	      // state
	      "aria-keyshortcuts": 0,
	      "aria-label": 0,
	      "aria-roledescription": 0,
	      // Widget Attributes
	      "aria-autocomplete": 0,
	      "aria-checked": 0,
	      "aria-expanded": 0,
	      "aria-haspopup": 0,
	      "aria-level": 0,
	      "aria-modal": 0,
	      "aria-multiline": 0,
	      "aria-multiselectable": 0,
	      "aria-orientation": 0,
	      "aria-placeholder": 0,
	      "aria-pressed": 0,
	      "aria-readonly": 0,
	      "aria-required": 0,
	      "aria-selected": 0,
	      "aria-sort": 0,
	      "aria-valuemax": 0,
	      "aria-valuemin": 0,
	      "aria-valuenow": 0,
	      "aria-valuetext": 0,
	      // Live Region Attributes
	      "aria-atomic": 0,
	      "aria-busy": 0,
	      "aria-live": 0,
	      "aria-relevant": 0,
	      // Drag-and-Drop Attributes
	      "aria-dropeffect": 0,
	      "aria-grabbed": 0,
	      // Relationship Attributes
	      "aria-activedescendant": 0,
	      "aria-colcount": 0,
	      "aria-colindex": 0,
	      "aria-colspan": 0,
	      "aria-controls": 0,
	      "aria-describedby": 0,
	      "aria-errormessage": 0,
	      "aria-flowto": 0,
	      "aria-labelledby": 0,
	      "aria-owns": 0,
	      "aria-posinset": 0,
	      "aria-rowcount": 0,
	      "aria-rowindex": 0,
	      "aria-rowspan": 0,
	      "aria-setsize": 0
	    };
	    var warnedProperties = {};
	    var rARIA = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$");
	    var rARIACamel = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
	    function validateProperty(tagName, name) {
	      {
	        if (hasOwnProperty.call(warnedProperties, name) && warnedProperties[name]) {
	          return true;
	        }
	        if (rARIACamel.test(name)) {
	          var ariaName = "aria-" + name.slice(4).toLowerCase();
	          var correctName = ariaProperties.hasOwnProperty(ariaName) ? ariaName : null;
	          if (correctName == null) {
	            error("Invalid ARIA attribute `%s`. ARIA attributes follow the pattern aria-* and must be lowercase.", name);
	            warnedProperties[name] = true;
	            return true;
	          }
	          if (name !== correctName) {
	            error("Invalid ARIA attribute `%s`. Did you mean `%s`?", name, correctName);
	            warnedProperties[name] = true;
	            return true;
	          }
	        }
	        if (rARIA.test(name)) {
	          var lowerCasedName = name.toLowerCase();
	          var standardName = ariaProperties.hasOwnProperty(lowerCasedName) ? lowerCasedName : null;
	          if (standardName == null) {
	            warnedProperties[name] = true;
	            return false;
	          }
	          if (name !== standardName) {
	            error("Unknown ARIA attribute `%s`. Did you mean `%s`?", name, standardName);
	            warnedProperties[name] = true;
	            return true;
	          }
	        }
	      }
	      return true;
	    }
	    function warnInvalidARIAProps(type, props) {
	      {
	        var invalidProps = [];
	        for (var key in props) {
	          var isValid = validateProperty(type, key);
	          if (!isValid) {
	            invalidProps.push(key);
	          }
	        }
	        var unknownPropString = invalidProps.map(function(prop) {
	          return "`" + prop + "`";
	        }).join(", ");
	        if (invalidProps.length === 1) {
	          error("Invalid aria prop %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type);
	        } else if (invalidProps.length > 1) {
	          error("Invalid aria props %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type);
	        }
	      }
	    }
	    function validateProperties(type, props) {
	      if (isCustomComponent(type, props)) {
	        return;
	      }
	      warnInvalidARIAProps(type, props);
	    }
	    var didWarnValueNull = false;
	    function validateProperties$1(type, props) {
	      {
	        if (type !== "input" && type !== "textarea" && type !== "select") {
	          return;
	        }
	        if (props != null && props.value === null && !didWarnValueNull) {
	          didWarnValueNull = true;
	          if (type === "select" && props.multiple) {
	            error("`value` prop on `%s` should not be null. Consider using an empty array when `multiple` is set to `true` to clear the component or `undefined` for uncontrolled components.", type);
	          } else {
	            error("`value` prop on `%s` should not be null. Consider using an empty string to clear the component or `undefined` for uncontrolled components.", type);
	          }
	        }
	      }
	    }
	    var validateProperty$1 = function() {
	    };
	    {
	      var warnedProperties$1 = {};
	      var EVENT_NAME_REGEX = /^on./;
	      var INVALID_EVENT_NAME_REGEX = /^on[^A-Z]/;
	      var rARIA$1 = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$");
	      var rARIACamel$1 = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
	      validateProperty$1 = function(tagName, name, value, eventRegistry) {
	        if (hasOwnProperty.call(warnedProperties$1, name) && warnedProperties$1[name]) {
	          return true;
	        }
	        var lowerCasedName = name.toLowerCase();
	        if (lowerCasedName === "onfocusin" || lowerCasedName === "onfocusout") {
	          error("React uses onFocus and onBlur instead of onFocusIn and onFocusOut. All React events are normalized to bubble, so onFocusIn and onFocusOut are not needed/supported by React.");
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (eventRegistry != null) {
	          var registrationNameDependencies2 = eventRegistry.registrationNameDependencies, possibleRegistrationNames2 = eventRegistry.possibleRegistrationNames;
	          if (registrationNameDependencies2.hasOwnProperty(name)) {
	            return true;
	          }
	          var registrationName = possibleRegistrationNames2.hasOwnProperty(lowerCasedName) ? possibleRegistrationNames2[lowerCasedName] : null;
	          if (registrationName != null) {
	            error("Invalid event handler property `%s`. Did you mean `%s`?", name, registrationName);
	            warnedProperties$1[name] = true;
	            return true;
	          }
	          if (EVENT_NAME_REGEX.test(name)) {
	            error("Unknown event handler property `%s`. It will be ignored.", name);
	            warnedProperties$1[name] = true;
	            return true;
	          }
	        } else if (EVENT_NAME_REGEX.test(name)) {
	          if (INVALID_EVENT_NAME_REGEX.test(name)) {
	            error("Invalid event handler property `%s`. React events use the camelCase naming convention, for example `onClick`.", name);
	          }
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (rARIA$1.test(name) || rARIACamel$1.test(name)) {
	          return true;
	        }
	        if (lowerCasedName === "innerhtml") {
	          error("Directly setting property `innerHTML` is not permitted. For more information, lookup documentation on `dangerouslySetInnerHTML`.");
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (lowerCasedName === "aria") {
	          error("The `aria` attribute is reserved for future use in React. Pass individual `aria-` attributes instead.");
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (lowerCasedName === "is" && value !== null && value !== void 0 && typeof value !== "string") {
	          error("Received a `%s` for a string attribute `is`. If this is expected, cast the value to a string.", typeof value);
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (typeof value === "number" && isNaN(value)) {
	          error("Received NaN for the `%s` attribute. If this is expected, cast the value to a string.", name);
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        var propertyInfo = getPropertyInfo(name);
	        var isReserved = propertyInfo !== null && propertyInfo.type === RESERVED;
	        if (possibleStandardNames.hasOwnProperty(lowerCasedName)) {
	          var standardName = possibleStandardNames[lowerCasedName];
	          if (standardName !== name) {
	            error("Invalid DOM property `%s`. Did you mean `%s`?", name, standardName);
	            warnedProperties$1[name] = true;
	            return true;
	          }
	        } else if (!isReserved && name !== lowerCasedName) {
	          error("React does not recognize the `%s` prop on a DOM element. If you intentionally want it to appear in the DOM as a custom attribute, spell it as lowercase `%s` instead. If you accidentally passed it from a parent component, remove it from the DOM element.", name, lowerCasedName);
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (typeof value === "boolean" && shouldRemoveAttributeWithWarning(name, value, propertyInfo, false)) {
	          if (value) {
	            error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.', value, name, name, value, name);
	          } else {
	            error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.', value, name, name, value, name, name, name);
	          }
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        if (isReserved) {
	          return true;
	        }
	        if (shouldRemoveAttributeWithWarning(name, value, propertyInfo, false)) {
	          warnedProperties$1[name] = true;
	          return false;
	        }
	        if ((value === "false" || value === "true") && propertyInfo !== null && propertyInfo.type === BOOLEAN) {
	          error("Received the string `%s` for the boolean attribute `%s`. %s Did you mean %s={%s}?", value, name, value === "false" ? "The browser will interpret it as a truthy value." : 'Although this works, it will not work as expected if you pass the string "false".', name, value);
	          warnedProperties$1[name] = true;
	          return true;
	        }
	        return true;
	      };
	    }
	    var warnUnknownProperties = function(type, props, eventRegistry) {
	      {
	        var unknownProps = [];
	        for (var key in props) {
	          var isValid = validateProperty$1(type, key, props[key], eventRegistry);
	          if (!isValid) {
	            unknownProps.push(key);
	          }
	        }
	        var unknownPropString = unknownProps.map(function(prop) {
	          return "`" + prop + "`";
	        }).join(", ");
	        if (unknownProps.length === 1) {
	          error("Invalid value for prop %s on <%s> tag. Either remove it from the element, or pass a string or number value to keep it in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type);
	        } else if (unknownProps.length > 1) {
	          error("Invalid values for props %s on <%s> tag. Either remove them from the element, or pass a string or number value to keep them in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type);
	        }
	      }
	    };
	    function validateProperties$2(type, props, eventRegistry) {
	      if (isCustomComponent(type, props)) {
	        return;
	      }
	      warnUnknownProperties(type, props, eventRegistry);
	    }
	    var IS_EVENT_HANDLE_NON_MANAGED_NODE = 1;
	    var IS_NON_DELEGATED = 1 << 1;
	    var IS_CAPTURE_PHASE = 1 << 2;
	    var SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS = IS_EVENT_HANDLE_NON_MANAGED_NODE | IS_NON_DELEGATED | IS_CAPTURE_PHASE;
	    var currentReplayingEvent = null;
	    function setReplayingEvent(event) {
	      {
	        if (currentReplayingEvent !== null) {
	          error("Expected currently replaying event to be null. This error is likely caused by a bug in React. Please file an issue.");
	        }
	      }
	      currentReplayingEvent = event;
	    }
	    function resetReplayingEvent() {
	      {
	        if (currentReplayingEvent === null) {
	          error("Expected currently replaying event to not be null. This error is likely caused by a bug in React. Please file an issue.");
	        }
	      }
	      currentReplayingEvent = null;
	    }
	    function isReplayingEvent(event) {
	      return event === currentReplayingEvent;
	    }
	    function getEventTarget(nativeEvent) {
	      var target = nativeEvent.target || nativeEvent.srcElement || window;
	      if (target.correspondingUseElement) {
	        target = target.correspondingUseElement;
	      }
	      return target.nodeType === TEXT_NODE ? target.parentNode : target;
	    }
	    var restoreImpl = null;
	    var restoreTarget = null;
	    var restoreQueue = null;
	    function restoreStateOfTarget(target) {
	      var internalInstance = getInstanceFromNode(target);
	      if (!internalInstance) {
	        return;
	      }
	      if (typeof restoreImpl !== "function") {
	        throw new Error("setRestoreImplementation() needs to be called to handle a target for controlled events. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      var stateNode = internalInstance.stateNode;
	      if (stateNode) {
	        var _props = getFiberCurrentPropsFromNode(stateNode);
	        restoreImpl(internalInstance.stateNode, internalInstance.type, _props);
	      }
	    }
	    function setRestoreImplementation(impl) {
	      restoreImpl = impl;
	    }
	    function enqueueStateRestore(target) {
	      if (restoreTarget) {
	        if (restoreQueue) {
	          restoreQueue.push(target);
	        } else {
	          restoreQueue = [target];
	        }
	      } else {
	        restoreTarget = target;
	      }
	    }
	    function needsStateRestore() {
	      return restoreTarget !== null || restoreQueue !== null;
	    }
	    function restoreStateIfNeeded() {
	      if (!restoreTarget) {
	        return;
	      }
	      var target = restoreTarget;
	      var queuedTargets = restoreQueue;
	      restoreTarget = null;
	      restoreQueue = null;
	      restoreStateOfTarget(target);
	      if (queuedTargets) {
	        for (var i = 0; i < queuedTargets.length; i++) {
	          restoreStateOfTarget(queuedTargets[i]);
	        }
	      }
	    }
	    var batchedUpdatesImpl = function(fn, bookkeeping) {
	      return fn(bookkeeping);
	    };
	    var flushSyncImpl = function() {
	    };
	    var isInsideEventHandler = false;
	    function finishEventHandler() {
	      var controlledComponentsHavePendingUpdates = needsStateRestore();
	      if (controlledComponentsHavePendingUpdates) {
	        flushSyncImpl();
	        restoreStateIfNeeded();
	      }
	    }
	    function batchedUpdates(fn, a, b) {
	      if (isInsideEventHandler) {
	        return fn(a, b);
	      }
	      isInsideEventHandler = true;
	      try {
	        return batchedUpdatesImpl(fn, a, b);
	      } finally {
	        isInsideEventHandler = false;
	        finishEventHandler();
	      }
	    }
	    function setBatchingImplementation(_batchedUpdatesImpl, _discreteUpdatesImpl, _flushSyncImpl) {
	      batchedUpdatesImpl = _batchedUpdatesImpl;
	      flushSyncImpl = _flushSyncImpl;
	    }
	    function isInteractive(tag) {
	      return tag === "button" || tag === "input" || tag === "select" || tag === "textarea";
	    }
	    function shouldPreventMouseEvent(name, type, props) {
	      switch (name) {
	        case "onClick":
	        case "onClickCapture":
	        case "onDoubleClick":
	        case "onDoubleClickCapture":
	        case "onMouseDown":
	        case "onMouseDownCapture":
	        case "onMouseMove":
	        case "onMouseMoveCapture":
	        case "onMouseUp":
	        case "onMouseUpCapture":
	        case "onMouseEnter":
	          return !!(props.disabled && isInteractive(type));
	        default:
	          return false;
	      }
	    }
	    function getListener(inst, registrationName) {
	      var stateNode = inst.stateNode;
	      if (stateNode === null) {
	        return null;
	      }
	      var props = getFiberCurrentPropsFromNode(stateNode);
	      if (props === null) {
	        return null;
	      }
	      var listener = props[registrationName];
	      if (shouldPreventMouseEvent(registrationName, inst.type, props)) {
	        return null;
	      }
	      if (listener && typeof listener !== "function") {
	        throw new Error("Expected `" + registrationName + "` listener to be a function, instead got a value of `" + typeof listener + "` type.");
	      }
	      return listener;
	    }
	    var passiveBrowserEventsSupported = false;
	    if (canUseDOM) {
	      try {
	        var options = {};
	        Object.defineProperty(options, "passive", {
	          get: function() {
	            passiveBrowserEventsSupported = true;
	          }
	        });
	        window.addEventListener("test", options, options);
	        window.removeEventListener("test", options, options);
	      } catch (e) {
	        passiveBrowserEventsSupported = false;
	      }
	    }
	    function invokeGuardedCallbackProd(name, func, context, a, b, c, d, e, f) {
	      var funcArgs = Array.prototype.slice.call(arguments, 3);
	      try {
	        func.apply(context, funcArgs);
	      } catch (error2) {
	        this.onError(error2);
	      }
	    }
	    var invokeGuardedCallbackImpl = invokeGuardedCallbackProd;
	    {
	      if (typeof window !== "undefined" && typeof window.dispatchEvent === "function" && typeof document !== "undefined" && typeof document.createEvent === "function") {
	        var fakeNode = document.createElement("react");
	        invokeGuardedCallbackImpl = function invokeGuardedCallbackDev(name, func, context, a, b, c, d, e, f) {
	          if (typeof document === "undefined" || document === null) {
	            throw new Error("The `document` global was defined when React was initialized, but is not defined anymore. This can happen in a test environment if a component schedules an update from an asynchronous callback, but the test has already finished running. To solve this, you can either unmount the component at the end of your test (and ensure that any asynchronous operations get canceled in `componentWillUnmount`), or you can change the test itself to be asynchronous.");
	          }
	          var evt = document.createEvent("Event");
	          var didCall = false;
	          var didError = true;
	          var windowEvent = window.event;
	          var windowEventDescriptor = Object.getOwnPropertyDescriptor(window, "event");
	          function restoreAfterDispatch() {
	            fakeNode.removeEventListener(evtType, callCallback2, false);
	            if (typeof window.event !== "undefined" && window.hasOwnProperty("event")) {
	              window.event = windowEvent;
	            }
	          }
	          var funcArgs = Array.prototype.slice.call(arguments, 3);
	          function callCallback2() {
	            didCall = true;
	            restoreAfterDispatch();
	            func.apply(context, funcArgs);
	            didError = false;
	          }
	          var error2;
	          var didSetError = false;
	          var isCrossOriginError = false;
	          function handleWindowError(event) {
	            error2 = event.error;
	            didSetError = true;
	            if (error2 === null && event.colno === 0 && event.lineno === 0) {
	              isCrossOriginError = true;
	            }
	            if (event.defaultPrevented) {
	              if (error2 != null && typeof error2 === "object") {
	                try {
	                  error2._suppressLogging = true;
	                } catch (inner) {
	                }
	              }
	            }
	          }
	          var evtType = "react-" + (name ? name : "invokeguardedcallback");
	          window.addEventListener("error", handleWindowError);
	          fakeNode.addEventListener(evtType, callCallback2, false);
	          evt.initEvent(evtType, false, false);
	          fakeNode.dispatchEvent(evt);
	          if (windowEventDescriptor) {
	            Object.defineProperty(window, "event", windowEventDescriptor);
	          }
	          if (didCall && didError) {
	            if (!didSetError) {
	              error2 = new Error(`An error was thrown inside one of your components, but React doesn't know what it was. This is likely due to browser flakiness. React does its best to preserve the "Pause on exceptions" behavior of the DevTools, which requires some DEV-mode only tricks. It's possible that these don't work in your browser. Try triggering the error in production mode, or switching to a modern browser. If you suspect that this is actually an issue with React, please file an issue.`);
	            } else if (isCrossOriginError) {
	              error2 = new Error("A cross-origin error was thrown. React doesn't have access to the actual error object in development. See https://reactjs.org/link/crossorigin-error for more information.");
	            }
	            this.onError(error2);
	          }
	          window.removeEventListener("error", handleWindowError);
	          if (!didCall) {
	            restoreAfterDispatch();
	            return invokeGuardedCallbackProd.apply(this, arguments);
	          }
	        };
	      }
	    }
	    var invokeGuardedCallbackImpl$1 = invokeGuardedCallbackImpl;
	    var hasError = false;
	    var caughtError = null;
	    var hasRethrowError = false;
	    var rethrowError = null;
	    var reporter = {
	      onError: function(error2) {
	        hasError = true;
	        caughtError = error2;
	      }
	    };
	    function invokeGuardedCallback(name, func, context, a, b, c, d, e, f) {
	      hasError = false;
	      caughtError = null;
	      invokeGuardedCallbackImpl$1.apply(reporter, arguments);
	    }
	    function invokeGuardedCallbackAndCatchFirstError(name, func, context, a, b, c, d, e, f) {
	      invokeGuardedCallback.apply(this, arguments);
	      if (hasError) {
	        var error2 = clearCaughtError();
	        if (!hasRethrowError) {
	          hasRethrowError = true;
	          rethrowError = error2;
	        }
	      }
	    }
	    function rethrowCaughtError() {
	      if (hasRethrowError) {
	        var error2 = rethrowError;
	        hasRethrowError = false;
	        rethrowError = null;
	        throw error2;
	      }
	    }
	    function hasCaughtError() {
	      return hasError;
	    }
	    function clearCaughtError() {
	      if (hasError) {
	        var error2 = caughtError;
	        hasError = false;
	        caughtError = null;
	        return error2;
	      } else {
	        throw new Error("clearCaughtError was called but no error was captured. This error is likely caused by a bug in React. Please file an issue.");
	      }
	    }
	    function get(key) {
	      return key._reactInternals;
	    }
	    function has(key) {
	      return key._reactInternals !== void 0;
	    }
	    function set(key, value) {
	      key._reactInternals = value;
	    }
	    var NoFlags = (
	      /*                      */
	      0
	    );
	    var PerformedWork = (
	      /*                */
	      1
	    );
	    var Placement = (
	      /*                    */
	      2
	    );
	    var Update = (
	      /*                       */
	      4
	    );
	    var ChildDeletion = (
	      /*                */
	      16
	    );
	    var ContentReset = (
	      /*                 */
	      32
	    );
	    var Callback = (
	      /*                     */
	      64
	    );
	    var DidCapture = (
	      /*                   */
	      128
	    );
	    var ForceClientRender = (
	      /*            */
	      256
	    );
	    var Ref = (
	      /*                          */
	      512
	    );
	    var Snapshot = (
	      /*                     */
	      1024
	    );
	    var Passive = (
	      /*                      */
	      2048
	    );
	    var Hydrating = (
	      /*                    */
	      4096
	    );
	    var Visibility = (
	      /*                   */
	      8192
	    );
	    var StoreConsistency = (
	      /*             */
	      16384
	    );
	    var LifecycleEffectMask = Passive | Update | Callback | Ref | Snapshot | StoreConsistency;
	    var HostEffectMask = (
	      /*               */
	      32767
	    );
	    var Incomplete = (
	      /*                   */
	      32768
	    );
	    var ShouldCapture = (
	      /*                */
	      65536
	    );
	    var ForceUpdateForLegacySuspense = (
	      /* */
	      131072
	    );
	    var Forked = (
	      /*                       */
	      1048576
	    );
	    var RefStatic = (
	      /*                    */
	      2097152
	    );
	    var LayoutStatic = (
	      /*                 */
	      4194304
	    );
	    var PassiveStatic = (
	      /*                */
	      8388608
	    );
	    var MountLayoutDev = (
	      /*               */
	      16777216
	    );
	    var MountPassiveDev = (
	      /*              */
	      33554432
	    );
	    var BeforeMutationMask = (
	      // TODO: Remove Update flag from before mutation phase by re-landing Visibility
	      // flag logic (see #20043)
	      Update | Snapshot | 0
	    );
	    var MutationMask = Placement | Update | ChildDeletion | ContentReset | Ref | Hydrating | Visibility;
	    var LayoutMask = Update | Callback | Ref | Visibility;
	    var PassiveMask = Passive | ChildDeletion;
	    var StaticMask = LayoutStatic | PassiveStatic | RefStatic;
	    var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
	    function getNearestMountedFiber(fiber) {
	      var node = fiber;
	      var nearestMounted = fiber;
	      if (!fiber.alternate) {
	        var nextNode = node;
	        do {
	          node = nextNode;
	          if ((node.flags & (Placement | Hydrating)) !== NoFlags) {
	            nearestMounted = node.return;
	          }
	          nextNode = node.return;
	        } while (nextNode);
	      } else {
	        while (node.return) {
	          node = node.return;
	        }
	      }
	      if (node.tag === HostRoot) {
	        return nearestMounted;
	      }
	      return null;
	    }
	    function getSuspenseInstanceFromFiber(fiber) {
	      if (fiber.tag === SuspenseComponent) {
	        var suspenseState = fiber.memoizedState;
	        if (suspenseState === null) {
	          var current2 = fiber.alternate;
	          if (current2 !== null) {
	            suspenseState = current2.memoizedState;
	          }
	        }
	        if (suspenseState !== null) {
	          return suspenseState.dehydrated;
	        }
	      }
	      return null;
	    }
	    function getContainerFromFiber(fiber) {
	      return fiber.tag === HostRoot ? fiber.stateNode.containerInfo : null;
	    }
	    function isFiberMounted(fiber) {
	      return getNearestMountedFiber(fiber) === fiber;
	    }
	    function isMounted(component) {
	      {
	        var owner = ReactCurrentOwner.current;
	        if (owner !== null && owner.tag === ClassComponent) {
	          var ownerFiber = owner;
	          var instance = ownerFiber.stateNode;
	          if (!instance._warnedAboutRefsInRender) {
	            error("%s is accessing isMounted inside its render() function. render() should be a pure function of props and state. It should never access something that requires stale data from the previous render, such as refs. Move this logic to componentDidMount and componentDidUpdate instead.", getComponentNameFromFiber(ownerFiber) || "A component");
	          }
	          instance._warnedAboutRefsInRender = true;
	        }
	      }
	      var fiber = get(component);
	      if (!fiber) {
	        return false;
	      }
	      return getNearestMountedFiber(fiber) === fiber;
	    }
	    function assertIsMounted(fiber) {
	      if (getNearestMountedFiber(fiber) !== fiber) {
	        throw new Error("Unable to find node on an unmounted component.");
	      }
	    }
	    function findCurrentFiberUsingSlowPath(fiber) {
	      var alternate = fiber.alternate;
	      if (!alternate) {
	        var nearestMounted = getNearestMountedFiber(fiber);
	        if (nearestMounted === null) {
	          throw new Error("Unable to find node on an unmounted component.");
	        }
	        if (nearestMounted !== fiber) {
	          return null;
	        }
	        return fiber;
	      }
	      var a = fiber;
	      var b = alternate;
	      while (true) {
	        var parentA = a.return;
	        if (parentA === null) {
	          break;
	        }
	        var parentB = parentA.alternate;
	        if (parentB === null) {
	          var nextParent = parentA.return;
	          if (nextParent !== null) {
	            a = b = nextParent;
	            continue;
	          }
	          break;
	        }
	        if (parentA.child === parentB.child) {
	          var child = parentA.child;
	          while (child) {
	            if (child === a) {
	              assertIsMounted(parentA);
	              return fiber;
	            }
	            if (child === b) {
	              assertIsMounted(parentA);
	              return alternate;
	            }
	            child = child.sibling;
	          }
	          throw new Error("Unable to find node on an unmounted component.");
	        }
	        if (a.return !== b.return) {
	          a = parentA;
	          b = parentB;
	        } else {
	          var didFindChild = false;
	          var _child = parentA.child;
	          while (_child) {
	            if (_child === a) {
	              didFindChild = true;
	              a = parentA;
	              b = parentB;
	              break;
	            }
	            if (_child === b) {
	              didFindChild = true;
	              b = parentA;
	              a = parentB;
	              break;
	            }
	            _child = _child.sibling;
	          }
	          if (!didFindChild) {
	            _child = parentB.child;
	            while (_child) {
	              if (_child === a) {
	                didFindChild = true;
	                a = parentB;
	                b = parentA;
	                break;
	              }
	              if (_child === b) {
	                didFindChild = true;
	                b = parentB;
	                a = parentA;
	                break;
	              }
	              _child = _child.sibling;
	            }
	            if (!didFindChild) {
	              throw new Error("Child was not found in either parent set. This indicates a bug in React related to the return pointer. Please file an issue.");
	            }
	          }
	        }
	        if (a.alternate !== b) {
	          throw new Error("Return fibers should always be each others' alternates. This error is likely caused by a bug in React. Please file an issue.");
	        }
	      }
	      if (a.tag !== HostRoot) {
	        throw new Error("Unable to find node on an unmounted component.");
	      }
	      if (a.stateNode.current === a) {
	        return fiber;
	      }
	      return alternate;
	    }
	    function findCurrentHostFiber(parent) {
	      var currentParent = findCurrentFiberUsingSlowPath(parent);
	      return currentParent !== null ? findCurrentHostFiberImpl(currentParent) : null;
	    }
	    function findCurrentHostFiberImpl(node) {
	      if (node.tag === HostComponent || node.tag === HostText) {
	        return node;
	      }
	      var child = node.child;
	      while (child !== null) {
	        var match = findCurrentHostFiberImpl(child);
	        if (match !== null) {
	          return match;
	        }
	        child = child.sibling;
	      }
	      return null;
	    }
	    function findCurrentHostFiberWithNoPortals(parent) {
	      var currentParent = findCurrentFiberUsingSlowPath(parent);
	      return currentParent !== null ? findCurrentHostFiberWithNoPortalsImpl(currentParent) : null;
	    }
	    function findCurrentHostFiberWithNoPortalsImpl(node) {
	      if (node.tag === HostComponent || node.tag === HostText) {
	        return node;
	      }
	      var child = node.child;
	      while (child !== null) {
	        if (child.tag !== HostPortal) {
	          var match = findCurrentHostFiberWithNoPortalsImpl(child);
	          if (match !== null) {
	            return match;
	          }
	        }
	        child = child.sibling;
	      }
	      return null;
	    }
	    var scheduleCallback = Scheduler.unstable_scheduleCallback;
	    var cancelCallback = Scheduler.unstable_cancelCallback;
	    var shouldYield = Scheduler.unstable_shouldYield;
	    var requestPaint = Scheduler.unstable_requestPaint;
	    var now = Scheduler.unstable_now;
	    var getCurrentPriorityLevel = Scheduler.unstable_getCurrentPriorityLevel;
	    var ImmediatePriority = Scheduler.unstable_ImmediatePriority;
	    var UserBlockingPriority = Scheduler.unstable_UserBlockingPriority;
	    var NormalPriority = Scheduler.unstable_NormalPriority;
	    var LowPriority = Scheduler.unstable_LowPriority;
	    var IdlePriority = Scheduler.unstable_IdlePriority;
	    var unstable_yieldValue = Scheduler.unstable_yieldValue;
	    var unstable_setDisableYieldValue = Scheduler.unstable_setDisableYieldValue;
	    var rendererID = null;
	    var injectedHook = null;
	    var injectedProfilingHooks = null;
	    var hasLoggedError = false;
	    var isDevToolsPresent = typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined";
	    function injectInternals(internals) {
	      if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined") {
	        return false;
	      }
	      var hook = __REACT_DEVTOOLS_GLOBAL_HOOK__;
	      if (hook.isDisabled) {
	        return true;
	      }
	      if (!hook.supportsFiber) {
	        {
	          error("The installed version of React DevTools is too old and will not work with the current version of React. Please update React DevTools. https://reactjs.org/link/react-devtools");
	        }
	        return true;
	      }
	      try {
	        if (enableSchedulingProfiler) {
	          internals = assign({}, internals, {
	            getLaneLabelMap,
	            injectProfilingHooks
	          });
	        }
	        rendererID = hook.inject(internals);
	        injectedHook = hook;
	      } catch (err) {
	        {
	          error("React instrumentation encountered an error: %s.", err);
	        }
	      }
	      if (hook.checkDCE) {
	        return true;
	      } else {
	        return false;
	      }
	    }
	    function onScheduleRoot(root2, children) {
	      {
	        if (injectedHook && typeof injectedHook.onScheduleFiberRoot === "function") {
	          try {
	            injectedHook.onScheduleFiberRoot(rendererID, root2, children);
	          } catch (err) {
	            if (!hasLoggedError) {
	              hasLoggedError = true;
	              error("React instrumentation encountered an error: %s", err);
	            }
	          }
	        }
	      }
	    }
	    function onCommitRoot(root2, eventPriority) {
	      if (injectedHook && typeof injectedHook.onCommitFiberRoot === "function") {
	        try {
	          var didError = (root2.current.flags & DidCapture) === DidCapture;
	          if (enableProfilerTimer) {
	            var schedulerPriority;
	            switch (eventPriority) {
	              case DiscreteEventPriority:
	                schedulerPriority = ImmediatePriority;
	                break;
	              case ContinuousEventPriority:
	                schedulerPriority = UserBlockingPriority;
	                break;
	              case DefaultEventPriority:
	                schedulerPriority = NormalPriority;
	                break;
	              case IdleEventPriority:
	                schedulerPriority = IdlePriority;
	                break;
	              default:
	                schedulerPriority = NormalPriority;
	                break;
	            }
	            injectedHook.onCommitFiberRoot(rendererID, root2, schedulerPriority, didError);
	          }
	        } catch (err) {
	          {
	            if (!hasLoggedError) {
	              hasLoggedError = true;
	              error("React instrumentation encountered an error: %s", err);
	            }
	          }
	        }
	      }
	    }
	    function onPostCommitRoot(root2) {
	      if (injectedHook && typeof injectedHook.onPostCommitFiberRoot === "function") {
	        try {
	          injectedHook.onPostCommitFiberRoot(rendererID, root2);
	        } catch (err) {
	          {
	            if (!hasLoggedError) {
	              hasLoggedError = true;
	              error("React instrumentation encountered an error: %s", err);
	            }
	          }
	        }
	      }
	    }
	    function onCommitUnmount(fiber) {
	      if (injectedHook && typeof injectedHook.onCommitFiberUnmount === "function") {
	        try {
	          injectedHook.onCommitFiberUnmount(rendererID, fiber);
	        } catch (err) {
	          {
	            if (!hasLoggedError) {
	              hasLoggedError = true;
	              error("React instrumentation encountered an error: %s", err);
	            }
	          }
	        }
	      }
	    }
	    function setIsStrictModeForDevtools(newIsStrictMode) {
	      {
	        if (typeof unstable_yieldValue === "function") {
	          unstable_setDisableYieldValue(newIsStrictMode);
	          setSuppressWarning(newIsStrictMode);
	        }
	        if (injectedHook && typeof injectedHook.setStrictMode === "function") {
	          try {
	            injectedHook.setStrictMode(rendererID, newIsStrictMode);
	          } catch (err) {
	            {
	              if (!hasLoggedError) {
	                hasLoggedError = true;
	                error("React instrumentation encountered an error: %s", err);
	              }
	            }
	          }
	        }
	      }
	    }
	    function injectProfilingHooks(profilingHooks) {
	      injectedProfilingHooks = profilingHooks;
	    }
	    function getLaneLabelMap() {
	      {
	        var map = /* @__PURE__ */ new Map();
	        var lane = 1;
	        for (var index2 = 0; index2 < TotalLanes; index2++) {
	          var label = getLabelForLane(lane);
	          map.set(lane, label);
	          lane *= 2;
	        }
	        return map;
	      }
	    }
	    function markCommitStarted(lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markCommitStarted === "function") {
	          injectedProfilingHooks.markCommitStarted(lanes);
	        }
	      }
	    }
	    function markCommitStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markCommitStopped === "function") {
	          injectedProfilingHooks.markCommitStopped();
	        }
	      }
	    }
	    function markComponentRenderStarted(fiber) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentRenderStarted === "function") {
	          injectedProfilingHooks.markComponentRenderStarted(fiber);
	        }
	      }
	    }
	    function markComponentRenderStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentRenderStopped === "function") {
	          injectedProfilingHooks.markComponentRenderStopped();
	        }
	      }
	    }
	    function markComponentPassiveEffectMountStarted(fiber) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectMountStarted === "function") {
	          injectedProfilingHooks.markComponentPassiveEffectMountStarted(fiber);
	        }
	      }
	    }
	    function markComponentPassiveEffectMountStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectMountStopped === "function") {
	          injectedProfilingHooks.markComponentPassiveEffectMountStopped();
	        }
	      }
	    }
	    function markComponentPassiveEffectUnmountStarted(fiber) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectUnmountStarted === "function") {
	          injectedProfilingHooks.markComponentPassiveEffectUnmountStarted(fiber);
	        }
	      }
	    }
	    function markComponentPassiveEffectUnmountStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectUnmountStopped === "function") {
	          injectedProfilingHooks.markComponentPassiveEffectUnmountStopped();
	        }
	      }
	    }
	    function markComponentLayoutEffectMountStarted(fiber) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectMountStarted === "function") {
	          injectedProfilingHooks.markComponentLayoutEffectMountStarted(fiber);
	        }
	      }
	    }
	    function markComponentLayoutEffectMountStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectMountStopped === "function") {
	          injectedProfilingHooks.markComponentLayoutEffectMountStopped();
	        }
	      }
	    }
	    function markComponentLayoutEffectUnmountStarted(fiber) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectUnmountStarted === "function") {
	          injectedProfilingHooks.markComponentLayoutEffectUnmountStarted(fiber);
	        }
	      }
	    }
	    function markComponentLayoutEffectUnmountStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectUnmountStopped === "function") {
	          injectedProfilingHooks.markComponentLayoutEffectUnmountStopped();
	        }
	      }
	    }
	    function markComponentErrored(fiber, thrownValue, lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentErrored === "function") {
	          injectedProfilingHooks.markComponentErrored(fiber, thrownValue, lanes);
	        }
	      }
	    }
	    function markComponentSuspended(fiber, wakeable, lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentSuspended === "function") {
	          injectedProfilingHooks.markComponentSuspended(fiber, wakeable, lanes);
	        }
	      }
	    }
	    function markLayoutEffectsStarted(lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markLayoutEffectsStarted === "function") {
	          injectedProfilingHooks.markLayoutEffectsStarted(lanes);
	        }
	      }
	    }
	    function markLayoutEffectsStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markLayoutEffectsStopped === "function") {
	          injectedProfilingHooks.markLayoutEffectsStopped();
	        }
	      }
	    }
	    function markPassiveEffectsStarted(lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markPassiveEffectsStarted === "function") {
	          injectedProfilingHooks.markPassiveEffectsStarted(lanes);
	        }
	      }
	    }
	    function markPassiveEffectsStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markPassiveEffectsStopped === "function") {
	          injectedProfilingHooks.markPassiveEffectsStopped();
	        }
	      }
	    }
	    function markRenderStarted(lanes) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderStarted === "function") {
	          injectedProfilingHooks.markRenderStarted(lanes);
	        }
	      }
	    }
	    function markRenderYielded() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderYielded === "function") {
	          injectedProfilingHooks.markRenderYielded();
	        }
	      }
	    }
	    function markRenderStopped() {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderStopped === "function") {
	          injectedProfilingHooks.markRenderStopped();
	        }
	      }
	    }
	    function markRenderScheduled(lane) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderScheduled === "function") {
	          injectedProfilingHooks.markRenderScheduled(lane);
	        }
	      }
	    }
	    function markForceUpdateScheduled(fiber, lane) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markForceUpdateScheduled === "function") {
	          injectedProfilingHooks.markForceUpdateScheduled(fiber, lane);
	        }
	      }
	    }
	    function markStateUpdateScheduled(fiber, lane) {
	      {
	        if (injectedProfilingHooks !== null && typeof injectedProfilingHooks.markStateUpdateScheduled === "function") {
	          injectedProfilingHooks.markStateUpdateScheduled(fiber, lane);
	        }
	      }
	    }
	    var NoMode = (
	      /*                         */
	      0
	    );
	    var ConcurrentMode = (
	      /*                 */
	      1
	    );
	    var ProfileMode = (
	      /*                    */
	      2
	    );
	    var StrictLegacyMode = (
	      /*               */
	      8
	    );
	    var StrictEffectsMode = (
	      /*              */
	      16
	    );
	    var clz32 = Math.clz32 ? Math.clz32 : clz32Fallback;
	    var log = Math.log;
	    var LN2 = Math.LN2;
	    function clz32Fallback(x) {
	      var asUint = x >>> 0;
	      if (asUint === 0) {
	        return 32;
	      }
	      return 31 - (log(asUint) / LN2 | 0) | 0;
	    }
	    var TotalLanes = 31;
	    var NoLanes = (
	      /*                        */
	      0
	    );
	    var NoLane = (
	      /*                          */
	      0
	    );
	    var SyncLane = (
	      /*                        */
	      1
	    );
	    var InputContinuousHydrationLane = (
	      /*    */
	      2
	    );
	    var InputContinuousLane = (
	      /*             */
	      4
	    );
	    var DefaultHydrationLane = (
	      /*            */
	      8
	    );
	    var DefaultLane = (
	      /*                     */
	      16
	    );
	    var TransitionHydrationLane = (
	      /*                */
	      32
	    );
	    var TransitionLanes = (
	      /*                       */
	      4194240
	    );
	    var TransitionLane1 = (
	      /*                        */
	      64
	    );
	    var TransitionLane2 = (
	      /*                        */
	      128
	    );
	    var TransitionLane3 = (
	      /*                        */
	      256
	    );
	    var TransitionLane4 = (
	      /*                        */
	      512
	    );
	    var TransitionLane5 = (
	      /*                        */
	      1024
	    );
	    var TransitionLane6 = (
	      /*                        */
	      2048
	    );
	    var TransitionLane7 = (
	      /*                        */
	      4096
	    );
	    var TransitionLane8 = (
	      /*                        */
	      8192
	    );
	    var TransitionLane9 = (
	      /*                        */
	      16384
	    );
	    var TransitionLane10 = (
	      /*                       */
	      32768
	    );
	    var TransitionLane11 = (
	      /*                       */
	      65536
	    );
	    var TransitionLane12 = (
	      /*                       */
	      131072
	    );
	    var TransitionLane13 = (
	      /*                       */
	      262144
	    );
	    var TransitionLane14 = (
	      /*                       */
	      524288
	    );
	    var TransitionLane15 = (
	      /*                       */
	      1048576
	    );
	    var TransitionLane16 = (
	      /*                       */
	      2097152
	    );
	    var RetryLanes = (
	      /*                            */
	      130023424
	    );
	    var RetryLane1 = (
	      /*                             */
	      4194304
	    );
	    var RetryLane2 = (
	      /*                             */
	      8388608
	    );
	    var RetryLane3 = (
	      /*                             */
	      16777216
	    );
	    var RetryLane4 = (
	      /*                             */
	      33554432
	    );
	    var RetryLane5 = (
	      /*                             */
	      67108864
	    );
	    var SomeRetryLane = RetryLane1;
	    var SelectiveHydrationLane = (
	      /*          */
	      134217728
	    );
	    var NonIdleLanes = (
	      /*                          */
	      268435455
	    );
	    var IdleHydrationLane = (
	      /*               */
	      268435456
	    );
	    var IdleLane = (
	      /*                        */
	      536870912
	    );
	    var OffscreenLane = (
	      /*                   */
	      1073741824
	    );
	    function getLabelForLane(lane) {
	      {
	        if (lane & SyncLane) {
	          return "Sync";
	        }
	        if (lane & InputContinuousHydrationLane) {
	          return "InputContinuousHydration";
	        }
	        if (lane & InputContinuousLane) {
	          return "InputContinuous";
	        }
	        if (lane & DefaultHydrationLane) {
	          return "DefaultHydration";
	        }
	        if (lane & DefaultLane) {
	          return "Default";
	        }
	        if (lane & TransitionHydrationLane) {
	          return "TransitionHydration";
	        }
	        if (lane & TransitionLanes) {
	          return "Transition";
	        }
	        if (lane & RetryLanes) {
	          return "Retry";
	        }
	        if (lane & SelectiveHydrationLane) {
	          return "SelectiveHydration";
	        }
	        if (lane & IdleHydrationLane) {
	          return "IdleHydration";
	        }
	        if (lane & IdleLane) {
	          return "Idle";
	        }
	        if (lane & OffscreenLane) {
	          return "Offscreen";
	        }
	      }
	    }
	    var NoTimestamp = -1;
	    var nextTransitionLane = TransitionLane1;
	    var nextRetryLane = RetryLane1;
	    function getHighestPriorityLanes(lanes) {
	      switch (getHighestPriorityLane(lanes)) {
	        case SyncLane:
	          return SyncLane;
	        case InputContinuousHydrationLane:
	          return InputContinuousHydrationLane;
	        case InputContinuousLane:
	          return InputContinuousLane;
	        case DefaultHydrationLane:
	          return DefaultHydrationLane;
	        case DefaultLane:
	          return DefaultLane;
	        case TransitionHydrationLane:
	          return TransitionHydrationLane;
	        case TransitionLane1:
	        case TransitionLane2:
	        case TransitionLane3:
	        case TransitionLane4:
	        case TransitionLane5:
	        case TransitionLane6:
	        case TransitionLane7:
	        case TransitionLane8:
	        case TransitionLane9:
	        case TransitionLane10:
	        case TransitionLane11:
	        case TransitionLane12:
	        case TransitionLane13:
	        case TransitionLane14:
	        case TransitionLane15:
	        case TransitionLane16:
	          return lanes & TransitionLanes;
	        case RetryLane1:
	        case RetryLane2:
	        case RetryLane3:
	        case RetryLane4:
	        case RetryLane5:
	          return lanes & RetryLanes;
	        case SelectiveHydrationLane:
	          return SelectiveHydrationLane;
	        case IdleHydrationLane:
	          return IdleHydrationLane;
	        case IdleLane:
	          return IdleLane;
	        case OffscreenLane:
	          return OffscreenLane;
	        default:
	          {
	            error("Should have found matching lanes. This is a bug in React.");
	          }
	          return lanes;
	      }
	    }
	    function getNextLanes(root2, wipLanes) {
	      var pendingLanes = root2.pendingLanes;
	      if (pendingLanes === NoLanes) {
	        return NoLanes;
	      }
	      var nextLanes = NoLanes;
	      var suspendedLanes = root2.suspendedLanes;
	      var pingedLanes = root2.pingedLanes;
	      var nonIdlePendingLanes = pendingLanes & NonIdleLanes;
	      if (nonIdlePendingLanes !== NoLanes) {
	        var nonIdleUnblockedLanes = nonIdlePendingLanes & ~suspendedLanes;
	        if (nonIdleUnblockedLanes !== NoLanes) {
	          nextLanes = getHighestPriorityLanes(nonIdleUnblockedLanes);
	        } else {
	          var nonIdlePingedLanes = nonIdlePendingLanes & pingedLanes;
	          if (nonIdlePingedLanes !== NoLanes) {
	            nextLanes = getHighestPriorityLanes(nonIdlePingedLanes);
	          }
	        }
	      } else {
	        var unblockedLanes = pendingLanes & ~suspendedLanes;
	        if (unblockedLanes !== NoLanes) {
	          nextLanes = getHighestPriorityLanes(unblockedLanes);
	        } else {
	          if (pingedLanes !== NoLanes) {
	            nextLanes = getHighestPriorityLanes(pingedLanes);
	          }
	        }
	      }
	      if (nextLanes === NoLanes) {
	        return NoLanes;
	      }
	      if (wipLanes !== NoLanes && wipLanes !== nextLanes && // If we already suspended with a delay, then interrupting is fine. Don't
	      // bother waiting until the root is complete.
	      (wipLanes & suspendedLanes) === NoLanes) {
	        var nextLane = getHighestPriorityLane(nextLanes);
	        var wipLane = getHighestPriorityLane(wipLanes);
	        if (
	          // Tests whether the next lane is equal or lower priority than the wip
	          // one. This works because the bits decrease in priority as you go left.
	          nextLane >= wipLane || // Default priority updates should not interrupt transition updates. The
	          // only difference between default updates and transition updates is that
	          // default updates do not support refresh transitions.
	          nextLane === DefaultLane && (wipLane & TransitionLanes) !== NoLanes
	        ) {
	          return wipLanes;
	        }
	      }
	      if ((nextLanes & InputContinuousLane) !== NoLanes) {
	        nextLanes |= pendingLanes & DefaultLane;
	      }
	      var entangledLanes = root2.entangledLanes;
	      if (entangledLanes !== NoLanes) {
	        var entanglements = root2.entanglements;
	        var lanes = nextLanes & entangledLanes;
	        while (lanes > 0) {
	          var index2 = pickArbitraryLaneIndex(lanes);
	          var lane = 1 << index2;
	          nextLanes |= entanglements[index2];
	          lanes &= ~lane;
	        }
	      }
	      return nextLanes;
	    }
	    function getMostRecentEventTime(root2, lanes) {
	      var eventTimes = root2.eventTimes;
	      var mostRecentEventTime = NoTimestamp;
	      while (lanes > 0) {
	        var index2 = pickArbitraryLaneIndex(lanes);
	        var lane = 1 << index2;
	        var eventTime = eventTimes[index2];
	        if (eventTime > mostRecentEventTime) {
	          mostRecentEventTime = eventTime;
	        }
	        lanes &= ~lane;
	      }
	      return mostRecentEventTime;
	    }
	    function computeExpirationTime(lane, currentTime) {
	      switch (lane) {
	        case SyncLane:
	        case InputContinuousHydrationLane:
	        case InputContinuousLane:
	          return currentTime + 250;
	        case DefaultHydrationLane:
	        case DefaultLane:
	        case TransitionHydrationLane:
	        case TransitionLane1:
	        case TransitionLane2:
	        case TransitionLane3:
	        case TransitionLane4:
	        case TransitionLane5:
	        case TransitionLane6:
	        case TransitionLane7:
	        case TransitionLane8:
	        case TransitionLane9:
	        case TransitionLane10:
	        case TransitionLane11:
	        case TransitionLane12:
	        case TransitionLane13:
	        case TransitionLane14:
	        case TransitionLane15:
	        case TransitionLane16:
	          return currentTime + 5e3;
	        case RetryLane1:
	        case RetryLane2:
	        case RetryLane3:
	        case RetryLane4:
	        case RetryLane5:
	          return NoTimestamp;
	        case SelectiveHydrationLane:
	        case IdleHydrationLane:
	        case IdleLane:
	        case OffscreenLane:
	          return NoTimestamp;
	        default:
	          {
	            error("Should have found matching lanes. This is a bug in React.");
	          }
	          return NoTimestamp;
	      }
	    }
	    function markStarvedLanesAsExpired(root2, currentTime) {
	      var pendingLanes = root2.pendingLanes;
	      var suspendedLanes = root2.suspendedLanes;
	      var pingedLanes = root2.pingedLanes;
	      var expirationTimes = root2.expirationTimes;
	      var lanes = pendingLanes;
	      while (lanes > 0) {
	        var index2 = pickArbitraryLaneIndex(lanes);
	        var lane = 1 << index2;
	        var expirationTime = expirationTimes[index2];
	        if (expirationTime === NoTimestamp) {
	          if ((lane & suspendedLanes) === NoLanes || (lane & pingedLanes) !== NoLanes) {
	            expirationTimes[index2] = computeExpirationTime(lane, currentTime);
	          }
	        } else if (expirationTime <= currentTime) {
	          root2.expiredLanes |= lane;
	        }
	        lanes &= ~lane;
	      }
	    }
	    function getHighestPriorityPendingLanes(root2) {
	      return getHighestPriorityLanes(root2.pendingLanes);
	    }
	    function getLanesToRetrySynchronouslyOnError(root2) {
	      var everythingButOffscreen = root2.pendingLanes & ~OffscreenLane;
	      if (everythingButOffscreen !== NoLanes) {
	        return everythingButOffscreen;
	      }
	      if (everythingButOffscreen & OffscreenLane) {
	        return OffscreenLane;
	      }
	      return NoLanes;
	    }
	    function includesSyncLane(lanes) {
	      return (lanes & SyncLane) !== NoLanes;
	    }
	    function includesNonIdleWork(lanes) {
	      return (lanes & NonIdleLanes) !== NoLanes;
	    }
	    function includesOnlyRetries(lanes) {
	      return (lanes & RetryLanes) === lanes;
	    }
	    function includesOnlyNonUrgentLanes(lanes) {
	      var UrgentLanes = SyncLane | InputContinuousLane | DefaultLane;
	      return (lanes & UrgentLanes) === NoLanes;
	    }
	    function includesOnlyTransitions(lanes) {
	      return (lanes & TransitionLanes) === lanes;
	    }
	    function includesBlockingLane(root2, lanes) {
	      var SyncDefaultLanes = InputContinuousHydrationLane | InputContinuousLane | DefaultHydrationLane | DefaultLane;
	      return (lanes & SyncDefaultLanes) !== NoLanes;
	    }
	    function includesExpiredLane(root2, lanes) {
	      return (lanes & root2.expiredLanes) !== NoLanes;
	    }
	    function isTransitionLane(lane) {
	      return (lane & TransitionLanes) !== NoLanes;
	    }
	    function claimNextTransitionLane() {
	      var lane = nextTransitionLane;
	      nextTransitionLane <<= 1;
	      if ((nextTransitionLane & TransitionLanes) === NoLanes) {
	        nextTransitionLane = TransitionLane1;
	      }
	      return lane;
	    }
	    function claimNextRetryLane() {
	      var lane = nextRetryLane;
	      nextRetryLane <<= 1;
	      if ((nextRetryLane & RetryLanes) === NoLanes) {
	        nextRetryLane = RetryLane1;
	      }
	      return lane;
	    }
	    function getHighestPriorityLane(lanes) {
	      return lanes & -lanes;
	    }
	    function pickArbitraryLane(lanes) {
	      return getHighestPriorityLane(lanes);
	    }
	    function pickArbitraryLaneIndex(lanes) {
	      return 31 - clz32(lanes);
	    }
	    function laneToIndex(lane) {
	      return pickArbitraryLaneIndex(lane);
	    }
	    function includesSomeLane(a, b) {
	      return (a & b) !== NoLanes;
	    }
	    function isSubsetOfLanes(set2, subset) {
	      return (set2 & subset) === subset;
	    }
	    function mergeLanes(a, b) {
	      return a | b;
	    }
	    function removeLanes(set2, subset) {
	      return set2 & ~subset;
	    }
	    function intersectLanes(a, b) {
	      return a & b;
	    }
	    function laneToLanes(lane) {
	      return lane;
	    }
	    function higherPriorityLane(a, b) {
	      return a !== NoLane && a < b ? a : b;
	    }
	    function createLaneMap(initial) {
	      var laneMap = [];
	      for (var i = 0; i < TotalLanes; i++) {
	        laneMap.push(initial);
	      }
	      return laneMap;
	    }
	    function markRootUpdated(root2, updateLane, eventTime) {
	      root2.pendingLanes |= updateLane;
	      if (updateLane !== IdleLane) {
	        root2.suspendedLanes = NoLanes;
	        root2.pingedLanes = NoLanes;
	      }
	      var eventTimes = root2.eventTimes;
	      var index2 = laneToIndex(updateLane);
	      eventTimes[index2] = eventTime;
	    }
	    function markRootSuspended(root2, suspendedLanes) {
	      root2.suspendedLanes |= suspendedLanes;
	      root2.pingedLanes &= ~suspendedLanes;
	      var expirationTimes = root2.expirationTimes;
	      var lanes = suspendedLanes;
	      while (lanes > 0) {
	        var index2 = pickArbitraryLaneIndex(lanes);
	        var lane = 1 << index2;
	        expirationTimes[index2] = NoTimestamp;
	        lanes &= ~lane;
	      }
	    }
	    function markRootPinged(root2, pingedLanes, eventTime) {
	      root2.pingedLanes |= root2.suspendedLanes & pingedLanes;
	    }
	    function markRootFinished(root2, remainingLanes) {
	      var noLongerPendingLanes = root2.pendingLanes & ~remainingLanes;
	      root2.pendingLanes = remainingLanes;
	      root2.suspendedLanes = NoLanes;
	      root2.pingedLanes = NoLanes;
	      root2.expiredLanes &= remainingLanes;
	      root2.mutableReadLanes &= remainingLanes;
	      root2.entangledLanes &= remainingLanes;
	      var entanglements = root2.entanglements;
	      var eventTimes = root2.eventTimes;
	      var expirationTimes = root2.expirationTimes;
	      var lanes = noLongerPendingLanes;
	      while (lanes > 0) {
	        var index2 = pickArbitraryLaneIndex(lanes);
	        var lane = 1 << index2;
	        entanglements[index2] = NoLanes;
	        eventTimes[index2] = NoTimestamp;
	        expirationTimes[index2] = NoTimestamp;
	        lanes &= ~lane;
	      }
	    }
	    function markRootEntangled(root2, entangledLanes) {
	      var rootEntangledLanes = root2.entangledLanes |= entangledLanes;
	      var entanglements = root2.entanglements;
	      var lanes = rootEntangledLanes;
	      while (lanes) {
	        var index2 = pickArbitraryLaneIndex(lanes);
	        var lane = 1 << index2;
	        if (
	          // Is this one of the newly entangled lanes?
	          lane & entangledLanes | // Is this lane transitively entangled with the newly entangled lanes?
	          entanglements[index2] & entangledLanes
	        ) {
	          entanglements[index2] |= entangledLanes;
	        }
	        lanes &= ~lane;
	      }
	    }
	    function getBumpedLaneForHydration(root2, renderLanes2) {
	      var renderLane = getHighestPriorityLane(renderLanes2);
	      var lane;
	      switch (renderLane) {
	        case InputContinuousLane:
	          lane = InputContinuousHydrationLane;
	          break;
	        case DefaultLane:
	          lane = DefaultHydrationLane;
	          break;
	        case TransitionLane1:
	        case TransitionLane2:
	        case TransitionLane3:
	        case TransitionLane4:
	        case TransitionLane5:
	        case TransitionLane6:
	        case TransitionLane7:
	        case TransitionLane8:
	        case TransitionLane9:
	        case TransitionLane10:
	        case TransitionLane11:
	        case TransitionLane12:
	        case TransitionLane13:
	        case TransitionLane14:
	        case TransitionLane15:
	        case TransitionLane16:
	        case RetryLane1:
	        case RetryLane2:
	        case RetryLane3:
	        case RetryLane4:
	        case RetryLane5:
	          lane = TransitionHydrationLane;
	          break;
	        case IdleLane:
	          lane = IdleHydrationLane;
	          break;
	        default:
	          lane = NoLane;
	          break;
	      }
	      if ((lane & (root2.suspendedLanes | renderLanes2)) !== NoLane) {
	        return NoLane;
	      }
	      return lane;
	    }
	    function addFiberToLanesMap(root2, fiber, lanes) {
	      if (!isDevToolsPresent) {
	        return;
	      }
	      var pendingUpdatersLaneMap = root2.pendingUpdatersLaneMap;
	      while (lanes > 0) {
	        var index2 = laneToIndex(lanes);
	        var lane = 1 << index2;
	        var updaters = pendingUpdatersLaneMap[index2];
	        updaters.add(fiber);
	        lanes &= ~lane;
	      }
	    }
	    function movePendingFibersToMemoized(root2, lanes) {
	      if (!isDevToolsPresent) {
	        return;
	      }
	      var pendingUpdatersLaneMap = root2.pendingUpdatersLaneMap;
	      var memoizedUpdaters = root2.memoizedUpdaters;
	      while (lanes > 0) {
	        var index2 = laneToIndex(lanes);
	        var lane = 1 << index2;
	        var updaters = pendingUpdatersLaneMap[index2];
	        if (updaters.size > 0) {
	          updaters.forEach(function(fiber) {
	            var alternate = fiber.alternate;
	            if (alternate === null || !memoizedUpdaters.has(alternate)) {
	              memoizedUpdaters.add(fiber);
	            }
	          });
	          updaters.clear();
	        }
	        lanes &= ~lane;
	      }
	    }
	    function getTransitionsForLanes(root2, lanes) {
	      {
	        return null;
	      }
	    }
	    var DiscreteEventPriority = SyncLane;
	    var ContinuousEventPriority = InputContinuousLane;
	    var DefaultEventPriority = DefaultLane;
	    var IdleEventPriority = IdleLane;
	    var currentUpdatePriority = NoLane;
	    function getCurrentUpdatePriority() {
	      return currentUpdatePriority;
	    }
	    function setCurrentUpdatePriority(newPriority) {
	      currentUpdatePriority = newPriority;
	    }
	    function runWithPriority(priority, fn) {
	      var previousPriority = currentUpdatePriority;
	      try {
	        currentUpdatePriority = priority;
	        return fn();
	      } finally {
	        currentUpdatePriority = previousPriority;
	      }
	    }
	    function higherEventPriority(a, b) {
	      return a !== 0 && a < b ? a : b;
	    }
	    function lowerEventPriority(a, b) {
	      return a === 0 || a > b ? a : b;
	    }
	    function isHigherEventPriority(a, b) {
	      return a !== 0 && a < b;
	    }
	    function lanesToEventPriority(lanes) {
	      var lane = getHighestPriorityLane(lanes);
	      if (!isHigherEventPriority(DiscreteEventPriority, lane)) {
	        return DiscreteEventPriority;
	      }
	      if (!isHigherEventPriority(ContinuousEventPriority, lane)) {
	        return ContinuousEventPriority;
	      }
	      if (includesNonIdleWork(lane)) {
	        return DefaultEventPriority;
	      }
	      return IdleEventPriority;
	    }
	    function isRootDehydrated(root2) {
	      var currentState = root2.current.memoizedState;
	      return currentState.isDehydrated;
	    }
	    var _attemptSynchronousHydration;
	    function setAttemptSynchronousHydration(fn) {
	      _attemptSynchronousHydration = fn;
	    }
	    function attemptSynchronousHydration(fiber) {
	      _attemptSynchronousHydration(fiber);
	    }
	    var attemptContinuousHydration;
	    function setAttemptContinuousHydration(fn) {
	      attemptContinuousHydration = fn;
	    }
	    var attemptHydrationAtCurrentPriority;
	    function setAttemptHydrationAtCurrentPriority(fn) {
	      attemptHydrationAtCurrentPriority = fn;
	    }
	    var getCurrentUpdatePriority$1;
	    function setGetCurrentUpdatePriority(fn) {
	      getCurrentUpdatePriority$1 = fn;
	    }
	    var attemptHydrationAtPriority;
	    function setAttemptHydrationAtPriority(fn) {
	      attemptHydrationAtPriority = fn;
	    }
	    var hasScheduledReplayAttempt = false;
	    var queuedDiscreteEvents = [];
	    var queuedFocus = null;
	    var queuedDrag = null;
	    var queuedMouse = null;
	    var queuedPointers = /* @__PURE__ */ new Map();
	    var queuedPointerCaptures = /* @__PURE__ */ new Map();
	    var queuedExplicitHydrationTargets = [];
	    var discreteReplayableEvents = [
	      "mousedown",
	      "mouseup",
	      "touchcancel",
	      "touchend",
	      "touchstart",
	      "auxclick",
	      "dblclick",
	      "pointercancel",
	      "pointerdown",
	      "pointerup",
	      "dragend",
	      "dragstart",
	      "drop",
	      "compositionend",
	      "compositionstart",
	      "keydown",
	      "keypress",
	      "keyup",
	      "input",
	      "textInput",
	      // Intentionally camelCase
	      "copy",
	      "cut",
	      "paste",
	      "click",
	      "change",
	      "contextmenu",
	      "reset",
	      "submit"
	    ];
	    function isDiscreteEventThatRequiresHydration(eventType) {
	      return discreteReplayableEvents.indexOf(eventType) > -1;
	    }
	    function createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      return {
	        blockedOn,
	        domEventName,
	        eventSystemFlags,
	        nativeEvent,
	        targetContainers: [targetContainer]
	      };
	    }
	    function clearIfContinuousEvent(domEventName, nativeEvent) {
	      switch (domEventName) {
	        case "focusin":
	        case "focusout":
	          queuedFocus = null;
	          break;
	        case "dragenter":
	        case "dragleave":
	          queuedDrag = null;
	          break;
	        case "mouseover":
	        case "mouseout":
	          queuedMouse = null;
	          break;
	        case "pointerover":
	        case "pointerout": {
	          var pointerId = nativeEvent.pointerId;
	          queuedPointers.delete(pointerId);
	          break;
	        }
	        case "gotpointercapture":
	        case "lostpointercapture": {
	          var _pointerId = nativeEvent.pointerId;
	          queuedPointerCaptures.delete(_pointerId);
	          break;
	        }
	      }
	    }
	    function accumulateOrCreateContinuousQueuedReplayableEvent(existingQueuedEvent, blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      if (existingQueuedEvent === null || existingQueuedEvent.nativeEvent !== nativeEvent) {
	        var queuedEvent = createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent);
	        if (blockedOn !== null) {
	          var _fiber2 = getInstanceFromNode(blockedOn);
	          if (_fiber2 !== null) {
	            attemptContinuousHydration(_fiber2);
	          }
	        }
	        return queuedEvent;
	      }
	      existingQueuedEvent.eventSystemFlags |= eventSystemFlags;
	      var targetContainers = existingQueuedEvent.targetContainers;
	      if (targetContainer !== null && targetContainers.indexOf(targetContainer) === -1) {
	        targetContainers.push(targetContainer);
	      }
	      return existingQueuedEvent;
	    }
	    function queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      switch (domEventName) {
	        case "focusin": {
	          var focusEvent = nativeEvent;
	          queuedFocus = accumulateOrCreateContinuousQueuedReplayableEvent(queuedFocus, blockedOn, domEventName, eventSystemFlags, targetContainer, focusEvent);
	          return true;
	        }
	        case "dragenter": {
	          var dragEvent = nativeEvent;
	          queuedDrag = accumulateOrCreateContinuousQueuedReplayableEvent(queuedDrag, blockedOn, domEventName, eventSystemFlags, targetContainer, dragEvent);
	          return true;
	        }
	        case "mouseover": {
	          var mouseEvent = nativeEvent;
	          queuedMouse = accumulateOrCreateContinuousQueuedReplayableEvent(queuedMouse, blockedOn, domEventName, eventSystemFlags, targetContainer, mouseEvent);
	          return true;
	        }
	        case "pointerover": {
	          var pointerEvent = nativeEvent;
	          var pointerId = pointerEvent.pointerId;
	          queuedPointers.set(pointerId, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointers.get(pointerId) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, pointerEvent));
	          return true;
	        }
	        case "gotpointercapture": {
	          var _pointerEvent = nativeEvent;
	          var _pointerId2 = _pointerEvent.pointerId;
	          queuedPointerCaptures.set(_pointerId2, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointerCaptures.get(_pointerId2) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, _pointerEvent));
	          return true;
	        }
	      }
	      return false;
	    }
	    function attemptExplicitHydrationTarget(queuedTarget) {
	      var targetInst = getClosestInstanceFromNode(queuedTarget.target);
	      if (targetInst !== null) {
	        var nearestMounted = getNearestMountedFiber(targetInst);
	        if (nearestMounted !== null) {
	          var tag = nearestMounted.tag;
	          if (tag === SuspenseComponent) {
	            var instance = getSuspenseInstanceFromFiber(nearestMounted);
	            if (instance !== null) {
	              queuedTarget.blockedOn = instance;
	              attemptHydrationAtPriority(queuedTarget.priority, function() {
	                attemptHydrationAtCurrentPriority(nearestMounted);
	              });
	              return;
	            }
	          } else if (tag === HostRoot) {
	            var root2 = nearestMounted.stateNode;
	            if (isRootDehydrated(root2)) {
	              queuedTarget.blockedOn = getContainerFromFiber(nearestMounted);
	              return;
	            }
	          }
	        }
	      }
	      queuedTarget.blockedOn = null;
	    }
	    function queueExplicitHydrationTarget(target) {
	      var updatePriority = getCurrentUpdatePriority$1();
	      var queuedTarget = {
	        blockedOn: null,
	        target,
	        priority: updatePriority
	      };
	      var i = 0;
	      for (; i < queuedExplicitHydrationTargets.length; i++) {
	        if (!isHigherEventPriority(updatePriority, queuedExplicitHydrationTargets[i].priority)) {
	          break;
	        }
	      }
	      queuedExplicitHydrationTargets.splice(i, 0, queuedTarget);
	      if (i === 0) {
	        attemptExplicitHydrationTarget(queuedTarget);
	      }
	    }
	    function attemptReplayContinuousQueuedEvent(queuedEvent) {
	      if (queuedEvent.blockedOn !== null) {
	        return false;
	      }
	      var targetContainers = queuedEvent.targetContainers;
	      while (targetContainers.length > 0) {
	        var targetContainer = targetContainers[0];
	        var nextBlockedOn = findInstanceBlockingEvent(queuedEvent.domEventName, queuedEvent.eventSystemFlags, targetContainer, queuedEvent.nativeEvent);
	        if (nextBlockedOn === null) {
	          {
	            var nativeEvent = queuedEvent.nativeEvent;
	            var nativeEventClone = new nativeEvent.constructor(nativeEvent.type, nativeEvent);
	            setReplayingEvent(nativeEventClone);
	            nativeEvent.target.dispatchEvent(nativeEventClone);
	            resetReplayingEvent();
	          }
	        } else {
	          var _fiber3 = getInstanceFromNode(nextBlockedOn);
	          if (_fiber3 !== null) {
	            attemptContinuousHydration(_fiber3);
	          }
	          queuedEvent.blockedOn = nextBlockedOn;
	          return false;
	        }
	        targetContainers.shift();
	      }
	      return true;
	    }
	    function attemptReplayContinuousQueuedEventInMap(queuedEvent, key, map) {
	      if (attemptReplayContinuousQueuedEvent(queuedEvent)) {
	        map.delete(key);
	      }
	    }
	    function replayUnblockedEvents() {
	      hasScheduledReplayAttempt = false;
	      if (queuedFocus !== null && attemptReplayContinuousQueuedEvent(queuedFocus)) {
	        queuedFocus = null;
	      }
	      if (queuedDrag !== null && attemptReplayContinuousQueuedEvent(queuedDrag)) {
	        queuedDrag = null;
	      }
	      if (queuedMouse !== null && attemptReplayContinuousQueuedEvent(queuedMouse)) {
	        queuedMouse = null;
	      }
	      queuedPointers.forEach(attemptReplayContinuousQueuedEventInMap);
	      queuedPointerCaptures.forEach(attemptReplayContinuousQueuedEventInMap);
	    }
	    function scheduleCallbackIfUnblocked(queuedEvent, unblocked) {
	      if (queuedEvent.blockedOn === unblocked) {
	        queuedEvent.blockedOn = null;
	        if (!hasScheduledReplayAttempt) {
	          hasScheduledReplayAttempt = true;
	          Scheduler.unstable_scheduleCallback(Scheduler.unstable_NormalPriority, replayUnblockedEvents);
	        }
	      }
	    }
	    function retryIfBlockedOn(unblocked) {
	      if (queuedDiscreteEvents.length > 0) {
	        scheduleCallbackIfUnblocked(queuedDiscreteEvents[0], unblocked);
	        for (var i = 1; i < queuedDiscreteEvents.length; i++) {
	          var queuedEvent = queuedDiscreteEvents[i];
	          if (queuedEvent.blockedOn === unblocked) {
	            queuedEvent.blockedOn = null;
	          }
	        }
	      }
	      if (queuedFocus !== null) {
	        scheduleCallbackIfUnblocked(queuedFocus, unblocked);
	      }
	      if (queuedDrag !== null) {
	        scheduleCallbackIfUnblocked(queuedDrag, unblocked);
	      }
	      if (queuedMouse !== null) {
	        scheduleCallbackIfUnblocked(queuedMouse, unblocked);
	      }
	      var unblock = function(queuedEvent2) {
	        return scheduleCallbackIfUnblocked(queuedEvent2, unblocked);
	      };
	      queuedPointers.forEach(unblock);
	      queuedPointerCaptures.forEach(unblock);
	      for (var _i = 0; _i < queuedExplicitHydrationTargets.length; _i++) {
	        var queuedTarget = queuedExplicitHydrationTargets[_i];
	        if (queuedTarget.blockedOn === unblocked) {
	          queuedTarget.blockedOn = null;
	        }
	      }
	      while (queuedExplicitHydrationTargets.length > 0) {
	        var nextExplicitTarget = queuedExplicitHydrationTargets[0];
	        if (nextExplicitTarget.blockedOn !== null) {
	          break;
	        } else {
	          attemptExplicitHydrationTarget(nextExplicitTarget);
	          if (nextExplicitTarget.blockedOn === null) {
	            queuedExplicitHydrationTargets.shift();
	          }
	        }
	      }
	    }
	    var ReactCurrentBatchConfig = ReactSharedInternals.ReactCurrentBatchConfig;
	    var _enabled = true;
	    function setEnabled(enabled) {
	      _enabled = !!enabled;
	    }
	    function isEnabled() {
	      return _enabled;
	    }
	    function createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags) {
	      var eventPriority = getEventPriority(domEventName);
	      var listenerWrapper;
	      switch (eventPriority) {
	        case DiscreteEventPriority:
	          listenerWrapper = dispatchDiscreteEvent;
	          break;
	        case ContinuousEventPriority:
	          listenerWrapper = dispatchContinuousEvent;
	          break;
	        case DefaultEventPriority:
	        default:
	          listenerWrapper = dispatchEvent;
	          break;
	      }
	      return listenerWrapper.bind(null, domEventName, eventSystemFlags, targetContainer);
	    }
	    function dispatchDiscreteEvent(domEventName, eventSystemFlags, container, nativeEvent) {
	      var previousPriority = getCurrentUpdatePriority();
	      var prevTransition = ReactCurrentBatchConfig.transition;
	      ReactCurrentBatchConfig.transition = null;
	      try {
	        setCurrentUpdatePriority(DiscreteEventPriority);
	        dispatchEvent(domEventName, eventSystemFlags, container, nativeEvent);
	      } finally {
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig.transition = prevTransition;
	      }
	    }
	    function dispatchContinuousEvent(domEventName, eventSystemFlags, container, nativeEvent) {
	      var previousPriority = getCurrentUpdatePriority();
	      var prevTransition = ReactCurrentBatchConfig.transition;
	      ReactCurrentBatchConfig.transition = null;
	      try {
	        setCurrentUpdatePriority(ContinuousEventPriority);
	        dispatchEvent(domEventName, eventSystemFlags, container, nativeEvent);
	      } finally {
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig.transition = prevTransition;
	      }
	    }
	    function dispatchEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      if (!_enabled) {
	        return;
	      }
	      {
	        dispatchEventWithEnableCapturePhaseSelectiveHydrationWithoutDiscreteEventReplay(domEventName, eventSystemFlags, targetContainer, nativeEvent);
	      }
	    }
	    function dispatchEventWithEnableCapturePhaseSelectiveHydrationWithoutDiscreteEventReplay(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      var blockedOn = findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent);
	      if (blockedOn === null) {
	        dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, return_targetInst, targetContainer);
	        clearIfContinuousEvent(domEventName, nativeEvent);
	        return;
	      }
	      if (queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent)) {
	        nativeEvent.stopPropagation();
	        return;
	      }
	      clearIfContinuousEvent(domEventName, nativeEvent);
	      if (eventSystemFlags & IS_CAPTURE_PHASE && isDiscreteEventThatRequiresHydration(domEventName)) {
	        while (blockedOn !== null) {
	          var fiber = getInstanceFromNode(blockedOn);
	          if (fiber !== null) {
	            attemptSynchronousHydration(fiber);
	          }
	          var nextBlockedOn = findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent);
	          if (nextBlockedOn === null) {
	            dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, return_targetInst, targetContainer);
	          }
	          if (nextBlockedOn === blockedOn) {
	            break;
	          }
	          blockedOn = nextBlockedOn;
	        }
	        if (blockedOn !== null) {
	          nativeEvent.stopPropagation();
	        }
	        return;
	      }
	      dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, null, targetContainer);
	    }
	    var return_targetInst = null;
	    function findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
	      return_targetInst = null;
	      var nativeEventTarget = getEventTarget(nativeEvent);
	      var targetInst = getClosestInstanceFromNode(nativeEventTarget);
	      if (targetInst !== null) {
	        var nearestMounted = getNearestMountedFiber(targetInst);
	        if (nearestMounted === null) {
	          targetInst = null;
	        } else {
	          var tag = nearestMounted.tag;
	          if (tag === SuspenseComponent) {
	            var instance = getSuspenseInstanceFromFiber(nearestMounted);
	            if (instance !== null) {
	              return instance;
	            }
	            targetInst = null;
	          } else if (tag === HostRoot) {
	            var root2 = nearestMounted.stateNode;
	            if (isRootDehydrated(root2)) {
	              return getContainerFromFiber(nearestMounted);
	            }
	            targetInst = null;
	          } else if (nearestMounted !== targetInst) {
	            targetInst = null;
	          }
	        }
	      }
	      return_targetInst = targetInst;
	      return null;
	    }
	    function getEventPriority(domEventName) {
	      switch (domEventName) {
	        case "cancel":
	        case "click":
	        case "close":
	        case "contextmenu":
	        case "copy":
	        case "cut":
	        case "auxclick":
	        case "dblclick":
	        case "dragend":
	        case "dragstart":
	        case "drop":
	        case "focusin":
	        case "focusout":
	        case "input":
	        case "invalid":
	        case "keydown":
	        case "keypress":
	        case "keyup":
	        case "mousedown":
	        case "mouseup":
	        case "paste":
	        case "pause":
	        case "play":
	        case "pointercancel":
	        case "pointerdown":
	        case "pointerup":
	        case "ratechange":
	        case "reset":
	        case "resize":
	        case "seeked":
	        case "submit":
	        case "touchcancel":
	        case "touchend":
	        case "touchstart":
	        case "volumechange":
	        case "change":
	        case "selectionchange":
	        case "textInput":
	        case "compositionstart":
	        case "compositionend":
	        case "compositionupdate":
	        case "beforeblur":
	        case "afterblur":
	        case "beforeinput":
	        case "blur":
	        case "fullscreenchange":
	        case "focus":
	        case "hashchange":
	        case "popstate":
	        case "select":
	        case "selectstart":
	          return DiscreteEventPriority;
	        case "drag":
	        case "dragenter":
	        case "dragexit":
	        case "dragleave":
	        case "dragover":
	        case "mousemove":
	        case "mouseout":
	        case "mouseover":
	        case "pointermove":
	        case "pointerout":
	        case "pointerover":
	        case "scroll":
	        case "toggle":
	        case "touchmove":
	        case "wheel":
	        case "mouseenter":
	        case "mouseleave":
	        case "pointerenter":
	        case "pointerleave":
	          return ContinuousEventPriority;
	        case "message": {
	          var schedulerPriority = getCurrentPriorityLevel();
	          switch (schedulerPriority) {
	            case ImmediatePriority:
	              return DiscreteEventPriority;
	            case UserBlockingPriority:
	              return ContinuousEventPriority;
	            case NormalPriority:
	            case LowPriority:
	              return DefaultEventPriority;
	            case IdlePriority:
	              return IdleEventPriority;
	            default:
	              return DefaultEventPriority;
	          }
	        }
	        default:
	          return DefaultEventPriority;
	      }
	    }
	    function addEventBubbleListener(target, eventType, listener) {
	      target.addEventListener(eventType, listener, false);
	      return listener;
	    }
	    function addEventCaptureListener(target, eventType, listener) {
	      target.addEventListener(eventType, listener, true);
	      return listener;
	    }
	    function addEventCaptureListenerWithPassiveFlag(target, eventType, listener, passive) {
	      target.addEventListener(eventType, listener, {
	        capture: true,
	        passive
	      });
	      return listener;
	    }
	    function addEventBubbleListenerWithPassiveFlag(target, eventType, listener, passive) {
	      target.addEventListener(eventType, listener, {
	        passive
	      });
	      return listener;
	    }
	    var root = null;
	    var startText = null;
	    var fallbackText = null;
	    function initialize(nativeEventTarget) {
	      root = nativeEventTarget;
	      startText = getText();
	      return true;
	    }
	    function reset() {
	      root = null;
	      startText = null;
	      fallbackText = null;
	    }
	    function getData() {
	      if (fallbackText) {
	        return fallbackText;
	      }
	      var start;
	      var startValue = startText;
	      var startLength = startValue.length;
	      var end;
	      var endValue = getText();
	      var endLength = endValue.length;
	      for (start = 0; start < startLength; start++) {
	        if (startValue[start] !== endValue[start]) {
	          break;
	        }
	      }
	      var minEnd = startLength - start;
	      for (end = 1; end <= minEnd; end++) {
	        if (startValue[startLength - end] !== endValue[endLength - end]) {
	          break;
	        }
	      }
	      var sliceTail = end > 1 ? 1 - end : void 0;
	      fallbackText = endValue.slice(start, sliceTail);
	      return fallbackText;
	    }
	    function getText() {
	      if ("value" in root) {
	        return root.value;
	      }
	      return root.textContent;
	    }
	    function getEventCharCode(nativeEvent) {
	      var charCode;
	      var keyCode = nativeEvent.keyCode;
	      if ("charCode" in nativeEvent) {
	        charCode = nativeEvent.charCode;
	        if (charCode === 0 && keyCode === 13) {
	          charCode = 13;
	        }
	      } else {
	        charCode = keyCode;
	      }
	      if (charCode === 10) {
	        charCode = 13;
	      }
	      if (charCode >= 32 || charCode === 13) {
	        return charCode;
	      }
	      return 0;
	    }
	    function functionThatReturnsTrue() {
	      return true;
	    }
	    function functionThatReturnsFalse() {
	      return false;
	    }
	    function createSyntheticEvent(Interface) {
	      function SyntheticBaseEvent(reactName, reactEventType, targetInst, nativeEvent, nativeEventTarget) {
	        this._reactName = reactName;
	        this._targetInst = targetInst;
	        this.type = reactEventType;
	        this.nativeEvent = nativeEvent;
	        this.target = nativeEventTarget;
	        this.currentTarget = null;
	        for (var _propName in Interface) {
	          if (!Interface.hasOwnProperty(_propName)) {
	            continue;
	          }
	          var normalize = Interface[_propName];
	          if (normalize) {
	            this[_propName] = normalize(nativeEvent);
	          } else {
	            this[_propName] = nativeEvent[_propName];
	          }
	        }
	        var defaultPrevented = nativeEvent.defaultPrevented != null ? nativeEvent.defaultPrevented : nativeEvent.returnValue === false;
	        if (defaultPrevented) {
	          this.isDefaultPrevented = functionThatReturnsTrue;
	        } else {
	          this.isDefaultPrevented = functionThatReturnsFalse;
	        }
	        this.isPropagationStopped = functionThatReturnsFalse;
	        return this;
	      }
	      assign(SyntheticBaseEvent.prototype, {
	        preventDefault: function() {
	          this.defaultPrevented = true;
	          var event = this.nativeEvent;
	          if (!event) {
	            return;
	          }
	          if (event.preventDefault) {
	            event.preventDefault();
	          } else if (typeof event.returnValue !== "unknown") {
	            event.returnValue = false;
	          }
	          this.isDefaultPrevented = functionThatReturnsTrue;
	        },
	        stopPropagation: function() {
	          var event = this.nativeEvent;
	          if (!event) {
	            return;
	          }
	          if (event.stopPropagation) {
	            event.stopPropagation();
	          } else if (typeof event.cancelBubble !== "unknown") {
	            event.cancelBubble = true;
	          }
	          this.isPropagationStopped = functionThatReturnsTrue;
	        },
	        /**
	         * We release all dispatched `SyntheticEvent`s after each event loop, adding
	         * them back into the pool. This allows a way to hold onto a reference that
	         * won't be added back into the pool.
	         */
	        persist: function() {
	        },
	        /**
	         * Checks if this event should be released back into the pool.
	         *
	         * @return {boolean} True if this should not be released, false otherwise.
	         */
	        isPersistent: functionThatReturnsTrue
	      });
	      return SyntheticBaseEvent;
	    }
	    var EventInterface = {
	      eventPhase: 0,
	      bubbles: 0,
	      cancelable: 0,
	      timeStamp: function(event) {
	        return event.timeStamp || Date.now();
	      },
	      defaultPrevented: 0,
	      isTrusted: 0
	    };
	    var SyntheticEvent = createSyntheticEvent(EventInterface);
	    var UIEventInterface = assign({}, EventInterface, {
	      view: 0,
	      detail: 0
	    });
	    var SyntheticUIEvent = createSyntheticEvent(UIEventInterface);
	    var lastMovementX;
	    var lastMovementY;
	    var lastMouseEvent;
	    function updateMouseMovementPolyfillState(event) {
	      if (event !== lastMouseEvent) {
	        if (lastMouseEvent && event.type === "mousemove") {
	          lastMovementX = event.screenX - lastMouseEvent.screenX;
	          lastMovementY = event.screenY - lastMouseEvent.screenY;
	        } else {
	          lastMovementX = 0;
	          lastMovementY = 0;
	        }
	        lastMouseEvent = event;
	      }
	    }
	    var MouseEventInterface = assign({}, UIEventInterface, {
	      screenX: 0,
	      screenY: 0,
	      clientX: 0,
	      clientY: 0,
	      pageX: 0,
	      pageY: 0,
	      ctrlKey: 0,
	      shiftKey: 0,
	      altKey: 0,
	      metaKey: 0,
	      getModifierState: getEventModifierState,
	      button: 0,
	      buttons: 0,
	      relatedTarget: function(event) {
	        if (event.relatedTarget === void 0)
	          return event.fromElement === event.srcElement ? event.toElement : event.fromElement;
	        return event.relatedTarget;
	      },
	      movementX: function(event) {
	        if ("movementX" in event) {
	          return event.movementX;
	        }
	        updateMouseMovementPolyfillState(event);
	        return lastMovementX;
	      },
	      movementY: function(event) {
	        if ("movementY" in event) {
	          return event.movementY;
	        }
	        return lastMovementY;
	      }
	    });
	    var SyntheticMouseEvent = createSyntheticEvent(MouseEventInterface);
	    var DragEventInterface = assign({}, MouseEventInterface, {
	      dataTransfer: 0
	    });
	    var SyntheticDragEvent = createSyntheticEvent(DragEventInterface);
	    var FocusEventInterface = assign({}, UIEventInterface, {
	      relatedTarget: 0
	    });
	    var SyntheticFocusEvent = createSyntheticEvent(FocusEventInterface);
	    var AnimationEventInterface = assign({}, EventInterface, {
	      animationName: 0,
	      elapsedTime: 0,
	      pseudoElement: 0
	    });
	    var SyntheticAnimationEvent = createSyntheticEvent(AnimationEventInterface);
	    var ClipboardEventInterface = assign({}, EventInterface, {
	      clipboardData: function(event) {
	        return "clipboardData" in event ? event.clipboardData : window.clipboardData;
	      }
	    });
	    var SyntheticClipboardEvent = createSyntheticEvent(ClipboardEventInterface);
	    var CompositionEventInterface = assign({}, EventInterface, {
	      data: 0
	    });
	    var SyntheticCompositionEvent = createSyntheticEvent(CompositionEventInterface);
	    var SyntheticInputEvent = SyntheticCompositionEvent;
	    var normalizeKey = {
	      Esc: "Escape",
	      Spacebar: " ",
	      Left: "ArrowLeft",
	      Up: "ArrowUp",
	      Right: "ArrowRight",
	      Down: "ArrowDown",
	      Del: "Delete",
	      Win: "OS",
	      Menu: "ContextMenu",
	      Apps: "ContextMenu",
	      Scroll: "ScrollLock",
	      MozPrintableKey: "Unidentified"
	    };
	    var translateToKey = {
	      "8": "Backspace",
	      "9": "Tab",
	      "12": "Clear",
	      "13": "Enter",
	      "16": "Shift",
	      "17": "Control",
	      "18": "Alt",
	      "19": "Pause",
	      "20": "CapsLock",
	      "27": "Escape",
	      "32": " ",
	      "33": "PageUp",
	      "34": "PageDown",
	      "35": "End",
	      "36": "Home",
	      "37": "ArrowLeft",
	      "38": "ArrowUp",
	      "39": "ArrowRight",
	      "40": "ArrowDown",
	      "45": "Insert",
	      "46": "Delete",
	      "112": "F1",
	      "113": "F2",
	      "114": "F3",
	      "115": "F4",
	      "116": "F5",
	      "117": "F6",
	      "118": "F7",
	      "119": "F8",
	      "120": "F9",
	      "121": "F10",
	      "122": "F11",
	      "123": "F12",
	      "144": "NumLock",
	      "145": "ScrollLock",
	      "224": "Meta"
	    };
	    function getEventKey(nativeEvent) {
	      if (nativeEvent.key) {
	        var key = normalizeKey[nativeEvent.key] || nativeEvent.key;
	        if (key !== "Unidentified") {
	          return key;
	        }
	      }
	      if (nativeEvent.type === "keypress") {
	        var charCode = getEventCharCode(nativeEvent);
	        return charCode === 13 ? "Enter" : String.fromCharCode(charCode);
	      }
	      if (nativeEvent.type === "keydown" || nativeEvent.type === "keyup") {
	        return translateToKey[nativeEvent.keyCode] || "Unidentified";
	      }
	      return "";
	    }
	    var modifierKeyToProp = {
	      Alt: "altKey",
	      Control: "ctrlKey",
	      Meta: "metaKey",
	      Shift: "shiftKey"
	    };
	    function modifierStateGetter(keyArg) {
	      var syntheticEvent = this;
	      var nativeEvent = syntheticEvent.nativeEvent;
	      if (nativeEvent.getModifierState) {
	        return nativeEvent.getModifierState(keyArg);
	      }
	      var keyProp = modifierKeyToProp[keyArg];
	      return keyProp ? !!nativeEvent[keyProp] : false;
	    }
	    function getEventModifierState(nativeEvent) {
	      return modifierStateGetter;
	    }
	    var KeyboardEventInterface = assign({}, UIEventInterface, {
	      key: getEventKey,
	      code: 0,
	      location: 0,
	      ctrlKey: 0,
	      shiftKey: 0,
	      altKey: 0,
	      metaKey: 0,
	      repeat: 0,
	      locale: 0,
	      getModifierState: getEventModifierState,
	      // Legacy Interface
	      charCode: function(event) {
	        if (event.type === "keypress") {
	          return getEventCharCode(event);
	        }
	        return 0;
	      },
	      keyCode: function(event) {
	        if (event.type === "keydown" || event.type === "keyup") {
	          return event.keyCode;
	        }
	        return 0;
	      },
	      which: function(event) {
	        if (event.type === "keypress") {
	          return getEventCharCode(event);
	        }
	        if (event.type === "keydown" || event.type === "keyup") {
	          return event.keyCode;
	        }
	        return 0;
	      }
	    });
	    var SyntheticKeyboardEvent = createSyntheticEvent(KeyboardEventInterface);
	    var PointerEventInterface = assign({}, MouseEventInterface, {
	      pointerId: 0,
	      width: 0,
	      height: 0,
	      pressure: 0,
	      tangentialPressure: 0,
	      tiltX: 0,
	      tiltY: 0,
	      twist: 0,
	      pointerType: 0,
	      isPrimary: 0
	    });
	    var SyntheticPointerEvent = createSyntheticEvent(PointerEventInterface);
	    var TouchEventInterface = assign({}, UIEventInterface, {
	      touches: 0,
	      targetTouches: 0,
	      changedTouches: 0,
	      altKey: 0,
	      metaKey: 0,
	      ctrlKey: 0,
	      shiftKey: 0,
	      getModifierState: getEventModifierState
	    });
	    var SyntheticTouchEvent = createSyntheticEvent(TouchEventInterface);
	    var TransitionEventInterface = assign({}, EventInterface, {
	      propertyName: 0,
	      elapsedTime: 0,
	      pseudoElement: 0
	    });
	    var SyntheticTransitionEvent = createSyntheticEvent(TransitionEventInterface);
	    var WheelEventInterface = assign({}, MouseEventInterface, {
	      deltaX: function(event) {
	        return "deltaX" in event ? event.deltaX : (
	          // Fallback to `wheelDeltaX` for Webkit and normalize (right is positive).
	          "wheelDeltaX" in event ? -event.wheelDeltaX : 0
	        );
	      },
	      deltaY: function(event) {
	        return "deltaY" in event ? event.deltaY : (
	          // Fallback to `wheelDeltaY` for Webkit and normalize (down is positive).
	          "wheelDeltaY" in event ? -event.wheelDeltaY : (
	            // Fallback to `wheelDelta` for IE<9 and normalize (down is positive).
	            "wheelDelta" in event ? -event.wheelDelta : 0
	          )
	        );
	      },
	      deltaZ: 0,
	      // Browsers without "deltaMode" is reporting in raw wheel delta where one
	      // notch on the scroll is always +/- 120, roughly equivalent to pixels.
	      // A good approximation of DOM_DELTA_LINE (1) is 5% of viewport size or
	      // ~40 pixels, for DOM_DELTA_SCREEN (2) it is 87.5% of viewport size.
	      deltaMode: 0
	    });
	    var SyntheticWheelEvent = createSyntheticEvent(WheelEventInterface);
	    var END_KEYCODES = [9, 13, 27, 32];
	    var START_KEYCODE = 229;
	    var canUseCompositionEvent = canUseDOM && "CompositionEvent" in window;
	    var documentMode = null;
	    if (canUseDOM && "documentMode" in document) {
	      documentMode = document.documentMode;
	    }
	    var canUseTextInputEvent = canUseDOM && "TextEvent" in window && !documentMode;
	    var useFallbackCompositionData = canUseDOM && (!canUseCompositionEvent || documentMode && documentMode > 8 && documentMode <= 11);
	    var SPACEBAR_CODE = 32;
	    var SPACEBAR_CHAR = String.fromCharCode(SPACEBAR_CODE);
	    function registerEvents() {
	      registerTwoPhaseEvent("onBeforeInput", ["compositionend", "keypress", "textInput", "paste"]);
	      registerTwoPhaseEvent("onCompositionEnd", ["compositionend", "focusout", "keydown", "keypress", "keyup", "mousedown"]);
	      registerTwoPhaseEvent("onCompositionStart", ["compositionstart", "focusout", "keydown", "keypress", "keyup", "mousedown"]);
	      registerTwoPhaseEvent("onCompositionUpdate", ["compositionupdate", "focusout", "keydown", "keypress", "keyup", "mousedown"]);
	    }
	    var hasSpaceKeypress = false;
	    function isKeypressCommand(nativeEvent) {
	      return (nativeEvent.ctrlKey || nativeEvent.altKey || nativeEvent.metaKey) && // ctrlKey && altKey is equivalent to AltGr, and is not a command.
	      !(nativeEvent.ctrlKey && nativeEvent.altKey);
	    }
	    function getCompositionEventType(domEventName) {
	      switch (domEventName) {
	        case "compositionstart":
	          return "onCompositionStart";
	        case "compositionend":
	          return "onCompositionEnd";
	        case "compositionupdate":
	          return "onCompositionUpdate";
	      }
	    }
	    function isFallbackCompositionStart(domEventName, nativeEvent) {
	      return domEventName === "keydown" && nativeEvent.keyCode === START_KEYCODE;
	    }
	    function isFallbackCompositionEnd(domEventName, nativeEvent) {
	      switch (domEventName) {
	        case "keyup":
	          return END_KEYCODES.indexOf(nativeEvent.keyCode) !== -1;
	        case "keydown":
	          return nativeEvent.keyCode !== START_KEYCODE;
	        case "keypress":
	        case "mousedown":
	        case "focusout":
	          return true;
	        default:
	          return false;
	      }
	    }
	    function getDataFromCustomEvent(nativeEvent) {
	      var detail = nativeEvent.detail;
	      if (typeof detail === "object" && "data" in detail) {
	        return detail.data;
	      }
	      return null;
	    }
	    function isUsingKoreanIME(nativeEvent) {
	      return nativeEvent.locale === "ko";
	    }
	    var isComposing = false;
	    function extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
	      var eventType;
	      var fallbackData;
	      if (canUseCompositionEvent) {
	        eventType = getCompositionEventType(domEventName);
	      } else if (!isComposing) {
	        if (isFallbackCompositionStart(domEventName, nativeEvent)) {
	          eventType = "onCompositionStart";
	        }
	      } else if (isFallbackCompositionEnd(domEventName, nativeEvent)) {
	        eventType = "onCompositionEnd";
	      }
	      if (!eventType) {
	        return null;
	      }
	      if (useFallbackCompositionData && !isUsingKoreanIME(nativeEvent)) {
	        if (!isComposing && eventType === "onCompositionStart") {
	          isComposing = initialize(nativeEventTarget);
	        } else if (eventType === "onCompositionEnd") {
	          if (isComposing) {
	            fallbackData = getData();
	          }
	        }
	      }
	      var listeners = accumulateTwoPhaseListeners(targetInst, eventType);
	      if (listeners.length > 0) {
	        var event = new SyntheticCompositionEvent(eventType, domEventName, null, nativeEvent, nativeEventTarget);
	        dispatchQueue.push({
	          event,
	          listeners
	        });
	        if (fallbackData) {
	          event.data = fallbackData;
	        } else {
	          var customData = getDataFromCustomEvent(nativeEvent);
	          if (customData !== null) {
	            event.data = customData;
	          }
	        }
	      }
	    }
	    function getNativeBeforeInputChars(domEventName, nativeEvent) {
	      switch (domEventName) {
	        case "compositionend":
	          return getDataFromCustomEvent(nativeEvent);
	        case "keypress":
	          var which = nativeEvent.which;
	          if (which !== SPACEBAR_CODE) {
	            return null;
	          }
	          hasSpaceKeypress = true;
	          return SPACEBAR_CHAR;
	        case "textInput":
	          var chars = nativeEvent.data;
	          if (chars === SPACEBAR_CHAR && hasSpaceKeypress) {
	            return null;
	          }
	          return chars;
	        default:
	          return null;
	      }
	    }
	    function getFallbackBeforeInputChars(domEventName, nativeEvent) {
	      if (isComposing) {
	        if (domEventName === "compositionend" || !canUseCompositionEvent && isFallbackCompositionEnd(domEventName, nativeEvent)) {
	          var chars = getData();
	          reset();
	          isComposing = false;
	          return chars;
	        }
	        return null;
	      }
	      switch (domEventName) {
	        case "paste":
	          return null;
	        case "keypress":
	          if (!isKeypressCommand(nativeEvent)) {
	            if (nativeEvent.char && nativeEvent.char.length > 1) {
	              return nativeEvent.char;
	            } else if (nativeEvent.which) {
	              return String.fromCharCode(nativeEvent.which);
	            }
	          }
	          return null;
	        case "compositionend":
	          return useFallbackCompositionData && !isUsingKoreanIME(nativeEvent) ? null : nativeEvent.data;
	        default:
	          return null;
	      }
	    }
	    function extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
	      var chars;
	      if (canUseTextInputEvent) {
	        chars = getNativeBeforeInputChars(domEventName, nativeEvent);
	      } else {
	        chars = getFallbackBeforeInputChars(domEventName, nativeEvent);
	      }
	      if (!chars) {
	        return null;
	      }
	      var listeners = accumulateTwoPhaseListeners(targetInst, "onBeforeInput");
	      if (listeners.length > 0) {
	        var event = new SyntheticInputEvent("onBeforeInput", "beforeinput", null, nativeEvent, nativeEventTarget);
	        dispatchQueue.push({
	          event,
	          listeners
	        });
	        event.data = chars;
	      }
	    }
	    function extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	      extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	    }
	    var supportedInputTypes = {
	      color: true,
	      date: true,
	      datetime: true,
	      "datetime-local": true,
	      email: true,
	      month: true,
	      number: true,
	      password: true,
	      range: true,
	      search: true,
	      tel: true,
	      text: true,
	      time: true,
	      url: true,
	      week: true
	    };
	    function isTextInputElement(elem) {
	      var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();
	      if (nodeName === "input") {
	        return !!supportedInputTypes[elem.type];
	      }
	      if (nodeName === "textarea") {
	        return true;
	      }
	      return false;
	    }
	    /**
	     * Checks if an event is supported in the current execution environment.
	     *
	     * NOTE: This will not work correctly for non-generic events such as `change`,
	     * `reset`, `load`, `error`, and `select`.
	     *
	     * Borrows from Modernizr.
	     *
	     * @param {string} eventNameSuffix Event name, e.g. "click".
	     * @return {boolean} True if the event is supported.
	     * @internal
	     * @license Modernizr 3.0.0pre (Custom Build) | MIT
	     */
	    function isEventSupported(eventNameSuffix) {
	      if (!canUseDOM) {
	        return false;
	      }
	      var eventName = "on" + eventNameSuffix;
	      var isSupported = eventName in document;
	      if (!isSupported) {
	        var element = document.createElement("div");
	        element.setAttribute(eventName, "return;");
	        isSupported = typeof element[eventName] === "function";
	      }
	      return isSupported;
	    }
	    function registerEvents$1() {
	      registerTwoPhaseEvent("onChange", ["change", "click", "focusin", "focusout", "input", "keydown", "keyup", "selectionchange"]);
	    }
	    function createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, target) {
	      enqueueStateRestore(target);
	      var listeners = accumulateTwoPhaseListeners(inst, "onChange");
	      if (listeners.length > 0) {
	        var event = new SyntheticEvent("onChange", "change", null, nativeEvent, target);
	        dispatchQueue.push({
	          event,
	          listeners
	        });
	      }
	    }
	    var activeElement = null;
	    var activeElementInst = null;
	    function shouldUseChangeEvent(elem) {
	      var nodeName = elem.nodeName && elem.nodeName.toLowerCase();
	      return nodeName === "select" || nodeName === "input" && elem.type === "file";
	    }
	    function manualDispatchChangeEvent(nativeEvent) {
	      var dispatchQueue = [];
	      createAndAccumulateChangeEvent(dispatchQueue, activeElementInst, nativeEvent, getEventTarget(nativeEvent));
	      batchedUpdates(runEventInBatch, dispatchQueue);
	    }
	    function runEventInBatch(dispatchQueue) {
	      processDispatchQueue(dispatchQueue, 0);
	    }
	    function getInstIfValueChanged(targetInst) {
	      var targetNode = getNodeFromInstance(targetInst);
	      if (updateValueIfChanged(targetNode)) {
	        return targetInst;
	      }
	    }
	    function getTargetInstForChangeEvent(domEventName, targetInst) {
	      if (domEventName === "change") {
	        return targetInst;
	      }
	    }
	    var isInputEventSupported = false;
	    if (canUseDOM) {
	      isInputEventSupported = isEventSupported("input") && (!document.documentMode || document.documentMode > 9);
	    }
	    function startWatchingForValueChange(target, targetInst) {
	      activeElement = target;
	      activeElementInst = targetInst;
	      activeElement.attachEvent("onpropertychange", handlePropertyChange);
	    }
	    function stopWatchingForValueChange() {
	      if (!activeElement) {
	        return;
	      }
	      activeElement.detachEvent("onpropertychange", handlePropertyChange);
	      activeElement = null;
	      activeElementInst = null;
	    }
	    function handlePropertyChange(nativeEvent) {
	      if (nativeEvent.propertyName !== "value") {
	        return;
	      }
	      if (getInstIfValueChanged(activeElementInst)) {
	        manualDispatchChangeEvent(nativeEvent);
	      }
	    }
	    function handleEventsForInputEventPolyfill(domEventName, target, targetInst) {
	      if (domEventName === "focusin") {
	        stopWatchingForValueChange();
	        startWatchingForValueChange(target, targetInst);
	      } else if (domEventName === "focusout") {
	        stopWatchingForValueChange();
	      }
	    }
	    function getTargetInstForInputEventPolyfill(domEventName, targetInst) {
	      if (domEventName === "selectionchange" || domEventName === "keyup" || domEventName === "keydown") {
	        return getInstIfValueChanged(activeElementInst);
	      }
	    }
	    function shouldUseClickEvent(elem) {
	      var nodeName = elem.nodeName;
	      return nodeName && nodeName.toLowerCase() === "input" && (elem.type === "checkbox" || elem.type === "radio");
	    }
	    function getTargetInstForClickEvent(domEventName, targetInst) {
	      if (domEventName === "click") {
	        return getInstIfValueChanged(targetInst);
	      }
	    }
	    function getTargetInstForInputOrChangeEvent(domEventName, targetInst) {
	      if (domEventName === "input" || domEventName === "change") {
	        return getInstIfValueChanged(targetInst);
	      }
	    }
	    function handleControlledInputBlur(node) {
	      var state = node._wrapperState;
	      if (!state || !state.controlled || node.type !== "number") {
	        return;
	      }
	      {
	        setDefaultValue(node, "number", node.value);
	      }
	    }
	    function extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      var targetNode = targetInst ? getNodeFromInstance(targetInst) : window;
	      var getTargetInstFunc, handleEventFunc;
	      if (shouldUseChangeEvent(targetNode)) {
	        getTargetInstFunc = getTargetInstForChangeEvent;
	      } else if (isTextInputElement(targetNode)) {
	        if (isInputEventSupported) {
	          getTargetInstFunc = getTargetInstForInputOrChangeEvent;
	        } else {
	          getTargetInstFunc = getTargetInstForInputEventPolyfill;
	          handleEventFunc = handleEventsForInputEventPolyfill;
	        }
	      } else if (shouldUseClickEvent(targetNode)) {
	        getTargetInstFunc = getTargetInstForClickEvent;
	      }
	      if (getTargetInstFunc) {
	        var inst = getTargetInstFunc(domEventName, targetInst);
	        if (inst) {
	          createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, nativeEventTarget);
	          return;
	        }
	      }
	      if (handleEventFunc) {
	        handleEventFunc(domEventName, targetNode, targetInst);
	      }
	      if (domEventName === "focusout") {
	        handleControlledInputBlur(targetNode);
	      }
	    }
	    function registerEvents$2() {
	      registerDirectEvent("onMouseEnter", ["mouseout", "mouseover"]);
	      registerDirectEvent("onMouseLeave", ["mouseout", "mouseover"]);
	      registerDirectEvent("onPointerEnter", ["pointerout", "pointerover"]);
	      registerDirectEvent("onPointerLeave", ["pointerout", "pointerover"]);
	    }
	    function extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      var isOverEvent = domEventName === "mouseover" || domEventName === "pointerover";
	      var isOutEvent = domEventName === "mouseout" || domEventName === "pointerout";
	      if (isOverEvent && !isReplayingEvent(nativeEvent)) {
	        var related = nativeEvent.relatedTarget || nativeEvent.fromElement;
	        if (related) {
	          if (getClosestInstanceFromNode(related) || isContainerMarkedAsRoot(related)) {
	            return;
	          }
	        }
	      }
	      if (!isOutEvent && !isOverEvent) {
	        return;
	      }
	      var win;
	      if (nativeEventTarget.window === nativeEventTarget) {
	        win = nativeEventTarget;
	      } else {
	        var doc = nativeEventTarget.ownerDocument;
	        if (doc) {
	          win = doc.defaultView || doc.parentWindow;
	        } else {
	          win = window;
	        }
	      }
	      var from;
	      var to;
	      if (isOutEvent) {
	        var _related = nativeEvent.relatedTarget || nativeEvent.toElement;
	        from = targetInst;
	        to = _related ? getClosestInstanceFromNode(_related) : null;
	        if (to !== null) {
	          var nearestMounted = getNearestMountedFiber(to);
	          if (to !== nearestMounted || to.tag !== HostComponent && to.tag !== HostText) {
	            to = null;
	          }
	        }
	      } else {
	        from = null;
	        to = targetInst;
	      }
	      if (from === to) {
	        return;
	      }
	      var SyntheticEventCtor = SyntheticMouseEvent;
	      var leaveEventType = "onMouseLeave";
	      var enterEventType = "onMouseEnter";
	      var eventTypePrefix = "mouse";
	      if (domEventName === "pointerout" || domEventName === "pointerover") {
	        SyntheticEventCtor = SyntheticPointerEvent;
	        leaveEventType = "onPointerLeave";
	        enterEventType = "onPointerEnter";
	        eventTypePrefix = "pointer";
	      }
	      var fromNode = from == null ? win : getNodeFromInstance(from);
	      var toNode = to == null ? win : getNodeFromInstance(to);
	      var leave = new SyntheticEventCtor(leaveEventType, eventTypePrefix + "leave", from, nativeEvent, nativeEventTarget);
	      leave.target = fromNode;
	      leave.relatedTarget = toNode;
	      var enter = null;
	      var nativeTargetInst = getClosestInstanceFromNode(nativeEventTarget);
	      if (nativeTargetInst === targetInst) {
	        var enterEvent = new SyntheticEventCtor(enterEventType, eventTypePrefix + "enter", to, nativeEvent, nativeEventTarget);
	        enterEvent.target = toNode;
	        enterEvent.relatedTarget = fromNode;
	        enter = enterEvent;
	      }
	      accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leave, enter, from, to);
	    }
	    function is(x, y) {
	      return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
	    }
	    var objectIs = typeof Object.is === "function" ? Object.is : is;
	    function shallowEqual(objA, objB) {
	      if (objectIs(objA, objB)) {
	        return true;
	      }
	      if (typeof objA !== "object" || objA === null || typeof objB !== "object" || objB === null) {
	        return false;
	      }
	      var keysA = Object.keys(objA);
	      var keysB = Object.keys(objB);
	      if (keysA.length !== keysB.length) {
	        return false;
	      }
	      for (var i = 0; i < keysA.length; i++) {
	        var currentKey = keysA[i];
	        if (!hasOwnProperty.call(objB, currentKey) || !objectIs(objA[currentKey], objB[currentKey])) {
	          return false;
	        }
	      }
	      return true;
	    }
	    function getLeafNode(node) {
	      while (node && node.firstChild) {
	        node = node.firstChild;
	      }
	      return node;
	    }
	    function getSiblingNode(node) {
	      while (node) {
	        if (node.nextSibling) {
	          return node.nextSibling;
	        }
	        node = node.parentNode;
	      }
	    }
	    function getNodeForCharacterOffset(root2, offset) {
	      var node = getLeafNode(root2);
	      var nodeStart = 0;
	      var nodeEnd = 0;
	      while (node) {
	        if (node.nodeType === TEXT_NODE) {
	          nodeEnd = nodeStart + node.textContent.length;
	          if (nodeStart <= offset && nodeEnd >= offset) {
	            return {
	              node,
	              offset: offset - nodeStart
	            };
	          }
	          nodeStart = nodeEnd;
	        }
	        node = getLeafNode(getSiblingNode(node));
	      }
	    }
	    function getOffsets(outerNode) {
	      var ownerDocument = outerNode.ownerDocument;
	      var win = ownerDocument && ownerDocument.defaultView || window;
	      var selection = win.getSelection && win.getSelection();
	      if (!selection || selection.rangeCount === 0) {
	        return null;
	      }
	      var anchorNode = selection.anchorNode, anchorOffset = selection.anchorOffset, focusNode = selection.focusNode, focusOffset = selection.focusOffset;
	      try {
	        anchorNode.nodeType;
	        focusNode.nodeType;
	      } catch (e) {
	        return null;
	      }
	      return getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset);
	    }
	    function getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset) {
	      var length = 0;
	      var start = -1;
	      var end = -1;
	      var indexWithinAnchor = 0;
	      var indexWithinFocus = 0;
	      var node = outerNode;
	      var parentNode = null;
	      outer:
	        while (true) {
	          var next = null;
	          while (true) {
	            if (node === anchorNode && (anchorOffset === 0 || node.nodeType === TEXT_NODE)) {
	              start = length + anchorOffset;
	            }
	            if (node === focusNode && (focusOffset === 0 || node.nodeType === TEXT_NODE)) {
	              end = length + focusOffset;
	            }
	            if (node.nodeType === TEXT_NODE) {
	              length += node.nodeValue.length;
	            }
	            if ((next = node.firstChild) === null) {
	              break;
	            }
	            parentNode = node;
	            node = next;
	          }
	          while (true) {
	            if (node === outerNode) {
	              break outer;
	            }
	            if (parentNode === anchorNode && ++indexWithinAnchor === anchorOffset) {
	              start = length;
	            }
	            if (parentNode === focusNode && ++indexWithinFocus === focusOffset) {
	              end = length;
	            }
	            if ((next = node.nextSibling) !== null) {
	              break;
	            }
	            node = parentNode;
	            parentNode = node.parentNode;
	          }
	          node = next;
	        }
	      if (start === -1 || end === -1) {
	        return null;
	      }
	      return {
	        start,
	        end
	      };
	    }
	    function setOffsets(node, offsets) {
	      var doc = node.ownerDocument || document;
	      var win = doc && doc.defaultView || window;
	      if (!win.getSelection) {
	        return;
	      }
	      var selection = win.getSelection();
	      var length = node.textContent.length;
	      var start = Math.min(offsets.start, length);
	      var end = offsets.end === void 0 ? start : Math.min(offsets.end, length);
	      if (!selection.extend && start > end) {
	        var temp = end;
	        end = start;
	        start = temp;
	      }
	      var startMarker = getNodeForCharacterOffset(node, start);
	      var endMarker = getNodeForCharacterOffset(node, end);
	      if (startMarker && endMarker) {
	        if (selection.rangeCount === 1 && selection.anchorNode === startMarker.node && selection.anchorOffset === startMarker.offset && selection.focusNode === endMarker.node && selection.focusOffset === endMarker.offset) {
	          return;
	        }
	        var range = doc.createRange();
	        range.setStart(startMarker.node, startMarker.offset);
	        selection.removeAllRanges();
	        if (start > end) {
	          selection.addRange(range);
	          selection.extend(endMarker.node, endMarker.offset);
	        } else {
	          range.setEnd(endMarker.node, endMarker.offset);
	          selection.addRange(range);
	        }
	      }
	    }
	    function isTextNode(node) {
	      return node && node.nodeType === TEXT_NODE;
	    }
	    function containsNode(outerNode, innerNode) {
	      if (!outerNode || !innerNode) {
	        return false;
	      } else if (outerNode === innerNode) {
	        return true;
	      } else if (isTextNode(outerNode)) {
	        return false;
	      } else if (isTextNode(innerNode)) {
	        return containsNode(outerNode, innerNode.parentNode);
	      } else if ("contains" in outerNode) {
	        return outerNode.contains(innerNode);
	      } else if (outerNode.compareDocumentPosition) {
	        return !!(outerNode.compareDocumentPosition(innerNode) & 16);
	      } else {
	        return false;
	      }
	    }
	    function isInDocument(node) {
	      return node && node.ownerDocument && containsNode(node.ownerDocument.documentElement, node);
	    }
	    function isSameOriginFrame(iframe) {
	      try {
	        return typeof iframe.contentWindow.location.href === "string";
	      } catch (err) {
	        return false;
	      }
	    }
	    function getActiveElementDeep() {
	      var win = window;
	      var element = getActiveElement();
	      while (element instanceof win.HTMLIFrameElement) {
	        if (isSameOriginFrame(element)) {
	          win = element.contentWindow;
	        } else {
	          return element;
	        }
	        element = getActiveElement(win.document);
	      }
	      return element;
	    }
	    function hasSelectionCapabilities(elem) {
	      var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();
	      return nodeName && (nodeName === "input" && (elem.type === "text" || elem.type === "search" || elem.type === "tel" || elem.type === "url" || elem.type === "password") || nodeName === "textarea" || elem.contentEditable === "true");
	    }
	    function getSelectionInformation() {
	      var focusedElem = getActiveElementDeep();
	      return {
	        focusedElem,
	        selectionRange: hasSelectionCapabilities(focusedElem) ? getSelection(focusedElem) : null
	      };
	    }
	    function restoreSelection(priorSelectionInformation) {
	      var curFocusedElem = getActiveElementDeep();
	      var priorFocusedElem = priorSelectionInformation.focusedElem;
	      var priorSelectionRange = priorSelectionInformation.selectionRange;
	      if (curFocusedElem !== priorFocusedElem && isInDocument(priorFocusedElem)) {
	        if (priorSelectionRange !== null && hasSelectionCapabilities(priorFocusedElem)) {
	          setSelection(priorFocusedElem, priorSelectionRange);
	        }
	        var ancestors = [];
	        var ancestor = priorFocusedElem;
	        while (ancestor = ancestor.parentNode) {
	          if (ancestor.nodeType === ELEMENT_NODE) {
	            ancestors.push({
	              element: ancestor,
	              left: ancestor.scrollLeft,
	              top: ancestor.scrollTop
	            });
	          }
	        }
	        if (typeof priorFocusedElem.focus === "function") {
	          priorFocusedElem.focus();
	        }
	        for (var i = 0; i < ancestors.length; i++) {
	          var info = ancestors[i];
	          info.element.scrollLeft = info.left;
	          info.element.scrollTop = info.top;
	        }
	      }
	    }
	    function getSelection(input) {
	      var selection;
	      if ("selectionStart" in input) {
	        selection = {
	          start: input.selectionStart,
	          end: input.selectionEnd
	        };
	      } else {
	        selection = getOffsets(input);
	      }
	      return selection || {
	        start: 0,
	        end: 0
	      };
	    }
	    function setSelection(input, offsets) {
	      var start = offsets.start;
	      var end = offsets.end;
	      if (end === void 0) {
	        end = start;
	      }
	      if ("selectionStart" in input) {
	        input.selectionStart = start;
	        input.selectionEnd = Math.min(end, input.value.length);
	      } else {
	        setOffsets(input, offsets);
	      }
	    }
	    var skipSelectionChangeEvent = canUseDOM && "documentMode" in document && document.documentMode <= 11;
	    function registerEvents$3() {
	      registerTwoPhaseEvent("onSelect", ["focusout", "contextmenu", "dragend", "focusin", "keydown", "keyup", "mousedown", "mouseup", "selectionchange"]);
	    }
	    var activeElement$1 = null;
	    var activeElementInst$1 = null;
	    var lastSelection = null;
	    var mouseDown = false;
	    function getSelection$1(node) {
	      if ("selectionStart" in node && hasSelectionCapabilities(node)) {
	        return {
	          start: node.selectionStart,
	          end: node.selectionEnd
	        };
	      } else {
	        var win = node.ownerDocument && node.ownerDocument.defaultView || window;
	        var selection = win.getSelection();
	        return {
	          anchorNode: selection.anchorNode,
	          anchorOffset: selection.anchorOffset,
	          focusNode: selection.focusNode,
	          focusOffset: selection.focusOffset
	        };
	      }
	    }
	    function getEventTargetDocument(eventTarget) {
	      return eventTarget.window === eventTarget ? eventTarget.document : eventTarget.nodeType === DOCUMENT_NODE ? eventTarget : eventTarget.ownerDocument;
	    }
	    function constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget) {
	      var doc = getEventTargetDocument(nativeEventTarget);
	      if (mouseDown || activeElement$1 == null || activeElement$1 !== getActiveElement(doc)) {
	        return;
	      }
	      var currentSelection = getSelection$1(activeElement$1);
	      if (!lastSelection || !shallowEqual(lastSelection, currentSelection)) {
	        lastSelection = currentSelection;
	        var listeners = accumulateTwoPhaseListeners(activeElementInst$1, "onSelect");
	        if (listeners.length > 0) {
	          var event = new SyntheticEvent("onSelect", "select", null, nativeEvent, nativeEventTarget);
	          dispatchQueue.push({
	            event,
	            listeners
	          });
	          event.target = activeElement$1;
	        }
	      }
	    }
	    function extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      var targetNode = targetInst ? getNodeFromInstance(targetInst) : window;
	      switch (domEventName) {
	        case "focusin":
	          if (isTextInputElement(targetNode) || targetNode.contentEditable === "true") {
	            activeElement$1 = targetNode;
	            activeElementInst$1 = targetInst;
	            lastSelection = null;
	          }
	          break;
	        case "focusout":
	          activeElement$1 = null;
	          activeElementInst$1 = null;
	          lastSelection = null;
	          break;
	        case "mousedown":
	          mouseDown = true;
	          break;
	        case "contextmenu":
	        case "mouseup":
	        case "dragend":
	          mouseDown = false;
	          constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
	          break;
	        case "selectionchange":
	          if (skipSelectionChangeEvent) {
	            break;
	          }
	        case "keydown":
	        case "keyup":
	          constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
	      }
	    }
	    function makePrefixMap(styleProp, eventName) {
	      var prefixes2 = {};
	      prefixes2[styleProp.toLowerCase()] = eventName.toLowerCase();
	      prefixes2["Webkit" + styleProp] = "webkit" + eventName;
	      prefixes2["Moz" + styleProp] = "moz" + eventName;
	      return prefixes2;
	    }
	    var vendorPrefixes = {
	      animationend: makePrefixMap("Animation", "AnimationEnd"),
	      animationiteration: makePrefixMap("Animation", "AnimationIteration"),
	      animationstart: makePrefixMap("Animation", "AnimationStart"),
	      transitionend: makePrefixMap("Transition", "TransitionEnd")
	    };
	    var prefixedEventNames = {};
	    var style = {};
	    if (canUseDOM) {
	      style = document.createElement("div").style;
	      if (!("AnimationEvent" in window)) {
	        delete vendorPrefixes.animationend.animation;
	        delete vendorPrefixes.animationiteration.animation;
	        delete vendorPrefixes.animationstart.animation;
	      }
	      if (!("TransitionEvent" in window)) {
	        delete vendorPrefixes.transitionend.transition;
	      }
	    }
	    function getVendorPrefixedEventName(eventName) {
	      if (prefixedEventNames[eventName]) {
	        return prefixedEventNames[eventName];
	      } else if (!vendorPrefixes[eventName]) {
	        return eventName;
	      }
	      var prefixMap = vendorPrefixes[eventName];
	      for (var styleProp in prefixMap) {
	        if (prefixMap.hasOwnProperty(styleProp) && styleProp in style) {
	          return prefixedEventNames[eventName] = prefixMap[styleProp];
	        }
	      }
	      return eventName;
	    }
	    var ANIMATION_END = getVendorPrefixedEventName("animationend");
	    var ANIMATION_ITERATION = getVendorPrefixedEventName("animationiteration");
	    var ANIMATION_START = getVendorPrefixedEventName("animationstart");
	    var TRANSITION_END = getVendorPrefixedEventName("transitionend");
	    var topLevelEventsToReactNames = /* @__PURE__ */ new Map();
	    var simpleEventPluginEvents = ["abort", "auxClick", "cancel", "canPlay", "canPlayThrough", "click", "close", "contextMenu", "copy", "cut", "drag", "dragEnd", "dragEnter", "dragExit", "dragLeave", "dragOver", "dragStart", "drop", "durationChange", "emptied", "encrypted", "ended", "error", "gotPointerCapture", "input", "invalid", "keyDown", "keyPress", "keyUp", "load", "loadedData", "loadedMetadata", "loadStart", "lostPointerCapture", "mouseDown", "mouseMove", "mouseOut", "mouseOver", "mouseUp", "paste", "pause", "play", "playing", "pointerCancel", "pointerDown", "pointerMove", "pointerOut", "pointerOver", "pointerUp", "progress", "rateChange", "reset", "resize", "seeked", "seeking", "stalled", "submit", "suspend", "timeUpdate", "touchCancel", "touchEnd", "touchStart", "volumeChange", "scroll", "toggle", "touchMove", "waiting", "wheel"];
	    function registerSimpleEvent(domEventName, reactName) {
	      topLevelEventsToReactNames.set(domEventName, reactName);
	      registerTwoPhaseEvent(reactName, [domEventName]);
	    }
	    function registerSimpleEvents() {
	      for (var i = 0; i < simpleEventPluginEvents.length; i++) {
	        var eventName = simpleEventPluginEvents[i];
	        var domEventName = eventName.toLowerCase();
	        var capitalizedEvent = eventName[0].toUpperCase() + eventName.slice(1);
	        registerSimpleEvent(domEventName, "on" + capitalizedEvent);
	      }
	      registerSimpleEvent(ANIMATION_END, "onAnimationEnd");
	      registerSimpleEvent(ANIMATION_ITERATION, "onAnimationIteration");
	      registerSimpleEvent(ANIMATION_START, "onAnimationStart");
	      registerSimpleEvent("dblclick", "onDoubleClick");
	      registerSimpleEvent("focusin", "onFocus");
	      registerSimpleEvent("focusout", "onBlur");
	      registerSimpleEvent(TRANSITION_END, "onTransitionEnd");
	    }
	    function extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      var reactName = topLevelEventsToReactNames.get(domEventName);
	      if (reactName === void 0) {
	        return;
	      }
	      var SyntheticEventCtor = SyntheticEvent;
	      var reactEventType = domEventName;
	      switch (domEventName) {
	        case "keypress":
	          if (getEventCharCode(nativeEvent) === 0) {
	            return;
	          }
	        case "keydown":
	        case "keyup":
	          SyntheticEventCtor = SyntheticKeyboardEvent;
	          break;
	        case "focusin":
	          reactEventType = "focus";
	          SyntheticEventCtor = SyntheticFocusEvent;
	          break;
	        case "focusout":
	          reactEventType = "blur";
	          SyntheticEventCtor = SyntheticFocusEvent;
	          break;
	        case "beforeblur":
	        case "afterblur":
	          SyntheticEventCtor = SyntheticFocusEvent;
	          break;
	        case "click":
	          if (nativeEvent.button === 2) {
	            return;
	          }
	        case "auxclick":
	        case "dblclick":
	        case "mousedown":
	        case "mousemove":
	        case "mouseup":
	        case "mouseout":
	        case "mouseover":
	        case "contextmenu":
	          SyntheticEventCtor = SyntheticMouseEvent;
	          break;
	        case "drag":
	        case "dragend":
	        case "dragenter":
	        case "dragexit":
	        case "dragleave":
	        case "dragover":
	        case "dragstart":
	        case "drop":
	          SyntheticEventCtor = SyntheticDragEvent;
	          break;
	        case "touchcancel":
	        case "touchend":
	        case "touchmove":
	        case "touchstart":
	          SyntheticEventCtor = SyntheticTouchEvent;
	          break;
	        case ANIMATION_END:
	        case ANIMATION_ITERATION:
	        case ANIMATION_START:
	          SyntheticEventCtor = SyntheticAnimationEvent;
	          break;
	        case TRANSITION_END:
	          SyntheticEventCtor = SyntheticTransitionEvent;
	          break;
	        case "scroll":
	          SyntheticEventCtor = SyntheticUIEvent;
	          break;
	        case "wheel":
	          SyntheticEventCtor = SyntheticWheelEvent;
	          break;
	        case "copy":
	        case "cut":
	        case "paste":
	          SyntheticEventCtor = SyntheticClipboardEvent;
	          break;
	        case "gotpointercapture":
	        case "lostpointercapture":
	        case "pointercancel":
	        case "pointerdown":
	        case "pointermove":
	        case "pointerout":
	        case "pointerover":
	        case "pointerup":
	          SyntheticEventCtor = SyntheticPointerEvent;
	          break;
	      }
	      var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0;
	      {
	        var accumulateTargetOnly = !inCapturePhase && // TODO: ideally, we'd eventually add all events from
	        // nonDelegatedEvents list in DOMPluginEventSystem.
	        // Then we can remove this special list.
	        // This is a breaking change that can wait until React 18.
	        domEventName === "scroll";
	        var _listeners = accumulateSinglePhaseListeners(targetInst, reactName, nativeEvent.type, inCapturePhase, accumulateTargetOnly);
	        if (_listeners.length > 0) {
	          var _event = new SyntheticEventCtor(reactName, reactEventType, null, nativeEvent, nativeEventTarget);
	          dispatchQueue.push({
	            event: _event,
	            listeners: _listeners
	          });
	        }
	      }
	    }
	    registerSimpleEvents();
	    registerEvents$2();
	    registerEvents$1();
	    registerEvents$3();
	    registerEvents();
	    function extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
	      extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
	      var shouldProcessPolyfillPlugins = (eventSystemFlags & SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS) === 0;
	      if (shouldProcessPolyfillPlugins) {
	        extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	        extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	        extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	        extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
	      }
	    }
	    var mediaEventTypes = ["abort", "canplay", "canplaythrough", "durationchange", "emptied", "encrypted", "ended", "error", "loadeddata", "loadedmetadata", "loadstart", "pause", "play", "playing", "progress", "ratechange", "resize", "seeked", "seeking", "stalled", "suspend", "timeupdate", "volumechange", "waiting"];
	    var nonDelegatedEvents = new Set(["cancel", "close", "invalid", "load", "scroll", "toggle"].concat(mediaEventTypes));
	    function executeDispatch(event, listener, currentTarget) {
	      var type = event.type || "unknown-event";
	      event.currentTarget = currentTarget;
	      invokeGuardedCallbackAndCatchFirstError(type, listener, void 0, event);
	      event.currentTarget = null;
	    }
	    function processDispatchQueueItemsInOrder(event, dispatchListeners, inCapturePhase) {
	      var previousInstance;
	      if (inCapturePhase) {
	        for (var i = dispatchListeners.length - 1; i >= 0; i--) {
	          var _dispatchListeners$i = dispatchListeners[i], instance = _dispatchListeners$i.instance, currentTarget = _dispatchListeners$i.currentTarget, listener = _dispatchListeners$i.listener;
	          if (instance !== previousInstance && event.isPropagationStopped()) {
	            return;
	          }
	          executeDispatch(event, listener, currentTarget);
	          previousInstance = instance;
	        }
	      } else {
	        for (var _i = 0; _i < dispatchListeners.length; _i++) {
	          var _dispatchListeners$_i = dispatchListeners[_i], _instance = _dispatchListeners$_i.instance, _currentTarget = _dispatchListeners$_i.currentTarget, _listener = _dispatchListeners$_i.listener;
	          if (_instance !== previousInstance && event.isPropagationStopped()) {
	            return;
	          }
	          executeDispatch(event, _listener, _currentTarget);
	          previousInstance = _instance;
	        }
	      }
	    }
	    function processDispatchQueue(dispatchQueue, eventSystemFlags) {
	      var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0;
	      for (var i = 0; i < dispatchQueue.length; i++) {
	        var _dispatchQueue$i = dispatchQueue[i], event = _dispatchQueue$i.event, listeners = _dispatchQueue$i.listeners;
	        processDispatchQueueItemsInOrder(event, listeners, inCapturePhase);
	      }
	      rethrowCaughtError();
	    }
	    function dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
	      var nativeEventTarget = getEventTarget(nativeEvent);
	      var dispatchQueue = [];
	      extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
	      processDispatchQueue(dispatchQueue, eventSystemFlags);
	    }
	    function listenToNonDelegatedEvent(domEventName, targetElement) {
	      {
	        if (!nonDelegatedEvents.has(domEventName)) {
	          error('Did not expect a listenToNonDelegatedEvent() call for "%s". This is a bug in React. Please file an issue.', domEventName);
	        }
	      }
	      var isCapturePhaseListener = false;
	      var listenerSet = getEventListenerSet(targetElement);
	      var listenerSetKey = getListenerSetKey(domEventName, isCapturePhaseListener);
	      if (!listenerSet.has(listenerSetKey)) {
	        addTrappedEventListener(targetElement, domEventName, IS_NON_DELEGATED, isCapturePhaseListener);
	        listenerSet.add(listenerSetKey);
	      }
	    }
	    function listenToNativeEvent(domEventName, isCapturePhaseListener, target) {
	      {
	        if (nonDelegatedEvents.has(domEventName) && !isCapturePhaseListener) {
	          error('Did not expect a listenToNativeEvent() call for "%s" in the bubble phase. This is a bug in React. Please file an issue.', domEventName);
	        }
	      }
	      var eventSystemFlags = 0;
	      if (isCapturePhaseListener) {
	        eventSystemFlags |= IS_CAPTURE_PHASE;
	      }
	      addTrappedEventListener(target, domEventName, eventSystemFlags, isCapturePhaseListener);
	    }
	    var listeningMarker = "_reactListening" + Math.random().toString(36).slice(2);
	    function listenToAllSupportedEvents(rootContainerElement) {
	      if (!rootContainerElement[listeningMarker]) {
	        rootContainerElement[listeningMarker] = true;
	        allNativeEvents.forEach(function(domEventName) {
	          if (domEventName !== "selectionchange") {
	            if (!nonDelegatedEvents.has(domEventName)) {
	              listenToNativeEvent(domEventName, false, rootContainerElement);
	            }
	            listenToNativeEvent(domEventName, true, rootContainerElement);
	          }
	        });
	        var ownerDocument = rootContainerElement.nodeType === DOCUMENT_NODE ? rootContainerElement : rootContainerElement.ownerDocument;
	        if (ownerDocument !== null) {
	          if (!ownerDocument[listeningMarker]) {
	            ownerDocument[listeningMarker] = true;
	            listenToNativeEvent("selectionchange", false, ownerDocument);
	          }
	        }
	      }
	    }
	    function addTrappedEventListener(targetContainer, domEventName, eventSystemFlags, isCapturePhaseListener, isDeferredListenerForLegacyFBSupport) {
	      var listener = createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags);
	      var isPassiveListener = void 0;
	      if (passiveBrowserEventsSupported) {
	        if (domEventName === "touchstart" || domEventName === "touchmove" || domEventName === "wheel") {
	          isPassiveListener = true;
	        }
	      }
	      targetContainer = targetContainer;
	      if (isCapturePhaseListener) {
	        if (isPassiveListener !== void 0) {
	          addEventCaptureListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener);
	        } else {
	          addEventCaptureListener(targetContainer, domEventName, listener);
	        }
	      } else {
	        if (isPassiveListener !== void 0) {
	          addEventBubbleListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener);
	        } else {
	          addEventBubbleListener(targetContainer, domEventName, listener);
	        }
	      }
	    }
	    function isMatchingRootContainer(grandContainer, targetContainer) {
	      return grandContainer === targetContainer || grandContainer.nodeType === COMMENT_NODE && grandContainer.parentNode === targetContainer;
	    }
	    function dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
	      var ancestorInst = targetInst;
	      if ((eventSystemFlags & IS_EVENT_HANDLE_NON_MANAGED_NODE) === 0 && (eventSystemFlags & IS_NON_DELEGATED) === 0) {
	        var targetContainerNode = targetContainer;
	        if (targetInst !== null) {
	          var node = targetInst;
	          mainLoop:
	            while (true) {
	              if (node === null) {
	                return;
	              }
	              var nodeTag = node.tag;
	              if (nodeTag === HostRoot || nodeTag === HostPortal) {
	                var container = node.stateNode.containerInfo;
	                if (isMatchingRootContainer(container, targetContainerNode)) {
	                  break;
	                }
	                if (nodeTag === HostPortal) {
	                  var grandNode = node.return;
	                  while (grandNode !== null) {
	                    var grandTag = grandNode.tag;
	                    if (grandTag === HostRoot || grandTag === HostPortal) {
	                      var grandContainer = grandNode.stateNode.containerInfo;
	                      if (isMatchingRootContainer(grandContainer, targetContainerNode)) {
	                        return;
	                      }
	                    }
	                    grandNode = grandNode.return;
	                  }
	                }
	                while (container !== null) {
	                  var parentNode = getClosestInstanceFromNode(container);
	                  if (parentNode === null) {
	                    return;
	                  }
	                  var parentTag = parentNode.tag;
	                  if (parentTag === HostComponent || parentTag === HostText) {
	                    node = ancestorInst = parentNode;
	                    continue mainLoop;
	                  }
	                  container = container.parentNode;
	                }
	              }
	              node = node.return;
	            }
	        }
	      }
	      batchedUpdates(function() {
	        return dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, ancestorInst);
	      });
	    }
	    function createDispatchListener(instance, listener, currentTarget) {
	      return {
	        instance,
	        listener,
	        currentTarget
	      };
	    }
	    function accumulateSinglePhaseListeners(targetFiber, reactName, nativeEventType, inCapturePhase, accumulateTargetOnly, nativeEvent) {
	      var captureName = reactName !== null ? reactName + "Capture" : null;
	      var reactEventName = inCapturePhase ? captureName : reactName;
	      var listeners = [];
	      var instance = targetFiber;
	      var lastHostComponent = null;
	      while (instance !== null) {
	        var _instance2 = instance, stateNode = _instance2.stateNode, tag = _instance2.tag;
	        if (tag === HostComponent && stateNode !== null) {
	          lastHostComponent = stateNode;
	          if (reactEventName !== null) {
	            var listener = getListener(instance, reactEventName);
	            if (listener != null) {
	              listeners.push(createDispatchListener(instance, listener, lastHostComponent));
	            }
	          }
	        }
	        if (accumulateTargetOnly) {
	          break;
	        }
	        instance = instance.return;
	      }
	      return listeners;
	    }
	    function accumulateTwoPhaseListeners(targetFiber, reactName) {
	      var captureName = reactName + "Capture";
	      var listeners = [];
	      var instance = targetFiber;
	      while (instance !== null) {
	        var _instance3 = instance, stateNode = _instance3.stateNode, tag = _instance3.tag;
	        if (tag === HostComponent && stateNode !== null) {
	          var currentTarget = stateNode;
	          var captureListener = getListener(instance, captureName);
	          if (captureListener != null) {
	            listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
	          }
	          var bubbleListener = getListener(instance, reactName);
	          if (bubbleListener != null) {
	            listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
	          }
	        }
	        instance = instance.return;
	      }
	      return listeners;
	    }
	    function getParent(inst) {
	      if (inst === null) {
	        return null;
	      }
	      do {
	        inst = inst.return;
	      } while (inst && inst.tag !== HostComponent);
	      if (inst) {
	        return inst;
	      }
	      return null;
	    }
	    function getLowestCommonAncestor(instA, instB) {
	      var nodeA = instA;
	      var nodeB = instB;
	      var depthA = 0;
	      for (var tempA = nodeA; tempA; tempA = getParent(tempA)) {
	        depthA++;
	      }
	      var depthB = 0;
	      for (var tempB = nodeB; tempB; tempB = getParent(tempB)) {
	        depthB++;
	      }
	      while (depthA - depthB > 0) {
	        nodeA = getParent(nodeA);
	        depthA--;
	      }
	      while (depthB - depthA > 0) {
	        nodeB = getParent(nodeB);
	        depthB--;
	      }
	      var depth = depthA;
	      while (depth--) {
	        if (nodeA === nodeB || nodeB !== null && nodeA === nodeB.alternate) {
	          return nodeA;
	        }
	        nodeA = getParent(nodeA);
	        nodeB = getParent(nodeB);
	      }
	      return null;
	    }
	    function accumulateEnterLeaveListenersForEvent(dispatchQueue, event, target, common, inCapturePhase) {
	      var registrationName = event._reactName;
	      var listeners = [];
	      var instance = target;
	      while (instance !== null) {
	        if (instance === common) {
	          break;
	        }
	        var _instance4 = instance, alternate = _instance4.alternate, stateNode = _instance4.stateNode, tag = _instance4.tag;
	        if (alternate !== null && alternate === common) {
	          break;
	        }
	        if (tag === HostComponent && stateNode !== null) {
	          var currentTarget = stateNode;
	          if (inCapturePhase) {
	            var captureListener = getListener(instance, registrationName);
	            if (captureListener != null) {
	              listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
	            }
	          } else if (!inCapturePhase) {
	            var bubbleListener = getListener(instance, registrationName);
	            if (bubbleListener != null) {
	              listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
	            }
	          }
	        }
	        instance = instance.return;
	      }
	      if (listeners.length !== 0) {
	        dispatchQueue.push({
	          event,
	          listeners
	        });
	      }
	    }
	    function accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leaveEvent, enterEvent, from, to) {
	      var common = from && to ? getLowestCommonAncestor(from, to) : null;
	      if (from !== null) {
	        accumulateEnterLeaveListenersForEvent(dispatchQueue, leaveEvent, from, common, false);
	      }
	      if (to !== null && enterEvent !== null) {
	        accumulateEnterLeaveListenersForEvent(dispatchQueue, enterEvent, to, common, true);
	      }
	    }
	    function getListenerSetKey(domEventName, capture) {
	      return domEventName + "__" + (capture ? "capture" : "bubble");
	    }
	    var didWarnInvalidHydration = false;
	    var DANGEROUSLY_SET_INNER_HTML = "dangerouslySetInnerHTML";
	    var SUPPRESS_CONTENT_EDITABLE_WARNING = "suppressContentEditableWarning";
	    var SUPPRESS_HYDRATION_WARNING = "suppressHydrationWarning";
	    var AUTOFOCUS = "autoFocus";
	    var CHILDREN = "children";
	    var STYLE = "style";
	    var HTML$1 = "__html";
	    var warnedUnknownTags;
	    var validatePropertiesInDevelopment;
	    var warnForPropDifference;
	    var warnForExtraAttributes;
	    var warnForInvalidEventListener;
	    var canDiffStyleForHydrationWarning;
	    var normalizeHTML;
	    {
	      warnedUnknownTags = {
	        // There are working polyfills for <dialog>. Let people use it.
	        dialog: true,
	        // Electron ships a custom <webview> tag to display external web content in
	        // an isolated frame and process.
	        // This tag is not present in non Electron environments such as JSDom which
	        // is often used for testing purposes.
	        // @see https://electronjs.org/docs/api/webview-tag
	        webview: true
	      };
	      validatePropertiesInDevelopment = function(type, props) {
	        validateProperties(type, props);
	        validateProperties$1(type, props);
	        validateProperties$2(type, props, {
	          registrationNameDependencies,
	          possibleRegistrationNames
	        });
	      };
	      canDiffStyleForHydrationWarning = canUseDOM && !document.documentMode;
	      warnForPropDifference = function(propName, serverValue, clientValue) {
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        var normalizedClientValue = normalizeMarkupForTextOrAttribute(clientValue);
	        var normalizedServerValue = normalizeMarkupForTextOrAttribute(serverValue);
	        if (normalizedServerValue === normalizedClientValue) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        error("Prop `%s` did not match. Server: %s Client: %s", propName, JSON.stringify(normalizedServerValue), JSON.stringify(normalizedClientValue));
	      };
	      warnForExtraAttributes = function(attributeNames) {
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        var names = [];
	        attributeNames.forEach(function(name) {
	          names.push(name);
	        });
	        error("Extra attributes from the server: %s", names);
	      };
	      warnForInvalidEventListener = function(registrationName, listener) {
	        if (listener === false) {
	          error("Expected `%s` listener to be a function, instead got `false`.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.", registrationName, registrationName, registrationName);
	        } else {
	          error("Expected `%s` listener to be a function, instead got a value of `%s` type.", registrationName, typeof listener);
	        }
	      };
	      normalizeHTML = function(parent, html) {
	        var testElement = parent.namespaceURI === HTML_NAMESPACE ? parent.ownerDocument.createElement(parent.tagName) : parent.ownerDocument.createElementNS(parent.namespaceURI, parent.tagName);
	        testElement.innerHTML = html;
	        return testElement.innerHTML;
	      };
	    }
	    var NORMALIZE_NEWLINES_REGEX = /\r\n?/g;
	    var NORMALIZE_NULL_AND_REPLACEMENT_REGEX = /\u0000|\uFFFD/g;
	    function normalizeMarkupForTextOrAttribute(markup) {
	      {
	        checkHtmlStringCoercion(markup);
	      }
	      var markupString = typeof markup === "string" ? markup : "" + markup;
	      return markupString.replace(NORMALIZE_NEWLINES_REGEX, "\n").replace(NORMALIZE_NULL_AND_REPLACEMENT_REGEX, "");
	    }
	    function checkForUnmatchedText(serverText, clientText, isConcurrentMode, shouldWarnDev) {
	      var normalizedClientText = normalizeMarkupForTextOrAttribute(clientText);
	      var normalizedServerText = normalizeMarkupForTextOrAttribute(serverText);
	      if (normalizedServerText === normalizedClientText) {
	        return;
	      }
	      if (shouldWarnDev) {
	        {
	          if (!didWarnInvalidHydration) {
	            didWarnInvalidHydration = true;
	            error('Text content did not match. Server: "%s" Client: "%s"', normalizedServerText, normalizedClientText);
	          }
	        }
	      }
	      if (isConcurrentMode && enableClientRenderFallbackOnTextMismatch) {
	        throw new Error("Text content does not match server-rendered HTML.");
	      }
	    }
	    function getOwnerDocumentFromRootContainer(rootContainerElement) {
	      return rootContainerElement.nodeType === DOCUMENT_NODE ? rootContainerElement : rootContainerElement.ownerDocument;
	    }
	    function noop() {
	    }
	    function trapClickOnNonInteractiveElement(node) {
	      node.onclick = noop;
	    }
	    function setInitialDOMProperties(tag, domElement, rootContainerElement, nextProps, isCustomComponentTag) {
	      for (var propKey in nextProps) {
	        if (!nextProps.hasOwnProperty(propKey)) {
	          continue;
	        }
	        var nextProp = nextProps[propKey];
	        if (propKey === STYLE) {
	          {
	            if (nextProp) {
	              Object.freeze(nextProp);
	            }
	          }
	          setValueForStyles(domElement, nextProp);
	        } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
	          var nextHtml = nextProp ? nextProp[HTML$1] : void 0;
	          if (nextHtml != null) {
	            setInnerHTML(domElement, nextHtml);
	          }
	        } else if (propKey === CHILDREN) {
	          if (typeof nextProp === "string") {
	            var canSetTextContent = tag !== "textarea" || nextProp !== "";
	            if (canSetTextContent) {
	              setTextContent(domElement, nextProp);
	            }
	          } else if (typeof nextProp === "number") {
	            setTextContent(domElement, "" + nextProp);
	          }
	        } else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING)
	          ;
	        else if (propKey === AUTOFOCUS)
	          ;
	        else if (registrationNameDependencies.hasOwnProperty(propKey)) {
	          if (nextProp != null) {
	            if (typeof nextProp !== "function") {
	              warnForInvalidEventListener(propKey, nextProp);
	            }
	            if (propKey === "onScroll") {
	              listenToNonDelegatedEvent("scroll", domElement);
	            }
	          }
	        } else if (nextProp != null) {
	          setValueForProperty(domElement, propKey, nextProp, isCustomComponentTag);
	        }
	      }
	    }
	    function updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag) {
	      for (var i = 0; i < updatePayload.length; i += 2) {
	        var propKey = updatePayload[i];
	        var propValue = updatePayload[i + 1];
	        if (propKey === STYLE) {
	          setValueForStyles(domElement, propValue);
	        } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
	          setInnerHTML(domElement, propValue);
	        } else if (propKey === CHILDREN) {
	          setTextContent(domElement, propValue);
	        } else {
	          setValueForProperty(domElement, propKey, propValue, isCustomComponentTag);
	        }
	      }
	    }
	    function createElement(type, props, rootContainerElement, parentNamespace) {
	      var isCustomComponentTag;
	      var ownerDocument = getOwnerDocumentFromRootContainer(rootContainerElement);
	      var domElement;
	      var namespaceURI = parentNamespace;
	      if (namespaceURI === HTML_NAMESPACE) {
	        namespaceURI = getIntrinsicNamespace(type);
	      }
	      if (namespaceURI === HTML_NAMESPACE) {
	        {
	          isCustomComponentTag = isCustomComponent(type, props);
	          if (!isCustomComponentTag && type !== type.toLowerCase()) {
	            error("<%s /> is using incorrect casing. Use PascalCase for React components, or lowercase for HTML elements.", type);
	          }
	        }
	        if (type === "script") {
	          var div = ownerDocument.createElement("div");
	          div.innerHTML = "<script></script>";
	          var firstChild = div.firstChild;
	          domElement = div.removeChild(firstChild);
	        } else if (typeof props.is === "string") {
	          domElement = ownerDocument.createElement(type, {
	            is: props.is
	          });
	        } else {
	          domElement = ownerDocument.createElement(type);
	          if (type === "select") {
	            var node = domElement;
	            if (props.multiple) {
	              node.multiple = true;
	            } else if (props.size) {
	              node.size = props.size;
	            }
	          }
	        }
	      } else {
	        domElement = ownerDocument.createElementNS(namespaceURI, type);
	      }
	      {
	        if (namespaceURI === HTML_NAMESPACE) {
	          if (!isCustomComponentTag && Object.prototype.toString.call(domElement) === "[object HTMLUnknownElement]" && !hasOwnProperty.call(warnedUnknownTags, type)) {
	            warnedUnknownTags[type] = true;
	            error("The tag <%s> is unrecognized in this browser. If you meant to render a React component, start its name with an uppercase letter.", type);
	          }
	        }
	      }
	      return domElement;
	    }
	    function createTextNode(text, rootContainerElement) {
	      return getOwnerDocumentFromRootContainer(rootContainerElement).createTextNode(text);
	    }
	    function setInitialProperties(domElement, tag, rawProps, rootContainerElement) {
	      var isCustomComponentTag = isCustomComponent(tag, rawProps);
	      {
	        validatePropertiesInDevelopment(tag, rawProps);
	      }
	      var props;
	      switch (tag) {
	        case "dialog":
	          listenToNonDelegatedEvent("cancel", domElement);
	          listenToNonDelegatedEvent("close", domElement);
	          props = rawProps;
	          break;
	        case "iframe":
	        case "object":
	        case "embed":
	          listenToNonDelegatedEvent("load", domElement);
	          props = rawProps;
	          break;
	        case "video":
	        case "audio":
	          for (var i = 0; i < mediaEventTypes.length; i++) {
	            listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
	          }
	          props = rawProps;
	          break;
	        case "source":
	          listenToNonDelegatedEvent("error", domElement);
	          props = rawProps;
	          break;
	        case "img":
	        case "image":
	        case "link":
	          listenToNonDelegatedEvent("error", domElement);
	          listenToNonDelegatedEvent("load", domElement);
	          props = rawProps;
	          break;
	        case "details":
	          listenToNonDelegatedEvent("toggle", domElement);
	          props = rawProps;
	          break;
	        case "input":
	          initWrapperState(domElement, rawProps);
	          props = getHostProps(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	        case "option":
	          validateProps(domElement, rawProps);
	          props = rawProps;
	          break;
	        case "select":
	          initWrapperState$1(domElement, rawProps);
	          props = getHostProps$1(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	        case "textarea":
	          initWrapperState$2(domElement, rawProps);
	          props = getHostProps$2(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	        default:
	          props = rawProps;
	      }
	      assertValidProps(tag, props);
	      setInitialDOMProperties(tag, domElement, rootContainerElement, props, isCustomComponentTag);
	      switch (tag) {
	        case "input":
	          track(domElement);
	          postMountWrapper(domElement, rawProps, false);
	          break;
	        case "textarea":
	          track(domElement);
	          postMountWrapper$3(domElement);
	          break;
	        case "option":
	          postMountWrapper$1(domElement, rawProps);
	          break;
	        case "select":
	          postMountWrapper$2(domElement, rawProps);
	          break;
	        default:
	          if (typeof props.onClick === "function") {
	            trapClickOnNonInteractiveElement(domElement);
	          }
	          break;
	      }
	    }
	    function diffProperties(domElement, tag, lastRawProps, nextRawProps, rootContainerElement) {
	      {
	        validatePropertiesInDevelopment(tag, nextRawProps);
	      }
	      var updatePayload = null;
	      var lastProps;
	      var nextProps;
	      switch (tag) {
	        case "input":
	          lastProps = getHostProps(domElement, lastRawProps);
	          nextProps = getHostProps(domElement, nextRawProps);
	          updatePayload = [];
	          break;
	        case "select":
	          lastProps = getHostProps$1(domElement, lastRawProps);
	          nextProps = getHostProps$1(domElement, nextRawProps);
	          updatePayload = [];
	          break;
	        case "textarea":
	          lastProps = getHostProps$2(domElement, lastRawProps);
	          nextProps = getHostProps$2(domElement, nextRawProps);
	          updatePayload = [];
	          break;
	        default:
	          lastProps = lastRawProps;
	          nextProps = nextRawProps;
	          if (typeof lastProps.onClick !== "function" && typeof nextProps.onClick === "function") {
	            trapClickOnNonInteractiveElement(domElement);
	          }
	          break;
	      }
	      assertValidProps(tag, nextProps);
	      var propKey;
	      var styleName;
	      var styleUpdates = null;
	      for (propKey in lastProps) {
	        if (nextProps.hasOwnProperty(propKey) || !lastProps.hasOwnProperty(propKey) || lastProps[propKey] == null) {
	          continue;
	        }
	        if (propKey === STYLE) {
	          var lastStyle = lastProps[propKey];
	          for (styleName in lastStyle) {
	            if (lastStyle.hasOwnProperty(styleName)) {
	              if (!styleUpdates) {
	                styleUpdates = {};
	              }
	              styleUpdates[styleName] = "";
	            }
	          }
	        } else if (propKey === DANGEROUSLY_SET_INNER_HTML || propKey === CHILDREN)
	          ;
	        else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING)
	          ;
	        else if (propKey === AUTOFOCUS)
	          ;
	        else if (registrationNameDependencies.hasOwnProperty(propKey)) {
	          if (!updatePayload) {
	            updatePayload = [];
	          }
	        } else {
	          (updatePayload = updatePayload || []).push(propKey, null);
	        }
	      }
	      for (propKey in nextProps) {
	        var nextProp = nextProps[propKey];
	        var lastProp = lastProps != null ? lastProps[propKey] : void 0;
	        if (!nextProps.hasOwnProperty(propKey) || nextProp === lastProp || nextProp == null && lastProp == null) {
	          continue;
	        }
	        if (propKey === STYLE) {
	          {
	            if (nextProp) {
	              Object.freeze(nextProp);
	            }
	          }
	          if (lastProp) {
	            for (styleName in lastProp) {
	              if (lastProp.hasOwnProperty(styleName) && (!nextProp || !nextProp.hasOwnProperty(styleName))) {
	                if (!styleUpdates) {
	                  styleUpdates = {};
	                }
	                styleUpdates[styleName] = "";
	              }
	            }
	            for (styleName in nextProp) {
	              if (nextProp.hasOwnProperty(styleName) && lastProp[styleName] !== nextProp[styleName]) {
	                if (!styleUpdates) {
	                  styleUpdates = {};
	                }
	                styleUpdates[styleName] = nextProp[styleName];
	              }
	            }
	          } else {
	            if (!styleUpdates) {
	              if (!updatePayload) {
	                updatePayload = [];
	              }
	              updatePayload.push(propKey, styleUpdates);
	            }
	            styleUpdates = nextProp;
	          }
	        } else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
	          var nextHtml = nextProp ? nextProp[HTML$1] : void 0;
	          var lastHtml = lastProp ? lastProp[HTML$1] : void 0;
	          if (nextHtml != null) {
	            if (lastHtml !== nextHtml) {
	              (updatePayload = updatePayload || []).push(propKey, nextHtml);
	            }
	          }
	        } else if (propKey === CHILDREN) {
	          if (typeof nextProp === "string" || typeof nextProp === "number") {
	            (updatePayload = updatePayload || []).push(propKey, "" + nextProp);
	          }
	        } else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING)
	          ;
	        else if (registrationNameDependencies.hasOwnProperty(propKey)) {
	          if (nextProp != null) {
	            if (typeof nextProp !== "function") {
	              warnForInvalidEventListener(propKey, nextProp);
	            }
	            if (propKey === "onScroll") {
	              listenToNonDelegatedEvent("scroll", domElement);
	            }
	          }
	          if (!updatePayload && lastProp !== nextProp) {
	            updatePayload = [];
	          }
	        } else {
	          (updatePayload = updatePayload || []).push(propKey, nextProp);
	        }
	      }
	      if (styleUpdates) {
	        {
	          validateShorthandPropertyCollisionInDev(styleUpdates, nextProps[STYLE]);
	        }
	        (updatePayload = updatePayload || []).push(STYLE, styleUpdates);
	      }
	      return updatePayload;
	    }
	    function updateProperties(domElement, updatePayload, tag, lastRawProps, nextRawProps) {
	      if (tag === "input" && nextRawProps.type === "radio" && nextRawProps.name != null) {
	        updateChecked(domElement, nextRawProps);
	      }
	      var wasCustomComponentTag = isCustomComponent(tag, lastRawProps);
	      var isCustomComponentTag = isCustomComponent(tag, nextRawProps);
	      updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag);
	      switch (tag) {
	        case "input":
	          updateWrapper(domElement, nextRawProps);
	          break;
	        case "textarea":
	          updateWrapper$1(domElement, nextRawProps);
	          break;
	        case "select":
	          postUpdateWrapper(domElement, nextRawProps);
	          break;
	      }
	    }
	    function getPossibleStandardName(propName) {
	      {
	        var lowerCasedName = propName.toLowerCase();
	        if (!possibleStandardNames.hasOwnProperty(lowerCasedName)) {
	          return null;
	        }
	        return possibleStandardNames[lowerCasedName] || null;
	      }
	    }
	    function diffHydratedProperties(domElement, tag, rawProps, parentNamespace, rootContainerElement, isConcurrentMode, shouldWarnDev) {
	      var isCustomComponentTag;
	      var extraAttributeNames;
	      {
	        isCustomComponentTag = isCustomComponent(tag, rawProps);
	        validatePropertiesInDevelopment(tag, rawProps);
	      }
	      switch (tag) {
	        case "dialog":
	          listenToNonDelegatedEvent("cancel", domElement);
	          listenToNonDelegatedEvent("close", domElement);
	          break;
	        case "iframe":
	        case "object":
	        case "embed":
	          listenToNonDelegatedEvent("load", domElement);
	          break;
	        case "video":
	        case "audio":
	          for (var i = 0; i < mediaEventTypes.length; i++) {
	            listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
	          }
	          break;
	        case "source":
	          listenToNonDelegatedEvent("error", domElement);
	          break;
	        case "img":
	        case "image":
	        case "link":
	          listenToNonDelegatedEvent("error", domElement);
	          listenToNonDelegatedEvent("load", domElement);
	          break;
	        case "details":
	          listenToNonDelegatedEvent("toggle", domElement);
	          break;
	        case "input":
	          initWrapperState(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	        case "option":
	          validateProps(domElement, rawProps);
	          break;
	        case "select":
	          initWrapperState$1(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	        case "textarea":
	          initWrapperState$2(domElement, rawProps);
	          listenToNonDelegatedEvent("invalid", domElement);
	          break;
	      }
	      assertValidProps(tag, rawProps);
	      {
	        extraAttributeNames = /* @__PURE__ */ new Set();
	        var attributes = domElement.attributes;
	        for (var _i = 0; _i < attributes.length; _i++) {
	          var name = attributes[_i].name.toLowerCase();
	          switch (name) {
	            case "value":
	              break;
	            case "checked":
	              break;
	            case "selected":
	              break;
	            default:
	              extraAttributeNames.add(attributes[_i].name);
	          }
	        }
	      }
	      var updatePayload = null;
	      for (var propKey in rawProps) {
	        if (!rawProps.hasOwnProperty(propKey)) {
	          continue;
	        }
	        var nextProp = rawProps[propKey];
	        if (propKey === CHILDREN) {
	          if (typeof nextProp === "string") {
	            if (domElement.textContent !== nextProp) {
	              if (rawProps[SUPPRESS_HYDRATION_WARNING] !== true) {
	                checkForUnmatchedText(domElement.textContent, nextProp, isConcurrentMode, shouldWarnDev);
	              }
	              updatePayload = [CHILDREN, nextProp];
	            }
	          } else if (typeof nextProp === "number") {
	            if (domElement.textContent !== "" + nextProp) {
	              if (rawProps[SUPPRESS_HYDRATION_WARNING] !== true) {
	                checkForUnmatchedText(domElement.textContent, nextProp, isConcurrentMode, shouldWarnDev);
	              }
	              updatePayload = [CHILDREN, "" + nextProp];
	            }
	          }
	        } else if (registrationNameDependencies.hasOwnProperty(propKey)) {
	          if (nextProp != null) {
	            if (typeof nextProp !== "function") {
	              warnForInvalidEventListener(propKey, nextProp);
	            }
	            if (propKey === "onScroll") {
	              listenToNonDelegatedEvent("scroll", domElement);
	            }
	          }
	        } else if (shouldWarnDev && true && // Convince Flow we've calculated it (it's DEV-only in this method.)
	        typeof isCustomComponentTag === "boolean") {
	          var serverValue = void 0;
	          var propertyInfo = isCustomComponentTag && enableCustomElementPropertySupport ? null : getPropertyInfo(propKey);
	          if (rawProps[SUPPRESS_HYDRATION_WARNING] === true)
	            ;
	          else if (propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || // Controlled attributes are not validated
	          // TODO: Only ignore them on controlled tags.
	          propKey === "value" || propKey === "checked" || propKey === "selected")
	            ;
	          else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
	            var serverHTML = domElement.innerHTML;
	            var nextHtml = nextProp ? nextProp[HTML$1] : void 0;
	            if (nextHtml != null) {
	              var expectedHTML = normalizeHTML(domElement, nextHtml);
	              if (expectedHTML !== serverHTML) {
	                warnForPropDifference(propKey, serverHTML, expectedHTML);
	              }
	            }
	          } else if (propKey === STYLE) {
	            extraAttributeNames.delete(propKey);
	            if (canDiffStyleForHydrationWarning) {
	              var expectedStyle = createDangerousStringForStyles(nextProp);
	              serverValue = domElement.getAttribute("style");
	              if (expectedStyle !== serverValue) {
	                warnForPropDifference(propKey, serverValue, expectedStyle);
	              }
	            }
	          } else if (isCustomComponentTag && !enableCustomElementPropertySupport) {
	            extraAttributeNames.delete(propKey.toLowerCase());
	            serverValue = getValueForAttribute(domElement, propKey, nextProp);
	            if (nextProp !== serverValue) {
	              warnForPropDifference(propKey, serverValue, nextProp);
	            }
	          } else if (!shouldIgnoreAttribute(propKey, propertyInfo, isCustomComponentTag) && !shouldRemoveAttribute(propKey, nextProp, propertyInfo, isCustomComponentTag)) {
	            var isMismatchDueToBadCasing = false;
	            if (propertyInfo !== null) {
	              extraAttributeNames.delete(propertyInfo.attributeName);
	              serverValue = getValueForProperty(domElement, propKey, nextProp, propertyInfo);
	            } else {
	              var ownNamespace = parentNamespace;
	              if (ownNamespace === HTML_NAMESPACE) {
	                ownNamespace = getIntrinsicNamespace(tag);
	              }
	              if (ownNamespace === HTML_NAMESPACE) {
	                extraAttributeNames.delete(propKey.toLowerCase());
	              } else {
	                var standardName = getPossibleStandardName(propKey);
	                if (standardName !== null && standardName !== propKey) {
	                  isMismatchDueToBadCasing = true;
	                  extraAttributeNames.delete(standardName);
	                }
	                extraAttributeNames.delete(propKey);
	              }
	              serverValue = getValueForAttribute(domElement, propKey, nextProp);
	            }
	            var dontWarnCustomElement = enableCustomElementPropertySupport;
	            if (!dontWarnCustomElement && nextProp !== serverValue && !isMismatchDueToBadCasing) {
	              warnForPropDifference(propKey, serverValue, nextProp);
	            }
	          }
	        }
	      }
	      {
	        if (shouldWarnDev) {
	          if (
	            // $FlowFixMe - Should be inferred as not undefined.
	            extraAttributeNames.size > 0 && rawProps[SUPPRESS_HYDRATION_WARNING] !== true
	          ) {
	            warnForExtraAttributes(extraAttributeNames);
	          }
	        }
	      }
	      switch (tag) {
	        case "input":
	          track(domElement);
	          postMountWrapper(domElement, rawProps, true);
	          break;
	        case "textarea":
	          track(domElement);
	          postMountWrapper$3(domElement);
	          break;
	        case "select":
	        case "option":
	          break;
	        default:
	          if (typeof rawProps.onClick === "function") {
	            trapClickOnNonInteractiveElement(domElement);
	          }
	          break;
	      }
	      return updatePayload;
	    }
	    function diffHydratedText(textNode, text, isConcurrentMode) {
	      var isDifferent = textNode.nodeValue !== text;
	      return isDifferent;
	    }
	    function warnForDeletedHydratableElement(parentNode, child) {
	      {
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        error("Did not expect server HTML to contain a <%s> in <%s>.", child.nodeName.toLowerCase(), parentNode.nodeName.toLowerCase());
	      }
	    }
	    function warnForDeletedHydratableText(parentNode, child) {
	      {
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        error('Did not expect server HTML to contain the text node "%s" in <%s>.', child.nodeValue, parentNode.nodeName.toLowerCase());
	      }
	    }
	    function warnForInsertedHydratedElement(parentNode, tag, props) {
	      {
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        error("Expected server HTML to contain a matching <%s> in <%s>.", tag, parentNode.nodeName.toLowerCase());
	      }
	    }
	    function warnForInsertedHydratedText(parentNode, text) {
	      {
	        if (text === "") {
	          return;
	        }
	        if (didWarnInvalidHydration) {
	          return;
	        }
	        didWarnInvalidHydration = true;
	        error('Expected server HTML to contain a matching text node for "%s" in <%s>.', text, parentNode.nodeName.toLowerCase());
	      }
	    }
	    function restoreControlledState$3(domElement, tag, props) {
	      switch (tag) {
	        case "input":
	          restoreControlledState(domElement, props);
	          return;
	        case "textarea":
	          restoreControlledState$2(domElement, props);
	          return;
	        case "select":
	          restoreControlledState$1(domElement, props);
	          return;
	      }
	    }
	    var validateDOMNesting = function() {
	    };
	    var updatedAncestorInfo = function() {
	    };
	    {
	      var specialTags = ["address", "applet", "area", "article", "aside", "base", "basefont", "bgsound", "blockquote", "body", "br", "button", "caption", "center", "col", "colgroup", "dd", "details", "dir", "div", "dl", "dt", "embed", "fieldset", "figcaption", "figure", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "iframe", "img", "input", "isindex", "li", "link", "listing", "main", "marquee", "menu", "menuitem", "meta", "nav", "noembed", "noframes", "noscript", "object", "ol", "p", "param", "plaintext", "pre", "script", "section", "select", "source", "style", "summary", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "title", "tr", "track", "ul", "wbr", "xmp"];
	      var inScopeTags = [
	        "applet",
	        "caption",
	        "html",
	        "table",
	        "td",
	        "th",
	        "marquee",
	        "object",
	        "template",
	        // https://html.spec.whatwg.org/multipage/syntax.html#html-integration-point
	        // TODO: Distinguish by namespace here -- for <title>, including it here
	        // errs on the side of fewer warnings
	        "foreignObject",
	        "desc",
	        "title"
	      ];
	      var buttonScopeTags = inScopeTags.concat(["button"]);
	      var impliedEndTags = ["dd", "dt", "li", "option", "optgroup", "p", "rp", "rt"];
	      var emptyAncestorInfo = {
	        current: null,
	        formTag: null,
	        aTagInScope: null,
	        buttonTagInScope: null,
	        nobrTagInScope: null,
	        pTagInButtonScope: null,
	        listItemTagAutoclosing: null,
	        dlItemTagAutoclosing: null
	      };
	      updatedAncestorInfo = function(oldInfo, tag) {
	        var ancestorInfo = assign({}, oldInfo || emptyAncestorInfo);
	        var info = {
	          tag
	        };
	        if (inScopeTags.indexOf(tag) !== -1) {
	          ancestorInfo.aTagInScope = null;
	          ancestorInfo.buttonTagInScope = null;
	          ancestorInfo.nobrTagInScope = null;
	        }
	        if (buttonScopeTags.indexOf(tag) !== -1) {
	          ancestorInfo.pTagInButtonScope = null;
	        }
	        if (specialTags.indexOf(tag) !== -1 && tag !== "address" && tag !== "div" && tag !== "p") {
	          ancestorInfo.listItemTagAutoclosing = null;
	          ancestorInfo.dlItemTagAutoclosing = null;
	        }
	        ancestorInfo.current = info;
	        if (tag === "form") {
	          ancestorInfo.formTag = info;
	        }
	        if (tag === "a") {
	          ancestorInfo.aTagInScope = info;
	        }
	        if (tag === "button") {
	          ancestorInfo.buttonTagInScope = info;
	        }
	        if (tag === "nobr") {
	          ancestorInfo.nobrTagInScope = info;
	        }
	        if (tag === "p") {
	          ancestorInfo.pTagInButtonScope = info;
	        }
	        if (tag === "li") {
	          ancestorInfo.listItemTagAutoclosing = info;
	        }
	        if (tag === "dd" || tag === "dt") {
	          ancestorInfo.dlItemTagAutoclosing = info;
	        }
	        return ancestorInfo;
	      };
	      var isTagValidWithParent = function(tag, parentTag) {
	        switch (parentTag) {
	          case "select":
	            return tag === "option" || tag === "optgroup" || tag === "#text";
	          case "optgroup":
	            return tag === "option" || tag === "#text";
	          case "option":
	            return tag === "#text";
	          case "tr":
	            return tag === "th" || tag === "td" || tag === "style" || tag === "script" || tag === "template";
	          case "tbody":
	          case "thead":
	          case "tfoot":
	            return tag === "tr" || tag === "style" || tag === "script" || tag === "template";
	          case "colgroup":
	            return tag === "col" || tag === "template";
	          case "table":
	            return tag === "caption" || tag === "colgroup" || tag === "tbody" || tag === "tfoot" || tag === "thead" || tag === "style" || tag === "script" || tag === "template";
	          case "head":
	            return tag === "base" || tag === "basefont" || tag === "bgsound" || tag === "link" || tag === "meta" || tag === "title" || tag === "noscript" || tag === "noframes" || tag === "style" || tag === "script" || tag === "template";
	          case "html":
	            return tag === "head" || tag === "body" || tag === "frameset";
	          case "frameset":
	            return tag === "frame";
	          case "#document":
	            return tag === "html";
	        }
	        switch (tag) {
	          case "h1":
	          case "h2":
	          case "h3":
	          case "h4":
	          case "h5":
	          case "h6":
	            return parentTag !== "h1" && parentTag !== "h2" && parentTag !== "h3" && parentTag !== "h4" && parentTag !== "h5" && parentTag !== "h6";
	          case "rp":
	          case "rt":
	            return impliedEndTags.indexOf(parentTag) === -1;
	          case "body":
	          case "caption":
	          case "col":
	          case "colgroup":
	          case "frameset":
	          case "frame":
	          case "head":
	          case "html":
	          case "tbody":
	          case "td":
	          case "tfoot":
	          case "th":
	          case "thead":
	          case "tr":
	            return parentTag == null;
	        }
	        return true;
	      };
	      var findInvalidAncestorForTag = function(tag, ancestorInfo) {
	        switch (tag) {
	          case "address":
	          case "article":
	          case "aside":
	          case "blockquote":
	          case "center":
	          case "details":
	          case "dialog":
	          case "dir":
	          case "div":
	          case "dl":
	          case "fieldset":
	          case "figcaption":
	          case "figure":
	          case "footer":
	          case "header":
	          case "hgroup":
	          case "main":
	          case "menu":
	          case "nav":
	          case "ol":
	          case "p":
	          case "section":
	          case "summary":
	          case "ul":
	          case "pre":
	          case "listing":
	          case "table":
	          case "hr":
	          case "xmp":
	          case "h1":
	          case "h2":
	          case "h3":
	          case "h4":
	          case "h5":
	          case "h6":
	            return ancestorInfo.pTagInButtonScope;
	          case "form":
	            return ancestorInfo.formTag || ancestorInfo.pTagInButtonScope;
	          case "li":
	            return ancestorInfo.listItemTagAutoclosing;
	          case "dd":
	          case "dt":
	            return ancestorInfo.dlItemTagAutoclosing;
	          case "button":
	            return ancestorInfo.buttonTagInScope;
	          case "a":
	            return ancestorInfo.aTagInScope;
	          case "nobr":
	            return ancestorInfo.nobrTagInScope;
	        }
	        return null;
	      };
	      var didWarn$1 = {};
	      validateDOMNesting = function(childTag, childText, ancestorInfo) {
	        ancestorInfo = ancestorInfo || emptyAncestorInfo;
	        var parentInfo = ancestorInfo.current;
	        var parentTag = parentInfo && parentInfo.tag;
	        if (childText != null) {
	          if (childTag != null) {
	            error("validateDOMNesting: when childText is passed, childTag should be null");
	          }
	          childTag = "#text";
	        }
	        var invalidParent = isTagValidWithParent(childTag, parentTag) ? null : parentInfo;
	        var invalidAncestor = invalidParent ? null : findInvalidAncestorForTag(childTag, ancestorInfo);
	        var invalidParentOrAncestor = invalidParent || invalidAncestor;
	        if (!invalidParentOrAncestor) {
	          return;
	        }
	        var ancestorTag = invalidParentOrAncestor.tag;
	        var warnKey = !!invalidParent + "|" + childTag + "|" + ancestorTag;
	        if (didWarn$1[warnKey]) {
	          return;
	        }
	        didWarn$1[warnKey] = true;
	        var tagDisplayName = childTag;
	        var whitespaceInfo = "";
	        if (childTag === "#text") {
	          if (/\S/.test(childText)) {
	            tagDisplayName = "Text nodes";
	          } else {
	            tagDisplayName = "Whitespace text nodes";
	            whitespaceInfo = " Make sure you don't have any extra whitespace between tags on each line of your source code.";
	          }
	        } else {
	          tagDisplayName = "<" + childTag + ">";
	        }
	        if (invalidParent) {
	          var info = "";
	          if (ancestorTag === "table" && childTag === "tr") {
	            info += " Add a <tbody>, <thead> or <tfoot> to your code to match the DOM tree generated by the browser.";
	          }
	          error("validateDOMNesting(...): %s cannot appear as a child of <%s>.%s%s", tagDisplayName, ancestorTag, whitespaceInfo, info);
	        } else {
	          error("validateDOMNesting(...): %s cannot appear as a descendant of <%s>.", tagDisplayName, ancestorTag);
	        }
	      };
	    }
	    var SUPPRESS_HYDRATION_WARNING$1 = "suppressHydrationWarning";
	    var SUSPENSE_START_DATA = "$";
	    var SUSPENSE_END_DATA = "/$";
	    var SUSPENSE_PENDING_START_DATA = "$?";
	    var SUSPENSE_FALLBACK_START_DATA = "$!";
	    var STYLE$1 = "style";
	    var eventsEnabled = null;
	    var selectionInformation = null;
	    function getRootHostContext(rootContainerInstance) {
	      var type;
	      var namespace;
	      var nodeType = rootContainerInstance.nodeType;
	      switch (nodeType) {
	        case DOCUMENT_NODE:
	        case DOCUMENT_FRAGMENT_NODE: {
	          type = nodeType === DOCUMENT_NODE ? "#document" : "#fragment";
	          var root2 = rootContainerInstance.documentElement;
	          namespace = root2 ? root2.namespaceURI : getChildNamespace(null, "");
	          break;
	        }
	        default: {
	          var container = nodeType === COMMENT_NODE ? rootContainerInstance.parentNode : rootContainerInstance;
	          var ownNamespace = container.namespaceURI || null;
	          type = container.tagName;
	          namespace = getChildNamespace(ownNamespace, type);
	          break;
	        }
	      }
	      {
	        var validatedTag = type.toLowerCase();
	        var ancestorInfo = updatedAncestorInfo(null, validatedTag);
	        return {
	          namespace,
	          ancestorInfo
	        };
	      }
	    }
	    function getChildHostContext(parentHostContext, type, rootContainerInstance) {
	      {
	        var parentHostContextDev = parentHostContext;
	        var namespace = getChildNamespace(parentHostContextDev.namespace, type);
	        var ancestorInfo = updatedAncestorInfo(parentHostContextDev.ancestorInfo, type);
	        return {
	          namespace,
	          ancestorInfo
	        };
	      }
	    }
	    function getPublicInstance(instance) {
	      return instance;
	    }
	    function prepareForCommit(containerInfo) {
	      eventsEnabled = isEnabled();
	      selectionInformation = getSelectionInformation();
	      var activeInstance = null;
	      setEnabled(false);
	      return activeInstance;
	    }
	    function resetAfterCommit(containerInfo) {
	      restoreSelection(selectionInformation);
	      setEnabled(eventsEnabled);
	      eventsEnabled = null;
	      selectionInformation = null;
	    }
	    function createInstance(type, props, rootContainerInstance, hostContext, internalInstanceHandle) {
	      var parentNamespace;
	      {
	        var hostContextDev = hostContext;
	        validateDOMNesting(type, null, hostContextDev.ancestorInfo);
	        if (typeof props.children === "string" || typeof props.children === "number") {
	          var string = "" + props.children;
	          var ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
	          validateDOMNesting(null, string, ownAncestorInfo);
	        }
	        parentNamespace = hostContextDev.namespace;
	      }
	      var domElement = createElement(type, props, rootContainerInstance, parentNamespace);
	      precacheFiberNode(internalInstanceHandle, domElement);
	      updateFiberProps(domElement, props);
	      return domElement;
	    }
	    function appendInitialChild(parentInstance, child) {
	      parentInstance.appendChild(child);
	    }
	    function finalizeInitialChildren(domElement, type, props, rootContainerInstance, hostContext) {
	      setInitialProperties(domElement, type, props, rootContainerInstance);
	      switch (type) {
	        case "button":
	        case "input":
	        case "select":
	        case "textarea":
	          return !!props.autoFocus;
	        case "img":
	          return true;
	        default:
	          return false;
	      }
	    }
	    function prepareUpdate(domElement, type, oldProps, newProps, rootContainerInstance, hostContext) {
	      {
	        var hostContextDev = hostContext;
	        if (typeof newProps.children !== typeof oldProps.children && (typeof newProps.children === "string" || typeof newProps.children === "number")) {
	          var string = "" + newProps.children;
	          var ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
	          validateDOMNesting(null, string, ownAncestorInfo);
	        }
	      }
	      return diffProperties(domElement, type, oldProps, newProps);
	    }
	    function shouldSetTextContent(type, props) {
	      return type === "textarea" || type === "noscript" || typeof props.children === "string" || typeof props.children === "number" || typeof props.dangerouslySetInnerHTML === "object" && props.dangerouslySetInnerHTML !== null && props.dangerouslySetInnerHTML.__html != null;
	    }
	    function createTextInstance(text, rootContainerInstance, hostContext, internalInstanceHandle) {
	      {
	        var hostContextDev = hostContext;
	        validateDOMNesting(null, text, hostContextDev.ancestorInfo);
	      }
	      var textNode = createTextNode(text, rootContainerInstance);
	      precacheFiberNode(internalInstanceHandle, textNode);
	      return textNode;
	    }
	    function getCurrentEventPriority() {
	      var currentEvent = window.event;
	      if (currentEvent === void 0) {
	        return DefaultEventPriority;
	      }
	      return getEventPriority(currentEvent.type);
	    }
	    var scheduleTimeout = typeof setTimeout === "function" ? setTimeout : void 0;
	    var cancelTimeout = typeof clearTimeout === "function" ? clearTimeout : void 0;
	    var noTimeout = -1;
	    var localPromise = typeof Promise === "function" ? Promise : void 0;
	    var scheduleMicrotask = typeof queueMicrotask === "function" ? queueMicrotask : typeof localPromise !== "undefined" ? function(callback) {
	      return localPromise.resolve(null).then(callback).catch(handleErrorInNextTick);
	    } : scheduleTimeout;
	    function handleErrorInNextTick(error2) {
	      setTimeout(function() {
	        throw error2;
	      });
	    }
	    function commitMount(domElement, type, newProps, internalInstanceHandle) {
	      switch (type) {
	        case "button":
	        case "input":
	        case "select":
	        case "textarea":
	          if (newProps.autoFocus) {
	            domElement.focus();
	          }
	          return;
	        case "img": {
	          if (newProps.src) {
	            domElement.src = newProps.src;
	          }
	          return;
	        }
	      }
	    }
	    function commitUpdate(domElement, updatePayload, type, oldProps, newProps, internalInstanceHandle) {
	      updateProperties(domElement, updatePayload, type, oldProps, newProps);
	      updateFiberProps(domElement, newProps);
	    }
	    function resetTextContent(domElement) {
	      setTextContent(domElement, "");
	    }
	    function commitTextUpdate(textInstance, oldText, newText) {
	      textInstance.nodeValue = newText;
	    }
	    function appendChild(parentInstance, child) {
	      parentInstance.appendChild(child);
	    }
	    function appendChildToContainer(container, child) {
	      var parentNode;
	      if (container.nodeType === COMMENT_NODE) {
	        parentNode = container.parentNode;
	        parentNode.insertBefore(child, container);
	      } else {
	        parentNode = container;
	        parentNode.appendChild(child);
	      }
	      var reactRootContainer = container._reactRootContainer;
	      if ((reactRootContainer === null || reactRootContainer === void 0) && parentNode.onclick === null) {
	        trapClickOnNonInteractiveElement(parentNode);
	      }
	    }
	    function insertBefore(parentInstance, child, beforeChild) {
	      parentInstance.insertBefore(child, beforeChild);
	    }
	    function insertInContainerBefore(container, child, beforeChild) {
	      if (container.nodeType === COMMENT_NODE) {
	        container.parentNode.insertBefore(child, beforeChild);
	      } else {
	        container.insertBefore(child, beforeChild);
	      }
	    }
	    function removeChild(parentInstance, child) {
	      parentInstance.removeChild(child);
	    }
	    function removeChildFromContainer(container, child) {
	      if (container.nodeType === COMMENT_NODE) {
	        container.parentNode.removeChild(child);
	      } else {
	        container.removeChild(child);
	      }
	    }
	    function clearSuspenseBoundary(parentInstance, suspenseInstance) {
	      var node = suspenseInstance;
	      var depth = 0;
	      do {
	        var nextNode = node.nextSibling;
	        parentInstance.removeChild(node);
	        if (nextNode && nextNode.nodeType === COMMENT_NODE) {
	          var data = nextNode.data;
	          if (data === SUSPENSE_END_DATA) {
	            if (depth === 0) {
	              parentInstance.removeChild(nextNode);
	              retryIfBlockedOn(suspenseInstance);
	              return;
	            } else {
	              depth--;
	            }
	          } else if (data === SUSPENSE_START_DATA || data === SUSPENSE_PENDING_START_DATA || data === SUSPENSE_FALLBACK_START_DATA) {
	            depth++;
	          }
	        }
	        node = nextNode;
	      } while (node);
	      retryIfBlockedOn(suspenseInstance);
	    }
	    function clearSuspenseBoundaryFromContainer(container, suspenseInstance) {
	      if (container.nodeType === COMMENT_NODE) {
	        clearSuspenseBoundary(container.parentNode, suspenseInstance);
	      } else if (container.nodeType === ELEMENT_NODE) {
	        clearSuspenseBoundary(container, suspenseInstance);
	      }
	      retryIfBlockedOn(container);
	    }
	    function hideInstance(instance) {
	      instance = instance;
	      var style2 = instance.style;
	      if (typeof style2.setProperty === "function") {
	        style2.setProperty("display", "none", "important");
	      } else {
	        style2.display = "none";
	      }
	    }
	    function hideTextInstance(textInstance) {
	      textInstance.nodeValue = "";
	    }
	    function unhideInstance(instance, props) {
	      instance = instance;
	      var styleProp = props[STYLE$1];
	      var display = styleProp !== void 0 && styleProp !== null && styleProp.hasOwnProperty("display") ? styleProp.display : null;
	      instance.style.display = dangerousStyleValue("display", display);
	    }
	    function unhideTextInstance(textInstance, text) {
	      textInstance.nodeValue = text;
	    }
	    function clearContainer(container) {
	      if (container.nodeType === ELEMENT_NODE) {
	        container.textContent = "";
	      } else if (container.nodeType === DOCUMENT_NODE) {
	        if (container.documentElement) {
	          container.removeChild(container.documentElement);
	        }
	      }
	    }
	    function canHydrateInstance(instance, type, props) {
	      if (instance.nodeType !== ELEMENT_NODE || type.toLowerCase() !== instance.nodeName.toLowerCase()) {
	        return null;
	      }
	      return instance;
	    }
	    function canHydrateTextInstance(instance, text) {
	      if (text === "" || instance.nodeType !== TEXT_NODE) {
	        return null;
	      }
	      return instance;
	    }
	    function canHydrateSuspenseInstance(instance) {
	      if (instance.nodeType !== COMMENT_NODE) {
	        return null;
	      }
	      return instance;
	    }
	    function isSuspenseInstancePending(instance) {
	      return instance.data === SUSPENSE_PENDING_START_DATA;
	    }
	    function isSuspenseInstanceFallback(instance) {
	      return instance.data === SUSPENSE_FALLBACK_START_DATA;
	    }
	    function getSuspenseInstanceFallbackErrorDetails(instance) {
	      var dataset = instance.nextSibling && instance.nextSibling.dataset;
	      var digest, message, stack;
	      if (dataset) {
	        digest = dataset.dgst;
	        {
	          message = dataset.msg;
	          stack = dataset.stck;
	        }
	      }
	      {
	        return {
	          message,
	          digest,
	          stack
	        };
	      }
	    }
	    function registerSuspenseInstanceRetry(instance, callback) {
	      instance._reactRetry = callback;
	    }
	    function getNextHydratable(node) {
	      for (; node != null; node = node.nextSibling) {
	        var nodeType = node.nodeType;
	        if (nodeType === ELEMENT_NODE || nodeType === TEXT_NODE) {
	          break;
	        }
	        if (nodeType === COMMENT_NODE) {
	          var nodeData = node.data;
	          if (nodeData === SUSPENSE_START_DATA || nodeData === SUSPENSE_FALLBACK_START_DATA || nodeData === SUSPENSE_PENDING_START_DATA) {
	            break;
	          }
	          if (nodeData === SUSPENSE_END_DATA) {
	            return null;
	          }
	        }
	      }
	      return node;
	    }
	    function getNextHydratableSibling(instance) {
	      return getNextHydratable(instance.nextSibling);
	    }
	    function getFirstHydratableChild(parentInstance) {
	      return getNextHydratable(parentInstance.firstChild);
	    }
	    function getFirstHydratableChildWithinContainer(parentContainer) {
	      return getNextHydratable(parentContainer.firstChild);
	    }
	    function getFirstHydratableChildWithinSuspenseInstance(parentInstance) {
	      return getNextHydratable(parentInstance.nextSibling);
	    }
	    function hydrateInstance(instance, type, props, rootContainerInstance, hostContext, internalInstanceHandle, shouldWarnDev) {
	      precacheFiberNode(internalInstanceHandle, instance);
	      updateFiberProps(instance, props);
	      var parentNamespace;
	      {
	        var hostContextDev = hostContext;
	        parentNamespace = hostContextDev.namespace;
	      }
	      var isConcurrentMode = (internalInstanceHandle.mode & ConcurrentMode) !== NoMode;
	      return diffHydratedProperties(instance, type, props, parentNamespace, rootContainerInstance, isConcurrentMode, shouldWarnDev);
	    }
	    function hydrateTextInstance(textInstance, text, internalInstanceHandle, shouldWarnDev) {
	      precacheFiberNode(internalInstanceHandle, textInstance);
	      (internalInstanceHandle.mode & ConcurrentMode) !== NoMode;
	      return diffHydratedText(textInstance, text);
	    }
	    function hydrateSuspenseInstance(suspenseInstance, internalInstanceHandle) {
	      precacheFiberNode(internalInstanceHandle, suspenseInstance);
	    }
	    function getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance) {
	      var node = suspenseInstance.nextSibling;
	      var depth = 0;
	      while (node) {
	        if (node.nodeType === COMMENT_NODE) {
	          var data = node.data;
	          if (data === SUSPENSE_END_DATA) {
	            if (depth === 0) {
	              return getNextHydratableSibling(node);
	            } else {
	              depth--;
	            }
	          } else if (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) {
	            depth++;
	          }
	        }
	        node = node.nextSibling;
	      }
	      return null;
	    }
	    function getParentSuspenseInstance(targetInstance) {
	      var node = targetInstance.previousSibling;
	      var depth = 0;
	      while (node) {
	        if (node.nodeType === COMMENT_NODE) {
	          var data = node.data;
	          if (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) {
	            if (depth === 0) {
	              return node;
	            } else {
	              depth--;
	            }
	          } else if (data === SUSPENSE_END_DATA) {
	            depth++;
	          }
	        }
	        node = node.previousSibling;
	      }
	      return null;
	    }
	    function commitHydratedContainer(container) {
	      retryIfBlockedOn(container);
	    }
	    function commitHydratedSuspenseInstance(suspenseInstance) {
	      retryIfBlockedOn(suspenseInstance);
	    }
	    function shouldDeleteUnhydratedTailInstances(parentType) {
	      return parentType !== "head" && parentType !== "body";
	    }
	    function didNotMatchHydratedContainerTextInstance(parentContainer, textInstance, text, isConcurrentMode) {
	      var shouldWarnDev = true;
	      checkForUnmatchedText(textInstance.nodeValue, text, isConcurrentMode, shouldWarnDev);
	    }
	    function didNotMatchHydratedTextInstance(parentType, parentProps, parentInstance, textInstance, text, isConcurrentMode) {
	      if (parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
	        var shouldWarnDev = true;
	        checkForUnmatchedText(textInstance.nodeValue, text, isConcurrentMode, shouldWarnDev);
	      }
	    }
	    function didNotHydrateInstanceWithinContainer(parentContainer, instance) {
	      {
	        if (instance.nodeType === ELEMENT_NODE) {
	          warnForDeletedHydratableElement(parentContainer, instance);
	        } else if (instance.nodeType === COMMENT_NODE)
	          ;
	        else {
	          warnForDeletedHydratableText(parentContainer, instance);
	        }
	      }
	    }
	    function didNotHydrateInstanceWithinSuspenseInstance(parentInstance, instance) {
	      {
	        var parentNode = parentInstance.parentNode;
	        if (parentNode !== null) {
	          if (instance.nodeType === ELEMENT_NODE) {
	            warnForDeletedHydratableElement(parentNode, instance);
	          } else if (instance.nodeType === COMMENT_NODE)
	            ;
	          else {
	            warnForDeletedHydratableText(parentNode, instance);
	          }
	        }
	      }
	    }
	    function didNotHydrateInstance(parentType, parentProps, parentInstance, instance, isConcurrentMode) {
	      {
	        if (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
	          if (instance.nodeType === ELEMENT_NODE) {
	            warnForDeletedHydratableElement(parentInstance, instance);
	          } else if (instance.nodeType === COMMENT_NODE)
	            ;
	          else {
	            warnForDeletedHydratableText(parentInstance, instance);
	          }
	        }
	      }
	    }
	    function didNotFindHydratableInstanceWithinContainer(parentContainer, type, props) {
	      {
	        warnForInsertedHydratedElement(parentContainer, type);
	      }
	    }
	    function didNotFindHydratableTextInstanceWithinContainer(parentContainer, text) {
	      {
	        warnForInsertedHydratedText(parentContainer, text);
	      }
	    }
	    function didNotFindHydratableInstanceWithinSuspenseInstance(parentInstance, type, props) {
	      {
	        var parentNode = parentInstance.parentNode;
	        if (parentNode !== null)
	          warnForInsertedHydratedElement(parentNode, type);
	      }
	    }
	    function didNotFindHydratableTextInstanceWithinSuspenseInstance(parentInstance, text) {
	      {
	        var parentNode = parentInstance.parentNode;
	        if (parentNode !== null)
	          warnForInsertedHydratedText(parentNode, text);
	      }
	    }
	    function didNotFindHydratableInstance(parentType, parentProps, parentInstance, type, props, isConcurrentMode) {
	      {
	        if (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
	          warnForInsertedHydratedElement(parentInstance, type);
	        }
	      }
	    }
	    function didNotFindHydratableTextInstance(parentType, parentProps, parentInstance, text, isConcurrentMode) {
	      {
	        if (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== true) {
	          warnForInsertedHydratedText(parentInstance, text);
	        }
	      }
	    }
	    function errorHydratingContainer(parentContainer) {
	      {
	        error("An error occurred during hydration. The server HTML was replaced with client content in <%s>.", parentContainer.nodeName.toLowerCase());
	      }
	    }
	    function preparePortalMount(portalInstance) {
	      listenToAllSupportedEvents(portalInstance);
	    }
	    var randomKey = Math.random().toString(36).slice(2);
	    var internalInstanceKey = "__reactFiber$" + randomKey;
	    var internalPropsKey = "__reactProps$" + randomKey;
	    var internalContainerInstanceKey = "__reactContainer$" + randomKey;
	    var internalEventHandlersKey = "__reactEvents$" + randomKey;
	    var internalEventHandlerListenersKey = "__reactListeners$" + randomKey;
	    var internalEventHandlesSetKey = "__reactHandles$" + randomKey;
	    function detachDeletedInstance(node) {
	      delete node[internalInstanceKey];
	      delete node[internalPropsKey];
	      delete node[internalEventHandlersKey];
	      delete node[internalEventHandlerListenersKey];
	      delete node[internalEventHandlesSetKey];
	    }
	    function precacheFiberNode(hostInst, node) {
	      node[internalInstanceKey] = hostInst;
	    }
	    function markContainerAsRoot(hostRoot, node) {
	      node[internalContainerInstanceKey] = hostRoot;
	    }
	    function unmarkContainerAsRoot(node) {
	      node[internalContainerInstanceKey] = null;
	    }
	    function isContainerMarkedAsRoot(node) {
	      return !!node[internalContainerInstanceKey];
	    }
	    function getClosestInstanceFromNode(targetNode) {
	      var targetInst = targetNode[internalInstanceKey];
	      if (targetInst) {
	        return targetInst;
	      }
	      var parentNode = targetNode.parentNode;
	      while (parentNode) {
	        targetInst = parentNode[internalContainerInstanceKey] || parentNode[internalInstanceKey];
	        if (targetInst) {
	          var alternate = targetInst.alternate;
	          if (targetInst.child !== null || alternate !== null && alternate.child !== null) {
	            var suspenseInstance = getParentSuspenseInstance(targetNode);
	            while (suspenseInstance !== null) {
	              var targetSuspenseInst = suspenseInstance[internalInstanceKey];
	              if (targetSuspenseInst) {
	                return targetSuspenseInst;
	              }
	              suspenseInstance = getParentSuspenseInstance(suspenseInstance);
	            }
	          }
	          return targetInst;
	        }
	        targetNode = parentNode;
	        parentNode = targetNode.parentNode;
	      }
	      return null;
	    }
	    function getInstanceFromNode(node) {
	      var inst = node[internalInstanceKey] || node[internalContainerInstanceKey];
	      if (inst) {
	        if (inst.tag === HostComponent || inst.tag === HostText || inst.tag === SuspenseComponent || inst.tag === HostRoot) {
	          return inst;
	        } else {
	          return null;
	        }
	      }
	      return null;
	    }
	    function getNodeFromInstance(inst) {
	      if (inst.tag === HostComponent || inst.tag === HostText) {
	        return inst.stateNode;
	      }
	      throw new Error("getNodeFromInstance: Invalid argument.");
	    }
	    function getFiberCurrentPropsFromNode(node) {
	      return node[internalPropsKey] || null;
	    }
	    function updateFiberProps(node, props) {
	      node[internalPropsKey] = props;
	    }
	    function getEventListenerSet(node) {
	      var elementListenerSet = node[internalEventHandlersKey];
	      if (elementListenerSet === void 0) {
	        elementListenerSet = node[internalEventHandlersKey] = /* @__PURE__ */ new Set();
	      }
	      return elementListenerSet;
	    }
	    var loggedTypeFailures = {};
	    var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
	    function setCurrentlyValidatingElement(element) {
	      {
	        if (element) {
	          var owner = element._owner;
	          var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
	          ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
	        } else {
	          ReactDebugCurrentFrame$1.setExtraStackFrame(null);
	        }
	      }
	    }
	    function checkPropTypes(typeSpecs, values, location, componentName, element) {
	      {
	        var has2 = Function.call.bind(hasOwnProperty);
	        for (var typeSpecName in typeSpecs) {
	          if (has2(typeSpecs, typeSpecName)) {
	            var error$1 = void 0;
	            try {
	              if (typeof typeSpecs[typeSpecName] !== "function") {
	                var err = Error((componentName || "React class") + ": " + location + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
	                err.name = "Invariant Violation";
	                throw err;
	              }
	              error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
	            } catch (ex) {
	              error$1 = ex;
	            }
	            if (error$1 && !(error$1 instanceof Error)) {
	              setCurrentlyValidatingElement(element);
	              error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location, typeSpecName, typeof error$1);
	              setCurrentlyValidatingElement(null);
	            }
	            if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
	              loggedTypeFailures[error$1.message] = true;
	              setCurrentlyValidatingElement(element);
	              error("Failed %s type: %s", location, error$1.message);
	              setCurrentlyValidatingElement(null);
	            }
	          }
	        }
	      }
	    }
	    var valueStack = [];
	    var fiberStack;
	    {
	      fiberStack = [];
	    }
	    var index = -1;
	    function createCursor(defaultValue) {
	      return {
	        current: defaultValue
	      };
	    }
	    function pop(cursor, fiber) {
	      if (index < 0) {
	        {
	          error("Unexpected pop.");
	        }
	        return;
	      }
	      {
	        if (fiber !== fiberStack[index]) {
	          error("Unexpected Fiber popped.");
	        }
	      }
	      cursor.current = valueStack[index];
	      valueStack[index] = null;
	      {
	        fiberStack[index] = null;
	      }
	      index--;
	    }
	    function push(cursor, value, fiber) {
	      index++;
	      valueStack[index] = cursor.current;
	      {
	        fiberStack[index] = fiber;
	      }
	      cursor.current = value;
	    }
	    var warnedAboutMissingGetChildContext;
	    {
	      warnedAboutMissingGetChildContext = {};
	    }
	    var emptyContextObject = {};
	    {
	      Object.freeze(emptyContextObject);
	    }
	    var contextStackCursor = createCursor(emptyContextObject);
	    var didPerformWorkStackCursor = createCursor(false);
	    var previousContext = emptyContextObject;
	    function getUnmaskedContext(workInProgress2, Component, didPushOwnContextIfProvider) {
	      {
	        if (didPushOwnContextIfProvider && isContextProvider(Component)) {
	          return previousContext;
	        }
	        return contextStackCursor.current;
	      }
	    }
	    function cacheContext(workInProgress2, unmaskedContext, maskedContext) {
	      {
	        var instance = workInProgress2.stateNode;
	        instance.__reactInternalMemoizedUnmaskedChildContext = unmaskedContext;
	        instance.__reactInternalMemoizedMaskedChildContext = maskedContext;
	      }
	    }
	    function getMaskedContext(workInProgress2, unmaskedContext) {
	      {
	        var type = workInProgress2.type;
	        var contextTypes = type.contextTypes;
	        if (!contextTypes) {
	          return emptyContextObject;
	        }
	        var instance = workInProgress2.stateNode;
	        if (instance && instance.__reactInternalMemoizedUnmaskedChildContext === unmaskedContext) {
	          return instance.__reactInternalMemoizedMaskedChildContext;
	        }
	        var context = {};
	        for (var key in contextTypes) {
	          context[key] = unmaskedContext[key];
	        }
	        {
	          var name = getComponentNameFromFiber(workInProgress2) || "Unknown";
	          checkPropTypes(contextTypes, context, "context", name);
	        }
	        if (instance) {
	          cacheContext(workInProgress2, unmaskedContext, context);
	        }
	        return context;
	      }
	    }
	    function hasContextChanged() {
	      {
	        return didPerformWorkStackCursor.current;
	      }
	    }
	    function isContextProvider(type) {
	      {
	        var childContextTypes = type.childContextTypes;
	        return childContextTypes !== null && childContextTypes !== void 0;
	      }
	    }
	    function popContext(fiber) {
	      {
	        pop(didPerformWorkStackCursor, fiber);
	        pop(contextStackCursor, fiber);
	      }
	    }
	    function popTopLevelContextObject(fiber) {
	      {
	        pop(didPerformWorkStackCursor, fiber);
	        pop(contextStackCursor, fiber);
	      }
	    }
	    function pushTopLevelContextObject(fiber, context, didChange) {
	      {
	        if (contextStackCursor.current !== emptyContextObject) {
	          throw new Error("Unexpected context found on stack. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        push(contextStackCursor, context, fiber);
	        push(didPerformWorkStackCursor, didChange, fiber);
	      }
	    }
	    function processChildContext(fiber, type, parentContext) {
	      {
	        var instance = fiber.stateNode;
	        var childContextTypes = type.childContextTypes;
	        if (typeof instance.getChildContext !== "function") {
	          {
	            var componentName = getComponentNameFromFiber(fiber) || "Unknown";
	            if (!warnedAboutMissingGetChildContext[componentName]) {
	              warnedAboutMissingGetChildContext[componentName] = true;
	              error("%s.childContextTypes is specified but there is no getChildContext() method on the instance. You can either define getChildContext() on %s or remove childContextTypes from it.", componentName, componentName);
	            }
	          }
	          return parentContext;
	        }
	        var childContext = instance.getChildContext();
	        for (var contextKey in childContext) {
	          if (!(contextKey in childContextTypes)) {
	            throw new Error((getComponentNameFromFiber(fiber) || "Unknown") + '.getChildContext(): key "' + contextKey + '" is not defined in childContextTypes.');
	          }
	        }
	        {
	          var name = getComponentNameFromFiber(fiber) || "Unknown";
	          checkPropTypes(childContextTypes, childContext, "child context", name);
	        }
	        return assign({}, parentContext, childContext);
	      }
	    }
	    function pushContextProvider(workInProgress2) {
	      {
	        var instance = workInProgress2.stateNode;
	        var memoizedMergedChildContext = instance && instance.__reactInternalMemoizedMergedChildContext || emptyContextObject;
	        previousContext = contextStackCursor.current;
	        push(contextStackCursor, memoizedMergedChildContext, workInProgress2);
	        push(didPerformWorkStackCursor, didPerformWorkStackCursor.current, workInProgress2);
	        return true;
	      }
	    }
	    function invalidateContextProvider(workInProgress2, type, didChange) {
	      {
	        var instance = workInProgress2.stateNode;
	        if (!instance) {
	          throw new Error("Expected to have an instance by this point. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        if (didChange) {
	          var mergedContext = processChildContext(workInProgress2, type, previousContext);
	          instance.__reactInternalMemoizedMergedChildContext = mergedContext;
	          pop(didPerformWorkStackCursor, workInProgress2);
	          pop(contextStackCursor, workInProgress2);
	          push(contextStackCursor, mergedContext, workInProgress2);
	          push(didPerformWorkStackCursor, didChange, workInProgress2);
	        } else {
	          pop(didPerformWorkStackCursor, workInProgress2);
	          push(didPerformWorkStackCursor, didChange, workInProgress2);
	        }
	      }
	    }
	    function findCurrentUnmaskedContext(fiber) {
	      {
	        if (!isFiberMounted(fiber) || fiber.tag !== ClassComponent) {
	          throw new Error("Expected subtree parent to be a mounted class component. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        var node = fiber;
	        do {
	          switch (node.tag) {
	            case HostRoot:
	              return node.stateNode.context;
	            case ClassComponent: {
	              var Component = node.type;
	              if (isContextProvider(Component)) {
	                return node.stateNode.__reactInternalMemoizedMergedChildContext;
	              }
	              break;
	            }
	          }
	          node = node.return;
	        } while (node !== null);
	        throw new Error("Found unexpected detached subtree parent. This error is likely caused by a bug in React. Please file an issue.");
	      }
	    }
	    var LegacyRoot = 0;
	    var ConcurrentRoot = 1;
	    var syncQueue = null;
	    var includesLegacySyncCallbacks = false;
	    var isFlushingSyncQueue = false;
	    function scheduleSyncCallback(callback) {
	      if (syncQueue === null) {
	        syncQueue = [callback];
	      } else {
	        syncQueue.push(callback);
	      }
	    }
	    function scheduleLegacySyncCallback(callback) {
	      includesLegacySyncCallbacks = true;
	      scheduleSyncCallback(callback);
	    }
	    function flushSyncCallbacksOnlyInLegacyMode() {
	      if (includesLegacySyncCallbacks) {
	        flushSyncCallbacks();
	      }
	    }
	    function flushSyncCallbacks() {
	      if (!isFlushingSyncQueue && syncQueue !== null) {
	        isFlushingSyncQueue = true;
	        var i = 0;
	        var previousUpdatePriority = getCurrentUpdatePriority();
	        try {
	          var isSync = true;
	          var queue = syncQueue;
	          setCurrentUpdatePriority(DiscreteEventPriority);
	          for (; i < queue.length; i++) {
	            var callback = queue[i];
	            do {
	              callback = callback(isSync);
	            } while (callback !== null);
	          }
	          syncQueue = null;
	          includesLegacySyncCallbacks = false;
	        } catch (error2) {
	          if (syncQueue !== null) {
	            syncQueue = syncQueue.slice(i + 1);
	          }
	          scheduleCallback(ImmediatePriority, flushSyncCallbacks);
	          throw error2;
	        } finally {
	          setCurrentUpdatePriority(previousUpdatePriority);
	          isFlushingSyncQueue = false;
	        }
	      }
	      return null;
	    }
	    var forkStack = [];
	    var forkStackIndex = 0;
	    var treeForkProvider = null;
	    var treeForkCount = 0;
	    var idStack = [];
	    var idStackIndex = 0;
	    var treeContextProvider = null;
	    var treeContextId = 1;
	    var treeContextOverflow = "";
	    function isForkedChild(workInProgress2) {
	      warnIfNotHydrating();
	      return (workInProgress2.flags & Forked) !== NoFlags;
	    }
	    function getForksAtLevel(workInProgress2) {
	      warnIfNotHydrating();
	      return treeForkCount;
	    }
	    function getTreeId() {
	      var overflow = treeContextOverflow;
	      var idWithLeadingBit = treeContextId;
	      var id = idWithLeadingBit & ~getLeadingBit(idWithLeadingBit);
	      return id.toString(32) + overflow;
	    }
	    function pushTreeFork(workInProgress2, totalChildren) {
	      warnIfNotHydrating();
	      forkStack[forkStackIndex++] = treeForkCount;
	      forkStack[forkStackIndex++] = treeForkProvider;
	      treeForkProvider = workInProgress2;
	      treeForkCount = totalChildren;
	    }
	    function pushTreeId(workInProgress2, totalChildren, index2) {
	      warnIfNotHydrating();
	      idStack[idStackIndex++] = treeContextId;
	      idStack[idStackIndex++] = treeContextOverflow;
	      idStack[idStackIndex++] = treeContextProvider;
	      treeContextProvider = workInProgress2;
	      var baseIdWithLeadingBit = treeContextId;
	      var baseOverflow = treeContextOverflow;
	      var baseLength = getBitLength(baseIdWithLeadingBit) - 1;
	      var baseId = baseIdWithLeadingBit & ~(1 << baseLength);
	      var slot = index2 + 1;
	      var length = getBitLength(totalChildren) + baseLength;
	      if (length > 30) {
	        var numberOfOverflowBits = baseLength - baseLength % 5;
	        var newOverflowBits = (1 << numberOfOverflowBits) - 1;
	        var newOverflow = (baseId & newOverflowBits).toString(32);
	        var restOfBaseId = baseId >> numberOfOverflowBits;
	        var restOfBaseLength = baseLength - numberOfOverflowBits;
	        var restOfLength = getBitLength(totalChildren) + restOfBaseLength;
	        var restOfNewBits = slot << restOfBaseLength;
	        var id = restOfNewBits | restOfBaseId;
	        var overflow = newOverflow + baseOverflow;
	        treeContextId = 1 << restOfLength | id;
	        treeContextOverflow = overflow;
	      } else {
	        var newBits = slot << baseLength;
	        var _id = newBits | baseId;
	        var _overflow = baseOverflow;
	        treeContextId = 1 << length | _id;
	        treeContextOverflow = _overflow;
	      }
	    }
	    function pushMaterializedTreeId(workInProgress2) {
	      warnIfNotHydrating();
	      var returnFiber = workInProgress2.return;
	      if (returnFiber !== null) {
	        var numberOfForks = 1;
	        var slotIndex = 0;
	        pushTreeFork(workInProgress2, numberOfForks);
	        pushTreeId(workInProgress2, numberOfForks, slotIndex);
	      }
	    }
	    function getBitLength(number) {
	      return 32 - clz32(number);
	    }
	    function getLeadingBit(id) {
	      return 1 << getBitLength(id) - 1;
	    }
	    function popTreeContext(workInProgress2) {
	      while (workInProgress2 === treeForkProvider) {
	        treeForkProvider = forkStack[--forkStackIndex];
	        forkStack[forkStackIndex] = null;
	        treeForkCount = forkStack[--forkStackIndex];
	        forkStack[forkStackIndex] = null;
	      }
	      while (workInProgress2 === treeContextProvider) {
	        treeContextProvider = idStack[--idStackIndex];
	        idStack[idStackIndex] = null;
	        treeContextOverflow = idStack[--idStackIndex];
	        idStack[idStackIndex] = null;
	        treeContextId = idStack[--idStackIndex];
	        idStack[idStackIndex] = null;
	      }
	    }
	    function getSuspendedTreeContext() {
	      warnIfNotHydrating();
	      if (treeContextProvider !== null) {
	        return {
	          id: treeContextId,
	          overflow: treeContextOverflow
	        };
	      } else {
	        return null;
	      }
	    }
	    function restoreSuspendedTreeContext(workInProgress2, suspendedContext) {
	      warnIfNotHydrating();
	      idStack[idStackIndex++] = treeContextId;
	      idStack[idStackIndex++] = treeContextOverflow;
	      idStack[idStackIndex++] = treeContextProvider;
	      treeContextId = suspendedContext.id;
	      treeContextOverflow = suspendedContext.overflow;
	      treeContextProvider = workInProgress2;
	    }
	    function warnIfNotHydrating() {
	      {
	        if (!getIsHydrating()) {
	          error("Expected to be hydrating. This is a bug in React. Please file an issue.");
	        }
	      }
	    }
	    var hydrationParentFiber = null;
	    var nextHydratableInstance = null;
	    var isHydrating = false;
	    var didSuspendOrErrorDEV = false;
	    var hydrationErrors = null;
	    function warnIfHydrating() {
	      {
	        if (isHydrating) {
	          error("We should not be hydrating here. This is a bug in React. Please file a bug.");
	        }
	      }
	    }
	    function markDidThrowWhileHydratingDEV() {
	      {
	        didSuspendOrErrorDEV = true;
	      }
	    }
	    function didSuspendOrErrorWhileHydratingDEV() {
	      {
	        return didSuspendOrErrorDEV;
	      }
	    }
	    function enterHydrationState(fiber) {
	      var parentInstance = fiber.stateNode.containerInfo;
	      nextHydratableInstance = getFirstHydratableChildWithinContainer(parentInstance);
	      hydrationParentFiber = fiber;
	      isHydrating = true;
	      hydrationErrors = null;
	      didSuspendOrErrorDEV = false;
	      return true;
	    }
	    function reenterHydrationStateFromDehydratedSuspenseInstance(fiber, suspenseInstance, treeContext) {
	      nextHydratableInstance = getFirstHydratableChildWithinSuspenseInstance(suspenseInstance);
	      hydrationParentFiber = fiber;
	      isHydrating = true;
	      hydrationErrors = null;
	      didSuspendOrErrorDEV = false;
	      if (treeContext !== null) {
	        restoreSuspendedTreeContext(fiber, treeContext);
	      }
	      return true;
	    }
	    function warnUnhydratedInstance(returnFiber, instance) {
	      {
	        switch (returnFiber.tag) {
	          case HostRoot: {
	            didNotHydrateInstanceWithinContainer(returnFiber.stateNode.containerInfo, instance);
	            break;
	          }
	          case HostComponent: {
	            var isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
	            didNotHydrateInstance(
	              returnFiber.type,
	              returnFiber.memoizedProps,
	              returnFiber.stateNode,
	              instance,
	              // TODO: Delete this argument when we remove the legacy root API.
	              isConcurrentMode
	            );
	            break;
	          }
	          case SuspenseComponent: {
	            var suspenseState = returnFiber.memoizedState;
	            if (suspenseState.dehydrated !== null)
	              didNotHydrateInstanceWithinSuspenseInstance(suspenseState.dehydrated, instance);
	            break;
	          }
	        }
	      }
	    }
	    function deleteHydratableInstance(returnFiber, instance) {
	      warnUnhydratedInstance(returnFiber, instance);
	      var childToDelete = createFiberFromHostInstanceForDeletion();
	      childToDelete.stateNode = instance;
	      childToDelete.return = returnFiber;
	      var deletions = returnFiber.deletions;
	      if (deletions === null) {
	        returnFiber.deletions = [childToDelete];
	        returnFiber.flags |= ChildDeletion;
	      } else {
	        deletions.push(childToDelete);
	      }
	    }
	    function warnNonhydratedInstance(returnFiber, fiber) {
	      {
	        if (didSuspendOrErrorDEV) {
	          return;
	        }
	        switch (returnFiber.tag) {
	          case HostRoot: {
	            var parentContainer = returnFiber.stateNode.containerInfo;
	            switch (fiber.tag) {
	              case HostComponent:
	                var type = fiber.type;
	                fiber.pendingProps;
	                didNotFindHydratableInstanceWithinContainer(parentContainer, type);
	                break;
	              case HostText:
	                var text = fiber.pendingProps;
	                didNotFindHydratableTextInstanceWithinContainer(parentContainer, text);
	                break;
	            }
	            break;
	          }
	          case HostComponent: {
	            var parentType = returnFiber.type;
	            var parentProps = returnFiber.memoizedProps;
	            var parentInstance = returnFiber.stateNode;
	            switch (fiber.tag) {
	              case HostComponent: {
	                var _type = fiber.type;
	                var _props = fiber.pendingProps;
	                var isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
	                didNotFindHydratableInstance(
	                  parentType,
	                  parentProps,
	                  parentInstance,
	                  _type,
	                  _props,
	                  // TODO: Delete this argument when we remove the legacy root API.
	                  isConcurrentMode
	                );
	                break;
	              }
	              case HostText: {
	                var _text = fiber.pendingProps;
	                var _isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
	                didNotFindHydratableTextInstance(
	                  parentType,
	                  parentProps,
	                  parentInstance,
	                  _text,
	                  // TODO: Delete this argument when we remove the legacy root API.
	                  _isConcurrentMode
	                );
	                break;
	              }
	            }
	            break;
	          }
	          case SuspenseComponent: {
	            var suspenseState = returnFiber.memoizedState;
	            var _parentInstance = suspenseState.dehydrated;
	            if (_parentInstance !== null)
	              switch (fiber.tag) {
	                case HostComponent:
	                  var _type2 = fiber.type;
	                  fiber.pendingProps;
	                  didNotFindHydratableInstanceWithinSuspenseInstance(_parentInstance, _type2);
	                  break;
	                case HostText:
	                  var _text2 = fiber.pendingProps;
	                  didNotFindHydratableTextInstanceWithinSuspenseInstance(_parentInstance, _text2);
	                  break;
	              }
	            break;
	          }
	          default:
	            return;
	        }
	      }
	    }
	    function insertNonHydratedInstance(returnFiber, fiber) {
	      fiber.flags = fiber.flags & ~Hydrating | Placement;
	      warnNonhydratedInstance(returnFiber, fiber);
	    }
	    function tryHydrate(fiber, nextInstance) {
	      switch (fiber.tag) {
	        case HostComponent: {
	          var type = fiber.type;
	          fiber.pendingProps;
	          var instance = canHydrateInstance(nextInstance, type);
	          if (instance !== null) {
	            fiber.stateNode = instance;
	            hydrationParentFiber = fiber;
	            nextHydratableInstance = getFirstHydratableChild(instance);
	            return true;
	          }
	          return false;
	        }
	        case HostText: {
	          var text = fiber.pendingProps;
	          var textInstance = canHydrateTextInstance(nextInstance, text);
	          if (textInstance !== null) {
	            fiber.stateNode = textInstance;
	            hydrationParentFiber = fiber;
	            nextHydratableInstance = null;
	            return true;
	          }
	          return false;
	        }
	        case SuspenseComponent: {
	          var suspenseInstance = canHydrateSuspenseInstance(nextInstance);
	          if (suspenseInstance !== null) {
	            var suspenseState = {
	              dehydrated: suspenseInstance,
	              treeContext: getSuspendedTreeContext(),
	              retryLane: OffscreenLane
	            };
	            fiber.memoizedState = suspenseState;
	            var dehydratedFragment = createFiberFromDehydratedFragment(suspenseInstance);
	            dehydratedFragment.return = fiber;
	            fiber.child = dehydratedFragment;
	            hydrationParentFiber = fiber;
	            nextHydratableInstance = null;
	            return true;
	          }
	          return false;
	        }
	        default:
	          return false;
	      }
	    }
	    function shouldClientRenderOnMismatch(fiber) {
	      return (fiber.mode & ConcurrentMode) !== NoMode && (fiber.flags & DidCapture) === NoFlags;
	    }
	    function throwOnHydrationMismatch(fiber) {
	      throw new Error("Hydration failed because the initial UI does not match what was rendered on the server.");
	    }
	    function tryToClaimNextHydratableInstance(fiber) {
	      if (!isHydrating) {
	        return;
	      }
	      var nextInstance = nextHydratableInstance;
	      if (!nextInstance) {
	        if (shouldClientRenderOnMismatch(fiber)) {
	          warnNonhydratedInstance(hydrationParentFiber, fiber);
	          throwOnHydrationMismatch();
	        }
	        insertNonHydratedInstance(hydrationParentFiber, fiber);
	        isHydrating = false;
	        hydrationParentFiber = fiber;
	        return;
	      }
	      var firstAttemptedInstance = nextInstance;
	      if (!tryHydrate(fiber, nextInstance)) {
	        if (shouldClientRenderOnMismatch(fiber)) {
	          warnNonhydratedInstance(hydrationParentFiber, fiber);
	          throwOnHydrationMismatch();
	        }
	        nextInstance = getNextHydratableSibling(firstAttemptedInstance);
	        var prevHydrationParentFiber = hydrationParentFiber;
	        if (!nextInstance || !tryHydrate(fiber, nextInstance)) {
	          insertNonHydratedInstance(hydrationParentFiber, fiber);
	          isHydrating = false;
	          hydrationParentFiber = fiber;
	          return;
	        }
	        deleteHydratableInstance(prevHydrationParentFiber, firstAttemptedInstance);
	      }
	    }
	    function prepareToHydrateHostInstance(fiber, rootContainerInstance, hostContext) {
	      var instance = fiber.stateNode;
	      var shouldWarnIfMismatchDev = !didSuspendOrErrorDEV;
	      var updatePayload = hydrateInstance(instance, fiber.type, fiber.memoizedProps, rootContainerInstance, hostContext, fiber, shouldWarnIfMismatchDev);
	      fiber.updateQueue = updatePayload;
	      if (updatePayload !== null) {
	        return true;
	      }
	      return false;
	    }
	    function prepareToHydrateHostTextInstance(fiber) {
	      var textInstance = fiber.stateNode;
	      var textContent = fiber.memoizedProps;
	      var shouldUpdate = hydrateTextInstance(textInstance, textContent, fiber);
	      if (shouldUpdate) {
	        var returnFiber = hydrationParentFiber;
	        if (returnFiber !== null) {
	          switch (returnFiber.tag) {
	            case HostRoot: {
	              var parentContainer = returnFiber.stateNode.containerInfo;
	              var isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
	              didNotMatchHydratedContainerTextInstance(
	                parentContainer,
	                textInstance,
	                textContent,
	                // TODO: Delete this argument when we remove the legacy root API.
	                isConcurrentMode
	              );
	              break;
	            }
	            case HostComponent: {
	              var parentType = returnFiber.type;
	              var parentProps = returnFiber.memoizedProps;
	              var parentInstance = returnFiber.stateNode;
	              var _isConcurrentMode2 = (returnFiber.mode & ConcurrentMode) !== NoMode;
	              didNotMatchHydratedTextInstance(
	                parentType,
	                parentProps,
	                parentInstance,
	                textInstance,
	                textContent,
	                // TODO: Delete this argument when we remove the legacy root API.
	                _isConcurrentMode2
	              );
	              break;
	            }
	          }
	        }
	      }
	      return shouldUpdate;
	    }
	    function prepareToHydrateHostSuspenseInstance(fiber) {
	      var suspenseState = fiber.memoizedState;
	      var suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
	      if (!suspenseInstance) {
	        throw new Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      hydrateSuspenseInstance(suspenseInstance, fiber);
	    }
	    function skipPastDehydratedSuspenseInstance(fiber) {
	      var suspenseState = fiber.memoizedState;
	      var suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
	      if (!suspenseInstance) {
	        throw new Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      return getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance);
	    }
	    function popToNextHostParent(fiber) {
	      var parent = fiber.return;
	      while (parent !== null && parent.tag !== HostComponent && parent.tag !== HostRoot && parent.tag !== SuspenseComponent) {
	        parent = parent.return;
	      }
	      hydrationParentFiber = parent;
	    }
	    function popHydrationState(fiber) {
	      if (fiber !== hydrationParentFiber) {
	        return false;
	      }
	      if (!isHydrating) {
	        popToNextHostParent(fiber);
	        isHydrating = true;
	        return false;
	      }
	      if (fiber.tag !== HostRoot && (fiber.tag !== HostComponent || shouldDeleteUnhydratedTailInstances(fiber.type) && !shouldSetTextContent(fiber.type, fiber.memoizedProps))) {
	        var nextInstance = nextHydratableInstance;
	        if (nextInstance) {
	          if (shouldClientRenderOnMismatch(fiber)) {
	            warnIfUnhydratedTailNodes(fiber);
	            throwOnHydrationMismatch();
	          } else {
	            while (nextInstance) {
	              deleteHydratableInstance(fiber, nextInstance);
	              nextInstance = getNextHydratableSibling(nextInstance);
	            }
	          }
	        }
	      }
	      popToNextHostParent(fiber);
	      if (fiber.tag === SuspenseComponent) {
	        nextHydratableInstance = skipPastDehydratedSuspenseInstance(fiber);
	      } else {
	        nextHydratableInstance = hydrationParentFiber ? getNextHydratableSibling(fiber.stateNode) : null;
	      }
	      return true;
	    }
	    function hasUnhydratedTailNodes() {
	      return isHydrating && nextHydratableInstance !== null;
	    }
	    function warnIfUnhydratedTailNodes(fiber) {
	      var nextInstance = nextHydratableInstance;
	      while (nextInstance) {
	        warnUnhydratedInstance(fiber, nextInstance);
	        nextInstance = getNextHydratableSibling(nextInstance);
	      }
	    }
	    function resetHydrationState() {
	      hydrationParentFiber = null;
	      nextHydratableInstance = null;
	      isHydrating = false;
	      didSuspendOrErrorDEV = false;
	    }
	    function upgradeHydrationErrorsToRecoverable() {
	      if (hydrationErrors !== null) {
	        queueRecoverableErrors(hydrationErrors);
	        hydrationErrors = null;
	      }
	    }
	    function getIsHydrating() {
	      return isHydrating;
	    }
	    function queueHydrationError(error2) {
	      if (hydrationErrors === null) {
	        hydrationErrors = [error2];
	      } else {
	        hydrationErrors.push(error2);
	      }
	    }
	    var ReactCurrentBatchConfig$1 = ReactSharedInternals.ReactCurrentBatchConfig;
	    var NoTransition = null;
	    function requestCurrentTransition() {
	      return ReactCurrentBatchConfig$1.transition;
	    }
	    var ReactStrictModeWarnings = {
	      recordUnsafeLifecycleWarnings: function(fiber, instance) {
	      },
	      flushPendingUnsafeLifecycleWarnings: function() {
	      },
	      recordLegacyContextWarning: function(fiber, instance) {
	      },
	      flushLegacyContextWarning: function() {
	      },
	      discardPendingWarnings: function() {
	      }
	    };
	    {
	      var findStrictRoot = function(fiber) {
	        var maybeStrictRoot = null;
	        var node = fiber;
	        while (node !== null) {
	          if (node.mode & StrictLegacyMode) {
	            maybeStrictRoot = node;
	          }
	          node = node.return;
	        }
	        return maybeStrictRoot;
	      };
	      var setToSortedString = function(set2) {
	        var array = [];
	        set2.forEach(function(value) {
	          array.push(value);
	        });
	        return array.sort().join(", ");
	      };
	      var pendingComponentWillMountWarnings = [];
	      var pendingUNSAFE_ComponentWillMountWarnings = [];
	      var pendingComponentWillReceivePropsWarnings = [];
	      var pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
	      var pendingComponentWillUpdateWarnings = [];
	      var pendingUNSAFE_ComponentWillUpdateWarnings = [];
	      var didWarnAboutUnsafeLifecycles = /* @__PURE__ */ new Set();
	      ReactStrictModeWarnings.recordUnsafeLifecycleWarnings = function(fiber, instance) {
	        if (didWarnAboutUnsafeLifecycles.has(fiber.type)) {
	          return;
	        }
	        if (typeof instance.componentWillMount === "function" && // Don't warn about react-lifecycles-compat polyfilled components.
	        instance.componentWillMount.__suppressDeprecationWarning !== true) {
	          pendingComponentWillMountWarnings.push(fiber);
	        }
	        if (fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillMount === "function") {
	          pendingUNSAFE_ComponentWillMountWarnings.push(fiber);
	        }
	        if (typeof instance.componentWillReceiveProps === "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
	          pendingComponentWillReceivePropsWarnings.push(fiber);
	        }
	        if (fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillReceiveProps === "function") {
	          pendingUNSAFE_ComponentWillReceivePropsWarnings.push(fiber);
	        }
	        if (typeof instance.componentWillUpdate === "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
	          pendingComponentWillUpdateWarnings.push(fiber);
	        }
	        if (fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillUpdate === "function") {
	          pendingUNSAFE_ComponentWillUpdateWarnings.push(fiber);
	        }
	      };
	      ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings = function() {
	        var componentWillMountUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingComponentWillMountWarnings.length > 0) {
	          pendingComponentWillMountWarnings.forEach(function(fiber) {
	            componentWillMountUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingComponentWillMountWarnings = [];
	        }
	        var UNSAFE_componentWillMountUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingUNSAFE_ComponentWillMountWarnings.length > 0) {
	          pendingUNSAFE_ComponentWillMountWarnings.forEach(function(fiber) {
	            UNSAFE_componentWillMountUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingUNSAFE_ComponentWillMountWarnings = [];
	        }
	        var componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingComponentWillReceivePropsWarnings.length > 0) {
	          pendingComponentWillReceivePropsWarnings.forEach(function(fiber) {
	            componentWillReceivePropsUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingComponentWillReceivePropsWarnings = [];
	        }
	        var UNSAFE_componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingUNSAFE_ComponentWillReceivePropsWarnings.length > 0) {
	          pendingUNSAFE_ComponentWillReceivePropsWarnings.forEach(function(fiber) {
	            UNSAFE_componentWillReceivePropsUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
	        }
	        var componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingComponentWillUpdateWarnings.length > 0) {
	          pendingComponentWillUpdateWarnings.forEach(function(fiber) {
	            componentWillUpdateUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingComponentWillUpdateWarnings = [];
	        }
	        var UNSAFE_componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
	        if (pendingUNSAFE_ComponentWillUpdateWarnings.length > 0) {
	          pendingUNSAFE_ComponentWillUpdateWarnings.forEach(function(fiber) {
	            UNSAFE_componentWillUpdateUniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutUnsafeLifecycles.add(fiber.type);
	          });
	          pendingUNSAFE_ComponentWillUpdateWarnings = [];
	        }
	        if (UNSAFE_componentWillMountUniqueNames.size > 0) {
	          var sortedNames = setToSortedString(UNSAFE_componentWillMountUniqueNames);
	          error("Using UNSAFE_componentWillMount in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move code with side effects to componentDidMount, and set initial state in the constructor.\n\nPlease update the following components: %s", sortedNames);
	        }
	        if (UNSAFE_componentWillReceivePropsUniqueNames.size > 0) {
	          var _sortedNames = setToSortedString(UNSAFE_componentWillReceivePropsUniqueNames);
	          error("Using UNSAFE_componentWillReceiveProps in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state\n\nPlease update the following components: %s", _sortedNames);
	        }
	        if (UNSAFE_componentWillUpdateUniqueNames.size > 0) {
	          var _sortedNames2 = setToSortedString(UNSAFE_componentWillUpdateUniqueNames);
	          error("Using UNSAFE_componentWillUpdate in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n\nPlease update the following components: %s", _sortedNames2);
	        }
	        if (componentWillMountUniqueNames.size > 0) {
	          var _sortedNames3 = setToSortedString(componentWillMountUniqueNames);
	          warn("componentWillMount has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move code with side effects to componentDidMount, and set initial state in the constructor.\n* Rename componentWillMount to UNSAFE_componentWillMount to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames3);
	        }
	        if (componentWillReceivePropsUniqueNames.size > 0) {
	          var _sortedNames4 = setToSortedString(componentWillReceivePropsUniqueNames);
	          warn("componentWillReceiveProps has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state\n* Rename componentWillReceiveProps to UNSAFE_componentWillReceiveProps to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames4);
	        }
	        if (componentWillUpdateUniqueNames.size > 0) {
	          var _sortedNames5 = setToSortedString(componentWillUpdateUniqueNames);
	          warn("componentWillUpdate has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* Rename componentWillUpdate to UNSAFE_componentWillUpdate to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames5);
	        }
	      };
	      var pendingLegacyContextWarning = /* @__PURE__ */ new Map();
	      var didWarnAboutLegacyContext = /* @__PURE__ */ new Set();
	      ReactStrictModeWarnings.recordLegacyContextWarning = function(fiber, instance) {
	        var strictRoot = findStrictRoot(fiber);
	        if (strictRoot === null) {
	          error("Expected to find a StrictMode component in a strict mode tree. This error is likely caused by a bug in React. Please file an issue.");
	          return;
	        }
	        if (didWarnAboutLegacyContext.has(fiber.type)) {
	          return;
	        }
	        var warningsForRoot = pendingLegacyContextWarning.get(strictRoot);
	        if (fiber.type.contextTypes != null || fiber.type.childContextTypes != null || instance !== null && typeof instance.getChildContext === "function") {
	          if (warningsForRoot === void 0) {
	            warningsForRoot = [];
	            pendingLegacyContextWarning.set(strictRoot, warningsForRoot);
	          }
	          warningsForRoot.push(fiber);
	        }
	      };
	      ReactStrictModeWarnings.flushLegacyContextWarning = function() {
	        pendingLegacyContextWarning.forEach(function(fiberArray, strictRoot) {
	          if (fiberArray.length === 0) {
	            return;
	          }
	          var firstFiber = fiberArray[0];
	          var uniqueNames = /* @__PURE__ */ new Set();
	          fiberArray.forEach(function(fiber) {
	            uniqueNames.add(getComponentNameFromFiber(fiber) || "Component");
	            didWarnAboutLegacyContext.add(fiber.type);
	          });
	          var sortedNames = setToSortedString(uniqueNames);
	          try {
	            setCurrentFiber(firstFiber);
	            error("Legacy context API has been detected within a strict-mode tree.\n\nThe old API will be supported in all 16.x releases, but applications using it should migrate to the new version.\n\nPlease update the following components: %s\n\nLearn more about this warning here: https://reactjs.org/link/legacy-context", sortedNames);
	          } finally {
	            resetCurrentFiber();
	          }
	        });
	      };
	      ReactStrictModeWarnings.discardPendingWarnings = function() {
	        pendingComponentWillMountWarnings = [];
	        pendingUNSAFE_ComponentWillMountWarnings = [];
	        pendingComponentWillReceivePropsWarnings = [];
	        pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
	        pendingComponentWillUpdateWarnings = [];
	        pendingUNSAFE_ComponentWillUpdateWarnings = [];
	        pendingLegacyContextWarning = /* @__PURE__ */ new Map();
	      };
	    }
	    function resolveDefaultProps(Component, baseProps) {
	      if (Component && Component.defaultProps) {
	        var props = assign({}, baseProps);
	        var defaultProps = Component.defaultProps;
	        for (var propName in defaultProps) {
	          if (props[propName] === void 0) {
	            props[propName] = defaultProps[propName];
	          }
	        }
	        return props;
	      }
	      return baseProps;
	    }
	    var valueCursor = createCursor(null);
	    var rendererSigil;
	    {
	      rendererSigil = {};
	    }
	    var currentlyRenderingFiber = null;
	    var lastContextDependency = null;
	    var lastFullyObservedContext = null;
	    var isDisallowedContextReadInDEV = false;
	    function resetContextDependencies() {
	      currentlyRenderingFiber = null;
	      lastContextDependency = null;
	      lastFullyObservedContext = null;
	      {
	        isDisallowedContextReadInDEV = false;
	      }
	    }
	    function enterDisallowedContextReadInDEV() {
	      {
	        isDisallowedContextReadInDEV = true;
	      }
	    }
	    function exitDisallowedContextReadInDEV() {
	      {
	        isDisallowedContextReadInDEV = false;
	      }
	    }
	    function pushProvider(providerFiber, context, nextValue) {
	      {
	        push(valueCursor, context._currentValue, providerFiber);
	        context._currentValue = nextValue;
	        {
	          if (context._currentRenderer !== void 0 && context._currentRenderer !== null && context._currentRenderer !== rendererSigil) {
	            error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported.");
	          }
	          context._currentRenderer = rendererSigil;
	        }
	      }
	    }
	    function popProvider(context, providerFiber) {
	      var currentValue = valueCursor.current;
	      pop(valueCursor, providerFiber);
	      {
	        {
	          context._currentValue = currentValue;
	        }
	      }
	    }
	    function scheduleContextWorkOnParentPath(parent, renderLanes2, propagationRoot) {
	      var node = parent;
	      while (node !== null) {
	        var alternate = node.alternate;
	        if (!isSubsetOfLanes(node.childLanes, renderLanes2)) {
	          node.childLanes = mergeLanes(node.childLanes, renderLanes2);
	          if (alternate !== null) {
	            alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes2);
	          }
	        } else if (alternate !== null && !isSubsetOfLanes(alternate.childLanes, renderLanes2)) {
	          alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes2);
	        }
	        if (node === propagationRoot) {
	          break;
	        }
	        node = node.return;
	      }
	      {
	        if (node !== propagationRoot) {
	          error("Expected to find the propagation root when scheduling context work. This error is likely caused by a bug in React. Please file an issue.");
	        }
	      }
	    }
	    function propagateContextChange(workInProgress2, context, renderLanes2) {
	      {
	        propagateContextChange_eager(workInProgress2, context, renderLanes2);
	      }
	    }
	    function propagateContextChange_eager(workInProgress2, context, renderLanes2) {
	      var fiber = workInProgress2.child;
	      if (fiber !== null) {
	        fiber.return = workInProgress2;
	      }
	      while (fiber !== null) {
	        var nextFiber = void 0;
	        var list = fiber.dependencies;
	        if (list !== null) {
	          nextFiber = fiber.child;
	          var dependency = list.firstContext;
	          while (dependency !== null) {
	            if (dependency.context === context) {
	              if (fiber.tag === ClassComponent) {
	                var lane = pickArbitraryLane(renderLanes2);
	                var update = createUpdate(NoTimestamp, lane);
	                update.tag = ForceUpdate;
	                var updateQueue = fiber.updateQueue;
	                if (updateQueue === null)
	                  ;
	                else {
	                  var sharedQueue = updateQueue.shared;
	                  var pending = sharedQueue.pending;
	                  if (pending === null) {
	                    update.next = update;
	                  } else {
	                    update.next = pending.next;
	                    pending.next = update;
	                  }
	                  sharedQueue.pending = update;
	                }
	              }
	              fiber.lanes = mergeLanes(fiber.lanes, renderLanes2);
	              var alternate = fiber.alternate;
	              if (alternate !== null) {
	                alternate.lanes = mergeLanes(alternate.lanes, renderLanes2);
	              }
	              scheduleContextWorkOnParentPath(fiber.return, renderLanes2, workInProgress2);
	              list.lanes = mergeLanes(list.lanes, renderLanes2);
	              break;
	            }
	            dependency = dependency.next;
	          }
	        } else if (fiber.tag === ContextProvider) {
	          nextFiber = fiber.type === workInProgress2.type ? null : fiber.child;
	        } else if (fiber.tag === DehydratedFragment) {
	          var parentSuspense = fiber.return;
	          if (parentSuspense === null) {
	            throw new Error("We just came from a parent so we must have had a parent. This is a bug in React.");
	          }
	          parentSuspense.lanes = mergeLanes(parentSuspense.lanes, renderLanes2);
	          var _alternate = parentSuspense.alternate;
	          if (_alternate !== null) {
	            _alternate.lanes = mergeLanes(_alternate.lanes, renderLanes2);
	          }
	          scheduleContextWorkOnParentPath(parentSuspense, renderLanes2, workInProgress2);
	          nextFiber = fiber.sibling;
	        } else {
	          nextFiber = fiber.child;
	        }
	        if (nextFiber !== null) {
	          nextFiber.return = fiber;
	        } else {
	          nextFiber = fiber;
	          while (nextFiber !== null) {
	            if (nextFiber === workInProgress2) {
	              nextFiber = null;
	              break;
	            }
	            var sibling = nextFiber.sibling;
	            if (sibling !== null) {
	              sibling.return = nextFiber.return;
	              nextFiber = sibling;
	              break;
	            }
	            nextFiber = nextFiber.return;
	          }
	        }
	        fiber = nextFiber;
	      }
	    }
	    function prepareToReadContext(workInProgress2, renderLanes2) {
	      currentlyRenderingFiber = workInProgress2;
	      lastContextDependency = null;
	      lastFullyObservedContext = null;
	      var dependencies = workInProgress2.dependencies;
	      if (dependencies !== null) {
	        {
	          var firstContext = dependencies.firstContext;
	          if (firstContext !== null) {
	            if (includesSomeLane(dependencies.lanes, renderLanes2)) {
	              markWorkInProgressReceivedUpdate();
	            }
	            dependencies.firstContext = null;
	          }
	        }
	      }
	    }
	    function readContext(context) {
	      {
	        if (isDisallowedContextReadInDEV) {
	          error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
	        }
	      }
	      var value = context._currentValue;
	      if (lastFullyObservedContext === context)
	        ;
	      else {
	        var contextItem = {
	          context,
	          memoizedValue: value,
	          next: null
	        };
	        if (lastContextDependency === null) {
	          if (currentlyRenderingFiber === null) {
	            throw new Error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
	          }
	          lastContextDependency = contextItem;
	          currentlyRenderingFiber.dependencies = {
	            lanes: NoLanes,
	            firstContext: contextItem
	          };
	        } else {
	          lastContextDependency = lastContextDependency.next = contextItem;
	        }
	      }
	      return value;
	    }
	    var concurrentQueues = null;
	    function pushConcurrentUpdateQueue(queue) {
	      if (concurrentQueues === null) {
	        concurrentQueues = [queue];
	      } else {
	        concurrentQueues.push(queue);
	      }
	    }
	    function finishQueueingConcurrentUpdates() {
	      if (concurrentQueues !== null) {
	        for (var i = 0; i < concurrentQueues.length; i++) {
	          var queue = concurrentQueues[i];
	          var lastInterleavedUpdate = queue.interleaved;
	          if (lastInterleavedUpdate !== null) {
	            queue.interleaved = null;
	            var firstInterleavedUpdate = lastInterleavedUpdate.next;
	            var lastPendingUpdate = queue.pending;
	            if (lastPendingUpdate !== null) {
	              var firstPendingUpdate = lastPendingUpdate.next;
	              lastPendingUpdate.next = firstInterleavedUpdate;
	              lastInterleavedUpdate.next = firstPendingUpdate;
	            }
	            queue.pending = lastInterleavedUpdate;
	          }
	        }
	        concurrentQueues = null;
	      }
	    }
	    function enqueueConcurrentHookUpdate(fiber, queue, update, lane) {
	      var interleaved = queue.interleaved;
	      if (interleaved === null) {
	        update.next = update;
	        pushConcurrentUpdateQueue(queue);
	      } else {
	        update.next = interleaved.next;
	        interleaved.next = update;
	      }
	      queue.interleaved = update;
	      return markUpdateLaneFromFiberToRoot(fiber, lane);
	    }
	    function enqueueConcurrentHookUpdateAndEagerlyBailout(fiber, queue, update, lane) {
	      var interleaved = queue.interleaved;
	      if (interleaved === null) {
	        update.next = update;
	        pushConcurrentUpdateQueue(queue);
	      } else {
	        update.next = interleaved.next;
	        interleaved.next = update;
	      }
	      queue.interleaved = update;
	    }
	    function enqueueConcurrentClassUpdate(fiber, queue, update, lane) {
	      var interleaved = queue.interleaved;
	      if (interleaved === null) {
	        update.next = update;
	        pushConcurrentUpdateQueue(queue);
	      } else {
	        update.next = interleaved.next;
	        interleaved.next = update;
	      }
	      queue.interleaved = update;
	      return markUpdateLaneFromFiberToRoot(fiber, lane);
	    }
	    function enqueueConcurrentRenderForLane(fiber, lane) {
	      return markUpdateLaneFromFiberToRoot(fiber, lane);
	    }
	    var unsafe_markUpdateLaneFromFiberToRoot = markUpdateLaneFromFiberToRoot;
	    function markUpdateLaneFromFiberToRoot(sourceFiber, lane) {
	      sourceFiber.lanes = mergeLanes(sourceFiber.lanes, lane);
	      var alternate = sourceFiber.alternate;
	      if (alternate !== null) {
	        alternate.lanes = mergeLanes(alternate.lanes, lane);
	      }
	      {
	        if (alternate === null && (sourceFiber.flags & (Placement | Hydrating)) !== NoFlags) {
	          warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber);
	        }
	      }
	      var node = sourceFiber;
	      var parent = sourceFiber.return;
	      while (parent !== null) {
	        parent.childLanes = mergeLanes(parent.childLanes, lane);
	        alternate = parent.alternate;
	        if (alternate !== null) {
	          alternate.childLanes = mergeLanes(alternate.childLanes, lane);
	        } else {
	          {
	            if ((parent.flags & (Placement | Hydrating)) !== NoFlags) {
	              warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber);
	            }
	          }
	        }
	        node = parent;
	        parent = parent.return;
	      }
	      if (node.tag === HostRoot) {
	        var root2 = node.stateNode;
	        return root2;
	      } else {
	        return null;
	      }
	    }
	    var UpdateState = 0;
	    var ReplaceState = 1;
	    var ForceUpdate = 2;
	    var CaptureUpdate = 3;
	    var hasForceUpdate = false;
	    var didWarnUpdateInsideUpdate;
	    var currentlyProcessingQueue;
	    {
	      didWarnUpdateInsideUpdate = false;
	      currentlyProcessingQueue = null;
	    }
	    function initializeUpdateQueue(fiber) {
	      var queue = {
	        baseState: fiber.memoizedState,
	        firstBaseUpdate: null,
	        lastBaseUpdate: null,
	        shared: {
	          pending: null,
	          interleaved: null,
	          lanes: NoLanes
	        },
	        effects: null
	      };
	      fiber.updateQueue = queue;
	    }
	    function cloneUpdateQueue(current2, workInProgress2) {
	      var queue = workInProgress2.updateQueue;
	      var currentQueue = current2.updateQueue;
	      if (queue === currentQueue) {
	        var clone = {
	          baseState: currentQueue.baseState,
	          firstBaseUpdate: currentQueue.firstBaseUpdate,
	          lastBaseUpdate: currentQueue.lastBaseUpdate,
	          shared: currentQueue.shared,
	          effects: currentQueue.effects
	        };
	        workInProgress2.updateQueue = clone;
	      }
	    }
	    function createUpdate(eventTime, lane) {
	      var update = {
	        eventTime,
	        lane,
	        tag: UpdateState,
	        payload: null,
	        callback: null,
	        next: null
	      };
	      return update;
	    }
	    function enqueueUpdate(fiber, update, lane) {
	      var updateQueue = fiber.updateQueue;
	      if (updateQueue === null) {
	        return null;
	      }
	      var sharedQueue = updateQueue.shared;
	      {
	        if (currentlyProcessingQueue === sharedQueue && !didWarnUpdateInsideUpdate) {
	          error("An update (setState, replaceState, or forceUpdate) was scheduled from inside an update function. Update functions should be pure, with zero side-effects. Consider using componentDidUpdate or a callback.");
	          didWarnUpdateInsideUpdate = true;
	        }
	      }
	      if (isUnsafeClassRenderPhaseUpdate()) {
	        var pending = sharedQueue.pending;
	        if (pending === null) {
	          update.next = update;
	        } else {
	          update.next = pending.next;
	          pending.next = update;
	        }
	        sharedQueue.pending = update;
	        return unsafe_markUpdateLaneFromFiberToRoot(fiber, lane);
	      } else {
	        return enqueueConcurrentClassUpdate(fiber, sharedQueue, update, lane);
	      }
	    }
	    function entangleTransitions(root2, fiber, lane) {
	      var updateQueue = fiber.updateQueue;
	      if (updateQueue === null) {
	        return;
	      }
	      var sharedQueue = updateQueue.shared;
	      if (isTransitionLane(lane)) {
	        var queueLanes = sharedQueue.lanes;
	        queueLanes = intersectLanes(queueLanes, root2.pendingLanes);
	        var newQueueLanes = mergeLanes(queueLanes, lane);
	        sharedQueue.lanes = newQueueLanes;
	        markRootEntangled(root2, newQueueLanes);
	      }
	    }
	    function enqueueCapturedUpdate(workInProgress2, capturedUpdate) {
	      var queue = workInProgress2.updateQueue;
	      var current2 = workInProgress2.alternate;
	      if (current2 !== null) {
	        var currentQueue = current2.updateQueue;
	        if (queue === currentQueue) {
	          var newFirst = null;
	          var newLast = null;
	          var firstBaseUpdate = queue.firstBaseUpdate;
	          if (firstBaseUpdate !== null) {
	            var update = firstBaseUpdate;
	            do {
	              var clone = {
	                eventTime: update.eventTime,
	                lane: update.lane,
	                tag: update.tag,
	                payload: update.payload,
	                callback: update.callback,
	                next: null
	              };
	              if (newLast === null) {
	                newFirst = newLast = clone;
	              } else {
	                newLast.next = clone;
	                newLast = clone;
	              }
	              update = update.next;
	            } while (update !== null);
	            if (newLast === null) {
	              newFirst = newLast = capturedUpdate;
	            } else {
	              newLast.next = capturedUpdate;
	              newLast = capturedUpdate;
	            }
	          } else {
	            newFirst = newLast = capturedUpdate;
	          }
	          queue = {
	            baseState: currentQueue.baseState,
	            firstBaseUpdate: newFirst,
	            lastBaseUpdate: newLast,
	            shared: currentQueue.shared,
	            effects: currentQueue.effects
	          };
	          workInProgress2.updateQueue = queue;
	          return;
	        }
	      }
	      var lastBaseUpdate = queue.lastBaseUpdate;
	      if (lastBaseUpdate === null) {
	        queue.firstBaseUpdate = capturedUpdate;
	      } else {
	        lastBaseUpdate.next = capturedUpdate;
	      }
	      queue.lastBaseUpdate = capturedUpdate;
	    }
	    function getStateFromUpdate(workInProgress2, queue, update, prevState, nextProps, instance) {
	      switch (update.tag) {
	        case ReplaceState: {
	          var payload = update.payload;
	          if (typeof payload === "function") {
	            {
	              enterDisallowedContextReadInDEV();
	            }
	            var nextState = payload.call(instance, prevState, nextProps);
	            {
	              if (workInProgress2.mode & StrictLegacyMode) {
	                setIsStrictModeForDevtools(true);
	                try {
	                  payload.call(instance, prevState, nextProps);
	                } finally {
	                  setIsStrictModeForDevtools(false);
	                }
	              }
	              exitDisallowedContextReadInDEV();
	            }
	            return nextState;
	          }
	          return payload;
	        }
	        case CaptureUpdate: {
	          workInProgress2.flags = workInProgress2.flags & ~ShouldCapture | DidCapture;
	        }
	        case UpdateState: {
	          var _payload = update.payload;
	          var partialState;
	          if (typeof _payload === "function") {
	            {
	              enterDisallowedContextReadInDEV();
	            }
	            partialState = _payload.call(instance, prevState, nextProps);
	            {
	              if (workInProgress2.mode & StrictLegacyMode) {
	                setIsStrictModeForDevtools(true);
	                try {
	                  _payload.call(instance, prevState, nextProps);
	                } finally {
	                  setIsStrictModeForDevtools(false);
	                }
	              }
	              exitDisallowedContextReadInDEV();
	            }
	          } else {
	            partialState = _payload;
	          }
	          if (partialState === null || partialState === void 0) {
	            return prevState;
	          }
	          return assign({}, prevState, partialState);
	        }
	        case ForceUpdate: {
	          hasForceUpdate = true;
	          return prevState;
	        }
	      }
	      return prevState;
	    }
	    function processUpdateQueue(workInProgress2, props, instance, renderLanes2) {
	      var queue = workInProgress2.updateQueue;
	      hasForceUpdate = false;
	      {
	        currentlyProcessingQueue = queue.shared;
	      }
	      var firstBaseUpdate = queue.firstBaseUpdate;
	      var lastBaseUpdate = queue.lastBaseUpdate;
	      var pendingQueue = queue.shared.pending;
	      if (pendingQueue !== null) {
	        queue.shared.pending = null;
	        var lastPendingUpdate = pendingQueue;
	        var firstPendingUpdate = lastPendingUpdate.next;
	        lastPendingUpdate.next = null;
	        if (lastBaseUpdate === null) {
	          firstBaseUpdate = firstPendingUpdate;
	        } else {
	          lastBaseUpdate.next = firstPendingUpdate;
	        }
	        lastBaseUpdate = lastPendingUpdate;
	        var current2 = workInProgress2.alternate;
	        if (current2 !== null) {
	          var currentQueue = current2.updateQueue;
	          var currentLastBaseUpdate = currentQueue.lastBaseUpdate;
	          if (currentLastBaseUpdate !== lastBaseUpdate) {
	            if (currentLastBaseUpdate === null) {
	              currentQueue.firstBaseUpdate = firstPendingUpdate;
	            } else {
	              currentLastBaseUpdate.next = firstPendingUpdate;
	            }
	            currentQueue.lastBaseUpdate = lastPendingUpdate;
	          }
	        }
	      }
	      if (firstBaseUpdate !== null) {
	        var newState = queue.baseState;
	        var newLanes = NoLanes;
	        var newBaseState = null;
	        var newFirstBaseUpdate = null;
	        var newLastBaseUpdate = null;
	        var update = firstBaseUpdate;
	        do {
	          var updateLane = update.lane;
	          var updateEventTime = update.eventTime;
	          if (!isSubsetOfLanes(renderLanes2, updateLane)) {
	            var clone = {
	              eventTime: updateEventTime,
	              lane: updateLane,
	              tag: update.tag,
	              payload: update.payload,
	              callback: update.callback,
	              next: null
	            };
	            if (newLastBaseUpdate === null) {
	              newFirstBaseUpdate = newLastBaseUpdate = clone;
	              newBaseState = newState;
	            } else {
	              newLastBaseUpdate = newLastBaseUpdate.next = clone;
	            }
	            newLanes = mergeLanes(newLanes, updateLane);
	          } else {
	            if (newLastBaseUpdate !== null) {
	              var _clone = {
	                eventTime: updateEventTime,
	                // This update is going to be committed so we never want uncommit
	                // it. Using NoLane works because 0 is a subset of all bitmasks, so
	                // this will never be skipped by the check above.
	                lane: NoLane,
	                tag: update.tag,
	                payload: update.payload,
	                callback: update.callback,
	                next: null
	              };
	              newLastBaseUpdate = newLastBaseUpdate.next = _clone;
	            }
	            newState = getStateFromUpdate(workInProgress2, queue, update, newState, props, instance);
	            var callback = update.callback;
	            if (callback !== null && // If the update was already committed, we should not queue its
	            // callback again.
	            update.lane !== NoLane) {
	              workInProgress2.flags |= Callback;
	              var effects = queue.effects;
	              if (effects === null) {
	                queue.effects = [update];
	              } else {
	                effects.push(update);
	              }
	            }
	          }
	          update = update.next;
	          if (update === null) {
	            pendingQueue = queue.shared.pending;
	            if (pendingQueue === null) {
	              break;
	            } else {
	              var _lastPendingUpdate = pendingQueue;
	              var _firstPendingUpdate = _lastPendingUpdate.next;
	              _lastPendingUpdate.next = null;
	              update = _firstPendingUpdate;
	              queue.lastBaseUpdate = _lastPendingUpdate;
	              queue.shared.pending = null;
	            }
	          }
	        } while (true);
	        if (newLastBaseUpdate === null) {
	          newBaseState = newState;
	        }
	        queue.baseState = newBaseState;
	        queue.firstBaseUpdate = newFirstBaseUpdate;
	        queue.lastBaseUpdate = newLastBaseUpdate;
	        var lastInterleaved = queue.shared.interleaved;
	        if (lastInterleaved !== null) {
	          var interleaved = lastInterleaved;
	          do {
	            newLanes = mergeLanes(newLanes, interleaved.lane);
	            interleaved = interleaved.next;
	          } while (interleaved !== lastInterleaved);
	        } else if (firstBaseUpdate === null) {
	          queue.shared.lanes = NoLanes;
	        }
	        markSkippedUpdateLanes(newLanes);
	        workInProgress2.lanes = newLanes;
	        workInProgress2.memoizedState = newState;
	      }
	      {
	        currentlyProcessingQueue = null;
	      }
	    }
	    function callCallback(callback, context) {
	      if (typeof callback !== "function") {
	        throw new Error("Invalid argument passed as callback. Expected a function. Instead " + ("received: " + callback));
	      }
	      callback.call(context);
	    }
	    function resetHasForceUpdateBeforeProcessing() {
	      hasForceUpdate = false;
	    }
	    function checkHasForceUpdateAfterProcessing() {
	      return hasForceUpdate;
	    }
	    function commitUpdateQueue(finishedWork, finishedQueue, instance) {
	      var effects = finishedQueue.effects;
	      finishedQueue.effects = null;
	      if (effects !== null) {
	        for (var i = 0; i < effects.length; i++) {
	          var effect = effects[i];
	          var callback = effect.callback;
	          if (callback !== null) {
	            effect.callback = null;
	            callCallback(callback, instance);
	          }
	        }
	      }
	    }
	    var fakeInternalInstance = {};
	    var emptyRefsObject = new React.Component().refs;
	    var didWarnAboutStateAssignmentForComponent;
	    var didWarnAboutUninitializedState;
	    var didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate;
	    var didWarnAboutLegacyLifecyclesAndDerivedState;
	    var didWarnAboutUndefinedDerivedState;
	    var warnOnUndefinedDerivedState;
	    var warnOnInvalidCallback;
	    var didWarnAboutDirectlyAssigningPropsToState;
	    var didWarnAboutContextTypeAndContextTypes;
	    var didWarnAboutInvalidateContextType;
	    {
	      didWarnAboutStateAssignmentForComponent = /* @__PURE__ */ new Set();
	      didWarnAboutUninitializedState = /* @__PURE__ */ new Set();
	      didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = /* @__PURE__ */ new Set();
	      didWarnAboutLegacyLifecyclesAndDerivedState = /* @__PURE__ */ new Set();
	      didWarnAboutDirectlyAssigningPropsToState = /* @__PURE__ */ new Set();
	      didWarnAboutUndefinedDerivedState = /* @__PURE__ */ new Set();
	      didWarnAboutContextTypeAndContextTypes = /* @__PURE__ */ new Set();
	      didWarnAboutInvalidateContextType = /* @__PURE__ */ new Set();
	      var didWarnOnInvalidCallback = /* @__PURE__ */ new Set();
	      warnOnInvalidCallback = function(callback, callerName) {
	        if (callback === null || typeof callback === "function") {
	          return;
	        }
	        var key = callerName + "_" + callback;
	        if (!didWarnOnInvalidCallback.has(key)) {
	          didWarnOnInvalidCallback.add(key);
	          error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback);
	        }
	      };
	      warnOnUndefinedDerivedState = function(type, partialState) {
	        if (partialState === void 0) {
	          var componentName = getComponentNameFromType(type) || "Component";
	          if (!didWarnAboutUndefinedDerivedState.has(componentName)) {
	            didWarnAboutUndefinedDerivedState.add(componentName);
	            error("%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. You have returned undefined.", componentName);
	          }
	        }
	      };
	      Object.defineProperty(fakeInternalInstance, "_processChildContext", {
	        enumerable: false,
	        value: function() {
	          throw new Error("_processChildContext is not available in React 16+. This likely means you have multiple copies of React and are attempting to nest a React 15 tree inside a React 16 tree using unstable_renderSubtreeIntoContainer, which isn't supported. Try to make sure you have only one copy of React (and ideally, switch to ReactDOM.createPortal).");
	        }
	      });
	      Object.freeze(fakeInternalInstance);
	    }
	    function applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, nextProps) {
	      var prevState = workInProgress2.memoizedState;
	      var partialState = getDerivedStateFromProps(nextProps, prevState);
	      {
	        if (workInProgress2.mode & StrictLegacyMode) {
	          setIsStrictModeForDevtools(true);
	          try {
	            partialState = getDerivedStateFromProps(nextProps, prevState);
	          } finally {
	            setIsStrictModeForDevtools(false);
	          }
	        }
	        warnOnUndefinedDerivedState(ctor, partialState);
	      }
	      var memoizedState = partialState === null || partialState === void 0 ? prevState : assign({}, prevState, partialState);
	      workInProgress2.memoizedState = memoizedState;
	      if (workInProgress2.lanes === NoLanes) {
	        var updateQueue = workInProgress2.updateQueue;
	        updateQueue.baseState = memoizedState;
	      }
	    }
	    var classComponentUpdater = {
	      isMounted,
	      enqueueSetState: function(inst, payload, callback) {
	        var fiber = get(inst);
	        var eventTime = requestEventTime();
	        var lane = requestUpdateLane(fiber);
	        var update = createUpdate(eventTime, lane);
	        update.payload = payload;
	        if (callback !== void 0 && callback !== null) {
	          {
	            warnOnInvalidCallback(callback, "setState");
	          }
	          update.callback = callback;
	        }
	        var root2 = enqueueUpdate(fiber, update, lane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	          entangleTransitions(root2, fiber, lane);
	        }
	        {
	          markStateUpdateScheduled(fiber, lane);
	        }
	      },
	      enqueueReplaceState: function(inst, payload, callback) {
	        var fiber = get(inst);
	        var eventTime = requestEventTime();
	        var lane = requestUpdateLane(fiber);
	        var update = createUpdate(eventTime, lane);
	        update.tag = ReplaceState;
	        update.payload = payload;
	        if (callback !== void 0 && callback !== null) {
	          {
	            warnOnInvalidCallback(callback, "replaceState");
	          }
	          update.callback = callback;
	        }
	        var root2 = enqueueUpdate(fiber, update, lane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	          entangleTransitions(root2, fiber, lane);
	        }
	        {
	          markStateUpdateScheduled(fiber, lane);
	        }
	      },
	      enqueueForceUpdate: function(inst, callback) {
	        var fiber = get(inst);
	        var eventTime = requestEventTime();
	        var lane = requestUpdateLane(fiber);
	        var update = createUpdate(eventTime, lane);
	        update.tag = ForceUpdate;
	        if (callback !== void 0 && callback !== null) {
	          {
	            warnOnInvalidCallback(callback, "forceUpdate");
	          }
	          update.callback = callback;
	        }
	        var root2 = enqueueUpdate(fiber, update, lane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	          entangleTransitions(root2, fiber, lane);
	        }
	        {
	          markForceUpdateScheduled(fiber, lane);
	        }
	      }
	    };
	    function checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext) {
	      var instance = workInProgress2.stateNode;
	      if (typeof instance.shouldComponentUpdate === "function") {
	        var shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);
	        {
	          if (workInProgress2.mode & StrictLegacyMode) {
	            setIsStrictModeForDevtools(true);
	            try {
	              shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);
	            } finally {
	              setIsStrictModeForDevtools(false);
	            }
	          }
	          if (shouldUpdate === void 0) {
	            error("%s.shouldComponentUpdate(): Returned undefined instead of a boolean value. Make sure to return true or false.", getComponentNameFromType(ctor) || "Component");
	          }
	        }
	        return shouldUpdate;
	      }
	      if (ctor.prototype && ctor.prototype.isPureReactComponent) {
	        return !shallowEqual(oldProps, newProps) || !shallowEqual(oldState, newState);
	      }
	      return true;
	    }
	    function checkClassInstance(workInProgress2, ctor, newProps) {
	      var instance = workInProgress2.stateNode;
	      {
	        var name = getComponentNameFromType(ctor) || "Component";
	        var renderPresent = instance.render;
	        if (!renderPresent) {
	          if (ctor.prototype && typeof ctor.prototype.render === "function") {
	            error("%s(...): No `render` method found on the returned component instance: did you accidentally return an object from the constructor?", name);
	          } else {
	            error("%s(...): No `render` method found on the returned component instance: you may have forgotten to define `render`.", name);
	          }
	        }
	        if (instance.getInitialState && !instance.getInitialState.isReactClassApproved && !instance.state) {
	          error("getInitialState was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Did you mean to define a state property instead?", name);
	        }
	        if (instance.getDefaultProps && !instance.getDefaultProps.isReactClassApproved) {
	          error("getDefaultProps was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Use a static property to define defaultProps instead.", name);
	        }
	        if (instance.propTypes) {
	          error("propTypes was defined as an instance property on %s. Use a static property to define propTypes instead.", name);
	        }
	        if (instance.contextType) {
	          error("contextType was defined as an instance property on %s. Use a static property to define contextType instead.", name);
	        }
	        {
	          if (instance.contextTypes) {
	            error("contextTypes was defined as an instance property on %s. Use a static property to define contextTypes instead.", name);
	          }
	          if (ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor)) {
	            didWarnAboutContextTypeAndContextTypes.add(ctor);
	            error("%s declares both contextTypes and contextType static properties. The legacy contextTypes property will be ignored.", name);
	          }
	        }
	        if (typeof instance.componentShouldUpdate === "function") {
	          error("%s has a method called componentShouldUpdate(). Did you mean shouldComponentUpdate()? The name is phrased as a question because the function is expected to return a value.", name);
	        }
	        if (ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate !== "undefined") {
	          error("%s has a method called shouldComponentUpdate(). shouldComponentUpdate should not be used when extending React.PureComponent. Please extend React.Component if shouldComponentUpdate is used.", getComponentNameFromType(ctor) || "A pure component");
	        }
	        if (typeof instance.componentDidUnmount === "function") {
	          error("%s has a method called componentDidUnmount(). But there is no such lifecycle method. Did you mean componentWillUnmount()?", name);
	        }
	        if (typeof instance.componentDidReceiveProps === "function") {
	          error("%s has a method called componentDidReceiveProps(). But there is no such lifecycle method. If you meant to update the state in response to changing props, use componentWillReceiveProps(). If you meant to fetch data or run side-effects or mutations after React has updated the UI, use componentDidUpdate().", name);
	        }
	        if (typeof instance.componentWillRecieveProps === "function") {
	          error("%s has a method called componentWillRecieveProps(). Did you mean componentWillReceiveProps()?", name);
	        }
	        if (typeof instance.UNSAFE_componentWillRecieveProps === "function") {
	          error("%s has a method called UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?", name);
	        }
	        var hasMutatedProps = instance.props !== newProps;
	        if (instance.props !== void 0 && hasMutatedProps) {
	          error("%s(...): When calling super() in `%s`, make sure to pass up the same props that your component's constructor was passed.", name, name);
	        }
	        if (instance.defaultProps) {
	          error("Setting defaultProps as an instance property on %s is not supported and will be ignored. Instead, define defaultProps as a static property on %s.", name, name);
	        }
	        if (typeof instance.getSnapshotBeforeUpdate === "function" && typeof instance.componentDidUpdate !== "function" && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor)) {
	          didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor);
	          error("%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). This component defines getSnapshotBeforeUpdate() only.", getComponentNameFromType(ctor));
	        }
	        if (typeof instance.getDerivedStateFromProps === "function") {
	          error("%s: getDerivedStateFromProps() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name);
	        }
	        if (typeof instance.getDerivedStateFromError === "function") {
	          error("%s: getDerivedStateFromError() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name);
	        }
	        if (typeof ctor.getSnapshotBeforeUpdate === "function") {
	          error("%s: getSnapshotBeforeUpdate() is defined as a static method and will be ignored. Instead, declare it as an instance method.", name);
	        }
	        var _state = instance.state;
	        if (_state && (typeof _state !== "object" || isArray(_state))) {
	          error("%s.state: must be set to an object or null", name);
	        }
	        if (typeof instance.getChildContext === "function" && typeof ctor.childContextTypes !== "object") {
	          error("%s.getChildContext(): childContextTypes must be defined in order to use getChildContext().", name);
	        }
	      }
	    }
	    function adoptClassInstance(workInProgress2, instance) {
	      instance.updater = classComponentUpdater;
	      workInProgress2.stateNode = instance;
	      set(instance, workInProgress2);
	      {
	        instance._reactInternalInstance = fakeInternalInstance;
	      }
	    }
	    function constructClassInstance(workInProgress2, ctor, props) {
	      var isLegacyContextConsumer = false;
	      var unmaskedContext = emptyContextObject;
	      var context = emptyContextObject;
	      var contextType = ctor.contextType;
	      {
	        if ("contextType" in ctor) {
	          var isValid = (
	            // Allow null for conditional declaration
	            contextType === null || contextType !== void 0 && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === void 0
	          );
	          if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
	            didWarnAboutInvalidateContextType.add(ctor);
	            var addendum = "";
	            if (contextType === void 0) {
	              addendum = " However, it is set to undefined. This can be caused by a typo or by mixing up named and default imports. This can also happen due to a circular dependency, so try moving the createContext() call to a separate file.";
	            } else if (typeof contextType !== "object") {
	              addendum = " However, it is set to a " + typeof contextType + ".";
	            } else if (contextType.$$typeof === REACT_PROVIDER_TYPE) {
	              addendum = " Did you accidentally pass the Context.Provider instead?";
	            } else if (contextType._context !== void 0) {
	              addendum = " Did you accidentally pass the Context.Consumer instead?";
	            } else {
	              addendum = " However, it is set to an object with keys {" + Object.keys(contextType).join(", ") + "}.";
	            }
	            error("%s defines an invalid contextType. contextType should point to the Context object returned by React.createContext().%s", getComponentNameFromType(ctor) || "Component", addendum);
	          }
	        }
	      }
	      if (typeof contextType === "object" && contextType !== null) {
	        context = readContext(contextType);
	      } else {
	        unmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
	        var contextTypes = ctor.contextTypes;
	        isLegacyContextConsumer = contextTypes !== null && contextTypes !== void 0;
	        context = isLegacyContextConsumer ? getMaskedContext(workInProgress2, unmaskedContext) : emptyContextObject;
	      }
	      var instance = new ctor(props, context);
	      {
	        if (workInProgress2.mode & StrictLegacyMode) {
	          setIsStrictModeForDevtools(true);
	          try {
	            instance = new ctor(props, context);
	          } finally {
	            setIsStrictModeForDevtools(false);
	          }
	        }
	      }
	      var state = workInProgress2.memoizedState = instance.state !== null && instance.state !== void 0 ? instance.state : null;
	      adoptClassInstance(workInProgress2, instance);
	      {
	        if (typeof ctor.getDerivedStateFromProps === "function" && state === null) {
	          var componentName = getComponentNameFromType(ctor) || "Component";
	          if (!didWarnAboutUninitializedState.has(componentName)) {
	            didWarnAboutUninitializedState.add(componentName);
	            error("`%s` uses `getDerivedStateFromProps` but its initial state is %s. This is not recommended. Instead, define the initial state by assigning an object to `this.state` in the constructor of `%s`. This ensures that `getDerivedStateFromProps` arguments have a consistent shape.", componentName, instance.state === null ? "null" : "undefined", componentName);
	          }
	        }
	        if (typeof ctor.getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function") {
	          var foundWillMountName = null;
	          var foundWillReceivePropsName = null;
	          var foundWillUpdateName = null;
	          if (typeof instance.componentWillMount === "function" && instance.componentWillMount.__suppressDeprecationWarning !== true) {
	            foundWillMountName = "componentWillMount";
	          } else if (typeof instance.UNSAFE_componentWillMount === "function") {
	            foundWillMountName = "UNSAFE_componentWillMount";
	          }
	          if (typeof instance.componentWillReceiveProps === "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
	            foundWillReceivePropsName = "componentWillReceiveProps";
	          } else if (typeof instance.UNSAFE_componentWillReceiveProps === "function") {
	            foundWillReceivePropsName = "UNSAFE_componentWillReceiveProps";
	          }
	          if (typeof instance.componentWillUpdate === "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
	            foundWillUpdateName = "componentWillUpdate";
	          } else if (typeof instance.UNSAFE_componentWillUpdate === "function") {
	            foundWillUpdateName = "UNSAFE_componentWillUpdate";
	          }
	          if (foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
	            var _componentName = getComponentNameFromType(ctor) || "Component";
	            var newApiName = typeof ctor.getDerivedStateFromProps === "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
	            if (!didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName)) {
	              didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName);
	              error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n%s uses %s but also contains the following legacy lifecycles:%s%s%s\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://reactjs.org/link/unsafe-component-lifecycles", _componentName, newApiName, foundWillMountName !== null ? "\n  " + foundWillMountName : "", foundWillReceivePropsName !== null ? "\n  " + foundWillReceivePropsName : "", foundWillUpdateName !== null ? "\n  " + foundWillUpdateName : "");
	            }
	          }
	        }
	      }
	      if (isLegacyContextConsumer) {
	        cacheContext(workInProgress2, unmaskedContext, context);
	      }
	      return instance;
	    }
	    function callComponentWillMount(workInProgress2, instance) {
	      var oldState = instance.state;
	      if (typeof instance.componentWillMount === "function") {
	        instance.componentWillMount();
	      }
	      if (typeof instance.UNSAFE_componentWillMount === "function") {
	        instance.UNSAFE_componentWillMount();
	      }
	      if (oldState !== instance.state) {
	        {
	          error("%s.componentWillMount(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", getComponentNameFromFiber(workInProgress2) || "Component");
	        }
	        classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
	      }
	    }
	    function callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext) {
	      var oldState = instance.state;
	      if (typeof instance.componentWillReceiveProps === "function") {
	        instance.componentWillReceiveProps(newProps, nextContext);
	      }
	      if (typeof instance.UNSAFE_componentWillReceiveProps === "function") {
	        instance.UNSAFE_componentWillReceiveProps(newProps, nextContext);
	      }
	      if (instance.state !== oldState) {
	        {
	          var componentName = getComponentNameFromFiber(workInProgress2) || "Component";
	          if (!didWarnAboutStateAssignmentForComponent.has(componentName)) {
	            didWarnAboutStateAssignmentForComponent.add(componentName);
	            error("%s.componentWillReceiveProps(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", componentName);
	          }
	        }
	        classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
	      }
	    }
	    function mountClassInstance(workInProgress2, ctor, newProps, renderLanes2) {
	      {
	        checkClassInstance(workInProgress2, ctor, newProps);
	      }
	      var instance = workInProgress2.stateNode;
	      instance.props = newProps;
	      instance.state = workInProgress2.memoizedState;
	      instance.refs = emptyRefsObject;
	      initializeUpdateQueue(workInProgress2);
	      var contextType = ctor.contextType;
	      if (typeof contextType === "object" && contextType !== null) {
	        instance.context = readContext(contextType);
	      } else {
	        var unmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
	        instance.context = getMaskedContext(workInProgress2, unmaskedContext);
	      }
	      {
	        if (instance.state === newProps) {
	          var componentName = getComponentNameFromType(ctor) || "Component";
	          if (!didWarnAboutDirectlyAssigningPropsToState.has(componentName)) {
	            didWarnAboutDirectlyAssigningPropsToState.add(componentName);
	            error("%s: It is not recommended to assign props directly to state because updates to props won't be reflected in state. In most cases, it is better to use props directly.", componentName);
	          }
	        }
	        if (workInProgress2.mode & StrictLegacyMode) {
	          ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, instance);
	        }
	        {
	          ReactStrictModeWarnings.recordUnsafeLifecycleWarnings(workInProgress2, instance);
	        }
	      }
	      instance.state = workInProgress2.memoizedState;
	      var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
	      if (typeof getDerivedStateFromProps === "function") {
	        applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
	        instance.state = workInProgress2.memoizedState;
	      }
	      if (typeof ctor.getDerivedStateFromProps !== "function" && typeof instance.getSnapshotBeforeUpdate !== "function" && (typeof instance.UNSAFE_componentWillMount === "function" || typeof instance.componentWillMount === "function")) {
	        callComponentWillMount(workInProgress2, instance);
	        processUpdateQueue(workInProgress2, newProps, instance, renderLanes2);
	        instance.state = workInProgress2.memoizedState;
	      }
	      if (typeof instance.componentDidMount === "function") {
	        var fiberFlags = Update;
	        {
	          fiberFlags |= LayoutStatic;
	        }
	        if ((workInProgress2.mode & StrictEffectsMode) !== NoMode) {
	          fiberFlags |= MountLayoutDev;
	        }
	        workInProgress2.flags |= fiberFlags;
	      }
	    }
	    function resumeMountClassInstance(workInProgress2, ctor, newProps, renderLanes2) {
	      var instance = workInProgress2.stateNode;
	      var oldProps = workInProgress2.memoizedProps;
	      instance.props = oldProps;
	      var oldContext = instance.context;
	      var contextType = ctor.contextType;
	      var nextContext = emptyContextObject;
	      if (typeof contextType === "object" && contextType !== null) {
	        nextContext = readContext(contextType);
	      } else {
	        var nextLegacyUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
	        nextContext = getMaskedContext(workInProgress2, nextLegacyUnmaskedContext);
	      }
	      var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
	      var hasNewLifecycles = typeof getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function";
	      if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === "function" || typeof instance.componentWillReceiveProps === "function")) {
	        if (oldProps !== newProps || oldContext !== nextContext) {
	          callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext);
	        }
	      }
	      resetHasForceUpdateBeforeProcessing();
	      var oldState = workInProgress2.memoizedState;
	      var newState = instance.state = oldState;
	      processUpdateQueue(workInProgress2, newProps, instance, renderLanes2);
	      newState = workInProgress2.memoizedState;
	      if (oldProps === newProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
	        if (typeof instance.componentDidMount === "function") {
	          var fiberFlags = Update;
	          {
	            fiberFlags |= LayoutStatic;
	          }
	          if ((workInProgress2.mode & StrictEffectsMode) !== NoMode) {
	            fiberFlags |= MountLayoutDev;
	          }
	          workInProgress2.flags |= fiberFlags;
	        }
	        return false;
	      }
	      if (typeof getDerivedStateFromProps === "function") {
	        applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
	        newState = workInProgress2.memoizedState;
	      }
	      var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext);
	      if (shouldUpdate) {
	        if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillMount === "function" || typeof instance.componentWillMount === "function")) {
	          if (typeof instance.componentWillMount === "function") {
	            instance.componentWillMount();
	          }
	          if (typeof instance.UNSAFE_componentWillMount === "function") {
	            instance.UNSAFE_componentWillMount();
	          }
	        }
	        if (typeof instance.componentDidMount === "function") {
	          var _fiberFlags = Update;
	          {
	            _fiberFlags |= LayoutStatic;
	          }
	          if ((workInProgress2.mode & StrictEffectsMode) !== NoMode) {
	            _fiberFlags |= MountLayoutDev;
	          }
	          workInProgress2.flags |= _fiberFlags;
	        }
	      } else {
	        if (typeof instance.componentDidMount === "function") {
	          var _fiberFlags2 = Update;
	          {
	            _fiberFlags2 |= LayoutStatic;
	          }
	          if ((workInProgress2.mode & StrictEffectsMode) !== NoMode) {
	            _fiberFlags2 |= MountLayoutDev;
	          }
	          workInProgress2.flags |= _fiberFlags2;
	        }
	        workInProgress2.memoizedProps = newProps;
	        workInProgress2.memoizedState = newState;
	      }
	      instance.props = newProps;
	      instance.state = newState;
	      instance.context = nextContext;
	      return shouldUpdate;
	    }
	    function updateClassInstance(current2, workInProgress2, ctor, newProps, renderLanes2) {
	      var instance = workInProgress2.stateNode;
	      cloneUpdateQueue(current2, workInProgress2);
	      var unresolvedOldProps = workInProgress2.memoizedProps;
	      var oldProps = workInProgress2.type === workInProgress2.elementType ? unresolvedOldProps : resolveDefaultProps(workInProgress2.type, unresolvedOldProps);
	      instance.props = oldProps;
	      var unresolvedNewProps = workInProgress2.pendingProps;
	      var oldContext = instance.context;
	      var contextType = ctor.contextType;
	      var nextContext = emptyContextObject;
	      if (typeof contextType === "object" && contextType !== null) {
	        nextContext = readContext(contextType);
	      } else {
	        var nextUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
	        nextContext = getMaskedContext(workInProgress2, nextUnmaskedContext);
	      }
	      var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
	      var hasNewLifecycles = typeof getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function";
	      if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === "function" || typeof instance.componentWillReceiveProps === "function")) {
	        if (unresolvedOldProps !== unresolvedNewProps || oldContext !== nextContext) {
	          callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext);
	        }
	      }
	      resetHasForceUpdateBeforeProcessing();
	      var oldState = workInProgress2.memoizedState;
	      var newState = instance.state = oldState;
	      processUpdateQueue(workInProgress2, newProps, instance, renderLanes2);
	      newState = workInProgress2.memoizedState;
	      if (unresolvedOldProps === unresolvedNewProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing() && !enableLazyContextPropagation) {
	        if (typeof instance.componentDidUpdate === "function") {
	          if (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
	            workInProgress2.flags |= Update;
	          }
	        }
	        if (typeof instance.getSnapshotBeforeUpdate === "function") {
	          if (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
	            workInProgress2.flags |= Snapshot;
	          }
	        }
	        return false;
	      }
	      if (typeof getDerivedStateFromProps === "function") {
	        applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
	        newState = workInProgress2.memoizedState;
	      }
	      var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext) || // TODO: In some cases, we'll end up checking if context has changed twice,
	      // both before and after `shouldComponentUpdate` has been called. Not ideal,
	      // but I'm loath to refactor this function. This only happens for memoized
	      // components so it's not that common.
	      enableLazyContextPropagation;
	      if (shouldUpdate) {
	        if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillUpdate === "function" || typeof instance.componentWillUpdate === "function")) {
	          if (typeof instance.componentWillUpdate === "function") {
	            instance.componentWillUpdate(newProps, newState, nextContext);
	          }
	          if (typeof instance.UNSAFE_componentWillUpdate === "function") {
	            instance.UNSAFE_componentWillUpdate(newProps, newState, nextContext);
	          }
	        }
	        if (typeof instance.componentDidUpdate === "function") {
	          workInProgress2.flags |= Update;
	        }
	        if (typeof instance.getSnapshotBeforeUpdate === "function") {
	          workInProgress2.flags |= Snapshot;
	        }
	      } else {
	        if (typeof instance.componentDidUpdate === "function") {
	          if (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
	            workInProgress2.flags |= Update;
	          }
	        }
	        if (typeof instance.getSnapshotBeforeUpdate === "function") {
	          if (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
	            workInProgress2.flags |= Snapshot;
	          }
	        }
	        workInProgress2.memoizedProps = newProps;
	        workInProgress2.memoizedState = newState;
	      }
	      instance.props = newProps;
	      instance.state = newState;
	      instance.context = nextContext;
	      return shouldUpdate;
	    }
	    var didWarnAboutMaps;
	    var didWarnAboutGenerators;
	    var didWarnAboutStringRefs;
	    var ownerHasKeyUseWarning;
	    var ownerHasFunctionTypeWarning;
	    var warnForMissingKey = function(child, returnFiber) {
	    };
	    {
	      didWarnAboutMaps = false;
	      didWarnAboutGenerators = false;
	      didWarnAboutStringRefs = {};
	      ownerHasKeyUseWarning = {};
	      ownerHasFunctionTypeWarning = {};
	      warnForMissingKey = function(child, returnFiber) {
	        if (child === null || typeof child !== "object") {
	          return;
	        }
	        if (!child._store || child._store.validated || child.key != null) {
	          return;
	        }
	        if (typeof child._store !== "object") {
	          throw new Error("React Component in warnForMissingKey should have a _store. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        child._store.validated = true;
	        var componentName = getComponentNameFromFiber(returnFiber) || "Component";
	        if (ownerHasKeyUseWarning[componentName]) {
	          return;
	        }
	        ownerHasKeyUseWarning[componentName] = true;
	        error('Each child in a list should have a unique "key" prop. See https://reactjs.org/link/warning-keys for more information.');
	      };
	    }
	    function coerceRef(returnFiber, current2, element) {
	      var mixedRef = element.ref;
	      if (mixedRef !== null && typeof mixedRef !== "function" && typeof mixedRef !== "object") {
	        {
	          if ((returnFiber.mode & StrictLegacyMode || warnAboutStringRefs) && // We warn in ReactElement.js if owner and self are equal for string refs
	          // because these cannot be automatically converted to an arrow function
	          // using a codemod. Therefore, we don't have to warn about string refs again.
	          !(element._owner && element._self && element._owner.stateNode !== element._self)) {
	            var componentName = getComponentNameFromFiber(returnFiber) || "Component";
	            if (!didWarnAboutStringRefs[componentName]) {
	              {
	                error('A string ref, "%s", has been found within a strict mode tree. String refs are a source of potential bugs and should be avoided. We recommend using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', mixedRef);
	              }
	              didWarnAboutStringRefs[componentName] = true;
	            }
	          }
	        }
	        if (element._owner) {
	          var owner = element._owner;
	          var inst;
	          if (owner) {
	            var ownerFiber = owner;
	            if (ownerFiber.tag !== ClassComponent) {
	              throw new Error("Function components cannot have string refs. We recommend using useRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref");
	            }
	            inst = ownerFiber.stateNode;
	          }
	          if (!inst) {
	            throw new Error("Missing owner for string ref " + mixedRef + ". This error is likely caused by a bug in React. Please file an issue.");
	          }
	          var resolvedInst = inst;
	          {
	            checkPropStringCoercion(mixedRef, "ref");
	          }
	          var stringRef = "" + mixedRef;
	          if (current2 !== null && current2.ref !== null && typeof current2.ref === "function" && current2.ref._stringRef === stringRef) {
	            return current2.ref;
	          }
	          var ref = function(value) {
	            var refs = resolvedInst.refs;
	            if (refs === emptyRefsObject) {
	              refs = resolvedInst.refs = {};
	            }
	            if (value === null) {
	              delete refs[stringRef];
	            } else {
	              refs[stringRef] = value;
	            }
	          };
	          ref._stringRef = stringRef;
	          return ref;
	        } else {
	          if (typeof mixedRef !== "string") {
	            throw new Error("Expected ref to be a function, a string, an object returned by React.createRef(), or null.");
	          }
	          if (!element._owner) {
	            throw new Error("Element ref was specified as a string (" + mixedRef + ") but no owner was set. This could happen for one of the following reasons:\n1. You may be adding a ref to a function component\n2. You may be adding a ref to a component that was not created inside a component's render method\n3. You have multiple copies of React loaded\nSee https://reactjs.org/link/refs-must-have-owner for more information.");
	          }
	        }
	      }
	      return mixedRef;
	    }
	    function throwOnInvalidObjectType(returnFiber, newChild) {
	      var childString = Object.prototype.toString.call(newChild);
	      throw new Error("Objects are not valid as a React child (found: " + (childString === "[object Object]" ? "object with keys {" + Object.keys(newChild).join(", ") + "}" : childString) + "). If you meant to render a collection of children, use an array instead.");
	    }
	    function warnOnFunctionType(returnFiber) {
	      {
	        var componentName = getComponentNameFromFiber(returnFiber) || "Component";
	        if (ownerHasFunctionTypeWarning[componentName]) {
	          return;
	        }
	        ownerHasFunctionTypeWarning[componentName] = true;
	        error("Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it.");
	      }
	    }
	    function resolveLazy(lazyType) {
	      var payload = lazyType._payload;
	      var init = lazyType._init;
	      return init(payload);
	    }
	    function ChildReconciler(shouldTrackSideEffects) {
	      function deleteChild(returnFiber, childToDelete) {
	        if (!shouldTrackSideEffects) {
	          return;
	        }
	        var deletions = returnFiber.deletions;
	        if (deletions === null) {
	          returnFiber.deletions = [childToDelete];
	          returnFiber.flags |= ChildDeletion;
	        } else {
	          deletions.push(childToDelete);
	        }
	      }
	      function deleteRemainingChildren(returnFiber, currentFirstChild) {
	        if (!shouldTrackSideEffects) {
	          return null;
	        }
	        var childToDelete = currentFirstChild;
	        while (childToDelete !== null) {
	          deleteChild(returnFiber, childToDelete);
	          childToDelete = childToDelete.sibling;
	        }
	        return null;
	      }
	      function mapRemainingChildren(returnFiber, currentFirstChild) {
	        var existingChildren = /* @__PURE__ */ new Map();
	        var existingChild = currentFirstChild;
	        while (existingChild !== null) {
	          if (existingChild.key !== null) {
	            existingChildren.set(existingChild.key, existingChild);
	          } else {
	            existingChildren.set(existingChild.index, existingChild);
	          }
	          existingChild = existingChild.sibling;
	        }
	        return existingChildren;
	      }
	      function useFiber(fiber, pendingProps) {
	        var clone = createWorkInProgress(fiber, pendingProps);
	        clone.index = 0;
	        clone.sibling = null;
	        return clone;
	      }
	      function placeChild(newFiber, lastPlacedIndex, newIndex) {
	        newFiber.index = newIndex;
	        if (!shouldTrackSideEffects) {
	          newFiber.flags |= Forked;
	          return lastPlacedIndex;
	        }
	        var current2 = newFiber.alternate;
	        if (current2 !== null) {
	          var oldIndex = current2.index;
	          if (oldIndex < lastPlacedIndex) {
	            newFiber.flags |= Placement;
	            return lastPlacedIndex;
	          } else {
	            return oldIndex;
	          }
	        } else {
	          newFiber.flags |= Placement;
	          return lastPlacedIndex;
	        }
	      }
	      function placeSingleChild(newFiber) {
	        if (shouldTrackSideEffects && newFiber.alternate === null) {
	          newFiber.flags |= Placement;
	        }
	        return newFiber;
	      }
	      function updateTextNode(returnFiber, current2, textContent, lanes) {
	        if (current2 === null || current2.tag !== HostText) {
	          var created = createFiberFromText(textContent, returnFiber.mode, lanes);
	          created.return = returnFiber;
	          return created;
	        } else {
	          var existing = useFiber(current2, textContent);
	          existing.return = returnFiber;
	          return existing;
	        }
	      }
	      function updateElement(returnFiber, current2, element, lanes) {
	        var elementType = element.type;
	        if (elementType === REACT_FRAGMENT_TYPE) {
	          return updateFragment2(returnFiber, current2, element.props.children, lanes, element.key);
	        }
	        if (current2 !== null) {
	          if (current2.elementType === elementType || // Keep this check inline so it only runs on the false path:
	          isCompatibleFamilyForHotReloading(current2, element) || // Lazy types should reconcile their resolved type.
	          // We need to do this after the Hot Reloading check above,
	          // because hot reloading has different semantics than prod because
	          // it doesn't resuspend. So we can't let the call below suspend.
	          typeof elementType === "object" && elementType !== null && elementType.$$typeof === REACT_LAZY_TYPE && resolveLazy(elementType) === current2.type) {
	            var existing = useFiber(current2, element.props);
	            existing.ref = coerceRef(returnFiber, current2, element);
	            existing.return = returnFiber;
	            {
	              existing._debugSource = element._source;
	              existing._debugOwner = element._owner;
	            }
	            return existing;
	          }
	        }
	        var created = createFiberFromElement(element, returnFiber.mode, lanes);
	        created.ref = coerceRef(returnFiber, current2, element);
	        created.return = returnFiber;
	        return created;
	      }
	      function updatePortal(returnFiber, current2, portal, lanes) {
	        if (current2 === null || current2.tag !== HostPortal || current2.stateNode.containerInfo !== portal.containerInfo || current2.stateNode.implementation !== portal.implementation) {
	          var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
	          created.return = returnFiber;
	          return created;
	        } else {
	          var existing = useFiber(current2, portal.children || []);
	          existing.return = returnFiber;
	          return existing;
	        }
	      }
	      function updateFragment2(returnFiber, current2, fragment, lanes, key) {
	        if (current2 === null || current2.tag !== Fragment) {
	          var created = createFiberFromFragment(fragment, returnFiber.mode, lanes, key);
	          created.return = returnFiber;
	          return created;
	        } else {
	          var existing = useFiber(current2, fragment);
	          existing.return = returnFiber;
	          return existing;
	        }
	      }
	      function createChild(returnFiber, newChild, lanes) {
	        if (typeof newChild === "string" && newChild !== "" || typeof newChild === "number") {
	          var created = createFiberFromText("" + newChild, returnFiber.mode, lanes);
	          created.return = returnFiber;
	          return created;
	        }
	        if (typeof newChild === "object" && newChild !== null) {
	          switch (newChild.$$typeof) {
	            case REACT_ELEMENT_TYPE: {
	              var _created = createFiberFromElement(newChild, returnFiber.mode, lanes);
	              _created.ref = coerceRef(returnFiber, null, newChild);
	              _created.return = returnFiber;
	              return _created;
	            }
	            case REACT_PORTAL_TYPE: {
	              var _created2 = createFiberFromPortal(newChild, returnFiber.mode, lanes);
	              _created2.return = returnFiber;
	              return _created2;
	            }
	            case REACT_LAZY_TYPE: {
	              var payload = newChild._payload;
	              var init = newChild._init;
	              return createChild(returnFiber, init(payload), lanes);
	            }
	          }
	          if (isArray(newChild) || getIteratorFn(newChild)) {
	            var _created3 = createFiberFromFragment(newChild, returnFiber.mode, lanes, null);
	            _created3.return = returnFiber;
	            return _created3;
	          }
	          throwOnInvalidObjectType(returnFiber, newChild);
	        }
	        {
	          if (typeof newChild === "function") {
	            warnOnFunctionType(returnFiber);
	          }
	        }
	        return null;
	      }
	      function updateSlot(returnFiber, oldFiber, newChild, lanes) {
	        var key = oldFiber !== null ? oldFiber.key : null;
	        if (typeof newChild === "string" && newChild !== "" || typeof newChild === "number") {
	          if (key !== null) {
	            return null;
	          }
	          return updateTextNode(returnFiber, oldFiber, "" + newChild, lanes);
	        }
	        if (typeof newChild === "object" && newChild !== null) {
	          switch (newChild.$$typeof) {
	            case REACT_ELEMENT_TYPE: {
	              if (newChild.key === key) {
	                return updateElement(returnFiber, oldFiber, newChild, lanes);
	              } else {
	                return null;
	              }
	            }
	            case REACT_PORTAL_TYPE: {
	              if (newChild.key === key) {
	                return updatePortal(returnFiber, oldFiber, newChild, lanes);
	              } else {
	                return null;
	              }
	            }
	            case REACT_LAZY_TYPE: {
	              var payload = newChild._payload;
	              var init = newChild._init;
	              return updateSlot(returnFiber, oldFiber, init(payload), lanes);
	            }
	          }
	          if (isArray(newChild) || getIteratorFn(newChild)) {
	            if (key !== null) {
	              return null;
	            }
	            return updateFragment2(returnFiber, oldFiber, newChild, lanes, null);
	          }
	          throwOnInvalidObjectType(returnFiber, newChild);
	        }
	        {
	          if (typeof newChild === "function") {
	            warnOnFunctionType(returnFiber);
	          }
	        }
	        return null;
	      }
	      function updateFromMap(existingChildren, returnFiber, newIdx, newChild, lanes) {
	        if (typeof newChild === "string" && newChild !== "" || typeof newChild === "number") {
	          var matchedFiber = existingChildren.get(newIdx) || null;
	          return updateTextNode(returnFiber, matchedFiber, "" + newChild, lanes);
	        }
	        if (typeof newChild === "object" && newChild !== null) {
	          switch (newChild.$$typeof) {
	            case REACT_ELEMENT_TYPE: {
	              var _matchedFiber = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
	              return updateElement(returnFiber, _matchedFiber, newChild, lanes);
	            }
	            case REACT_PORTAL_TYPE: {
	              var _matchedFiber2 = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
	              return updatePortal(returnFiber, _matchedFiber2, newChild, lanes);
	            }
	            case REACT_LAZY_TYPE:
	              var payload = newChild._payload;
	              var init = newChild._init;
	              return updateFromMap(existingChildren, returnFiber, newIdx, init(payload), lanes);
	          }
	          if (isArray(newChild) || getIteratorFn(newChild)) {
	            var _matchedFiber3 = existingChildren.get(newIdx) || null;
	            return updateFragment2(returnFiber, _matchedFiber3, newChild, lanes, null);
	          }
	          throwOnInvalidObjectType(returnFiber, newChild);
	        }
	        {
	          if (typeof newChild === "function") {
	            warnOnFunctionType(returnFiber);
	          }
	        }
	        return null;
	      }
	      function warnOnInvalidKey(child, knownKeys, returnFiber) {
	        {
	          if (typeof child !== "object" || child === null) {
	            return knownKeys;
	          }
	          switch (child.$$typeof) {
	            case REACT_ELEMENT_TYPE:
	            case REACT_PORTAL_TYPE:
	              warnForMissingKey(child, returnFiber);
	              var key = child.key;
	              if (typeof key !== "string") {
	                break;
	              }
	              if (knownKeys === null) {
	                knownKeys = /* @__PURE__ */ new Set();
	                knownKeys.add(key);
	                break;
	              }
	              if (!knownKeys.has(key)) {
	                knownKeys.add(key);
	                break;
	              }
	              error("Encountered two children with the same key, `%s`. Keys should be unique so that components maintain their identity across updates. Non-unique keys may cause children to be duplicated and/or omitted — the behavior is unsupported and could change in a future version.", key);
	              break;
	            case REACT_LAZY_TYPE:
	              var payload = child._payload;
	              var init = child._init;
	              warnOnInvalidKey(init(payload), knownKeys, returnFiber);
	              break;
	          }
	        }
	        return knownKeys;
	      }
	      function reconcileChildrenArray(returnFiber, currentFirstChild, newChildren, lanes) {
	        {
	          var knownKeys = null;
	          for (var i = 0; i < newChildren.length; i++) {
	            var child = newChildren[i];
	            knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
	          }
	        }
	        var resultingFirstChild = null;
	        var previousNewFiber = null;
	        var oldFiber = currentFirstChild;
	        var lastPlacedIndex = 0;
	        var newIdx = 0;
	        var nextOldFiber = null;
	        for (; oldFiber !== null && newIdx < newChildren.length; newIdx++) {
	          if (oldFiber.index > newIdx) {
	            nextOldFiber = oldFiber;
	            oldFiber = null;
	          } else {
	            nextOldFiber = oldFiber.sibling;
	          }
	          var newFiber = updateSlot(returnFiber, oldFiber, newChildren[newIdx], lanes);
	          if (newFiber === null) {
	            if (oldFiber === null) {
	              oldFiber = nextOldFiber;
	            }
	            break;
	          }
	          if (shouldTrackSideEffects) {
	            if (oldFiber && newFiber.alternate === null) {
	              deleteChild(returnFiber, oldFiber);
	            }
	          }
	          lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);
	          if (previousNewFiber === null) {
	            resultingFirstChild = newFiber;
	          } else {
	            previousNewFiber.sibling = newFiber;
	          }
	          previousNewFiber = newFiber;
	          oldFiber = nextOldFiber;
	        }
	        if (newIdx === newChildren.length) {
	          deleteRemainingChildren(returnFiber, oldFiber);
	          if (getIsHydrating()) {
	            var numberOfForks = newIdx;
	            pushTreeFork(returnFiber, numberOfForks);
	          }
	          return resultingFirstChild;
	        }
	        if (oldFiber === null) {
	          for (; newIdx < newChildren.length; newIdx++) {
	            var _newFiber = createChild(returnFiber, newChildren[newIdx], lanes);
	            if (_newFiber === null) {
	              continue;
	            }
	            lastPlacedIndex = placeChild(_newFiber, lastPlacedIndex, newIdx);
	            if (previousNewFiber === null) {
	              resultingFirstChild = _newFiber;
	            } else {
	              previousNewFiber.sibling = _newFiber;
	            }
	            previousNewFiber = _newFiber;
	          }
	          if (getIsHydrating()) {
	            var _numberOfForks = newIdx;
	            pushTreeFork(returnFiber, _numberOfForks);
	          }
	          return resultingFirstChild;
	        }
	        var existingChildren = mapRemainingChildren(returnFiber, oldFiber);
	        for (; newIdx < newChildren.length; newIdx++) {
	          var _newFiber2 = updateFromMap(existingChildren, returnFiber, newIdx, newChildren[newIdx], lanes);
	          if (_newFiber2 !== null) {
	            if (shouldTrackSideEffects) {
	              if (_newFiber2.alternate !== null) {
	                existingChildren.delete(_newFiber2.key === null ? newIdx : _newFiber2.key);
	              }
	            }
	            lastPlacedIndex = placeChild(_newFiber2, lastPlacedIndex, newIdx);
	            if (previousNewFiber === null) {
	              resultingFirstChild = _newFiber2;
	            } else {
	              previousNewFiber.sibling = _newFiber2;
	            }
	            previousNewFiber = _newFiber2;
	          }
	        }
	        if (shouldTrackSideEffects) {
	          existingChildren.forEach(function(child2) {
	            return deleteChild(returnFiber, child2);
	          });
	        }
	        if (getIsHydrating()) {
	          var _numberOfForks2 = newIdx;
	          pushTreeFork(returnFiber, _numberOfForks2);
	        }
	        return resultingFirstChild;
	      }
	      function reconcileChildrenIterator(returnFiber, currentFirstChild, newChildrenIterable, lanes) {
	        var iteratorFn = getIteratorFn(newChildrenIterable);
	        if (typeof iteratorFn !== "function") {
	          throw new Error("An object is not an iterable. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        {
	          if (typeof Symbol === "function" && // $FlowFixMe Flow doesn't know about toStringTag
	          newChildrenIterable[Symbol.toStringTag] === "Generator") {
	            if (!didWarnAboutGenerators) {
	              error("Using Generators as children is unsupported and will likely yield unexpected results because enumerating a generator mutates it. You may convert it to an array with `Array.from()` or the `[...spread]` operator before rendering. Keep in mind you might need to polyfill these features for older browsers.");
	            }
	            didWarnAboutGenerators = true;
	          }
	          if (newChildrenIterable.entries === iteratorFn) {
	            if (!didWarnAboutMaps) {
	              error("Using Maps as children is not supported. Use an array of keyed ReactElements instead.");
	            }
	            didWarnAboutMaps = true;
	          }
	          var _newChildren = iteratorFn.call(newChildrenIterable);
	          if (_newChildren) {
	            var knownKeys = null;
	            var _step = _newChildren.next();
	            for (; !_step.done; _step = _newChildren.next()) {
	              var child = _step.value;
	              knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
	            }
	          }
	        }
	        var newChildren = iteratorFn.call(newChildrenIterable);
	        if (newChildren == null) {
	          throw new Error("An iterable object provided no iterator.");
	        }
	        var resultingFirstChild = null;
	        var previousNewFiber = null;
	        var oldFiber = currentFirstChild;
	        var lastPlacedIndex = 0;
	        var newIdx = 0;
	        var nextOldFiber = null;
	        var step = newChildren.next();
	        for (; oldFiber !== null && !step.done; newIdx++, step = newChildren.next()) {
	          if (oldFiber.index > newIdx) {
	            nextOldFiber = oldFiber;
	            oldFiber = null;
	          } else {
	            nextOldFiber = oldFiber.sibling;
	          }
	          var newFiber = updateSlot(returnFiber, oldFiber, step.value, lanes);
	          if (newFiber === null) {
	            if (oldFiber === null) {
	              oldFiber = nextOldFiber;
	            }
	            break;
	          }
	          if (shouldTrackSideEffects) {
	            if (oldFiber && newFiber.alternate === null) {
	              deleteChild(returnFiber, oldFiber);
	            }
	          }
	          lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);
	          if (previousNewFiber === null) {
	            resultingFirstChild = newFiber;
	          } else {
	            previousNewFiber.sibling = newFiber;
	          }
	          previousNewFiber = newFiber;
	          oldFiber = nextOldFiber;
	        }
	        if (step.done) {
	          deleteRemainingChildren(returnFiber, oldFiber);
	          if (getIsHydrating()) {
	            var numberOfForks = newIdx;
	            pushTreeFork(returnFiber, numberOfForks);
	          }
	          return resultingFirstChild;
	        }
	        if (oldFiber === null) {
	          for (; !step.done; newIdx++, step = newChildren.next()) {
	            var _newFiber3 = createChild(returnFiber, step.value, lanes);
	            if (_newFiber3 === null) {
	              continue;
	            }
	            lastPlacedIndex = placeChild(_newFiber3, lastPlacedIndex, newIdx);
	            if (previousNewFiber === null) {
	              resultingFirstChild = _newFiber3;
	            } else {
	              previousNewFiber.sibling = _newFiber3;
	            }
	            previousNewFiber = _newFiber3;
	          }
	          if (getIsHydrating()) {
	            var _numberOfForks3 = newIdx;
	            pushTreeFork(returnFiber, _numberOfForks3);
	          }
	          return resultingFirstChild;
	        }
	        var existingChildren = mapRemainingChildren(returnFiber, oldFiber);
	        for (; !step.done; newIdx++, step = newChildren.next()) {
	          var _newFiber4 = updateFromMap(existingChildren, returnFiber, newIdx, step.value, lanes);
	          if (_newFiber4 !== null) {
	            if (shouldTrackSideEffects) {
	              if (_newFiber4.alternate !== null) {
	                existingChildren.delete(_newFiber4.key === null ? newIdx : _newFiber4.key);
	              }
	            }
	            lastPlacedIndex = placeChild(_newFiber4, lastPlacedIndex, newIdx);
	            if (previousNewFiber === null) {
	              resultingFirstChild = _newFiber4;
	            } else {
	              previousNewFiber.sibling = _newFiber4;
	            }
	            previousNewFiber = _newFiber4;
	          }
	        }
	        if (shouldTrackSideEffects) {
	          existingChildren.forEach(function(child2) {
	            return deleteChild(returnFiber, child2);
	          });
	        }
	        if (getIsHydrating()) {
	          var _numberOfForks4 = newIdx;
	          pushTreeFork(returnFiber, _numberOfForks4);
	        }
	        return resultingFirstChild;
	      }
	      function reconcileSingleTextNode(returnFiber, currentFirstChild, textContent, lanes) {
	        if (currentFirstChild !== null && currentFirstChild.tag === HostText) {
	          deleteRemainingChildren(returnFiber, currentFirstChild.sibling);
	          var existing = useFiber(currentFirstChild, textContent);
	          existing.return = returnFiber;
	          return existing;
	        }
	        deleteRemainingChildren(returnFiber, currentFirstChild);
	        var created = createFiberFromText(textContent, returnFiber.mode, lanes);
	        created.return = returnFiber;
	        return created;
	      }
	      function reconcileSingleElement(returnFiber, currentFirstChild, element, lanes) {
	        var key = element.key;
	        var child = currentFirstChild;
	        while (child !== null) {
	          if (child.key === key) {
	            var elementType = element.type;
	            if (elementType === REACT_FRAGMENT_TYPE) {
	              if (child.tag === Fragment) {
	                deleteRemainingChildren(returnFiber, child.sibling);
	                var existing = useFiber(child, element.props.children);
	                existing.return = returnFiber;
	                {
	                  existing._debugSource = element._source;
	                  existing._debugOwner = element._owner;
	                }
	                return existing;
	              }
	            } else {
	              if (child.elementType === elementType || // Keep this check inline so it only runs on the false path:
	              isCompatibleFamilyForHotReloading(child, element) || // Lazy types should reconcile their resolved type.
	              // We need to do this after the Hot Reloading check above,
	              // because hot reloading has different semantics than prod because
	              // it doesn't resuspend. So we can't let the call below suspend.
	              typeof elementType === "object" && elementType !== null && elementType.$$typeof === REACT_LAZY_TYPE && resolveLazy(elementType) === child.type) {
	                deleteRemainingChildren(returnFiber, child.sibling);
	                var _existing = useFiber(child, element.props);
	                _existing.ref = coerceRef(returnFiber, child, element);
	                _existing.return = returnFiber;
	                {
	                  _existing._debugSource = element._source;
	                  _existing._debugOwner = element._owner;
	                }
	                return _existing;
	              }
	            }
	            deleteRemainingChildren(returnFiber, child);
	            break;
	          } else {
	            deleteChild(returnFiber, child);
	          }
	          child = child.sibling;
	        }
	        if (element.type === REACT_FRAGMENT_TYPE) {
	          var created = createFiberFromFragment(element.props.children, returnFiber.mode, lanes, element.key);
	          created.return = returnFiber;
	          return created;
	        } else {
	          var _created4 = createFiberFromElement(element, returnFiber.mode, lanes);
	          _created4.ref = coerceRef(returnFiber, currentFirstChild, element);
	          _created4.return = returnFiber;
	          return _created4;
	        }
	      }
	      function reconcileSinglePortal(returnFiber, currentFirstChild, portal, lanes) {
	        var key = portal.key;
	        var child = currentFirstChild;
	        while (child !== null) {
	          if (child.key === key) {
	            if (child.tag === HostPortal && child.stateNode.containerInfo === portal.containerInfo && child.stateNode.implementation === portal.implementation) {
	              deleteRemainingChildren(returnFiber, child.sibling);
	              var existing = useFiber(child, portal.children || []);
	              existing.return = returnFiber;
	              return existing;
	            } else {
	              deleteRemainingChildren(returnFiber, child);
	              break;
	            }
	          } else {
	            deleteChild(returnFiber, child);
	          }
	          child = child.sibling;
	        }
	        var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
	        created.return = returnFiber;
	        return created;
	      }
	      function reconcileChildFibers2(returnFiber, currentFirstChild, newChild, lanes) {
	        var isUnkeyedTopLevelFragment = typeof newChild === "object" && newChild !== null && newChild.type === REACT_FRAGMENT_TYPE && newChild.key === null;
	        if (isUnkeyedTopLevelFragment) {
	          newChild = newChild.props.children;
	        }
	        if (typeof newChild === "object" && newChild !== null) {
	          switch (newChild.$$typeof) {
	            case REACT_ELEMENT_TYPE:
	              return placeSingleChild(reconcileSingleElement(returnFiber, currentFirstChild, newChild, lanes));
	            case REACT_PORTAL_TYPE:
	              return placeSingleChild(reconcileSinglePortal(returnFiber, currentFirstChild, newChild, lanes));
	            case REACT_LAZY_TYPE:
	              var payload = newChild._payload;
	              var init = newChild._init;
	              return reconcileChildFibers2(returnFiber, currentFirstChild, init(payload), lanes);
	          }
	          if (isArray(newChild)) {
	            return reconcileChildrenArray(returnFiber, currentFirstChild, newChild, lanes);
	          }
	          if (getIteratorFn(newChild)) {
	            return reconcileChildrenIterator(returnFiber, currentFirstChild, newChild, lanes);
	          }
	          throwOnInvalidObjectType(returnFiber, newChild);
	        }
	        if (typeof newChild === "string" && newChild !== "" || typeof newChild === "number") {
	          return placeSingleChild(reconcileSingleTextNode(returnFiber, currentFirstChild, "" + newChild, lanes));
	        }
	        {
	          if (typeof newChild === "function") {
	            warnOnFunctionType(returnFiber);
	          }
	        }
	        return deleteRemainingChildren(returnFiber, currentFirstChild);
	      }
	      return reconcileChildFibers2;
	    }
	    var reconcileChildFibers = ChildReconciler(true);
	    var mountChildFibers = ChildReconciler(false);
	    function cloneChildFibers(current2, workInProgress2) {
	      if (current2 !== null && workInProgress2.child !== current2.child) {
	        throw new Error("Resuming work not yet implemented.");
	      }
	      if (workInProgress2.child === null) {
	        return;
	      }
	      var currentChild = workInProgress2.child;
	      var newChild = createWorkInProgress(currentChild, currentChild.pendingProps);
	      workInProgress2.child = newChild;
	      newChild.return = workInProgress2;
	      while (currentChild.sibling !== null) {
	        currentChild = currentChild.sibling;
	        newChild = newChild.sibling = createWorkInProgress(currentChild, currentChild.pendingProps);
	        newChild.return = workInProgress2;
	      }
	      newChild.sibling = null;
	    }
	    function resetChildFibers(workInProgress2, lanes) {
	      var child = workInProgress2.child;
	      while (child !== null) {
	        resetWorkInProgress(child, lanes);
	        child = child.sibling;
	      }
	    }
	    var NO_CONTEXT = {};
	    var contextStackCursor$1 = createCursor(NO_CONTEXT);
	    var contextFiberStackCursor = createCursor(NO_CONTEXT);
	    var rootInstanceStackCursor = createCursor(NO_CONTEXT);
	    function requiredContext(c) {
	      if (c === NO_CONTEXT) {
	        throw new Error("Expected host context to exist. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      return c;
	    }
	    function getRootHostContainer() {
	      var rootInstance = requiredContext(rootInstanceStackCursor.current);
	      return rootInstance;
	    }
	    function pushHostContainer(fiber, nextRootInstance) {
	      push(rootInstanceStackCursor, nextRootInstance, fiber);
	      push(contextFiberStackCursor, fiber, fiber);
	      push(contextStackCursor$1, NO_CONTEXT, fiber);
	      var nextRootContext = getRootHostContext(nextRootInstance);
	      pop(contextStackCursor$1, fiber);
	      push(contextStackCursor$1, nextRootContext, fiber);
	    }
	    function popHostContainer(fiber) {
	      pop(contextStackCursor$1, fiber);
	      pop(contextFiberStackCursor, fiber);
	      pop(rootInstanceStackCursor, fiber);
	    }
	    function getHostContext() {
	      var context = requiredContext(contextStackCursor$1.current);
	      return context;
	    }
	    function pushHostContext(fiber) {
	      requiredContext(rootInstanceStackCursor.current);
	      var context = requiredContext(contextStackCursor$1.current);
	      var nextContext = getChildHostContext(context, fiber.type);
	      if (context === nextContext) {
	        return;
	      }
	      push(contextFiberStackCursor, fiber, fiber);
	      push(contextStackCursor$1, nextContext, fiber);
	    }
	    function popHostContext(fiber) {
	      if (contextFiberStackCursor.current !== fiber) {
	        return;
	      }
	      pop(contextStackCursor$1, fiber);
	      pop(contextFiberStackCursor, fiber);
	    }
	    var DefaultSuspenseContext = 0;
	    var SubtreeSuspenseContextMask = 1;
	    var InvisibleParentSuspenseContext = 1;
	    var ForceSuspenseFallback = 2;
	    var suspenseStackCursor = createCursor(DefaultSuspenseContext);
	    function hasSuspenseContext(parentContext, flag) {
	      return (parentContext & flag) !== 0;
	    }
	    function setDefaultShallowSuspenseContext(parentContext) {
	      return parentContext & SubtreeSuspenseContextMask;
	    }
	    function setShallowSuspenseContext(parentContext, shallowContext) {
	      return parentContext & SubtreeSuspenseContextMask | shallowContext;
	    }
	    function addSubtreeSuspenseContext(parentContext, subtreeContext) {
	      return parentContext | subtreeContext;
	    }
	    function pushSuspenseContext(fiber, newContext) {
	      push(suspenseStackCursor, newContext, fiber);
	    }
	    function popSuspenseContext(fiber) {
	      pop(suspenseStackCursor, fiber);
	    }
	    function shouldCaptureSuspense(workInProgress2, hasInvisibleParent) {
	      var nextState = workInProgress2.memoizedState;
	      if (nextState !== null) {
	        if (nextState.dehydrated !== null) {
	          return true;
	        }
	        return false;
	      }
	      workInProgress2.memoizedProps;
	      {
	        return true;
	      }
	    }
	    function findFirstSuspended(row) {
	      var node = row;
	      while (node !== null) {
	        if (node.tag === SuspenseComponent) {
	          var state = node.memoizedState;
	          if (state !== null) {
	            var dehydrated = state.dehydrated;
	            if (dehydrated === null || isSuspenseInstancePending(dehydrated) || isSuspenseInstanceFallback(dehydrated)) {
	              return node;
	            }
	          }
	        } else if (node.tag === SuspenseListComponent && // revealOrder undefined can't be trusted because it don't
	        // keep track of whether it suspended or not.
	        node.memoizedProps.revealOrder !== void 0) {
	          var didSuspend = (node.flags & DidCapture) !== NoFlags;
	          if (didSuspend) {
	            return node;
	          }
	        } else if (node.child !== null) {
	          node.child.return = node;
	          node = node.child;
	          continue;
	        }
	        if (node === row) {
	          return null;
	        }
	        while (node.sibling === null) {
	          if (node.return === null || node.return === row) {
	            return null;
	          }
	          node = node.return;
	        }
	        node.sibling.return = node.return;
	        node = node.sibling;
	      }
	      return null;
	    }
	    var NoFlags$1 = (
	      /*   */
	      0
	    );
	    var HasEffect = (
	      /* */
	      1
	    );
	    var Insertion = (
	      /*  */
	      2
	    );
	    var Layout = (
	      /*    */
	      4
	    );
	    var Passive$1 = (
	      /*   */
	      8
	    );
	    var workInProgressSources = [];
	    function resetWorkInProgressVersions() {
	      for (var i = 0; i < workInProgressSources.length; i++) {
	        var mutableSource = workInProgressSources[i];
	        {
	          mutableSource._workInProgressVersionPrimary = null;
	        }
	      }
	      workInProgressSources.length = 0;
	    }
	    function registerMutableSourceForHydration(root2, mutableSource) {
	      var getVersion = mutableSource._getVersion;
	      var version = getVersion(mutableSource._source);
	      if (root2.mutableSourceEagerHydrationData == null) {
	        root2.mutableSourceEagerHydrationData = [mutableSource, version];
	      } else {
	        root2.mutableSourceEagerHydrationData.push(mutableSource, version);
	      }
	    }
	    var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher, ReactCurrentBatchConfig$2 = ReactSharedInternals.ReactCurrentBatchConfig;
	    var didWarnAboutMismatchedHooksForComponent;
	    var didWarnUncachedGetSnapshot;
	    {
	      didWarnAboutMismatchedHooksForComponent = /* @__PURE__ */ new Set();
	    }
	    var renderLanes = NoLanes;
	    var currentlyRenderingFiber$1 = null;
	    var currentHook = null;
	    var workInProgressHook = null;
	    var didScheduleRenderPhaseUpdate = false;
	    var didScheduleRenderPhaseUpdateDuringThisPass = false;
	    var localIdCounter = 0;
	    var globalClientIdCounter = 0;
	    var RE_RENDER_LIMIT = 25;
	    var currentHookNameInDev = null;
	    var hookTypesDev = null;
	    var hookTypesUpdateIndexDev = -1;
	    var ignorePreviousDependencies = false;
	    function mountHookTypesDev() {
	      {
	        var hookName = currentHookNameInDev;
	        if (hookTypesDev === null) {
	          hookTypesDev = [hookName];
	        } else {
	          hookTypesDev.push(hookName);
	        }
	      }
	    }
	    function updateHookTypesDev() {
	      {
	        var hookName = currentHookNameInDev;
	        if (hookTypesDev !== null) {
	          hookTypesUpdateIndexDev++;
	          if (hookTypesDev[hookTypesUpdateIndexDev] !== hookName) {
	            warnOnHookMismatchInDev(hookName);
	          }
	        }
	      }
	    }
	    function checkDepsAreArrayDev(deps) {
	      {
	        if (deps !== void 0 && deps !== null && !isArray(deps)) {
	          error("%s received a final argument that is not an array (instead, received `%s`). When specified, the final argument must be an array.", currentHookNameInDev, typeof deps);
	        }
	      }
	    }
	    function warnOnHookMismatchInDev(currentHookName) {
	      {
	        var componentName = getComponentNameFromFiber(currentlyRenderingFiber$1);
	        if (!didWarnAboutMismatchedHooksForComponent.has(componentName)) {
	          didWarnAboutMismatchedHooksForComponent.add(componentName);
	          if (hookTypesDev !== null) {
	            var table = "";
	            var secondColumnStart = 30;
	            for (var i = 0; i <= hookTypesUpdateIndexDev; i++) {
	              var oldHookName = hookTypesDev[i];
	              var newHookName = i === hookTypesUpdateIndexDev ? currentHookName : oldHookName;
	              var row = i + 1 + ". " + oldHookName;
	              while (row.length < secondColumnStart) {
	                row += " ";
	              }
	              row += newHookName + "\n";
	              table += row;
	            }
	            error("React has detected a change in the order of Hooks called by %s. This will lead to bugs and errors if not fixed. For more information, read the Rules of Hooks: https://reactjs.org/link/rules-of-hooks\n\n   Previous render            Next render\n   ------------------------------------------------------\n%s   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n", componentName, table);
	          }
	        }
	      }
	    }
	    function throwInvalidHookError() {
	      throw new Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.");
	    }
	    function areHookInputsEqual(nextDeps, prevDeps) {
	      {
	        if (ignorePreviousDependencies) {
	          return false;
	        }
	      }
	      if (prevDeps === null) {
	        {
	          error("%s received a final argument during this render, but not during the previous render. Even though the final argument is optional, its type cannot change between renders.", currentHookNameInDev);
	        }
	        return false;
	      }
	      {
	        if (nextDeps.length !== prevDeps.length) {
	          error("The final argument passed to %s changed size between renders. The order and size of this array must remain constant.\n\nPrevious: %s\nIncoming: %s", currentHookNameInDev, "[" + prevDeps.join(", ") + "]", "[" + nextDeps.join(", ") + "]");
	        }
	      }
	      for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++) {
	        if (objectIs(nextDeps[i], prevDeps[i])) {
	          continue;
	        }
	        return false;
	      }
	      return true;
	    }
	    function renderWithHooks(current2, workInProgress2, Component, props, secondArg, nextRenderLanes) {
	      renderLanes = nextRenderLanes;
	      currentlyRenderingFiber$1 = workInProgress2;
	      {
	        hookTypesDev = current2 !== null ? current2._debugHookTypes : null;
	        hookTypesUpdateIndexDev = -1;
	        ignorePreviousDependencies = current2 !== null && current2.type !== workInProgress2.type;
	      }
	      workInProgress2.memoizedState = null;
	      workInProgress2.updateQueue = null;
	      workInProgress2.lanes = NoLanes;
	      {
	        if (current2 !== null && current2.memoizedState !== null) {
	          ReactCurrentDispatcher$1.current = HooksDispatcherOnUpdateInDEV;
	        } else if (hookTypesDev !== null) {
	          ReactCurrentDispatcher$1.current = HooksDispatcherOnMountWithHookTypesInDEV;
	        } else {
	          ReactCurrentDispatcher$1.current = HooksDispatcherOnMountInDEV;
	        }
	      }
	      var children = Component(props, secondArg);
	      if (didScheduleRenderPhaseUpdateDuringThisPass) {
	        var numberOfReRenders = 0;
	        do {
	          didScheduleRenderPhaseUpdateDuringThisPass = false;
	          localIdCounter = 0;
	          if (numberOfReRenders >= RE_RENDER_LIMIT) {
	            throw new Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
	          }
	          numberOfReRenders += 1;
	          {
	            ignorePreviousDependencies = false;
	          }
	          currentHook = null;
	          workInProgressHook = null;
	          workInProgress2.updateQueue = null;
	          {
	            hookTypesUpdateIndexDev = -1;
	          }
	          ReactCurrentDispatcher$1.current = HooksDispatcherOnRerenderInDEV;
	          children = Component(props, secondArg);
	        } while (didScheduleRenderPhaseUpdateDuringThisPass);
	      }
	      ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;
	      {
	        workInProgress2._debugHookTypes = hookTypesDev;
	      }
	      var didRenderTooFewHooks = currentHook !== null && currentHook.next !== null;
	      renderLanes = NoLanes;
	      currentlyRenderingFiber$1 = null;
	      currentHook = null;
	      workInProgressHook = null;
	      {
	        currentHookNameInDev = null;
	        hookTypesDev = null;
	        hookTypesUpdateIndexDev = -1;
	        if (current2 !== null && (current2.flags & StaticMask) !== (workInProgress2.flags & StaticMask) && // Disable this warning in legacy mode, because legacy Suspense is weird
	        // and creates false positives. To make this work in legacy mode, we'd
	        // need to mark fibers that commit in an incomplete state, somehow. For
	        // now I'll disable the warning that most of the bugs that would trigger
	        // it are either exclusive to concurrent mode or exist in both.
	        (current2.mode & ConcurrentMode) !== NoMode) {
	          error("Internal React error: Expected static flag was missing. Please notify the React team.");
	        }
	      }
	      didScheduleRenderPhaseUpdate = false;
	      if (didRenderTooFewHooks) {
	        throw new Error("Rendered fewer hooks than expected. This may be caused by an accidental early return statement.");
	      }
	      return children;
	    }
	    function checkDidRenderIdHook() {
	      var didRenderIdHook = localIdCounter !== 0;
	      localIdCounter = 0;
	      return didRenderIdHook;
	    }
	    function bailoutHooks(current2, workInProgress2, lanes) {
	      workInProgress2.updateQueue = current2.updateQueue;
	      if ((workInProgress2.mode & StrictEffectsMode) !== NoMode) {
	        workInProgress2.flags &= ~(MountPassiveDev | MountLayoutDev | Passive | Update);
	      } else {
	        workInProgress2.flags &= ~(Passive | Update);
	      }
	      current2.lanes = removeLanes(current2.lanes, lanes);
	    }
	    function resetHooksAfterThrow() {
	      ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;
	      if (didScheduleRenderPhaseUpdate) {
	        var hook = currentlyRenderingFiber$1.memoizedState;
	        while (hook !== null) {
	          var queue = hook.queue;
	          if (queue !== null) {
	            queue.pending = null;
	          }
	          hook = hook.next;
	        }
	        didScheduleRenderPhaseUpdate = false;
	      }
	      renderLanes = NoLanes;
	      currentlyRenderingFiber$1 = null;
	      currentHook = null;
	      workInProgressHook = null;
	      {
	        hookTypesDev = null;
	        hookTypesUpdateIndexDev = -1;
	        currentHookNameInDev = null;
	        isUpdatingOpaqueValueInRenderPhase = false;
	      }
	      didScheduleRenderPhaseUpdateDuringThisPass = false;
	      localIdCounter = 0;
	    }
	    function mountWorkInProgressHook() {
	      var hook = {
	        memoizedState: null,
	        baseState: null,
	        baseQueue: null,
	        queue: null,
	        next: null
	      };
	      if (workInProgressHook === null) {
	        currentlyRenderingFiber$1.memoizedState = workInProgressHook = hook;
	      } else {
	        workInProgressHook = workInProgressHook.next = hook;
	      }
	      return workInProgressHook;
	    }
	    function updateWorkInProgressHook() {
	      var nextCurrentHook;
	      if (currentHook === null) {
	        var current2 = currentlyRenderingFiber$1.alternate;
	        if (current2 !== null) {
	          nextCurrentHook = current2.memoizedState;
	        } else {
	          nextCurrentHook = null;
	        }
	      } else {
	        nextCurrentHook = currentHook.next;
	      }
	      var nextWorkInProgressHook;
	      if (workInProgressHook === null) {
	        nextWorkInProgressHook = currentlyRenderingFiber$1.memoizedState;
	      } else {
	        nextWorkInProgressHook = workInProgressHook.next;
	      }
	      if (nextWorkInProgressHook !== null) {
	        workInProgressHook = nextWorkInProgressHook;
	        nextWorkInProgressHook = workInProgressHook.next;
	        currentHook = nextCurrentHook;
	      } else {
	        if (nextCurrentHook === null) {
	          throw new Error("Rendered more hooks than during the previous render.");
	        }
	        currentHook = nextCurrentHook;
	        var newHook = {
	          memoizedState: currentHook.memoizedState,
	          baseState: currentHook.baseState,
	          baseQueue: currentHook.baseQueue,
	          queue: currentHook.queue,
	          next: null
	        };
	        if (workInProgressHook === null) {
	          currentlyRenderingFiber$1.memoizedState = workInProgressHook = newHook;
	        } else {
	          workInProgressHook = workInProgressHook.next = newHook;
	        }
	      }
	      return workInProgressHook;
	    }
	    function createFunctionComponentUpdateQueue() {
	      return {
	        lastEffect: null,
	        stores: null
	      };
	    }
	    function basicStateReducer(state, action) {
	      return typeof action === "function" ? action(state) : action;
	    }
	    function mountReducer(reducer, initialArg, init) {
	      var hook = mountWorkInProgressHook();
	      var initialState;
	      if (init !== void 0) {
	        initialState = init(initialArg);
	      } else {
	        initialState = initialArg;
	      }
	      hook.memoizedState = hook.baseState = initialState;
	      var queue = {
	        pending: null,
	        interleaved: null,
	        lanes: NoLanes,
	        dispatch: null,
	        lastRenderedReducer: reducer,
	        lastRenderedState: initialState
	      };
	      hook.queue = queue;
	      var dispatch = queue.dispatch = dispatchReducerAction.bind(null, currentlyRenderingFiber$1, queue);
	      return [hook.memoizedState, dispatch];
	    }
	    function updateReducer(reducer, initialArg, init) {
	      var hook = updateWorkInProgressHook();
	      var queue = hook.queue;
	      if (queue === null) {
	        throw new Error("Should have a queue. This is likely a bug in React. Please file an issue.");
	      }
	      queue.lastRenderedReducer = reducer;
	      var current2 = currentHook;
	      var baseQueue = current2.baseQueue;
	      var pendingQueue = queue.pending;
	      if (pendingQueue !== null) {
	        if (baseQueue !== null) {
	          var baseFirst = baseQueue.next;
	          var pendingFirst = pendingQueue.next;
	          baseQueue.next = pendingFirst;
	          pendingQueue.next = baseFirst;
	        }
	        {
	          if (current2.baseQueue !== baseQueue) {
	            error("Internal error: Expected work-in-progress queue to be a clone. This is a bug in React.");
	          }
	        }
	        current2.baseQueue = baseQueue = pendingQueue;
	        queue.pending = null;
	      }
	      if (baseQueue !== null) {
	        var first = baseQueue.next;
	        var newState = current2.baseState;
	        var newBaseState = null;
	        var newBaseQueueFirst = null;
	        var newBaseQueueLast = null;
	        var update = first;
	        do {
	          var updateLane = update.lane;
	          if (!isSubsetOfLanes(renderLanes, updateLane)) {
	            var clone = {
	              lane: updateLane,
	              action: update.action,
	              hasEagerState: update.hasEagerState,
	              eagerState: update.eagerState,
	              next: null
	            };
	            if (newBaseQueueLast === null) {
	              newBaseQueueFirst = newBaseQueueLast = clone;
	              newBaseState = newState;
	            } else {
	              newBaseQueueLast = newBaseQueueLast.next = clone;
	            }
	            currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, updateLane);
	            markSkippedUpdateLanes(updateLane);
	          } else {
	            if (newBaseQueueLast !== null) {
	              var _clone = {
	                // This update is going to be committed so we never want uncommit
	                // it. Using NoLane works because 0 is a subset of all bitmasks, so
	                // this will never be skipped by the check above.
	                lane: NoLane,
	                action: update.action,
	                hasEagerState: update.hasEagerState,
	                eagerState: update.eagerState,
	                next: null
	              };
	              newBaseQueueLast = newBaseQueueLast.next = _clone;
	            }
	            if (update.hasEagerState) {
	              newState = update.eagerState;
	            } else {
	              var action = update.action;
	              newState = reducer(newState, action);
	            }
	          }
	          update = update.next;
	        } while (update !== null && update !== first);
	        if (newBaseQueueLast === null) {
	          newBaseState = newState;
	        } else {
	          newBaseQueueLast.next = newBaseQueueFirst;
	        }
	        if (!objectIs(newState, hook.memoizedState)) {
	          markWorkInProgressReceivedUpdate();
	        }
	        hook.memoizedState = newState;
	        hook.baseState = newBaseState;
	        hook.baseQueue = newBaseQueueLast;
	        queue.lastRenderedState = newState;
	      }
	      var lastInterleaved = queue.interleaved;
	      if (lastInterleaved !== null) {
	        var interleaved = lastInterleaved;
	        do {
	          var interleavedLane = interleaved.lane;
	          currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, interleavedLane);
	          markSkippedUpdateLanes(interleavedLane);
	          interleaved = interleaved.next;
	        } while (interleaved !== lastInterleaved);
	      } else if (baseQueue === null) {
	        queue.lanes = NoLanes;
	      }
	      var dispatch = queue.dispatch;
	      return [hook.memoizedState, dispatch];
	    }
	    function rerenderReducer(reducer, initialArg, init) {
	      var hook = updateWorkInProgressHook();
	      var queue = hook.queue;
	      if (queue === null) {
	        throw new Error("Should have a queue. This is likely a bug in React. Please file an issue.");
	      }
	      queue.lastRenderedReducer = reducer;
	      var dispatch = queue.dispatch;
	      var lastRenderPhaseUpdate = queue.pending;
	      var newState = hook.memoizedState;
	      if (lastRenderPhaseUpdate !== null) {
	        queue.pending = null;
	        var firstRenderPhaseUpdate = lastRenderPhaseUpdate.next;
	        var update = firstRenderPhaseUpdate;
	        do {
	          var action = update.action;
	          newState = reducer(newState, action);
	          update = update.next;
	        } while (update !== firstRenderPhaseUpdate);
	        if (!objectIs(newState, hook.memoizedState)) {
	          markWorkInProgressReceivedUpdate();
	        }
	        hook.memoizedState = newState;
	        if (hook.baseQueue === null) {
	          hook.baseState = newState;
	        }
	        queue.lastRenderedState = newState;
	      }
	      return [newState, dispatch];
	    }
	    function mountMutableSource(source, getSnapshot, subscribe) {
	      {
	        return void 0;
	      }
	    }
	    function updateMutableSource(source, getSnapshot, subscribe) {
	      {
	        return void 0;
	      }
	    }
	    function mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
	      var fiber = currentlyRenderingFiber$1;
	      var hook = mountWorkInProgressHook();
	      var nextSnapshot;
	      var isHydrating2 = getIsHydrating();
	      if (isHydrating2) {
	        if (getServerSnapshot === void 0) {
	          throw new Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
	        }
	        nextSnapshot = getServerSnapshot();
	        {
	          if (!didWarnUncachedGetSnapshot) {
	            if (nextSnapshot !== getServerSnapshot()) {
	              error("The result of getServerSnapshot should be cached to avoid an infinite loop");
	              didWarnUncachedGetSnapshot = true;
	            }
	          }
	        }
	      } else {
	        nextSnapshot = getSnapshot();
	        {
	          if (!didWarnUncachedGetSnapshot) {
	            var cachedSnapshot = getSnapshot();
	            if (!objectIs(nextSnapshot, cachedSnapshot)) {
	              error("The result of getSnapshot should be cached to avoid an infinite loop");
	              didWarnUncachedGetSnapshot = true;
	            }
	          }
	        }
	        var root2 = getWorkInProgressRoot();
	        if (root2 === null) {
	          throw new Error("Expected a work-in-progress root. This is a bug in React. Please file an issue.");
	        }
	        if (!includesBlockingLane(root2, renderLanes)) {
	          pushStoreConsistencyCheck(fiber, getSnapshot, nextSnapshot);
	        }
	      }
	      hook.memoizedState = nextSnapshot;
	      var inst = {
	        value: nextSnapshot,
	        getSnapshot
	      };
	      hook.queue = inst;
	      mountEffect(subscribeToStore.bind(null, fiber, inst, subscribe), [subscribe]);
	      fiber.flags |= Passive;
	      pushEffect(HasEffect | Passive$1, updateStoreInstance.bind(null, fiber, inst, nextSnapshot, getSnapshot), void 0, null);
	      return nextSnapshot;
	    }
	    function updateSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
	      var fiber = currentlyRenderingFiber$1;
	      var hook = updateWorkInProgressHook();
	      var nextSnapshot = getSnapshot();
	      {
	        if (!didWarnUncachedGetSnapshot) {
	          var cachedSnapshot = getSnapshot();
	          if (!objectIs(nextSnapshot, cachedSnapshot)) {
	            error("The result of getSnapshot should be cached to avoid an infinite loop");
	            didWarnUncachedGetSnapshot = true;
	          }
	        }
	      }
	      var prevSnapshot = hook.memoizedState;
	      var snapshotChanged = !objectIs(prevSnapshot, nextSnapshot);
	      if (snapshotChanged) {
	        hook.memoizedState = nextSnapshot;
	        markWorkInProgressReceivedUpdate();
	      }
	      var inst = hook.queue;
	      updateEffect(subscribeToStore.bind(null, fiber, inst, subscribe), [subscribe]);
	      if (inst.getSnapshot !== getSnapshot || snapshotChanged || // Check if the susbcribe function changed. We can save some memory by
	      // checking whether we scheduled a subscription effect above.
	      workInProgressHook !== null && workInProgressHook.memoizedState.tag & HasEffect) {
	        fiber.flags |= Passive;
	        pushEffect(HasEffect | Passive$1, updateStoreInstance.bind(null, fiber, inst, nextSnapshot, getSnapshot), void 0, null);
	        var root2 = getWorkInProgressRoot();
	        if (root2 === null) {
	          throw new Error("Expected a work-in-progress root. This is a bug in React. Please file an issue.");
	        }
	        if (!includesBlockingLane(root2, renderLanes)) {
	          pushStoreConsistencyCheck(fiber, getSnapshot, nextSnapshot);
	        }
	      }
	      return nextSnapshot;
	    }
	    function pushStoreConsistencyCheck(fiber, getSnapshot, renderedSnapshot) {
	      fiber.flags |= StoreConsistency;
	      var check = {
	        getSnapshot,
	        value: renderedSnapshot
	      };
	      var componentUpdateQueue = currentlyRenderingFiber$1.updateQueue;
	      if (componentUpdateQueue === null) {
	        componentUpdateQueue = createFunctionComponentUpdateQueue();
	        currentlyRenderingFiber$1.updateQueue = componentUpdateQueue;
	        componentUpdateQueue.stores = [check];
	      } else {
	        var stores = componentUpdateQueue.stores;
	        if (stores === null) {
	          componentUpdateQueue.stores = [check];
	        } else {
	          stores.push(check);
	        }
	      }
	    }
	    function updateStoreInstance(fiber, inst, nextSnapshot, getSnapshot) {
	      inst.value = nextSnapshot;
	      inst.getSnapshot = getSnapshot;
	      if (checkIfSnapshotChanged(inst)) {
	        forceStoreRerender(fiber);
	      }
	    }
	    function subscribeToStore(fiber, inst, subscribe) {
	      var handleStoreChange = function() {
	        if (checkIfSnapshotChanged(inst)) {
	          forceStoreRerender(fiber);
	        }
	      };
	      return subscribe(handleStoreChange);
	    }
	    function checkIfSnapshotChanged(inst) {
	      var latestGetSnapshot = inst.getSnapshot;
	      var prevValue = inst.value;
	      try {
	        var nextValue = latestGetSnapshot();
	        return !objectIs(prevValue, nextValue);
	      } catch (error2) {
	        return true;
	      }
	    }
	    function forceStoreRerender(fiber) {
	      var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	      if (root2 !== null) {
	        scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	      }
	    }
	    function mountState(initialState) {
	      var hook = mountWorkInProgressHook();
	      if (typeof initialState === "function") {
	        initialState = initialState();
	      }
	      hook.memoizedState = hook.baseState = initialState;
	      var queue = {
	        pending: null,
	        interleaved: null,
	        lanes: NoLanes,
	        dispatch: null,
	        lastRenderedReducer: basicStateReducer,
	        lastRenderedState: initialState
	      };
	      hook.queue = queue;
	      var dispatch = queue.dispatch = dispatchSetState.bind(null, currentlyRenderingFiber$1, queue);
	      return [hook.memoizedState, dispatch];
	    }
	    function updateState(initialState) {
	      return updateReducer(basicStateReducer);
	    }
	    function rerenderState(initialState) {
	      return rerenderReducer(basicStateReducer);
	    }
	    function pushEffect(tag, create, destroy, deps) {
	      var effect = {
	        tag,
	        create,
	        destroy,
	        deps,
	        // Circular
	        next: null
	      };
	      var componentUpdateQueue = currentlyRenderingFiber$1.updateQueue;
	      if (componentUpdateQueue === null) {
	        componentUpdateQueue = createFunctionComponentUpdateQueue();
	        currentlyRenderingFiber$1.updateQueue = componentUpdateQueue;
	        componentUpdateQueue.lastEffect = effect.next = effect;
	      } else {
	        var lastEffect = componentUpdateQueue.lastEffect;
	        if (lastEffect === null) {
	          componentUpdateQueue.lastEffect = effect.next = effect;
	        } else {
	          var firstEffect = lastEffect.next;
	          lastEffect.next = effect;
	          effect.next = firstEffect;
	          componentUpdateQueue.lastEffect = effect;
	        }
	      }
	      return effect;
	    }
	    function mountRef(initialValue) {
	      var hook = mountWorkInProgressHook();
	      {
	        var _ref2 = {
	          current: initialValue
	        };
	        hook.memoizedState = _ref2;
	        return _ref2;
	      }
	    }
	    function updateRef(initialValue) {
	      var hook = updateWorkInProgressHook();
	      return hook.memoizedState;
	    }
	    function mountEffectImpl(fiberFlags, hookFlags, create, deps) {
	      var hook = mountWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      currentlyRenderingFiber$1.flags |= fiberFlags;
	      hook.memoizedState = pushEffect(HasEffect | hookFlags, create, void 0, nextDeps);
	    }
	    function updateEffectImpl(fiberFlags, hookFlags, create, deps) {
	      var hook = updateWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      var destroy = void 0;
	      if (currentHook !== null) {
	        var prevEffect = currentHook.memoizedState;
	        destroy = prevEffect.destroy;
	        if (nextDeps !== null) {
	          var prevDeps = prevEffect.deps;
	          if (areHookInputsEqual(nextDeps, prevDeps)) {
	            hook.memoizedState = pushEffect(hookFlags, create, destroy, nextDeps);
	            return;
	          }
	        }
	      }
	      currentlyRenderingFiber$1.flags |= fiberFlags;
	      hook.memoizedState = pushEffect(HasEffect | hookFlags, create, destroy, nextDeps);
	    }
	    function mountEffect(create, deps) {
	      if ((currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode) {
	        return mountEffectImpl(MountPassiveDev | Passive | PassiveStatic, Passive$1, create, deps);
	      } else {
	        return mountEffectImpl(Passive | PassiveStatic, Passive$1, create, deps);
	      }
	    }
	    function updateEffect(create, deps) {
	      return updateEffectImpl(Passive, Passive$1, create, deps);
	    }
	    function mountInsertionEffect(create, deps) {
	      return mountEffectImpl(Update, Insertion, create, deps);
	    }
	    function updateInsertionEffect(create, deps) {
	      return updateEffectImpl(Update, Insertion, create, deps);
	    }
	    function mountLayoutEffect(create, deps) {
	      var fiberFlags = Update;
	      {
	        fiberFlags |= LayoutStatic;
	      }
	      if ((currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode) {
	        fiberFlags |= MountLayoutDev;
	      }
	      return mountEffectImpl(fiberFlags, Layout, create, deps);
	    }
	    function updateLayoutEffect(create, deps) {
	      return updateEffectImpl(Update, Layout, create, deps);
	    }
	    function imperativeHandleEffect(create, ref) {
	      if (typeof ref === "function") {
	        var refCallback = ref;
	        var _inst = create();
	        refCallback(_inst);
	        return function() {
	          refCallback(null);
	        };
	      } else if (ref !== null && ref !== void 0) {
	        var refObject = ref;
	        {
	          if (!refObject.hasOwnProperty("current")) {
	            error("Expected useImperativeHandle() first argument to either be a ref callback or React.createRef() object. Instead received: %s.", "an object with keys {" + Object.keys(refObject).join(", ") + "}");
	          }
	        }
	        var _inst2 = create();
	        refObject.current = _inst2;
	        return function() {
	          refObject.current = null;
	        };
	      }
	    }
	    function mountImperativeHandle(ref, create, deps) {
	      {
	        if (typeof create !== "function") {
	          error("Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null");
	        }
	      }
	      var effectDeps = deps !== null && deps !== void 0 ? deps.concat([ref]) : null;
	      var fiberFlags = Update;
	      {
	        fiberFlags |= LayoutStatic;
	      }
	      if ((currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode) {
	        fiberFlags |= MountLayoutDev;
	      }
	      return mountEffectImpl(fiberFlags, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
	    }
	    function updateImperativeHandle(ref, create, deps) {
	      {
	        if (typeof create !== "function") {
	          error("Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null");
	        }
	      }
	      var effectDeps = deps !== null && deps !== void 0 ? deps.concat([ref]) : null;
	      return updateEffectImpl(Update, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
	    }
	    function mountDebugValue(value, formatterFn) {
	    }
	    var updateDebugValue = mountDebugValue;
	    function mountCallback(callback, deps) {
	      var hook = mountWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      hook.memoizedState = [callback, nextDeps];
	      return callback;
	    }
	    function updateCallback(callback, deps) {
	      var hook = updateWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      var prevState = hook.memoizedState;
	      if (prevState !== null) {
	        if (nextDeps !== null) {
	          var prevDeps = prevState[1];
	          if (areHookInputsEqual(nextDeps, prevDeps)) {
	            return prevState[0];
	          }
	        }
	      }
	      hook.memoizedState = [callback, nextDeps];
	      return callback;
	    }
	    function mountMemo(nextCreate, deps) {
	      var hook = mountWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      var nextValue = nextCreate();
	      hook.memoizedState = [nextValue, nextDeps];
	      return nextValue;
	    }
	    function updateMemo(nextCreate, deps) {
	      var hook = updateWorkInProgressHook();
	      var nextDeps = deps === void 0 ? null : deps;
	      var prevState = hook.memoizedState;
	      if (prevState !== null) {
	        if (nextDeps !== null) {
	          var prevDeps = prevState[1];
	          if (areHookInputsEqual(nextDeps, prevDeps)) {
	            return prevState[0];
	          }
	        }
	      }
	      var nextValue = nextCreate();
	      hook.memoizedState = [nextValue, nextDeps];
	      return nextValue;
	    }
	    function mountDeferredValue(value) {
	      var hook = mountWorkInProgressHook();
	      hook.memoizedState = value;
	      return value;
	    }
	    function updateDeferredValue(value) {
	      var hook = updateWorkInProgressHook();
	      var resolvedCurrentHook = currentHook;
	      var prevValue = resolvedCurrentHook.memoizedState;
	      return updateDeferredValueImpl(hook, prevValue, value);
	    }
	    function rerenderDeferredValue(value) {
	      var hook = updateWorkInProgressHook();
	      if (currentHook === null) {
	        hook.memoizedState = value;
	        return value;
	      } else {
	        var prevValue = currentHook.memoizedState;
	        return updateDeferredValueImpl(hook, prevValue, value);
	      }
	    }
	    function updateDeferredValueImpl(hook, prevValue, value) {
	      var shouldDeferValue = !includesOnlyNonUrgentLanes(renderLanes);
	      if (shouldDeferValue) {
	        if (!objectIs(value, prevValue)) {
	          var deferredLane = claimNextTransitionLane();
	          currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, deferredLane);
	          markSkippedUpdateLanes(deferredLane);
	          hook.baseState = true;
	        }
	        return prevValue;
	      } else {
	        if (hook.baseState) {
	          hook.baseState = false;
	          markWorkInProgressReceivedUpdate();
	        }
	        hook.memoizedState = value;
	        return value;
	      }
	    }
	    function startTransition(setPending, callback, options2) {
	      var previousPriority = getCurrentUpdatePriority();
	      setCurrentUpdatePriority(higherEventPriority(previousPriority, ContinuousEventPriority));
	      setPending(true);
	      var prevTransition = ReactCurrentBatchConfig$2.transition;
	      ReactCurrentBatchConfig$2.transition = {};
	      var currentTransition = ReactCurrentBatchConfig$2.transition;
	      {
	        ReactCurrentBatchConfig$2.transition._updatedFibers = /* @__PURE__ */ new Set();
	      }
	      try {
	        setPending(false);
	        callback();
	      } finally {
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig$2.transition = prevTransition;
	        {
	          if (prevTransition === null && currentTransition._updatedFibers) {
	            var updatedFibersCount = currentTransition._updatedFibers.size;
	            if (updatedFibersCount > 10) {
	              warn("Detected a large number of updates inside startTransition. If this is due to a subscription please re-write it to use React provided hooks. Otherwise concurrent mode guarantees are off the table.");
	            }
	            currentTransition._updatedFibers.clear();
	          }
	        }
	      }
	    }
	    function mountTransition() {
	      var _mountState = mountState(false), isPending = _mountState[0], setPending = _mountState[1];
	      var start = startTransition.bind(null, setPending);
	      var hook = mountWorkInProgressHook();
	      hook.memoizedState = start;
	      return [isPending, start];
	    }
	    function updateTransition() {
	      var _updateState = updateState(), isPending = _updateState[0];
	      var hook = updateWorkInProgressHook();
	      var start = hook.memoizedState;
	      return [isPending, start];
	    }
	    function rerenderTransition() {
	      var _rerenderState = rerenderState(), isPending = _rerenderState[0];
	      var hook = updateWorkInProgressHook();
	      var start = hook.memoizedState;
	      return [isPending, start];
	    }
	    var isUpdatingOpaqueValueInRenderPhase = false;
	    function getIsUpdatingOpaqueValueInRenderPhaseInDEV() {
	      {
	        return isUpdatingOpaqueValueInRenderPhase;
	      }
	    }
	    function mountId() {
	      var hook = mountWorkInProgressHook();
	      var root2 = getWorkInProgressRoot();
	      var identifierPrefix = root2.identifierPrefix;
	      var id;
	      if (getIsHydrating()) {
	        var treeId = getTreeId();
	        id = ":" + identifierPrefix + "R" + treeId;
	        var localId = localIdCounter++;
	        if (localId > 0) {
	          id += "H" + localId.toString(32);
	        }
	        id += ":";
	      } else {
	        var globalClientId = globalClientIdCounter++;
	        id = ":" + identifierPrefix + "r" + globalClientId.toString(32) + ":";
	      }
	      hook.memoizedState = id;
	      return id;
	    }
	    function updateId() {
	      var hook = updateWorkInProgressHook();
	      var id = hook.memoizedState;
	      return id;
	    }
	    function dispatchReducerAction(fiber, queue, action) {
	      {
	        if (typeof arguments[3] === "function") {
	          error("State updates from the useState() and useReducer() Hooks don't support the second callback argument. To execute a side effect after rendering, declare it in the component body with useEffect().");
	        }
	      }
	      var lane = requestUpdateLane(fiber);
	      var update = {
	        lane,
	        action,
	        hasEagerState: false,
	        eagerState: null,
	        next: null
	      };
	      if (isRenderPhaseUpdate(fiber)) {
	        enqueueRenderPhaseUpdate(queue, update);
	      } else {
	        var root2 = enqueueConcurrentHookUpdate(fiber, queue, update, lane);
	        if (root2 !== null) {
	          var eventTime = requestEventTime();
	          scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	          entangleTransitionUpdate(root2, queue, lane);
	        }
	      }
	      markUpdateInDevTools(fiber, lane);
	    }
	    function dispatchSetState(fiber, queue, action) {
	      {
	        if (typeof arguments[3] === "function") {
	          error("State updates from the useState() and useReducer() Hooks don't support the second callback argument. To execute a side effect after rendering, declare it in the component body with useEffect().");
	        }
	      }
	      var lane = requestUpdateLane(fiber);
	      var update = {
	        lane,
	        action,
	        hasEagerState: false,
	        eagerState: null,
	        next: null
	      };
	      if (isRenderPhaseUpdate(fiber)) {
	        enqueueRenderPhaseUpdate(queue, update);
	      } else {
	        var alternate = fiber.alternate;
	        if (fiber.lanes === NoLanes && (alternate === null || alternate.lanes === NoLanes)) {
	          var lastRenderedReducer = queue.lastRenderedReducer;
	          if (lastRenderedReducer !== null) {
	            var prevDispatcher;
	            {
	              prevDispatcher = ReactCurrentDispatcher$1.current;
	              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	            }
	            try {
	              var currentState = queue.lastRenderedState;
	              var eagerState = lastRenderedReducer(currentState, action);
	              update.hasEagerState = true;
	              update.eagerState = eagerState;
	              if (objectIs(eagerState, currentState)) {
	                enqueueConcurrentHookUpdateAndEagerlyBailout(fiber, queue, update, lane);
	                return;
	              }
	            } catch (error2) {
	            } finally {
	              {
	                ReactCurrentDispatcher$1.current = prevDispatcher;
	              }
	            }
	          }
	        }
	        var root2 = enqueueConcurrentHookUpdate(fiber, queue, update, lane);
	        if (root2 !== null) {
	          var eventTime = requestEventTime();
	          scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	          entangleTransitionUpdate(root2, queue, lane);
	        }
	      }
	      markUpdateInDevTools(fiber, lane);
	    }
	    function isRenderPhaseUpdate(fiber) {
	      var alternate = fiber.alternate;
	      return fiber === currentlyRenderingFiber$1 || alternate !== null && alternate === currentlyRenderingFiber$1;
	    }
	    function enqueueRenderPhaseUpdate(queue, update) {
	      didScheduleRenderPhaseUpdateDuringThisPass = didScheduleRenderPhaseUpdate = true;
	      var pending = queue.pending;
	      if (pending === null) {
	        update.next = update;
	      } else {
	        update.next = pending.next;
	        pending.next = update;
	      }
	      queue.pending = update;
	    }
	    function entangleTransitionUpdate(root2, queue, lane) {
	      if (isTransitionLane(lane)) {
	        var queueLanes = queue.lanes;
	        queueLanes = intersectLanes(queueLanes, root2.pendingLanes);
	        var newQueueLanes = mergeLanes(queueLanes, lane);
	        queue.lanes = newQueueLanes;
	        markRootEntangled(root2, newQueueLanes);
	      }
	    }
	    function markUpdateInDevTools(fiber, lane, action) {
	      {
	        markStateUpdateScheduled(fiber, lane);
	      }
	    }
	    var ContextOnlyDispatcher = {
	      readContext,
	      useCallback: throwInvalidHookError,
	      useContext: throwInvalidHookError,
	      useEffect: throwInvalidHookError,
	      useImperativeHandle: throwInvalidHookError,
	      useInsertionEffect: throwInvalidHookError,
	      useLayoutEffect: throwInvalidHookError,
	      useMemo: throwInvalidHookError,
	      useReducer: throwInvalidHookError,
	      useRef: throwInvalidHookError,
	      useState: throwInvalidHookError,
	      useDebugValue: throwInvalidHookError,
	      useDeferredValue: throwInvalidHookError,
	      useTransition: throwInvalidHookError,
	      useMutableSource: throwInvalidHookError,
	      useSyncExternalStore: throwInvalidHookError,
	      useId: throwInvalidHookError,
	      unstable_isNewReconciler: enableNewReconciler
	    };
	    var HooksDispatcherOnMountInDEV = null;
	    var HooksDispatcherOnMountWithHookTypesInDEV = null;
	    var HooksDispatcherOnUpdateInDEV = null;
	    var HooksDispatcherOnRerenderInDEV = null;
	    var InvalidNestedHooksDispatcherOnMountInDEV = null;
	    var InvalidNestedHooksDispatcherOnUpdateInDEV = null;
	    var InvalidNestedHooksDispatcherOnRerenderInDEV = null;
	    {
	      var warnInvalidContextAccess = function() {
	        error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
	      };
	      var warnInvalidHookAccess = function() {
	        error("Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. You can only call Hooks at the top level of your React function. For more information, see https://reactjs.org/link/rules-of-hooks");
	      };
	      HooksDispatcherOnMountInDEV = {
	        readContext: function(context) {
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          return mountCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          mountHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          return mountEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          return mountImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          return mountInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          return mountLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          mountHookTypesDev();
	          checkDepsAreArrayDev(deps);
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          mountHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          mountHookTypesDev();
	          return mountRef(initialValue);
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          mountHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          mountHookTypesDev();
	          return mountDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          mountHookTypesDev();
	          return mountDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          mountHookTypesDev();
	          return mountTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          mountHookTypesDev();
	          return mountMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          mountHookTypesDev();
	          return mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          mountHookTypesDev();
	          return mountId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      HooksDispatcherOnMountWithHookTypesInDEV = {
	        readContext: function(context) {
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          updateHookTypesDev();
	          return mountCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          updateHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          updateHookTypesDev();
	          return mountEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          updateHookTypesDev();
	          return mountImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          updateHookTypesDev();
	          return mountInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          updateHookTypesDev();
	          return mountLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          updateHookTypesDev();
	          return mountRef(initialValue);
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          updateHookTypesDev();
	          return mountDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          updateHookTypesDev();
	          return mountDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          updateHookTypesDev();
	          return mountTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          updateHookTypesDev();
	          return mountMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          updateHookTypesDev();
	          return mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          updateHookTypesDev();
	          return mountId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      HooksDispatcherOnUpdateInDEV = {
	        readContext: function(context) {
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          updateHookTypesDev();
	          return updateCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          updateHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          updateHookTypesDev();
	          return updateEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          updateHookTypesDev();
	          return updateImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          updateHookTypesDev();
	          return updateInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          updateHookTypesDev();
	          return updateLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          updateHookTypesDev();
	          return updateRef();
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          updateHookTypesDev();
	          return updateDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          updateHookTypesDev();
	          return updateDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          updateHookTypesDev();
	          return updateTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          updateHookTypesDev();
	          return updateMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          updateHookTypesDev();
	          return updateSyncExternalStore(subscribe, getSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          updateHookTypesDev();
	          return updateId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      HooksDispatcherOnRerenderInDEV = {
	        readContext: function(context) {
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          updateHookTypesDev();
	          return updateCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          updateHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          updateHookTypesDev();
	          return updateEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          updateHookTypesDev();
	          return updateImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          updateHookTypesDev();
	          return updateInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          updateHookTypesDev();
	          return updateLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
	          try {
	            return updateMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
	          try {
	            return rerenderReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          updateHookTypesDev();
	          return updateRef();
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
	          try {
	            return rerenderState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          updateHookTypesDev();
	          return updateDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          updateHookTypesDev();
	          return rerenderDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          updateHookTypesDev();
	          return rerenderTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          updateHookTypesDev();
	          return updateMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          updateHookTypesDev();
	          return updateSyncExternalStore(subscribe, getSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          updateHookTypesDev();
	          return updateId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      InvalidNestedHooksDispatcherOnMountInDEV = {
	        readContext: function(context) {
	          warnInvalidContextAccess();
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountRef(initialValue);
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
	          try {
	            return mountState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          warnInvalidHookAccess();
	          mountHookTypesDev();
	          return mountId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      InvalidNestedHooksDispatcherOnUpdateInDEV = {
	        readContext: function(context) {
	          warnInvalidContextAccess();
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateRef();
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateSyncExternalStore(subscribe, getSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	      InvalidNestedHooksDispatcherOnRerenderInDEV = {
	        readContext: function(context) {
	          warnInvalidContextAccess();
	          return readContext(context);
	        },
	        useCallback: function(callback, deps) {
	          currentHookNameInDev = "useCallback";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateCallback(callback, deps);
	        },
	        useContext: function(context) {
	          currentHookNameInDev = "useContext";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return readContext(context);
	        },
	        useEffect: function(create, deps) {
	          currentHookNameInDev = "useEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateEffect(create, deps);
	        },
	        useImperativeHandle: function(ref, create, deps) {
	          currentHookNameInDev = "useImperativeHandle";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateImperativeHandle(ref, create, deps);
	        },
	        useInsertionEffect: function(create, deps) {
	          currentHookNameInDev = "useInsertionEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateInsertionEffect(create, deps);
	        },
	        useLayoutEffect: function(create, deps) {
	          currentHookNameInDev = "useLayoutEffect";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateLayoutEffect(create, deps);
	        },
	        useMemo: function(create, deps) {
	          currentHookNameInDev = "useMemo";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return updateMemo(create, deps);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useReducer: function(reducer, initialArg, init) {
	          currentHookNameInDev = "useReducer";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return rerenderReducer(reducer, initialArg, init);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useRef: function(initialValue) {
	          currentHookNameInDev = "useRef";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateRef();
	        },
	        useState: function(initialState) {
	          currentHookNameInDev = "useState";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          var prevDispatcher = ReactCurrentDispatcher$1.current;
	          ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
	          try {
	            return rerenderState(initialState);
	          } finally {
	            ReactCurrentDispatcher$1.current = prevDispatcher;
	          }
	        },
	        useDebugValue: function(value, formatterFn) {
	          currentHookNameInDev = "useDebugValue";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateDebugValue();
	        },
	        useDeferredValue: function(value) {
	          currentHookNameInDev = "useDeferredValue";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return rerenderDeferredValue(value);
	        },
	        useTransition: function() {
	          currentHookNameInDev = "useTransition";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return rerenderTransition();
	        },
	        useMutableSource: function(source, getSnapshot, subscribe) {
	          currentHookNameInDev = "useMutableSource";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateMutableSource();
	        },
	        useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
	          currentHookNameInDev = "useSyncExternalStore";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateSyncExternalStore(subscribe, getSnapshot);
	        },
	        useId: function() {
	          currentHookNameInDev = "useId";
	          warnInvalidHookAccess();
	          updateHookTypesDev();
	          return updateId();
	        },
	        unstable_isNewReconciler: enableNewReconciler
	      };
	    }
	    var now$1 = Scheduler.unstable_now;
	    var commitTime = 0;
	    var layoutEffectStartTime = -1;
	    var profilerStartTime = -1;
	    var passiveEffectStartTime = -1;
	    var currentUpdateIsNested = false;
	    var nestedUpdateScheduled = false;
	    function isCurrentUpdateNested() {
	      return currentUpdateIsNested;
	    }
	    function markNestedUpdateScheduled() {
	      {
	        nestedUpdateScheduled = true;
	      }
	    }
	    function resetNestedUpdateFlag() {
	      {
	        currentUpdateIsNested = false;
	        nestedUpdateScheduled = false;
	      }
	    }
	    function syncNestedUpdateFlag() {
	      {
	        currentUpdateIsNested = nestedUpdateScheduled;
	        nestedUpdateScheduled = false;
	      }
	    }
	    function getCommitTime() {
	      return commitTime;
	    }
	    function recordCommitTime() {
	      commitTime = now$1();
	    }
	    function startProfilerTimer(fiber) {
	      profilerStartTime = now$1();
	      if (fiber.actualStartTime < 0) {
	        fiber.actualStartTime = now$1();
	      }
	    }
	    function stopProfilerTimerIfRunning(fiber) {
	      profilerStartTime = -1;
	    }
	    function stopProfilerTimerIfRunningAndRecordDelta(fiber, overrideBaseTime) {
	      if (profilerStartTime >= 0) {
	        var elapsedTime = now$1() - profilerStartTime;
	        fiber.actualDuration += elapsedTime;
	        if (overrideBaseTime) {
	          fiber.selfBaseDuration = elapsedTime;
	        }
	        profilerStartTime = -1;
	      }
	    }
	    function recordLayoutEffectDuration(fiber) {
	      if (layoutEffectStartTime >= 0) {
	        var elapsedTime = now$1() - layoutEffectStartTime;
	        layoutEffectStartTime = -1;
	        var parentFiber = fiber.return;
	        while (parentFiber !== null) {
	          switch (parentFiber.tag) {
	            case HostRoot:
	              var root2 = parentFiber.stateNode;
	              root2.effectDuration += elapsedTime;
	              return;
	            case Profiler:
	              var parentStateNode = parentFiber.stateNode;
	              parentStateNode.effectDuration += elapsedTime;
	              return;
	          }
	          parentFiber = parentFiber.return;
	        }
	      }
	    }
	    function recordPassiveEffectDuration(fiber) {
	      if (passiveEffectStartTime >= 0) {
	        var elapsedTime = now$1() - passiveEffectStartTime;
	        passiveEffectStartTime = -1;
	        var parentFiber = fiber.return;
	        while (parentFiber !== null) {
	          switch (parentFiber.tag) {
	            case HostRoot:
	              var root2 = parentFiber.stateNode;
	              if (root2 !== null) {
	                root2.passiveEffectDuration += elapsedTime;
	              }
	              return;
	            case Profiler:
	              var parentStateNode = parentFiber.stateNode;
	              if (parentStateNode !== null) {
	                parentStateNode.passiveEffectDuration += elapsedTime;
	              }
	              return;
	          }
	          parentFiber = parentFiber.return;
	        }
	      }
	    }
	    function startLayoutEffectTimer() {
	      layoutEffectStartTime = now$1();
	    }
	    function startPassiveEffectTimer() {
	      passiveEffectStartTime = now$1();
	    }
	    function transferActualDuration(fiber) {
	      var child = fiber.child;
	      while (child) {
	        fiber.actualDuration += child.actualDuration;
	        child = child.sibling;
	      }
	    }
	    function createCapturedValueAtFiber(value, source) {
	      return {
	        value,
	        source,
	        stack: getStackByFiberInDevAndProd(source),
	        digest: null
	      };
	    }
	    function createCapturedValue(value, digest, stack) {
	      return {
	        value,
	        source: null,
	        stack: stack != null ? stack : null,
	        digest: digest != null ? digest : null
	      };
	    }
	    function showErrorDialog(boundary, errorInfo) {
	      return true;
	    }
	    function logCapturedError(boundary, errorInfo) {
	      try {
	        var logError = showErrorDialog(boundary, errorInfo);
	        if (logError === false) {
	          return;
	        }
	        var error2 = errorInfo.value;
	        if (true) {
	          var source = errorInfo.source;
	          var stack = errorInfo.stack;
	          var componentStack = stack !== null ? stack : "";
	          if (error2 != null && error2._suppressLogging) {
	            if (boundary.tag === ClassComponent) {
	              return;
	            }
	            console["error"](error2);
	          }
	          var componentName = source ? getComponentNameFromFiber(source) : null;
	          var componentNameMessage = componentName ? "The above error occurred in the <" + componentName + "> component:" : "The above error occurred in one of your React components:";
	          var errorBoundaryMessage;
	          if (boundary.tag === HostRoot) {
	            errorBoundaryMessage = "Consider adding an error boundary to your tree to customize error handling behavior.\nVisit https://reactjs.org/link/error-boundaries to learn more about error boundaries.";
	          } else {
	            var errorBoundaryName = getComponentNameFromFiber(boundary) || "Anonymous";
	            errorBoundaryMessage = "React will try to recreate this component tree from scratch " + ("using the error boundary you provided, " + errorBoundaryName + ".");
	          }
	          var combinedMessage = componentNameMessage + "\n" + componentStack + "\n\n" + ("" + errorBoundaryMessage);
	          console["error"](combinedMessage);
	        }
	      } catch (e) {
	        setTimeout(function() {
	          throw e;
	        });
	      }
	    }
	    var PossiblyWeakMap$1 = typeof WeakMap === "function" ? WeakMap : Map;
	    function createRootErrorUpdate(fiber, errorInfo, lane) {
	      var update = createUpdate(NoTimestamp, lane);
	      update.tag = CaptureUpdate;
	      update.payload = {
	        element: null
	      };
	      var error2 = errorInfo.value;
	      update.callback = function() {
	        onUncaughtError(error2);
	        logCapturedError(fiber, errorInfo);
	      };
	      return update;
	    }
	    function createClassErrorUpdate(fiber, errorInfo, lane) {
	      var update = createUpdate(NoTimestamp, lane);
	      update.tag = CaptureUpdate;
	      var getDerivedStateFromError = fiber.type.getDerivedStateFromError;
	      if (typeof getDerivedStateFromError === "function") {
	        var error$1 = errorInfo.value;
	        update.payload = function() {
	          return getDerivedStateFromError(error$1);
	        };
	        update.callback = function() {
	          {
	            markFailedErrorBoundaryForHotReloading(fiber);
	          }
	          logCapturedError(fiber, errorInfo);
	        };
	      }
	      var inst = fiber.stateNode;
	      if (inst !== null && typeof inst.componentDidCatch === "function") {
	        update.callback = function callback() {
	          {
	            markFailedErrorBoundaryForHotReloading(fiber);
	          }
	          logCapturedError(fiber, errorInfo);
	          if (typeof getDerivedStateFromError !== "function") {
	            markLegacyErrorBoundaryAsFailed(this);
	          }
	          var error$12 = errorInfo.value;
	          var stack = errorInfo.stack;
	          this.componentDidCatch(error$12, {
	            componentStack: stack !== null ? stack : ""
	          });
	          {
	            if (typeof getDerivedStateFromError !== "function") {
	              if (!includesSomeLane(fiber.lanes, SyncLane)) {
	                error("%s: Error boundaries should implement getDerivedStateFromError(). In that method, return a state update to display an error message or fallback UI.", getComponentNameFromFiber(fiber) || "Unknown");
	              }
	            }
	          }
	        };
	      }
	      return update;
	    }
	    function attachPingListener(root2, wakeable, lanes) {
	      var pingCache = root2.pingCache;
	      var threadIDs;
	      if (pingCache === null) {
	        pingCache = root2.pingCache = new PossiblyWeakMap$1();
	        threadIDs = /* @__PURE__ */ new Set();
	        pingCache.set(wakeable, threadIDs);
	      } else {
	        threadIDs = pingCache.get(wakeable);
	        if (threadIDs === void 0) {
	          threadIDs = /* @__PURE__ */ new Set();
	          pingCache.set(wakeable, threadIDs);
	        }
	      }
	      if (!threadIDs.has(lanes)) {
	        threadIDs.add(lanes);
	        var ping = pingSuspendedRoot.bind(null, root2, wakeable, lanes);
	        {
	          if (isDevToolsPresent) {
	            restorePendingUpdaters(root2, lanes);
	          }
	        }
	        wakeable.then(ping, ping);
	      }
	    }
	    function attachRetryListener(suspenseBoundary, root2, wakeable, lanes) {
	      var wakeables = suspenseBoundary.updateQueue;
	      if (wakeables === null) {
	        var updateQueue = /* @__PURE__ */ new Set();
	        updateQueue.add(wakeable);
	        suspenseBoundary.updateQueue = updateQueue;
	      } else {
	        wakeables.add(wakeable);
	      }
	    }
	    function resetSuspendedComponent(sourceFiber, rootRenderLanes) {
	      var tag = sourceFiber.tag;
	      if ((sourceFiber.mode & ConcurrentMode) === NoMode && (tag === FunctionComponent || tag === ForwardRef || tag === SimpleMemoComponent)) {
	        var currentSource = sourceFiber.alternate;
	        if (currentSource) {
	          sourceFiber.updateQueue = currentSource.updateQueue;
	          sourceFiber.memoizedState = currentSource.memoizedState;
	          sourceFiber.lanes = currentSource.lanes;
	        } else {
	          sourceFiber.updateQueue = null;
	          sourceFiber.memoizedState = null;
	        }
	      }
	    }
	    function getNearestSuspenseBoundaryToCapture(returnFiber) {
	      var node = returnFiber;
	      do {
	        if (node.tag === SuspenseComponent && shouldCaptureSuspense(node)) {
	          return node;
	        }
	        node = node.return;
	      } while (node !== null);
	      return null;
	    }
	    function markSuspenseBoundaryShouldCapture(suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes) {
	      if ((suspenseBoundary.mode & ConcurrentMode) === NoMode) {
	        if (suspenseBoundary === returnFiber) {
	          suspenseBoundary.flags |= ShouldCapture;
	        } else {
	          suspenseBoundary.flags |= DidCapture;
	          sourceFiber.flags |= ForceUpdateForLegacySuspense;
	          sourceFiber.flags &= ~(LifecycleEffectMask | Incomplete);
	          if (sourceFiber.tag === ClassComponent) {
	            var currentSourceFiber = sourceFiber.alternate;
	            if (currentSourceFiber === null) {
	              sourceFiber.tag = IncompleteClassComponent;
	            } else {
	              var update = createUpdate(NoTimestamp, SyncLane);
	              update.tag = ForceUpdate;
	              enqueueUpdate(sourceFiber, update, SyncLane);
	            }
	          }
	          sourceFiber.lanes = mergeLanes(sourceFiber.lanes, SyncLane);
	        }
	        return suspenseBoundary;
	      }
	      suspenseBoundary.flags |= ShouldCapture;
	      suspenseBoundary.lanes = rootRenderLanes;
	      return suspenseBoundary;
	    }
	    function throwException(root2, returnFiber, sourceFiber, value, rootRenderLanes) {
	      sourceFiber.flags |= Incomplete;
	      {
	        if (isDevToolsPresent) {
	          restorePendingUpdaters(root2, rootRenderLanes);
	        }
	      }
	      if (value !== null && typeof value === "object" && typeof value.then === "function") {
	        var wakeable = value;
	        resetSuspendedComponent(sourceFiber);
	        {
	          if (getIsHydrating() && sourceFiber.mode & ConcurrentMode) {
	            markDidThrowWhileHydratingDEV();
	          }
	        }
	        var suspenseBoundary = getNearestSuspenseBoundaryToCapture(returnFiber);
	        if (suspenseBoundary !== null) {
	          suspenseBoundary.flags &= ~ForceClientRender;
	          markSuspenseBoundaryShouldCapture(suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes);
	          if (suspenseBoundary.mode & ConcurrentMode) {
	            attachPingListener(root2, wakeable, rootRenderLanes);
	          }
	          attachRetryListener(suspenseBoundary, root2, wakeable);
	          return;
	        } else {
	          if (!includesSyncLane(rootRenderLanes)) {
	            attachPingListener(root2, wakeable, rootRenderLanes);
	            renderDidSuspendDelayIfPossible();
	            return;
	          }
	          var uncaughtSuspenseError = new Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");
	          value = uncaughtSuspenseError;
	        }
	      } else {
	        if (getIsHydrating() && sourceFiber.mode & ConcurrentMode) {
	          markDidThrowWhileHydratingDEV();
	          var _suspenseBoundary = getNearestSuspenseBoundaryToCapture(returnFiber);
	          if (_suspenseBoundary !== null) {
	            if ((_suspenseBoundary.flags & ShouldCapture) === NoFlags) {
	              _suspenseBoundary.flags |= ForceClientRender;
	            }
	            markSuspenseBoundaryShouldCapture(_suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes);
	            queueHydrationError(createCapturedValueAtFiber(value, sourceFiber));
	            return;
	          }
	        }
	      }
	      value = createCapturedValueAtFiber(value, sourceFiber);
	      renderDidError(value);
	      var workInProgress2 = returnFiber;
	      do {
	        switch (workInProgress2.tag) {
	          case HostRoot: {
	            var _errorInfo = value;
	            workInProgress2.flags |= ShouldCapture;
	            var lane = pickArbitraryLane(rootRenderLanes);
	            workInProgress2.lanes = mergeLanes(workInProgress2.lanes, lane);
	            var update = createRootErrorUpdate(workInProgress2, _errorInfo, lane);
	            enqueueCapturedUpdate(workInProgress2, update);
	            return;
	          }
	          case ClassComponent:
	            var errorInfo = value;
	            var ctor = workInProgress2.type;
	            var instance = workInProgress2.stateNode;
	            if ((workInProgress2.flags & DidCapture) === NoFlags && (typeof ctor.getDerivedStateFromError === "function" || instance !== null && typeof instance.componentDidCatch === "function" && !isAlreadyFailedLegacyErrorBoundary(instance))) {
	              workInProgress2.flags |= ShouldCapture;
	              var _lane = pickArbitraryLane(rootRenderLanes);
	              workInProgress2.lanes = mergeLanes(workInProgress2.lanes, _lane);
	              var _update = createClassErrorUpdate(workInProgress2, errorInfo, _lane);
	              enqueueCapturedUpdate(workInProgress2, _update);
	              return;
	            }
	            break;
	        }
	        workInProgress2 = workInProgress2.return;
	      } while (workInProgress2 !== null);
	    }
	    function getSuspendedCache() {
	      {
	        return null;
	      }
	    }
	    var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
	    var didReceiveUpdate = false;
	    var didWarnAboutBadClass;
	    var didWarnAboutModulePatternComponent;
	    var didWarnAboutContextTypeOnFunctionComponent;
	    var didWarnAboutGetDerivedStateOnFunctionComponent;
	    var didWarnAboutFunctionRefs;
	    var didWarnAboutReassigningProps;
	    var didWarnAboutRevealOrder;
	    var didWarnAboutTailOptions;
	    {
	      didWarnAboutBadClass = {};
	      didWarnAboutModulePatternComponent = {};
	      didWarnAboutContextTypeOnFunctionComponent = {};
	      didWarnAboutGetDerivedStateOnFunctionComponent = {};
	      didWarnAboutFunctionRefs = {};
	      didWarnAboutReassigningProps = false;
	      didWarnAboutRevealOrder = {};
	      didWarnAboutTailOptions = {};
	    }
	    function reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2) {
	      if (current2 === null) {
	        workInProgress2.child = mountChildFibers(workInProgress2, null, nextChildren, renderLanes2);
	      } else {
	        workInProgress2.child = reconcileChildFibers(workInProgress2, current2.child, nextChildren, renderLanes2);
	      }
	    }
	    function forceUnmountCurrentAndReconcile(current2, workInProgress2, nextChildren, renderLanes2) {
	      workInProgress2.child = reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2);
	      workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderLanes2);
	    }
	    function updateForwardRef(current2, workInProgress2, Component, nextProps, renderLanes2) {
	      {
	        if (workInProgress2.type !== workInProgress2.elementType) {
	          var innerPropTypes = Component.propTypes;
	          if (innerPropTypes) {
	            checkPropTypes(
	              innerPropTypes,
	              nextProps,
	              // Resolved props
	              "prop",
	              getComponentNameFromType(Component)
	            );
	          }
	        }
	      }
	      var render2 = Component.render;
	      var ref = workInProgress2.ref;
	      var nextChildren;
	      var hasId;
	      prepareToReadContext(workInProgress2, renderLanes2);
	      {
	        markComponentRenderStarted(workInProgress2);
	      }
	      {
	        ReactCurrentOwner$1.current = workInProgress2;
	        setIsRendering(true);
	        nextChildren = renderWithHooks(current2, workInProgress2, render2, nextProps, ref, renderLanes2);
	        hasId = checkDidRenderIdHook();
	        if (workInProgress2.mode & StrictLegacyMode) {
	          setIsStrictModeForDevtools(true);
	          try {
	            nextChildren = renderWithHooks(current2, workInProgress2, render2, nextProps, ref, renderLanes2);
	            hasId = checkDidRenderIdHook();
	          } finally {
	            setIsStrictModeForDevtools(false);
	          }
	        }
	        setIsRendering(false);
	      }
	      {
	        markComponentRenderStopped();
	      }
	      if (current2 !== null && !didReceiveUpdate) {
	        bailoutHooks(current2, workInProgress2, renderLanes2);
	        return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	      }
	      if (getIsHydrating() && hasId) {
	        pushMaterializedTreeId(workInProgress2);
	      }
	      workInProgress2.flags |= PerformedWork;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateMemoComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
	      if (current2 === null) {
	        var type = Component.type;
	        if (isSimpleFunctionComponent(type) && Component.compare === null && // SimpleMemoComponent codepath doesn't resolve outer props either.
	        Component.defaultProps === void 0) {
	          var resolvedType = type;
	          {
	            resolvedType = resolveFunctionForHotReloading(type);
	          }
	          workInProgress2.tag = SimpleMemoComponent;
	          workInProgress2.type = resolvedType;
	          {
	            validateFunctionComponentInDev(workInProgress2, type);
	          }
	          return updateSimpleMemoComponent(current2, workInProgress2, resolvedType, nextProps, renderLanes2);
	        }
	        {
	          var innerPropTypes = type.propTypes;
	          if (innerPropTypes) {
	            checkPropTypes(
	              innerPropTypes,
	              nextProps,
	              // Resolved props
	              "prop",
	              getComponentNameFromType(type)
	            );
	          }
	        }
	        var child = createFiberFromTypeAndProps(Component.type, null, nextProps, workInProgress2, workInProgress2.mode, renderLanes2);
	        child.ref = workInProgress2.ref;
	        child.return = workInProgress2;
	        workInProgress2.child = child;
	        return child;
	      }
	      {
	        var _type = Component.type;
	        var _innerPropTypes = _type.propTypes;
	        if (_innerPropTypes) {
	          checkPropTypes(
	            _innerPropTypes,
	            nextProps,
	            // Resolved props
	            "prop",
	            getComponentNameFromType(_type)
	          );
	        }
	      }
	      var currentChild = current2.child;
	      var hasScheduledUpdateOrContext = checkScheduledUpdateOrContext(current2, renderLanes2);
	      if (!hasScheduledUpdateOrContext) {
	        var prevProps = currentChild.memoizedProps;
	        var compare = Component.compare;
	        compare = compare !== null ? compare : shallowEqual;
	        if (compare(prevProps, nextProps) && current2.ref === workInProgress2.ref) {
	          return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	        }
	      }
	      workInProgress2.flags |= PerformedWork;
	      var newChild = createWorkInProgress(currentChild, nextProps);
	      newChild.ref = workInProgress2.ref;
	      newChild.return = workInProgress2;
	      workInProgress2.child = newChild;
	      return newChild;
	    }
	    function updateSimpleMemoComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
	      {
	        if (workInProgress2.type !== workInProgress2.elementType) {
	          var outerMemoType = workInProgress2.elementType;
	          if (outerMemoType.$$typeof === REACT_LAZY_TYPE) {
	            var lazyComponent = outerMemoType;
	            var payload = lazyComponent._payload;
	            var init = lazyComponent._init;
	            try {
	              outerMemoType = init(payload);
	            } catch (x) {
	              outerMemoType = null;
	            }
	            var outerPropTypes = outerMemoType && outerMemoType.propTypes;
	            if (outerPropTypes) {
	              checkPropTypes(
	                outerPropTypes,
	                nextProps,
	                // Resolved (SimpleMemoComponent has no defaultProps)
	                "prop",
	                getComponentNameFromType(outerMemoType)
	              );
	            }
	          }
	        }
	      }
	      if (current2 !== null) {
	        var prevProps = current2.memoizedProps;
	        if (shallowEqual(prevProps, nextProps) && current2.ref === workInProgress2.ref && // Prevent bailout if the implementation changed due to hot reload.
	        workInProgress2.type === current2.type) {
	          didReceiveUpdate = false;
	          workInProgress2.pendingProps = nextProps = prevProps;
	          if (!checkScheduledUpdateOrContext(current2, renderLanes2)) {
	            workInProgress2.lanes = current2.lanes;
	            return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	          } else if ((current2.flags & ForceUpdateForLegacySuspense) !== NoFlags) {
	            didReceiveUpdate = true;
	          }
	        }
	      }
	      return updateFunctionComponent(current2, workInProgress2, Component, nextProps, renderLanes2);
	    }
	    function updateOffscreenComponent(current2, workInProgress2, renderLanes2) {
	      var nextProps = workInProgress2.pendingProps;
	      var nextChildren = nextProps.children;
	      var prevState = current2 !== null ? current2.memoizedState : null;
	      if (nextProps.mode === "hidden" || enableLegacyHidden) {
	        if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	          var nextState = {
	            baseLanes: NoLanes,
	            cachePool: null,
	            transitions: null
	          };
	          workInProgress2.memoizedState = nextState;
	          pushRenderLanes(workInProgress2, renderLanes2);
	        } else if (!includesSomeLane(renderLanes2, OffscreenLane)) {
	          var spawnedCachePool = null;
	          var nextBaseLanes;
	          if (prevState !== null) {
	            var prevBaseLanes = prevState.baseLanes;
	            nextBaseLanes = mergeLanes(prevBaseLanes, renderLanes2);
	          } else {
	            nextBaseLanes = renderLanes2;
	          }
	          workInProgress2.lanes = workInProgress2.childLanes = laneToLanes(OffscreenLane);
	          var _nextState = {
	            baseLanes: nextBaseLanes,
	            cachePool: spawnedCachePool,
	            transitions: null
	          };
	          workInProgress2.memoizedState = _nextState;
	          workInProgress2.updateQueue = null;
	          pushRenderLanes(workInProgress2, nextBaseLanes);
	          return null;
	        } else {
	          var _nextState2 = {
	            baseLanes: NoLanes,
	            cachePool: null,
	            transitions: null
	          };
	          workInProgress2.memoizedState = _nextState2;
	          var subtreeRenderLanes2 = prevState !== null ? prevState.baseLanes : renderLanes2;
	          pushRenderLanes(workInProgress2, subtreeRenderLanes2);
	        }
	      } else {
	        var _subtreeRenderLanes;
	        if (prevState !== null) {
	          _subtreeRenderLanes = mergeLanes(prevState.baseLanes, renderLanes2);
	          workInProgress2.memoizedState = null;
	        } else {
	          _subtreeRenderLanes = renderLanes2;
	        }
	        pushRenderLanes(workInProgress2, _subtreeRenderLanes);
	      }
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateFragment(current2, workInProgress2, renderLanes2) {
	      var nextChildren = workInProgress2.pendingProps;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateMode(current2, workInProgress2, renderLanes2) {
	      var nextChildren = workInProgress2.pendingProps.children;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateProfiler(current2, workInProgress2, renderLanes2) {
	      {
	        workInProgress2.flags |= Update;
	        {
	          var stateNode = workInProgress2.stateNode;
	          stateNode.effectDuration = 0;
	          stateNode.passiveEffectDuration = 0;
	        }
	      }
	      var nextProps = workInProgress2.pendingProps;
	      var nextChildren = nextProps.children;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function markRef(current2, workInProgress2) {
	      var ref = workInProgress2.ref;
	      if (current2 === null && ref !== null || current2 !== null && current2.ref !== ref) {
	        workInProgress2.flags |= Ref;
	        {
	          workInProgress2.flags |= RefStatic;
	        }
	      }
	    }
	    function updateFunctionComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
	      {
	        if (workInProgress2.type !== workInProgress2.elementType) {
	          var innerPropTypes = Component.propTypes;
	          if (innerPropTypes) {
	            checkPropTypes(
	              innerPropTypes,
	              nextProps,
	              // Resolved props
	              "prop",
	              getComponentNameFromType(Component)
	            );
	          }
	        }
	      }
	      var context;
	      {
	        var unmaskedContext = getUnmaskedContext(workInProgress2, Component, true);
	        context = getMaskedContext(workInProgress2, unmaskedContext);
	      }
	      var nextChildren;
	      var hasId;
	      prepareToReadContext(workInProgress2, renderLanes2);
	      {
	        markComponentRenderStarted(workInProgress2);
	      }
	      {
	        ReactCurrentOwner$1.current = workInProgress2;
	        setIsRendering(true);
	        nextChildren = renderWithHooks(current2, workInProgress2, Component, nextProps, context, renderLanes2);
	        hasId = checkDidRenderIdHook();
	        if (workInProgress2.mode & StrictLegacyMode) {
	          setIsStrictModeForDevtools(true);
	          try {
	            nextChildren = renderWithHooks(current2, workInProgress2, Component, nextProps, context, renderLanes2);
	            hasId = checkDidRenderIdHook();
	          } finally {
	            setIsStrictModeForDevtools(false);
	          }
	        }
	        setIsRendering(false);
	      }
	      {
	        markComponentRenderStopped();
	      }
	      if (current2 !== null && !didReceiveUpdate) {
	        bailoutHooks(current2, workInProgress2, renderLanes2);
	        return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	      }
	      if (getIsHydrating() && hasId) {
	        pushMaterializedTreeId(workInProgress2);
	      }
	      workInProgress2.flags |= PerformedWork;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateClassComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
	      {
	        switch (shouldError(workInProgress2)) {
	          case false: {
	            var _instance = workInProgress2.stateNode;
	            var ctor = workInProgress2.type;
	            var tempInstance = new ctor(workInProgress2.memoizedProps, _instance.context);
	            var state = tempInstance.state;
	            _instance.updater.enqueueSetState(_instance, state, null);
	            break;
	          }
	          case true: {
	            workInProgress2.flags |= DidCapture;
	            workInProgress2.flags |= ShouldCapture;
	            var error$1 = new Error("Simulated error coming from DevTools");
	            var lane = pickArbitraryLane(renderLanes2);
	            workInProgress2.lanes = mergeLanes(workInProgress2.lanes, lane);
	            var update = createClassErrorUpdate(workInProgress2, createCapturedValueAtFiber(error$1, workInProgress2), lane);
	            enqueueCapturedUpdate(workInProgress2, update);
	            break;
	          }
	        }
	        if (workInProgress2.type !== workInProgress2.elementType) {
	          var innerPropTypes = Component.propTypes;
	          if (innerPropTypes) {
	            checkPropTypes(
	              innerPropTypes,
	              nextProps,
	              // Resolved props
	              "prop",
	              getComponentNameFromType(Component)
	            );
	          }
	        }
	      }
	      var hasContext;
	      if (isContextProvider(Component)) {
	        hasContext = true;
	        pushContextProvider(workInProgress2);
	      } else {
	        hasContext = false;
	      }
	      prepareToReadContext(workInProgress2, renderLanes2);
	      var instance = workInProgress2.stateNode;
	      var shouldUpdate;
	      if (instance === null) {
	        resetSuspendedCurrentOnMountInLegacyMode(current2, workInProgress2);
	        constructClassInstance(workInProgress2, Component, nextProps);
	        mountClassInstance(workInProgress2, Component, nextProps, renderLanes2);
	        shouldUpdate = true;
	      } else if (current2 === null) {
	        shouldUpdate = resumeMountClassInstance(workInProgress2, Component, nextProps, renderLanes2);
	      } else {
	        shouldUpdate = updateClassInstance(current2, workInProgress2, Component, nextProps, renderLanes2);
	      }
	      var nextUnitOfWork = finishClassComponent(current2, workInProgress2, Component, shouldUpdate, hasContext, renderLanes2);
	      {
	        var inst = workInProgress2.stateNode;
	        if (shouldUpdate && inst.props !== nextProps) {
	          if (!didWarnAboutReassigningProps) {
	            error("It looks like %s is reassigning its own `this.props` while rendering. This is not supported and can lead to confusing bugs.", getComponentNameFromFiber(workInProgress2) || "a component");
	          }
	          didWarnAboutReassigningProps = true;
	        }
	      }
	      return nextUnitOfWork;
	    }
	    function finishClassComponent(current2, workInProgress2, Component, shouldUpdate, hasContext, renderLanes2) {
	      markRef(current2, workInProgress2);
	      var didCaptureError = (workInProgress2.flags & DidCapture) !== NoFlags;
	      if (!shouldUpdate && !didCaptureError) {
	        if (hasContext) {
	          invalidateContextProvider(workInProgress2, Component, false);
	        }
	        return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	      }
	      var instance = workInProgress2.stateNode;
	      ReactCurrentOwner$1.current = workInProgress2;
	      var nextChildren;
	      if (didCaptureError && typeof Component.getDerivedStateFromError !== "function") {
	        nextChildren = null;
	        {
	          stopProfilerTimerIfRunning();
	        }
	      } else {
	        {
	          markComponentRenderStarted(workInProgress2);
	        }
	        {
	          setIsRendering(true);
	          nextChildren = instance.render();
	          if (workInProgress2.mode & StrictLegacyMode) {
	            setIsStrictModeForDevtools(true);
	            try {
	              instance.render();
	            } finally {
	              setIsStrictModeForDevtools(false);
	            }
	          }
	          setIsRendering(false);
	        }
	        {
	          markComponentRenderStopped();
	        }
	      }
	      workInProgress2.flags |= PerformedWork;
	      if (current2 !== null && didCaptureError) {
	        forceUnmountCurrentAndReconcile(current2, workInProgress2, nextChildren, renderLanes2);
	      } else {
	        reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      }
	      workInProgress2.memoizedState = instance.state;
	      if (hasContext) {
	        invalidateContextProvider(workInProgress2, Component, true);
	      }
	      return workInProgress2.child;
	    }
	    function pushHostRootContext(workInProgress2) {
	      var root2 = workInProgress2.stateNode;
	      if (root2.pendingContext) {
	        pushTopLevelContextObject(workInProgress2, root2.pendingContext, root2.pendingContext !== root2.context);
	      } else if (root2.context) {
	        pushTopLevelContextObject(workInProgress2, root2.context, false);
	      }
	      pushHostContainer(workInProgress2, root2.containerInfo);
	    }
	    function updateHostRoot(current2, workInProgress2, renderLanes2) {
	      pushHostRootContext(workInProgress2);
	      if (current2 === null) {
	        throw new Error("Should have a current fiber. This is a bug in React.");
	      }
	      var nextProps = workInProgress2.pendingProps;
	      var prevState = workInProgress2.memoizedState;
	      var prevChildren = prevState.element;
	      cloneUpdateQueue(current2, workInProgress2);
	      processUpdateQueue(workInProgress2, nextProps, null, renderLanes2);
	      var nextState = workInProgress2.memoizedState;
	      workInProgress2.stateNode;
	      var nextChildren = nextState.element;
	      if (prevState.isDehydrated) {
	        var overrideState = {
	          element: nextChildren,
	          isDehydrated: false,
	          cache: nextState.cache,
	          pendingSuspenseBoundaries: nextState.pendingSuspenseBoundaries,
	          transitions: nextState.transitions
	        };
	        var updateQueue = workInProgress2.updateQueue;
	        updateQueue.baseState = overrideState;
	        workInProgress2.memoizedState = overrideState;
	        if (workInProgress2.flags & ForceClientRender) {
	          var recoverableError = createCapturedValueAtFiber(new Error("There was an error while hydrating. Because the error happened outside of a Suspense boundary, the entire root will switch to client rendering."), workInProgress2);
	          return mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, recoverableError);
	        } else if (nextChildren !== prevChildren) {
	          var _recoverableError = createCapturedValueAtFiber(new Error("This root received an early update, before anything was able hydrate. Switched the entire root to client rendering."), workInProgress2);
	          return mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, _recoverableError);
	        } else {
	          enterHydrationState(workInProgress2);
	          var child = mountChildFibers(workInProgress2, null, nextChildren, renderLanes2);
	          workInProgress2.child = child;
	          var node = child;
	          while (node) {
	            node.flags = node.flags & ~Placement | Hydrating;
	            node = node.sibling;
	          }
	        }
	      } else {
	        resetHydrationState();
	        if (nextChildren === prevChildren) {
	          return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	        }
	        reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      }
	      return workInProgress2.child;
	    }
	    function mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, recoverableError) {
	      resetHydrationState();
	      queueHydrationError(recoverableError);
	      workInProgress2.flags |= ForceClientRender;
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateHostComponent(current2, workInProgress2, renderLanes2) {
	      pushHostContext(workInProgress2);
	      if (current2 === null) {
	        tryToClaimNextHydratableInstance(workInProgress2);
	      }
	      var type = workInProgress2.type;
	      var nextProps = workInProgress2.pendingProps;
	      var prevProps = current2 !== null ? current2.memoizedProps : null;
	      var nextChildren = nextProps.children;
	      var isDirectTextChild = shouldSetTextContent(type, nextProps);
	      if (isDirectTextChild) {
	        nextChildren = null;
	      } else if (prevProps !== null && shouldSetTextContent(type, prevProps)) {
	        workInProgress2.flags |= ContentReset;
	      }
	      markRef(current2, workInProgress2);
	      reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function updateHostText(current2, workInProgress2) {
	      if (current2 === null) {
	        tryToClaimNextHydratableInstance(workInProgress2);
	      }
	      return null;
	    }
	    function mountLazyComponent(_current, workInProgress2, elementType, renderLanes2) {
	      resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2);
	      var props = workInProgress2.pendingProps;
	      var lazyComponent = elementType;
	      var payload = lazyComponent._payload;
	      var init = lazyComponent._init;
	      var Component = init(payload);
	      workInProgress2.type = Component;
	      var resolvedTag = workInProgress2.tag = resolveLazyComponentTag(Component);
	      var resolvedProps = resolveDefaultProps(Component, props);
	      var child;
	      switch (resolvedTag) {
	        case FunctionComponent: {
	          {
	            validateFunctionComponentInDev(workInProgress2, Component);
	            workInProgress2.type = Component = resolveFunctionForHotReloading(Component);
	          }
	          child = updateFunctionComponent(null, workInProgress2, Component, resolvedProps, renderLanes2);
	          return child;
	        }
	        case ClassComponent: {
	          {
	            workInProgress2.type = Component = resolveClassForHotReloading(Component);
	          }
	          child = updateClassComponent(null, workInProgress2, Component, resolvedProps, renderLanes2);
	          return child;
	        }
	        case ForwardRef: {
	          {
	            workInProgress2.type = Component = resolveForwardRefForHotReloading(Component);
	          }
	          child = updateForwardRef(null, workInProgress2, Component, resolvedProps, renderLanes2);
	          return child;
	        }
	        case MemoComponent: {
	          {
	            if (workInProgress2.type !== workInProgress2.elementType) {
	              var outerPropTypes = Component.propTypes;
	              if (outerPropTypes) {
	                checkPropTypes(
	                  outerPropTypes,
	                  resolvedProps,
	                  // Resolved for outer only
	                  "prop",
	                  getComponentNameFromType(Component)
	                );
	              }
	            }
	          }
	          child = updateMemoComponent(
	            null,
	            workInProgress2,
	            Component,
	            resolveDefaultProps(Component.type, resolvedProps),
	            // The inner type can have defaults too
	            renderLanes2
	          );
	          return child;
	        }
	      }
	      var hint = "";
	      {
	        if (Component !== null && typeof Component === "object" && Component.$$typeof === REACT_LAZY_TYPE) {
	          hint = " Did you wrap a component in React.lazy() more than once?";
	        }
	      }
	      throw new Error("Element type is invalid. Received a promise that resolves to: " + Component + ". " + ("Lazy element type must resolve to a class or function." + hint));
	    }
	    function mountIncompleteClassComponent(_current, workInProgress2, Component, nextProps, renderLanes2) {
	      resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2);
	      workInProgress2.tag = ClassComponent;
	      var hasContext;
	      if (isContextProvider(Component)) {
	        hasContext = true;
	        pushContextProvider(workInProgress2);
	      } else {
	        hasContext = false;
	      }
	      prepareToReadContext(workInProgress2, renderLanes2);
	      constructClassInstance(workInProgress2, Component, nextProps);
	      mountClassInstance(workInProgress2, Component, nextProps, renderLanes2);
	      return finishClassComponent(null, workInProgress2, Component, true, hasContext, renderLanes2);
	    }
	    function mountIndeterminateComponent(_current, workInProgress2, Component, renderLanes2) {
	      resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2);
	      var props = workInProgress2.pendingProps;
	      var context;
	      {
	        var unmaskedContext = getUnmaskedContext(workInProgress2, Component, false);
	        context = getMaskedContext(workInProgress2, unmaskedContext);
	      }
	      prepareToReadContext(workInProgress2, renderLanes2);
	      var value;
	      var hasId;
	      {
	        markComponentRenderStarted(workInProgress2);
	      }
	      {
	        if (Component.prototype && typeof Component.prototype.render === "function") {
	          var componentName = getComponentNameFromType(Component) || "Unknown";
	          if (!didWarnAboutBadClass[componentName]) {
	            error("The <%s /> component appears to have a render method, but doesn't extend React.Component. This is likely to cause errors. Change %s to extend React.Component instead.", componentName, componentName);
	            didWarnAboutBadClass[componentName] = true;
	          }
	        }
	        if (workInProgress2.mode & StrictLegacyMode) {
	          ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, null);
	        }
	        setIsRendering(true);
	        ReactCurrentOwner$1.current = workInProgress2;
	        value = renderWithHooks(null, workInProgress2, Component, props, context, renderLanes2);
	        hasId = checkDidRenderIdHook();
	        setIsRendering(false);
	      }
	      {
	        markComponentRenderStopped();
	      }
	      workInProgress2.flags |= PerformedWork;
	      {
	        if (typeof value === "object" && value !== null && typeof value.render === "function" && value.$$typeof === void 0) {
	          var _componentName = getComponentNameFromType(Component) || "Unknown";
	          if (!didWarnAboutModulePatternComponent[_componentName]) {
	            error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName, _componentName, _componentName);
	            didWarnAboutModulePatternComponent[_componentName] = true;
	          }
	        }
	      }
	      if (
	        // Run these checks in production only if the flag is off.
	        // Eventually we'll delete this branch altogether.
	        typeof value === "object" && value !== null && typeof value.render === "function" && value.$$typeof === void 0
	      ) {
	        {
	          var _componentName2 = getComponentNameFromType(Component) || "Unknown";
	          if (!didWarnAboutModulePatternComponent[_componentName2]) {
	            error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName2, _componentName2, _componentName2);
	            didWarnAboutModulePatternComponent[_componentName2] = true;
	          }
	        }
	        workInProgress2.tag = ClassComponent;
	        workInProgress2.memoizedState = null;
	        workInProgress2.updateQueue = null;
	        var hasContext = false;
	        if (isContextProvider(Component)) {
	          hasContext = true;
	          pushContextProvider(workInProgress2);
	        } else {
	          hasContext = false;
	        }
	        workInProgress2.memoizedState = value.state !== null && value.state !== void 0 ? value.state : null;
	        initializeUpdateQueue(workInProgress2);
	        adoptClassInstance(workInProgress2, value);
	        mountClassInstance(workInProgress2, Component, props, renderLanes2);
	        return finishClassComponent(null, workInProgress2, Component, true, hasContext, renderLanes2);
	      } else {
	        workInProgress2.tag = FunctionComponent;
	        {
	          if (workInProgress2.mode & StrictLegacyMode) {
	            setIsStrictModeForDevtools(true);
	            try {
	              value = renderWithHooks(null, workInProgress2, Component, props, context, renderLanes2);
	              hasId = checkDidRenderIdHook();
	            } finally {
	              setIsStrictModeForDevtools(false);
	            }
	          }
	        }
	        if (getIsHydrating() && hasId) {
	          pushMaterializedTreeId(workInProgress2);
	        }
	        reconcileChildren(null, workInProgress2, value, renderLanes2);
	        {
	          validateFunctionComponentInDev(workInProgress2, Component);
	        }
	        return workInProgress2.child;
	      }
	    }
	    function validateFunctionComponentInDev(workInProgress2, Component) {
	      {
	        if (Component) {
	          if (Component.childContextTypes) {
	            error("%s(...): childContextTypes cannot be defined on a function component.", Component.displayName || Component.name || "Component");
	          }
	        }
	        if (workInProgress2.ref !== null) {
	          var info = "";
	          var ownerName = getCurrentFiberOwnerNameInDevOrNull();
	          if (ownerName) {
	            info += "\n\nCheck the render method of `" + ownerName + "`.";
	          }
	          var warningKey = ownerName || "";
	          var debugSource = workInProgress2._debugSource;
	          if (debugSource) {
	            warningKey = debugSource.fileName + ":" + debugSource.lineNumber;
	          }
	          if (!didWarnAboutFunctionRefs[warningKey]) {
	            didWarnAboutFunctionRefs[warningKey] = true;
	            error("Function components cannot be given refs. Attempts to access this ref will fail. Did you mean to use React.forwardRef()?%s", info);
	          }
	        }
	        if (typeof Component.getDerivedStateFromProps === "function") {
	          var _componentName3 = getComponentNameFromType(Component) || "Unknown";
	          if (!didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3]) {
	            error("%s: Function components do not support getDerivedStateFromProps.", _componentName3);
	            didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] = true;
	          }
	        }
	        if (typeof Component.contextType === "object" && Component.contextType !== null) {
	          var _componentName4 = getComponentNameFromType(Component) || "Unknown";
	          if (!didWarnAboutContextTypeOnFunctionComponent[_componentName4]) {
	            error("%s: Function components do not support contextType.", _componentName4);
	            didWarnAboutContextTypeOnFunctionComponent[_componentName4] = true;
	          }
	        }
	      }
	    }
	    var SUSPENDED_MARKER = {
	      dehydrated: null,
	      treeContext: null,
	      retryLane: NoLane
	    };
	    function mountSuspenseOffscreenState(renderLanes2) {
	      return {
	        baseLanes: renderLanes2,
	        cachePool: getSuspendedCache(),
	        transitions: null
	      };
	    }
	    function updateSuspenseOffscreenState(prevOffscreenState, renderLanes2) {
	      var cachePool = null;
	      return {
	        baseLanes: mergeLanes(prevOffscreenState.baseLanes, renderLanes2),
	        cachePool,
	        transitions: prevOffscreenState.transitions
	      };
	    }
	    function shouldRemainOnFallback(suspenseContext, current2, workInProgress2, renderLanes2) {
	      if (current2 !== null) {
	        var suspenseState = current2.memoizedState;
	        if (suspenseState === null) {
	          return false;
	        }
	      }
	      return hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
	    }
	    function getRemainingWorkInPrimaryTree(current2, renderLanes2) {
	      return removeLanes(current2.childLanes, renderLanes2);
	    }
	    function updateSuspenseComponent(current2, workInProgress2, renderLanes2) {
	      var nextProps = workInProgress2.pendingProps;
	      {
	        if (shouldSuspend(workInProgress2)) {
	          workInProgress2.flags |= DidCapture;
	        }
	      }
	      var suspenseContext = suspenseStackCursor.current;
	      var showFallback = false;
	      var didSuspend = (workInProgress2.flags & DidCapture) !== NoFlags;
	      if (didSuspend || shouldRemainOnFallback(suspenseContext, current2)) {
	        showFallback = true;
	        workInProgress2.flags &= ~DidCapture;
	      } else {
	        if (current2 === null || current2.memoizedState !== null) {
	          {
	            suspenseContext = addSubtreeSuspenseContext(suspenseContext, InvisibleParentSuspenseContext);
	          }
	        }
	      }
	      suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
	      pushSuspenseContext(workInProgress2, suspenseContext);
	      if (current2 === null) {
	        tryToClaimNextHydratableInstance(workInProgress2);
	        var suspenseState = workInProgress2.memoizedState;
	        if (suspenseState !== null) {
	          var dehydrated = suspenseState.dehydrated;
	          if (dehydrated !== null) {
	            return mountDehydratedSuspenseComponent(workInProgress2, dehydrated);
	          }
	        }
	        var nextPrimaryChildren = nextProps.children;
	        var nextFallbackChildren = nextProps.fallback;
	        if (showFallback) {
	          var fallbackFragment = mountSuspenseFallbackChildren(workInProgress2, nextPrimaryChildren, nextFallbackChildren, renderLanes2);
	          var primaryChildFragment = workInProgress2.child;
	          primaryChildFragment.memoizedState = mountSuspenseOffscreenState(renderLanes2);
	          workInProgress2.memoizedState = SUSPENDED_MARKER;
	          return fallbackFragment;
	        } else {
	          return mountSuspensePrimaryChildren(workInProgress2, nextPrimaryChildren);
	        }
	      } else {
	        var prevState = current2.memoizedState;
	        if (prevState !== null) {
	          var _dehydrated = prevState.dehydrated;
	          if (_dehydrated !== null) {
	            return updateDehydratedSuspenseComponent(current2, workInProgress2, didSuspend, nextProps, _dehydrated, prevState, renderLanes2);
	          }
	        }
	        if (showFallback) {
	          var _nextFallbackChildren = nextProps.fallback;
	          var _nextPrimaryChildren = nextProps.children;
	          var fallbackChildFragment = updateSuspenseFallbackChildren(current2, workInProgress2, _nextPrimaryChildren, _nextFallbackChildren, renderLanes2);
	          var _primaryChildFragment2 = workInProgress2.child;
	          var prevOffscreenState = current2.child.memoizedState;
	          _primaryChildFragment2.memoizedState = prevOffscreenState === null ? mountSuspenseOffscreenState(renderLanes2) : updateSuspenseOffscreenState(prevOffscreenState, renderLanes2);
	          _primaryChildFragment2.childLanes = getRemainingWorkInPrimaryTree(current2, renderLanes2);
	          workInProgress2.memoizedState = SUSPENDED_MARKER;
	          return fallbackChildFragment;
	        } else {
	          var _nextPrimaryChildren2 = nextProps.children;
	          var _primaryChildFragment3 = updateSuspensePrimaryChildren(current2, workInProgress2, _nextPrimaryChildren2, renderLanes2);
	          workInProgress2.memoizedState = null;
	          return _primaryChildFragment3;
	        }
	      }
	    }
	    function mountSuspensePrimaryChildren(workInProgress2, primaryChildren, renderLanes2) {
	      var mode = workInProgress2.mode;
	      var primaryChildProps = {
	        mode: "visible",
	        children: primaryChildren
	      };
	      var primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, mode);
	      primaryChildFragment.return = workInProgress2;
	      workInProgress2.child = primaryChildFragment;
	      return primaryChildFragment;
	    }
	    function mountSuspenseFallbackChildren(workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
	      var mode = workInProgress2.mode;
	      var progressedPrimaryFragment = workInProgress2.child;
	      var primaryChildProps = {
	        mode: "hidden",
	        children: primaryChildren
	      };
	      var primaryChildFragment;
	      var fallbackChildFragment;
	      if ((mode & ConcurrentMode) === NoMode && progressedPrimaryFragment !== null) {
	        primaryChildFragment = progressedPrimaryFragment;
	        primaryChildFragment.childLanes = NoLanes;
	        primaryChildFragment.pendingProps = primaryChildProps;
	        if (workInProgress2.mode & ProfileMode) {
	          primaryChildFragment.actualDuration = 0;
	          primaryChildFragment.actualStartTime = -1;
	          primaryChildFragment.selfBaseDuration = 0;
	          primaryChildFragment.treeBaseDuration = 0;
	        }
	        fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null);
	      } else {
	        primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, mode);
	        fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null);
	      }
	      primaryChildFragment.return = workInProgress2;
	      fallbackChildFragment.return = workInProgress2;
	      primaryChildFragment.sibling = fallbackChildFragment;
	      workInProgress2.child = primaryChildFragment;
	      return fallbackChildFragment;
	    }
	    function mountWorkInProgressOffscreenFiber(offscreenProps, mode, renderLanes2) {
	      return createFiberFromOffscreen(offscreenProps, mode, NoLanes, null);
	    }
	    function updateWorkInProgressOffscreenFiber(current2, offscreenProps) {
	      return createWorkInProgress(current2, offscreenProps);
	    }
	    function updateSuspensePrimaryChildren(current2, workInProgress2, primaryChildren, renderLanes2) {
	      var currentPrimaryChildFragment = current2.child;
	      var currentFallbackChildFragment = currentPrimaryChildFragment.sibling;
	      var primaryChildFragment = updateWorkInProgressOffscreenFiber(currentPrimaryChildFragment, {
	        mode: "visible",
	        children: primaryChildren
	      });
	      if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	        primaryChildFragment.lanes = renderLanes2;
	      }
	      primaryChildFragment.return = workInProgress2;
	      primaryChildFragment.sibling = null;
	      if (currentFallbackChildFragment !== null) {
	        var deletions = workInProgress2.deletions;
	        if (deletions === null) {
	          workInProgress2.deletions = [currentFallbackChildFragment];
	          workInProgress2.flags |= ChildDeletion;
	        } else {
	          deletions.push(currentFallbackChildFragment);
	        }
	      }
	      workInProgress2.child = primaryChildFragment;
	      return primaryChildFragment;
	    }
	    function updateSuspenseFallbackChildren(current2, workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
	      var mode = workInProgress2.mode;
	      var currentPrimaryChildFragment = current2.child;
	      var currentFallbackChildFragment = currentPrimaryChildFragment.sibling;
	      var primaryChildProps = {
	        mode: "hidden",
	        children: primaryChildren
	      };
	      var primaryChildFragment;
	      if (
	        // In legacy mode, we commit the primary tree as if it successfully
	        // completed, even though it's in an inconsistent state.
	        (mode & ConcurrentMode) === NoMode && // Make sure we're on the second pass, i.e. the primary child fragment was
	        // already cloned. In legacy mode, the only case where this isn't true is
	        // when DevTools forces us to display a fallback; we skip the first render
	        // pass entirely and go straight to rendering the fallback. (In Concurrent
	        // Mode, SuspenseList can also trigger this scenario, but this is a legacy-
	        // only codepath.)
	        workInProgress2.child !== currentPrimaryChildFragment
	      ) {
	        var progressedPrimaryFragment = workInProgress2.child;
	        primaryChildFragment = progressedPrimaryFragment;
	        primaryChildFragment.childLanes = NoLanes;
	        primaryChildFragment.pendingProps = primaryChildProps;
	        if (workInProgress2.mode & ProfileMode) {
	          primaryChildFragment.actualDuration = 0;
	          primaryChildFragment.actualStartTime = -1;
	          primaryChildFragment.selfBaseDuration = currentPrimaryChildFragment.selfBaseDuration;
	          primaryChildFragment.treeBaseDuration = currentPrimaryChildFragment.treeBaseDuration;
	        }
	        workInProgress2.deletions = null;
	      } else {
	        primaryChildFragment = updateWorkInProgressOffscreenFiber(currentPrimaryChildFragment, primaryChildProps);
	        primaryChildFragment.subtreeFlags = currentPrimaryChildFragment.subtreeFlags & StaticMask;
	      }
	      var fallbackChildFragment;
	      if (currentFallbackChildFragment !== null) {
	        fallbackChildFragment = createWorkInProgress(currentFallbackChildFragment, fallbackChildren);
	      } else {
	        fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null);
	        fallbackChildFragment.flags |= Placement;
	      }
	      fallbackChildFragment.return = workInProgress2;
	      primaryChildFragment.return = workInProgress2;
	      primaryChildFragment.sibling = fallbackChildFragment;
	      workInProgress2.child = primaryChildFragment;
	      return fallbackChildFragment;
	    }
	    function retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, recoverableError) {
	      if (recoverableError !== null) {
	        queueHydrationError(recoverableError);
	      }
	      reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2);
	      var nextProps = workInProgress2.pendingProps;
	      var primaryChildren = nextProps.children;
	      var primaryChildFragment = mountSuspensePrimaryChildren(workInProgress2, primaryChildren);
	      primaryChildFragment.flags |= Placement;
	      workInProgress2.memoizedState = null;
	      return primaryChildFragment;
	    }
	    function mountSuspenseFallbackAfterRetryWithoutHydrating(current2, workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
	      var fiberMode = workInProgress2.mode;
	      var primaryChildProps = {
	        mode: "visible",
	        children: primaryChildren
	      };
	      var primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, fiberMode);
	      var fallbackChildFragment = createFiberFromFragment(fallbackChildren, fiberMode, renderLanes2, null);
	      fallbackChildFragment.flags |= Placement;
	      primaryChildFragment.return = workInProgress2;
	      fallbackChildFragment.return = workInProgress2;
	      primaryChildFragment.sibling = fallbackChildFragment;
	      workInProgress2.child = primaryChildFragment;
	      if ((workInProgress2.mode & ConcurrentMode) !== NoMode) {
	        reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2);
	      }
	      return fallbackChildFragment;
	    }
	    function mountDehydratedSuspenseComponent(workInProgress2, suspenseInstance, renderLanes2) {
	      if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	        {
	          error("Cannot hydrate Suspense in legacy mode. Switch from ReactDOM.hydrate(element, container) to ReactDOMClient.hydrateRoot(container, <App />).render(element) or remove the Suspense components from the server rendered components.");
	        }
	        workInProgress2.lanes = laneToLanes(SyncLane);
	      } else if (isSuspenseInstanceFallback(suspenseInstance)) {
	        workInProgress2.lanes = laneToLanes(DefaultHydrationLane);
	      } else {
	        workInProgress2.lanes = laneToLanes(OffscreenLane);
	      }
	      return null;
	    }
	    function updateDehydratedSuspenseComponent(current2, workInProgress2, didSuspend, nextProps, suspenseInstance, suspenseState, renderLanes2) {
	      if (!didSuspend) {
	        warnIfHydrating();
	        if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	          return retrySuspenseComponentWithoutHydrating(
	            current2,
	            workInProgress2,
	            renderLanes2,
	            // TODO: When we delete legacy mode, we should make this error argument
	            // required — every concurrent mode path that causes hydration to
	            // de-opt to client rendering should have an error message.
	            null
	          );
	        }
	        if (isSuspenseInstanceFallback(suspenseInstance)) {
	          var digest, message, stack;
	          {
	            var _getSuspenseInstanceF = getSuspenseInstanceFallbackErrorDetails(suspenseInstance);
	            digest = _getSuspenseInstanceF.digest;
	            message = _getSuspenseInstanceF.message;
	            stack = _getSuspenseInstanceF.stack;
	          }
	          var error2;
	          if (message) {
	            error2 = new Error(message);
	          } else {
	            error2 = new Error("The server could not finish this Suspense boundary, likely due to an error during server rendering. Switched to client rendering.");
	          }
	          var capturedValue = createCapturedValue(error2, digest, stack);
	          return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, capturedValue);
	        }
	        var hasContextChanged2 = includesSomeLane(renderLanes2, current2.childLanes);
	        if (didReceiveUpdate || hasContextChanged2) {
	          var root2 = getWorkInProgressRoot();
	          if (root2 !== null) {
	            var attemptHydrationAtLane = getBumpedLaneForHydration(root2, renderLanes2);
	            if (attemptHydrationAtLane !== NoLane && attemptHydrationAtLane !== suspenseState.retryLane) {
	              suspenseState.retryLane = attemptHydrationAtLane;
	              var eventTime = NoTimestamp;
	              enqueueConcurrentRenderForLane(current2, attemptHydrationAtLane);
	              scheduleUpdateOnFiber(root2, current2, attemptHydrationAtLane, eventTime);
	            }
	          }
	          renderDidSuspendDelayIfPossible();
	          var _capturedValue = createCapturedValue(new Error("This Suspense boundary received an update before it finished hydrating. This caused the boundary to switch to client rendering. The usual way to fix this is to wrap the original update in startTransition."));
	          return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, _capturedValue);
	        } else if (isSuspenseInstancePending(suspenseInstance)) {
	          workInProgress2.flags |= DidCapture;
	          workInProgress2.child = current2.child;
	          var retry = retryDehydratedSuspenseBoundary.bind(null, current2);
	          registerSuspenseInstanceRetry(suspenseInstance, retry);
	          return null;
	        } else {
	          reenterHydrationStateFromDehydratedSuspenseInstance(workInProgress2, suspenseInstance, suspenseState.treeContext);
	          var primaryChildren = nextProps.children;
	          var primaryChildFragment = mountSuspensePrimaryChildren(workInProgress2, primaryChildren);
	          primaryChildFragment.flags |= Hydrating;
	          return primaryChildFragment;
	        }
	      } else {
	        if (workInProgress2.flags & ForceClientRender) {
	          workInProgress2.flags &= ~ForceClientRender;
	          var _capturedValue2 = createCapturedValue(new Error("There was an error while hydrating this Suspense boundary. Switched to client rendering."));
	          return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, _capturedValue2);
	        } else if (workInProgress2.memoizedState !== null) {
	          workInProgress2.child = current2.child;
	          workInProgress2.flags |= DidCapture;
	          return null;
	        } else {
	          var nextPrimaryChildren = nextProps.children;
	          var nextFallbackChildren = nextProps.fallback;
	          var fallbackChildFragment = mountSuspenseFallbackAfterRetryWithoutHydrating(current2, workInProgress2, nextPrimaryChildren, nextFallbackChildren, renderLanes2);
	          var _primaryChildFragment4 = workInProgress2.child;
	          _primaryChildFragment4.memoizedState = mountSuspenseOffscreenState(renderLanes2);
	          workInProgress2.memoizedState = SUSPENDED_MARKER;
	          return fallbackChildFragment;
	        }
	      }
	    }
	    function scheduleSuspenseWorkOnFiber(fiber, renderLanes2, propagationRoot) {
	      fiber.lanes = mergeLanes(fiber.lanes, renderLanes2);
	      var alternate = fiber.alternate;
	      if (alternate !== null) {
	        alternate.lanes = mergeLanes(alternate.lanes, renderLanes2);
	      }
	      scheduleContextWorkOnParentPath(fiber.return, renderLanes2, propagationRoot);
	    }
	    function propagateSuspenseContextChange(workInProgress2, firstChild, renderLanes2) {
	      var node = firstChild;
	      while (node !== null) {
	        if (node.tag === SuspenseComponent) {
	          var state = node.memoizedState;
	          if (state !== null) {
	            scheduleSuspenseWorkOnFiber(node, renderLanes2, workInProgress2);
	          }
	        } else if (node.tag === SuspenseListComponent) {
	          scheduleSuspenseWorkOnFiber(node, renderLanes2, workInProgress2);
	        } else if (node.child !== null) {
	          node.child.return = node;
	          node = node.child;
	          continue;
	        }
	        if (node === workInProgress2) {
	          return;
	        }
	        while (node.sibling === null) {
	          if (node.return === null || node.return === workInProgress2) {
	            return;
	          }
	          node = node.return;
	        }
	        node.sibling.return = node.return;
	        node = node.sibling;
	      }
	    }
	    function findLastContentRow(firstChild) {
	      var row = firstChild;
	      var lastContentRow = null;
	      while (row !== null) {
	        var currentRow = row.alternate;
	        if (currentRow !== null && findFirstSuspended(currentRow) === null) {
	          lastContentRow = row;
	        }
	        row = row.sibling;
	      }
	      return lastContentRow;
	    }
	    function validateRevealOrder(revealOrder) {
	      {
	        if (revealOrder !== void 0 && revealOrder !== "forwards" && revealOrder !== "backwards" && revealOrder !== "together" && !didWarnAboutRevealOrder[revealOrder]) {
	          didWarnAboutRevealOrder[revealOrder] = true;
	          if (typeof revealOrder === "string") {
	            switch (revealOrder.toLowerCase()) {
	              case "together":
	              case "forwards":
	              case "backwards": {
	                error('"%s" is not a valid value for revealOrder on <SuspenseList />. Use lowercase "%s" instead.', revealOrder, revealOrder.toLowerCase());
	                break;
	              }
	              case "forward":
	              case "backward": {
	                error('"%s" is not a valid value for revealOrder on <SuspenseList />. React uses the -s suffix in the spelling. Use "%ss" instead.', revealOrder, revealOrder.toLowerCase());
	                break;
	              }
	              default:
	                error('"%s" is not a supported revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
	                break;
	            }
	          } else {
	            error('%s is not a supported value for revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
	          }
	        }
	      }
	    }
	    function validateTailOptions(tailMode, revealOrder) {
	      {
	        if (tailMode !== void 0 && !didWarnAboutTailOptions[tailMode]) {
	          if (tailMode !== "collapsed" && tailMode !== "hidden") {
	            didWarnAboutTailOptions[tailMode] = true;
	            error('"%s" is not a supported value for tail on <SuspenseList />. Did you mean "collapsed" or "hidden"?', tailMode);
	          } else if (revealOrder !== "forwards" && revealOrder !== "backwards") {
	            didWarnAboutTailOptions[tailMode] = true;
	            error('<SuspenseList tail="%s" /> is only valid if revealOrder is "forwards" or "backwards". Did you mean to specify revealOrder="forwards"?', tailMode);
	          }
	        }
	      }
	    }
	    function validateSuspenseListNestedChild(childSlot, index2) {
	      {
	        var isAnArray = isArray(childSlot);
	        var isIterable = !isAnArray && typeof getIteratorFn(childSlot) === "function";
	        if (isAnArray || isIterable) {
	          var type = isAnArray ? "array" : "iterable";
	          error("A nested %s was passed to row #%s in <SuspenseList />. Wrap it in an additional SuspenseList to configure its revealOrder: <SuspenseList revealOrder=...> ... <SuspenseList revealOrder=...>{%s}</SuspenseList> ... </SuspenseList>", type, index2, type);
	          return false;
	        }
	      }
	      return true;
	    }
	    function validateSuspenseListChildren(children, revealOrder) {
	      {
	        if ((revealOrder === "forwards" || revealOrder === "backwards") && children !== void 0 && children !== null && children !== false) {
	          if (isArray(children)) {
	            for (var i = 0; i < children.length; i++) {
	              if (!validateSuspenseListNestedChild(children[i], i)) {
	                return;
	              }
	            }
	          } else {
	            var iteratorFn = getIteratorFn(children);
	            if (typeof iteratorFn === "function") {
	              var childrenIterator = iteratorFn.call(children);
	              if (childrenIterator) {
	                var step = childrenIterator.next();
	                var _i = 0;
	                for (; !step.done; step = childrenIterator.next()) {
	                  if (!validateSuspenseListNestedChild(step.value, _i)) {
	                    return;
	                  }
	                  _i++;
	                }
	              }
	            } else {
	              error('A single row was passed to a <SuspenseList revealOrder="%s" />. This is not useful since it needs multiple rows. Did you mean to pass multiple children or an array?', revealOrder);
	            }
	          }
	        }
	      }
	    }
	    function initSuspenseListRenderState(workInProgress2, isBackwards, tail, lastContentRow, tailMode) {
	      var renderState = workInProgress2.memoizedState;
	      if (renderState === null) {
	        workInProgress2.memoizedState = {
	          isBackwards,
	          rendering: null,
	          renderingStartTime: 0,
	          last: lastContentRow,
	          tail,
	          tailMode
	        };
	      } else {
	        renderState.isBackwards = isBackwards;
	        renderState.rendering = null;
	        renderState.renderingStartTime = 0;
	        renderState.last = lastContentRow;
	        renderState.tail = tail;
	        renderState.tailMode = tailMode;
	      }
	    }
	    function updateSuspenseListComponent(current2, workInProgress2, renderLanes2) {
	      var nextProps = workInProgress2.pendingProps;
	      var revealOrder = nextProps.revealOrder;
	      var tailMode = nextProps.tail;
	      var newChildren = nextProps.children;
	      validateRevealOrder(revealOrder);
	      validateTailOptions(tailMode, revealOrder);
	      validateSuspenseListChildren(newChildren, revealOrder);
	      reconcileChildren(current2, workInProgress2, newChildren, renderLanes2);
	      var suspenseContext = suspenseStackCursor.current;
	      var shouldForceFallback = hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
	      if (shouldForceFallback) {
	        suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
	        workInProgress2.flags |= DidCapture;
	      } else {
	        var didSuspendBefore = current2 !== null && (current2.flags & DidCapture) !== NoFlags;
	        if (didSuspendBefore) {
	          propagateSuspenseContextChange(workInProgress2, workInProgress2.child, renderLanes2);
	        }
	        suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
	      }
	      pushSuspenseContext(workInProgress2, suspenseContext);
	      if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	        workInProgress2.memoizedState = null;
	      } else {
	        switch (revealOrder) {
	          case "forwards": {
	            var lastContentRow = findLastContentRow(workInProgress2.child);
	            var tail;
	            if (lastContentRow === null) {
	              tail = workInProgress2.child;
	              workInProgress2.child = null;
	            } else {
	              tail = lastContentRow.sibling;
	              lastContentRow.sibling = null;
	            }
	            initSuspenseListRenderState(
	              workInProgress2,
	              false,
	              // isBackwards
	              tail,
	              lastContentRow,
	              tailMode
	            );
	            break;
	          }
	          case "backwards": {
	            var _tail = null;
	            var row = workInProgress2.child;
	            workInProgress2.child = null;
	            while (row !== null) {
	              var currentRow = row.alternate;
	              if (currentRow !== null && findFirstSuspended(currentRow) === null) {
	                workInProgress2.child = row;
	                break;
	              }
	              var nextRow = row.sibling;
	              row.sibling = _tail;
	              _tail = row;
	              row = nextRow;
	            }
	            initSuspenseListRenderState(
	              workInProgress2,
	              true,
	              // isBackwards
	              _tail,
	              null,
	              // last
	              tailMode
	            );
	            break;
	          }
	          case "together": {
	            initSuspenseListRenderState(
	              workInProgress2,
	              false,
	              // isBackwards
	              null,
	              // tail
	              null,
	              // last
	              void 0
	            );
	            break;
	          }
	          default: {
	            workInProgress2.memoizedState = null;
	          }
	        }
	      }
	      return workInProgress2.child;
	    }
	    function updatePortalComponent(current2, workInProgress2, renderLanes2) {
	      pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
	      var nextChildren = workInProgress2.pendingProps;
	      if (current2 === null) {
	        workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderLanes2);
	      } else {
	        reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
	      }
	      return workInProgress2.child;
	    }
	    var hasWarnedAboutUsingNoValuePropOnContextProvider = false;
	    function updateContextProvider(current2, workInProgress2, renderLanes2) {
	      var providerType = workInProgress2.type;
	      var context = providerType._context;
	      var newProps = workInProgress2.pendingProps;
	      var oldProps = workInProgress2.memoizedProps;
	      var newValue = newProps.value;
	      {
	        if (!("value" in newProps)) {
	          if (!hasWarnedAboutUsingNoValuePropOnContextProvider) {
	            hasWarnedAboutUsingNoValuePropOnContextProvider = true;
	            error("The `value` prop is required for the `<Context.Provider>`. Did you misspell it or forget to pass it?");
	          }
	        }
	        var providerPropTypes = workInProgress2.type.propTypes;
	        if (providerPropTypes) {
	          checkPropTypes(providerPropTypes, newProps, "prop", "Context.Provider");
	        }
	      }
	      pushProvider(workInProgress2, context, newValue);
	      {
	        if (oldProps !== null) {
	          var oldValue = oldProps.value;
	          if (objectIs(oldValue, newValue)) {
	            if (oldProps.children === newProps.children && !hasContextChanged()) {
	              return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	            }
	          } else {
	            propagateContextChange(workInProgress2, context, renderLanes2);
	          }
	        }
	      }
	      var newChildren = newProps.children;
	      reconcileChildren(current2, workInProgress2, newChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    var hasWarnedAboutUsingContextAsConsumer = false;
	    function updateContextConsumer(current2, workInProgress2, renderLanes2) {
	      var context = workInProgress2.type;
	      {
	        if (context._context === void 0) {
	          if (context !== context.Consumer) {
	            if (!hasWarnedAboutUsingContextAsConsumer) {
	              hasWarnedAboutUsingContextAsConsumer = true;
	              error("Rendering <Context> directly is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?");
	            }
	          }
	        } else {
	          context = context._context;
	        }
	      }
	      var newProps = workInProgress2.pendingProps;
	      var render2 = newProps.children;
	      {
	        if (typeof render2 !== "function") {
	          error("A context consumer was rendered with multiple children, or a child that isn't a function. A context consumer expects a single child that is a function. If you did pass a function, make sure there is no trailing or leading whitespace around it.");
	        }
	      }
	      prepareToReadContext(workInProgress2, renderLanes2);
	      var newValue = readContext(context);
	      {
	        markComponentRenderStarted(workInProgress2);
	      }
	      var newChildren;
	      {
	        ReactCurrentOwner$1.current = workInProgress2;
	        setIsRendering(true);
	        newChildren = render2(newValue);
	        setIsRendering(false);
	      }
	      {
	        markComponentRenderStopped();
	      }
	      workInProgress2.flags |= PerformedWork;
	      reconcileChildren(current2, workInProgress2, newChildren, renderLanes2);
	      return workInProgress2.child;
	    }
	    function markWorkInProgressReceivedUpdate() {
	      didReceiveUpdate = true;
	    }
	    function resetSuspendedCurrentOnMountInLegacyMode(current2, workInProgress2) {
	      if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
	        if (current2 !== null) {
	          current2.alternate = null;
	          workInProgress2.alternate = null;
	          workInProgress2.flags |= Placement;
	        }
	      }
	    }
	    function bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2) {
	      if (current2 !== null) {
	        workInProgress2.dependencies = current2.dependencies;
	      }
	      {
	        stopProfilerTimerIfRunning();
	      }
	      markSkippedUpdateLanes(workInProgress2.lanes);
	      if (!includesSomeLane(renderLanes2, workInProgress2.childLanes)) {
	        {
	          return null;
	        }
	      }
	      cloneChildFibers(current2, workInProgress2);
	      return workInProgress2.child;
	    }
	    function remountFiber(current2, oldWorkInProgress, newWorkInProgress) {
	      {
	        var returnFiber = oldWorkInProgress.return;
	        if (returnFiber === null) {
	          throw new Error("Cannot swap the root fiber.");
	        }
	        current2.alternate = null;
	        oldWorkInProgress.alternate = null;
	        newWorkInProgress.index = oldWorkInProgress.index;
	        newWorkInProgress.sibling = oldWorkInProgress.sibling;
	        newWorkInProgress.return = oldWorkInProgress.return;
	        newWorkInProgress.ref = oldWorkInProgress.ref;
	        if (oldWorkInProgress === returnFiber.child) {
	          returnFiber.child = newWorkInProgress;
	        } else {
	          var prevSibling = returnFiber.child;
	          if (prevSibling === null) {
	            throw new Error("Expected parent to have a child.");
	          }
	          while (prevSibling.sibling !== oldWorkInProgress) {
	            prevSibling = prevSibling.sibling;
	            if (prevSibling === null) {
	              throw new Error("Expected to find the previous sibling.");
	            }
	          }
	          prevSibling.sibling = newWorkInProgress;
	        }
	        var deletions = returnFiber.deletions;
	        if (deletions === null) {
	          returnFiber.deletions = [current2];
	          returnFiber.flags |= ChildDeletion;
	        } else {
	          deletions.push(current2);
	        }
	        newWorkInProgress.flags |= Placement;
	        return newWorkInProgress;
	      }
	    }
	    function checkScheduledUpdateOrContext(current2, renderLanes2) {
	      var updateLanes = current2.lanes;
	      if (includesSomeLane(updateLanes, renderLanes2)) {
	        return true;
	      }
	      return false;
	    }
	    function attemptEarlyBailoutIfNoScheduledUpdate(current2, workInProgress2, renderLanes2) {
	      switch (workInProgress2.tag) {
	        case HostRoot:
	          pushHostRootContext(workInProgress2);
	          workInProgress2.stateNode;
	          resetHydrationState();
	          break;
	        case HostComponent:
	          pushHostContext(workInProgress2);
	          break;
	        case ClassComponent: {
	          var Component = workInProgress2.type;
	          if (isContextProvider(Component)) {
	            pushContextProvider(workInProgress2);
	          }
	          break;
	        }
	        case HostPortal:
	          pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
	          break;
	        case ContextProvider: {
	          var newValue = workInProgress2.memoizedProps.value;
	          var context = workInProgress2.type._context;
	          pushProvider(workInProgress2, context, newValue);
	          break;
	        }
	        case Profiler:
	          {
	            var hasChildWork = includesSomeLane(renderLanes2, workInProgress2.childLanes);
	            if (hasChildWork) {
	              workInProgress2.flags |= Update;
	            }
	            {
	              var stateNode = workInProgress2.stateNode;
	              stateNode.effectDuration = 0;
	              stateNode.passiveEffectDuration = 0;
	            }
	          }
	          break;
	        case SuspenseComponent: {
	          var state = workInProgress2.memoizedState;
	          if (state !== null) {
	            if (state.dehydrated !== null) {
	              pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
	              workInProgress2.flags |= DidCapture;
	              return null;
	            }
	            var primaryChildFragment = workInProgress2.child;
	            var primaryChildLanes = primaryChildFragment.childLanes;
	            if (includesSomeLane(renderLanes2, primaryChildLanes)) {
	              return updateSuspenseComponent(current2, workInProgress2, renderLanes2);
	            } else {
	              pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
	              var child = bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	              if (child !== null) {
	                return child.sibling;
	              } else {
	                return null;
	              }
	            }
	          } else {
	            pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
	          }
	          break;
	        }
	        case SuspenseListComponent: {
	          var didSuspendBefore = (current2.flags & DidCapture) !== NoFlags;
	          var _hasChildWork = includesSomeLane(renderLanes2, workInProgress2.childLanes);
	          if (didSuspendBefore) {
	            if (_hasChildWork) {
	              return updateSuspenseListComponent(current2, workInProgress2, renderLanes2);
	            }
	            workInProgress2.flags |= DidCapture;
	          }
	          var renderState = workInProgress2.memoizedState;
	          if (renderState !== null) {
	            renderState.rendering = null;
	            renderState.tail = null;
	            renderState.lastEffect = null;
	          }
	          pushSuspenseContext(workInProgress2, suspenseStackCursor.current);
	          if (_hasChildWork) {
	            break;
	          } else {
	            return null;
	          }
	        }
	        case OffscreenComponent:
	        case LegacyHiddenComponent: {
	          workInProgress2.lanes = NoLanes;
	          return updateOffscreenComponent(current2, workInProgress2, renderLanes2);
	        }
	      }
	      return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
	    }
	    function beginWork(current2, workInProgress2, renderLanes2) {
	      {
	        if (workInProgress2._debugNeedsRemount && current2 !== null) {
	          return remountFiber(current2, workInProgress2, createFiberFromTypeAndProps(workInProgress2.type, workInProgress2.key, workInProgress2.pendingProps, workInProgress2._debugOwner || null, workInProgress2.mode, workInProgress2.lanes));
	        }
	      }
	      if (current2 !== null) {
	        var oldProps = current2.memoizedProps;
	        var newProps = workInProgress2.pendingProps;
	        if (oldProps !== newProps || hasContextChanged() || // Force a re-render if the implementation changed due to hot reload:
	        workInProgress2.type !== current2.type) {
	          didReceiveUpdate = true;
	        } else {
	          var hasScheduledUpdateOrContext = checkScheduledUpdateOrContext(current2, renderLanes2);
	          if (!hasScheduledUpdateOrContext && // If this is the second pass of an error or suspense boundary, there
	          // may not be work scheduled on `current`, so we check for this flag.
	          (workInProgress2.flags & DidCapture) === NoFlags) {
	            didReceiveUpdate = false;
	            return attemptEarlyBailoutIfNoScheduledUpdate(current2, workInProgress2, renderLanes2);
	          }
	          if ((current2.flags & ForceUpdateForLegacySuspense) !== NoFlags) {
	            didReceiveUpdate = true;
	          } else {
	            didReceiveUpdate = false;
	          }
	        }
	      } else {
	        didReceiveUpdate = false;
	        if (getIsHydrating() && isForkedChild(workInProgress2)) {
	          var slotIndex = workInProgress2.index;
	          var numberOfForks = getForksAtLevel();
	          pushTreeId(workInProgress2, numberOfForks, slotIndex);
	        }
	      }
	      workInProgress2.lanes = NoLanes;
	      switch (workInProgress2.tag) {
	        case IndeterminateComponent: {
	          return mountIndeterminateComponent(current2, workInProgress2, workInProgress2.type, renderLanes2);
	        }
	        case LazyComponent: {
	          var elementType = workInProgress2.elementType;
	          return mountLazyComponent(current2, workInProgress2, elementType, renderLanes2);
	        }
	        case FunctionComponent: {
	          var Component = workInProgress2.type;
	          var unresolvedProps = workInProgress2.pendingProps;
	          var resolvedProps = workInProgress2.elementType === Component ? unresolvedProps : resolveDefaultProps(Component, unresolvedProps);
	          return updateFunctionComponent(current2, workInProgress2, Component, resolvedProps, renderLanes2);
	        }
	        case ClassComponent: {
	          var _Component = workInProgress2.type;
	          var _unresolvedProps = workInProgress2.pendingProps;
	          var _resolvedProps = workInProgress2.elementType === _Component ? _unresolvedProps : resolveDefaultProps(_Component, _unresolvedProps);
	          return updateClassComponent(current2, workInProgress2, _Component, _resolvedProps, renderLanes2);
	        }
	        case HostRoot:
	          return updateHostRoot(current2, workInProgress2, renderLanes2);
	        case HostComponent:
	          return updateHostComponent(current2, workInProgress2, renderLanes2);
	        case HostText:
	          return updateHostText(current2, workInProgress2);
	        case SuspenseComponent:
	          return updateSuspenseComponent(current2, workInProgress2, renderLanes2);
	        case HostPortal:
	          return updatePortalComponent(current2, workInProgress2, renderLanes2);
	        case ForwardRef: {
	          var type = workInProgress2.type;
	          var _unresolvedProps2 = workInProgress2.pendingProps;
	          var _resolvedProps2 = workInProgress2.elementType === type ? _unresolvedProps2 : resolveDefaultProps(type, _unresolvedProps2);
	          return updateForwardRef(current2, workInProgress2, type, _resolvedProps2, renderLanes2);
	        }
	        case Fragment:
	          return updateFragment(current2, workInProgress2, renderLanes2);
	        case Mode:
	          return updateMode(current2, workInProgress2, renderLanes2);
	        case Profiler:
	          return updateProfiler(current2, workInProgress2, renderLanes2);
	        case ContextProvider:
	          return updateContextProvider(current2, workInProgress2, renderLanes2);
	        case ContextConsumer:
	          return updateContextConsumer(current2, workInProgress2, renderLanes2);
	        case MemoComponent: {
	          var _type2 = workInProgress2.type;
	          var _unresolvedProps3 = workInProgress2.pendingProps;
	          var _resolvedProps3 = resolveDefaultProps(_type2, _unresolvedProps3);
	          {
	            if (workInProgress2.type !== workInProgress2.elementType) {
	              var outerPropTypes = _type2.propTypes;
	              if (outerPropTypes) {
	                checkPropTypes(
	                  outerPropTypes,
	                  _resolvedProps3,
	                  // Resolved for outer only
	                  "prop",
	                  getComponentNameFromType(_type2)
	                );
	              }
	            }
	          }
	          _resolvedProps3 = resolveDefaultProps(_type2.type, _resolvedProps3);
	          return updateMemoComponent(current2, workInProgress2, _type2, _resolvedProps3, renderLanes2);
	        }
	        case SimpleMemoComponent: {
	          return updateSimpleMemoComponent(current2, workInProgress2, workInProgress2.type, workInProgress2.pendingProps, renderLanes2);
	        }
	        case IncompleteClassComponent: {
	          var _Component2 = workInProgress2.type;
	          var _unresolvedProps4 = workInProgress2.pendingProps;
	          var _resolvedProps4 = workInProgress2.elementType === _Component2 ? _unresolvedProps4 : resolveDefaultProps(_Component2, _unresolvedProps4);
	          return mountIncompleteClassComponent(current2, workInProgress2, _Component2, _resolvedProps4, renderLanes2);
	        }
	        case SuspenseListComponent: {
	          return updateSuspenseListComponent(current2, workInProgress2, renderLanes2);
	        }
	        case ScopeComponent: {
	          break;
	        }
	        case OffscreenComponent: {
	          return updateOffscreenComponent(current2, workInProgress2, renderLanes2);
	        }
	      }
	      throw new Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
	    }
	    function markUpdate(workInProgress2) {
	      workInProgress2.flags |= Update;
	    }
	    function markRef$1(workInProgress2) {
	      workInProgress2.flags |= Ref;
	      {
	        workInProgress2.flags |= RefStatic;
	      }
	    }
	    var appendAllChildren;
	    var updateHostContainer;
	    var updateHostComponent$1;
	    var updateHostText$1;
	    {
	      appendAllChildren = function(parent, workInProgress2, needsVisibilityToggle, isHidden) {
	        var node = workInProgress2.child;
	        while (node !== null) {
	          if (node.tag === HostComponent || node.tag === HostText) {
	            appendInitialChild(parent, node.stateNode);
	          } else if (node.tag === HostPortal)
	            ;
	          else if (node.child !== null) {
	            node.child.return = node;
	            node = node.child;
	            continue;
	          }
	          if (node === workInProgress2) {
	            return;
	          }
	          while (node.sibling === null) {
	            if (node.return === null || node.return === workInProgress2) {
	              return;
	            }
	            node = node.return;
	          }
	          node.sibling.return = node.return;
	          node = node.sibling;
	        }
	      };
	      updateHostContainer = function(current2, workInProgress2) {
	      };
	      updateHostComponent$1 = function(current2, workInProgress2, type, newProps, rootContainerInstance) {
	        var oldProps = current2.memoizedProps;
	        if (oldProps === newProps) {
	          return;
	        }
	        var instance = workInProgress2.stateNode;
	        var currentHostContext = getHostContext();
	        var updatePayload = prepareUpdate(instance, type, oldProps, newProps, rootContainerInstance, currentHostContext);
	        workInProgress2.updateQueue = updatePayload;
	        if (updatePayload) {
	          markUpdate(workInProgress2);
	        }
	      };
	      updateHostText$1 = function(current2, workInProgress2, oldText, newText) {
	        if (oldText !== newText) {
	          markUpdate(workInProgress2);
	        }
	      };
	    }
	    function cutOffTailIfNeeded(renderState, hasRenderedATailFallback) {
	      if (getIsHydrating()) {
	        return;
	      }
	      switch (renderState.tailMode) {
	        case "hidden": {
	          var tailNode = renderState.tail;
	          var lastTailNode = null;
	          while (tailNode !== null) {
	            if (tailNode.alternate !== null) {
	              lastTailNode = tailNode;
	            }
	            tailNode = tailNode.sibling;
	          }
	          if (lastTailNode === null) {
	            renderState.tail = null;
	          } else {
	            lastTailNode.sibling = null;
	          }
	          break;
	        }
	        case "collapsed": {
	          var _tailNode = renderState.tail;
	          var _lastTailNode = null;
	          while (_tailNode !== null) {
	            if (_tailNode.alternate !== null) {
	              _lastTailNode = _tailNode;
	            }
	            _tailNode = _tailNode.sibling;
	          }
	          if (_lastTailNode === null) {
	            if (!hasRenderedATailFallback && renderState.tail !== null) {
	              renderState.tail.sibling = null;
	            } else {
	              renderState.tail = null;
	            }
	          } else {
	            _lastTailNode.sibling = null;
	          }
	          break;
	        }
	      }
	    }
	    function bubbleProperties(completedWork) {
	      var didBailout = completedWork.alternate !== null && completedWork.alternate.child === completedWork.child;
	      var newChildLanes = NoLanes;
	      var subtreeFlags = NoFlags;
	      if (!didBailout) {
	        if ((completedWork.mode & ProfileMode) !== NoMode) {
	          var actualDuration = completedWork.actualDuration;
	          var treeBaseDuration = completedWork.selfBaseDuration;
	          var child = completedWork.child;
	          while (child !== null) {
	            newChildLanes = mergeLanes(newChildLanes, mergeLanes(child.lanes, child.childLanes));
	            subtreeFlags |= child.subtreeFlags;
	            subtreeFlags |= child.flags;
	            actualDuration += child.actualDuration;
	            treeBaseDuration += child.treeBaseDuration;
	            child = child.sibling;
	          }
	          completedWork.actualDuration = actualDuration;
	          completedWork.treeBaseDuration = treeBaseDuration;
	        } else {
	          var _child = completedWork.child;
	          while (_child !== null) {
	            newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child.lanes, _child.childLanes));
	            subtreeFlags |= _child.subtreeFlags;
	            subtreeFlags |= _child.flags;
	            _child.return = completedWork;
	            _child = _child.sibling;
	          }
	        }
	        completedWork.subtreeFlags |= subtreeFlags;
	      } else {
	        if ((completedWork.mode & ProfileMode) !== NoMode) {
	          var _treeBaseDuration = completedWork.selfBaseDuration;
	          var _child2 = completedWork.child;
	          while (_child2 !== null) {
	            newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child2.lanes, _child2.childLanes));
	            subtreeFlags |= _child2.subtreeFlags & StaticMask;
	            subtreeFlags |= _child2.flags & StaticMask;
	            _treeBaseDuration += _child2.treeBaseDuration;
	            _child2 = _child2.sibling;
	          }
	          completedWork.treeBaseDuration = _treeBaseDuration;
	        } else {
	          var _child3 = completedWork.child;
	          while (_child3 !== null) {
	            newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child3.lanes, _child3.childLanes));
	            subtreeFlags |= _child3.subtreeFlags & StaticMask;
	            subtreeFlags |= _child3.flags & StaticMask;
	            _child3.return = completedWork;
	            _child3 = _child3.sibling;
	          }
	        }
	        completedWork.subtreeFlags |= subtreeFlags;
	      }
	      completedWork.childLanes = newChildLanes;
	      return didBailout;
	    }
	    function completeDehydratedSuspenseBoundary(current2, workInProgress2, nextState) {
	      if (hasUnhydratedTailNodes() && (workInProgress2.mode & ConcurrentMode) !== NoMode && (workInProgress2.flags & DidCapture) === NoFlags) {
	        warnIfUnhydratedTailNodes(workInProgress2);
	        resetHydrationState();
	        workInProgress2.flags |= ForceClientRender | Incomplete | ShouldCapture;
	        return false;
	      }
	      var wasHydrated = popHydrationState(workInProgress2);
	      if (nextState !== null && nextState.dehydrated !== null) {
	        if (current2 === null) {
	          if (!wasHydrated) {
	            throw new Error("A dehydrated suspense component was completed without a hydrated node. This is probably a bug in React.");
	          }
	          prepareToHydrateHostSuspenseInstance(workInProgress2);
	          bubbleProperties(workInProgress2);
	          {
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              var isTimedOutSuspense = nextState !== null;
	              if (isTimedOutSuspense) {
	                var primaryChildFragment = workInProgress2.child;
	                if (primaryChildFragment !== null) {
	                  workInProgress2.treeBaseDuration -= primaryChildFragment.treeBaseDuration;
	                }
	              }
	            }
	          }
	          return false;
	        } else {
	          resetHydrationState();
	          if ((workInProgress2.flags & DidCapture) === NoFlags) {
	            workInProgress2.memoizedState = null;
	          }
	          workInProgress2.flags |= Update;
	          bubbleProperties(workInProgress2);
	          {
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              var _isTimedOutSuspense = nextState !== null;
	              if (_isTimedOutSuspense) {
	                var _primaryChildFragment = workInProgress2.child;
	                if (_primaryChildFragment !== null) {
	                  workInProgress2.treeBaseDuration -= _primaryChildFragment.treeBaseDuration;
	                }
	              }
	            }
	          }
	          return false;
	        }
	      } else {
	        upgradeHydrationErrorsToRecoverable();
	        return true;
	      }
	    }
	    function completeWork(current2, workInProgress2, renderLanes2) {
	      var newProps = workInProgress2.pendingProps;
	      popTreeContext(workInProgress2);
	      switch (workInProgress2.tag) {
	        case IndeterminateComponent:
	        case LazyComponent:
	        case SimpleMemoComponent:
	        case FunctionComponent:
	        case ForwardRef:
	        case Fragment:
	        case Mode:
	        case Profiler:
	        case ContextConsumer:
	        case MemoComponent:
	          bubbleProperties(workInProgress2);
	          return null;
	        case ClassComponent: {
	          var Component = workInProgress2.type;
	          if (isContextProvider(Component)) {
	            popContext(workInProgress2);
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case HostRoot: {
	          var fiberRoot = workInProgress2.stateNode;
	          popHostContainer(workInProgress2);
	          popTopLevelContextObject(workInProgress2);
	          resetWorkInProgressVersions();
	          if (fiberRoot.pendingContext) {
	            fiberRoot.context = fiberRoot.pendingContext;
	            fiberRoot.pendingContext = null;
	          }
	          if (current2 === null || current2.child === null) {
	            var wasHydrated = popHydrationState(workInProgress2);
	            if (wasHydrated) {
	              markUpdate(workInProgress2);
	            } else {
	              if (current2 !== null) {
	                var prevState = current2.memoizedState;
	                if (
	                  // Check if this is a client root
	                  !prevState.isDehydrated || // Check if we reverted to client rendering (e.g. due to an error)
	                  (workInProgress2.flags & ForceClientRender) !== NoFlags
	                ) {
	                  workInProgress2.flags |= Snapshot;
	                  upgradeHydrationErrorsToRecoverable();
	                }
	              }
	            }
	          }
	          updateHostContainer(current2, workInProgress2);
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case HostComponent: {
	          popHostContext(workInProgress2);
	          var rootContainerInstance = getRootHostContainer();
	          var type = workInProgress2.type;
	          if (current2 !== null && workInProgress2.stateNode != null) {
	            updateHostComponent$1(current2, workInProgress2, type, newProps, rootContainerInstance);
	            if (current2.ref !== workInProgress2.ref) {
	              markRef$1(workInProgress2);
	            }
	          } else {
	            if (!newProps) {
	              if (workInProgress2.stateNode === null) {
	                throw new Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
	              }
	              bubbleProperties(workInProgress2);
	              return null;
	            }
	            var currentHostContext = getHostContext();
	            var _wasHydrated = popHydrationState(workInProgress2);
	            if (_wasHydrated) {
	              if (prepareToHydrateHostInstance(workInProgress2, rootContainerInstance, currentHostContext)) {
	                markUpdate(workInProgress2);
	              }
	            } else {
	              var instance = createInstance(type, newProps, rootContainerInstance, currentHostContext, workInProgress2);
	              appendAllChildren(instance, workInProgress2, false, false);
	              workInProgress2.stateNode = instance;
	              if (finalizeInitialChildren(instance, type, newProps, rootContainerInstance)) {
	                markUpdate(workInProgress2);
	              }
	            }
	            if (workInProgress2.ref !== null) {
	              markRef$1(workInProgress2);
	            }
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case HostText: {
	          var newText = newProps;
	          if (current2 && workInProgress2.stateNode != null) {
	            var oldText = current2.memoizedProps;
	            updateHostText$1(current2, workInProgress2, oldText, newText);
	          } else {
	            if (typeof newText !== "string") {
	              if (workInProgress2.stateNode === null) {
	                throw new Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
	              }
	            }
	            var _rootContainerInstance = getRootHostContainer();
	            var _currentHostContext = getHostContext();
	            var _wasHydrated2 = popHydrationState(workInProgress2);
	            if (_wasHydrated2) {
	              if (prepareToHydrateHostTextInstance(workInProgress2)) {
	                markUpdate(workInProgress2);
	              }
	            } else {
	              workInProgress2.stateNode = createTextInstance(newText, _rootContainerInstance, _currentHostContext, workInProgress2);
	            }
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case SuspenseComponent: {
	          popSuspenseContext(workInProgress2);
	          var nextState = workInProgress2.memoizedState;
	          if (current2 === null || current2.memoizedState !== null && current2.memoizedState.dehydrated !== null) {
	            var fallthroughToNormalSuspensePath = completeDehydratedSuspenseBoundary(current2, workInProgress2, nextState);
	            if (!fallthroughToNormalSuspensePath) {
	              if (workInProgress2.flags & ShouldCapture) {
	                return workInProgress2;
	              } else {
	                return null;
	              }
	            }
	          }
	          if ((workInProgress2.flags & DidCapture) !== NoFlags) {
	            workInProgress2.lanes = renderLanes2;
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              transferActualDuration(workInProgress2);
	            }
	            return workInProgress2;
	          }
	          var nextDidTimeout = nextState !== null;
	          var prevDidTimeout = current2 !== null && current2.memoizedState !== null;
	          if (nextDidTimeout !== prevDidTimeout) {
	            if (nextDidTimeout) {
	              var _offscreenFiber2 = workInProgress2.child;
	              _offscreenFiber2.flags |= Visibility;
	              if ((workInProgress2.mode & ConcurrentMode) !== NoMode) {
	                var hasInvisibleChildContext = current2 === null && (workInProgress2.memoizedProps.unstable_avoidThisFallback !== true || !enableSuspenseAvoidThisFallback);
	                if (hasInvisibleChildContext || hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext)) {
	                  renderDidSuspend();
	                } else {
	                  renderDidSuspendDelayIfPossible();
	                }
	              }
	            }
	          }
	          var wakeables = workInProgress2.updateQueue;
	          if (wakeables !== null) {
	            workInProgress2.flags |= Update;
	          }
	          bubbleProperties(workInProgress2);
	          {
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              if (nextDidTimeout) {
	                var primaryChildFragment = workInProgress2.child;
	                if (primaryChildFragment !== null) {
	                  workInProgress2.treeBaseDuration -= primaryChildFragment.treeBaseDuration;
	                }
	              }
	            }
	          }
	          return null;
	        }
	        case HostPortal:
	          popHostContainer(workInProgress2);
	          updateHostContainer(current2, workInProgress2);
	          if (current2 === null) {
	            preparePortalMount(workInProgress2.stateNode.containerInfo);
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        case ContextProvider:
	          var context = workInProgress2.type._context;
	          popProvider(context, workInProgress2);
	          bubbleProperties(workInProgress2);
	          return null;
	        case IncompleteClassComponent: {
	          var _Component = workInProgress2.type;
	          if (isContextProvider(_Component)) {
	            popContext(workInProgress2);
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case SuspenseListComponent: {
	          popSuspenseContext(workInProgress2);
	          var renderState = workInProgress2.memoizedState;
	          if (renderState === null) {
	            bubbleProperties(workInProgress2);
	            return null;
	          }
	          var didSuspendAlready = (workInProgress2.flags & DidCapture) !== NoFlags;
	          var renderedTail = renderState.rendering;
	          if (renderedTail === null) {
	            if (!didSuspendAlready) {
	              var cannotBeSuspended = renderHasNotSuspendedYet() && (current2 === null || (current2.flags & DidCapture) === NoFlags);
	              if (!cannotBeSuspended) {
	                var row = workInProgress2.child;
	                while (row !== null) {
	                  var suspended = findFirstSuspended(row);
	                  if (suspended !== null) {
	                    didSuspendAlready = true;
	                    workInProgress2.flags |= DidCapture;
	                    cutOffTailIfNeeded(renderState, false);
	                    var newThenables = suspended.updateQueue;
	                    if (newThenables !== null) {
	                      workInProgress2.updateQueue = newThenables;
	                      workInProgress2.flags |= Update;
	                    }
	                    workInProgress2.subtreeFlags = NoFlags;
	                    resetChildFibers(workInProgress2, renderLanes2);
	                    pushSuspenseContext(workInProgress2, setShallowSuspenseContext(suspenseStackCursor.current, ForceSuspenseFallback));
	                    return workInProgress2.child;
	                  }
	                  row = row.sibling;
	                }
	              }
	              if (renderState.tail !== null && now() > getRenderTargetTime()) {
	                workInProgress2.flags |= DidCapture;
	                didSuspendAlready = true;
	                cutOffTailIfNeeded(renderState, false);
	                workInProgress2.lanes = SomeRetryLane;
	              }
	            } else {
	              cutOffTailIfNeeded(renderState, false);
	            }
	          } else {
	            if (!didSuspendAlready) {
	              var _suspended = findFirstSuspended(renderedTail);
	              if (_suspended !== null) {
	                workInProgress2.flags |= DidCapture;
	                didSuspendAlready = true;
	                var _newThenables = _suspended.updateQueue;
	                if (_newThenables !== null) {
	                  workInProgress2.updateQueue = _newThenables;
	                  workInProgress2.flags |= Update;
	                }
	                cutOffTailIfNeeded(renderState, true);
	                if (renderState.tail === null && renderState.tailMode === "hidden" && !renderedTail.alternate && !getIsHydrating()) {
	                  bubbleProperties(workInProgress2);
	                  return null;
	                }
	              } else if (
	                // The time it took to render last row is greater than the remaining
	                // time we have to render. So rendering one more row would likely
	                // exceed it.
	                now() * 2 - renderState.renderingStartTime > getRenderTargetTime() && renderLanes2 !== OffscreenLane
	              ) {
	                workInProgress2.flags |= DidCapture;
	                didSuspendAlready = true;
	                cutOffTailIfNeeded(renderState, false);
	                workInProgress2.lanes = SomeRetryLane;
	              }
	            }
	            if (renderState.isBackwards) {
	              renderedTail.sibling = workInProgress2.child;
	              workInProgress2.child = renderedTail;
	            } else {
	              var previousSibling = renderState.last;
	              if (previousSibling !== null) {
	                previousSibling.sibling = renderedTail;
	              } else {
	                workInProgress2.child = renderedTail;
	              }
	              renderState.last = renderedTail;
	            }
	          }
	          if (renderState.tail !== null) {
	            var next = renderState.tail;
	            renderState.rendering = next;
	            renderState.tail = next.sibling;
	            renderState.renderingStartTime = now();
	            next.sibling = null;
	            var suspenseContext = suspenseStackCursor.current;
	            if (didSuspendAlready) {
	              suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
	            } else {
	              suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
	            }
	            pushSuspenseContext(workInProgress2, suspenseContext);
	            return next;
	          }
	          bubbleProperties(workInProgress2);
	          return null;
	        }
	        case ScopeComponent: {
	          break;
	        }
	        case OffscreenComponent:
	        case LegacyHiddenComponent: {
	          popRenderLanes(workInProgress2);
	          var _nextState = workInProgress2.memoizedState;
	          var nextIsHidden = _nextState !== null;
	          if (current2 !== null) {
	            var _prevState = current2.memoizedState;
	            var prevIsHidden = _prevState !== null;
	            if (prevIsHidden !== nextIsHidden && // LegacyHidden doesn't do any hiding — it only pre-renders.
	            !enableLegacyHidden) {
	              workInProgress2.flags |= Visibility;
	            }
	          }
	          if (!nextIsHidden || (workInProgress2.mode & ConcurrentMode) === NoMode) {
	            bubbleProperties(workInProgress2);
	          } else {
	            if (includesSomeLane(subtreeRenderLanes, OffscreenLane)) {
	              bubbleProperties(workInProgress2);
	              {
	                if (workInProgress2.subtreeFlags & (Placement | Update)) {
	                  workInProgress2.flags |= Visibility;
	                }
	              }
	            }
	          }
	          return null;
	        }
	        case CacheComponent: {
	          return null;
	        }
	        case TracingMarkerComponent: {
	          return null;
	        }
	      }
	      throw new Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
	    }
	    function unwindWork(current2, workInProgress2, renderLanes2) {
	      popTreeContext(workInProgress2);
	      switch (workInProgress2.tag) {
	        case ClassComponent: {
	          var Component = workInProgress2.type;
	          if (isContextProvider(Component)) {
	            popContext(workInProgress2);
	          }
	          var flags = workInProgress2.flags;
	          if (flags & ShouldCapture) {
	            workInProgress2.flags = flags & ~ShouldCapture | DidCapture;
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              transferActualDuration(workInProgress2);
	            }
	            return workInProgress2;
	          }
	          return null;
	        }
	        case HostRoot: {
	          workInProgress2.stateNode;
	          popHostContainer(workInProgress2);
	          popTopLevelContextObject(workInProgress2);
	          resetWorkInProgressVersions();
	          var _flags = workInProgress2.flags;
	          if ((_flags & ShouldCapture) !== NoFlags && (_flags & DidCapture) === NoFlags) {
	            workInProgress2.flags = _flags & ~ShouldCapture | DidCapture;
	            return workInProgress2;
	          }
	          return null;
	        }
	        case HostComponent: {
	          popHostContext(workInProgress2);
	          return null;
	        }
	        case SuspenseComponent: {
	          popSuspenseContext(workInProgress2);
	          var suspenseState = workInProgress2.memoizedState;
	          if (suspenseState !== null && suspenseState.dehydrated !== null) {
	            if (workInProgress2.alternate === null) {
	              throw new Error("Threw in newly mounted dehydrated component. This is likely a bug in React. Please file an issue.");
	            }
	            resetHydrationState();
	          }
	          var _flags2 = workInProgress2.flags;
	          if (_flags2 & ShouldCapture) {
	            workInProgress2.flags = _flags2 & ~ShouldCapture | DidCapture;
	            if ((workInProgress2.mode & ProfileMode) !== NoMode) {
	              transferActualDuration(workInProgress2);
	            }
	            return workInProgress2;
	          }
	          return null;
	        }
	        case SuspenseListComponent: {
	          popSuspenseContext(workInProgress2);
	          return null;
	        }
	        case HostPortal:
	          popHostContainer(workInProgress2);
	          return null;
	        case ContextProvider:
	          var context = workInProgress2.type._context;
	          popProvider(context, workInProgress2);
	          return null;
	        case OffscreenComponent:
	        case LegacyHiddenComponent:
	          popRenderLanes(workInProgress2);
	          return null;
	        case CacheComponent:
	          return null;
	        default:
	          return null;
	      }
	    }
	    function unwindInterruptedWork(current2, interruptedWork, renderLanes2) {
	      popTreeContext(interruptedWork);
	      switch (interruptedWork.tag) {
	        case ClassComponent: {
	          var childContextTypes = interruptedWork.type.childContextTypes;
	          if (childContextTypes !== null && childContextTypes !== void 0) {
	            popContext(interruptedWork);
	          }
	          break;
	        }
	        case HostRoot: {
	          interruptedWork.stateNode;
	          popHostContainer(interruptedWork);
	          popTopLevelContextObject(interruptedWork);
	          resetWorkInProgressVersions();
	          break;
	        }
	        case HostComponent: {
	          popHostContext(interruptedWork);
	          break;
	        }
	        case HostPortal:
	          popHostContainer(interruptedWork);
	          break;
	        case SuspenseComponent:
	          popSuspenseContext(interruptedWork);
	          break;
	        case SuspenseListComponent:
	          popSuspenseContext(interruptedWork);
	          break;
	        case ContextProvider:
	          var context = interruptedWork.type._context;
	          popProvider(context, interruptedWork);
	          break;
	        case OffscreenComponent:
	        case LegacyHiddenComponent:
	          popRenderLanes(interruptedWork);
	          break;
	      }
	    }
	    var didWarnAboutUndefinedSnapshotBeforeUpdate = null;
	    {
	      didWarnAboutUndefinedSnapshotBeforeUpdate = /* @__PURE__ */ new Set();
	    }
	    var offscreenSubtreeIsHidden = false;
	    var offscreenSubtreeWasHidden = false;
	    var PossiblyWeakSet = typeof WeakSet === "function" ? WeakSet : Set;
	    var nextEffect = null;
	    var inProgressLanes = null;
	    var inProgressRoot = null;
	    function reportUncaughtErrorInDEV(error2) {
	      {
	        invokeGuardedCallback(null, function() {
	          throw error2;
	        });
	        clearCaughtError();
	      }
	    }
	    var callComponentWillUnmountWithTimer = function(current2, instance) {
	      instance.props = current2.memoizedProps;
	      instance.state = current2.memoizedState;
	      if (current2.mode & ProfileMode) {
	        try {
	          startLayoutEffectTimer();
	          instance.componentWillUnmount();
	        } finally {
	          recordLayoutEffectDuration(current2);
	        }
	      } else {
	        instance.componentWillUnmount();
	      }
	    };
	    function safelyCallCommitHookLayoutEffectListMount(current2, nearestMountedAncestor) {
	      try {
	        commitHookEffectListMount(Layout, current2);
	      } catch (error2) {
	        captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	      }
	    }
	    function safelyCallComponentWillUnmount(current2, nearestMountedAncestor, instance) {
	      try {
	        callComponentWillUnmountWithTimer(current2, instance);
	      } catch (error2) {
	        captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	      }
	    }
	    function safelyCallComponentDidMount(current2, nearestMountedAncestor, instance) {
	      try {
	        instance.componentDidMount();
	      } catch (error2) {
	        captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	      }
	    }
	    function safelyAttachRef(current2, nearestMountedAncestor) {
	      try {
	        commitAttachRef(current2);
	      } catch (error2) {
	        captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	      }
	    }
	    function safelyDetachRef(current2, nearestMountedAncestor) {
	      var ref = current2.ref;
	      if (ref !== null) {
	        if (typeof ref === "function") {
	          var retVal;
	          try {
	            if (enableProfilerTimer && enableProfilerCommitHooks && current2.mode & ProfileMode) {
	              try {
	                startLayoutEffectTimer();
	                retVal = ref(null);
	              } finally {
	                recordLayoutEffectDuration(current2);
	              }
	            } else {
	              retVal = ref(null);
	            }
	          } catch (error2) {
	            captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	          }
	          {
	            if (typeof retVal === "function") {
	              error("Unexpected return value from a callback ref in %s. A callback ref should not return a function.", getComponentNameFromFiber(current2));
	            }
	          }
	        } else {
	          ref.current = null;
	        }
	      }
	    }
	    function safelyCallDestroy(current2, nearestMountedAncestor, destroy) {
	      try {
	        destroy();
	      } catch (error2) {
	        captureCommitPhaseError(current2, nearestMountedAncestor, error2);
	      }
	    }
	    var shouldFireAfterActiveInstanceBlur = false;
	    function commitBeforeMutationEffects(root2, firstChild) {
	      prepareForCommit(root2.containerInfo);
	      nextEffect = firstChild;
	      commitBeforeMutationEffects_begin();
	      var shouldFire = shouldFireAfterActiveInstanceBlur;
	      shouldFireAfterActiveInstanceBlur = false;
	      return shouldFire;
	    }
	    function commitBeforeMutationEffects_begin() {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var child = fiber.child;
	        if ((fiber.subtreeFlags & BeforeMutationMask) !== NoFlags && child !== null) {
	          child.return = fiber;
	          nextEffect = child;
	        } else {
	          commitBeforeMutationEffects_complete();
	        }
	      }
	    }
	    function commitBeforeMutationEffects_complete() {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        setCurrentFiber(fiber);
	        try {
	          commitBeforeMutationEffectsOnFiber(fiber);
	        } catch (error2) {
	          captureCommitPhaseError(fiber, fiber.return, error2);
	        }
	        resetCurrentFiber();
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function commitBeforeMutationEffectsOnFiber(finishedWork) {
	      var current2 = finishedWork.alternate;
	      var flags = finishedWork.flags;
	      if ((flags & Snapshot) !== NoFlags) {
	        setCurrentFiber(finishedWork);
	        switch (finishedWork.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            break;
	          }
	          case ClassComponent: {
	            if (current2 !== null) {
	              var prevProps = current2.memoizedProps;
	              var prevState = current2.memoizedState;
	              var instance = finishedWork.stateNode;
	              {
	                if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
	                  if (instance.props !== finishedWork.memoizedProps) {
	                    error("Expected %s props to match memoized props before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                  }
	                  if (instance.state !== finishedWork.memoizedState) {
	                    error("Expected %s state to match memoized state before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                  }
	                }
	              }
	              var snapshot = instance.getSnapshotBeforeUpdate(finishedWork.elementType === finishedWork.type ? prevProps : resolveDefaultProps(finishedWork.type, prevProps), prevState);
	              {
	                var didWarnSet = didWarnAboutUndefinedSnapshotBeforeUpdate;
	                if (snapshot === void 0 && !didWarnSet.has(finishedWork.type)) {
	                  didWarnSet.add(finishedWork.type);
	                  error("%s.getSnapshotBeforeUpdate(): A snapshot value (or null) must be returned. You have returned undefined.", getComponentNameFromFiber(finishedWork));
	                }
	              }
	              instance.__reactInternalSnapshotBeforeUpdate = snapshot;
	            }
	            break;
	          }
	          case HostRoot: {
	            {
	              var root2 = finishedWork.stateNode;
	              clearContainer(root2.containerInfo);
	            }
	            break;
	          }
	          case HostComponent:
	          case HostText:
	          case HostPortal:
	          case IncompleteClassComponent:
	            break;
	          default: {
	            throw new Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
	          }
	        }
	        resetCurrentFiber();
	      }
	    }
	    function commitHookEffectListUnmount(flags, finishedWork, nearestMountedAncestor) {
	      var updateQueue = finishedWork.updateQueue;
	      var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;
	      if (lastEffect !== null) {
	        var firstEffect = lastEffect.next;
	        var effect = firstEffect;
	        do {
	          if ((effect.tag & flags) === flags) {
	            var destroy = effect.destroy;
	            effect.destroy = void 0;
	            if (destroy !== void 0) {
	              {
	                if ((flags & Passive$1) !== NoFlags$1) {
	                  markComponentPassiveEffectUnmountStarted(finishedWork);
	                } else if ((flags & Layout) !== NoFlags$1) {
	                  markComponentLayoutEffectUnmountStarted(finishedWork);
	                }
	              }
	              {
	                if ((flags & Insertion) !== NoFlags$1) {
	                  setIsRunningInsertionEffect(true);
	                }
	              }
	              safelyCallDestroy(finishedWork, nearestMountedAncestor, destroy);
	              {
	                if ((flags & Insertion) !== NoFlags$1) {
	                  setIsRunningInsertionEffect(false);
	                }
	              }
	              {
	                if ((flags & Passive$1) !== NoFlags$1) {
	                  markComponentPassiveEffectUnmountStopped();
	                } else if ((flags & Layout) !== NoFlags$1) {
	                  markComponentLayoutEffectUnmountStopped();
	                }
	              }
	            }
	          }
	          effect = effect.next;
	        } while (effect !== firstEffect);
	      }
	    }
	    function commitHookEffectListMount(flags, finishedWork) {
	      var updateQueue = finishedWork.updateQueue;
	      var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;
	      if (lastEffect !== null) {
	        var firstEffect = lastEffect.next;
	        var effect = firstEffect;
	        do {
	          if ((effect.tag & flags) === flags) {
	            {
	              if ((flags & Passive$1) !== NoFlags$1) {
	                markComponentPassiveEffectMountStarted(finishedWork);
	              } else if ((flags & Layout) !== NoFlags$1) {
	                markComponentLayoutEffectMountStarted(finishedWork);
	              }
	            }
	            var create = effect.create;
	            {
	              if ((flags & Insertion) !== NoFlags$1) {
	                setIsRunningInsertionEffect(true);
	              }
	            }
	            effect.destroy = create();
	            {
	              if ((flags & Insertion) !== NoFlags$1) {
	                setIsRunningInsertionEffect(false);
	              }
	            }
	            {
	              if ((flags & Passive$1) !== NoFlags$1) {
	                markComponentPassiveEffectMountStopped();
	              } else if ((flags & Layout) !== NoFlags$1) {
	                markComponentLayoutEffectMountStopped();
	              }
	            }
	            {
	              var destroy = effect.destroy;
	              if (destroy !== void 0 && typeof destroy !== "function") {
	                var hookName = void 0;
	                if ((effect.tag & Layout) !== NoFlags) {
	                  hookName = "useLayoutEffect";
	                } else if ((effect.tag & Insertion) !== NoFlags) {
	                  hookName = "useInsertionEffect";
	                } else {
	                  hookName = "useEffect";
	                }
	                var addendum = void 0;
	                if (destroy === null) {
	                  addendum = " You returned null. If your effect does not require clean up, return undefined (or nothing).";
	                } else if (typeof destroy.then === "function") {
	                  addendum = "\n\nIt looks like you wrote " + hookName + "(async () => ...) or returned a Promise. Instead, write the async function inside your effect and call it immediately:\n\n" + hookName + "(() => {\n  async function fetchData() {\n    // You can await here\n    const response = await MyAPI.getData(someId);\n    // ...\n  }\n  fetchData();\n}, [someId]); // Or [] if effect doesn't need props or state\n\nLearn more about data fetching with Hooks: https://reactjs.org/link/hooks-data-fetching";
	                } else {
	                  addendum = " You returned: " + destroy;
	                }
	                error("%s must not return anything besides a function, which is used for clean-up.%s", hookName, addendum);
	              }
	            }
	          }
	          effect = effect.next;
	        } while (effect !== firstEffect);
	      }
	    }
	    function commitPassiveEffectDurations(finishedRoot, finishedWork) {
	      {
	        if ((finishedWork.flags & Update) !== NoFlags) {
	          switch (finishedWork.tag) {
	            case Profiler: {
	              var passiveEffectDuration = finishedWork.stateNode.passiveEffectDuration;
	              var _finishedWork$memoize = finishedWork.memoizedProps, id = _finishedWork$memoize.id, onPostCommit = _finishedWork$memoize.onPostCommit;
	              var commitTime2 = getCommitTime();
	              var phase = finishedWork.alternate === null ? "mount" : "update";
	              {
	                if (isCurrentUpdateNested()) {
	                  phase = "nested-update";
	                }
	              }
	              if (typeof onPostCommit === "function") {
	                onPostCommit(id, phase, passiveEffectDuration, commitTime2);
	              }
	              var parentFiber = finishedWork.return;
	              outer:
	                while (parentFiber !== null) {
	                  switch (parentFiber.tag) {
	                    case HostRoot:
	                      var root2 = parentFiber.stateNode;
	                      root2.passiveEffectDuration += passiveEffectDuration;
	                      break outer;
	                    case Profiler:
	                      var parentStateNode = parentFiber.stateNode;
	                      parentStateNode.passiveEffectDuration += passiveEffectDuration;
	                      break outer;
	                  }
	                  parentFiber = parentFiber.return;
	                }
	              break;
	            }
	          }
	        }
	      }
	    }
	    function commitLayoutEffectOnFiber(finishedRoot, current2, finishedWork, committedLanes) {
	      if ((finishedWork.flags & LayoutMask) !== NoFlags) {
	        switch (finishedWork.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            if (!offscreenSubtreeWasHidden) {
	              if (finishedWork.mode & ProfileMode) {
	                try {
	                  startLayoutEffectTimer();
	                  commitHookEffectListMount(Layout | HasEffect, finishedWork);
	                } finally {
	                  recordLayoutEffectDuration(finishedWork);
	                }
	              } else {
	                commitHookEffectListMount(Layout | HasEffect, finishedWork);
	              }
	            }
	            break;
	          }
	          case ClassComponent: {
	            var instance = finishedWork.stateNode;
	            if (finishedWork.flags & Update) {
	              if (!offscreenSubtreeWasHidden) {
	                if (current2 === null) {
	                  {
	                    if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
	                      if (instance.props !== finishedWork.memoizedProps) {
	                        error("Expected %s props to match memoized props before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                      }
	                      if (instance.state !== finishedWork.memoizedState) {
	                        error("Expected %s state to match memoized state before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                      }
	                    }
	                  }
	                  if (finishedWork.mode & ProfileMode) {
	                    try {
	                      startLayoutEffectTimer();
	                      instance.componentDidMount();
	                    } finally {
	                      recordLayoutEffectDuration(finishedWork);
	                    }
	                  } else {
	                    instance.componentDidMount();
	                  }
	                } else {
	                  var prevProps = finishedWork.elementType === finishedWork.type ? current2.memoizedProps : resolveDefaultProps(finishedWork.type, current2.memoizedProps);
	                  var prevState = current2.memoizedState;
	                  {
	                    if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
	                      if (instance.props !== finishedWork.memoizedProps) {
	                        error("Expected %s props to match memoized props before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                      }
	                      if (instance.state !== finishedWork.memoizedState) {
	                        error("Expected %s state to match memoized state before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                      }
	                    }
	                  }
	                  if (finishedWork.mode & ProfileMode) {
	                    try {
	                      startLayoutEffectTimer();
	                      instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
	                    } finally {
	                      recordLayoutEffectDuration(finishedWork);
	                    }
	                  } else {
	                    instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
	                  }
	                }
	              }
	            }
	            var updateQueue = finishedWork.updateQueue;
	            if (updateQueue !== null) {
	              {
	                if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
	                  if (instance.props !== finishedWork.memoizedProps) {
	                    error("Expected %s props to match memoized props before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                  }
	                  if (instance.state !== finishedWork.memoizedState) {
	                    error("Expected %s state to match memoized state before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance");
	                  }
	                }
	              }
	              commitUpdateQueue(finishedWork, updateQueue, instance);
	            }
	            break;
	          }
	          case HostRoot: {
	            var _updateQueue = finishedWork.updateQueue;
	            if (_updateQueue !== null) {
	              var _instance = null;
	              if (finishedWork.child !== null) {
	                switch (finishedWork.child.tag) {
	                  case HostComponent:
	                    _instance = getPublicInstance(finishedWork.child.stateNode);
	                    break;
	                  case ClassComponent:
	                    _instance = finishedWork.child.stateNode;
	                    break;
	                }
	              }
	              commitUpdateQueue(finishedWork, _updateQueue, _instance);
	            }
	            break;
	          }
	          case HostComponent: {
	            var _instance2 = finishedWork.stateNode;
	            if (current2 === null && finishedWork.flags & Update) {
	              var type = finishedWork.type;
	              var props = finishedWork.memoizedProps;
	              commitMount(_instance2, type, props);
	            }
	            break;
	          }
	          case HostText: {
	            break;
	          }
	          case HostPortal: {
	            break;
	          }
	          case Profiler: {
	            {
	              var _finishedWork$memoize2 = finishedWork.memoizedProps, onCommit = _finishedWork$memoize2.onCommit, onRender = _finishedWork$memoize2.onRender;
	              var effectDuration = finishedWork.stateNode.effectDuration;
	              var commitTime2 = getCommitTime();
	              var phase = current2 === null ? "mount" : "update";
	              {
	                if (isCurrentUpdateNested()) {
	                  phase = "nested-update";
	                }
	              }
	              if (typeof onRender === "function") {
	                onRender(finishedWork.memoizedProps.id, phase, finishedWork.actualDuration, finishedWork.treeBaseDuration, finishedWork.actualStartTime, commitTime2);
	              }
	              {
	                if (typeof onCommit === "function") {
	                  onCommit(finishedWork.memoizedProps.id, phase, effectDuration, commitTime2);
	                }
	                enqueuePendingPassiveProfilerEffect(finishedWork);
	                var parentFiber = finishedWork.return;
	                outer:
	                  while (parentFiber !== null) {
	                    switch (parentFiber.tag) {
	                      case HostRoot:
	                        var root2 = parentFiber.stateNode;
	                        root2.effectDuration += effectDuration;
	                        break outer;
	                      case Profiler:
	                        var parentStateNode = parentFiber.stateNode;
	                        parentStateNode.effectDuration += effectDuration;
	                        break outer;
	                    }
	                    parentFiber = parentFiber.return;
	                  }
	              }
	            }
	            break;
	          }
	          case SuspenseComponent: {
	            commitSuspenseHydrationCallbacks(finishedRoot, finishedWork);
	            break;
	          }
	          case SuspenseListComponent:
	          case IncompleteClassComponent:
	          case ScopeComponent:
	          case OffscreenComponent:
	          case LegacyHiddenComponent:
	          case TracingMarkerComponent: {
	            break;
	          }
	          default:
	            throw new Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
	        }
	      }
	      if (!offscreenSubtreeWasHidden) {
	        {
	          if (finishedWork.flags & Ref) {
	            commitAttachRef(finishedWork);
	          }
	        }
	      }
	    }
	    function reappearLayoutEffectsOnFiber(node) {
	      switch (node.tag) {
	        case FunctionComponent:
	        case ForwardRef:
	        case SimpleMemoComponent: {
	          if (node.mode & ProfileMode) {
	            try {
	              startLayoutEffectTimer();
	              safelyCallCommitHookLayoutEffectListMount(node, node.return);
	            } finally {
	              recordLayoutEffectDuration(node);
	            }
	          } else {
	            safelyCallCommitHookLayoutEffectListMount(node, node.return);
	          }
	          break;
	        }
	        case ClassComponent: {
	          var instance = node.stateNode;
	          if (typeof instance.componentDidMount === "function") {
	            safelyCallComponentDidMount(node, node.return, instance);
	          }
	          safelyAttachRef(node, node.return);
	          break;
	        }
	        case HostComponent: {
	          safelyAttachRef(node, node.return);
	          break;
	        }
	      }
	    }
	    function hideOrUnhideAllChildren(finishedWork, isHidden) {
	      var hostSubtreeRoot = null;
	      {
	        var node = finishedWork;
	        while (true) {
	          if (node.tag === HostComponent) {
	            if (hostSubtreeRoot === null) {
	              hostSubtreeRoot = node;
	              try {
	                var instance = node.stateNode;
	                if (isHidden) {
	                  hideInstance(instance);
	                } else {
	                  unhideInstance(node.stateNode, node.memoizedProps);
	                }
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	            }
	          } else if (node.tag === HostText) {
	            if (hostSubtreeRoot === null) {
	              try {
	                var _instance3 = node.stateNode;
	                if (isHidden) {
	                  hideTextInstance(_instance3);
	                } else {
	                  unhideTextInstance(_instance3, node.memoizedProps);
	                }
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	            }
	          } else if ((node.tag === OffscreenComponent || node.tag === LegacyHiddenComponent) && node.memoizedState !== null && node !== finishedWork)
	            ;
	          else if (node.child !== null) {
	            node.child.return = node;
	            node = node.child;
	            continue;
	          }
	          if (node === finishedWork) {
	            return;
	          }
	          while (node.sibling === null) {
	            if (node.return === null || node.return === finishedWork) {
	              return;
	            }
	            if (hostSubtreeRoot === node) {
	              hostSubtreeRoot = null;
	            }
	            node = node.return;
	          }
	          if (hostSubtreeRoot === node) {
	            hostSubtreeRoot = null;
	          }
	          node.sibling.return = node.return;
	          node = node.sibling;
	        }
	      }
	    }
	    function commitAttachRef(finishedWork) {
	      var ref = finishedWork.ref;
	      if (ref !== null) {
	        var instance = finishedWork.stateNode;
	        var instanceToUse;
	        switch (finishedWork.tag) {
	          case HostComponent:
	            instanceToUse = getPublicInstance(instance);
	            break;
	          default:
	            instanceToUse = instance;
	        }
	        if (typeof ref === "function") {
	          var retVal;
	          if (finishedWork.mode & ProfileMode) {
	            try {
	              startLayoutEffectTimer();
	              retVal = ref(instanceToUse);
	            } finally {
	              recordLayoutEffectDuration(finishedWork);
	            }
	          } else {
	            retVal = ref(instanceToUse);
	          }
	          {
	            if (typeof retVal === "function") {
	              error("Unexpected return value from a callback ref in %s. A callback ref should not return a function.", getComponentNameFromFiber(finishedWork));
	            }
	          }
	        } else {
	          {
	            if (!ref.hasOwnProperty("current")) {
	              error("Unexpected ref object provided for %s. Use either a ref-setter function or React.createRef().", getComponentNameFromFiber(finishedWork));
	            }
	          }
	          ref.current = instanceToUse;
	        }
	      }
	    }
	    function detachFiberMutation(fiber) {
	      var alternate = fiber.alternate;
	      if (alternate !== null) {
	        alternate.return = null;
	      }
	      fiber.return = null;
	    }
	    function detachFiberAfterEffects(fiber) {
	      var alternate = fiber.alternate;
	      if (alternate !== null) {
	        fiber.alternate = null;
	        detachFiberAfterEffects(alternate);
	      }
	      {
	        fiber.child = null;
	        fiber.deletions = null;
	        fiber.sibling = null;
	        if (fiber.tag === HostComponent) {
	          var hostInstance = fiber.stateNode;
	          if (hostInstance !== null) {
	            detachDeletedInstance(hostInstance);
	          }
	        }
	        fiber.stateNode = null;
	        {
	          fiber._debugOwner = null;
	        }
	        {
	          fiber.return = null;
	          fiber.dependencies = null;
	          fiber.memoizedProps = null;
	          fiber.memoizedState = null;
	          fiber.pendingProps = null;
	          fiber.stateNode = null;
	          fiber.updateQueue = null;
	        }
	      }
	    }
	    function getHostParentFiber(fiber) {
	      var parent = fiber.return;
	      while (parent !== null) {
	        if (isHostParent(parent)) {
	          return parent;
	        }
	        parent = parent.return;
	      }
	      throw new Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
	    }
	    function isHostParent(fiber) {
	      return fiber.tag === HostComponent || fiber.tag === HostRoot || fiber.tag === HostPortal;
	    }
	    function getHostSibling(fiber) {
	      var node = fiber;
	      siblings:
	        while (true) {
	          while (node.sibling === null) {
	            if (node.return === null || isHostParent(node.return)) {
	              return null;
	            }
	            node = node.return;
	          }
	          node.sibling.return = node.return;
	          node = node.sibling;
	          while (node.tag !== HostComponent && node.tag !== HostText && node.tag !== DehydratedFragment) {
	            if (node.flags & Placement) {
	              continue siblings;
	            }
	            if (node.child === null || node.tag === HostPortal) {
	              continue siblings;
	            } else {
	              node.child.return = node;
	              node = node.child;
	            }
	          }
	          if (!(node.flags & Placement)) {
	            return node.stateNode;
	          }
	        }
	    }
	    function commitPlacement(finishedWork) {
	      var parentFiber = getHostParentFiber(finishedWork);
	      switch (parentFiber.tag) {
	        case HostComponent: {
	          var parent = parentFiber.stateNode;
	          if (parentFiber.flags & ContentReset) {
	            resetTextContent(parent);
	            parentFiber.flags &= ~ContentReset;
	          }
	          var before = getHostSibling(finishedWork);
	          insertOrAppendPlacementNode(finishedWork, before, parent);
	          break;
	        }
	        case HostRoot:
	        case HostPortal: {
	          var _parent = parentFiber.stateNode.containerInfo;
	          var _before = getHostSibling(finishedWork);
	          insertOrAppendPlacementNodeIntoContainer(finishedWork, _before, _parent);
	          break;
	        }
	        default:
	          throw new Error("Invalid host parent fiber. This error is likely caused by a bug in React. Please file an issue.");
	      }
	    }
	    function insertOrAppendPlacementNodeIntoContainer(node, before, parent) {
	      var tag = node.tag;
	      var isHost = tag === HostComponent || tag === HostText;
	      if (isHost) {
	        var stateNode = node.stateNode;
	        if (before) {
	          insertInContainerBefore(parent, stateNode, before);
	        } else {
	          appendChildToContainer(parent, stateNode);
	        }
	      } else if (tag === HostPortal)
	        ;
	      else {
	        var child = node.child;
	        if (child !== null) {
	          insertOrAppendPlacementNodeIntoContainer(child, before, parent);
	          var sibling = child.sibling;
	          while (sibling !== null) {
	            insertOrAppendPlacementNodeIntoContainer(sibling, before, parent);
	            sibling = sibling.sibling;
	          }
	        }
	      }
	    }
	    function insertOrAppendPlacementNode(node, before, parent) {
	      var tag = node.tag;
	      var isHost = tag === HostComponent || tag === HostText;
	      if (isHost) {
	        var stateNode = node.stateNode;
	        if (before) {
	          insertBefore(parent, stateNode, before);
	        } else {
	          appendChild(parent, stateNode);
	        }
	      } else if (tag === HostPortal)
	        ;
	      else {
	        var child = node.child;
	        if (child !== null) {
	          insertOrAppendPlacementNode(child, before, parent);
	          var sibling = child.sibling;
	          while (sibling !== null) {
	            insertOrAppendPlacementNode(sibling, before, parent);
	            sibling = sibling.sibling;
	          }
	        }
	      }
	    }
	    var hostParent = null;
	    var hostParentIsContainer = false;
	    function commitDeletionEffects(root2, returnFiber, deletedFiber) {
	      {
	        var parent = returnFiber;
	        findParent:
	          while (parent !== null) {
	            switch (parent.tag) {
	              case HostComponent: {
	                hostParent = parent.stateNode;
	                hostParentIsContainer = false;
	                break findParent;
	              }
	              case HostRoot: {
	                hostParent = parent.stateNode.containerInfo;
	                hostParentIsContainer = true;
	                break findParent;
	              }
	              case HostPortal: {
	                hostParent = parent.stateNode.containerInfo;
	                hostParentIsContainer = true;
	                break findParent;
	              }
	            }
	            parent = parent.return;
	          }
	        if (hostParent === null) {
	          throw new Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
	        }
	        commitDeletionEffectsOnFiber(root2, returnFiber, deletedFiber);
	        hostParent = null;
	        hostParentIsContainer = false;
	      }
	      detachFiberMutation(deletedFiber);
	    }
	    function recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, parent) {
	      var child = parent.child;
	      while (child !== null) {
	        commitDeletionEffectsOnFiber(finishedRoot, nearestMountedAncestor, child);
	        child = child.sibling;
	      }
	    }
	    function commitDeletionEffectsOnFiber(finishedRoot, nearestMountedAncestor, deletedFiber) {
	      onCommitUnmount(deletedFiber);
	      switch (deletedFiber.tag) {
	        case HostComponent: {
	          if (!offscreenSubtreeWasHidden) {
	            safelyDetachRef(deletedFiber, nearestMountedAncestor);
	          }
	        }
	        case HostText: {
	          {
	            var prevHostParent = hostParent;
	            var prevHostParentIsContainer = hostParentIsContainer;
	            hostParent = null;
	            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	            hostParent = prevHostParent;
	            hostParentIsContainer = prevHostParentIsContainer;
	            if (hostParent !== null) {
	              if (hostParentIsContainer) {
	                removeChildFromContainer(hostParent, deletedFiber.stateNode);
	              } else {
	                removeChild(hostParent, deletedFiber.stateNode);
	              }
	            }
	          }
	          return;
	        }
	        case DehydratedFragment: {
	          {
	            if (hostParent !== null) {
	              if (hostParentIsContainer) {
	                clearSuspenseBoundaryFromContainer(hostParent, deletedFiber.stateNode);
	              } else {
	                clearSuspenseBoundary(hostParent, deletedFiber.stateNode);
	              }
	            }
	          }
	          return;
	        }
	        case HostPortal: {
	          {
	            var _prevHostParent = hostParent;
	            var _prevHostParentIsContainer = hostParentIsContainer;
	            hostParent = deletedFiber.stateNode.containerInfo;
	            hostParentIsContainer = true;
	            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	            hostParent = _prevHostParent;
	            hostParentIsContainer = _prevHostParentIsContainer;
	          }
	          return;
	        }
	        case FunctionComponent:
	        case ForwardRef:
	        case MemoComponent:
	        case SimpleMemoComponent: {
	          if (!offscreenSubtreeWasHidden) {
	            var updateQueue = deletedFiber.updateQueue;
	            if (updateQueue !== null) {
	              var lastEffect = updateQueue.lastEffect;
	              if (lastEffect !== null) {
	                var firstEffect = lastEffect.next;
	                var effect = firstEffect;
	                do {
	                  var _effect = effect, destroy = _effect.destroy, tag = _effect.tag;
	                  if (destroy !== void 0) {
	                    if ((tag & Insertion) !== NoFlags$1) {
	                      safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy);
	                    } else if ((tag & Layout) !== NoFlags$1) {
	                      {
	                        markComponentLayoutEffectUnmountStarted(deletedFiber);
	                      }
	                      if (deletedFiber.mode & ProfileMode) {
	                        startLayoutEffectTimer();
	                        safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy);
	                        recordLayoutEffectDuration(deletedFiber);
	                      } else {
	                        safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy);
	                      }
	                      {
	                        markComponentLayoutEffectUnmountStopped();
	                      }
	                    }
	                  }
	                  effect = effect.next;
	                } while (effect !== firstEffect);
	              }
	            }
	          }
	          recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	          return;
	        }
	        case ClassComponent: {
	          if (!offscreenSubtreeWasHidden) {
	            safelyDetachRef(deletedFiber, nearestMountedAncestor);
	            var instance = deletedFiber.stateNode;
	            if (typeof instance.componentWillUnmount === "function") {
	              safelyCallComponentWillUnmount(deletedFiber, nearestMountedAncestor, instance);
	            }
	          }
	          recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	          return;
	        }
	        case ScopeComponent: {
	          recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	          return;
	        }
	        case OffscreenComponent: {
	          if (
	            // TODO: Remove this dead flag
	            deletedFiber.mode & ConcurrentMode
	          ) {
	            var prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
	            offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden || deletedFiber.memoizedState !== null;
	            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	            offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden;
	          } else {
	            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	          }
	          break;
	        }
	        default: {
	          recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
	          return;
	        }
	      }
	    }
	    function commitSuspenseCallback(finishedWork) {
	      finishedWork.memoizedState;
	    }
	    function commitSuspenseHydrationCallbacks(finishedRoot, finishedWork) {
	      var newState = finishedWork.memoizedState;
	      if (newState === null) {
	        var current2 = finishedWork.alternate;
	        if (current2 !== null) {
	          var prevState = current2.memoizedState;
	          if (prevState !== null) {
	            var suspenseInstance = prevState.dehydrated;
	            if (suspenseInstance !== null) {
	              commitHydratedSuspenseInstance(suspenseInstance);
	            }
	          }
	        }
	      }
	    }
	    function attachSuspenseRetryListeners(finishedWork) {
	      var wakeables = finishedWork.updateQueue;
	      if (wakeables !== null) {
	        finishedWork.updateQueue = null;
	        var retryCache = finishedWork.stateNode;
	        if (retryCache === null) {
	          retryCache = finishedWork.stateNode = new PossiblyWeakSet();
	        }
	        wakeables.forEach(function(wakeable) {
	          var retry = resolveRetryWakeable.bind(null, finishedWork, wakeable);
	          if (!retryCache.has(wakeable)) {
	            retryCache.add(wakeable);
	            {
	              if (isDevToolsPresent) {
	                if (inProgressLanes !== null && inProgressRoot !== null) {
	                  restorePendingUpdaters(inProgressRoot, inProgressLanes);
	                } else {
	                  throw Error("Expected finished root and lanes to be set. This is a bug in React.");
	                }
	              }
	            }
	            wakeable.then(retry, retry);
	          }
	        });
	      }
	    }
	    function commitMutationEffects(root2, finishedWork, committedLanes) {
	      inProgressLanes = committedLanes;
	      inProgressRoot = root2;
	      setCurrentFiber(finishedWork);
	      commitMutationEffectsOnFiber(finishedWork, root2);
	      setCurrentFiber(finishedWork);
	      inProgressLanes = null;
	      inProgressRoot = null;
	    }
	    function recursivelyTraverseMutationEffects(root2, parentFiber, lanes) {
	      var deletions = parentFiber.deletions;
	      if (deletions !== null) {
	        for (var i = 0; i < deletions.length; i++) {
	          var childToDelete = deletions[i];
	          try {
	            commitDeletionEffects(root2, parentFiber, childToDelete);
	          } catch (error2) {
	            captureCommitPhaseError(childToDelete, parentFiber, error2);
	          }
	        }
	      }
	      var prevDebugFiber = getCurrentFiber();
	      if (parentFiber.subtreeFlags & MutationMask) {
	        var child = parentFiber.child;
	        while (child !== null) {
	          setCurrentFiber(child);
	          commitMutationEffectsOnFiber(child, root2);
	          child = child.sibling;
	        }
	      }
	      setCurrentFiber(prevDebugFiber);
	    }
	    function commitMutationEffectsOnFiber(finishedWork, root2, lanes) {
	      var current2 = finishedWork.alternate;
	      var flags = finishedWork.flags;
	      switch (finishedWork.tag) {
	        case FunctionComponent:
	        case ForwardRef:
	        case MemoComponent:
	        case SimpleMemoComponent: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Update) {
	            try {
	              commitHookEffectListUnmount(Insertion | HasEffect, finishedWork, finishedWork.return);
	              commitHookEffectListMount(Insertion | HasEffect, finishedWork);
	            } catch (error2) {
	              captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	            }
	            if (finishedWork.mode & ProfileMode) {
	              try {
	                startLayoutEffectTimer();
	                commitHookEffectListUnmount(Layout | HasEffect, finishedWork, finishedWork.return);
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	              recordLayoutEffectDuration(finishedWork);
	            } else {
	              try {
	                commitHookEffectListUnmount(Layout | HasEffect, finishedWork, finishedWork.return);
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	            }
	          }
	          return;
	        }
	        case ClassComponent: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Ref) {
	            if (current2 !== null) {
	              safelyDetachRef(current2, current2.return);
	            }
	          }
	          return;
	        }
	        case HostComponent: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Ref) {
	            if (current2 !== null) {
	              safelyDetachRef(current2, current2.return);
	            }
	          }
	          {
	            if (finishedWork.flags & ContentReset) {
	              var instance = finishedWork.stateNode;
	              try {
	                resetTextContent(instance);
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	            }
	            if (flags & Update) {
	              var _instance4 = finishedWork.stateNode;
	              if (_instance4 != null) {
	                var newProps = finishedWork.memoizedProps;
	                var oldProps = current2 !== null ? current2.memoizedProps : newProps;
	                var type = finishedWork.type;
	                var updatePayload = finishedWork.updateQueue;
	                finishedWork.updateQueue = null;
	                if (updatePayload !== null) {
	                  try {
	                    commitUpdate(_instance4, updatePayload, type, oldProps, newProps, finishedWork);
	                  } catch (error2) {
	                    captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	                  }
	                }
	              }
	            }
	          }
	          return;
	        }
	        case HostText: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Update) {
	            {
	              if (finishedWork.stateNode === null) {
	                throw new Error("This should have a text node initialized. This error is likely caused by a bug in React. Please file an issue.");
	              }
	              var textInstance = finishedWork.stateNode;
	              var newText = finishedWork.memoizedProps;
	              var oldText = current2 !== null ? current2.memoizedProps : newText;
	              try {
	                commitTextUpdate(textInstance, oldText, newText);
	              } catch (error2) {
	                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	              }
	            }
	          }
	          return;
	        }
	        case HostRoot: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Update) {
	            {
	              if (current2 !== null) {
	                var prevRootState = current2.memoizedState;
	                if (prevRootState.isDehydrated) {
	                  try {
	                    commitHydratedContainer(root2.containerInfo);
	                  } catch (error2) {
	                    captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	                  }
	                }
	              }
	            }
	          }
	          return;
	        }
	        case HostPortal: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          return;
	        }
	        case SuspenseComponent: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          var offscreenFiber = finishedWork.child;
	          if (offscreenFiber.flags & Visibility) {
	            var offscreenInstance = offscreenFiber.stateNode;
	            var newState = offscreenFiber.memoizedState;
	            var isHidden = newState !== null;
	            offscreenInstance.isHidden = isHidden;
	            if (isHidden) {
	              var wasHidden = offscreenFiber.alternate !== null && offscreenFiber.alternate.memoizedState !== null;
	              if (!wasHidden) {
	                markCommitTimeOfFallback();
	              }
	            }
	          }
	          if (flags & Update) {
	            try {
	              commitSuspenseCallback(finishedWork);
	            } catch (error2) {
	              captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	            }
	            attachSuspenseRetryListeners(finishedWork);
	          }
	          return;
	        }
	        case OffscreenComponent: {
	          var _wasHidden = current2 !== null && current2.memoizedState !== null;
	          if (
	            // TODO: Remove this dead flag
	            finishedWork.mode & ConcurrentMode
	          ) {
	            var prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
	            offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden || _wasHidden;
	            recursivelyTraverseMutationEffects(root2, finishedWork);
	            offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden;
	          } else {
	            recursivelyTraverseMutationEffects(root2, finishedWork);
	          }
	          commitReconciliationEffects(finishedWork);
	          if (flags & Visibility) {
	            var _offscreenInstance = finishedWork.stateNode;
	            var _newState = finishedWork.memoizedState;
	            var _isHidden = _newState !== null;
	            var offscreenBoundary = finishedWork;
	            _offscreenInstance.isHidden = _isHidden;
	            {
	              if (_isHidden) {
	                if (!_wasHidden) {
	                  if ((offscreenBoundary.mode & ConcurrentMode) !== NoMode) {
	                    nextEffect = offscreenBoundary;
	                    var offscreenChild = offscreenBoundary.child;
	                    while (offscreenChild !== null) {
	                      nextEffect = offscreenChild;
	                      disappearLayoutEffects_begin(offscreenChild);
	                      offscreenChild = offscreenChild.sibling;
	                    }
	                  }
	                }
	              }
	            }
	            {
	              hideOrUnhideAllChildren(offscreenBoundary, _isHidden);
	            }
	          }
	          return;
	        }
	        case SuspenseListComponent: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          if (flags & Update) {
	            attachSuspenseRetryListeners(finishedWork);
	          }
	          return;
	        }
	        case ScopeComponent: {
	          return;
	        }
	        default: {
	          recursivelyTraverseMutationEffects(root2, finishedWork);
	          commitReconciliationEffects(finishedWork);
	          return;
	        }
	      }
	    }
	    function commitReconciliationEffects(finishedWork) {
	      var flags = finishedWork.flags;
	      if (flags & Placement) {
	        try {
	          commitPlacement(finishedWork);
	        } catch (error2) {
	          captureCommitPhaseError(finishedWork, finishedWork.return, error2);
	        }
	        finishedWork.flags &= ~Placement;
	      }
	      if (flags & Hydrating) {
	        finishedWork.flags &= ~Hydrating;
	      }
	    }
	    function commitLayoutEffects(finishedWork, root2, committedLanes) {
	      inProgressLanes = committedLanes;
	      inProgressRoot = root2;
	      nextEffect = finishedWork;
	      commitLayoutEffects_begin(finishedWork, root2, committedLanes);
	      inProgressLanes = null;
	      inProgressRoot = null;
	    }
	    function commitLayoutEffects_begin(subtreeRoot, root2, committedLanes) {
	      var isModernRoot = (subtreeRoot.mode & ConcurrentMode) !== NoMode;
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var firstChild = fiber.child;
	        if (fiber.tag === OffscreenComponent && isModernRoot) {
	          var isHidden = fiber.memoizedState !== null;
	          var newOffscreenSubtreeIsHidden = isHidden || offscreenSubtreeIsHidden;
	          if (newOffscreenSubtreeIsHidden) {
	            commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
	            continue;
	          } else {
	            var current2 = fiber.alternate;
	            var wasHidden = current2 !== null && current2.memoizedState !== null;
	            var newOffscreenSubtreeWasHidden = wasHidden || offscreenSubtreeWasHidden;
	            var prevOffscreenSubtreeIsHidden = offscreenSubtreeIsHidden;
	            var prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
	            offscreenSubtreeIsHidden = newOffscreenSubtreeIsHidden;
	            offscreenSubtreeWasHidden = newOffscreenSubtreeWasHidden;
	            if (offscreenSubtreeWasHidden && !prevOffscreenSubtreeWasHidden) {
	              nextEffect = fiber;
	              reappearLayoutEffects_begin(fiber);
	            }
	            var child = firstChild;
	            while (child !== null) {
	              nextEffect = child;
	              commitLayoutEffects_begin(
	                child,
	                // New root; bubble back up to here and stop.
	                root2,
	                committedLanes
	              );
	              child = child.sibling;
	            }
	            nextEffect = fiber;
	            offscreenSubtreeIsHidden = prevOffscreenSubtreeIsHidden;
	            offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden;
	            commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
	            continue;
	          }
	        }
	        if ((fiber.subtreeFlags & LayoutMask) !== NoFlags && firstChild !== null) {
	          firstChild.return = fiber;
	          nextEffect = firstChild;
	        } else {
	          commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
	        }
	      }
	    }
	    function commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        if ((fiber.flags & LayoutMask) !== NoFlags) {
	          var current2 = fiber.alternate;
	          setCurrentFiber(fiber);
	          try {
	            commitLayoutEffectOnFiber(root2, current2, fiber, committedLanes);
	          } catch (error2) {
	            captureCommitPhaseError(fiber, fiber.return, error2);
	          }
	          resetCurrentFiber();
	        }
	        if (fiber === subtreeRoot) {
	          nextEffect = null;
	          return;
	        }
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function disappearLayoutEffects_begin(subtreeRoot) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var firstChild = fiber.child;
	        switch (fiber.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case MemoComponent:
	          case SimpleMemoComponent: {
	            if (fiber.mode & ProfileMode) {
	              try {
	                startLayoutEffectTimer();
	                commitHookEffectListUnmount(Layout, fiber, fiber.return);
	              } finally {
	                recordLayoutEffectDuration(fiber);
	              }
	            } else {
	              commitHookEffectListUnmount(Layout, fiber, fiber.return);
	            }
	            break;
	          }
	          case ClassComponent: {
	            safelyDetachRef(fiber, fiber.return);
	            var instance = fiber.stateNode;
	            if (typeof instance.componentWillUnmount === "function") {
	              safelyCallComponentWillUnmount(fiber, fiber.return, instance);
	            }
	            break;
	          }
	          case HostComponent: {
	            safelyDetachRef(fiber, fiber.return);
	            break;
	          }
	          case OffscreenComponent: {
	            var isHidden = fiber.memoizedState !== null;
	            if (isHidden) {
	              disappearLayoutEffects_complete(subtreeRoot);
	              continue;
	            }
	            break;
	          }
	        }
	        if (firstChild !== null) {
	          firstChild.return = fiber;
	          nextEffect = firstChild;
	        } else {
	          disappearLayoutEffects_complete(subtreeRoot);
	        }
	      }
	    }
	    function disappearLayoutEffects_complete(subtreeRoot) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        if (fiber === subtreeRoot) {
	          nextEffect = null;
	          return;
	        }
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function reappearLayoutEffects_begin(subtreeRoot) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var firstChild = fiber.child;
	        if (fiber.tag === OffscreenComponent) {
	          var isHidden = fiber.memoizedState !== null;
	          if (isHidden) {
	            reappearLayoutEffects_complete(subtreeRoot);
	            continue;
	          }
	        }
	        if (firstChild !== null) {
	          firstChild.return = fiber;
	          nextEffect = firstChild;
	        } else {
	          reappearLayoutEffects_complete(subtreeRoot);
	        }
	      }
	    }
	    function reappearLayoutEffects_complete(subtreeRoot) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        setCurrentFiber(fiber);
	        try {
	          reappearLayoutEffectsOnFiber(fiber);
	        } catch (error2) {
	          captureCommitPhaseError(fiber, fiber.return, error2);
	        }
	        resetCurrentFiber();
	        if (fiber === subtreeRoot) {
	          nextEffect = null;
	          return;
	        }
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function commitPassiveMountEffects(root2, finishedWork, committedLanes, committedTransitions) {
	      nextEffect = finishedWork;
	      commitPassiveMountEffects_begin(finishedWork, root2, committedLanes, committedTransitions);
	    }
	    function commitPassiveMountEffects_begin(subtreeRoot, root2, committedLanes, committedTransitions) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var firstChild = fiber.child;
	        if ((fiber.subtreeFlags & PassiveMask) !== NoFlags && firstChild !== null) {
	          firstChild.return = fiber;
	          nextEffect = firstChild;
	        } else {
	          commitPassiveMountEffects_complete(subtreeRoot, root2, committedLanes, committedTransitions);
	        }
	      }
	    }
	    function commitPassiveMountEffects_complete(subtreeRoot, root2, committedLanes, committedTransitions) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        if ((fiber.flags & Passive) !== NoFlags) {
	          setCurrentFiber(fiber);
	          try {
	            commitPassiveMountOnFiber(root2, fiber, committedLanes, committedTransitions);
	          } catch (error2) {
	            captureCommitPhaseError(fiber, fiber.return, error2);
	          }
	          resetCurrentFiber();
	        }
	        if (fiber === subtreeRoot) {
	          nextEffect = null;
	          return;
	        }
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function commitPassiveMountOnFiber(finishedRoot, finishedWork, committedLanes, committedTransitions) {
	      switch (finishedWork.tag) {
	        case FunctionComponent:
	        case ForwardRef:
	        case SimpleMemoComponent: {
	          if (finishedWork.mode & ProfileMode) {
	            startPassiveEffectTimer();
	            try {
	              commitHookEffectListMount(Passive$1 | HasEffect, finishedWork);
	            } finally {
	              recordPassiveEffectDuration(finishedWork);
	            }
	          } else {
	            commitHookEffectListMount(Passive$1 | HasEffect, finishedWork);
	          }
	          break;
	        }
	      }
	    }
	    function commitPassiveUnmountEffects(firstChild) {
	      nextEffect = firstChild;
	      commitPassiveUnmountEffects_begin();
	    }
	    function commitPassiveUnmountEffects_begin() {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var child = fiber.child;
	        if ((nextEffect.flags & ChildDeletion) !== NoFlags) {
	          var deletions = fiber.deletions;
	          if (deletions !== null) {
	            for (var i = 0; i < deletions.length; i++) {
	              var fiberToDelete = deletions[i];
	              nextEffect = fiberToDelete;
	              commitPassiveUnmountEffectsInsideOfDeletedTree_begin(fiberToDelete, fiber);
	            }
	            {
	              var previousFiber = fiber.alternate;
	              if (previousFiber !== null) {
	                var detachedChild = previousFiber.child;
	                if (detachedChild !== null) {
	                  previousFiber.child = null;
	                  do {
	                    var detachedSibling = detachedChild.sibling;
	                    detachedChild.sibling = null;
	                    detachedChild = detachedSibling;
	                  } while (detachedChild !== null);
	                }
	              }
	            }
	            nextEffect = fiber;
	          }
	        }
	        if ((fiber.subtreeFlags & PassiveMask) !== NoFlags && child !== null) {
	          child.return = fiber;
	          nextEffect = child;
	        } else {
	          commitPassiveUnmountEffects_complete();
	        }
	      }
	    }
	    function commitPassiveUnmountEffects_complete() {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        if ((fiber.flags & Passive) !== NoFlags) {
	          setCurrentFiber(fiber);
	          commitPassiveUnmountOnFiber(fiber);
	          resetCurrentFiber();
	        }
	        var sibling = fiber.sibling;
	        if (sibling !== null) {
	          sibling.return = fiber.return;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = fiber.return;
	      }
	    }
	    function commitPassiveUnmountOnFiber(finishedWork) {
	      switch (finishedWork.tag) {
	        case FunctionComponent:
	        case ForwardRef:
	        case SimpleMemoComponent: {
	          if (finishedWork.mode & ProfileMode) {
	            startPassiveEffectTimer();
	            commitHookEffectListUnmount(Passive$1 | HasEffect, finishedWork, finishedWork.return);
	            recordPassiveEffectDuration(finishedWork);
	          } else {
	            commitHookEffectListUnmount(Passive$1 | HasEffect, finishedWork, finishedWork.return);
	          }
	          break;
	        }
	      }
	    }
	    function commitPassiveUnmountEffectsInsideOfDeletedTree_begin(deletedSubtreeRoot, nearestMountedAncestor) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        setCurrentFiber(fiber);
	        commitPassiveUnmountInsideDeletedTreeOnFiber(fiber, nearestMountedAncestor);
	        resetCurrentFiber();
	        var child = fiber.child;
	        if (child !== null) {
	          child.return = fiber;
	          nextEffect = child;
	        } else {
	          commitPassiveUnmountEffectsInsideOfDeletedTree_complete(deletedSubtreeRoot);
	        }
	      }
	    }
	    function commitPassiveUnmountEffectsInsideOfDeletedTree_complete(deletedSubtreeRoot) {
	      while (nextEffect !== null) {
	        var fiber = nextEffect;
	        var sibling = fiber.sibling;
	        var returnFiber = fiber.return;
	        {
	          detachFiberAfterEffects(fiber);
	          if (fiber === deletedSubtreeRoot) {
	            nextEffect = null;
	            return;
	          }
	        }
	        if (sibling !== null) {
	          sibling.return = returnFiber;
	          nextEffect = sibling;
	          return;
	        }
	        nextEffect = returnFiber;
	      }
	    }
	    function commitPassiveUnmountInsideDeletedTreeOnFiber(current2, nearestMountedAncestor) {
	      switch (current2.tag) {
	        case FunctionComponent:
	        case ForwardRef:
	        case SimpleMemoComponent: {
	          if (current2.mode & ProfileMode) {
	            startPassiveEffectTimer();
	            commitHookEffectListUnmount(Passive$1, current2, nearestMountedAncestor);
	            recordPassiveEffectDuration(current2);
	          } else {
	            commitHookEffectListUnmount(Passive$1, current2, nearestMountedAncestor);
	          }
	          break;
	        }
	      }
	    }
	    function invokeLayoutEffectMountInDEV(fiber) {
	      {
	        switch (fiber.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            try {
	              commitHookEffectListMount(Layout | HasEffect, fiber);
	            } catch (error2) {
	              captureCommitPhaseError(fiber, fiber.return, error2);
	            }
	            break;
	          }
	          case ClassComponent: {
	            var instance = fiber.stateNode;
	            try {
	              instance.componentDidMount();
	            } catch (error2) {
	              captureCommitPhaseError(fiber, fiber.return, error2);
	            }
	            break;
	          }
	        }
	      }
	    }
	    function invokePassiveEffectMountInDEV(fiber) {
	      {
	        switch (fiber.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            try {
	              commitHookEffectListMount(Passive$1 | HasEffect, fiber);
	            } catch (error2) {
	              captureCommitPhaseError(fiber, fiber.return, error2);
	            }
	            break;
	          }
	        }
	      }
	    }
	    function invokeLayoutEffectUnmountInDEV(fiber) {
	      {
	        switch (fiber.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            try {
	              commitHookEffectListUnmount(Layout | HasEffect, fiber, fiber.return);
	            } catch (error2) {
	              captureCommitPhaseError(fiber, fiber.return, error2);
	            }
	            break;
	          }
	          case ClassComponent: {
	            var instance = fiber.stateNode;
	            if (typeof instance.componentWillUnmount === "function") {
	              safelyCallComponentWillUnmount(fiber, fiber.return, instance);
	            }
	            break;
	          }
	        }
	      }
	    }
	    function invokePassiveEffectUnmountInDEV(fiber) {
	      {
	        switch (fiber.tag) {
	          case FunctionComponent:
	          case ForwardRef:
	          case SimpleMemoComponent: {
	            try {
	              commitHookEffectListUnmount(Passive$1 | HasEffect, fiber, fiber.return);
	            } catch (error2) {
	              captureCommitPhaseError(fiber, fiber.return, error2);
	            }
	          }
	        }
	      }
	    }
	    if (typeof Symbol === "function" && Symbol.for) {
	      var symbolFor = Symbol.for;
	      symbolFor("selector.component");
	      symbolFor("selector.has_pseudo_class");
	      symbolFor("selector.role");
	      symbolFor("selector.test_id");
	      symbolFor("selector.text");
	    }
	    var commitHooks = [];
	    function onCommitRoot$1() {
	      {
	        commitHooks.forEach(function(commitHook) {
	          return commitHook();
	        });
	      }
	    }
	    var ReactCurrentActQueue = ReactSharedInternals.ReactCurrentActQueue;
	    function isLegacyActEnvironment(fiber) {
	      {
	        var isReactActEnvironmentGlobal = (
	          // $FlowExpectedError – Flow doesn't know about IS_REACT_ACT_ENVIRONMENT global
	          typeof IS_REACT_ACT_ENVIRONMENT !== "undefined" ? IS_REACT_ACT_ENVIRONMENT : void 0
	        );
	        var jestIsDefined = typeof jest !== "undefined";
	        return jestIsDefined && isReactActEnvironmentGlobal !== false;
	      }
	    }
	    function isConcurrentActEnvironment() {
	      {
	        var isReactActEnvironmentGlobal = (
	          // $FlowExpectedError – Flow doesn't know about IS_REACT_ACT_ENVIRONMENT global
	          typeof IS_REACT_ACT_ENVIRONMENT !== "undefined" ? IS_REACT_ACT_ENVIRONMENT : void 0
	        );
	        if (!isReactActEnvironmentGlobal && ReactCurrentActQueue.current !== null) {
	          error("The current testing environment is not configured to support act(...)");
	        }
	        return isReactActEnvironmentGlobal;
	      }
	    }
	    var ceil = Math.ceil;
	    var ReactCurrentDispatcher$2 = ReactSharedInternals.ReactCurrentDispatcher, ReactCurrentOwner$2 = ReactSharedInternals.ReactCurrentOwner, ReactCurrentBatchConfig$3 = ReactSharedInternals.ReactCurrentBatchConfig, ReactCurrentActQueue$1 = ReactSharedInternals.ReactCurrentActQueue;
	    var NoContext = (
	      /*             */
	      0
	    );
	    var BatchedContext = (
	      /*               */
	      1
	    );
	    var RenderContext = (
	      /*                */
	      2
	    );
	    var CommitContext = (
	      /*                */
	      4
	    );
	    var RootInProgress = 0;
	    var RootFatalErrored = 1;
	    var RootErrored = 2;
	    var RootSuspended = 3;
	    var RootSuspendedWithDelay = 4;
	    var RootCompleted = 5;
	    var RootDidNotComplete = 6;
	    var executionContext = NoContext;
	    var workInProgressRoot = null;
	    var workInProgress = null;
	    var workInProgressRootRenderLanes = NoLanes;
	    var subtreeRenderLanes = NoLanes;
	    var subtreeRenderLanesCursor = createCursor(NoLanes);
	    var workInProgressRootExitStatus = RootInProgress;
	    var workInProgressRootFatalError = null;
	    var workInProgressRootSkippedLanes = NoLanes;
	    var workInProgressRootInterleavedUpdatedLanes = NoLanes;
	    var workInProgressRootPingedLanes = NoLanes;
	    var workInProgressRootConcurrentErrors = null;
	    var workInProgressRootRecoverableErrors = null;
	    var globalMostRecentFallbackTime = 0;
	    var FALLBACK_THROTTLE_MS = 500;
	    var workInProgressRootRenderTargetTime = Infinity;
	    var RENDER_TIMEOUT_MS = 500;
	    var workInProgressTransitions = null;
	    function resetRenderTimer() {
	      workInProgressRootRenderTargetTime = now() + RENDER_TIMEOUT_MS;
	    }
	    function getRenderTargetTime() {
	      return workInProgressRootRenderTargetTime;
	    }
	    var hasUncaughtError = false;
	    var firstUncaughtError = null;
	    var legacyErrorBoundariesThatAlreadyFailed = null;
	    var rootDoesHavePassiveEffects = false;
	    var rootWithPendingPassiveEffects = null;
	    var pendingPassiveEffectsLanes = NoLanes;
	    var pendingPassiveProfilerEffects = [];
	    var pendingPassiveTransitions = null;
	    var NESTED_UPDATE_LIMIT = 50;
	    var nestedUpdateCount = 0;
	    var rootWithNestedUpdates = null;
	    var isFlushingPassiveEffects = false;
	    var didScheduleUpdateDuringPassiveEffects = false;
	    var NESTED_PASSIVE_UPDATE_LIMIT = 50;
	    var nestedPassiveUpdateCount = 0;
	    var rootWithPassiveNestedUpdates = null;
	    var currentEventTime = NoTimestamp;
	    var currentEventTransitionLane = NoLanes;
	    var isRunningInsertionEffect = false;
	    function getWorkInProgressRoot() {
	      return workInProgressRoot;
	    }
	    function requestEventTime() {
	      if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
	        return now();
	      }
	      if (currentEventTime !== NoTimestamp) {
	        return currentEventTime;
	      }
	      currentEventTime = now();
	      return currentEventTime;
	    }
	    function requestUpdateLane(fiber) {
	      var mode = fiber.mode;
	      if ((mode & ConcurrentMode) === NoMode) {
	        return SyncLane;
	      } else if ((executionContext & RenderContext) !== NoContext && workInProgressRootRenderLanes !== NoLanes) {
	        return pickArbitraryLane(workInProgressRootRenderLanes);
	      }
	      var isTransition = requestCurrentTransition() !== NoTransition;
	      if (isTransition) {
	        if (ReactCurrentBatchConfig$3.transition !== null) {
	          var transition = ReactCurrentBatchConfig$3.transition;
	          if (!transition._updatedFibers) {
	            transition._updatedFibers = /* @__PURE__ */ new Set();
	          }
	          transition._updatedFibers.add(fiber);
	        }
	        if (currentEventTransitionLane === NoLane) {
	          currentEventTransitionLane = claimNextTransitionLane();
	        }
	        return currentEventTransitionLane;
	      }
	      var updateLane = getCurrentUpdatePriority();
	      if (updateLane !== NoLane) {
	        return updateLane;
	      }
	      var eventLane = getCurrentEventPriority();
	      return eventLane;
	    }
	    function requestRetryLane(fiber) {
	      var mode = fiber.mode;
	      if ((mode & ConcurrentMode) === NoMode) {
	        return SyncLane;
	      }
	      return claimNextRetryLane();
	    }
	    function scheduleUpdateOnFiber(root2, fiber, lane, eventTime) {
	      checkForNestedUpdates();
	      {
	        if (isRunningInsertionEffect) {
	          error("useInsertionEffect must not schedule updates.");
	        }
	      }
	      {
	        if (isFlushingPassiveEffects) {
	          didScheduleUpdateDuringPassiveEffects = true;
	        }
	      }
	      markRootUpdated(root2, lane, eventTime);
	      if ((executionContext & RenderContext) !== NoLanes && root2 === workInProgressRoot) {
	        warnAboutRenderPhaseUpdatesInDEV(fiber);
	      } else {
	        {
	          if (isDevToolsPresent) {
	            addFiberToLanesMap(root2, fiber, lane);
	          }
	        }
	        warnIfUpdatesNotWrappedWithActDEV(fiber);
	        if (root2 === workInProgressRoot) {
	          if ((executionContext & RenderContext) === NoContext) {
	            workInProgressRootInterleavedUpdatedLanes = mergeLanes(workInProgressRootInterleavedUpdatedLanes, lane);
	          }
	          if (workInProgressRootExitStatus === RootSuspendedWithDelay) {
	            markRootSuspended$1(root2, workInProgressRootRenderLanes);
	          }
	        }
	        ensureRootIsScheduled(root2, eventTime);
	        if (lane === SyncLane && executionContext === NoContext && (fiber.mode & ConcurrentMode) === NoMode && // Treat `act` as if it's inside `batchedUpdates`, even in legacy mode.
	        !ReactCurrentActQueue$1.isBatchingLegacy) {
	          resetRenderTimer();
	          flushSyncCallbacksOnlyInLegacyMode();
	        }
	      }
	    }
	    function scheduleInitialHydrationOnRoot(root2, lane, eventTime) {
	      var current2 = root2.current;
	      current2.lanes = lane;
	      markRootUpdated(root2, lane, eventTime);
	      ensureRootIsScheduled(root2, eventTime);
	    }
	    function isUnsafeClassRenderPhaseUpdate(fiber) {
	      return (
	        // TODO: Remove outdated deferRenderPhaseUpdateToNextBatch experiment. We
	        // decided not to enable it.
	        (executionContext & RenderContext) !== NoContext
	      );
	    }
	    function ensureRootIsScheduled(root2, currentTime) {
	      var existingCallbackNode = root2.callbackNode;
	      markStarvedLanesAsExpired(root2, currentTime);
	      var nextLanes = getNextLanes(root2, root2 === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes);
	      if (nextLanes === NoLanes) {
	        if (existingCallbackNode !== null) {
	          cancelCallback$1(existingCallbackNode);
	        }
	        root2.callbackNode = null;
	        root2.callbackPriority = NoLane;
	        return;
	      }
	      var newCallbackPriority = getHighestPriorityLane(nextLanes);
	      var existingCallbackPriority = root2.callbackPriority;
	      if (existingCallbackPriority === newCallbackPriority && // Special case related to `act`. If the currently scheduled task is a
	      // Scheduler task, rather than an `act` task, cancel it and re-scheduled
	      // on the `act` queue.
	      !(ReactCurrentActQueue$1.current !== null && existingCallbackNode !== fakeActCallbackNode)) {
	        {
	          if (existingCallbackNode == null && existingCallbackPriority !== SyncLane) {
	            error("Expected scheduled callback to exist. This error is likely caused by a bug in React. Please file an issue.");
	          }
	        }
	        return;
	      }
	      if (existingCallbackNode != null) {
	        cancelCallback$1(existingCallbackNode);
	      }
	      var newCallbackNode;
	      if (newCallbackPriority === SyncLane) {
	        if (root2.tag === LegacyRoot) {
	          if (ReactCurrentActQueue$1.isBatchingLegacy !== null) {
	            ReactCurrentActQueue$1.didScheduleLegacyUpdate = true;
	          }
	          scheduleLegacySyncCallback(performSyncWorkOnRoot.bind(null, root2));
	        } else {
	          scheduleSyncCallback(performSyncWorkOnRoot.bind(null, root2));
	        }
	        {
	          if (ReactCurrentActQueue$1.current !== null) {
	            ReactCurrentActQueue$1.current.push(flushSyncCallbacks);
	          } else {
	            scheduleMicrotask(function() {
	              if ((executionContext & (RenderContext | CommitContext)) === NoContext) {
	                flushSyncCallbacks();
	              }
	            });
	          }
	        }
	        newCallbackNode = null;
	      } else {
	        var schedulerPriorityLevel;
	        switch (lanesToEventPriority(nextLanes)) {
	          case DiscreteEventPriority:
	            schedulerPriorityLevel = ImmediatePriority;
	            break;
	          case ContinuousEventPriority:
	            schedulerPriorityLevel = UserBlockingPriority;
	            break;
	          case DefaultEventPriority:
	            schedulerPriorityLevel = NormalPriority;
	            break;
	          case IdleEventPriority:
	            schedulerPriorityLevel = IdlePriority;
	            break;
	          default:
	            schedulerPriorityLevel = NormalPriority;
	            break;
	        }
	        newCallbackNode = scheduleCallback$1(schedulerPriorityLevel, performConcurrentWorkOnRoot.bind(null, root2));
	      }
	      root2.callbackPriority = newCallbackPriority;
	      root2.callbackNode = newCallbackNode;
	    }
	    function performConcurrentWorkOnRoot(root2, didTimeout) {
	      {
	        resetNestedUpdateFlag();
	      }
	      currentEventTime = NoTimestamp;
	      currentEventTransitionLane = NoLanes;
	      if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
	        throw new Error("Should not already be working.");
	      }
	      var originalCallbackNode = root2.callbackNode;
	      var didFlushPassiveEffects = flushPassiveEffects();
	      if (didFlushPassiveEffects) {
	        if (root2.callbackNode !== originalCallbackNode) {
	          return null;
	        }
	      }
	      var lanes = getNextLanes(root2, root2 === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes);
	      if (lanes === NoLanes) {
	        return null;
	      }
	      var shouldTimeSlice = !includesBlockingLane(root2, lanes) && !includesExpiredLane(root2, lanes) && !didTimeout;
	      var exitStatus = shouldTimeSlice ? renderRootConcurrent(root2, lanes) : renderRootSync(root2, lanes);
	      if (exitStatus !== RootInProgress) {
	        if (exitStatus === RootErrored) {
	          var errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
	          if (errorRetryLanes !== NoLanes) {
	            lanes = errorRetryLanes;
	            exitStatus = recoverFromConcurrentError(root2, errorRetryLanes);
	          }
	        }
	        if (exitStatus === RootFatalErrored) {
	          var fatalError = workInProgressRootFatalError;
	          prepareFreshStack(root2, NoLanes);
	          markRootSuspended$1(root2, lanes);
	          ensureRootIsScheduled(root2, now());
	          throw fatalError;
	        }
	        if (exitStatus === RootDidNotComplete) {
	          markRootSuspended$1(root2, lanes);
	        } else {
	          var renderWasConcurrent = !includesBlockingLane(root2, lanes);
	          var finishedWork = root2.current.alternate;
	          if (renderWasConcurrent && !isRenderConsistentWithExternalStores(finishedWork)) {
	            exitStatus = renderRootSync(root2, lanes);
	            if (exitStatus === RootErrored) {
	              var _errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
	              if (_errorRetryLanes !== NoLanes) {
	                lanes = _errorRetryLanes;
	                exitStatus = recoverFromConcurrentError(root2, _errorRetryLanes);
	              }
	            }
	            if (exitStatus === RootFatalErrored) {
	              var _fatalError = workInProgressRootFatalError;
	              prepareFreshStack(root2, NoLanes);
	              markRootSuspended$1(root2, lanes);
	              ensureRootIsScheduled(root2, now());
	              throw _fatalError;
	            }
	          }
	          root2.finishedWork = finishedWork;
	          root2.finishedLanes = lanes;
	          finishConcurrentRender(root2, exitStatus, lanes);
	        }
	      }
	      ensureRootIsScheduled(root2, now());
	      if (root2.callbackNode === originalCallbackNode) {
	        return performConcurrentWorkOnRoot.bind(null, root2);
	      }
	      return null;
	    }
	    function recoverFromConcurrentError(root2, errorRetryLanes) {
	      var errorsFromFirstAttempt = workInProgressRootConcurrentErrors;
	      if (isRootDehydrated(root2)) {
	        var rootWorkInProgress = prepareFreshStack(root2, errorRetryLanes);
	        rootWorkInProgress.flags |= ForceClientRender;
	        {
	          errorHydratingContainer(root2.containerInfo);
	        }
	      }
	      var exitStatus = renderRootSync(root2, errorRetryLanes);
	      if (exitStatus !== RootErrored) {
	        var errorsFromSecondAttempt = workInProgressRootRecoverableErrors;
	        workInProgressRootRecoverableErrors = errorsFromFirstAttempt;
	        if (errorsFromSecondAttempt !== null) {
	          queueRecoverableErrors(errorsFromSecondAttempt);
	        }
	      }
	      return exitStatus;
	    }
	    function queueRecoverableErrors(errors) {
	      if (workInProgressRootRecoverableErrors === null) {
	        workInProgressRootRecoverableErrors = errors;
	      } else {
	        workInProgressRootRecoverableErrors.push.apply(workInProgressRootRecoverableErrors, errors);
	      }
	    }
	    function finishConcurrentRender(root2, exitStatus, lanes) {
	      switch (exitStatus) {
	        case RootInProgress:
	        case RootFatalErrored: {
	          throw new Error("Root did not complete. This is a bug in React.");
	        }
	        case RootErrored: {
	          commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
	          break;
	        }
	        case RootSuspended: {
	          markRootSuspended$1(root2, lanes);
	          if (includesOnlyRetries(lanes) && // do not delay if we're inside an act() scope
	          !shouldForceFlushFallbacksInDEV()) {
	            var msUntilTimeout = globalMostRecentFallbackTime + FALLBACK_THROTTLE_MS - now();
	            if (msUntilTimeout > 10) {
	              var nextLanes = getNextLanes(root2, NoLanes);
	              if (nextLanes !== NoLanes) {
	                break;
	              }
	              var suspendedLanes = root2.suspendedLanes;
	              if (!isSubsetOfLanes(suspendedLanes, lanes)) {
	                requestEventTime();
	                markRootPinged(root2, suspendedLanes);
	                break;
	              }
	              root2.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root2, workInProgressRootRecoverableErrors, workInProgressTransitions), msUntilTimeout);
	              break;
	            }
	          }
	          commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
	          break;
	        }
	        case RootSuspendedWithDelay: {
	          markRootSuspended$1(root2, lanes);
	          if (includesOnlyTransitions(lanes)) {
	            break;
	          }
	          if (!shouldForceFlushFallbacksInDEV()) {
	            var mostRecentEventTime = getMostRecentEventTime(root2, lanes);
	            var eventTimeMs = mostRecentEventTime;
	            var timeElapsedMs = now() - eventTimeMs;
	            var _msUntilTimeout = jnd(timeElapsedMs) - timeElapsedMs;
	            if (_msUntilTimeout > 10) {
	              root2.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root2, workInProgressRootRecoverableErrors, workInProgressTransitions), _msUntilTimeout);
	              break;
	            }
	          }
	          commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
	          break;
	        }
	        case RootCompleted: {
	          commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
	          break;
	        }
	        default: {
	          throw new Error("Unknown root exit status.");
	        }
	      }
	    }
	    function isRenderConsistentWithExternalStores(finishedWork) {
	      var node = finishedWork;
	      while (true) {
	        if (node.flags & StoreConsistency) {
	          var updateQueue = node.updateQueue;
	          if (updateQueue !== null) {
	            var checks = updateQueue.stores;
	            if (checks !== null) {
	              for (var i = 0; i < checks.length; i++) {
	                var check = checks[i];
	                var getSnapshot = check.getSnapshot;
	                var renderedValue = check.value;
	                try {
	                  if (!objectIs(getSnapshot(), renderedValue)) {
	                    return false;
	                  }
	                } catch (error2) {
	                  return false;
	                }
	              }
	            }
	          }
	        }
	        var child = node.child;
	        if (node.subtreeFlags & StoreConsistency && child !== null) {
	          child.return = node;
	          node = child;
	          continue;
	        }
	        if (node === finishedWork) {
	          return true;
	        }
	        while (node.sibling === null) {
	          if (node.return === null || node.return === finishedWork) {
	            return true;
	          }
	          node = node.return;
	        }
	        node.sibling.return = node.return;
	        node = node.sibling;
	      }
	      return true;
	    }
	    function markRootSuspended$1(root2, suspendedLanes) {
	      suspendedLanes = removeLanes(suspendedLanes, workInProgressRootPingedLanes);
	      suspendedLanes = removeLanes(suspendedLanes, workInProgressRootInterleavedUpdatedLanes);
	      markRootSuspended(root2, suspendedLanes);
	    }
	    function performSyncWorkOnRoot(root2) {
	      {
	        syncNestedUpdateFlag();
	      }
	      if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
	        throw new Error("Should not already be working.");
	      }
	      flushPassiveEffects();
	      var lanes = getNextLanes(root2, NoLanes);
	      if (!includesSomeLane(lanes, SyncLane)) {
	        ensureRootIsScheduled(root2, now());
	        return null;
	      }
	      var exitStatus = renderRootSync(root2, lanes);
	      if (root2.tag !== LegacyRoot && exitStatus === RootErrored) {
	        var errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
	        if (errorRetryLanes !== NoLanes) {
	          lanes = errorRetryLanes;
	          exitStatus = recoverFromConcurrentError(root2, errorRetryLanes);
	        }
	      }
	      if (exitStatus === RootFatalErrored) {
	        var fatalError = workInProgressRootFatalError;
	        prepareFreshStack(root2, NoLanes);
	        markRootSuspended$1(root2, lanes);
	        ensureRootIsScheduled(root2, now());
	        throw fatalError;
	      }
	      if (exitStatus === RootDidNotComplete) {
	        throw new Error("Root did not complete. This is a bug in React.");
	      }
	      var finishedWork = root2.current.alternate;
	      root2.finishedWork = finishedWork;
	      root2.finishedLanes = lanes;
	      commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
	      ensureRootIsScheduled(root2, now());
	      return null;
	    }
	    function flushRoot(root2, lanes) {
	      if (lanes !== NoLanes) {
	        markRootEntangled(root2, mergeLanes(lanes, SyncLane));
	        ensureRootIsScheduled(root2, now());
	        if ((executionContext & (RenderContext | CommitContext)) === NoContext) {
	          resetRenderTimer();
	          flushSyncCallbacks();
	        }
	      }
	    }
	    function batchedUpdates$1(fn, a) {
	      var prevExecutionContext = executionContext;
	      executionContext |= BatchedContext;
	      try {
	        return fn(a);
	      } finally {
	        executionContext = prevExecutionContext;
	        if (executionContext === NoContext && // Treat `act` as if it's inside `batchedUpdates`, even in legacy mode.
	        !ReactCurrentActQueue$1.isBatchingLegacy) {
	          resetRenderTimer();
	          flushSyncCallbacksOnlyInLegacyMode();
	        }
	      }
	    }
	    function discreteUpdates(fn, a, b, c, d) {
	      var previousPriority = getCurrentUpdatePriority();
	      var prevTransition = ReactCurrentBatchConfig$3.transition;
	      try {
	        ReactCurrentBatchConfig$3.transition = null;
	        setCurrentUpdatePriority(DiscreteEventPriority);
	        return fn(a, b, c, d);
	      } finally {
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig$3.transition = prevTransition;
	        if (executionContext === NoContext) {
	          resetRenderTimer();
	        }
	      }
	    }
	    function flushSync(fn) {
	      if (rootWithPendingPassiveEffects !== null && rootWithPendingPassiveEffects.tag === LegacyRoot && (executionContext & (RenderContext | CommitContext)) === NoContext) {
	        flushPassiveEffects();
	      }
	      var prevExecutionContext = executionContext;
	      executionContext |= BatchedContext;
	      var prevTransition = ReactCurrentBatchConfig$3.transition;
	      var previousPriority = getCurrentUpdatePriority();
	      try {
	        ReactCurrentBatchConfig$3.transition = null;
	        setCurrentUpdatePriority(DiscreteEventPriority);
	        if (fn) {
	          return fn();
	        } else {
	          return void 0;
	        }
	      } finally {
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig$3.transition = prevTransition;
	        executionContext = prevExecutionContext;
	        if ((executionContext & (RenderContext | CommitContext)) === NoContext) {
	          flushSyncCallbacks();
	        }
	      }
	    }
	    function isAlreadyRendering() {
	      return (executionContext & (RenderContext | CommitContext)) !== NoContext;
	    }
	    function pushRenderLanes(fiber, lanes) {
	      push(subtreeRenderLanesCursor, subtreeRenderLanes, fiber);
	      subtreeRenderLanes = mergeLanes(subtreeRenderLanes, lanes);
	    }
	    function popRenderLanes(fiber) {
	      subtreeRenderLanes = subtreeRenderLanesCursor.current;
	      pop(subtreeRenderLanesCursor, fiber);
	    }
	    function prepareFreshStack(root2, lanes) {
	      root2.finishedWork = null;
	      root2.finishedLanes = NoLanes;
	      var timeoutHandle = root2.timeoutHandle;
	      if (timeoutHandle !== noTimeout) {
	        root2.timeoutHandle = noTimeout;
	        cancelTimeout(timeoutHandle);
	      }
	      if (workInProgress !== null) {
	        var interruptedWork = workInProgress.return;
	        while (interruptedWork !== null) {
	          var current2 = interruptedWork.alternate;
	          unwindInterruptedWork(current2, interruptedWork);
	          interruptedWork = interruptedWork.return;
	        }
	      }
	      workInProgressRoot = root2;
	      var rootWorkInProgress = createWorkInProgress(root2.current, null);
	      workInProgress = rootWorkInProgress;
	      workInProgressRootRenderLanes = subtreeRenderLanes = lanes;
	      workInProgressRootExitStatus = RootInProgress;
	      workInProgressRootFatalError = null;
	      workInProgressRootSkippedLanes = NoLanes;
	      workInProgressRootInterleavedUpdatedLanes = NoLanes;
	      workInProgressRootPingedLanes = NoLanes;
	      workInProgressRootConcurrentErrors = null;
	      workInProgressRootRecoverableErrors = null;
	      finishQueueingConcurrentUpdates();
	      {
	        ReactStrictModeWarnings.discardPendingWarnings();
	      }
	      return rootWorkInProgress;
	    }
	    function handleError(root2, thrownValue) {
	      do {
	        var erroredWork = workInProgress;
	        try {
	          resetContextDependencies();
	          resetHooksAfterThrow();
	          resetCurrentFiber();
	          ReactCurrentOwner$2.current = null;
	          if (erroredWork === null || erroredWork.return === null) {
	            workInProgressRootExitStatus = RootFatalErrored;
	            workInProgressRootFatalError = thrownValue;
	            workInProgress = null;
	            return;
	          }
	          if (enableProfilerTimer && erroredWork.mode & ProfileMode) {
	            stopProfilerTimerIfRunningAndRecordDelta(erroredWork, true);
	          }
	          if (enableSchedulingProfiler) {
	            markComponentRenderStopped();
	            if (thrownValue !== null && typeof thrownValue === "object" && typeof thrownValue.then === "function") {
	              var wakeable = thrownValue;
	              markComponentSuspended(erroredWork, wakeable, workInProgressRootRenderLanes);
	            } else {
	              markComponentErrored(erroredWork, thrownValue, workInProgressRootRenderLanes);
	            }
	          }
	          throwException(root2, erroredWork.return, erroredWork, thrownValue, workInProgressRootRenderLanes);
	          completeUnitOfWork(erroredWork);
	        } catch (yetAnotherThrownValue) {
	          thrownValue = yetAnotherThrownValue;
	          if (workInProgress === erroredWork && erroredWork !== null) {
	            erroredWork = erroredWork.return;
	            workInProgress = erroredWork;
	          } else {
	            erroredWork = workInProgress;
	          }
	          continue;
	        }
	        return;
	      } while (true);
	    }
	    function pushDispatcher() {
	      var prevDispatcher = ReactCurrentDispatcher$2.current;
	      ReactCurrentDispatcher$2.current = ContextOnlyDispatcher;
	      if (prevDispatcher === null) {
	        return ContextOnlyDispatcher;
	      } else {
	        return prevDispatcher;
	      }
	    }
	    function popDispatcher(prevDispatcher) {
	      ReactCurrentDispatcher$2.current = prevDispatcher;
	    }
	    function markCommitTimeOfFallback() {
	      globalMostRecentFallbackTime = now();
	    }
	    function markSkippedUpdateLanes(lane) {
	      workInProgressRootSkippedLanes = mergeLanes(lane, workInProgressRootSkippedLanes);
	    }
	    function renderDidSuspend() {
	      if (workInProgressRootExitStatus === RootInProgress) {
	        workInProgressRootExitStatus = RootSuspended;
	      }
	    }
	    function renderDidSuspendDelayIfPossible() {
	      if (workInProgressRootExitStatus === RootInProgress || workInProgressRootExitStatus === RootSuspended || workInProgressRootExitStatus === RootErrored) {
	        workInProgressRootExitStatus = RootSuspendedWithDelay;
	      }
	      if (workInProgressRoot !== null && (includesNonIdleWork(workInProgressRootSkippedLanes) || includesNonIdleWork(workInProgressRootInterleavedUpdatedLanes))) {
	        markRootSuspended$1(workInProgressRoot, workInProgressRootRenderLanes);
	      }
	    }
	    function renderDidError(error2) {
	      if (workInProgressRootExitStatus !== RootSuspendedWithDelay) {
	        workInProgressRootExitStatus = RootErrored;
	      }
	      if (workInProgressRootConcurrentErrors === null) {
	        workInProgressRootConcurrentErrors = [error2];
	      } else {
	        workInProgressRootConcurrentErrors.push(error2);
	      }
	    }
	    function renderHasNotSuspendedYet() {
	      return workInProgressRootExitStatus === RootInProgress;
	    }
	    function renderRootSync(root2, lanes) {
	      var prevExecutionContext = executionContext;
	      executionContext |= RenderContext;
	      var prevDispatcher = pushDispatcher();
	      if (workInProgressRoot !== root2 || workInProgressRootRenderLanes !== lanes) {
	        {
	          if (isDevToolsPresent) {
	            var memoizedUpdaters = root2.memoizedUpdaters;
	            if (memoizedUpdaters.size > 0) {
	              restorePendingUpdaters(root2, workInProgressRootRenderLanes);
	              memoizedUpdaters.clear();
	            }
	            movePendingFibersToMemoized(root2, lanes);
	          }
	        }
	        workInProgressTransitions = getTransitionsForLanes();
	        prepareFreshStack(root2, lanes);
	      }
	      {
	        markRenderStarted(lanes);
	      }
	      do {
	        try {
	          workLoopSync();
	          break;
	        } catch (thrownValue) {
	          handleError(root2, thrownValue);
	        }
	      } while (true);
	      resetContextDependencies();
	      executionContext = prevExecutionContext;
	      popDispatcher(prevDispatcher);
	      if (workInProgress !== null) {
	        throw new Error("Cannot commit an incomplete root. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      {
	        markRenderStopped();
	      }
	      workInProgressRoot = null;
	      workInProgressRootRenderLanes = NoLanes;
	      return workInProgressRootExitStatus;
	    }
	    function workLoopSync() {
	      while (workInProgress !== null) {
	        performUnitOfWork(workInProgress);
	      }
	    }
	    function renderRootConcurrent(root2, lanes) {
	      var prevExecutionContext = executionContext;
	      executionContext |= RenderContext;
	      var prevDispatcher = pushDispatcher();
	      if (workInProgressRoot !== root2 || workInProgressRootRenderLanes !== lanes) {
	        {
	          if (isDevToolsPresent) {
	            var memoizedUpdaters = root2.memoizedUpdaters;
	            if (memoizedUpdaters.size > 0) {
	              restorePendingUpdaters(root2, workInProgressRootRenderLanes);
	              memoizedUpdaters.clear();
	            }
	            movePendingFibersToMemoized(root2, lanes);
	          }
	        }
	        workInProgressTransitions = getTransitionsForLanes();
	        resetRenderTimer();
	        prepareFreshStack(root2, lanes);
	      }
	      {
	        markRenderStarted(lanes);
	      }
	      do {
	        try {
	          workLoopConcurrent();
	          break;
	        } catch (thrownValue) {
	          handleError(root2, thrownValue);
	        }
	      } while (true);
	      resetContextDependencies();
	      popDispatcher(prevDispatcher);
	      executionContext = prevExecutionContext;
	      if (workInProgress !== null) {
	        {
	          markRenderYielded();
	        }
	        return RootInProgress;
	      } else {
	        {
	          markRenderStopped();
	        }
	        workInProgressRoot = null;
	        workInProgressRootRenderLanes = NoLanes;
	        return workInProgressRootExitStatus;
	      }
	    }
	    function workLoopConcurrent() {
	      while (workInProgress !== null && !shouldYield()) {
	        performUnitOfWork(workInProgress);
	      }
	    }
	    function performUnitOfWork(unitOfWork) {
	      var current2 = unitOfWork.alternate;
	      setCurrentFiber(unitOfWork);
	      var next;
	      if ((unitOfWork.mode & ProfileMode) !== NoMode) {
	        startProfilerTimer(unitOfWork);
	        next = beginWork$1(current2, unitOfWork, subtreeRenderLanes);
	        stopProfilerTimerIfRunningAndRecordDelta(unitOfWork, true);
	      } else {
	        next = beginWork$1(current2, unitOfWork, subtreeRenderLanes);
	      }
	      resetCurrentFiber();
	      unitOfWork.memoizedProps = unitOfWork.pendingProps;
	      if (next === null) {
	        completeUnitOfWork(unitOfWork);
	      } else {
	        workInProgress = next;
	      }
	      ReactCurrentOwner$2.current = null;
	    }
	    function completeUnitOfWork(unitOfWork) {
	      var completedWork = unitOfWork;
	      do {
	        var current2 = completedWork.alternate;
	        var returnFiber = completedWork.return;
	        if ((completedWork.flags & Incomplete) === NoFlags) {
	          setCurrentFiber(completedWork);
	          var next = void 0;
	          if ((completedWork.mode & ProfileMode) === NoMode) {
	            next = completeWork(current2, completedWork, subtreeRenderLanes);
	          } else {
	            startProfilerTimer(completedWork);
	            next = completeWork(current2, completedWork, subtreeRenderLanes);
	            stopProfilerTimerIfRunningAndRecordDelta(completedWork, false);
	          }
	          resetCurrentFiber();
	          if (next !== null) {
	            workInProgress = next;
	            return;
	          }
	        } else {
	          var _next = unwindWork(current2, completedWork);
	          if (_next !== null) {
	            _next.flags &= HostEffectMask;
	            workInProgress = _next;
	            return;
	          }
	          if ((completedWork.mode & ProfileMode) !== NoMode) {
	            stopProfilerTimerIfRunningAndRecordDelta(completedWork, false);
	            var actualDuration = completedWork.actualDuration;
	            var child = completedWork.child;
	            while (child !== null) {
	              actualDuration += child.actualDuration;
	              child = child.sibling;
	            }
	            completedWork.actualDuration = actualDuration;
	          }
	          if (returnFiber !== null) {
	            returnFiber.flags |= Incomplete;
	            returnFiber.subtreeFlags = NoFlags;
	            returnFiber.deletions = null;
	          } else {
	            workInProgressRootExitStatus = RootDidNotComplete;
	            workInProgress = null;
	            return;
	          }
	        }
	        var siblingFiber = completedWork.sibling;
	        if (siblingFiber !== null) {
	          workInProgress = siblingFiber;
	          return;
	        }
	        completedWork = returnFiber;
	        workInProgress = completedWork;
	      } while (completedWork !== null);
	      if (workInProgressRootExitStatus === RootInProgress) {
	        workInProgressRootExitStatus = RootCompleted;
	      }
	    }
	    function commitRoot(root2, recoverableErrors, transitions) {
	      var previousUpdateLanePriority = getCurrentUpdatePriority();
	      var prevTransition = ReactCurrentBatchConfig$3.transition;
	      try {
	        ReactCurrentBatchConfig$3.transition = null;
	        setCurrentUpdatePriority(DiscreteEventPriority);
	        commitRootImpl(root2, recoverableErrors, transitions, previousUpdateLanePriority);
	      } finally {
	        ReactCurrentBatchConfig$3.transition = prevTransition;
	        setCurrentUpdatePriority(previousUpdateLanePriority);
	      }
	      return null;
	    }
	    function commitRootImpl(root2, recoverableErrors, transitions, renderPriorityLevel) {
	      do {
	        flushPassiveEffects();
	      } while (rootWithPendingPassiveEffects !== null);
	      flushRenderPhaseStrictModeWarningsInDEV();
	      if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
	        throw new Error("Should not already be working.");
	      }
	      var finishedWork = root2.finishedWork;
	      var lanes = root2.finishedLanes;
	      {
	        markCommitStarted(lanes);
	      }
	      if (finishedWork === null) {
	        {
	          markCommitStopped();
	        }
	        return null;
	      } else {
	        {
	          if (lanes === NoLanes) {
	            error("root.finishedLanes should not be empty during a commit. This is a bug in React.");
	          }
	        }
	      }
	      root2.finishedWork = null;
	      root2.finishedLanes = NoLanes;
	      if (finishedWork === root2.current) {
	        throw new Error("Cannot commit the same tree as before. This error is likely caused by a bug in React. Please file an issue.");
	      }
	      root2.callbackNode = null;
	      root2.callbackPriority = NoLane;
	      var remainingLanes = mergeLanes(finishedWork.lanes, finishedWork.childLanes);
	      markRootFinished(root2, remainingLanes);
	      if (root2 === workInProgressRoot) {
	        workInProgressRoot = null;
	        workInProgress = null;
	        workInProgressRootRenderLanes = NoLanes;
	      }
	      if ((finishedWork.subtreeFlags & PassiveMask) !== NoFlags || (finishedWork.flags & PassiveMask) !== NoFlags) {
	        if (!rootDoesHavePassiveEffects) {
	          rootDoesHavePassiveEffects = true;
	          pendingPassiveTransitions = transitions;
	          scheduleCallback$1(NormalPriority, function() {
	            flushPassiveEffects();
	            return null;
	          });
	        }
	      }
	      var subtreeHasEffects = (finishedWork.subtreeFlags & (BeforeMutationMask | MutationMask | LayoutMask | PassiveMask)) !== NoFlags;
	      var rootHasEffect = (finishedWork.flags & (BeforeMutationMask | MutationMask | LayoutMask | PassiveMask)) !== NoFlags;
	      if (subtreeHasEffects || rootHasEffect) {
	        var prevTransition = ReactCurrentBatchConfig$3.transition;
	        ReactCurrentBatchConfig$3.transition = null;
	        var previousPriority = getCurrentUpdatePriority();
	        setCurrentUpdatePriority(DiscreteEventPriority);
	        var prevExecutionContext = executionContext;
	        executionContext |= CommitContext;
	        ReactCurrentOwner$2.current = null;
	        commitBeforeMutationEffects(root2, finishedWork);
	        {
	          recordCommitTime();
	        }
	        commitMutationEffects(root2, finishedWork, lanes);
	        resetAfterCommit(root2.containerInfo);
	        root2.current = finishedWork;
	        {
	          markLayoutEffectsStarted(lanes);
	        }
	        commitLayoutEffects(finishedWork, root2, lanes);
	        {
	          markLayoutEffectsStopped();
	        }
	        requestPaint();
	        executionContext = prevExecutionContext;
	        setCurrentUpdatePriority(previousPriority);
	        ReactCurrentBatchConfig$3.transition = prevTransition;
	      } else {
	        root2.current = finishedWork;
	        {
	          recordCommitTime();
	        }
	      }
	      var rootDidHavePassiveEffects = rootDoesHavePassiveEffects;
	      if (rootDoesHavePassiveEffects) {
	        rootDoesHavePassiveEffects = false;
	        rootWithPendingPassiveEffects = root2;
	        pendingPassiveEffectsLanes = lanes;
	      } else {
	        {
	          nestedPassiveUpdateCount = 0;
	          rootWithPassiveNestedUpdates = null;
	        }
	      }
	      remainingLanes = root2.pendingLanes;
	      if (remainingLanes === NoLanes) {
	        legacyErrorBoundariesThatAlreadyFailed = null;
	      }
	      {
	        if (!rootDidHavePassiveEffects) {
	          commitDoubleInvokeEffectsInDEV(root2.current, false);
	        }
	      }
	      onCommitRoot(finishedWork.stateNode, renderPriorityLevel);
	      {
	        if (isDevToolsPresent) {
	          root2.memoizedUpdaters.clear();
	        }
	      }
	      {
	        onCommitRoot$1();
	      }
	      ensureRootIsScheduled(root2, now());
	      if (recoverableErrors !== null) {
	        var onRecoverableError = root2.onRecoverableError;
	        for (var i = 0; i < recoverableErrors.length; i++) {
	          var recoverableError = recoverableErrors[i];
	          var componentStack = recoverableError.stack;
	          var digest = recoverableError.digest;
	          onRecoverableError(recoverableError.value, {
	            componentStack,
	            digest
	          });
	        }
	      }
	      if (hasUncaughtError) {
	        hasUncaughtError = false;
	        var error$1 = firstUncaughtError;
	        firstUncaughtError = null;
	        throw error$1;
	      }
	      if (includesSomeLane(pendingPassiveEffectsLanes, SyncLane) && root2.tag !== LegacyRoot) {
	        flushPassiveEffects();
	      }
	      remainingLanes = root2.pendingLanes;
	      if (includesSomeLane(remainingLanes, SyncLane)) {
	        {
	          markNestedUpdateScheduled();
	        }
	        if (root2 === rootWithNestedUpdates) {
	          nestedUpdateCount++;
	        } else {
	          nestedUpdateCount = 0;
	          rootWithNestedUpdates = root2;
	        }
	      } else {
	        nestedUpdateCount = 0;
	      }
	      flushSyncCallbacks();
	      {
	        markCommitStopped();
	      }
	      return null;
	    }
	    function flushPassiveEffects() {
	      if (rootWithPendingPassiveEffects !== null) {
	        var renderPriority = lanesToEventPriority(pendingPassiveEffectsLanes);
	        var priority = lowerEventPriority(DefaultEventPriority, renderPriority);
	        var prevTransition = ReactCurrentBatchConfig$3.transition;
	        var previousPriority = getCurrentUpdatePriority();
	        try {
	          ReactCurrentBatchConfig$3.transition = null;
	          setCurrentUpdatePriority(priority);
	          return flushPassiveEffectsImpl();
	        } finally {
	          setCurrentUpdatePriority(previousPriority);
	          ReactCurrentBatchConfig$3.transition = prevTransition;
	        }
	      }
	      return false;
	    }
	    function enqueuePendingPassiveProfilerEffect(fiber) {
	      {
	        pendingPassiveProfilerEffects.push(fiber);
	        if (!rootDoesHavePassiveEffects) {
	          rootDoesHavePassiveEffects = true;
	          scheduleCallback$1(NormalPriority, function() {
	            flushPassiveEffects();
	            return null;
	          });
	        }
	      }
	    }
	    function flushPassiveEffectsImpl() {
	      if (rootWithPendingPassiveEffects === null) {
	        return false;
	      }
	      var transitions = pendingPassiveTransitions;
	      pendingPassiveTransitions = null;
	      var root2 = rootWithPendingPassiveEffects;
	      var lanes = pendingPassiveEffectsLanes;
	      rootWithPendingPassiveEffects = null;
	      pendingPassiveEffectsLanes = NoLanes;
	      if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
	        throw new Error("Cannot flush passive effects while already rendering.");
	      }
	      {
	        isFlushingPassiveEffects = true;
	        didScheduleUpdateDuringPassiveEffects = false;
	      }
	      {
	        markPassiveEffectsStarted(lanes);
	      }
	      var prevExecutionContext = executionContext;
	      executionContext |= CommitContext;
	      commitPassiveUnmountEffects(root2.current);
	      commitPassiveMountEffects(root2, root2.current, lanes, transitions);
	      {
	        var profilerEffects = pendingPassiveProfilerEffects;
	        pendingPassiveProfilerEffects = [];
	        for (var i = 0; i < profilerEffects.length; i++) {
	          var _fiber = profilerEffects[i];
	          commitPassiveEffectDurations(root2, _fiber);
	        }
	      }
	      {
	        markPassiveEffectsStopped();
	      }
	      {
	        commitDoubleInvokeEffectsInDEV(root2.current, true);
	      }
	      executionContext = prevExecutionContext;
	      flushSyncCallbacks();
	      {
	        if (didScheduleUpdateDuringPassiveEffects) {
	          if (root2 === rootWithPassiveNestedUpdates) {
	            nestedPassiveUpdateCount++;
	          } else {
	            nestedPassiveUpdateCount = 0;
	            rootWithPassiveNestedUpdates = root2;
	          }
	        } else {
	          nestedPassiveUpdateCount = 0;
	        }
	        isFlushingPassiveEffects = false;
	        didScheduleUpdateDuringPassiveEffects = false;
	      }
	      onPostCommitRoot(root2);
	      {
	        var stateNode = root2.current.stateNode;
	        stateNode.effectDuration = 0;
	        stateNode.passiveEffectDuration = 0;
	      }
	      return true;
	    }
	    function isAlreadyFailedLegacyErrorBoundary(instance) {
	      return legacyErrorBoundariesThatAlreadyFailed !== null && legacyErrorBoundariesThatAlreadyFailed.has(instance);
	    }
	    function markLegacyErrorBoundaryAsFailed(instance) {
	      if (legacyErrorBoundariesThatAlreadyFailed === null) {
	        legacyErrorBoundariesThatAlreadyFailed = /* @__PURE__ */ new Set([instance]);
	      } else {
	        legacyErrorBoundariesThatAlreadyFailed.add(instance);
	      }
	    }
	    function prepareToThrowUncaughtError(error2) {
	      if (!hasUncaughtError) {
	        hasUncaughtError = true;
	        firstUncaughtError = error2;
	      }
	    }
	    var onUncaughtError = prepareToThrowUncaughtError;
	    function captureCommitPhaseErrorOnRoot(rootFiber, sourceFiber, error2) {
	      var errorInfo = createCapturedValueAtFiber(error2, sourceFiber);
	      var update = createRootErrorUpdate(rootFiber, errorInfo, SyncLane);
	      var root2 = enqueueUpdate(rootFiber, update, SyncLane);
	      var eventTime = requestEventTime();
	      if (root2 !== null) {
	        markRootUpdated(root2, SyncLane, eventTime);
	        ensureRootIsScheduled(root2, eventTime);
	      }
	    }
	    function captureCommitPhaseError(sourceFiber, nearestMountedAncestor, error$1) {
	      {
	        reportUncaughtErrorInDEV(error$1);
	        setIsRunningInsertionEffect(false);
	      }
	      if (sourceFiber.tag === HostRoot) {
	        captureCommitPhaseErrorOnRoot(sourceFiber, sourceFiber, error$1);
	        return;
	      }
	      var fiber = null;
	      {
	        fiber = nearestMountedAncestor;
	      }
	      while (fiber !== null) {
	        if (fiber.tag === HostRoot) {
	          captureCommitPhaseErrorOnRoot(fiber, sourceFiber, error$1);
	          return;
	        } else if (fiber.tag === ClassComponent) {
	          var ctor = fiber.type;
	          var instance = fiber.stateNode;
	          if (typeof ctor.getDerivedStateFromError === "function" || typeof instance.componentDidCatch === "function" && !isAlreadyFailedLegacyErrorBoundary(instance)) {
	            var errorInfo = createCapturedValueAtFiber(error$1, sourceFiber);
	            var update = createClassErrorUpdate(fiber, errorInfo, SyncLane);
	            var root2 = enqueueUpdate(fiber, update, SyncLane);
	            var eventTime = requestEventTime();
	            if (root2 !== null) {
	              markRootUpdated(root2, SyncLane, eventTime);
	              ensureRootIsScheduled(root2, eventTime);
	            }
	            return;
	          }
	        }
	        fiber = fiber.return;
	      }
	      {
	        error("Internal React error: Attempted to capture a commit phase error inside a detached tree. This indicates a bug in React. Likely causes include deleting the same fiber more than once, committing an already-finished tree, or an inconsistent return pointer.\n\nError message:\n\n%s", error$1);
	      }
	    }
	    function pingSuspendedRoot(root2, wakeable, pingedLanes) {
	      var pingCache = root2.pingCache;
	      if (pingCache !== null) {
	        pingCache.delete(wakeable);
	      }
	      var eventTime = requestEventTime();
	      markRootPinged(root2, pingedLanes);
	      warnIfSuspenseResolutionNotWrappedWithActDEV(root2);
	      if (workInProgressRoot === root2 && isSubsetOfLanes(workInProgressRootRenderLanes, pingedLanes)) {
	        if (workInProgressRootExitStatus === RootSuspendedWithDelay || workInProgressRootExitStatus === RootSuspended && includesOnlyRetries(workInProgressRootRenderLanes) && now() - globalMostRecentFallbackTime < FALLBACK_THROTTLE_MS) {
	          prepareFreshStack(root2, NoLanes);
	        } else {
	          workInProgressRootPingedLanes = mergeLanes(workInProgressRootPingedLanes, pingedLanes);
	        }
	      }
	      ensureRootIsScheduled(root2, eventTime);
	    }
	    function retryTimedOutBoundary(boundaryFiber, retryLane) {
	      if (retryLane === NoLane) {
	        retryLane = requestRetryLane(boundaryFiber);
	      }
	      var eventTime = requestEventTime();
	      var root2 = enqueueConcurrentRenderForLane(boundaryFiber, retryLane);
	      if (root2 !== null) {
	        markRootUpdated(root2, retryLane, eventTime);
	        ensureRootIsScheduled(root2, eventTime);
	      }
	    }
	    function retryDehydratedSuspenseBoundary(boundaryFiber) {
	      var suspenseState = boundaryFiber.memoizedState;
	      var retryLane = NoLane;
	      if (suspenseState !== null) {
	        retryLane = suspenseState.retryLane;
	      }
	      retryTimedOutBoundary(boundaryFiber, retryLane);
	    }
	    function resolveRetryWakeable(boundaryFiber, wakeable) {
	      var retryLane = NoLane;
	      var retryCache;
	      switch (boundaryFiber.tag) {
	        case SuspenseComponent:
	          retryCache = boundaryFiber.stateNode;
	          var suspenseState = boundaryFiber.memoizedState;
	          if (suspenseState !== null) {
	            retryLane = suspenseState.retryLane;
	          }
	          break;
	        case SuspenseListComponent:
	          retryCache = boundaryFiber.stateNode;
	          break;
	        default:
	          throw new Error("Pinged unknown suspense boundary type. This is probably a bug in React.");
	      }
	      if (retryCache !== null) {
	        retryCache.delete(wakeable);
	      }
	      retryTimedOutBoundary(boundaryFiber, retryLane);
	    }
	    function jnd(timeElapsed) {
	      return timeElapsed < 120 ? 120 : timeElapsed < 480 ? 480 : timeElapsed < 1080 ? 1080 : timeElapsed < 1920 ? 1920 : timeElapsed < 3e3 ? 3e3 : timeElapsed < 4320 ? 4320 : ceil(timeElapsed / 1960) * 1960;
	    }
	    function checkForNestedUpdates() {
	      if (nestedUpdateCount > NESTED_UPDATE_LIMIT) {
	        nestedUpdateCount = 0;
	        rootWithNestedUpdates = null;
	        throw new Error("Maximum update depth exceeded. This can happen when a component repeatedly calls setState inside componentWillUpdate or componentDidUpdate. React limits the number of nested updates to prevent infinite loops.");
	      }
	      {
	        if (nestedPassiveUpdateCount > NESTED_PASSIVE_UPDATE_LIMIT) {
	          nestedPassiveUpdateCount = 0;
	          rootWithPassiveNestedUpdates = null;
	          error("Maximum update depth exceeded. This can happen when a component calls setState inside useEffect, but useEffect either doesn't have a dependency array, or one of the dependencies changes on every render.");
	        }
	      }
	    }
	    function flushRenderPhaseStrictModeWarningsInDEV() {
	      {
	        ReactStrictModeWarnings.flushLegacyContextWarning();
	        {
	          ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings();
	        }
	      }
	    }
	    function commitDoubleInvokeEffectsInDEV(fiber, hasPassiveEffects) {
	      {
	        setCurrentFiber(fiber);
	        invokeEffectsInDev(fiber, MountLayoutDev, invokeLayoutEffectUnmountInDEV);
	        if (hasPassiveEffects) {
	          invokeEffectsInDev(fiber, MountPassiveDev, invokePassiveEffectUnmountInDEV);
	        }
	        invokeEffectsInDev(fiber, MountLayoutDev, invokeLayoutEffectMountInDEV);
	        if (hasPassiveEffects) {
	          invokeEffectsInDev(fiber, MountPassiveDev, invokePassiveEffectMountInDEV);
	        }
	        resetCurrentFiber();
	      }
	    }
	    function invokeEffectsInDev(firstChild, fiberFlags, invokeEffectFn) {
	      {
	        var current2 = firstChild;
	        var subtreeRoot = null;
	        while (current2 !== null) {
	          var primarySubtreeFlag = current2.subtreeFlags & fiberFlags;
	          if (current2 !== subtreeRoot && current2.child !== null && primarySubtreeFlag !== NoFlags) {
	            current2 = current2.child;
	          } else {
	            if ((current2.flags & fiberFlags) !== NoFlags) {
	              invokeEffectFn(current2);
	            }
	            if (current2.sibling !== null) {
	              current2 = current2.sibling;
	            } else {
	              current2 = subtreeRoot = current2.return;
	            }
	          }
	        }
	      }
	    }
	    var didWarnStateUpdateForNotYetMountedComponent = null;
	    function warnAboutUpdateOnNotYetMountedFiberInDEV(fiber) {
	      {
	        if ((executionContext & RenderContext) !== NoContext) {
	          return;
	        }
	        if (!(fiber.mode & ConcurrentMode)) {
	          return;
	        }
	        var tag = fiber.tag;
	        if (tag !== IndeterminateComponent && tag !== HostRoot && tag !== ClassComponent && tag !== FunctionComponent && tag !== ForwardRef && tag !== MemoComponent && tag !== SimpleMemoComponent) {
	          return;
	        }
	        var componentName = getComponentNameFromFiber(fiber) || "ReactComponent";
	        if (didWarnStateUpdateForNotYetMountedComponent !== null) {
	          if (didWarnStateUpdateForNotYetMountedComponent.has(componentName)) {
	            return;
	          }
	          didWarnStateUpdateForNotYetMountedComponent.add(componentName);
	        } else {
	          didWarnStateUpdateForNotYetMountedComponent = /* @__PURE__ */ new Set([componentName]);
	        }
	        var previousFiber = current;
	        try {
	          setCurrentFiber(fiber);
	          error("Can't perform a React state update on a component that hasn't mounted yet. This indicates that you have a side-effect in your render function that asynchronously later calls tries to update the component. Move this work to useEffect instead.");
	        } finally {
	          if (previousFiber) {
	            setCurrentFiber(fiber);
	          } else {
	            resetCurrentFiber();
	          }
	        }
	      }
	    }
	    var beginWork$1;
	    {
	      var dummyFiber = null;
	      beginWork$1 = function(current2, unitOfWork, lanes) {
	        var originalWorkInProgressCopy = assignFiberPropertiesInDEV(dummyFiber, unitOfWork);
	        try {
	          return beginWork(current2, unitOfWork, lanes);
	        } catch (originalError) {
	          if (didSuspendOrErrorWhileHydratingDEV() || originalError !== null && typeof originalError === "object" && typeof originalError.then === "function") {
	            throw originalError;
	          }
	          resetContextDependencies();
	          resetHooksAfterThrow();
	          unwindInterruptedWork(current2, unitOfWork);
	          assignFiberPropertiesInDEV(unitOfWork, originalWorkInProgressCopy);
	          if (unitOfWork.mode & ProfileMode) {
	            startProfilerTimer(unitOfWork);
	          }
	          invokeGuardedCallback(null, beginWork, null, current2, unitOfWork, lanes);
	          if (hasCaughtError()) {
	            var replayError = clearCaughtError();
	            if (typeof replayError === "object" && replayError !== null && replayError._suppressLogging && typeof originalError === "object" && originalError !== null && !originalError._suppressLogging) {
	              originalError._suppressLogging = true;
	            }
	          }
	          throw originalError;
	        }
	      };
	    }
	    var didWarnAboutUpdateInRender = false;
	    var didWarnAboutUpdateInRenderForAnotherComponent;
	    {
	      didWarnAboutUpdateInRenderForAnotherComponent = /* @__PURE__ */ new Set();
	    }
	    function warnAboutRenderPhaseUpdatesInDEV(fiber) {
	      {
	        if (isRendering && !getIsUpdatingOpaqueValueInRenderPhaseInDEV()) {
	          switch (fiber.tag) {
	            case FunctionComponent:
	            case ForwardRef:
	            case SimpleMemoComponent: {
	              var renderingComponentName = workInProgress && getComponentNameFromFiber(workInProgress) || "Unknown";
	              var dedupeKey = renderingComponentName;
	              if (!didWarnAboutUpdateInRenderForAnotherComponent.has(dedupeKey)) {
	                didWarnAboutUpdateInRenderForAnotherComponent.add(dedupeKey);
	                var setStateComponentName = getComponentNameFromFiber(fiber) || "Unknown";
	                error("Cannot update a component (`%s`) while rendering a different component (`%s`). To locate the bad setState() call inside `%s`, follow the stack trace as described in https://reactjs.org/link/setstate-in-render", setStateComponentName, renderingComponentName, renderingComponentName);
	              }
	              break;
	            }
	            case ClassComponent: {
	              if (!didWarnAboutUpdateInRender) {
	                error("Cannot update during an existing state transition (such as within `render`). Render methods should be a pure function of props and state.");
	                didWarnAboutUpdateInRender = true;
	              }
	              break;
	            }
	          }
	        }
	      }
	    }
	    function restorePendingUpdaters(root2, lanes) {
	      {
	        if (isDevToolsPresent) {
	          var memoizedUpdaters = root2.memoizedUpdaters;
	          memoizedUpdaters.forEach(function(schedulingFiber) {
	            addFiberToLanesMap(root2, schedulingFiber, lanes);
	          });
	        }
	      }
	    }
	    var fakeActCallbackNode = {};
	    function scheduleCallback$1(priorityLevel, callback) {
	      {
	        var actQueue = ReactCurrentActQueue$1.current;
	        if (actQueue !== null) {
	          actQueue.push(callback);
	          return fakeActCallbackNode;
	        } else {
	          return scheduleCallback(priorityLevel, callback);
	        }
	      }
	    }
	    function cancelCallback$1(callbackNode) {
	      if (callbackNode === fakeActCallbackNode) {
	        return;
	      }
	      return cancelCallback(callbackNode);
	    }
	    function shouldForceFlushFallbacksInDEV() {
	      return ReactCurrentActQueue$1.current !== null;
	    }
	    function warnIfUpdatesNotWrappedWithActDEV(fiber) {
	      {
	        if (fiber.mode & ConcurrentMode) {
	          if (!isConcurrentActEnvironment()) {
	            return;
	          }
	        } else {
	          if (!isLegacyActEnvironment()) {
	            return;
	          }
	          if (executionContext !== NoContext) {
	            return;
	          }
	          if (fiber.tag !== FunctionComponent && fiber.tag !== ForwardRef && fiber.tag !== SimpleMemoComponent) {
	            return;
	          }
	        }
	        if (ReactCurrentActQueue$1.current === null) {
	          var previousFiber = current;
	          try {
	            setCurrentFiber(fiber);
	            error("An update to %s inside a test was not wrapped in act(...).\n\nWhen testing, code that causes React state updates should be wrapped into act(...):\n\nact(() => {\n  /* fire events that update state */\n});\n/* assert on the output */\n\nThis ensures that you're testing the behavior the user would see in the browser. Learn more at https://reactjs.org/link/wrap-tests-with-act", getComponentNameFromFiber(fiber));
	          } finally {
	            if (previousFiber) {
	              setCurrentFiber(fiber);
	            } else {
	              resetCurrentFiber();
	            }
	          }
	        }
	      }
	    }
	    function warnIfSuspenseResolutionNotWrappedWithActDEV(root2) {
	      {
	        if (root2.tag !== LegacyRoot && isConcurrentActEnvironment() && ReactCurrentActQueue$1.current === null) {
	          error("A suspended resource finished loading inside a test, but the event was not wrapped in act(...).\n\nWhen testing, code that resolves suspended data should be wrapped into act(...):\n\nact(() => {\n  /* finish loading suspended data */\n});\n/* assert on the output */\n\nThis ensures that you're testing the behavior the user would see in the browser. Learn more at https://reactjs.org/link/wrap-tests-with-act");
	        }
	      }
	    }
	    function setIsRunningInsertionEffect(isRunning) {
	      {
	        isRunningInsertionEffect = isRunning;
	      }
	    }
	    var resolveFamily = null;
	    var failedBoundaries = null;
	    var setRefreshHandler = function(handler) {
	      {
	        resolveFamily = handler;
	      }
	    };
	    function resolveFunctionForHotReloading(type) {
	      {
	        if (resolveFamily === null) {
	          return type;
	        }
	        var family = resolveFamily(type);
	        if (family === void 0) {
	          return type;
	        }
	        return family.current;
	      }
	    }
	    function resolveClassForHotReloading(type) {
	      return resolveFunctionForHotReloading(type);
	    }
	    function resolveForwardRefForHotReloading(type) {
	      {
	        if (resolveFamily === null) {
	          return type;
	        }
	        var family = resolveFamily(type);
	        if (family === void 0) {
	          if (type !== null && type !== void 0 && typeof type.render === "function") {
	            var currentRender = resolveFunctionForHotReloading(type.render);
	            if (type.render !== currentRender) {
	              var syntheticType = {
	                $$typeof: REACT_FORWARD_REF_TYPE,
	                render: currentRender
	              };
	              if (type.displayName !== void 0) {
	                syntheticType.displayName = type.displayName;
	              }
	              return syntheticType;
	            }
	          }
	          return type;
	        }
	        return family.current;
	      }
	    }
	    function isCompatibleFamilyForHotReloading(fiber, element) {
	      {
	        if (resolveFamily === null) {
	          return false;
	        }
	        var prevType = fiber.elementType;
	        var nextType = element.type;
	        var needsCompareFamilies = false;
	        var $$typeofNextType = typeof nextType === "object" && nextType !== null ? nextType.$$typeof : null;
	        switch (fiber.tag) {
	          case ClassComponent: {
	            if (typeof nextType === "function") {
	              needsCompareFamilies = true;
	            }
	            break;
	          }
	          case FunctionComponent: {
	            if (typeof nextType === "function") {
	              needsCompareFamilies = true;
	            } else if ($$typeofNextType === REACT_LAZY_TYPE) {
	              needsCompareFamilies = true;
	            }
	            break;
	          }
	          case ForwardRef: {
	            if ($$typeofNextType === REACT_FORWARD_REF_TYPE) {
	              needsCompareFamilies = true;
	            } else if ($$typeofNextType === REACT_LAZY_TYPE) {
	              needsCompareFamilies = true;
	            }
	            break;
	          }
	          case MemoComponent:
	          case SimpleMemoComponent: {
	            if ($$typeofNextType === REACT_MEMO_TYPE) {
	              needsCompareFamilies = true;
	            } else if ($$typeofNextType === REACT_LAZY_TYPE) {
	              needsCompareFamilies = true;
	            }
	            break;
	          }
	          default:
	            return false;
	        }
	        if (needsCompareFamilies) {
	          var prevFamily = resolveFamily(prevType);
	          if (prevFamily !== void 0 && prevFamily === resolveFamily(nextType)) {
	            return true;
	          }
	        }
	        return false;
	      }
	    }
	    function markFailedErrorBoundaryForHotReloading(fiber) {
	      {
	        if (resolveFamily === null) {
	          return;
	        }
	        if (typeof WeakSet !== "function") {
	          return;
	        }
	        if (failedBoundaries === null) {
	          failedBoundaries = /* @__PURE__ */ new WeakSet();
	        }
	        failedBoundaries.add(fiber);
	      }
	    }
	    var scheduleRefresh = function(root2, update) {
	      {
	        if (resolveFamily === null) {
	          return;
	        }
	        var staleFamilies = update.staleFamilies, updatedFamilies = update.updatedFamilies;
	        flushPassiveEffects();
	        flushSync(function() {
	          scheduleFibersWithFamiliesRecursively(root2.current, updatedFamilies, staleFamilies);
	        });
	      }
	    };
	    var scheduleRoot = function(root2, element) {
	      {
	        if (root2.context !== emptyContextObject) {
	          return;
	        }
	        flushPassiveEffects();
	        flushSync(function() {
	          updateContainer(element, root2, null, null);
	        });
	      }
	    };
	    function scheduleFibersWithFamiliesRecursively(fiber, updatedFamilies, staleFamilies) {
	      {
	        var alternate = fiber.alternate, child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type = fiber.type;
	        var candidateType = null;
	        switch (tag) {
	          case FunctionComponent:
	          case SimpleMemoComponent:
	          case ClassComponent:
	            candidateType = type;
	            break;
	          case ForwardRef:
	            candidateType = type.render;
	            break;
	        }
	        if (resolveFamily === null) {
	          throw new Error("Expected resolveFamily to be set during hot reload.");
	        }
	        var needsRender = false;
	        var needsRemount = false;
	        if (candidateType !== null) {
	          var family = resolveFamily(candidateType);
	          if (family !== void 0) {
	            if (staleFamilies.has(family)) {
	              needsRemount = true;
	            } else if (updatedFamilies.has(family)) {
	              if (tag === ClassComponent) {
	                needsRemount = true;
	              } else {
	                needsRender = true;
	              }
	            }
	          }
	        }
	        if (failedBoundaries !== null) {
	          if (failedBoundaries.has(fiber) || alternate !== null && failedBoundaries.has(alternate)) {
	            needsRemount = true;
	          }
	        }
	        if (needsRemount) {
	          fiber._debugNeedsRemount = true;
	        }
	        if (needsRemount || needsRender) {
	          var _root = enqueueConcurrentRenderForLane(fiber, SyncLane);
	          if (_root !== null) {
	            scheduleUpdateOnFiber(_root, fiber, SyncLane, NoTimestamp);
	          }
	        }
	        if (child !== null && !needsRemount) {
	          scheduleFibersWithFamiliesRecursively(child, updatedFamilies, staleFamilies);
	        }
	        if (sibling !== null) {
	          scheduleFibersWithFamiliesRecursively(sibling, updatedFamilies, staleFamilies);
	        }
	      }
	    }
	    var findHostInstancesForRefresh = function(root2, families) {
	      {
	        var hostInstances = /* @__PURE__ */ new Set();
	        var types = new Set(families.map(function(family) {
	          return family.current;
	        }));
	        findHostInstancesForMatchingFibersRecursively(root2.current, types, hostInstances);
	        return hostInstances;
	      }
	    };
	    function findHostInstancesForMatchingFibersRecursively(fiber, types, hostInstances) {
	      {
	        var child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type = fiber.type;
	        var candidateType = null;
	        switch (tag) {
	          case FunctionComponent:
	          case SimpleMemoComponent:
	          case ClassComponent:
	            candidateType = type;
	            break;
	          case ForwardRef:
	            candidateType = type.render;
	            break;
	        }
	        var didMatch = false;
	        if (candidateType !== null) {
	          if (types.has(candidateType)) {
	            didMatch = true;
	          }
	        }
	        if (didMatch) {
	          findHostInstancesForFiberShallowly(fiber, hostInstances);
	        } else {
	          if (child !== null) {
	            findHostInstancesForMatchingFibersRecursively(child, types, hostInstances);
	          }
	        }
	        if (sibling !== null) {
	          findHostInstancesForMatchingFibersRecursively(sibling, types, hostInstances);
	        }
	      }
	    }
	    function findHostInstancesForFiberShallowly(fiber, hostInstances) {
	      {
	        var foundHostInstances = findChildHostInstancesForFiberShallowly(fiber, hostInstances);
	        if (foundHostInstances) {
	          return;
	        }
	        var node = fiber;
	        while (true) {
	          switch (node.tag) {
	            case HostComponent:
	              hostInstances.add(node.stateNode);
	              return;
	            case HostPortal:
	              hostInstances.add(node.stateNode.containerInfo);
	              return;
	            case HostRoot:
	              hostInstances.add(node.stateNode.containerInfo);
	              return;
	          }
	          if (node.return === null) {
	            throw new Error("Expected to reach root first.");
	          }
	          node = node.return;
	        }
	      }
	    }
	    function findChildHostInstancesForFiberShallowly(fiber, hostInstances) {
	      {
	        var node = fiber;
	        var foundHostInstances = false;
	        while (true) {
	          if (node.tag === HostComponent) {
	            foundHostInstances = true;
	            hostInstances.add(node.stateNode);
	          } else if (node.child !== null) {
	            node.child.return = node;
	            node = node.child;
	            continue;
	          }
	          if (node === fiber) {
	            return foundHostInstances;
	          }
	          while (node.sibling === null) {
	            if (node.return === null || node.return === fiber) {
	              return foundHostInstances;
	            }
	            node = node.return;
	          }
	          node.sibling.return = node.return;
	          node = node.sibling;
	        }
	      }
	      return false;
	    }
	    var hasBadMapPolyfill;
	    {
	      hasBadMapPolyfill = false;
	      try {
	        var nonExtensibleObject = Object.preventExtensions({});
	        /* @__PURE__ */ new Map([[nonExtensibleObject, null]]);
	        /* @__PURE__ */ new Set([nonExtensibleObject]);
	      } catch (e) {
	        hasBadMapPolyfill = true;
	      }
	    }
	    function FiberNode(tag, pendingProps, key, mode) {
	      this.tag = tag;
	      this.key = key;
	      this.elementType = null;
	      this.type = null;
	      this.stateNode = null;
	      this.return = null;
	      this.child = null;
	      this.sibling = null;
	      this.index = 0;
	      this.ref = null;
	      this.pendingProps = pendingProps;
	      this.memoizedProps = null;
	      this.updateQueue = null;
	      this.memoizedState = null;
	      this.dependencies = null;
	      this.mode = mode;
	      this.flags = NoFlags;
	      this.subtreeFlags = NoFlags;
	      this.deletions = null;
	      this.lanes = NoLanes;
	      this.childLanes = NoLanes;
	      this.alternate = null;
	      {
	        this.actualDuration = Number.NaN;
	        this.actualStartTime = Number.NaN;
	        this.selfBaseDuration = Number.NaN;
	        this.treeBaseDuration = Number.NaN;
	        this.actualDuration = 0;
	        this.actualStartTime = -1;
	        this.selfBaseDuration = 0;
	        this.treeBaseDuration = 0;
	      }
	      {
	        this._debugSource = null;
	        this._debugOwner = null;
	        this._debugNeedsRemount = false;
	        this._debugHookTypes = null;
	        if (!hasBadMapPolyfill && typeof Object.preventExtensions === "function") {
	          Object.preventExtensions(this);
	        }
	      }
	    }
	    var createFiber = function(tag, pendingProps, key, mode) {
	      return new FiberNode(tag, pendingProps, key, mode);
	    };
	    function shouldConstruct$1(Component) {
	      var prototype = Component.prototype;
	      return !!(prototype && prototype.isReactComponent);
	    }
	    function isSimpleFunctionComponent(type) {
	      return typeof type === "function" && !shouldConstruct$1(type) && type.defaultProps === void 0;
	    }
	    function resolveLazyComponentTag(Component) {
	      if (typeof Component === "function") {
	        return shouldConstruct$1(Component) ? ClassComponent : FunctionComponent;
	      } else if (Component !== void 0 && Component !== null) {
	        var $$typeof = Component.$$typeof;
	        if ($$typeof === REACT_FORWARD_REF_TYPE) {
	          return ForwardRef;
	        }
	        if ($$typeof === REACT_MEMO_TYPE) {
	          return MemoComponent;
	        }
	      }
	      return IndeterminateComponent;
	    }
	    function createWorkInProgress(current2, pendingProps) {
	      var workInProgress2 = current2.alternate;
	      if (workInProgress2 === null) {
	        workInProgress2 = createFiber(current2.tag, pendingProps, current2.key, current2.mode);
	        workInProgress2.elementType = current2.elementType;
	        workInProgress2.type = current2.type;
	        workInProgress2.stateNode = current2.stateNode;
	        {
	          workInProgress2._debugSource = current2._debugSource;
	          workInProgress2._debugOwner = current2._debugOwner;
	          workInProgress2._debugHookTypes = current2._debugHookTypes;
	        }
	        workInProgress2.alternate = current2;
	        current2.alternate = workInProgress2;
	      } else {
	        workInProgress2.pendingProps = pendingProps;
	        workInProgress2.type = current2.type;
	        workInProgress2.flags = NoFlags;
	        workInProgress2.subtreeFlags = NoFlags;
	        workInProgress2.deletions = null;
	        {
	          workInProgress2.actualDuration = 0;
	          workInProgress2.actualStartTime = -1;
	        }
	      }
	      workInProgress2.flags = current2.flags & StaticMask;
	      workInProgress2.childLanes = current2.childLanes;
	      workInProgress2.lanes = current2.lanes;
	      workInProgress2.child = current2.child;
	      workInProgress2.memoizedProps = current2.memoizedProps;
	      workInProgress2.memoizedState = current2.memoizedState;
	      workInProgress2.updateQueue = current2.updateQueue;
	      var currentDependencies = current2.dependencies;
	      workInProgress2.dependencies = currentDependencies === null ? null : {
	        lanes: currentDependencies.lanes,
	        firstContext: currentDependencies.firstContext
	      };
	      workInProgress2.sibling = current2.sibling;
	      workInProgress2.index = current2.index;
	      workInProgress2.ref = current2.ref;
	      {
	        workInProgress2.selfBaseDuration = current2.selfBaseDuration;
	        workInProgress2.treeBaseDuration = current2.treeBaseDuration;
	      }
	      {
	        workInProgress2._debugNeedsRemount = current2._debugNeedsRemount;
	        switch (workInProgress2.tag) {
	          case IndeterminateComponent:
	          case FunctionComponent:
	          case SimpleMemoComponent:
	            workInProgress2.type = resolveFunctionForHotReloading(current2.type);
	            break;
	          case ClassComponent:
	            workInProgress2.type = resolveClassForHotReloading(current2.type);
	            break;
	          case ForwardRef:
	            workInProgress2.type = resolveForwardRefForHotReloading(current2.type);
	            break;
	        }
	      }
	      return workInProgress2;
	    }
	    function resetWorkInProgress(workInProgress2, renderLanes2) {
	      workInProgress2.flags &= StaticMask | Placement;
	      var current2 = workInProgress2.alternate;
	      if (current2 === null) {
	        workInProgress2.childLanes = NoLanes;
	        workInProgress2.lanes = renderLanes2;
	        workInProgress2.child = null;
	        workInProgress2.subtreeFlags = NoFlags;
	        workInProgress2.memoizedProps = null;
	        workInProgress2.memoizedState = null;
	        workInProgress2.updateQueue = null;
	        workInProgress2.dependencies = null;
	        workInProgress2.stateNode = null;
	        {
	          workInProgress2.selfBaseDuration = 0;
	          workInProgress2.treeBaseDuration = 0;
	        }
	      } else {
	        workInProgress2.childLanes = current2.childLanes;
	        workInProgress2.lanes = current2.lanes;
	        workInProgress2.child = current2.child;
	        workInProgress2.subtreeFlags = NoFlags;
	        workInProgress2.deletions = null;
	        workInProgress2.memoizedProps = current2.memoizedProps;
	        workInProgress2.memoizedState = current2.memoizedState;
	        workInProgress2.updateQueue = current2.updateQueue;
	        workInProgress2.type = current2.type;
	        var currentDependencies = current2.dependencies;
	        workInProgress2.dependencies = currentDependencies === null ? null : {
	          lanes: currentDependencies.lanes,
	          firstContext: currentDependencies.firstContext
	        };
	        {
	          workInProgress2.selfBaseDuration = current2.selfBaseDuration;
	          workInProgress2.treeBaseDuration = current2.treeBaseDuration;
	        }
	      }
	      return workInProgress2;
	    }
	    function createHostRootFiber(tag, isStrictMode, concurrentUpdatesByDefaultOverride) {
	      var mode;
	      if (tag === ConcurrentRoot) {
	        mode = ConcurrentMode;
	        if (isStrictMode === true) {
	          mode |= StrictLegacyMode;
	          {
	            mode |= StrictEffectsMode;
	          }
	        }
	      } else {
	        mode = NoMode;
	      }
	      if (isDevToolsPresent) {
	        mode |= ProfileMode;
	      }
	      return createFiber(HostRoot, null, null, mode);
	    }
	    function createFiberFromTypeAndProps(type, key, pendingProps, owner, mode, lanes) {
	      var fiberTag = IndeterminateComponent;
	      var resolvedType = type;
	      if (typeof type === "function") {
	        if (shouldConstruct$1(type)) {
	          fiberTag = ClassComponent;
	          {
	            resolvedType = resolveClassForHotReloading(resolvedType);
	          }
	        } else {
	          {
	            resolvedType = resolveFunctionForHotReloading(resolvedType);
	          }
	        }
	      } else if (typeof type === "string") {
	        fiberTag = HostComponent;
	      } else {
	        getTag:
	          switch (type) {
	            case REACT_FRAGMENT_TYPE:
	              return createFiberFromFragment(pendingProps.children, mode, lanes, key);
	            case REACT_STRICT_MODE_TYPE:
	              fiberTag = Mode;
	              mode |= StrictLegacyMode;
	              if ((mode & ConcurrentMode) !== NoMode) {
	                mode |= StrictEffectsMode;
	              }
	              break;
	            case REACT_PROFILER_TYPE:
	              return createFiberFromProfiler(pendingProps, mode, lanes, key);
	            case REACT_SUSPENSE_TYPE:
	              return createFiberFromSuspense(pendingProps, mode, lanes, key);
	            case REACT_SUSPENSE_LIST_TYPE:
	              return createFiberFromSuspenseList(pendingProps, mode, lanes, key);
	            case REACT_OFFSCREEN_TYPE:
	              return createFiberFromOffscreen(pendingProps, mode, lanes, key);
	            case REACT_LEGACY_HIDDEN_TYPE:
	            case REACT_SCOPE_TYPE:
	            case REACT_CACHE_TYPE:
	            case REACT_TRACING_MARKER_TYPE:
	            case REACT_DEBUG_TRACING_MODE_TYPE:
	            default: {
	              if (typeof type === "object" && type !== null) {
	                switch (type.$$typeof) {
	                  case REACT_PROVIDER_TYPE:
	                    fiberTag = ContextProvider;
	                    break getTag;
	                  case REACT_CONTEXT_TYPE:
	                    fiberTag = ContextConsumer;
	                    break getTag;
	                  case REACT_FORWARD_REF_TYPE:
	                    fiberTag = ForwardRef;
	                    {
	                      resolvedType = resolveForwardRefForHotReloading(resolvedType);
	                    }
	                    break getTag;
	                  case REACT_MEMO_TYPE:
	                    fiberTag = MemoComponent;
	                    break getTag;
	                  case REACT_LAZY_TYPE:
	                    fiberTag = LazyComponent;
	                    resolvedType = null;
	                    break getTag;
	                }
	              }
	              var info = "";
	              {
	                if (type === void 0 || typeof type === "object" && type !== null && Object.keys(type).length === 0) {
	                  info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
	                }
	                var ownerName = owner ? getComponentNameFromFiber(owner) : null;
	                if (ownerName) {
	                  info += "\n\nCheck the render method of `" + ownerName + "`.";
	                }
	              }
	              throw new Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) " + ("but got: " + (type == null ? type : typeof type) + "." + info));
	            }
	          }
	      }
	      var fiber = createFiber(fiberTag, pendingProps, key, mode);
	      fiber.elementType = type;
	      fiber.type = resolvedType;
	      fiber.lanes = lanes;
	      {
	        fiber._debugOwner = owner;
	      }
	      return fiber;
	    }
	    function createFiberFromElement(element, mode, lanes) {
	      var owner = null;
	      {
	        owner = element._owner;
	      }
	      var type = element.type;
	      var key = element.key;
	      var pendingProps = element.props;
	      var fiber = createFiberFromTypeAndProps(type, key, pendingProps, owner, mode, lanes);
	      {
	        fiber._debugSource = element._source;
	        fiber._debugOwner = element._owner;
	      }
	      return fiber;
	    }
	    function createFiberFromFragment(elements, mode, lanes, key) {
	      var fiber = createFiber(Fragment, elements, key, mode);
	      fiber.lanes = lanes;
	      return fiber;
	    }
	    function createFiberFromProfiler(pendingProps, mode, lanes, key) {
	      {
	        if (typeof pendingProps.id !== "string") {
	          error('Profiler must specify an "id" of type `string` as a prop. Received the type `%s` instead.', typeof pendingProps.id);
	        }
	      }
	      var fiber = createFiber(Profiler, pendingProps, key, mode | ProfileMode);
	      fiber.elementType = REACT_PROFILER_TYPE;
	      fiber.lanes = lanes;
	      {
	        fiber.stateNode = {
	          effectDuration: 0,
	          passiveEffectDuration: 0
	        };
	      }
	      return fiber;
	    }
	    function createFiberFromSuspense(pendingProps, mode, lanes, key) {
	      var fiber = createFiber(SuspenseComponent, pendingProps, key, mode);
	      fiber.elementType = REACT_SUSPENSE_TYPE;
	      fiber.lanes = lanes;
	      return fiber;
	    }
	    function createFiberFromSuspenseList(pendingProps, mode, lanes, key) {
	      var fiber = createFiber(SuspenseListComponent, pendingProps, key, mode);
	      fiber.elementType = REACT_SUSPENSE_LIST_TYPE;
	      fiber.lanes = lanes;
	      return fiber;
	    }
	    function createFiberFromOffscreen(pendingProps, mode, lanes, key) {
	      var fiber = createFiber(OffscreenComponent, pendingProps, key, mode);
	      fiber.elementType = REACT_OFFSCREEN_TYPE;
	      fiber.lanes = lanes;
	      var primaryChildInstance = {
	        isHidden: false
	      };
	      fiber.stateNode = primaryChildInstance;
	      return fiber;
	    }
	    function createFiberFromText(content, mode, lanes) {
	      var fiber = createFiber(HostText, content, null, mode);
	      fiber.lanes = lanes;
	      return fiber;
	    }
	    function createFiberFromHostInstanceForDeletion() {
	      var fiber = createFiber(HostComponent, null, null, NoMode);
	      fiber.elementType = "DELETED";
	      return fiber;
	    }
	    function createFiberFromDehydratedFragment(dehydratedNode) {
	      var fiber = createFiber(DehydratedFragment, null, null, NoMode);
	      fiber.stateNode = dehydratedNode;
	      return fiber;
	    }
	    function createFiberFromPortal(portal, mode, lanes) {
	      var pendingProps = portal.children !== null ? portal.children : [];
	      var fiber = createFiber(HostPortal, pendingProps, portal.key, mode);
	      fiber.lanes = lanes;
	      fiber.stateNode = {
	        containerInfo: portal.containerInfo,
	        pendingChildren: null,
	        // Used by persistent updates
	        implementation: portal.implementation
	      };
	      return fiber;
	    }
	    function assignFiberPropertiesInDEV(target, source) {
	      if (target === null) {
	        target = createFiber(IndeterminateComponent, null, null, NoMode);
	      }
	      target.tag = source.tag;
	      target.key = source.key;
	      target.elementType = source.elementType;
	      target.type = source.type;
	      target.stateNode = source.stateNode;
	      target.return = source.return;
	      target.child = source.child;
	      target.sibling = source.sibling;
	      target.index = source.index;
	      target.ref = source.ref;
	      target.pendingProps = source.pendingProps;
	      target.memoizedProps = source.memoizedProps;
	      target.updateQueue = source.updateQueue;
	      target.memoizedState = source.memoizedState;
	      target.dependencies = source.dependencies;
	      target.mode = source.mode;
	      target.flags = source.flags;
	      target.subtreeFlags = source.subtreeFlags;
	      target.deletions = source.deletions;
	      target.lanes = source.lanes;
	      target.childLanes = source.childLanes;
	      target.alternate = source.alternate;
	      {
	        target.actualDuration = source.actualDuration;
	        target.actualStartTime = source.actualStartTime;
	        target.selfBaseDuration = source.selfBaseDuration;
	        target.treeBaseDuration = source.treeBaseDuration;
	      }
	      target._debugSource = source._debugSource;
	      target._debugOwner = source._debugOwner;
	      target._debugNeedsRemount = source._debugNeedsRemount;
	      target._debugHookTypes = source._debugHookTypes;
	      return target;
	    }
	    function FiberRootNode(containerInfo, tag, hydrate2, identifierPrefix, onRecoverableError) {
	      this.tag = tag;
	      this.containerInfo = containerInfo;
	      this.pendingChildren = null;
	      this.current = null;
	      this.pingCache = null;
	      this.finishedWork = null;
	      this.timeoutHandle = noTimeout;
	      this.context = null;
	      this.pendingContext = null;
	      this.callbackNode = null;
	      this.callbackPriority = NoLane;
	      this.eventTimes = createLaneMap(NoLanes);
	      this.expirationTimes = createLaneMap(NoTimestamp);
	      this.pendingLanes = NoLanes;
	      this.suspendedLanes = NoLanes;
	      this.pingedLanes = NoLanes;
	      this.expiredLanes = NoLanes;
	      this.mutableReadLanes = NoLanes;
	      this.finishedLanes = NoLanes;
	      this.entangledLanes = NoLanes;
	      this.entanglements = createLaneMap(NoLanes);
	      this.identifierPrefix = identifierPrefix;
	      this.onRecoverableError = onRecoverableError;
	      {
	        this.mutableSourceEagerHydrationData = null;
	      }
	      {
	        this.effectDuration = 0;
	        this.passiveEffectDuration = 0;
	      }
	      {
	        this.memoizedUpdaters = /* @__PURE__ */ new Set();
	        var pendingUpdatersLaneMap = this.pendingUpdatersLaneMap = [];
	        for (var _i = 0; _i < TotalLanes; _i++) {
	          pendingUpdatersLaneMap.push(/* @__PURE__ */ new Set());
	        }
	      }
	      {
	        switch (tag) {
	          case ConcurrentRoot:
	            this._debugRootType = hydrate2 ? "hydrateRoot()" : "createRoot()";
	            break;
	          case LegacyRoot:
	            this._debugRootType = hydrate2 ? "hydrate()" : "render()";
	            break;
	        }
	      }
	    }
	    function createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
	      var root2 = new FiberRootNode(containerInfo, tag, hydrate2, identifierPrefix, onRecoverableError);
	      var uninitializedFiber = createHostRootFiber(tag, isStrictMode);
	      root2.current = uninitializedFiber;
	      uninitializedFiber.stateNode = root2;
	      {
	        var _initialState = {
	          element: initialChildren,
	          isDehydrated: hydrate2,
	          cache: null,
	          // not enabled yet
	          transitions: null,
	          pendingSuspenseBoundaries: null
	        };
	        uninitializedFiber.memoizedState = _initialState;
	      }
	      initializeUpdateQueue(uninitializedFiber);
	      return root2;
	    }
	    var ReactVersion = "18.2.0";
	    function createPortal(children, containerInfo, implementation) {
	      var key = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
	      {
	        checkKeyStringCoercion(key);
	      }
	      return {
	        // This tag allow us to uniquely identify this as a React Portal
	        $$typeof: REACT_PORTAL_TYPE,
	        key: key == null ? null : "" + key,
	        children,
	        containerInfo,
	        implementation
	      };
	    }
	    var didWarnAboutNestedUpdates;
	    var didWarnAboutFindNodeInStrictMode;
	    {
	      didWarnAboutNestedUpdates = false;
	      didWarnAboutFindNodeInStrictMode = {};
	    }
	    function getContextForSubtree(parentComponent) {
	      if (!parentComponent) {
	        return emptyContextObject;
	      }
	      var fiber = get(parentComponent);
	      var parentContext = findCurrentUnmaskedContext(fiber);
	      if (fiber.tag === ClassComponent) {
	        var Component = fiber.type;
	        if (isContextProvider(Component)) {
	          return processChildContext(fiber, Component, parentContext);
	        }
	      }
	      return parentContext;
	    }
	    function findHostInstanceWithWarning(component, methodName) {
	      {
	        var fiber = get(component);
	        if (fiber === void 0) {
	          if (typeof component.render === "function") {
	            throw new Error("Unable to find node on an unmounted component.");
	          } else {
	            var keys = Object.keys(component).join(",");
	            throw new Error("Argument appears to not be a ReactComponent. Keys: " + keys);
	          }
	        }
	        var hostFiber = findCurrentHostFiber(fiber);
	        if (hostFiber === null) {
	          return null;
	        }
	        if (hostFiber.mode & StrictLegacyMode) {
	          var componentName = getComponentNameFromFiber(fiber) || "Component";
	          if (!didWarnAboutFindNodeInStrictMode[componentName]) {
	            didWarnAboutFindNodeInStrictMode[componentName] = true;
	            var previousFiber = current;
	            try {
	              setCurrentFiber(hostFiber);
	              if (fiber.mode & StrictLegacyMode) {
	                error("%s is deprecated in StrictMode. %s was passed an instance of %s which is inside StrictMode. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-find-node", methodName, methodName, componentName);
	              } else {
	                error("%s is deprecated in StrictMode. %s was passed an instance of %s which renders StrictMode children. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-find-node", methodName, methodName, componentName);
	              }
	            } finally {
	              if (previousFiber) {
	                setCurrentFiber(previousFiber);
	              } else {
	                resetCurrentFiber();
	              }
	            }
	          }
	        }
	        return hostFiber.stateNode;
	      }
	    }
	    function createContainer(containerInfo, tag, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
	      var hydrate2 = false;
	      var initialChildren = null;
	      return createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
	    }
	    function createHydrationContainer(initialChildren, callback, containerInfo, tag, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
	      var hydrate2 = true;
	      var root2 = createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
	      root2.context = getContextForSubtree(null);
	      var current2 = root2.current;
	      var eventTime = requestEventTime();
	      var lane = requestUpdateLane(current2);
	      var update = createUpdate(eventTime, lane);
	      update.callback = callback !== void 0 && callback !== null ? callback : null;
	      enqueueUpdate(current2, update, lane);
	      scheduleInitialHydrationOnRoot(root2, lane, eventTime);
	      return root2;
	    }
	    function updateContainer(element, container, parentComponent, callback) {
	      {
	        onScheduleRoot(container, element);
	      }
	      var current$1 = container.current;
	      var eventTime = requestEventTime();
	      var lane = requestUpdateLane(current$1);
	      {
	        markRenderScheduled(lane);
	      }
	      var context = getContextForSubtree(parentComponent);
	      if (container.context === null) {
	        container.context = context;
	      } else {
	        container.pendingContext = context;
	      }
	      {
	        if (isRendering && current !== null && !didWarnAboutNestedUpdates) {
	          didWarnAboutNestedUpdates = true;
	          error("Render methods should be a pure function of props and state; triggering nested component updates from render is not allowed. If necessary, trigger nested updates in componentDidUpdate.\n\nCheck the render method of %s.", getComponentNameFromFiber(current) || "Unknown");
	        }
	      }
	      var update = createUpdate(eventTime, lane);
	      update.payload = {
	        element
	      };
	      callback = callback === void 0 ? null : callback;
	      if (callback !== null) {
	        {
	          if (typeof callback !== "function") {
	            error("render(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callback);
	          }
	        }
	        update.callback = callback;
	      }
	      var root2 = enqueueUpdate(current$1, update, lane);
	      if (root2 !== null) {
	        scheduleUpdateOnFiber(root2, current$1, lane, eventTime);
	        entangleTransitions(root2, current$1, lane);
	      }
	      return lane;
	    }
	    function getPublicRootInstance(container) {
	      var containerFiber = container.current;
	      if (!containerFiber.child) {
	        return null;
	      }
	      switch (containerFiber.child.tag) {
	        case HostComponent:
	          return getPublicInstance(containerFiber.child.stateNode);
	        default:
	          return containerFiber.child.stateNode;
	      }
	    }
	    function attemptSynchronousHydration$1(fiber) {
	      switch (fiber.tag) {
	        case HostRoot: {
	          var root2 = fiber.stateNode;
	          if (isRootDehydrated(root2)) {
	            var lanes = getHighestPriorityPendingLanes(root2);
	            flushRoot(root2, lanes);
	          }
	          break;
	        }
	        case SuspenseComponent: {
	          flushSync(function() {
	            var root3 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	            if (root3 !== null) {
	              var eventTime = requestEventTime();
	              scheduleUpdateOnFiber(root3, fiber, SyncLane, eventTime);
	            }
	          });
	          var retryLane = SyncLane;
	          markRetryLaneIfNotHydrated(fiber, retryLane);
	          break;
	        }
	      }
	    }
	    function markRetryLaneImpl(fiber, retryLane) {
	      var suspenseState = fiber.memoizedState;
	      if (suspenseState !== null && suspenseState.dehydrated !== null) {
	        suspenseState.retryLane = higherPriorityLane(suspenseState.retryLane, retryLane);
	      }
	    }
	    function markRetryLaneIfNotHydrated(fiber, retryLane) {
	      markRetryLaneImpl(fiber, retryLane);
	      var alternate = fiber.alternate;
	      if (alternate) {
	        markRetryLaneImpl(alternate, retryLane);
	      }
	    }
	    function attemptContinuousHydration$1(fiber) {
	      if (fiber.tag !== SuspenseComponent) {
	        return;
	      }
	      var lane = SelectiveHydrationLane;
	      var root2 = enqueueConcurrentRenderForLane(fiber, lane);
	      if (root2 !== null) {
	        var eventTime = requestEventTime();
	        scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	      }
	      markRetryLaneIfNotHydrated(fiber, lane);
	    }
	    function attemptHydrationAtCurrentPriority$1(fiber) {
	      if (fiber.tag !== SuspenseComponent) {
	        return;
	      }
	      var lane = requestUpdateLane(fiber);
	      var root2 = enqueueConcurrentRenderForLane(fiber, lane);
	      if (root2 !== null) {
	        var eventTime = requestEventTime();
	        scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
	      }
	      markRetryLaneIfNotHydrated(fiber, lane);
	    }
	    function findHostInstanceWithNoPortals(fiber) {
	      var hostFiber = findCurrentHostFiberWithNoPortals(fiber);
	      if (hostFiber === null) {
	        return null;
	      }
	      return hostFiber.stateNode;
	    }
	    var shouldErrorImpl = function(fiber) {
	      return null;
	    };
	    function shouldError(fiber) {
	      return shouldErrorImpl(fiber);
	    }
	    var shouldSuspendImpl = function(fiber) {
	      return false;
	    };
	    function shouldSuspend(fiber) {
	      return shouldSuspendImpl(fiber);
	    }
	    var overrideHookState = null;
	    var overrideHookStateDeletePath = null;
	    var overrideHookStateRenamePath = null;
	    var overrideProps = null;
	    var overridePropsDeletePath = null;
	    var overridePropsRenamePath = null;
	    var scheduleUpdate = null;
	    var setErrorHandler = null;
	    var setSuspenseHandler = null;
	    {
	      var copyWithDeleteImpl = function(obj, path, index2) {
	        var key = path[index2];
	        var updated = isArray(obj) ? obj.slice() : assign({}, obj);
	        if (index2 + 1 === path.length) {
	          if (isArray(updated)) {
	            updated.splice(key, 1);
	          } else {
	            delete updated[key];
	          }
	          return updated;
	        }
	        updated[key] = copyWithDeleteImpl(obj[key], path, index2 + 1);
	        return updated;
	      };
	      var copyWithDelete = function(obj, path) {
	        return copyWithDeleteImpl(obj, path, 0);
	      };
	      var copyWithRenameImpl = function(obj, oldPath, newPath, index2) {
	        var oldKey = oldPath[index2];
	        var updated = isArray(obj) ? obj.slice() : assign({}, obj);
	        if (index2 + 1 === oldPath.length) {
	          var newKey = newPath[index2];
	          updated[newKey] = updated[oldKey];
	          if (isArray(updated)) {
	            updated.splice(oldKey, 1);
	          } else {
	            delete updated[oldKey];
	          }
	        } else {
	          updated[oldKey] = copyWithRenameImpl(
	            // $FlowFixMe number or string is fine here
	            obj[oldKey],
	            oldPath,
	            newPath,
	            index2 + 1
	          );
	        }
	        return updated;
	      };
	      var copyWithRename = function(obj, oldPath, newPath) {
	        if (oldPath.length !== newPath.length) {
	          warn("copyWithRename() expects paths of the same length");
	          return;
	        } else {
	          for (var i = 0; i < newPath.length - 1; i++) {
	            if (oldPath[i] !== newPath[i]) {
	              warn("copyWithRename() expects paths to be the same except for the deepest key");
	              return;
	            }
	          }
	        }
	        return copyWithRenameImpl(obj, oldPath, newPath, 0);
	      };
	      var copyWithSetImpl = function(obj, path, index2, value) {
	        if (index2 >= path.length) {
	          return value;
	        }
	        var key = path[index2];
	        var updated = isArray(obj) ? obj.slice() : assign({}, obj);
	        updated[key] = copyWithSetImpl(obj[key], path, index2 + 1, value);
	        return updated;
	      };
	      var copyWithSet = function(obj, path, value) {
	        return copyWithSetImpl(obj, path, 0, value);
	      };
	      var findHook = function(fiber, id) {
	        var currentHook2 = fiber.memoizedState;
	        while (currentHook2 !== null && id > 0) {
	          currentHook2 = currentHook2.next;
	          id--;
	        }
	        return currentHook2;
	      };
	      overrideHookState = function(fiber, id, path, value) {
	        var hook = findHook(fiber, id);
	        if (hook !== null) {
	          var newState = copyWithSet(hook.memoizedState, path, value);
	          hook.memoizedState = newState;
	          hook.baseState = newState;
	          fiber.memoizedProps = assign({}, fiber.memoizedProps);
	          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	          if (root2 !== null) {
	            scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	          }
	        }
	      };
	      overrideHookStateDeletePath = function(fiber, id, path) {
	        var hook = findHook(fiber, id);
	        if (hook !== null) {
	          var newState = copyWithDelete(hook.memoizedState, path);
	          hook.memoizedState = newState;
	          hook.baseState = newState;
	          fiber.memoizedProps = assign({}, fiber.memoizedProps);
	          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	          if (root2 !== null) {
	            scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	          }
	        }
	      };
	      overrideHookStateRenamePath = function(fiber, id, oldPath, newPath) {
	        var hook = findHook(fiber, id);
	        if (hook !== null) {
	          var newState = copyWithRename(hook.memoizedState, oldPath, newPath);
	          hook.memoizedState = newState;
	          hook.baseState = newState;
	          fiber.memoizedProps = assign({}, fiber.memoizedProps);
	          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	          if (root2 !== null) {
	            scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	          }
	        }
	      };
	      overrideProps = function(fiber, path, value) {
	        fiber.pendingProps = copyWithSet(fiber.memoizedProps, path, value);
	        if (fiber.alternate) {
	          fiber.alternate.pendingProps = fiber.pendingProps;
	        }
	        var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	        }
	      };
	      overridePropsDeletePath = function(fiber, path) {
	        fiber.pendingProps = copyWithDelete(fiber.memoizedProps, path);
	        if (fiber.alternate) {
	          fiber.alternate.pendingProps = fiber.pendingProps;
	        }
	        var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	        }
	      };
	      overridePropsRenamePath = function(fiber, oldPath, newPath) {
	        fiber.pendingProps = copyWithRename(fiber.memoizedProps, oldPath, newPath);
	        if (fiber.alternate) {
	          fiber.alternate.pendingProps = fiber.pendingProps;
	        }
	        var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	        }
	      };
	      scheduleUpdate = function(fiber) {
	        var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
	        if (root2 !== null) {
	          scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
	        }
	      };
	      setErrorHandler = function(newShouldErrorImpl) {
	        shouldErrorImpl = newShouldErrorImpl;
	      };
	      setSuspenseHandler = function(newShouldSuspendImpl) {
	        shouldSuspendImpl = newShouldSuspendImpl;
	      };
	    }
	    function findHostInstanceByFiber(fiber) {
	      var hostFiber = findCurrentHostFiber(fiber);
	      if (hostFiber === null) {
	        return null;
	      }
	      return hostFiber.stateNode;
	    }
	    function emptyFindFiberByHostInstance(instance) {
	      return null;
	    }
	    function getCurrentFiberForDevTools() {
	      return current;
	    }
	    function injectIntoDevTools(devToolsConfig) {
	      var findFiberByHostInstance = devToolsConfig.findFiberByHostInstance;
	      var ReactCurrentDispatcher2 = ReactSharedInternals.ReactCurrentDispatcher;
	      return injectInternals({
	        bundleType: devToolsConfig.bundleType,
	        version: devToolsConfig.version,
	        rendererPackageName: devToolsConfig.rendererPackageName,
	        rendererConfig: devToolsConfig.rendererConfig,
	        overrideHookState,
	        overrideHookStateDeletePath,
	        overrideHookStateRenamePath,
	        overrideProps,
	        overridePropsDeletePath,
	        overridePropsRenamePath,
	        setErrorHandler,
	        setSuspenseHandler,
	        scheduleUpdate,
	        currentDispatcherRef: ReactCurrentDispatcher2,
	        findHostInstanceByFiber,
	        findFiberByHostInstance: findFiberByHostInstance || emptyFindFiberByHostInstance,
	        // React Refresh
	        findHostInstancesForRefresh,
	        scheduleRefresh,
	        scheduleRoot,
	        setRefreshHandler,
	        // Enables DevTools to append owner stacks to error messages in DEV mode.
	        getCurrentFiber: getCurrentFiberForDevTools,
	        // Enables DevTools to detect reconciler version rather than renderer version
	        // which may not match for third party renderers.
	        reconcilerVersion: ReactVersion
	      });
	    }
	    var defaultOnRecoverableError = typeof reportError === "function" ? (
	      // In modern browsers, reportError will dispatch an error event,
	      // emulating an uncaught JavaScript error.
	      reportError
	    ) : function(error2) {
	      console["error"](error2);
	    };
	    function ReactDOMRoot(internalRoot) {
	      this._internalRoot = internalRoot;
	    }
	    ReactDOMHydrationRoot.prototype.render = ReactDOMRoot.prototype.render = function(children) {
	      var root2 = this._internalRoot;
	      if (root2 === null) {
	        throw new Error("Cannot update an unmounted root.");
	      }
	      {
	        if (typeof arguments[1] === "function") {
	          error("render(...): does not support the second callback argument. To execute a side effect after rendering, declare it in a component body with useEffect().");
	        } else if (isValidContainer(arguments[1])) {
	          error("You passed a container to the second argument of root.render(...). You don't need to pass it again since you already passed it to create the root.");
	        } else if (typeof arguments[1] !== "undefined") {
	          error("You passed a second argument to root.render(...) but it only accepts one argument.");
	        }
	        var container = root2.containerInfo;
	        if (container.nodeType !== COMMENT_NODE) {
	          var hostInstance = findHostInstanceWithNoPortals(root2.current);
	          if (hostInstance) {
	            if (hostInstance.parentNode !== container) {
	              error("render(...): It looks like the React-rendered content of the root container was removed without using React. This is not supported and will cause errors. Instead, call root.unmount() to empty a root's container.");
	            }
	          }
	        }
	      }
	      updateContainer(children, root2, null, null);
	    };
	    ReactDOMHydrationRoot.prototype.unmount = ReactDOMRoot.prototype.unmount = function() {
	      {
	        if (typeof arguments[0] === "function") {
	          error("unmount(...): does not support a callback argument. To execute a side effect after rendering, declare it in a component body with useEffect().");
	        }
	      }
	      var root2 = this._internalRoot;
	      if (root2 !== null) {
	        this._internalRoot = null;
	        var container = root2.containerInfo;
	        {
	          if (isAlreadyRendering()) {
	            error("Attempted to synchronously unmount a root while React was already rendering. React cannot finish unmounting the root until the current render has completed, which may lead to a race condition.");
	          }
	        }
	        flushSync(function() {
	          updateContainer(null, root2, null, null);
	        });
	        unmarkContainerAsRoot(container);
	      }
	    };
	    function createRoot(container, options2) {
	      if (!isValidContainer(container)) {
	        throw new Error("createRoot(...): Target container is not a DOM element.");
	      }
	      warnIfReactDOMContainerInDEV(container);
	      var isStrictMode = false;
	      var concurrentUpdatesByDefaultOverride = false;
	      var identifierPrefix = "";
	      var onRecoverableError = defaultOnRecoverableError;
	      if (options2 !== null && options2 !== void 0) {
	        {
	          if (options2.hydrate) {
	            warn("hydrate through createRoot is deprecated. Use ReactDOMClient.hydrateRoot(container, <App />) instead.");
	          } else {
	            if (typeof options2 === "object" && options2 !== null && options2.$$typeof === REACT_ELEMENT_TYPE) {
	              error("You passed a JSX element to createRoot. You probably meant to call root.render instead. Example usage:\n\n  let root = createRoot(domContainer);\n  root.render(<App />);");
	            }
	          }
	        }
	        if (options2.unstable_strictMode === true) {
	          isStrictMode = true;
	        }
	        if (options2.identifierPrefix !== void 0) {
	          identifierPrefix = options2.identifierPrefix;
	        }
	        if (options2.onRecoverableError !== void 0) {
	          onRecoverableError = options2.onRecoverableError;
	        }
	        if (options2.transitionCallbacks !== void 0) {
	          options2.transitionCallbacks;
	        }
	      }
	      var root2 = createContainer(container, ConcurrentRoot, null, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
	      markContainerAsRoot(root2.current, container);
	      var rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
	      listenToAllSupportedEvents(rootContainerElement);
	      return new ReactDOMRoot(root2);
	    }
	    function ReactDOMHydrationRoot(internalRoot) {
	      this._internalRoot = internalRoot;
	    }
	    function scheduleHydration(target) {
	      if (target) {
	        queueExplicitHydrationTarget(target);
	      }
	    }
	    ReactDOMHydrationRoot.prototype.unstable_scheduleHydration = scheduleHydration;
	    function hydrateRoot(container, initialChildren, options2) {
	      if (!isValidContainer(container)) {
	        throw new Error("hydrateRoot(...): Target container is not a DOM element.");
	      }
	      warnIfReactDOMContainerInDEV(container);
	      {
	        if (initialChildren === void 0) {
	          error("Must provide initial children as second argument to hydrateRoot. Example usage: hydrateRoot(domContainer, <App />)");
	        }
	      }
	      var hydrationCallbacks = options2 != null ? options2 : null;
	      var mutableSources = options2 != null && options2.hydratedSources || null;
	      var isStrictMode = false;
	      var concurrentUpdatesByDefaultOverride = false;
	      var identifierPrefix = "";
	      var onRecoverableError = defaultOnRecoverableError;
	      if (options2 !== null && options2 !== void 0) {
	        if (options2.unstable_strictMode === true) {
	          isStrictMode = true;
	        }
	        if (options2.identifierPrefix !== void 0) {
	          identifierPrefix = options2.identifierPrefix;
	        }
	        if (options2.onRecoverableError !== void 0) {
	          onRecoverableError = options2.onRecoverableError;
	        }
	      }
	      var root2 = createHydrationContainer(initialChildren, null, container, ConcurrentRoot, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
	      markContainerAsRoot(root2.current, container);
	      listenToAllSupportedEvents(container);
	      if (mutableSources) {
	        for (var i = 0; i < mutableSources.length; i++) {
	          var mutableSource = mutableSources[i];
	          registerMutableSourceForHydration(root2, mutableSource);
	        }
	      }
	      return new ReactDOMHydrationRoot(root2);
	    }
	    function isValidContainer(node) {
	      return !!(node && (node.nodeType === ELEMENT_NODE || node.nodeType === DOCUMENT_NODE || node.nodeType === DOCUMENT_FRAGMENT_NODE || !disableCommentsAsDOMContainers));
	    }
	    function isValidContainerLegacy(node) {
	      return !!(node && (node.nodeType === ELEMENT_NODE || node.nodeType === DOCUMENT_NODE || node.nodeType === DOCUMENT_FRAGMENT_NODE || node.nodeType === COMMENT_NODE && node.nodeValue === " react-mount-point-unstable "));
	    }
	    function warnIfReactDOMContainerInDEV(container) {
	      {
	        if (container.nodeType === ELEMENT_NODE && container.tagName && container.tagName.toUpperCase() === "BODY") {
	          error("createRoot(): Creating roots directly with document.body is discouraged, since its children are often manipulated by third-party scripts and browser extensions. This may lead to subtle reconciliation issues. Try using a container element created for your app.");
	        }
	        if (isContainerMarkedAsRoot(container)) {
	          if (container._reactRootContainer) {
	            error("You are calling ReactDOMClient.createRoot() on a container that was previously passed to ReactDOM.render(). This is not supported.");
	          } else {
	            error("You are calling ReactDOMClient.createRoot() on a container that has already been passed to createRoot() before. Instead, call root.render() on the existing root instead if you want to update it.");
	          }
	        }
	      }
	    }
	    var ReactCurrentOwner$3 = ReactSharedInternals.ReactCurrentOwner;
	    var topLevelUpdateWarnings;
	    {
	      topLevelUpdateWarnings = function(container) {
	        if (container._reactRootContainer && container.nodeType !== COMMENT_NODE) {
	          var hostInstance = findHostInstanceWithNoPortals(container._reactRootContainer.current);
	          if (hostInstance) {
	            if (hostInstance.parentNode !== container) {
	              error("render(...): It looks like the React-rendered content of this container was removed without using React. This is not supported and will cause errors. Instead, call ReactDOM.unmountComponentAtNode to empty a container.");
	            }
	          }
	        }
	        var isRootRenderedBySomeReact = !!container._reactRootContainer;
	        var rootEl = getReactRootElementInContainer(container);
	        var hasNonRootReactChild = !!(rootEl && getInstanceFromNode(rootEl));
	        if (hasNonRootReactChild && !isRootRenderedBySomeReact) {
	          error("render(...): Replacing React-rendered children with a new root component. If you intended to update the children of this node, you should instead have the existing children update their state and render the new components instead of calling ReactDOM.render.");
	        }
	        if (container.nodeType === ELEMENT_NODE && container.tagName && container.tagName.toUpperCase() === "BODY") {
	          error("render(): Rendering components directly into document.body is discouraged, since its children are often manipulated by third-party scripts and browser extensions. This may lead to subtle reconciliation issues. Try rendering into a container element created for your app.");
	        }
	      };
	    }
	    function getReactRootElementInContainer(container) {
	      if (!container) {
	        return null;
	      }
	      if (container.nodeType === DOCUMENT_NODE) {
	        return container.documentElement;
	      } else {
	        return container.firstChild;
	      }
	    }
	    function noopOnRecoverableError() {
	    }
	    function legacyCreateRootFromDOMContainer(container, initialChildren, parentComponent, callback, isHydrationContainer) {
	      if (isHydrationContainer) {
	        if (typeof callback === "function") {
	          var originalCallback = callback;
	          callback = function() {
	            var instance = getPublicRootInstance(root2);
	            originalCallback.call(instance);
	          };
	        }
	        var root2 = createHydrationContainer(
	          initialChildren,
	          callback,
	          container,
	          LegacyRoot,
	          null,
	          // hydrationCallbacks
	          false,
	          // isStrictMode
	          false,
	          // concurrentUpdatesByDefaultOverride,
	          "",
	          // identifierPrefix
	          noopOnRecoverableError
	        );
	        container._reactRootContainer = root2;
	        markContainerAsRoot(root2.current, container);
	        var rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
	        listenToAllSupportedEvents(rootContainerElement);
	        flushSync();
	        return root2;
	      } else {
	        var rootSibling;
	        while (rootSibling = container.lastChild) {
	          container.removeChild(rootSibling);
	        }
	        if (typeof callback === "function") {
	          var _originalCallback = callback;
	          callback = function() {
	            var instance = getPublicRootInstance(_root);
	            _originalCallback.call(instance);
	          };
	        }
	        var _root = createContainer(
	          container,
	          LegacyRoot,
	          null,
	          // hydrationCallbacks
	          false,
	          // isStrictMode
	          false,
	          // concurrentUpdatesByDefaultOverride,
	          "",
	          // identifierPrefix
	          noopOnRecoverableError
	        );
	        container._reactRootContainer = _root;
	        markContainerAsRoot(_root.current, container);
	        var _rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
	        listenToAllSupportedEvents(_rootContainerElement);
	        flushSync(function() {
	          updateContainer(initialChildren, _root, parentComponent, callback);
	        });
	        return _root;
	      }
	    }
	    function warnOnInvalidCallback$1(callback, callerName) {
	      {
	        if (callback !== null && typeof callback !== "function") {
	          error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback);
	        }
	      }
	    }
	    function legacyRenderSubtreeIntoContainer(parentComponent, children, container, forceHydrate, callback) {
	      {
	        topLevelUpdateWarnings(container);
	        warnOnInvalidCallback$1(callback === void 0 ? null : callback, "render");
	      }
	      var maybeRoot = container._reactRootContainer;
	      var root2;
	      if (!maybeRoot) {
	        root2 = legacyCreateRootFromDOMContainer(container, children, parentComponent, callback, forceHydrate);
	      } else {
	        root2 = maybeRoot;
	        if (typeof callback === "function") {
	          var originalCallback = callback;
	          callback = function() {
	            var instance = getPublicRootInstance(root2);
	            originalCallback.call(instance);
	          };
	        }
	        updateContainer(children, root2, parentComponent, callback);
	      }
	      return getPublicRootInstance(root2);
	    }
	    function findDOMNode(componentOrElement) {
	      {
	        var owner = ReactCurrentOwner$3.current;
	        if (owner !== null && owner.stateNode !== null) {
	          var warnedAboutRefsInRender = owner.stateNode._warnedAboutRefsInRender;
	          if (!warnedAboutRefsInRender) {
	            error("%s is accessing findDOMNode inside its render(). render() should be a pure function of props and state. It should never access something that requires stale data from the previous render, such as refs. Move this logic to componentDidMount and componentDidUpdate instead.", getComponentNameFromType(owner.type) || "A component");
	          }
	          owner.stateNode._warnedAboutRefsInRender = true;
	        }
	      }
	      if (componentOrElement == null) {
	        return null;
	      }
	      if (componentOrElement.nodeType === ELEMENT_NODE) {
	        return componentOrElement;
	      }
	      {
	        return findHostInstanceWithWarning(componentOrElement, "findDOMNode");
	      }
	    }
	    function hydrate(element, container, callback) {
	      {
	        error("ReactDOM.hydrate is no longer supported in React 18. Use hydrateRoot instead. Until you switch to the new API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot");
	      }
	      if (!isValidContainerLegacy(container)) {
	        throw new Error("Target container is not a DOM element.");
	      }
	      {
	        var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
	        if (isModernRoot) {
	          error("You are calling ReactDOM.hydrate() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call hydrateRoot(container, element)?");
	        }
	      }
	      return legacyRenderSubtreeIntoContainer(null, element, container, true, callback);
	    }
	    function render(element, container, callback) {
	      {
	        error("ReactDOM.render is no longer supported in React 18. Use createRoot instead. Until you switch to the new API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot");
	      }
	      if (!isValidContainerLegacy(container)) {
	        throw new Error("Target container is not a DOM element.");
	      }
	      {
	        var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
	        if (isModernRoot) {
	          error("You are calling ReactDOM.render() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call root.render(element)?");
	        }
	      }
	      return legacyRenderSubtreeIntoContainer(null, element, container, false, callback);
	    }
	    function unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {
	      {
	        error("ReactDOM.unstable_renderSubtreeIntoContainer() is no longer supported in React 18. Consider using a portal instead. Until you switch to the createRoot API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot");
	      }
	      if (!isValidContainerLegacy(containerNode)) {
	        throw new Error("Target container is not a DOM element.");
	      }
	      if (parentComponent == null || !has(parentComponent)) {
	        throw new Error("parentComponent must be a valid React Component");
	      }
	      return legacyRenderSubtreeIntoContainer(parentComponent, element, containerNode, false, callback);
	    }
	    function unmountComponentAtNode(container) {
	      if (!isValidContainerLegacy(container)) {
	        throw new Error("unmountComponentAtNode(...): Target container is not a DOM element.");
	      }
	      {
	        var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
	        if (isModernRoot) {
	          error("You are calling ReactDOM.unmountComponentAtNode() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call root.unmount()?");
	        }
	      }
	      if (container._reactRootContainer) {
	        {
	          var rootEl = getReactRootElementInContainer(container);
	          var renderedByDifferentReact = rootEl && !getInstanceFromNode(rootEl);
	          if (renderedByDifferentReact) {
	            error("unmountComponentAtNode(): The node you're attempting to unmount was rendered by another copy of React.");
	          }
	        }
	        flushSync(function() {
	          legacyRenderSubtreeIntoContainer(null, null, container, false, function() {
	            container._reactRootContainer = null;
	            unmarkContainerAsRoot(container);
	          });
	        });
	        return true;
	      } else {
	        {
	          var _rootEl = getReactRootElementInContainer(container);
	          var hasNonRootReactChild = !!(_rootEl && getInstanceFromNode(_rootEl));
	          var isContainerReactRoot = container.nodeType === ELEMENT_NODE && isValidContainerLegacy(container.parentNode) && !!container.parentNode._reactRootContainer;
	          if (hasNonRootReactChild) {
	            error("unmountComponentAtNode(): The node you're attempting to unmount was rendered by React and is not a top-level container. %s", isContainerReactRoot ? "You may have accidentally passed in a React root node instead of its container." : "Instead, have the parent component update its state and rerender in order to remove this component.");
	          }
	        }
	        return false;
	      }
	    }
	    setAttemptSynchronousHydration(attemptSynchronousHydration$1);
	    setAttemptContinuousHydration(attemptContinuousHydration$1);
	    setAttemptHydrationAtCurrentPriority(attemptHydrationAtCurrentPriority$1);
	    setGetCurrentUpdatePriority(getCurrentUpdatePriority);
	    setAttemptHydrationAtPriority(runWithPriority);
	    {
	      if (typeof Map !== "function" || // $FlowIssue Flow incorrectly thinks Map has no prototype
	      Map.prototype == null || typeof Map.prototype.forEach !== "function" || typeof Set !== "function" || // $FlowIssue Flow incorrectly thinks Set has no prototype
	      Set.prototype == null || typeof Set.prototype.clear !== "function" || typeof Set.prototype.forEach !== "function") {
	        error("React depends on Map and Set built-in types. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");
	      }
	    }
	    setRestoreImplementation(restoreControlledState$3);
	    setBatchingImplementation(batchedUpdates$1, discreteUpdates, flushSync);
	    function createPortal$1(children, container) {
	      var key = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
	      if (!isValidContainer(container)) {
	        throw new Error("Target container is not a DOM element.");
	      }
	      return createPortal(children, container, null, key);
	    }
	    function renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {
	      return unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback);
	    }
	    var Internals = {
	      usingClientEntryPoint: false,
	      // Keep in sync with ReactTestUtils.js.
	      // This is an array for better minification.
	      Events: [getInstanceFromNode, getNodeFromInstance, getFiberCurrentPropsFromNode, enqueueStateRestore, restoreStateIfNeeded, batchedUpdates$1]
	    };
	    function createRoot$1(container, options2) {
	      {
	        if (!Internals.usingClientEntryPoint && true) {
	          error('You are importing createRoot from "react-dom" which is not supported. You should instead import it from "react-dom/client".');
	        }
	      }
	      return createRoot(container, options2);
	    }
	    function hydrateRoot$1(container, initialChildren, options2) {
	      {
	        if (!Internals.usingClientEntryPoint && true) {
	          error('You are importing hydrateRoot from "react-dom" which is not supported. You should instead import it from "react-dom/client".');
	        }
	      }
	      return hydrateRoot(container, initialChildren, options2);
	    }
	    function flushSync$1(fn) {
	      {
	        if (isAlreadyRendering()) {
	          error("flushSync was called from inside a lifecycle method. React cannot flush when React is already rendering. Consider moving this call to a scheduler task or micro task.");
	        }
	      }
	      return flushSync(fn);
	    }
	    var foundDevTools = injectIntoDevTools({
	      findFiberByHostInstance: getClosestInstanceFromNode,
	      bundleType: 1,
	      version: ReactVersion,
	      rendererPackageName: "react-dom"
	    });
	    {
	      if (!foundDevTools && canUseDOM && window.top === window.self) {
	        if (navigator.userAgent.indexOf("Chrome") > -1 && navigator.userAgent.indexOf("Edge") === -1 || navigator.userAgent.indexOf("Firefox") > -1) {
	          var protocol = window.location.protocol;
	          if (/^(https?|file):$/.test(protocol)) {
	            console.info("%cDownload the React DevTools for a better development experience: https://reactjs.org/link/react-devtools" + (protocol === "file:" ? "\nYou might need to use a local HTTP server (instead of file://): https://reactjs.org/link/react-devtools-faq" : ""), "font-weight:bold");
	          }
	        }
	      }
	    }
	    reactDom_development.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = Internals;
	    reactDom_development.createPortal = createPortal$1;
	    reactDom_development.createRoot = createRoot$1;
	    reactDom_development.findDOMNode = findDOMNode;
	    reactDom_development.flushSync = flushSync$1;
	    reactDom_development.hydrate = hydrate;
	    reactDom_development.hydrateRoot = hydrateRoot$1;
	    reactDom_development.render = render;
	    reactDom_development.unmountComponentAtNode = unmountComponentAtNode;
	    reactDom_development.unstable_batchedUpdates = batchedUpdates$1;
	    reactDom_development.unstable_renderSubtreeIntoContainer = renderSubtreeIntoContainer;
	    reactDom_development.version = ReactVersion;
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
	    }
	  })();
	}
	return reactDom_development;
}

var reactDom_production_min = {};

/**
 * @license React
 * react-dom.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReactDom_production_min;

function requireReactDom_production_min () {
	if (hasRequiredReactDom_production_min) return reactDom_production_min;
	hasRequiredReactDom_production_min = 1;
var aa=reactExports,ca=requireScheduler();function p(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return "Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var da=new Set,ea={};function fa(a,b){ha(a,b);ha(a+"Capture",b);}
	function ha(a,b){ea[a]=b;for(a=0;a<b.length;a++)da.add(b[a]);}
	var ia=!("undefined"===typeof window||"undefined"===typeof window.document||"undefined"===typeof window.document.createElement),ja=Object.prototype.hasOwnProperty,ka=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,la=
	{},ma={};function oa(a){if(ja.call(ma,a))return !0;if(ja.call(la,a))return !1;if(ka.test(a))return ma[a]=!0;la[a]=!0;return !1}function pa(a,b,c,d){if(null!==c&&0===c.type)return !1;switch(typeof b){case "function":case "symbol":return !0;case "boolean":if(d)return !1;if(null!==c)return !c.acceptsBooleans;a=a.toLowerCase().slice(0,5);return "data-"!==a&&"aria-"!==a;default:return !1}}
	function qa(a,b,c,d){if(null===b||"undefined"===typeof b||pa(a,b,c,d))return !0;if(d)return !1;if(null!==c)switch(c.type){case 3:return !b;case 4:return !1===b;case 5:return isNaN(b);case 6:return isNaN(b)||1>b}return !1}function v(a,b,c,d,e,f,g){this.acceptsBooleans=2===b||3===b||4===b;this.attributeName=d;this.attributeNamespace=e;this.mustUseProperty=c;this.propertyName=a;this.type=b;this.sanitizeURL=f;this.removeEmptyString=g;}var z={};
	"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a){z[a]=new v(a,0,!1,a,null,!1,!1);});[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach(function(a){var b=a[0];z[b]=new v(b,1,!1,a[1],null,!1,!1);});["contentEditable","draggable","spellCheck","value"].forEach(function(a){z[a]=new v(a,2,!1,a.toLowerCase(),null,!1,!1);});
	["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach(function(a){z[a]=new v(a,2,!1,a,null,!1,!1);});"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a){z[a]=new v(a,3,!1,a.toLowerCase(),null,!1,!1);});
	["checked","multiple","muted","selected"].forEach(function(a){z[a]=new v(a,3,!0,a,null,!1,!1);});["capture","download"].forEach(function(a){z[a]=new v(a,4,!1,a,null,!1,!1);});["cols","rows","size","span"].forEach(function(a){z[a]=new v(a,6,!1,a,null,!1,!1);});["rowSpan","start"].forEach(function(a){z[a]=new v(a,5,!1,a.toLowerCase(),null,!1,!1);});var ra=/[\-:]([a-z])/g;function sa(a){return a[1].toUpperCase()}
	"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a){var b=a.replace(ra,
	sa);z[b]=new v(b,1,!1,a,null,!1,!1);});"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a){var b=a.replace(ra,sa);z[b]=new v(b,1,!1,a,"http://www.w3.org/1999/xlink",!1,!1);});["xml:base","xml:lang","xml:space"].forEach(function(a){var b=a.replace(ra,sa);z[b]=new v(b,1,!1,a,"http://www.w3.org/XML/1998/namespace",!1,!1);});["tabIndex","crossOrigin"].forEach(function(a){z[a]=new v(a,1,!1,a.toLowerCase(),null,!1,!1);});
	z.xlinkHref=new v("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1);["src","href","action","formAction"].forEach(function(a){z[a]=new v(a,1,!1,a.toLowerCase(),null,!0,!0);});
	function ta(a,b,c,d){var e=z.hasOwnProperty(b)?z[b]:null;if(null!==e?0!==e.type:d||!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1])qa(b,c,e,d)&&(c=null),d||null===e?oa(b)&&(null===c?a.removeAttribute(b):a.setAttribute(b,""+c)):e.mustUseProperty?a[e.propertyName]=null===c?3===e.type?!1:"":c:(b=e.attributeName,d=e.attributeNamespace,null===c?a.removeAttribute(b):(e=e.type,c=3===e||4===e&&!0===c?"":""+c,d?a.setAttributeNS(d,b,c):a.setAttribute(b,c)));}
	var ua=aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,va=Symbol.for("react.element"),wa=Symbol.for("react.portal"),ya=Symbol.for("react.fragment"),za=Symbol.for("react.strict_mode"),Aa=Symbol.for("react.profiler"),Ba=Symbol.for("react.provider"),Ca=Symbol.for("react.context"),Da=Symbol.for("react.forward_ref"),Ea=Symbol.for("react.suspense"),Fa=Symbol.for("react.suspense_list"),Ga=Symbol.for("react.memo"),Ha=Symbol.for("react.lazy");	var Ia=Symbol.for("react.offscreen");var Ja=Symbol.iterator;function Ka(a){if(null===a||"object"!==typeof a)return null;a=Ja&&a[Ja]||a["@@iterator"];return "function"===typeof a?a:null}var A=Object.assign,La;function Ma(a){if(void 0===La)try{throw Error();}catch(c){var b=c.stack.trim().match(/\n( *(at )?)/);La=b&&b[1]||"";}return "\n"+La+a}var Na=!1;
	function Oa(a,b){if(!a||Na)return "";Na=!0;var c=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(b)if(b=function(){throw Error();},Object.defineProperty(b.prototype,"props",{set:function(){throw Error();}}),"object"===typeof Reflect&&Reflect.construct){try{Reflect.construct(b,[]);}catch(l){var d=l;}Reflect.construct(a,[],b);}else {try{b.call();}catch(l){d=l;}a.call(b.prototype);}else {try{throw Error();}catch(l){d=l;}a();}}catch(l){if(l&&d&&"string"===typeof l.stack){for(var e=l.stack.split("\n"),
	f=d.stack.split("\n"),g=e.length-1,h=f.length-1;1<=g&&0<=h&&e[g]!==f[h];)h--;for(;1<=g&&0<=h;g--,h--)if(e[g]!==f[h]){if(1!==g||1!==h){do if(g--,h--,0>h||e[g]!==f[h]){var k="\n"+e[g].replace(" at new "," at ");a.displayName&&k.includes("<anonymous>")&&(k=k.replace("<anonymous>",a.displayName));return k}while(1<=g&&0<=h)}break}}}finally{Na=!1,Error.prepareStackTrace=c;}return (a=a?a.displayName||a.name:"")?Ma(a):""}
	function Pa(a){switch(a.tag){case 5:return Ma(a.type);case 16:return Ma("Lazy");case 13:return Ma("Suspense");case 19:return Ma("SuspenseList");case 0:case 2:case 15:return a=Oa(a.type,!1),a;case 11:return a=Oa(a.type.render,!1),a;case 1:return a=Oa(a.type,!0),a;default:return ""}}
	function Qa(a){if(null==a)return null;if("function"===typeof a)return a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case ya:return "Fragment";case wa:return "Portal";case Aa:return "Profiler";case za:return "StrictMode";case Ea:return "Suspense";case Fa:return "SuspenseList"}if("object"===typeof a)switch(a.$$typeof){case Ca:return (a.displayName||"Context")+".Consumer";case Ba:return (a._context.displayName||"Context")+".Provider";case Da:var b=a.render;a=a.displayName;a||(a=b.displayName||
	b.name||"",a=""!==a?"ForwardRef("+a+")":"ForwardRef");return a;case Ga:return b=a.displayName||null,null!==b?b:Qa(a.type)||"Memo";case Ha:b=a._payload;a=a._init;try{return Qa(a(b))}catch(c){}}return null}
	function Ra(a){var b=a.type;switch(a.tag){case 24:return "Cache";case 9:return (b.displayName||"Context")+".Consumer";case 10:return (b._context.displayName||"Context")+".Provider";case 18:return "DehydratedFragment";case 11:return a=b.render,a=a.displayName||a.name||"",b.displayName||(""!==a?"ForwardRef("+a+")":"ForwardRef");case 7:return "Fragment";case 5:return b;case 4:return "Portal";case 3:return "Root";case 6:return "Text";case 16:return Qa(b);case 8:return b===za?"StrictMode":"Mode";case 22:return "Offscreen";
	case 12:return "Profiler";case 21:return "Scope";case 13:return "Suspense";case 19:return "SuspenseList";case 25:return "TracingMarker";case 1:case 0:case 17:case 2:case 14:case 15:if("function"===typeof b)return b.displayName||b.name||null;if("string"===typeof b)return b}return null}function Sa(a){switch(typeof a){case "boolean":case "number":case "string":case "undefined":return a;case "object":return a;default:return ""}}
	function Ta(a){var b=a.type;return (a=a.nodeName)&&"input"===a.toLowerCase()&&("checkbox"===b||"radio"===b)}
	function Ua(a){var b=Ta(a)?"checked":"value",c=Object.getOwnPropertyDescriptor(a.constructor.prototype,b),d=""+a[b];if(!a.hasOwnProperty(b)&&"undefined"!==typeof c&&"function"===typeof c.get&&"function"===typeof c.set){var e=c.get,f=c.set;Object.defineProperty(a,b,{configurable:!0,get:function(){return e.call(this)},set:function(a){d=""+a;f.call(this,a);}});Object.defineProperty(a,b,{enumerable:c.enumerable});return {getValue:function(){return d},setValue:function(a){d=""+a;},stopTracking:function(){a._valueTracker=
	null;delete a[b];}}}}function Va(a){a._valueTracker||(a._valueTracker=Ua(a));}function Wa(a){if(!a)return !1;var b=a._valueTracker;if(!b)return !0;var c=b.getValue();var d="";a&&(d=Ta(a)?a.checked?"true":"false":a.value);a=d;return a!==c?(b.setValue(a),!0):!1}function Xa(a){a=a||("undefined"!==typeof document?document:void 0);if("undefined"===typeof a)return null;try{return a.activeElement||a.body}catch(b){return a.body}}
	function Ya(a,b){var c=b.checked;return A({},b,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=c?c:a._wrapperState.initialChecked})}function Za(a,b){var c=null==b.defaultValue?"":b.defaultValue,d=null!=b.checked?b.checked:b.defaultChecked;c=Sa(null!=b.value?b.value:c);a._wrapperState={initialChecked:d,initialValue:c,controlled:"checkbox"===b.type||"radio"===b.type?null!=b.checked:null!=b.value};}function ab(a,b){b=b.checked;null!=b&&ta(a,"checked",b,!1);}
	function bb(a,b){ab(a,b);var c=Sa(b.value),d=b.type;if(null!=c)if("number"===d){if(0===c&&""===a.value||a.value!=c)a.value=""+c;}else a.value!==""+c&&(a.value=""+c);else if("submit"===d||"reset"===d){a.removeAttribute("value");return}b.hasOwnProperty("value")?cb(a,b.type,c):b.hasOwnProperty("defaultValue")&&cb(a,b.type,Sa(b.defaultValue));null==b.checked&&null!=b.defaultChecked&&(a.defaultChecked=!!b.defaultChecked);}
	function db(a,b,c){if(b.hasOwnProperty("value")||b.hasOwnProperty("defaultValue")){var d=b.type;if(!("submit"!==d&&"reset"!==d||void 0!==b.value&&null!==b.value))return;b=""+a._wrapperState.initialValue;c||b===a.value||(a.value=b);a.defaultValue=b;}c=a.name;""!==c&&(a.name="");a.defaultChecked=!!a._wrapperState.initialChecked;""!==c&&(a.name=c);}
	function cb(a,b,c){if("number"!==b||Xa(a.ownerDocument)!==a)null==c?a.defaultValue=""+a._wrapperState.initialValue:a.defaultValue!==""+c&&(a.defaultValue=""+c);}var eb=Array.isArray;
	function fb(a,b,c,d){a=a.options;if(b){b={};for(var e=0;e<c.length;e++)b["$"+c[e]]=!0;for(c=0;c<a.length;c++)e=b.hasOwnProperty("$"+a[c].value),a[c].selected!==e&&(a[c].selected=e),e&&d&&(a[c].defaultSelected=!0);}else {c=""+Sa(c);b=null;for(e=0;e<a.length;e++){if(a[e].value===c){a[e].selected=!0;d&&(a[e].defaultSelected=!0);return}null!==b||a[e].disabled||(b=a[e]);}null!==b&&(b.selected=!0);}}
	function gb(a,b){if(null!=b.dangerouslySetInnerHTML)throw Error(p(91));return A({},b,{value:void 0,defaultValue:void 0,children:""+a._wrapperState.initialValue})}function hb(a,b){var c=b.value;if(null==c){c=b.children;b=b.defaultValue;if(null!=c){if(null!=b)throw Error(p(92));if(eb(c)){if(1<c.length)throw Error(p(93));c=c[0];}b=c;}null==b&&(b="");c=b;}a._wrapperState={initialValue:Sa(c)};}
	function ib(a,b){var c=Sa(b.value),d=Sa(b.defaultValue);null!=c&&(c=""+c,c!==a.value&&(a.value=c),null==b.defaultValue&&a.defaultValue!==c&&(a.defaultValue=c));null!=d&&(a.defaultValue=""+d);}function jb(a){var b=a.textContent;b===a._wrapperState.initialValue&&""!==b&&null!==b&&(a.value=b);}function kb(a){switch(a){case "svg":return "http://www.w3.org/2000/svg";case "math":return "http://www.w3.org/1998/Math/MathML";default:return "http://www.w3.org/1999/xhtml"}}
	function lb(a,b){return null==a||"http://www.w3.org/1999/xhtml"===a?kb(b):"http://www.w3.org/2000/svg"===a&&"foreignObject"===b?"http://www.w3.org/1999/xhtml":a}
	var mb,nb=function(a){return "undefined"!==typeof MSApp&&MSApp.execUnsafeLocalFunction?function(b,c,d,e){MSApp.execUnsafeLocalFunction(function(){return a(b,c,d,e)});}:a}(function(a,b){if("http://www.w3.org/2000/svg"!==a.namespaceURI||"innerHTML"in a)a.innerHTML=b;else {mb=mb||document.createElement("div");mb.innerHTML="<svg>"+b.valueOf().toString()+"</svg>";for(b=mb.firstChild;a.firstChild;)a.removeChild(a.firstChild);for(;b.firstChild;)a.appendChild(b.firstChild);}});
	function ob(a,b){if(b){var c=a.firstChild;if(c&&c===a.lastChild&&3===c.nodeType){c.nodeValue=b;return}}a.textContent=b;}
	var pb={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,
	zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},qb=["Webkit","ms","Moz","O"];Object.keys(pb).forEach(function(a){qb.forEach(function(b){b=b+a.charAt(0).toUpperCase()+a.substring(1);pb[b]=pb[a];});});function rb(a,b,c){return null==b||"boolean"===typeof b||""===b?"":c||"number"!==typeof b||0===b||pb.hasOwnProperty(a)&&pb[a]?(""+b).trim():b+"px"}
	function sb(a,b){a=a.style;for(var c in b)if(b.hasOwnProperty(c)){var d=0===c.indexOf("--"),e=rb(c,b[c],d);"float"===c&&(c="cssFloat");d?a.setProperty(c,e):a[c]=e;}}var tb=A({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});
	function ub(a,b){if(b){if(tb[a]&&(null!=b.children||null!=b.dangerouslySetInnerHTML))throw Error(p(137,a));if(null!=b.dangerouslySetInnerHTML){if(null!=b.children)throw Error(p(60));if("object"!==typeof b.dangerouslySetInnerHTML||!("__html"in b.dangerouslySetInnerHTML))throw Error(p(61));}if(null!=b.style&&"object"!==typeof b.style)throw Error(p(62));}}
	function vb(a,b){if(-1===a.indexOf("-"))return "string"===typeof b.is;switch(a){case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":return !1;default:return !0}}var wb=null;function xb(a){a=a.target||a.srcElement||window;a.correspondingUseElement&&(a=a.correspondingUseElement);return 3===a.nodeType?a.parentNode:a}var yb=null,zb=null,Ab=null;
	function Bb(a){if(a=Cb(a)){if("function"!==typeof yb)throw Error(p(280));var b=a.stateNode;b&&(b=Db(b),yb(a.stateNode,a.type,b));}}function Eb(a){zb?Ab?Ab.push(a):Ab=[a]:zb=a;}function Fb(){if(zb){var a=zb,b=Ab;Ab=zb=null;Bb(a);if(b)for(a=0;a<b.length;a++)Bb(b[a]);}}function Gb(a,b){return a(b)}function Hb(){}var Ib=!1;function Jb(a,b,c){if(Ib)return a(b,c);Ib=!0;try{return Gb(a,b,c)}finally{if(Ib=!1,null!==zb||null!==Ab)Hb(),Fb();}}
	function Kb(a,b){var c=a.stateNode;if(null===c)return null;var d=Db(c);if(null===d)return null;c=d[b];a:switch(b){case "onClick":case "onClickCapture":case "onDoubleClick":case "onDoubleClickCapture":case "onMouseDown":case "onMouseDownCapture":case "onMouseMove":case "onMouseMoveCapture":case "onMouseUp":case "onMouseUpCapture":case "onMouseEnter":(d=!d.disabled)||(a=a.type,d=!("button"===a||"input"===a||"select"===a||"textarea"===a));a=!d;break a;default:a=!1;}if(a)return null;if(c&&"function"!==
	typeof c)throw Error(p(231,b,typeof c));return c}var Lb=!1;if(ia)try{var Mb={};Object.defineProperty(Mb,"passive",{get:function(){Lb=!0;}});window.addEventListener("test",Mb,Mb);window.removeEventListener("test",Mb,Mb);}catch(a){Lb=!1;}function Nb(a,b,c,d,e,f,g,h,k){var l=Array.prototype.slice.call(arguments,3);try{b.apply(c,l);}catch(m){this.onError(m);}}var Ob=!1,Pb=null,Qb=!1,Rb=null,Sb={onError:function(a){Ob=!0;Pb=a;}};function Tb(a,b,c,d,e,f,g,h,k){Ob=!1;Pb=null;Nb.apply(Sb,arguments);}
	function Ub(a,b,c,d,e,f,g,h,k){Tb.apply(this,arguments);if(Ob){if(Ob){var l=Pb;Ob=!1;Pb=null;}else throw Error(p(198));Qb||(Qb=!0,Rb=l);}}function Vb(a){var b=a,c=a;if(a.alternate)for(;b.return;)b=b.return;else {a=b;do b=a,0!==(b.flags&4098)&&(c=b.return),a=b.return;while(a)}return 3===b.tag?c:null}function Wb(a){if(13===a.tag){var b=a.memoizedState;null===b&&(a=a.alternate,null!==a&&(b=a.memoizedState));if(null!==b)return b.dehydrated}return null}function Xb(a){if(Vb(a)!==a)throw Error(p(188));}
	function Yb(a){var b=a.alternate;if(!b){b=Vb(a);if(null===b)throw Error(p(188));return b!==a?null:a}for(var c=a,d=b;;){var e=c.return;if(null===e)break;var f=e.alternate;if(null===f){d=e.return;if(null!==d){c=d;continue}break}if(e.child===f.child){for(f=e.child;f;){if(f===c)return Xb(e),a;if(f===d)return Xb(e),b;f=f.sibling;}throw Error(p(188));}if(c.return!==d.return)c=e,d=f;else {for(var g=!1,h=e.child;h;){if(h===c){g=!0;c=e;d=f;break}if(h===d){g=!0;d=e;c=f;break}h=h.sibling;}if(!g){for(h=f.child;h;){if(h===
	c){g=!0;c=f;d=e;break}if(h===d){g=!0;d=f;c=e;break}h=h.sibling;}if(!g)throw Error(p(189));}}if(c.alternate!==d)throw Error(p(190));}if(3!==c.tag)throw Error(p(188));return c.stateNode.current===c?a:b}function Zb(a){a=Yb(a);return null!==a?$b(a):null}function $b(a){if(5===a.tag||6===a.tag)return a;for(a=a.child;null!==a;){var b=$b(a);if(null!==b)return b;a=a.sibling;}return null}
	var ac=ca.unstable_scheduleCallback,bc=ca.unstable_cancelCallback,cc=ca.unstable_shouldYield,dc=ca.unstable_requestPaint,B=ca.unstable_now,ec=ca.unstable_getCurrentPriorityLevel,fc=ca.unstable_ImmediatePriority,gc=ca.unstable_UserBlockingPriority,hc=ca.unstable_NormalPriority,ic=ca.unstable_LowPriority,jc=ca.unstable_IdlePriority,kc=null,lc=null;function mc(a){if(lc&&"function"===typeof lc.onCommitFiberRoot)try{lc.onCommitFiberRoot(kc,a,void 0,128===(a.current.flags&128));}catch(b){}}
	var oc=Math.clz32?Math.clz32:nc,pc=Math.log,qc=Math.LN2;function nc(a){a>>>=0;return 0===a?32:31-(pc(a)/qc|0)|0}var rc=64,sc=4194304;
	function tc(a){switch(a&-a){case 1:return 1;case 2:return 2;case 4:return 4;case 8:return 8;case 16:return 16;case 32:return 32;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return a&4194240;case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:return a&130023424;case 134217728:return 134217728;case 268435456:return 268435456;case 536870912:return 536870912;case 1073741824:return 1073741824;
	default:return a}}function uc(a,b){var c=a.pendingLanes;if(0===c)return 0;var d=0,e=a.suspendedLanes,f=a.pingedLanes,g=c&268435455;if(0!==g){var h=g&~e;0!==h?d=tc(h):(f&=g,0!==f&&(d=tc(f)));}else g=c&~e,0!==g?d=tc(g):0!==f&&(d=tc(f));if(0===d)return 0;if(0!==b&&b!==d&&0===(b&e)&&(e=d&-d,f=b&-b,e>=f||16===e&&0!==(f&4194240)))return b;0!==(d&4)&&(d|=c&16);b=a.entangledLanes;if(0!==b)for(a=a.entanglements,b&=d;0<b;)c=31-oc(b),e=1<<c,d|=a[c],b&=~e;return d}
	function vc(a,b){switch(a){case 1:case 2:case 4:return b+250;case 8:case 16:case 32:case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return b+5E3;case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:return -1;case 134217728:case 268435456:case 536870912:case 1073741824:return -1;default:return -1}}
	function wc(a,b){for(var c=a.suspendedLanes,d=a.pingedLanes,e=a.expirationTimes,f=a.pendingLanes;0<f;){var g=31-oc(f),h=1<<g,k=e[g];if(-1===k){if(0===(h&c)||0!==(h&d))e[g]=vc(h,b);}else k<=b&&(a.expiredLanes|=h);f&=~h;}}function xc(a){a=a.pendingLanes&-1073741825;return 0!==a?a:a&1073741824?1073741824:0}function yc(){var a=rc;rc<<=1;0===(rc&4194240)&&(rc=64);return a}function zc(a){for(var b=[],c=0;31>c;c++)b.push(a);return b}
	function Ac(a,b,c){a.pendingLanes|=b;536870912!==b&&(a.suspendedLanes=0,a.pingedLanes=0);a=a.eventTimes;b=31-oc(b);a[b]=c;}function Bc(a,b){var c=a.pendingLanes&~b;a.pendingLanes=b;a.suspendedLanes=0;a.pingedLanes=0;a.expiredLanes&=b;a.mutableReadLanes&=b;a.entangledLanes&=b;b=a.entanglements;var d=a.eventTimes;for(a=a.expirationTimes;0<c;){var e=31-oc(c),f=1<<e;b[e]=0;d[e]=-1;a[e]=-1;c&=~f;}}
	function Cc(a,b){var c=a.entangledLanes|=b;for(a=a.entanglements;c;){var d=31-oc(c),e=1<<d;e&b|a[d]&b&&(a[d]|=b);c&=~e;}}var C=0;function Dc(a){a&=-a;return 1<a?4<a?0!==(a&268435455)?16:536870912:4:1}var Ec,Fc,Gc,Hc,Ic,Jc=!1,Kc=[],Lc=null,Mc=null,Nc=null,Oc=new Map,Pc=new Map,Qc=[],Rc="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
	function Sc(a,b){switch(a){case "focusin":case "focusout":Lc=null;break;case "dragenter":case "dragleave":Mc=null;break;case "mouseover":case "mouseout":Nc=null;break;case "pointerover":case "pointerout":Oc.delete(b.pointerId);break;case "gotpointercapture":case "lostpointercapture":Pc.delete(b.pointerId);}}
	function Tc(a,b,c,d,e,f){if(null===a||a.nativeEvent!==f)return a={blockedOn:b,domEventName:c,eventSystemFlags:d,nativeEvent:f,targetContainers:[e]},null!==b&&(b=Cb(b),null!==b&&Fc(b)),a;a.eventSystemFlags|=d;b=a.targetContainers;null!==e&&-1===b.indexOf(e)&&b.push(e);return a}
	function Uc(a,b,c,d,e){switch(b){case "focusin":return Lc=Tc(Lc,a,b,c,d,e),!0;case "dragenter":return Mc=Tc(Mc,a,b,c,d,e),!0;case "mouseover":return Nc=Tc(Nc,a,b,c,d,e),!0;case "pointerover":var f=e.pointerId;Oc.set(f,Tc(Oc.get(f)||null,a,b,c,d,e));return !0;case "gotpointercapture":return f=e.pointerId,Pc.set(f,Tc(Pc.get(f)||null,a,b,c,d,e)),!0}return !1}
	function Vc(a){var b=Wc(a.target);if(null!==b){var c=Vb(b);if(null!==c)if(b=c.tag,13===b){if(b=Wb(c),null!==b){a.blockedOn=b;Ic(a.priority,function(){Gc(c);});return}}else if(3===b&&c.stateNode.current.memoizedState.isDehydrated){a.blockedOn=3===c.tag?c.stateNode.containerInfo:null;return}}a.blockedOn=null;}
	function Xc(a){if(null!==a.blockedOn)return !1;for(var b=a.targetContainers;0<b.length;){var c=Yc(a.domEventName,a.eventSystemFlags,b[0],a.nativeEvent);if(null===c){c=a.nativeEvent;var d=new c.constructor(c.type,c);wb=d;c.target.dispatchEvent(d);wb=null;}else return b=Cb(c),null!==b&&Fc(b),a.blockedOn=c,!1;b.shift();}return !0}function Zc(a,b,c){Xc(a)&&c.delete(b);}function $c(){Jc=!1;null!==Lc&&Xc(Lc)&&(Lc=null);null!==Mc&&Xc(Mc)&&(Mc=null);null!==Nc&&Xc(Nc)&&(Nc=null);Oc.forEach(Zc);Pc.forEach(Zc);}
	function ad(a,b){a.blockedOn===b&&(a.blockedOn=null,Jc||(Jc=!0,ca.unstable_scheduleCallback(ca.unstable_NormalPriority,$c)));}
	function bd(a){function b(b){return ad(b,a)}if(0<Kc.length){ad(Kc[0],a);for(var c=1;c<Kc.length;c++){var d=Kc[c];d.blockedOn===a&&(d.blockedOn=null);}}null!==Lc&&ad(Lc,a);null!==Mc&&ad(Mc,a);null!==Nc&&ad(Nc,a);Oc.forEach(b);Pc.forEach(b);for(c=0;c<Qc.length;c++)d=Qc[c],d.blockedOn===a&&(d.blockedOn=null);for(;0<Qc.length&&(c=Qc[0],null===c.blockedOn);)Vc(c),null===c.blockedOn&&Qc.shift();}var cd=ua.ReactCurrentBatchConfig,dd=!0;
	function ed(a,b,c,d){var e=C,f=cd.transition;cd.transition=null;try{C=1,fd(a,b,c,d);}finally{C=e,cd.transition=f;}}function gd(a,b,c,d){var e=C,f=cd.transition;cd.transition=null;try{C=4,fd(a,b,c,d);}finally{C=e,cd.transition=f;}}
	function fd(a,b,c,d){if(dd){var e=Yc(a,b,c,d);if(null===e)hd(a,b,d,id,c),Sc(a,d);else if(Uc(e,a,b,c,d))d.stopPropagation();else if(Sc(a,d),b&4&&-1<Rc.indexOf(a)){for(;null!==e;){var f=Cb(e);null!==f&&Ec(f);f=Yc(a,b,c,d);null===f&&hd(a,b,d,id,c);if(f===e)break;e=f;}null!==e&&d.stopPropagation();}else hd(a,b,d,null,c);}}var id=null;
	function Yc(a,b,c,d){id=null;a=xb(d);a=Wc(a);if(null!==a)if(b=Vb(a),null===b)a=null;else if(c=b.tag,13===c){a=Wb(b);if(null!==a)return a;a=null;}else if(3===c){if(b.stateNode.current.memoizedState.isDehydrated)return 3===b.tag?b.stateNode.containerInfo:null;a=null;}else b!==a&&(a=null);id=a;return null}
	function jd(a){switch(a){case "cancel":case "click":case "close":case "contextmenu":case "copy":case "cut":case "auxclick":case "dblclick":case "dragend":case "dragstart":case "drop":case "focusin":case "focusout":case "input":case "invalid":case "keydown":case "keypress":case "keyup":case "mousedown":case "mouseup":case "paste":case "pause":case "play":case "pointercancel":case "pointerdown":case "pointerup":case "ratechange":case "reset":case "resize":case "seeked":case "submit":case "touchcancel":case "touchend":case "touchstart":case "volumechange":case "change":case "selectionchange":case "textInput":case "compositionstart":case "compositionend":case "compositionupdate":case "beforeblur":case "afterblur":case "beforeinput":case "blur":case "fullscreenchange":case "focus":case "hashchange":case "popstate":case "select":case "selectstart":return 1;case "drag":case "dragenter":case "dragexit":case "dragleave":case "dragover":case "mousemove":case "mouseout":case "mouseover":case "pointermove":case "pointerout":case "pointerover":case "scroll":case "toggle":case "touchmove":case "wheel":case "mouseenter":case "mouseleave":case "pointerenter":case "pointerleave":return 4;
	case "message":switch(ec()){case fc:return 1;case gc:return 4;case hc:case ic:return 16;case jc:return 536870912;default:return 16}default:return 16}}var kd=null,ld=null,md=null;function nd(){if(md)return md;var a,b=ld,c=b.length,d,e="value"in kd?kd.value:kd.textContent,f=e.length;for(a=0;a<c&&b[a]===e[a];a++);var g=c-a;for(d=1;d<=g&&b[c-d]===e[f-d];d++);return md=e.slice(a,1<d?1-d:void 0)}
	function od(a){var b=a.keyCode;"charCode"in a?(a=a.charCode,0===a&&13===b&&(a=13)):a=b;10===a&&(a=13);return 32<=a||13===a?a:0}function pd(){return !0}function qd(){return !1}
	function rd(a){function b(b,d,e,f,g){this._reactName=b;this._targetInst=e;this.type=d;this.nativeEvent=f;this.target=g;this.currentTarget=null;for(var c in a)a.hasOwnProperty(c)&&(b=a[c],this[c]=b?b(f):f[c]);this.isDefaultPrevented=(null!=f.defaultPrevented?f.defaultPrevented:!1===f.returnValue)?pd:qd;this.isPropagationStopped=qd;return this}A(b.prototype,{preventDefault:function(){this.defaultPrevented=!0;var a=this.nativeEvent;a&&(a.preventDefault?a.preventDefault():"unknown"!==typeof a.returnValue&&
	(a.returnValue=!1),this.isDefaultPrevented=pd);},stopPropagation:function(){var a=this.nativeEvent;a&&(a.stopPropagation?a.stopPropagation():"unknown"!==typeof a.cancelBubble&&(a.cancelBubble=!0),this.isPropagationStopped=pd);},persist:function(){},isPersistent:pd});return b}
	var sd={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(a){return a.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},td=rd(sd),ud=A({},sd,{view:0,detail:0}),vd=rd(ud),wd,xd,yd,Ad=A({},ud,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:zd,button:0,buttons:0,relatedTarget:function(a){return void 0===a.relatedTarget?a.fromElement===a.srcElement?a.toElement:a.fromElement:a.relatedTarget},movementX:function(a){if("movementX"in
	a)return a.movementX;a!==yd&&(yd&&"mousemove"===a.type?(wd=a.screenX-yd.screenX,xd=a.screenY-yd.screenY):xd=wd=0,yd=a);return wd},movementY:function(a){return "movementY"in a?a.movementY:xd}}),Bd=rd(Ad),Cd=A({},Ad,{dataTransfer:0}),Dd=rd(Cd),Ed=A({},ud,{relatedTarget:0}),Fd=rd(Ed),Gd=A({},sd,{animationName:0,elapsedTime:0,pseudoElement:0}),Hd=rd(Gd),Id=A({},sd,{clipboardData:function(a){return "clipboardData"in a?a.clipboardData:window.clipboardData}}),Jd=rd(Id),Kd=A({},sd,{data:0}),Ld=rd(Kd),Md={Esc:"Escape",
	Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},Nd={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",
	119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},Od={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function Pd(a){var b=this.nativeEvent;return b.getModifierState?b.getModifierState(a):(a=Od[a])?!!b[a]:!1}function zd(){return Pd}
	var Qd=A({},ud,{key:function(a){if(a.key){var b=Md[a.key]||a.key;if("Unidentified"!==b)return b}return "keypress"===a.type?(a=od(a),13===a?"Enter":String.fromCharCode(a)):"keydown"===a.type||"keyup"===a.type?Nd[a.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:zd,charCode:function(a){return "keypress"===a.type?od(a):0},keyCode:function(a){return "keydown"===a.type||"keyup"===a.type?a.keyCode:0},which:function(a){return "keypress"===
	a.type?od(a):"keydown"===a.type||"keyup"===a.type?a.keyCode:0}}),Rd=rd(Qd),Sd=A({},Ad,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0}),Td=rd(Sd),Ud=A({},ud,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:zd}),Vd=rd(Ud),Wd=A({},sd,{propertyName:0,elapsedTime:0,pseudoElement:0}),Xd=rd(Wd),Yd=A({},Ad,{deltaX:function(a){return "deltaX"in a?a.deltaX:"wheelDeltaX"in a?-a.wheelDeltaX:0},
	deltaY:function(a){return "deltaY"in a?a.deltaY:"wheelDeltaY"in a?-a.wheelDeltaY:"wheelDelta"in a?-a.wheelDelta:0},deltaZ:0,deltaMode:0}),Zd=rd(Yd),$d=[9,13,27,32],ae=ia&&"CompositionEvent"in window,be=null;ia&&"documentMode"in document&&(be=document.documentMode);var ce=ia&&"TextEvent"in window&&!be,de=ia&&(!ae||be&&8<be&&11>=be),ee=String.fromCharCode(32),fe=!1;
	function ge(a,b){switch(a){case "keyup":return -1!==$d.indexOf(b.keyCode);case "keydown":return 229!==b.keyCode;case "keypress":case "mousedown":case "focusout":return !0;default:return !1}}function he(a){a=a.detail;return "object"===typeof a&&"data"in a?a.data:null}var ie=!1;function je(a,b){switch(a){case "compositionend":return he(b);case "keypress":if(32!==b.which)return null;fe=!0;return ee;case "textInput":return a=b.data,a===ee&&fe?null:a;default:return null}}
	function ke(a,b){if(ie)return "compositionend"===a||!ae&&ge(a,b)?(a=nd(),md=ld=kd=null,ie=!1,a):null;switch(a){case "paste":return null;case "keypress":if(!(b.ctrlKey||b.altKey||b.metaKey)||b.ctrlKey&&b.altKey){if(b.char&&1<b.char.length)return b.char;if(b.which)return String.fromCharCode(b.which)}return null;case "compositionend":return de&&"ko"!==b.locale?null:b.data;default:return null}}
	var le={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function me(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return "input"===b?!!le[a.type]:"textarea"===b?!0:!1}function ne(a,b,c,d){Eb(d);b=oe(b,"onChange");0<b.length&&(c=new td("onChange","change",null,c,d),a.push({event:c,listeners:b}));}var pe=null,qe=null;function re(a){se(a,0);}function te(a){var b=ue(a);if(Wa(b))return a}
	function ve(a,b){if("change"===a)return b}var we=!1;if(ia){var xe;if(ia){var ye="oninput"in document;if(!ye){var ze=document.createElement("div");ze.setAttribute("oninput","return;");ye="function"===typeof ze.oninput;}xe=ye;}else xe=!1;we=xe&&(!document.documentMode||9<document.documentMode);}function Ae(){pe&&(pe.detachEvent("onpropertychange",Be),qe=pe=null);}function Be(a){if("value"===a.propertyName&&te(qe)){var b=[];ne(b,qe,a,xb(a));Jb(re,b);}}
	function Ce(a,b,c){"focusin"===a?(Ae(),pe=b,qe=c,pe.attachEvent("onpropertychange",Be)):"focusout"===a&&Ae();}function De(a){if("selectionchange"===a||"keyup"===a||"keydown"===a)return te(qe)}function Ee(a,b){if("click"===a)return te(b)}function Fe(a,b){if("input"===a||"change"===a)return te(b)}function Ge(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var He="function"===typeof Object.is?Object.is:Ge;
	function Ie(a,b){if(He(a,b))return !0;if("object"!==typeof a||null===a||"object"!==typeof b||null===b)return !1;var c=Object.keys(a),d=Object.keys(b);if(c.length!==d.length)return !1;for(d=0;d<c.length;d++){var e=c[d];if(!ja.call(b,e)||!He(a[e],b[e]))return !1}return !0}function Je(a){for(;a&&a.firstChild;)a=a.firstChild;return a}
	function Ke(a,b){var c=Je(a);a=0;for(var d;c;){if(3===c.nodeType){d=a+c.textContent.length;if(a<=b&&d>=b)return {node:c,offset:b-a};a=d;}a:{for(;c;){if(c.nextSibling){c=c.nextSibling;break a}c=c.parentNode;}c=void 0;}c=Je(c);}}function Le(a,b){return a&&b?a===b?!0:a&&3===a.nodeType?!1:b&&3===b.nodeType?Le(a,b.parentNode):"contains"in a?a.contains(b):a.compareDocumentPosition?!!(a.compareDocumentPosition(b)&16):!1:!1}
	function Me(){for(var a=window,b=Xa();b instanceof a.HTMLIFrameElement;){try{var c="string"===typeof b.contentWindow.location.href;}catch(d){c=!1;}if(c)a=b.contentWindow;else break;b=Xa(a.document);}return b}function Ne(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return b&&("input"===b&&("text"===a.type||"search"===a.type||"tel"===a.type||"url"===a.type||"password"===a.type)||"textarea"===b||"true"===a.contentEditable)}
	function Oe(a){var b=Me(),c=a.focusedElem,d=a.selectionRange;if(b!==c&&c&&c.ownerDocument&&Le(c.ownerDocument.documentElement,c)){if(null!==d&&Ne(c))if(b=d.start,a=d.end,void 0===a&&(a=b),"selectionStart"in c)c.selectionStart=b,c.selectionEnd=Math.min(a,c.value.length);else if(a=(b=c.ownerDocument||document)&&b.defaultView||window,a.getSelection){a=a.getSelection();var e=c.textContent.length,f=Math.min(d.start,e);d=void 0===d.end?f:Math.min(d.end,e);!a.extend&&f>d&&(e=d,d=f,f=e);e=Ke(c,f);var g=Ke(c,
	d);e&&g&&(1!==a.rangeCount||a.anchorNode!==e.node||a.anchorOffset!==e.offset||a.focusNode!==g.node||a.focusOffset!==g.offset)&&(b=b.createRange(),b.setStart(e.node,e.offset),a.removeAllRanges(),f>d?(a.addRange(b),a.extend(g.node,g.offset)):(b.setEnd(g.node,g.offset),a.addRange(b)));}b=[];for(a=c;a=a.parentNode;)1===a.nodeType&&b.push({element:a,left:a.scrollLeft,top:a.scrollTop});"function"===typeof c.focus&&c.focus();for(c=0;c<b.length;c++)a=b[c],a.element.scrollLeft=a.left,a.element.scrollTop=a.top;}}
	var Pe=ia&&"documentMode"in document&&11>=document.documentMode,Qe=null,Re=null,Se=null,Te=!1;
	function Ue(a,b,c){var d=c.window===c?c.document:9===c.nodeType?c:c.ownerDocument;Te||null==Qe||Qe!==Xa(d)||(d=Qe,"selectionStart"in d&&Ne(d)?d={start:d.selectionStart,end:d.selectionEnd}:(d=(d.ownerDocument&&d.ownerDocument.defaultView||window).getSelection(),d={anchorNode:d.anchorNode,anchorOffset:d.anchorOffset,focusNode:d.focusNode,focusOffset:d.focusOffset}),Se&&Ie(Se,d)||(Se=d,d=oe(Re,"onSelect"),0<d.length&&(b=new td("onSelect","select",null,b,c),a.push({event:b,listeners:d}),b.target=Qe)));}
	function Ve(a,b){var c={};c[a.toLowerCase()]=b.toLowerCase();c["Webkit"+a]="webkit"+b;c["Moz"+a]="moz"+b;return c}var We={animationend:Ve("Animation","AnimationEnd"),animationiteration:Ve("Animation","AnimationIteration"),animationstart:Ve("Animation","AnimationStart"),transitionend:Ve("Transition","TransitionEnd")},Xe={},Ye={};
	ia&&(Ye=document.createElement("div").style,"AnimationEvent"in window||(delete We.animationend.animation,delete We.animationiteration.animation,delete We.animationstart.animation),"TransitionEvent"in window||delete We.transitionend.transition);function Ze(a){if(Xe[a])return Xe[a];if(!We[a])return a;var b=We[a],c;for(c in b)if(b.hasOwnProperty(c)&&c in Ye)return Xe[a]=b[c];return a}var $e=Ze("animationend"),af=Ze("animationiteration"),bf=Ze("animationstart"),cf=Ze("transitionend"),df=new Map,ef="abort auxClick cancel canPlay canPlayThrough click close contextMenu copy cut drag dragEnd dragEnter dragExit dragLeave dragOver dragStart drop durationChange emptied encrypted ended error gotPointerCapture input invalid keyDown keyPress keyUp load loadedData loadedMetadata loadStart lostPointerCapture mouseDown mouseMove mouseOut mouseOver mouseUp paste pause play playing pointerCancel pointerDown pointerMove pointerOut pointerOver pointerUp progress rateChange reset resize seeked seeking stalled submit suspend timeUpdate touchCancel touchEnd touchStart volumeChange scroll toggle touchMove waiting wheel".split(" ");
	function ff(a,b){df.set(a,b);fa(b,[a]);}for(var gf=0;gf<ef.length;gf++){var hf=ef[gf],jf=hf.toLowerCase(),kf=hf[0].toUpperCase()+hf.slice(1);ff(jf,"on"+kf);}ff($e,"onAnimationEnd");ff(af,"onAnimationIteration");ff(bf,"onAnimationStart");ff("dblclick","onDoubleClick");ff("focusin","onFocus");ff("focusout","onBlur");ff(cf,"onTransitionEnd");ha("onMouseEnter",["mouseout","mouseover"]);ha("onMouseLeave",["mouseout","mouseover"]);ha("onPointerEnter",["pointerout","pointerover"]);
	ha("onPointerLeave",["pointerout","pointerover"]);fa("onChange","change click focusin focusout input keydown keyup selectionchange".split(" "));fa("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));fa("onBeforeInput",["compositionend","keypress","textInput","paste"]);fa("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" "));fa("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" "));
	fa("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var lf="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange resize seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),mf=new Set("cancel close invalid load scroll toggle".split(" ").concat(lf));
	function nf(a,b,c){var d=a.type||"unknown-event";a.currentTarget=c;Ub(d,b,void 0,a);a.currentTarget=null;}
	function se(a,b){b=0!==(b&4);for(var c=0;c<a.length;c++){var d=a[c],e=d.event;d=d.listeners;a:{var f=void 0;if(b)for(var g=d.length-1;0<=g;g--){var h=d[g],k=h.instance,l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;nf(e,h,l);f=k;}else for(g=0;g<d.length;g++){h=d[g];k=h.instance;l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;nf(e,h,l);f=k;}}}if(Qb)throw a=Rb,Qb=!1,Rb=null,a;}
	function D(a,b){var c=b[of];void 0===c&&(c=b[of]=new Set);var d=a+"__bubble";c.has(d)||(pf(b,a,2,!1),c.add(d));}function qf(a,b,c){var d=0;b&&(d|=4);pf(c,a,d,b);}var rf="_reactListening"+Math.random().toString(36).slice(2);function sf(a){if(!a[rf]){a[rf]=!0;da.forEach(function(b){"selectionchange"!==b&&(mf.has(b)||qf(b,!1,a),qf(b,!0,a));});var b=9===a.nodeType?a:a.ownerDocument;null===b||b[rf]||(b[rf]=!0,qf("selectionchange",!1,b));}}
	function pf(a,b,c,d){switch(jd(b)){case 1:var e=ed;break;case 4:e=gd;break;default:e=fd;}c=e.bind(null,b,c,a);e=void 0;!Lb||"touchstart"!==b&&"touchmove"!==b&&"wheel"!==b||(e=!0);d?void 0!==e?a.addEventListener(b,c,{capture:!0,passive:e}):a.addEventListener(b,c,!0):void 0!==e?a.addEventListener(b,c,{passive:e}):a.addEventListener(b,c,!1);}
	function hd(a,b,c,d,e){var f=d;if(0===(b&1)&&0===(b&2)&&null!==d)a:for(;;){if(null===d)return;var g=d.tag;if(3===g||4===g){var h=d.stateNode.containerInfo;if(h===e||8===h.nodeType&&h.parentNode===e)break;if(4===g)for(g=d.return;null!==g;){var k=g.tag;if(3===k||4===k)if(k=g.stateNode.containerInfo,k===e||8===k.nodeType&&k.parentNode===e)return;g=g.return;}for(;null!==h;){g=Wc(h);if(null===g)return;k=g.tag;if(5===k||6===k){d=f=g;continue a}h=h.parentNode;}}d=d.return;}Jb(function(){var d=f,e=xb(c),g=[];
	a:{var h=df.get(a);if(void 0!==h){var k=td,n=a;switch(a){case "keypress":if(0===od(c))break a;case "keydown":case "keyup":k=Rd;break;case "focusin":n="focus";k=Fd;break;case "focusout":n="blur";k=Fd;break;case "beforeblur":case "afterblur":k=Fd;break;case "click":if(2===c.button)break a;case "auxclick":case "dblclick":case "mousedown":case "mousemove":case "mouseup":case "mouseout":case "mouseover":case "contextmenu":k=Bd;break;case "drag":case "dragend":case "dragenter":case "dragexit":case "dragleave":case "dragover":case "dragstart":case "drop":k=
	Dd;break;case "touchcancel":case "touchend":case "touchmove":case "touchstart":k=Vd;break;case $e:case af:case bf:k=Hd;break;case cf:k=Xd;break;case "scroll":k=vd;break;case "wheel":k=Zd;break;case "copy":case "cut":case "paste":k=Jd;break;case "gotpointercapture":case "lostpointercapture":case "pointercancel":case "pointerdown":case "pointermove":case "pointerout":case "pointerover":case "pointerup":k=Td;}var t=0!==(b&4),J=!t&&"scroll"===a,x=t?null!==h?h+"Capture":null:h;t=[];for(var w=d,u;null!==
	w;){u=w;var F=u.stateNode;5===u.tag&&null!==F&&(u=F,null!==x&&(F=Kb(w,x),null!=F&&t.push(tf(w,F,u))));if(J)break;w=w.return;}0<t.length&&(h=new k(h,n,null,c,e),g.push({event:h,listeners:t}));}}if(0===(b&7)){a:{h="mouseover"===a||"pointerover"===a;k="mouseout"===a||"pointerout"===a;if(h&&c!==wb&&(n=c.relatedTarget||c.fromElement)&&(Wc(n)||n[uf]))break a;if(k||h){h=e.window===e?e:(h=e.ownerDocument)?h.defaultView||h.parentWindow:window;if(k){if(n=c.relatedTarget||c.toElement,k=d,n=n?Wc(n):null,null!==
	n&&(J=Vb(n),n!==J||5!==n.tag&&6!==n.tag))n=null;}else k=null,n=d;if(k!==n){t=Bd;F="onMouseLeave";x="onMouseEnter";w="mouse";if("pointerout"===a||"pointerover"===a)t=Td,F="onPointerLeave",x="onPointerEnter",w="pointer";J=null==k?h:ue(k);u=null==n?h:ue(n);h=new t(F,w+"leave",k,c,e);h.target=J;h.relatedTarget=u;F=null;Wc(e)===d&&(t=new t(x,w+"enter",n,c,e),t.target=u,t.relatedTarget=J,F=t);J=F;if(k&&n)b:{t=k;x=n;w=0;for(u=t;u;u=vf(u))w++;u=0;for(F=x;F;F=vf(F))u++;for(;0<w-u;)t=vf(t),w--;for(;0<u-w;)x=
	vf(x),u--;for(;w--;){if(t===x||null!==x&&t===x.alternate)break b;t=vf(t);x=vf(x);}t=null;}else t=null;null!==k&&wf(g,h,k,t,!1);null!==n&&null!==J&&wf(g,J,n,t,!0);}}}a:{h=d?ue(d):window;k=h.nodeName&&h.nodeName.toLowerCase();if("select"===k||"input"===k&&"file"===h.type)var na=ve;else if(me(h))if(we)na=Fe;else {na=De;var xa=Ce;}else (k=h.nodeName)&&"input"===k.toLowerCase()&&("checkbox"===h.type||"radio"===h.type)&&(na=Ee);if(na&&(na=na(a,d))){ne(g,na,c,e);break a}xa&&xa(a,h,d);"focusout"===a&&(xa=h._wrapperState)&&
	xa.controlled&&"number"===h.type&&cb(h,"number",h.value);}xa=d?ue(d):window;switch(a){case "focusin":if(me(xa)||"true"===xa.contentEditable)Qe=xa,Re=d,Se=null;break;case "focusout":Se=Re=Qe=null;break;case "mousedown":Te=!0;break;case "contextmenu":case "mouseup":case "dragend":Te=!1;Ue(g,c,e);break;case "selectionchange":if(Pe)break;case "keydown":case "keyup":Ue(g,c,e);}var $a;if(ae)b:{switch(a){case "compositionstart":var ba="onCompositionStart";break b;case "compositionend":ba="onCompositionEnd";
	break b;case "compositionupdate":ba="onCompositionUpdate";break b}ba=void 0;}else ie?ge(a,c)&&(ba="onCompositionEnd"):"keydown"===a&&229===c.keyCode&&(ba="onCompositionStart");ba&&(de&&"ko"!==c.locale&&(ie||"onCompositionStart"!==ba?"onCompositionEnd"===ba&&ie&&($a=nd()):(kd=e,ld="value"in kd?kd.value:kd.textContent,ie=!0)),xa=oe(d,ba),0<xa.length&&(ba=new Ld(ba,a,null,c,e),g.push({event:ba,listeners:xa}),$a?ba.data=$a:($a=he(c),null!==$a&&(ba.data=$a))));if($a=ce?je(a,c):ke(a,c))d=oe(d,"onBeforeInput"),
	0<d.length&&(e=new Ld("onBeforeInput","beforeinput",null,c,e),g.push({event:e,listeners:d}),e.data=$a);}se(g,b);});}function tf(a,b,c){return {instance:a,listener:b,currentTarget:c}}function oe(a,b){for(var c=b+"Capture",d=[];null!==a;){var e=a,f=e.stateNode;5===e.tag&&null!==f&&(e=f,f=Kb(a,c),null!=f&&d.unshift(tf(a,f,e)),f=Kb(a,b),null!=f&&d.push(tf(a,f,e)));a=a.return;}return d}function vf(a){if(null===a)return null;do a=a.return;while(a&&5!==a.tag);return a?a:null}
	function wf(a,b,c,d,e){for(var f=b._reactName,g=[];null!==c&&c!==d;){var h=c,k=h.alternate,l=h.stateNode;if(null!==k&&k===d)break;5===h.tag&&null!==l&&(h=l,e?(k=Kb(c,f),null!=k&&g.unshift(tf(c,k,h))):e||(k=Kb(c,f),null!=k&&g.push(tf(c,k,h))));c=c.return;}0!==g.length&&a.push({event:b,listeners:g});}var xf=/\r\n?/g,yf=/\u0000|\uFFFD/g;function zf(a){return ("string"===typeof a?a:""+a).replace(xf,"\n").replace(yf,"")}function Af(a,b,c){b=zf(b);if(zf(a)!==b&&c)throw Error(p(425));}function Bf(){}
	var Cf=null,Df=null;function Ef(a,b){return "textarea"===a||"noscript"===a||"string"===typeof b.children||"number"===typeof b.children||"object"===typeof b.dangerouslySetInnerHTML&&null!==b.dangerouslySetInnerHTML&&null!=b.dangerouslySetInnerHTML.__html}
	var Ff="function"===typeof setTimeout?setTimeout:void 0,Gf="function"===typeof clearTimeout?clearTimeout:void 0,Hf="function"===typeof Promise?Promise:void 0,Jf="function"===typeof queueMicrotask?queueMicrotask:"undefined"!==typeof Hf?function(a){return Hf.resolve(null).then(a).catch(If)}:Ff;function If(a){setTimeout(function(){throw a;});}
	function Kf(a,b){var c=b,d=0;do{var e=c.nextSibling;a.removeChild(c);if(e&&8===e.nodeType)if(c=e.data,"/$"===c){if(0===d){a.removeChild(e);bd(b);return}d--;}else "$"!==c&&"$?"!==c&&"$!"!==c||d++;c=e;}while(c);bd(b);}function Lf(a){for(;null!=a;a=a.nextSibling){var b=a.nodeType;if(1===b||3===b)break;if(8===b){b=a.data;if("$"===b||"$!"===b||"$?"===b)break;if("/$"===b)return null}}return a}
	function Mf(a){a=a.previousSibling;for(var b=0;a;){if(8===a.nodeType){var c=a.data;if("$"===c||"$!"===c||"$?"===c){if(0===b)return a;b--;}else "/$"===c&&b++;}a=a.previousSibling;}return null}var Nf=Math.random().toString(36).slice(2),Of="__reactFiber$"+Nf,Pf="__reactProps$"+Nf,uf="__reactContainer$"+Nf,of="__reactEvents$"+Nf,Qf="__reactListeners$"+Nf,Rf="__reactHandles$"+Nf;
	function Wc(a){var b=a[Of];if(b)return b;for(var c=a.parentNode;c;){if(b=c[uf]||c[Of]){c=b.alternate;if(null!==b.child||null!==c&&null!==c.child)for(a=Mf(a);null!==a;){if(c=a[Of])return c;a=Mf(a);}return b}a=c;c=a.parentNode;}return null}function Cb(a){a=a[Of]||a[uf];return !a||5!==a.tag&&6!==a.tag&&13!==a.tag&&3!==a.tag?null:a}function ue(a){if(5===a.tag||6===a.tag)return a.stateNode;throw Error(p(33));}function Db(a){return a[Pf]||null}var Sf=[],Tf=-1;function Uf(a){return {current:a}}
	function E(a){0>Tf||(a.current=Sf[Tf],Sf[Tf]=null,Tf--);}function G(a,b){Tf++;Sf[Tf]=a.current;a.current=b;}var Vf={},H=Uf(Vf),Wf=Uf(!1),Xf=Vf;function Yf(a,b){var c=a.type.contextTypes;if(!c)return Vf;var d=a.stateNode;if(d&&d.__reactInternalMemoizedUnmaskedChildContext===b)return d.__reactInternalMemoizedMaskedChildContext;var e={},f;for(f in c)e[f]=b[f];d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=b,a.__reactInternalMemoizedMaskedChildContext=e);return e}
	function Zf(a){a=a.childContextTypes;return null!==a&&void 0!==a}function $f(){E(Wf);E(H);}function ag(a,b,c){if(H.current!==Vf)throw Error(p(168));G(H,b);G(Wf,c);}function bg(a,b,c){var d=a.stateNode;b=b.childContextTypes;if("function"!==typeof d.getChildContext)return c;d=d.getChildContext();for(var e in d)if(!(e in b))throw Error(p(108,Ra(a)||"Unknown",e));return A({},c,d)}
	function cg(a){a=(a=a.stateNode)&&a.__reactInternalMemoizedMergedChildContext||Vf;Xf=H.current;G(H,a);G(Wf,Wf.current);return !0}function dg(a,b,c){var d=a.stateNode;if(!d)throw Error(p(169));c?(a=bg(a,b,Xf),d.__reactInternalMemoizedMergedChildContext=a,E(Wf),E(H),G(H,a)):E(Wf);G(Wf,c);}var eg=null,fg=!1,gg=!1;function hg(a){null===eg?eg=[a]:eg.push(a);}function ig(a){fg=!0;hg(a);}
	function jg(){if(!gg&&null!==eg){gg=!0;var a=0,b=C;try{var c=eg;for(C=1;a<c.length;a++){var d=c[a];do d=d(!0);while(null!==d)}eg=null;fg=!1;}catch(e){throw null!==eg&&(eg=eg.slice(a+1)),ac(fc,jg),e;}finally{C=b,gg=!1;}}return null}var kg=[],lg=0,mg=null,ng=0,og=[],pg=0,qg=null,rg=1,sg="";function tg(a,b){kg[lg++]=ng;kg[lg++]=mg;mg=a;ng=b;}
	function ug(a,b,c){og[pg++]=rg;og[pg++]=sg;og[pg++]=qg;qg=a;var d=rg;a=sg;var e=32-oc(d)-1;d&=~(1<<e);c+=1;var f=32-oc(b)+e;if(30<f){var g=e-e%5;f=(d&(1<<g)-1).toString(32);d>>=g;e-=g;rg=1<<32-oc(b)+e|c<<e|d;sg=f+a;}else rg=1<<f|c<<e|d,sg=a;}function vg(a){null!==a.return&&(tg(a,1),ug(a,1,0));}function wg(a){for(;a===mg;)mg=kg[--lg],kg[lg]=null,ng=kg[--lg],kg[lg]=null;for(;a===qg;)qg=og[--pg],og[pg]=null,sg=og[--pg],og[pg]=null,rg=og[--pg],og[pg]=null;}var xg=null,yg=null,I=!1,zg=null;
	function Ag(a,b){var c=Bg(5,null,null,0);c.elementType="DELETED";c.stateNode=b;c.return=a;b=a.deletions;null===b?(a.deletions=[c],a.flags|=16):b.push(c);}
	function Cg(a,b){switch(a.tag){case 5:var c=a.type;b=1!==b.nodeType||c.toLowerCase()!==b.nodeName.toLowerCase()?null:b;return null!==b?(a.stateNode=b,xg=a,yg=Lf(b.firstChild),!0):!1;case 6:return b=""===a.pendingProps||3!==b.nodeType?null:b,null!==b?(a.stateNode=b,xg=a,yg=null,!0):!1;case 13:return b=8!==b.nodeType?null:b,null!==b?(c=null!==qg?{id:rg,overflow:sg}:null,a.memoizedState={dehydrated:b,treeContext:c,retryLane:1073741824},c=Bg(18,null,null,0),c.stateNode=b,c.return=a,a.child=c,xg=a,yg=
	null,!0):!1;default:return !1}}function Dg(a){return 0!==(a.mode&1)&&0===(a.flags&128)}function Eg(a){if(I){var b=yg;if(b){var c=b;if(!Cg(a,b)){if(Dg(a))throw Error(p(418));b=Lf(c.nextSibling);var d=xg;b&&Cg(a,b)?Ag(d,c):(a.flags=a.flags&-4097|2,I=!1,xg=a);}}else {if(Dg(a))throw Error(p(418));a.flags=a.flags&-4097|2;I=!1;xg=a;}}}function Fg(a){for(a=a.return;null!==a&&5!==a.tag&&3!==a.tag&&13!==a.tag;)a=a.return;xg=a;}
	function Gg(a){if(a!==xg)return !1;if(!I)return Fg(a),I=!0,!1;var b;(b=3!==a.tag)&&!(b=5!==a.tag)&&(b=a.type,b="head"!==b&&"body"!==b&&!Ef(a.type,a.memoizedProps));if(b&&(b=yg)){if(Dg(a))throw Hg(),Error(p(418));for(;b;)Ag(a,b),b=Lf(b.nextSibling);}Fg(a);if(13===a.tag){a=a.memoizedState;a=null!==a?a.dehydrated:null;if(!a)throw Error(p(317));a:{a=a.nextSibling;for(b=0;a;){if(8===a.nodeType){var c=a.data;if("/$"===c){if(0===b){yg=Lf(a.nextSibling);break a}b--;}else "$"!==c&&"$!"!==c&&"$?"!==c||b++;}a=a.nextSibling;}yg=
	null;}}else yg=xg?Lf(a.stateNode.nextSibling):null;return !0}function Hg(){for(var a=yg;a;)a=Lf(a.nextSibling);}function Ig(){yg=xg=null;I=!1;}function Jg(a){null===zg?zg=[a]:zg.push(a);}var Kg=ua.ReactCurrentBatchConfig;function Lg(a,b){if(a&&a.defaultProps){b=A({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}var Mg=Uf(null),Ng=null,Og=null,Pg=null;function Qg(){Pg=Og=Ng=null;}function Rg(a){var b=Mg.current;E(Mg);a._currentValue=b;}
	function Sg(a,b,c){for(;null!==a;){var d=a.alternate;(a.childLanes&b)!==b?(a.childLanes|=b,null!==d&&(d.childLanes|=b)):null!==d&&(d.childLanes&b)!==b&&(d.childLanes|=b);if(a===c)break;a=a.return;}}function Tg(a,b){Ng=a;Pg=Og=null;a=a.dependencies;null!==a&&null!==a.firstContext&&(0!==(a.lanes&b)&&(Ug=!0),a.firstContext=null);}
	function Vg(a){var b=a._currentValue;if(Pg!==a)if(a={context:a,memoizedValue:b,next:null},null===Og){if(null===Ng)throw Error(p(308));Og=a;Ng.dependencies={lanes:0,firstContext:a};}else Og=Og.next=a;return b}var Wg=null;function Xg(a){null===Wg?Wg=[a]:Wg.push(a);}function Yg(a,b,c,d){var e=b.interleaved;null===e?(c.next=c,Xg(b)):(c.next=e.next,e.next=c);b.interleaved=c;return Zg(a,d)}
	function Zg(a,b){a.lanes|=b;var c=a.alternate;null!==c&&(c.lanes|=b);c=a;for(a=a.return;null!==a;)a.childLanes|=b,c=a.alternate,null!==c&&(c.childLanes|=b),c=a,a=a.return;return 3===c.tag?c.stateNode:null}var $g=!1;function ah(a){a.updateQueue={baseState:a.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null,interleaved:null,lanes:0},effects:null};}
	function bh(a,b){a=a.updateQueue;b.updateQueue===a&&(b.updateQueue={baseState:a.baseState,firstBaseUpdate:a.firstBaseUpdate,lastBaseUpdate:a.lastBaseUpdate,shared:a.shared,effects:a.effects});}function ch(a,b){return {eventTime:a,lane:b,tag:0,payload:null,callback:null,next:null}}
	function dh(a,b,c){var d=a.updateQueue;if(null===d)return null;d=d.shared;if(0!==(K&2)){var e=d.pending;null===e?b.next=b:(b.next=e.next,e.next=b);d.pending=b;return Zg(a,c)}e=d.interleaved;null===e?(b.next=b,Xg(d)):(b.next=e.next,e.next=b);d.interleaved=b;return Zg(a,c)}function eh(a,b,c){b=b.updateQueue;if(null!==b&&(b=b.shared,0!==(c&4194240))){var d=b.lanes;d&=a.pendingLanes;c|=d;b.lanes=c;Cc(a,c);}}
	function fh(a,b){var c=a.updateQueue,d=a.alternate;if(null!==d&&(d=d.updateQueue,c===d)){var e=null,f=null;c=c.firstBaseUpdate;if(null!==c){do{var g={eventTime:c.eventTime,lane:c.lane,tag:c.tag,payload:c.payload,callback:c.callback,next:null};null===f?e=f=g:f=f.next=g;c=c.next;}while(null!==c);null===f?e=f=b:f=f.next=b;}else e=f=b;c={baseState:d.baseState,firstBaseUpdate:e,lastBaseUpdate:f,shared:d.shared,effects:d.effects};a.updateQueue=c;return}a=c.lastBaseUpdate;null===a?c.firstBaseUpdate=b:a.next=
	b;c.lastBaseUpdate=b;}
	function gh(a,b,c,d){var e=a.updateQueue;$g=!1;var f=e.firstBaseUpdate,g=e.lastBaseUpdate,h=e.shared.pending;if(null!==h){e.shared.pending=null;var k=h,l=k.next;k.next=null;null===g?f=l:g.next=l;g=k;var m=a.alternate;null!==m&&(m=m.updateQueue,h=m.lastBaseUpdate,h!==g&&(null===h?m.firstBaseUpdate=l:h.next=l,m.lastBaseUpdate=k));}if(null!==f){var q=e.baseState;g=0;m=l=k=null;h=f;do{var r=h.lane,y=h.eventTime;if((d&r)===r){null!==m&&(m=m.next={eventTime:y,lane:0,tag:h.tag,payload:h.payload,callback:h.callback,
	next:null});a:{var n=a,t=h;r=b;y=c;switch(t.tag){case 1:n=t.payload;if("function"===typeof n){q=n.call(y,q,r);break a}q=n;break a;case 3:n.flags=n.flags&-65537|128;case 0:n=t.payload;r="function"===typeof n?n.call(y,q,r):n;if(null===r||void 0===r)break a;q=A({},q,r);break a;case 2:$g=!0;}}null!==h.callback&&0!==h.lane&&(a.flags|=64,r=e.effects,null===r?e.effects=[h]:r.push(h));}else y={eventTime:y,lane:r,tag:h.tag,payload:h.payload,callback:h.callback,next:null},null===m?(l=m=y,k=q):m=m.next=y,g|=r;
	h=h.next;if(null===h)if(h=e.shared.pending,null===h)break;else r=h,h=r.next,r.next=null,e.lastBaseUpdate=r,e.shared.pending=null;}while(1);null===m&&(k=q);e.baseState=k;e.firstBaseUpdate=l;e.lastBaseUpdate=m;b=e.shared.interleaved;if(null!==b){e=b;do g|=e.lane,e=e.next;while(e!==b)}else null===f&&(e.shared.lanes=0);hh|=g;a.lanes=g;a.memoizedState=q;}}
	function ih(a,b,c){a=b.effects;b.effects=null;if(null!==a)for(b=0;b<a.length;b++){var d=a[b],e=d.callback;if(null!==e){d.callback=null;d=c;if("function"!==typeof e)throw Error(p(191,e));e.call(d);}}}var jh=(new aa.Component).refs;function kh(a,b,c,d){b=a.memoizedState;c=c(d,b);c=null===c||void 0===c?b:A({},b,c);a.memoizedState=c;0===a.lanes&&(a.updateQueue.baseState=c);}
	var nh={isMounted:function(a){return (a=a._reactInternals)?Vb(a)===a:!1},enqueueSetState:function(a,b,c){a=a._reactInternals;var d=L(),e=lh(a),f=ch(d,e);f.payload=b;void 0!==c&&null!==c&&(f.callback=c);b=dh(a,f,e);null!==b&&(mh(b,a,e,d),eh(b,a,e));},enqueueReplaceState:function(a,b,c){a=a._reactInternals;var d=L(),e=lh(a),f=ch(d,e);f.tag=1;f.payload=b;void 0!==c&&null!==c&&(f.callback=c);b=dh(a,f,e);null!==b&&(mh(b,a,e,d),eh(b,a,e));},enqueueForceUpdate:function(a,b){a=a._reactInternals;var c=L(),d=
	lh(a),e=ch(c,d);e.tag=2;void 0!==b&&null!==b&&(e.callback=b);b=dh(a,e,d);null!==b&&(mh(b,a,d,c),eh(b,a,d));}};function oh(a,b,c,d,e,f,g){a=a.stateNode;return "function"===typeof a.shouldComponentUpdate?a.shouldComponentUpdate(d,f,g):b.prototype&&b.prototype.isPureReactComponent?!Ie(c,d)||!Ie(e,f):!0}
	function ph(a,b,c){var d=!1,e=Vf;var f=b.contextType;"object"===typeof f&&null!==f?f=Vg(f):(e=Zf(b)?Xf:H.current,d=b.contextTypes,f=(d=null!==d&&void 0!==d)?Yf(a,e):Vf);b=new b(c,f);a.memoizedState=null!==b.state&&void 0!==b.state?b.state:null;b.updater=nh;a.stateNode=b;b._reactInternals=a;d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=e,a.__reactInternalMemoizedMaskedChildContext=f);return b}
	function qh(a,b,c,d){a=b.state;"function"===typeof b.componentWillReceiveProps&&b.componentWillReceiveProps(c,d);"function"===typeof b.UNSAFE_componentWillReceiveProps&&b.UNSAFE_componentWillReceiveProps(c,d);b.state!==a&&nh.enqueueReplaceState(b,b.state,null);}
	function rh(a,b,c,d){var e=a.stateNode;e.props=c;e.state=a.memoizedState;e.refs=jh;ah(a);var f=b.contextType;"object"===typeof f&&null!==f?e.context=Vg(f):(f=Zf(b)?Xf:H.current,e.context=Yf(a,f));e.state=a.memoizedState;f=b.getDerivedStateFromProps;"function"===typeof f&&(kh(a,b,f,c),e.state=a.memoizedState);"function"===typeof b.getDerivedStateFromProps||"function"===typeof e.getSnapshotBeforeUpdate||"function"!==typeof e.UNSAFE_componentWillMount&&"function"!==typeof e.componentWillMount||(b=e.state,
	"function"===typeof e.componentWillMount&&e.componentWillMount(),"function"===typeof e.UNSAFE_componentWillMount&&e.UNSAFE_componentWillMount(),b!==e.state&&nh.enqueueReplaceState(e,e.state,null),gh(a,c,e,d),e.state=a.memoizedState);"function"===typeof e.componentDidMount&&(a.flags|=4194308);}
	function sh(a,b,c){a=c.ref;if(null!==a&&"function"!==typeof a&&"object"!==typeof a){if(c._owner){c=c._owner;if(c){if(1!==c.tag)throw Error(p(309));var d=c.stateNode;}if(!d)throw Error(p(147,a));var e=d,f=""+a;if(null!==b&&null!==b.ref&&"function"===typeof b.ref&&b.ref._stringRef===f)return b.ref;b=function(a){var b=e.refs;b===jh&&(b=e.refs={});null===a?delete b[f]:b[f]=a;};b._stringRef=f;return b}if("string"!==typeof a)throw Error(p(284));if(!c._owner)throw Error(p(290,a));}return a}
	function th(a,b){a=Object.prototype.toString.call(b);throw Error(p(31,"[object Object]"===a?"object with keys {"+Object.keys(b).join(", ")+"}":a));}function uh(a){var b=a._init;return b(a._payload)}
	function vh(a){function b(b,c){if(a){var d=b.deletions;null===d?(b.deletions=[c],b.flags|=16):d.push(c);}}function c(c,d){if(!a)return null;for(;null!==d;)b(c,d),d=d.sibling;return null}function d(a,b){for(a=new Map;null!==b;)null!==b.key?a.set(b.key,b):a.set(b.index,b),b=b.sibling;return a}function e(a,b){a=wh(a,b);a.index=0;a.sibling=null;return a}function f(b,c,d){b.index=d;if(!a)return b.flags|=1048576,c;d=b.alternate;if(null!==d)return d=d.index,d<c?(b.flags|=2,c):d;b.flags|=2;return c}function g(b){a&&
	null===b.alternate&&(b.flags|=2);return b}function h(a,b,c,d){if(null===b||6!==b.tag)return b=xh(c,a.mode,d),b.return=a,b;b=e(b,c);b.return=a;return b}function k(a,b,c,d){var f=c.type;if(f===ya)return m(a,b,c.props.children,d,c.key);if(null!==b&&(b.elementType===f||"object"===typeof f&&null!==f&&f.$$typeof===Ha&&uh(f)===b.type))return d=e(b,c.props),d.ref=sh(a,b,c),d.return=a,d;d=yh(c.type,c.key,c.props,null,a.mode,d);d.ref=sh(a,b,c);d.return=a;return d}function l(a,b,c,d){if(null===b||4!==b.tag||
	b.stateNode.containerInfo!==c.containerInfo||b.stateNode.implementation!==c.implementation)return b=zh(c,a.mode,d),b.return=a,b;b=e(b,c.children||[]);b.return=a;return b}function m(a,b,c,d,f){if(null===b||7!==b.tag)return b=Ah(c,a.mode,d,f),b.return=a,b;b=e(b,c);b.return=a;return b}function q(a,b,c){if("string"===typeof b&&""!==b||"number"===typeof b)return b=xh(""+b,a.mode,c),b.return=a,b;if("object"===typeof b&&null!==b){switch(b.$$typeof){case va:return c=yh(b.type,b.key,b.props,null,a.mode,c),
	c.ref=sh(a,null,b),c.return=a,c;case wa:return b=zh(b,a.mode,c),b.return=a,b;case Ha:var d=b._init;return q(a,d(b._payload),c)}if(eb(b)||Ka(b))return b=Ah(b,a.mode,c,null),b.return=a,b;th(a,b);}return null}function r(a,b,c,d){var e=null!==b?b.key:null;if("string"===typeof c&&""!==c||"number"===typeof c)return null!==e?null:h(a,b,""+c,d);if("object"===typeof c&&null!==c){switch(c.$$typeof){case va:return c.key===e?k(a,b,c,d):null;case wa:return c.key===e?l(a,b,c,d):null;case Ha:return e=c._init,r(a,
	b,e(c._payload),d)}if(eb(c)||Ka(c))return null!==e?null:m(a,b,c,d,null);th(a,c);}return null}function y(a,b,c,d,e){if("string"===typeof d&&""!==d||"number"===typeof d)return a=a.get(c)||null,h(b,a,""+d,e);if("object"===typeof d&&null!==d){switch(d.$$typeof){case va:return a=a.get(null===d.key?c:d.key)||null,k(b,a,d,e);case wa:return a=a.get(null===d.key?c:d.key)||null,l(b,a,d,e);case Ha:var f=d._init;return y(a,b,c,f(d._payload),e)}if(eb(d)||Ka(d))return a=a.get(c)||null,m(b,a,d,e,null);th(b,d);}return null}
	function n(e,g,h,k){for(var l=null,m=null,u=g,w=g=0,x=null;null!==u&&w<h.length;w++){u.index>w?(x=u,u=null):x=u.sibling;var n=r(e,u,h[w],k);if(null===n){null===u&&(u=x);break}a&&u&&null===n.alternate&&b(e,u);g=f(n,g,w);null===m?l=n:m.sibling=n;m=n;u=x;}if(w===h.length)return c(e,u),I&&tg(e,w),l;if(null===u){for(;w<h.length;w++)u=q(e,h[w],k),null!==u&&(g=f(u,g,w),null===m?l=u:m.sibling=u,m=u);I&&tg(e,w);return l}for(u=d(e,u);w<h.length;w++)x=y(u,e,w,h[w],k),null!==x&&(a&&null!==x.alternate&&u.delete(null===
	x.key?w:x.key),g=f(x,g,w),null===m?l=x:m.sibling=x,m=x);a&&u.forEach(function(a){return b(e,a)});I&&tg(e,w);return l}function t(e,g,h,k){var l=Ka(h);if("function"!==typeof l)throw Error(p(150));h=l.call(h);if(null==h)throw Error(p(151));for(var u=l=null,m=g,w=g=0,x=null,n=h.next();null!==m&&!n.done;w++,n=h.next()){m.index>w?(x=m,m=null):x=m.sibling;var t=r(e,m,n.value,k);if(null===t){null===m&&(m=x);break}a&&m&&null===t.alternate&&b(e,m);g=f(t,g,w);null===u?l=t:u.sibling=t;u=t;m=x;}if(n.done)return c(e,
	m),I&&tg(e,w),l;if(null===m){for(;!n.done;w++,n=h.next())n=q(e,n.value,k),null!==n&&(g=f(n,g,w),null===u?l=n:u.sibling=n,u=n);I&&tg(e,w);return l}for(m=d(e,m);!n.done;w++,n=h.next())n=y(m,e,w,n.value,k),null!==n&&(a&&null!==n.alternate&&m.delete(null===n.key?w:n.key),g=f(n,g,w),null===u?l=n:u.sibling=n,u=n);a&&m.forEach(function(a){return b(e,a)});I&&tg(e,w);return l}function J(a,d,f,h){"object"===typeof f&&null!==f&&f.type===ya&&null===f.key&&(f=f.props.children);if("object"===typeof f&&null!==f){switch(f.$$typeof){case va:a:{for(var k=
	f.key,l=d;null!==l;){if(l.key===k){k=f.type;if(k===ya){if(7===l.tag){c(a,l.sibling);d=e(l,f.props.children);d.return=a;a=d;break a}}else if(l.elementType===k||"object"===typeof k&&null!==k&&k.$$typeof===Ha&&uh(k)===l.type){c(a,l.sibling);d=e(l,f.props);d.ref=sh(a,l,f);d.return=a;a=d;break a}c(a,l);break}else b(a,l);l=l.sibling;}f.type===ya?(d=Ah(f.props.children,a.mode,h,f.key),d.return=a,a=d):(h=yh(f.type,f.key,f.props,null,a.mode,h),h.ref=sh(a,d,f),h.return=a,a=h);}return g(a);case wa:a:{for(l=f.key;null!==
	d;){if(d.key===l)if(4===d.tag&&d.stateNode.containerInfo===f.containerInfo&&d.stateNode.implementation===f.implementation){c(a,d.sibling);d=e(d,f.children||[]);d.return=a;a=d;break a}else {c(a,d);break}else b(a,d);d=d.sibling;}d=zh(f,a.mode,h);d.return=a;a=d;}return g(a);case Ha:return l=f._init,J(a,d,l(f._payload),h)}if(eb(f))return n(a,d,f,h);if(Ka(f))return t(a,d,f,h);th(a,f);}return "string"===typeof f&&""!==f||"number"===typeof f?(f=""+f,null!==d&&6===d.tag?(c(a,d.sibling),d=e(d,f),d.return=a,a=d):
	(c(a,d),d=xh(f,a.mode,h),d.return=a,a=d),g(a)):c(a,d)}return J}var Bh=vh(!0),Ch=vh(!1),Dh={},Eh=Uf(Dh),Fh=Uf(Dh),Gh=Uf(Dh);function Hh(a){if(a===Dh)throw Error(p(174));return a}function Ih(a,b){G(Gh,b);G(Fh,a);G(Eh,Dh);a=b.nodeType;switch(a){case 9:case 11:b=(b=b.documentElement)?b.namespaceURI:lb(null,"");break;default:a=8===a?b.parentNode:b,b=a.namespaceURI||null,a=a.tagName,b=lb(b,a);}E(Eh);G(Eh,b);}function Jh(){E(Eh);E(Fh);E(Gh);}
	function Kh(a){Hh(Gh.current);var b=Hh(Eh.current);var c=lb(b,a.type);b!==c&&(G(Fh,a),G(Eh,c));}function Lh(a){Fh.current===a&&(E(Eh),E(Fh));}var M=Uf(0);
	function Mh(a){for(var b=a;null!==b;){if(13===b.tag){var c=b.memoizedState;if(null!==c&&(c=c.dehydrated,null===c||"$?"===c.data||"$!"===c.data))return b}else if(19===b.tag&&void 0!==b.memoizedProps.revealOrder){if(0!==(b.flags&128))return b}else if(null!==b.child){b.child.return=b;b=b.child;continue}if(b===a)break;for(;null===b.sibling;){if(null===b.return||b.return===a)return null;b=b.return;}b.sibling.return=b.return;b=b.sibling;}return null}var Nh=[];
	function Oh(){for(var a=0;a<Nh.length;a++)Nh[a]._workInProgressVersionPrimary=null;Nh.length=0;}var Ph=ua.ReactCurrentDispatcher,Qh=ua.ReactCurrentBatchConfig,Rh=0,N=null,O=null,P=null,Sh=!1,Th=!1,Uh=0,Vh=0;function Q(){throw Error(p(321));}function Wh(a,b){if(null===b)return !1;for(var c=0;c<b.length&&c<a.length;c++)if(!He(a[c],b[c]))return !1;return !0}
	function Xh(a,b,c,d,e,f){Rh=f;N=b;b.memoizedState=null;b.updateQueue=null;b.lanes=0;Ph.current=null===a||null===a.memoizedState?Yh:Zh;a=c(d,e);if(Th){f=0;do{Th=!1;Uh=0;if(25<=f)throw Error(p(301));f+=1;P=O=null;b.updateQueue=null;Ph.current=$h;a=c(d,e);}while(Th)}Ph.current=ai;b=null!==O&&null!==O.next;Rh=0;P=O=N=null;Sh=!1;if(b)throw Error(p(300));return a}function bi(){var a=0!==Uh;Uh=0;return a}
	function ci(){var a={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};null===P?N.memoizedState=P=a:P=P.next=a;return P}function di(){if(null===O){var a=N.alternate;a=null!==a?a.memoizedState:null;}else a=O.next;var b=null===P?N.memoizedState:P.next;if(null!==b)P=b,O=a;else {if(null===a)throw Error(p(310));O=a;a={memoizedState:O.memoizedState,baseState:O.baseState,baseQueue:O.baseQueue,queue:O.queue,next:null};null===P?N.memoizedState=P=a:P=P.next=a;}return P}
	function ei(a,b){return "function"===typeof b?b(a):b}
	function fi(a){var b=di(),c=b.queue;if(null===c)throw Error(p(311));c.lastRenderedReducer=a;var d=O,e=d.baseQueue,f=c.pending;if(null!==f){if(null!==e){var g=e.next;e.next=f.next;f.next=g;}d.baseQueue=e=f;c.pending=null;}if(null!==e){f=e.next;d=d.baseState;var h=g=null,k=null,l=f;do{var m=l.lane;if((Rh&m)===m)null!==k&&(k=k.next={lane:0,action:l.action,hasEagerState:l.hasEagerState,eagerState:l.eagerState,next:null}),d=l.hasEagerState?l.eagerState:a(d,l.action);else {var q={lane:m,action:l.action,hasEagerState:l.hasEagerState,
	eagerState:l.eagerState,next:null};null===k?(h=k=q,g=d):k=k.next=q;N.lanes|=m;hh|=m;}l=l.next;}while(null!==l&&l!==f);null===k?g=d:k.next=h;He(d,b.memoizedState)||(Ug=!0);b.memoizedState=d;b.baseState=g;b.baseQueue=k;c.lastRenderedState=d;}a=c.interleaved;if(null!==a){e=a;do f=e.lane,N.lanes|=f,hh|=f,e=e.next;while(e!==a)}else null===e&&(c.lanes=0);return [b.memoizedState,c.dispatch]}
	function gi(a){var b=di(),c=b.queue;if(null===c)throw Error(p(311));c.lastRenderedReducer=a;var d=c.dispatch,e=c.pending,f=b.memoizedState;if(null!==e){c.pending=null;var g=e=e.next;do f=a(f,g.action),g=g.next;while(g!==e);He(f,b.memoizedState)||(Ug=!0);b.memoizedState=f;null===b.baseQueue&&(b.baseState=f);c.lastRenderedState=f;}return [f,d]}function hi(){}
	function ii(a,b){var c=N,d=di(),e=b(),f=!He(d.memoizedState,e);f&&(d.memoizedState=e,Ug=!0);d=d.queue;ji(ki.bind(null,c,d,a),[a]);if(d.getSnapshot!==b||f||null!==P&&P.memoizedState.tag&1){c.flags|=2048;li(9,mi.bind(null,c,d,e,b),void 0,null);if(null===R)throw Error(p(349));0!==(Rh&30)||ni(c,b,e);}return e}function ni(a,b,c){a.flags|=16384;a={getSnapshot:b,value:c};b=N.updateQueue;null===b?(b={lastEffect:null,stores:null},N.updateQueue=b,b.stores=[a]):(c=b.stores,null===c?b.stores=[a]:c.push(a));}
	function mi(a,b,c,d){b.value=c;b.getSnapshot=d;oi(b)&&pi(a);}function ki(a,b,c){return c(function(){oi(b)&&pi(a);})}function oi(a){var b=a.getSnapshot;a=a.value;try{var c=b();return !He(a,c)}catch(d){return !0}}function pi(a){var b=Zg(a,1);null!==b&&mh(b,a,1,-1);}
	function qi(a){var b=ci();"function"===typeof a&&(a=a());b.memoizedState=b.baseState=a;a={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:ei,lastRenderedState:a};b.queue=a;a=a.dispatch=ri.bind(null,N,a);return [b.memoizedState,a]}
	function li(a,b,c,d){a={tag:a,create:b,destroy:c,deps:d,next:null};b=N.updateQueue;null===b?(b={lastEffect:null,stores:null},N.updateQueue=b,b.lastEffect=a.next=a):(c=b.lastEffect,null===c?b.lastEffect=a.next=a:(d=c.next,c.next=a,a.next=d,b.lastEffect=a));return a}function si(){return di().memoizedState}function ti(a,b,c,d){var e=ci();N.flags|=a;e.memoizedState=li(1|b,c,void 0,void 0===d?null:d);}
	function ui(a,b,c,d){var e=di();d=void 0===d?null:d;var f=void 0;if(null!==O){var g=O.memoizedState;f=g.destroy;if(null!==d&&Wh(d,g.deps)){e.memoizedState=li(b,c,f,d);return}}N.flags|=a;e.memoizedState=li(1|b,c,f,d);}function vi(a,b){return ti(8390656,8,a,b)}function ji(a,b){return ui(2048,8,a,b)}function wi(a,b){return ui(4,2,a,b)}function xi(a,b){return ui(4,4,a,b)}
	function yi(a,b){if("function"===typeof b)return a=a(),b(a),function(){b(null);};if(null!==b&&void 0!==b)return a=a(),b.current=a,function(){b.current=null;}}function zi(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return ui(4,4,yi.bind(null,b,a),c)}function Ai(){}function Bi(a,b){var c=di();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Wh(b,d[1]))return d[0];c.memoizedState=[a,b];return a}
	function Ci(a,b){var c=di();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Wh(b,d[1]))return d[0];a=a();c.memoizedState=[a,b];return a}function Di(a,b,c){if(0===(Rh&21))return a.baseState&&(a.baseState=!1,Ug=!0),a.memoizedState=c;He(c,b)||(c=yc(),N.lanes|=c,hh|=c,a.baseState=!0);return b}function Ei(a,b){var c=C;C=0!==c&&4>c?c:4;a(!0);var d=Qh.transition;Qh.transition={};try{a(!1),b();}finally{C=c,Qh.transition=d;}}function Fi(){return di().memoizedState}
	function Gi(a,b,c){var d=lh(a);c={lane:d,action:c,hasEagerState:!1,eagerState:null,next:null};if(Hi(a))Ii(b,c);else if(c=Yg(a,b,c,d),null!==c){var e=L();mh(c,a,d,e);Ji(c,b,d);}}
	function ri(a,b,c){var d=lh(a),e={lane:d,action:c,hasEagerState:!1,eagerState:null,next:null};if(Hi(a))Ii(b,e);else {var f=a.alternate;if(0===a.lanes&&(null===f||0===f.lanes)&&(f=b.lastRenderedReducer,null!==f))try{var g=b.lastRenderedState,h=f(g,c);e.hasEagerState=!0;e.eagerState=h;if(He(h,g)){var k=b.interleaved;null===k?(e.next=e,Xg(b)):(e.next=k.next,k.next=e);b.interleaved=e;return}}catch(l){}finally{}c=Yg(a,b,e,d);null!==c&&(e=L(),mh(c,a,d,e),Ji(c,b,d));}}
	function Hi(a){var b=a.alternate;return a===N||null!==b&&b===N}function Ii(a,b){Th=Sh=!0;var c=a.pending;null===c?b.next=b:(b.next=c.next,c.next=b);a.pending=b;}function Ji(a,b,c){if(0!==(c&4194240)){var d=b.lanes;d&=a.pendingLanes;c|=d;b.lanes=c;Cc(a,c);}}
	var ai={readContext:Vg,useCallback:Q,useContext:Q,useEffect:Q,useImperativeHandle:Q,useInsertionEffect:Q,useLayoutEffect:Q,useMemo:Q,useReducer:Q,useRef:Q,useState:Q,useDebugValue:Q,useDeferredValue:Q,useTransition:Q,useMutableSource:Q,useSyncExternalStore:Q,useId:Q,unstable_isNewReconciler:!1},Yh={readContext:Vg,useCallback:function(a,b){ci().memoizedState=[a,void 0===b?null:b];return a},useContext:Vg,useEffect:vi,useImperativeHandle:function(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return ti(4194308,
	4,yi.bind(null,b,a),c)},useLayoutEffect:function(a,b){return ti(4194308,4,a,b)},useInsertionEffect:function(a,b){return ti(4,2,a,b)},useMemo:function(a,b){var c=ci();b=void 0===b?null:b;a=a();c.memoizedState=[a,b];return a},useReducer:function(a,b,c){var d=ci();b=void 0!==c?c(b):b;d.memoizedState=d.baseState=b;a={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:a,lastRenderedState:b};d.queue=a;a=a.dispatch=Gi.bind(null,N,a);return [d.memoizedState,a]},useRef:function(a){var b=
	ci();a={current:a};return b.memoizedState=a},useState:qi,useDebugValue:Ai,useDeferredValue:function(a){return ci().memoizedState=a},useTransition:function(){var a=qi(!1),b=a[0];a=Ei.bind(null,a[1]);ci().memoizedState=a;return [b,a]},useMutableSource:function(){},useSyncExternalStore:function(a,b,c){var d=N,e=ci();if(I){if(void 0===c)throw Error(p(407));c=c();}else {c=b();if(null===R)throw Error(p(349));0!==(Rh&30)||ni(d,b,c);}e.memoizedState=c;var f={value:c,getSnapshot:b};e.queue=f;vi(ki.bind(null,d,
	f,a),[a]);d.flags|=2048;li(9,mi.bind(null,d,f,c,b),void 0,null);return c},useId:function(){var a=ci(),b=R.identifierPrefix;if(I){var c=sg;var d=rg;c=(d&~(1<<32-oc(d)-1)).toString(32)+c;b=":"+b+"R"+c;c=Uh++;0<c&&(b+="H"+c.toString(32));b+=":";}else c=Vh++,b=":"+b+"r"+c.toString(32)+":";return a.memoizedState=b},unstable_isNewReconciler:!1},Zh={readContext:Vg,useCallback:Bi,useContext:Vg,useEffect:ji,useImperativeHandle:zi,useInsertionEffect:wi,useLayoutEffect:xi,useMemo:Ci,useReducer:fi,useRef:si,useState:function(){return fi(ei)},
	useDebugValue:Ai,useDeferredValue:function(a){var b=di();return Di(b,O.memoizedState,a)},useTransition:function(){var a=fi(ei)[0],b=di().memoizedState;return [a,b]},useMutableSource:hi,useSyncExternalStore:ii,useId:Fi,unstable_isNewReconciler:!1},$h={readContext:Vg,useCallback:Bi,useContext:Vg,useEffect:ji,useImperativeHandle:zi,useInsertionEffect:wi,useLayoutEffect:xi,useMemo:Ci,useReducer:gi,useRef:si,useState:function(){return gi(ei)},useDebugValue:Ai,useDeferredValue:function(a){var b=di();return null===
	O?b.memoizedState=a:Di(b,O.memoizedState,a)},useTransition:function(){var a=gi(ei)[0],b=di().memoizedState;return [a,b]},useMutableSource:hi,useSyncExternalStore:ii,useId:Fi,unstable_isNewReconciler:!1};function Ki(a,b){try{var c="",d=b;do c+=Pa(d),d=d.return;while(d);var e=c;}catch(f){e="\nError generating stack: "+f.message+"\n"+f.stack;}return {value:a,source:b,stack:e,digest:null}}function Li(a,b,c){return {value:a,source:null,stack:null!=c?c:null,digest:null!=b?b:null}}
	function Mi(a,b){try{console.error(b.value);}catch(c){setTimeout(function(){throw c;});}}var Ni="function"===typeof WeakMap?WeakMap:Map;function Oi(a,b,c){c=ch(-1,c);c.tag=3;c.payload={element:null};var d=b.value;c.callback=function(){Pi||(Pi=!0,Qi=d);Mi(a,b);};return c}
	function Ri(a,b,c){c=ch(-1,c);c.tag=3;var d=a.type.getDerivedStateFromError;if("function"===typeof d){var e=b.value;c.payload=function(){return d(e)};c.callback=function(){Mi(a,b);};}var f=a.stateNode;null!==f&&"function"===typeof f.componentDidCatch&&(c.callback=function(){Mi(a,b);"function"!==typeof d&&(null===Si?Si=new Set([this]):Si.add(this));var c=b.stack;this.componentDidCatch(b.value,{componentStack:null!==c?c:""});});return c}
	function Ti(a,b,c){var d=a.pingCache;if(null===d){d=a.pingCache=new Ni;var e=new Set;d.set(b,e);}else e=d.get(b),void 0===e&&(e=new Set,d.set(b,e));e.has(c)||(e.add(c),a=Ui.bind(null,a,b,c),b.then(a,a));}function Vi(a){do{var b;if(b=13===a.tag)b=a.memoizedState,b=null!==b?null!==b.dehydrated?!0:!1:!0;if(b)return a;a=a.return;}while(null!==a);return null}
	function Wi(a,b,c,d,e){if(0===(a.mode&1))return a===b?a.flags|=65536:(a.flags|=128,c.flags|=131072,c.flags&=-52805,1===c.tag&&(null===c.alternate?c.tag=17:(b=ch(-1,1),b.tag=2,dh(c,b,1))),c.lanes|=1),a;a.flags|=65536;a.lanes=e;return a}var Xi=ua.ReactCurrentOwner,Ug=!1;function Yi(a,b,c,d){b.child=null===a?Ch(b,null,c,d):Bh(b,a.child,c,d);}
	function Zi(a,b,c,d,e){c=c.render;var f=b.ref;Tg(b,e);d=Xh(a,b,c,d,f,e);c=bi();if(null!==a&&!Ug)return b.updateQueue=a.updateQueue,b.flags&=-2053,a.lanes&=~e,$i(a,b,e);I&&c&&vg(b);b.flags|=1;Yi(a,b,d,e);return b.child}
	function aj(a,b,c,d,e){if(null===a){var f=c.type;if("function"===typeof f&&!bj(f)&&void 0===f.defaultProps&&null===c.compare&&void 0===c.defaultProps)return b.tag=15,b.type=f,cj(a,b,f,d,e);a=yh(c.type,null,d,b,b.mode,e);a.ref=b.ref;a.return=b;return b.child=a}f=a.child;if(0===(a.lanes&e)){var g=f.memoizedProps;c=c.compare;c=null!==c?c:Ie;if(c(g,d)&&a.ref===b.ref)return $i(a,b,e)}b.flags|=1;a=wh(f,d);a.ref=b.ref;a.return=b;return b.child=a}
	function cj(a,b,c,d,e){if(null!==a){var f=a.memoizedProps;if(Ie(f,d)&&a.ref===b.ref)if(Ug=!1,b.pendingProps=d=f,0!==(a.lanes&e))0!==(a.flags&131072)&&(Ug=!0);else return b.lanes=a.lanes,$i(a,b,e)}return dj(a,b,c,d,e)}
	function ej(a,b,c){var d=b.pendingProps,e=d.children,f=null!==a?a.memoizedState:null;if("hidden"===d.mode)if(0===(b.mode&1))b.memoizedState={baseLanes:0,cachePool:null,transitions:null},G(fj,gj),gj|=c;else {if(0===(c&1073741824))return a=null!==f?f.baseLanes|c:c,b.lanes=b.childLanes=1073741824,b.memoizedState={baseLanes:a,cachePool:null,transitions:null},b.updateQueue=null,G(fj,gj),gj|=a,null;b.memoizedState={baseLanes:0,cachePool:null,transitions:null};d=null!==f?f.baseLanes:c;G(fj,gj);gj|=d;}else null!==
	f?(d=f.baseLanes|c,b.memoizedState=null):d=c,G(fj,gj),gj|=d;Yi(a,b,e,c);return b.child}function hj(a,b){var c=b.ref;if(null===a&&null!==c||null!==a&&a.ref!==c)b.flags|=512,b.flags|=2097152;}function dj(a,b,c,d,e){var f=Zf(c)?Xf:H.current;f=Yf(b,f);Tg(b,e);c=Xh(a,b,c,d,f,e);d=bi();if(null!==a&&!Ug)return b.updateQueue=a.updateQueue,b.flags&=-2053,a.lanes&=~e,$i(a,b,e);I&&d&&vg(b);b.flags|=1;Yi(a,b,c,e);return b.child}
	function ij(a,b,c,d,e){if(Zf(c)){var f=!0;cg(b);}else f=!1;Tg(b,e);if(null===b.stateNode)jj(a,b),ph(b,c,d),rh(b,c,d,e),d=!0;else if(null===a){var g=b.stateNode,h=b.memoizedProps;g.props=h;var k=g.context,l=c.contextType;"object"===typeof l&&null!==l?l=Vg(l):(l=Zf(c)?Xf:H.current,l=Yf(b,l));var m=c.getDerivedStateFromProps,q="function"===typeof m||"function"===typeof g.getSnapshotBeforeUpdate;q||"function"!==typeof g.UNSAFE_componentWillReceiveProps&&"function"!==typeof g.componentWillReceiveProps||
	(h!==d||k!==l)&&qh(b,g,d,l);$g=!1;var r=b.memoizedState;g.state=r;gh(b,d,g,e);k=b.memoizedState;h!==d||r!==k||Wf.current||$g?("function"===typeof m&&(kh(b,c,m,d),k=b.memoizedState),(h=$g||oh(b,c,h,d,r,k,l))?(q||"function"!==typeof g.UNSAFE_componentWillMount&&"function"!==typeof g.componentWillMount||("function"===typeof g.componentWillMount&&g.componentWillMount(),"function"===typeof g.UNSAFE_componentWillMount&&g.UNSAFE_componentWillMount()),"function"===typeof g.componentDidMount&&(b.flags|=4194308)):
	("function"===typeof g.componentDidMount&&(b.flags|=4194308),b.memoizedProps=d,b.memoizedState=k),g.props=d,g.state=k,g.context=l,d=h):("function"===typeof g.componentDidMount&&(b.flags|=4194308),d=!1);}else {g=b.stateNode;bh(a,b);h=b.memoizedProps;l=b.type===b.elementType?h:Lg(b.type,h);g.props=l;q=b.pendingProps;r=g.context;k=c.contextType;"object"===typeof k&&null!==k?k=Vg(k):(k=Zf(c)?Xf:H.current,k=Yf(b,k));var y=c.getDerivedStateFromProps;(m="function"===typeof y||"function"===typeof g.getSnapshotBeforeUpdate)||
	"function"!==typeof g.UNSAFE_componentWillReceiveProps&&"function"!==typeof g.componentWillReceiveProps||(h!==q||r!==k)&&qh(b,g,d,k);$g=!1;r=b.memoizedState;g.state=r;gh(b,d,g,e);var n=b.memoizedState;h!==q||r!==n||Wf.current||$g?("function"===typeof y&&(kh(b,c,y,d),n=b.memoizedState),(l=$g||oh(b,c,l,d,r,n,k)||!1)?(m||"function"!==typeof g.UNSAFE_componentWillUpdate&&"function"!==typeof g.componentWillUpdate||("function"===typeof g.componentWillUpdate&&g.componentWillUpdate(d,n,k),"function"===typeof g.UNSAFE_componentWillUpdate&&
	g.UNSAFE_componentWillUpdate(d,n,k)),"function"===typeof g.componentDidUpdate&&(b.flags|=4),"function"===typeof g.getSnapshotBeforeUpdate&&(b.flags|=1024)):("function"!==typeof g.componentDidUpdate||h===a.memoizedProps&&r===a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&r===a.memoizedState||(b.flags|=1024),b.memoizedProps=d,b.memoizedState=n),g.props=d,g.state=n,g.context=k,d=l):("function"!==typeof g.componentDidUpdate||h===a.memoizedProps&&r===
	a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&r===a.memoizedState||(b.flags|=1024),d=!1);}return kj(a,b,c,d,f,e)}
	function kj(a,b,c,d,e,f){hj(a,b);var g=0!==(b.flags&128);if(!d&&!g)return e&&dg(b,c,!1),$i(a,b,f);d=b.stateNode;Xi.current=b;var h=g&&"function"!==typeof c.getDerivedStateFromError?null:d.render();b.flags|=1;null!==a&&g?(b.child=Bh(b,a.child,null,f),b.child=Bh(b,null,h,f)):Yi(a,b,h,f);b.memoizedState=d.state;e&&dg(b,c,!0);return b.child}function lj(a){var b=a.stateNode;b.pendingContext?ag(a,b.pendingContext,b.pendingContext!==b.context):b.context&&ag(a,b.context,!1);Ih(a,b.containerInfo);}
	function mj(a,b,c,d,e){Ig();Jg(e);b.flags|=256;Yi(a,b,c,d);return b.child}var nj={dehydrated:null,treeContext:null,retryLane:0};function oj(a){return {baseLanes:a,cachePool:null,transitions:null}}
	function pj(a,b,c){var d=b.pendingProps,e=M.current,f=!1,g=0!==(b.flags&128),h;(h=g)||(h=null!==a&&null===a.memoizedState?!1:0!==(e&2));if(h)f=!0,b.flags&=-129;else if(null===a||null!==a.memoizedState)e|=1;G(M,e&1);if(null===a){Eg(b);a=b.memoizedState;if(null!==a&&(a=a.dehydrated,null!==a))return 0===(b.mode&1)?b.lanes=1:"$!"===a.data?b.lanes=8:b.lanes=1073741824,null;g=d.children;a=d.fallback;return f?(d=b.mode,f=b.child,g={mode:"hidden",children:g},0===(d&1)&&null!==f?(f.childLanes=0,f.pendingProps=
	g):f=qj(g,d,0,null),a=Ah(a,d,c,null),f.return=b,a.return=b,f.sibling=a,b.child=f,b.child.memoizedState=oj(c),b.memoizedState=nj,a):rj(b,g)}e=a.memoizedState;if(null!==e&&(h=e.dehydrated,null!==h))return sj(a,b,g,d,h,e,c);if(f){f=d.fallback;g=b.mode;e=a.child;h=e.sibling;var k={mode:"hidden",children:d.children};0===(g&1)&&b.child!==e?(d=b.child,d.childLanes=0,d.pendingProps=k,b.deletions=null):(d=wh(e,k),d.subtreeFlags=e.subtreeFlags&14680064);null!==h?f=wh(h,f):(f=Ah(f,g,c,null),f.flags|=2);f.return=
	b;d.return=b;d.sibling=f;b.child=d;d=f;f=b.child;g=a.child.memoizedState;g=null===g?oj(c):{baseLanes:g.baseLanes|c,cachePool:null,transitions:g.transitions};f.memoizedState=g;f.childLanes=a.childLanes&~c;b.memoizedState=nj;return d}f=a.child;a=f.sibling;d=wh(f,{mode:"visible",children:d.children});0===(b.mode&1)&&(d.lanes=c);d.return=b;d.sibling=null;null!==a&&(c=b.deletions,null===c?(b.deletions=[a],b.flags|=16):c.push(a));b.child=d;b.memoizedState=null;return d}
	function rj(a,b){b=qj({mode:"visible",children:b},a.mode,0,null);b.return=a;return a.child=b}function tj(a,b,c,d){null!==d&&Jg(d);Bh(b,a.child,null,c);a=rj(b,b.pendingProps.children);a.flags|=2;b.memoizedState=null;return a}
	function sj(a,b,c,d,e,f,g){if(c){if(b.flags&256)return b.flags&=-257,d=Li(Error(p(422))),tj(a,b,g,d);if(null!==b.memoizedState)return b.child=a.child,b.flags|=128,null;f=d.fallback;e=b.mode;d=qj({mode:"visible",children:d.children},e,0,null);f=Ah(f,e,g,null);f.flags|=2;d.return=b;f.return=b;d.sibling=f;b.child=d;0!==(b.mode&1)&&Bh(b,a.child,null,g);b.child.memoizedState=oj(g);b.memoizedState=nj;return f}if(0===(b.mode&1))return tj(a,b,g,null);if("$!"===e.data){d=e.nextSibling&&e.nextSibling.dataset;
	if(d)var h=d.dgst;d=h;f=Error(p(419));d=Li(f,d,void 0);return tj(a,b,g,d)}h=0!==(g&a.childLanes);if(Ug||h){d=R;if(null!==d){switch(g&-g){case 4:e=2;break;case 16:e=8;break;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:e=32;break;case 536870912:e=268435456;break;default:e=0;}e=0!==(e&(d.suspendedLanes|g))?0:e;
	0!==e&&e!==f.retryLane&&(f.retryLane=e,Zg(a,e),mh(d,a,e,-1));}uj();d=Li(Error(p(421)));return tj(a,b,g,d)}if("$?"===e.data)return b.flags|=128,b.child=a.child,b=vj.bind(null,a),e._reactRetry=b,null;a=f.treeContext;yg=Lf(e.nextSibling);xg=b;I=!0;zg=null;null!==a&&(og[pg++]=rg,og[pg++]=sg,og[pg++]=qg,rg=a.id,sg=a.overflow,qg=b);b=rj(b,d.children);b.flags|=4096;return b}function wj(a,b,c){a.lanes|=b;var d=a.alternate;null!==d&&(d.lanes|=b);Sg(a.return,b,c);}
	function xj(a,b,c,d,e){var f=a.memoizedState;null===f?a.memoizedState={isBackwards:b,rendering:null,renderingStartTime:0,last:d,tail:c,tailMode:e}:(f.isBackwards=b,f.rendering=null,f.renderingStartTime=0,f.last=d,f.tail=c,f.tailMode=e);}
	function yj(a,b,c){var d=b.pendingProps,e=d.revealOrder,f=d.tail;Yi(a,b,d.children,c);d=M.current;if(0!==(d&2))d=d&1|2,b.flags|=128;else {if(null!==a&&0!==(a.flags&128))a:for(a=b.child;null!==a;){if(13===a.tag)null!==a.memoizedState&&wj(a,c,b);else if(19===a.tag)wj(a,c,b);else if(null!==a.child){a.child.return=a;a=a.child;continue}if(a===b)break a;for(;null===a.sibling;){if(null===a.return||a.return===b)break a;a=a.return;}a.sibling.return=a.return;a=a.sibling;}d&=1;}G(M,d);if(0===(b.mode&1))b.memoizedState=
	null;else switch(e){case "forwards":c=b.child;for(e=null;null!==c;)a=c.alternate,null!==a&&null===Mh(a)&&(e=c),c=c.sibling;c=e;null===c?(e=b.child,b.child=null):(e=c.sibling,c.sibling=null);xj(b,!1,e,c,f);break;case "backwards":c=null;e=b.child;for(b.child=null;null!==e;){a=e.alternate;if(null!==a&&null===Mh(a)){b.child=e;break}a=e.sibling;e.sibling=c;c=e;e=a;}xj(b,!0,c,null,f);break;case "together":xj(b,!1,null,null,void 0);break;default:b.memoizedState=null;}return b.child}
	function jj(a,b){0===(b.mode&1)&&null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2);}function $i(a,b,c){null!==a&&(b.dependencies=a.dependencies);hh|=b.lanes;if(0===(c&b.childLanes))return null;if(null!==a&&b.child!==a.child)throw Error(p(153));if(null!==b.child){a=b.child;c=wh(a,a.pendingProps);b.child=c;for(c.return=b;null!==a.sibling;)a=a.sibling,c=c.sibling=wh(a,a.pendingProps),c.return=b;c.sibling=null;}return b.child}
	function zj(a,b,c){switch(b.tag){case 3:lj(b);Ig();break;case 5:Kh(b);break;case 1:Zf(b.type)&&cg(b);break;case 4:Ih(b,b.stateNode.containerInfo);break;case 10:var d=b.type._context,e=b.memoizedProps.value;G(Mg,d._currentValue);d._currentValue=e;break;case 13:d=b.memoizedState;if(null!==d){if(null!==d.dehydrated)return G(M,M.current&1),b.flags|=128,null;if(0!==(c&b.child.childLanes))return pj(a,b,c);G(M,M.current&1);a=$i(a,b,c);return null!==a?a.sibling:null}G(M,M.current&1);break;case 19:d=0!==(c&
	b.childLanes);if(0!==(a.flags&128)){if(d)return yj(a,b,c);b.flags|=128;}e=b.memoizedState;null!==e&&(e.rendering=null,e.tail=null,e.lastEffect=null);G(M,M.current);if(d)break;else return null;case 22:case 23:return b.lanes=0,ej(a,b,c)}return $i(a,b,c)}var Aj,Bj,Cj,Dj;
	Aj=function(a,b){for(var c=b.child;null!==c;){if(5===c.tag||6===c.tag)a.appendChild(c.stateNode);else if(4!==c.tag&&null!==c.child){c.child.return=c;c=c.child;continue}if(c===b)break;for(;null===c.sibling;){if(null===c.return||c.return===b)return;c=c.return;}c.sibling.return=c.return;c=c.sibling;}};Bj=function(){};
	Cj=function(a,b,c,d){var e=a.memoizedProps;if(e!==d){a=b.stateNode;Hh(Eh.current);var f=null;switch(c){case "input":e=Ya(a,e);d=Ya(a,d);f=[];break;case "select":e=A({},e,{value:void 0});d=A({},d,{value:void 0});f=[];break;case "textarea":e=gb(a,e);d=gb(a,d);f=[];break;default:"function"!==typeof e.onClick&&"function"===typeof d.onClick&&(a.onclick=Bf);}ub(c,d);var g;c=null;for(l in e)if(!d.hasOwnProperty(l)&&e.hasOwnProperty(l)&&null!=e[l])if("style"===l){var h=e[l];for(g in h)h.hasOwnProperty(g)&&
	(c||(c={}),c[g]="");}else "dangerouslySetInnerHTML"!==l&&"children"!==l&&"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&"autoFocus"!==l&&(ea.hasOwnProperty(l)?f||(f=[]):(f=f||[]).push(l,null));for(l in d){var k=d[l];h=null!=e?e[l]:void 0;if(d.hasOwnProperty(l)&&k!==h&&(null!=k||null!=h))if("style"===l)if(h){for(g in h)!h.hasOwnProperty(g)||k&&k.hasOwnProperty(g)||(c||(c={}),c[g]="");for(g in k)k.hasOwnProperty(g)&&h[g]!==k[g]&&(c||(c={}),c[g]=k[g]);}else c||(f||(f=[]),f.push(l,
	c)),c=k;else "dangerouslySetInnerHTML"===l?(k=k?k.__html:void 0,h=h?h.__html:void 0,null!=k&&h!==k&&(f=f||[]).push(l,k)):"children"===l?"string"!==typeof k&&"number"!==typeof k||(f=f||[]).push(l,""+k):"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&(ea.hasOwnProperty(l)?(null!=k&&"onScroll"===l&&D("scroll",a),f||h===k||(f=[])):(f=f||[]).push(l,k));}c&&(f=f||[]).push("style",c);var l=f;if(b.updateQueue=l)b.flags|=4;}};Dj=function(a,b,c,d){c!==d&&(b.flags|=4);};
	function Ej(a,b){if(!I)switch(a.tailMode){case "hidden":b=a.tail;for(var c=null;null!==b;)null!==b.alternate&&(c=b),b=b.sibling;null===c?a.tail=null:c.sibling=null;break;case "collapsed":c=a.tail;for(var d=null;null!==c;)null!==c.alternate&&(d=c),c=c.sibling;null===d?b||null===a.tail?a.tail=null:a.tail.sibling=null:d.sibling=null;}}
	function S(a){var b=null!==a.alternate&&a.alternate.child===a.child,c=0,d=0;if(b)for(var e=a.child;null!==e;)c|=e.lanes|e.childLanes,d|=e.subtreeFlags&14680064,d|=e.flags&14680064,e.return=a,e=e.sibling;else for(e=a.child;null!==e;)c|=e.lanes|e.childLanes,d|=e.subtreeFlags,d|=e.flags,e.return=a,e=e.sibling;a.subtreeFlags|=d;a.childLanes=c;return b}
	function Fj(a,b,c){var d=b.pendingProps;wg(b);switch(b.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return S(b),null;case 1:return Zf(b.type)&&$f(),S(b),null;case 3:d=b.stateNode;Jh();E(Wf);E(H);Oh();d.pendingContext&&(d.context=d.pendingContext,d.pendingContext=null);if(null===a||null===a.child)Gg(b)?b.flags|=4:null===a||a.memoizedState.isDehydrated&&0===(b.flags&256)||(b.flags|=1024,null!==zg&&(Gj(zg),zg=null));Bj(a,b);S(b);return null;case 5:Lh(b);var e=Hh(Gh.current);
	c=b.type;if(null!==a&&null!=b.stateNode)Cj(a,b,c,d,e),a.ref!==b.ref&&(b.flags|=512,b.flags|=2097152);else {if(!d){if(null===b.stateNode)throw Error(p(166));S(b);return null}a=Hh(Eh.current);if(Gg(b)){d=b.stateNode;c=b.type;var f=b.memoizedProps;d[Of]=b;d[Pf]=f;a=0!==(b.mode&1);switch(c){case "dialog":D("cancel",d);D("close",d);break;case "iframe":case "object":case "embed":D("load",d);break;case "video":case "audio":for(e=0;e<lf.length;e++)D(lf[e],d);break;case "source":D("error",d);break;case "img":case "image":case "link":D("error",
	d);D("load",d);break;case "details":D("toggle",d);break;case "input":Za(d,f);D("invalid",d);break;case "select":d._wrapperState={wasMultiple:!!f.multiple};D("invalid",d);break;case "textarea":hb(d,f),D("invalid",d);}ub(c,f);e=null;for(var g in f)if(f.hasOwnProperty(g)){var h=f[g];"children"===g?"string"===typeof h?d.textContent!==h&&(!0!==f.suppressHydrationWarning&&Af(d.textContent,h,a),e=["children",h]):"number"===typeof h&&d.textContent!==""+h&&(!0!==f.suppressHydrationWarning&&Af(d.textContent,
	h,a),e=["children",""+h]):ea.hasOwnProperty(g)&&null!=h&&"onScroll"===g&&D("scroll",d);}switch(c){case "input":Va(d);db(d,f,!0);break;case "textarea":Va(d);jb(d);break;case "select":case "option":break;default:"function"===typeof f.onClick&&(d.onclick=Bf);}d=e;b.updateQueue=d;null!==d&&(b.flags|=4);}else {g=9===e.nodeType?e:e.ownerDocument;"http://www.w3.org/1999/xhtml"===a&&(a=kb(c));"http://www.w3.org/1999/xhtml"===a?"script"===c?(a=g.createElement("div"),a.innerHTML="<script>\x3c/script>",a=a.removeChild(a.firstChild)):
	"string"===typeof d.is?a=g.createElement(c,{is:d.is}):(a=g.createElement(c),"select"===c&&(g=a,d.multiple?g.multiple=!0:d.size&&(g.size=d.size))):a=g.createElementNS(a,c);a[Of]=b;a[Pf]=d;Aj(a,b,!1,!1);b.stateNode=a;a:{g=vb(c,d);switch(c){case "dialog":D("cancel",a);D("close",a);e=d;break;case "iframe":case "object":case "embed":D("load",a);e=d;break;case "video":case "audio":for(e=0;e<lf.length;e++)D(lf[e],a);e=d;break;case "source":D("error",a);e=d;break;case "img":case "image":case "link":D("error",
	a);D("load",a);e=d;break;case "details":D("toggle",a);e=d;break;case "input":Za(a,d);e=Ya(a,d);D("invalid",a);break;case "option":e=d;break;case "select":a._wrapperState={wasMultiple:!!d.multiple};e=A({},d,{value:void 0});D("invalid",a);break;case "textarea":hb(a,d);e=gb(a,d);D("invalid",a);break;default:e=d;}ub(c,e);h=e;for(f in h)if(h.hasOwnProperty(f)){var k=h[f];"style"===f?sb(a,k):"dangerouslySetInnerHTML"===f?(k=k?k.__html:void 0,null!=k&&nb(a,k)):"children"===f?"string"===typeof k?("textarea"!==
	c||""!==k)&&ob(a,k):"number"===typeof k&&ob(a,""+k):"suppressContentEditableWarning"!==f&&"suppressHydrationWarning"!==f&&"autoFocus"!==f&&(ea.hasOwnProperty(f)?null!=k&&"onScroll"===f&&D("scroll",a):null!=k&&ta(a,f,k,g));}switch(c){case "input":Va(a);db(a,d,!1);break;case "textarea":Va(a);jb(a);break;case "option":null!=d.value&&a.setAttribute("value",""+Sa(d.value));break;case "select":a.multiple=!!d.multiple;f=d.value;null!=f?fb(a,!!d.multiple,f,!1):null!=d.defaultValue&&fb(a,!!d.multiple,d.defaultValue,
	!0);break;default:"function"===typeof e.onClick&&(a.onclick=Bf);}switch(c){case "button":case "input":case "select":case "textarea":d=!!d.autoFocus;break a;case "img":d=!0;break a;default:d=!1;}}d&&(b.flags|=4);}null!==b.ref&&(b.flags|=512,b.flags|=2097152);}S(b);return null;case 6:if(a&&null!=b.stateNode)Dj(a,b,a.memoizedProps,d);else {if("string"!==typeof d&&null===b.stateNode)throw Error(p(166));c=Hh(Gh.current);Hh(Eh.current);if(Gg(b)){d=b.stateNode;c=b.memoizedProps;d[Of]=b;if(f=d.nodeValue!==c)if(a=
	xg,null!==a)switch(a.tag){case 3:Af(d.nodeValue,c,0!==(a.mode&1));break;case 5:!0!==a.memoizedProps.suppressHydrationWarning&&Af(d.nodeValue,c,0!==(a.mode&1));}f&&(b.flags|=4);}else d=(9===c.nodeType?c:c.ownerDocument).createTextNode(d),d[Of]=b,b.stateNode=d;}S(b);return null;case 13:E(M);d=b.memoizedState;if(null===a||null!==a.memoizedState&&null!==a.memoizedState.dehydrated){if(I&&null!==yg&&0!==(b.mode&1)&&0===(b.flags&128))Hg(),Ig(),b.flags|=98560,f=!1;else if(f=Gg(b),null!==d&&null!==d.dehydrated){if(null===
	a){if(!f)throw Error(p(318));f=b.memoizedState;f=null!==f?f.dehydrated:null;if(!f)throw Error(p(317));f[Of]=b;}else Ig(),0===(b.flags&128)&&(b.memoizedState=null),b.flags|=4;S(b);f=!1;}else null!==zg&&(Gj(zg),zg=null),f=!0;if(!f)return b.flags&65536?b:null}if(0!==(b.flags&128))return b.lanes=c,b;d=null!==d;d!==(null!==a&&null!==a.memoizedState)&&d&&(b.child.flags|=8192,0!==(b.mode&1)&&(null===a||0!==(M.current&1)?0===T&&(T=3):uj()));null!==b.updateQueue&&(b.flags|=4);S(b);return null;case 4:return Jh(),
	Bj(a,b),null===a&&sf(b.stateNode.containerInfo),S(b),null;case 10:return Rg(b.type._context),S(b),null;case 17:return Zf(b.type)&&$f(),S(b),null;case 19:E(M);f=b.memoizedState;if(null===f)return S(b),null;d=0!==(b.flags&128);g=f.rendering;if(null===g)if(d)Ej(f,!1);else {if(0!==T||null!==a&&0!==(a.flags&128))for(a=b.child;null!==a;){g=Mh(a);if(null!==g){b.flags|=128;Ej(f,!1);d=g.updateQueue;null!==d&&(b.updateQueue=d,b.flags|=4);b.subtreeFlags=0;d=c;for(c=b.child;null!==c;)f=c,a=d,f.flags&=14680066,
	g=f.alternate,null===g?(f.childLanes=0,f.lanes=a,f.child=null,f.subtreeFlags=0,f.memoizedProps=null,f.memoizedState=null,f.updateQueue=null,f.dependencies=null,f.stateNode=null):(f.childLanes=g.childLanes,f.lanes=g.lanes,f.child=g.child,f.subtreeFlags=0,f.deletions=null,f.memoizedProps=g.memoizedProps,f.memoizedState=g.memoizedState,f.updateQueue=g.updateQueue,f.type=g.type,a=g.dependencies,f.dependencies=null===a?null:{lanes:a.lanes,firstContext:a.firstContext}),c=c.sibling;G(M,M.current&1|2);return b.child}a=
	a.sibling;}null!==f.tail&&B()>Hj&&(b.flags|=128,d=!0,Ej(f,!1),b.lanes=4194304);}else {if(!d)if(a=Mh(g),null!==a){if(b.flags|=128,d=!0,c=a.updateQueue,null!==c&&(b.updateQueue=c,b.flags|=4),Ej(f,!0),null===f.tail&&"hidden"===f.tailMode&&!g.alternate&&!I)return S(b),null}else 2*B()-f.renderingStartTime>Hj&&1073741824!==c&&(b.flags|=128,d=!0,Ej(f,!1),b.lanes=4194304);f.isBackwards?(g.sibling=b.child,b.child=g):(c=f.last,null!==c?c.sibling=g:b.child=g,f.last=g);}if(null!==f.tail)return b=f.tail,f.rendering=
	b,f.tail=b.sibling,f.renderingStartTime=B(),b.sibling=null,c=M.current,G(M,d?c&1|2:c&1),b;S(b);return null;case 22:case 23:return Ij(),d=null!==b.memoizedState,null!==a&&null!==a.memoizedState!==d&&(b.flags|=8192),d&&0!==(b.mode&1)?0!==(gj&1073741824)&&(S(b),b.subtreeFlags&6&&(b.flags|=8192)):S(b),null;case 24:return null;case 25:return null}throw Error(p(156,b.tag));}
	function Jj(a,b){wg(b);switch(b.tag){case 1:return Zf(b.type)&&$f(),a=b.flags,a&65536?(b.flags=a&-65537|128,b):null;case 3:return Jh(),E(Wf),E(H),Oh(),a=b.flags,0!==(a&65536)&&0===(a&128)?(b.flags=a&-65537|128,b):null;case 5:return Lh(b),null;case 13:E(M);a=b.memoizedState;if(null!==a&&null!==a.dehydrated){if(null===b.alternate)throw Error(p(340));Ig();}a=b.flags;return a&65536?(b.flags=a&-65537|128,b):null;case 19:return E(M),null;case 4:return Jh(),null;case 10:return Rg(b.type._context),null;case 22:case 23:return Ij(),
	null;case 24:return null;default:return null}}var Kj=!1,U=!1,Lj="function"===typeof WeakSet?WeakSet:Set,V=null;function Mj(a,b){var c=a.ref;if(null!==c)if("function"===typeof c)try{c(null);}catch(d){W(a,b,d);}else c.current=null;}function Nj(a,b,c){try{c();}catch(d){W(a,b,d);}}var Oj=!1;
	function Pj(a,b){Cf=dd;a=Me();if(Ne(a)){if("selectionStart"in a)var c={start:a.selectionStart,end:a.selectionEnd};else a:{c=(c=a.ownerDocument)&&c.defaultView||window;var d=c.getSelection&&c.getSelection();if(d&&0!==d.rangeCount){c=d.anchorNode;var e=d.anchorOffset,f=d.focusNode;d=d.focusOffset;try{c.nodeType,f.nodeType;}catch(F){c=null;break a}var g=0,h=-1,k=-1,l=0,m=0,q=a,r=null;b:for(;;){for(var y;;){q!==c||0!==e&&3!==q.nodeType||(h=g+e);q!==f||0!==d&&3!==q.nodeType||(k=g+d);3===q.nodeType&&(g+=
	q.nodeValue.length);if(null===(y=q.firstChild))break;r=q;q=y;}for(;;){if(q===a)break b;r===c&&++l===e&&(h=g);r===f&&++m===d&&(k=g);if(null!==(y=q.nextSibling))break;q=r;r=q.parentNode;}q=y;}c=-1===h||-1===k?null:{start:h,end:k};}else c=null;}c=c||{start:0,end:0};}else c=null;Df={focusedElem:a,selectionRange:c};dd=!1;for(V=b;null!==V;)if(b=V,a=b.child,0!==(b.subtreeFlags&1028)&&null!==a)a.return=b,V=a;else for(;null!==V;){b=V;try{var n=b.alternate;if(0!==(b.flags&1024))switch(b.tag){case 0:case 11:case 15:break;
	case 1:if(null!==n){var t=n.memoizedProps,J=n.memoizedState,x=b.stateNode,w=x.getSnapshotBeforeUpdate(b.elementType===b.type?t:Lg(b.type,t),J);x.__reactInternalSnapshotBeforeUpdate=w;}break;case 3:var u=b.stateNode.containerInfo;1===u.nodeType?u.textContent="":9===u.nodeType&&u.documentElement&&u.removeChild(u.documentElement);break;case 5:case 6:case 4:case 17:break;default:throw Error(p(163));}}catch(F){W(b,b.return,F);}a=b.sibling;if(null!==a){a.return=b.return;V=a;break}V=b.return;}n=Oj;Oj=!1;return n}
	function Qj(a,b,c){var d=b.updateQueue;d=null!==d?d.lastEffect:null;if(null!==d){var e=d=d.next;do{if((e.tag&a)===a){var f=e.destroy;e.destroy=void 0;void 0!==f&&Nj(b,c,f);}e=e.next;}while(e!==d)}}function Rj(a,b){b=b.updateQueue;b=null!==b?b.lastEffect:null;if(null!==b){var c=b=b.next;do{if((c.tag&a)===a){var d=c.create;c.destroy=d();}c=c.next;}while(c!==b)}}function Sj(a){var b=a.ref;if(null!==b){var c=a.stateNode;switch(a.tag){case 5:a=c;break;default:a=c;}"function"===typeof b?b(a):b.current=a;}}
	function Tj(a){var b=a.alternate;null!==b&&(a.alternate=null,Tj(b));a.child=null;a.deletions=null;a.sibling=null;5===a.tag&&(b=a.stateNode,null!==b&&(delete b[Of],delete b[Pf],delete b[of],delete b[Qf],delete b[Rf]));a.stateNode=null;a.return=null;a.dependencies=null;a.memoizedProps=null;a.memoizedState=null;a.pendingProps=null;a.stateNode=null;a.updateQueue=null;}function Uj(a){return 5===a.tag||3===a.tag||4===a.tag}
	function Vj(a){a:for(;;){for(;null===a.sibling;){if(null===a.return||Uj(a.return))return null;a=a.return;}a.sibling.return=a.return;for(a=a.sibling;5!==a.tag&&6!==a.tag&&18!==a.tag;){if(a.flags&2)continue a;if(null===a.child||4===a.tag)continue a;else a.child.return=a,a=a.child;}if(!(a.flags&2))return a.stateNode}}
	function Wj(a,b,c){var d=a.tag;if(5===d||6===d)a=a.stateNode,b?8===c.nodeType?c.parentNode.insertBefore(a,b):c.insertBefore(a,b):(8===c.nodeType?(b=c.parentNode,b.insertBefore(a,c)):(b=c,b.appendChild(a)),c=c._reactRootContainer,null!==c&&void 0!==c||null!==b.onclick||(b.onclick=Bf));else if(4!==d&&(a=a.child,null!==a))for(Wj(a,b,c),a=a.sibling;null!==a;)Wj(a,b,c),a=a.sibling;}
	function Xj(a,b,c){var d=a.tag;if(5===d||6===d)a=a.stateNode,b?c.insertBefore(a,b):c.appendChild(a);else if(4!==d&&(a=a.child,null!==a))for(Xj(a,b,c),a=a.sibling;null!==a;)Xj(a,b,c),a=a.sibling;}var X=null,Yj=!1;function Zj(a,b,c){for(c=c.child;null!==c;)ak(a,b,c),c=c.sibling;}
	function ak(a,b,c){if(lc&&"function"===typeof lc.onCommitFiberUnmount)try{lc.onCommitFiberUnmount(kc,c);}catch(h){}switch(c.tag){case 5:U||Mj(c,b);case 6:var d=X,e=Yj;X=null;Zj(a,b,c);X=d;Yj=e;null!==X&&(Yj?(a=X,c=c.stateNode,8===a.nodeType?a.parentNode.removeChild(c):a.removeChild(c)):X.removeChild(c.stateNode));break;case 18:null!==X&&(Yj?(a=X,c=c.stateNode,8===a.nodeType?Kf(a.parentNode,c):1===a.nodeType&&Kf(a,c),bd(a)):Kf(X,c.stateNode));break;case 4:d=X;e=Yj;X=c.stateNode.containerInfo;Yj=!0;
	Zj(a,b,c);X=d;Yj=e;break;case 0:case 11:case 14:case 15:if(!U&&(d=c.updateQueue,null!==d&&(d=d.lastEffect,null!==d))){e=d=d.next;do{var f=e,g=f.destroy;f=f.tag;void 0!==g&&(0!==(f&2)?Nj(c,b,g):0!==(f&4)&&Nj(c,b,g));e=e.next;}while(e!==d)}Zj(a,b,c);break;case 1:if(!U&&(Mj(c,b),d=c.stateNode,"function"===typeof d.componentWillUnmount))try{d.props=c.memoizedProps,d.state=c.memoizedState,d.componentWillUnmount();}catch(h){W(c,b,h);}Zj(a,b,c);break;case 21:Zj(a,b,c);break;case 22:c.mode&1?(U=(d=U)||null!==
	c.memoizedState,Zj(a,b,c),U=d):Zj(a,b,c);break;default:Zj(a,b,c);}}function bk(a){var b=a.updateQueue;if(null!==b){a.updateQueue=null;var c=a.stateNode;null===c&&(c=a.stateNode=new Lj);b.forEach(function(b){var d=ck.bind(null,a,b);c.has(b)||(c.add(b),b.then(d,d));});}}
	function dk(a,b){var c=b.deletions;if(null!==c)for(var d=0;d<c.length;d++){var e=c[d];try{var f=a,g=b,h=g;a:for(;null!==h;){switch(h.tag){case 5:X=h.stateNode;Yj=!1;break a;case 3:X=h.stateNode.containerInfo;Yj=!0;break a;case 4:X=h.stateNode.containerInfo;Yj=!0;break a}h=h.return;}if(null===X)throw Error(p(160));ak(f,g,e);X=null;Yj=!1;var k=e.alternate;null!==k&&(k.return=null);e.return=null;}catch(l){W(e,b,l);}}if(b.subtreeFlags&12854)for(b=b.child;null!==b;)ek(b,a),b=b.sibling;}
	function ek(a,b){var c=a.alternate,d=a.flags;switch(a.tag){case 0:case 11:case 14:case 15:dk(b,a);fk(a);if(d&4){try{Qj(3,a,a.return),Rj(3,a);}catch(t){W(a,a.return,t);}try{Qj(5,a,a.return);}catch(t){W(a,a.return,t);}}break;case 1:dk(b,a);fk(a);d&512&&null!==c&&Mj(c,c.return);break;case 5:dk(b,a);fk(a);d&512&&null!==c&&Mj(c,c.return);if(a.flags&32){var e=a.stateNode;try{ob(e,"");}catch(t){W(a,a.return,t);}}if(d&4&&(e=a.stateNode,null!=e)){var f=a.memoizedProps,g=null!==c?c.memoizedProps:f,h=a.type,k=a.updateQueue;
	a.updateQueue=null;if(null!==k)try{"input"===h&&"radio"===f.type&&null!=f.name&&ab(e,f);vb(h,g);var l=vb(h,f);for(g=0;g<k.length;g+=2){var m=k[g],q=k[g+1];"style"===m?sb(e,q):"dangerouslySetInnerHTML"===m?nb(e,q):"children"===m?ob(e,q):ta(e,m,q,l);}switch(h){case "input":bb(e,f);break;case "textarea":ib(e,f);break;case "select":var r=e._wrapperState.wasMultiple;e._wrapperState.wasMultiple=!!f.multiple;var y=f.value;null!=y?fb(e,!!f.multiple,y,!1):r!==!!f.multiple&&(null!=f.defaultValue?fb(e,!!f.multiple,
	f.defaultValue,!0):fb(e,!!f.multiple,f.multiple?[]:"",!1));}e[Pf]=f;}catch(t){W(a,a.return,t);}}break;case 6:dk(b,a);fk(a);if(d&4){if(null===a.stateNode)throw Error(p(162));e=a.stateNode;f=a.memoizedProps;try{e.nodeValue=f;}catch(t){W(a,a.return,t);}}break;case 3:dk(b,a);fk(a);if(d&4&&null!==c&&c.memoizedState.isDehydrated)try{bd(b.containerInfo);}catch(t){W(a,a.return,t);}break;case 4:dk(b,a);fk(a);break;case 13:dk(b,a);fk(a);e=a.child;e.flags&8192&&(f=null!==e.memoizedState,e.stateNode.isHidden=f,!f||
	null!==e.alternate&&null!==e.alternate.memoizedState||(gk=B()));d&4&&bk(a);break;case 22:m=null!==c&&null!==c.memoizedState;a.mode&1?(U=(l=U)||m,dk(b,a),U=l):dk(b,a);fk(a);if(d&8192){l=null!==a.memoizedState;if((a.stateNode.isHidden=l)&&!m&&0!==(a.mode&1))for(V=a,m=a.child;null!==m;){for(q=V=m;null!==V;){r=V;y=r.child;switch(r.tag){case 0:case 11:case 14:case 15:Qj(4,r,r.return);break;case 1:Mj(r,r.return);var n=r.stateNode;if("function"===typeof n.componentWillUnmount){d=r;c=r.return;try{b=d,n.props=
	b.memoizedProps,n.state=b.memoizedState,n.componentWillUnmount();}catch(t){W(d,c,t);}}break;case 5:Mj(r,r.return);break;case 22:if(null!==r.memoizedState){hk(q);continue}}null!==y?(y.return=r,V=y):hk(q);}m=m.sibling;}a:for(m=null,q=a;;){if(5===q.tag){if(null===m){m=q;try{e=q.stateNode,l?(f=e.style,"function"===typeof f.setProperty?f.setProperty("display","none","important"):f.display="none"):(h=q.stateNode,k=q.memoizedProps.style,g=void 0!==k&&null!==k&&k.hasOwnProperty("display")?k.display:null,h.style.display=
	rb("display",g));}catch(t){W(a,a.return,t);}}}else if(6===q.tag){if(null===m)try{q.stateNode.nodeValue=l?"":q.memoizedProps;}catch(t){W(a,a.return,t);}}else if((22!==q.tag&&23!==q.tag||null===q.memoizedState||q===a)&&null!==q.child){q.child.return=q;q=q.child;continue}if(q===a)break a;for(;null===q.sibling;){if(null===q.return||q.return===a)break a;m===q&&(m=null);q=q.return;}m===q&&(m=null);q.sibling.return=q.return;q=q.sibling;}}break;case 19:dk(b,a);fk(a);d&4&&bk(a);break;case 21:break;default:dk(b,
	a),fk(a);}}function fk(a){var b=a.flags;if(b&2){try{a:{for(var c=a.return;null!==c;){if(Uj(c)){var d=c;break a}c=c.return;}throw Error(p(160));}switch(d.tag){case 5:var e=d.stateNode;d.flags&32&&(ob(e,""),d.flags&=-33);var f=Vj(a);Xj(a,f,e);break;case 3:case 4:var g=d.stateNode.containerInfo,h=Vj(a);Wj(a,h,g);break;default:throw Error(p(161));}}catch(k){W(a,a.return,k);}a.flags&=-3;}b&4096&&(a.flags&=-4097);}function ik(a,b,c){V=a;jk(a);}
	function jk(a,b,c){for(var d=0!==(a.mode&1);null!==V;){var e=V,f=e.child;if(22===e.tag&&d){var g=null!==e.memoizedState||Kj;if(!g){var h=e.alternate,k=null!==h&&null!==h.memoizedState||U;h=Kj;var l=U;Kj=g;if((U=k)&&!l)for(V=e;null!==V;)g=V,k=g.child,22===g.tag&&null!==g.memoizedState?kk(e):null!==k?(k.return=g,V=k):kk(e);for(;null!==f;)V=f,jk(f),f=f.sibling;V=e;Kj=h;U=l;}lk(a);}else 0!==(e.subtreeFlags&8772)&&null!==f?(f.return=e,V=f):lk(a);}}
	function lk(a){for(;null!==V;){var b=V;if(0!==(b.flags&8772)){var c=b.alternate;try{if(0!==(b.flags&8772))switch(b.tag){case 0:case 11:case 15:U||Rj(5,b);break;case 1:var d=b.stateNode;if(b.flags&4&&!U)if(null===c)d.componentDidMount();else {var e=b.elementType===b.type?c.memoizedProps:Lg(b.type,c.memoizedProps);d.componentDidUpdate(e,c.memoizedState,d.__reactInternalSnapshotBeforeUpdate);}var f=b.updateQueue;null!==f&&ih(b,f,d);break;case 3:var g=b.updateQueue;if(null!==g){c=null;if(null!==b.child)switch(b.child.tag){case 5:c=
	b.child.stateNode;break;case 1:c=b.child.stateNode;}ih(b,g,c);}break;case 5:var h=b.stateNode;if(null===c&&b.flags&4){c=h;var k=b.memoizedProps;switch(b.type){case "button":case "input":case "select":case "textarea":k.autoFocus&&c.focus();break;case "img":k.src&&(c.src=k.src);}}break;case 6:break;case 4:break;case 12:break;case 13:if(null===b.memoizedState){var l=b.alternate;if(null!==l){var m=l.memoizedState;if(null!==m){var q=m.dehydrated;null!==q&&bd(q);}}}break;case 19:case 17:case 21:case 22:case 23:case 25:break;
	default:throw Error(p(163));}U||b.flags&512&&Sj(b);}catch(r){W(b,b.return,r);}}if(b===a){V=null;break}c=b.sibling;if(null!==c){c.return=b.return;V=c;break}V=b.return;}}function hk(a){for(;null!==V;){var b=V;if(b===a){V=null;break}var c=b.sibling;if(null!==c){c.return=b.return;V=c;break}V=b.return;}}
	function kk(a){for(;null!==V;){var b=V;try{switch(b.tag){case 0:case 11:case 15:var c=b.return;try{Rj(4,b);}catch(k){W(b,c,k);}break;case 1:var d=b.stateNode;if("function"===typeof d.componentDidMount){var e=b.return;try{d.componentDidMount();}catch(k){W(b,e,k);}}var f=b.return;try{Sj(b);}catch(k){W(b,f,k);}break;case 5:var g=b.return;try{Sj(b);}catch(k){W(b,g,k);}}}catch(k){W(b,b.return,k);}if(b===a){V=null;break}var h=b.sibling;if(null!==h){h.return=b.return;V=h;break}V=b.return;}}
	var mk=Math.ceil,nk=ua.ReactCurrentDispatcher,ok=ua.ReactCurrentOwner,pk=ua.ReactCurrentBatchConfig,K=0,R=null,Y=null,Z=0,gj=0,fj=Uf(0),T=0,qk=null,hh=0,rk=0,sk=0,tk=null,uk=null,gk=0,Hj=Infinity,vk=null,Pi=!1,Qi=null,Si=null,wk=!1,xk=null,yk=0,zk=0,Ak=null,Bk=-1,Ck=0;function L(){return 0!==(K&6)?B():-1!==Bk?Bk:Bk=B()}
	function lh(a){if(0===(a.mode&1))return 1;if(0!==(K&2)&&0!==Z)return Z&-Z;if(null!==Kg.transition)return 0===Ck&&(Ck=yc()),Ck;a=C;if(0!==a)return a;a=window.event;a=void 0===a?16:jd(a.type);return a}function mh(a,b,c,d){if(50<zk)throw zk=0,Ak=null,Error(p(185));Ac(a,c,d);if(0===(K&2)||a!==R)a===R&&(0===(K&2)&&(rk|=c),4===T&&Dk(a,Z)),Ek(a,d),1===c&&0===K&&0===(b.mode&1)&&(Hj=B()+500,fg&&jg());}
	function Ek(a,b){var c=a.callbackNode;wc(a,b);var d=uc(a,a===R?Z:0);if(0===d)null!==c&&bc(c),a.callbackNode=null,a.callbackPriority=0;else if(b=d&-d,a.callbackPriority!==b){null!=c&&bc(c);if(1===b)0===a.tag?ig(Fk.bind(null,a)):hg(Fk.bind(null,a)),Jf(function(){0===(K&6)&&jg();}),c=null;else {switch(Dc(d)){case 1:c=fc;break;case 4:c=gc;break;case 16:c=hc;break;case 536870912:c=jc;break;default:c=hc;}c=Gk(c,Hk.bind(null,a));}a.callbackPriority=b;a.callbackNode=c;}}
	function Hk(a,b){Bk=-1;Ck=0;if(0!==(K&6))throw Error(p(327));var c=a.callbackNode;if(Ik()&&a.callbackNode!==c)return null;var d=uc(a,a===R?Z:0);if(0===d)return null;if(0!==(d&30)||0!==(d&a.expiredLanes)||b)b=Jk(a,d);else {b=d;var e=K;K|=2;var f=Kk();if(R!==a||Z!==b)vk=null,Hj=B()+500,Lk(a,b);do try{Mk();break}catch(h){Nk(a,h);}while(1);Qg();nk.current=f;K=e;null!==Y?b=0:(R=null,Z=0,b=T);}if(0!==b){2===b&&(e=xc(a),0!==e&&(d=e,b=Ok(a,e)));if(1===b)throw c=qk,Lk(a,0),Dk(a,d),Ek(a,B()),c;if(6===b)Dk(a,d);
	else {e=a.current.alternate;if(0===(d&30)&&!Pk(e)&&(b=Jk(a,d),2===b&&(f=xc(a),0!==f&&(d=f,b=Ok(a,f))),1===b))throw c=qk,Lk(a,0),Dk(a,d),Ek(a,B()),c;a.finishedWork=e;a.finishedLanes=d;switch(b){case 0:case 1:throw Error(p(345));case 2:Qk(a,uk,vk);break;case 3:Dk(a,d);if((d&130023424)===d&&(b=gk+500-B(),10<b)){if(0!==uc(a,0))break;e=a.suspendedLanes;if((e&d)!==d){L();a.pingedLanes|=a.suspendedLanes&e;break}a.timeoutHandle=Ff(Qk.bind(null,a,uk,vk),b);break}Qk(a,uk,vk);break;case 4:Dk(a,d);if((d&4194240)===
	d)break;b=a.eventTimes;for(e=-1;0<d;){var g=31-oc(d);f=1<<g;g=b[g];g>e&&(e=g);d&=~f;}d=e;d=B()-d;d=(120>d?120:480>d?480:1080>d?1080:1920>d?1920:3E3>d?3E3:4320>d?4320:1960*mk(d/1960))-d;if(10<d){a.timeoutHandle=Ff(Qk.bind(null,a,uk,vk),d);break}Qk(a,uk,vk);break;case 5:Qk(a,uk,vk);break;default:throw Error(p(329));}}}Ek(a,B());return a.callbackNode===c?Hk.bind(null,a):null}
	function Ok(a,b){var c=tk;a.current.memoizedState.isDehydrated&&(Lk(a,b).flags|=256);a=Jk(a,b);2!==a&&(b=uk,uk=c,null!==b&&Gj(b));return a}function Gj(a){null===uk?uk=a:uk.push.apply(uk,a);}
	function Pk(a){for(var b=a;;){if(b.flags&16384){var c=b.updateQueue;if(null!==c&&(c=c.stores,null!==c))for(var d=0;d<c.length;d++){var e=c[d],f=e.getSnapshot;e=e.value;try{if(!He(f(),e))return !1}catch(g){return !1}}}c=b.child;if(b.subtreeFlags&16384&&null!==c)c.return=b,b=c;else {if(b===a)break;for(;null===b.sibling;){if(null===b.return||b.return===a)return !0;b=b.return;}b.sibling.return=b.return;b=b.sibling;}}return !0}
	function Dk(a,b){b&=~sk;b&=~rk;a.suspendedLanes|=b;a.pingedLanes&=~b;for(a=a.expirationTimes;0<b;){var c=31-oc(b),d=1<<c;a[c]=-1;b&=~d;}}function Fk(a){if(0!==(K&6))throw Error(p(327));Ik();var b=uc(a,0);if(0===(b&1))return Ek(a,B()),null;var c=Jk(a,b);if(0!==a.tag&&2===c){var d=xc(a);0!==d&&(b=d,c=Ok(a,d));}if(1===c)throw c=qk,Lk(a,0),Dk(a,b),Ek(a,B()),c;if(6===c)throw Error(p(345));a.finishedWork=a.current.alternate;a.finishedLanes=b;Qk(a,uk,vk);Ek(a,B());return null}
	function Rk(a,b){var c=K;K|=1;try{return a(b)}finally{K=c,0===K&&(Hj=B()+500,fg&&jg());}}function Sk(a){null!==xk&&0===xk.tag&&0===(K&6)&&Ik();var b=K;K|=1;var c=pk.transition,d=C;try{if(pk.transition=null,C=1,a)return a()}finally{C=d,pk.transition=c,K=b,0===(K&6)&&jg();}}function Ij(){gj=fj.current;E(fj);}
	function Lk(a,b){a.finishedWork=null;a.finishedLanes=0;var c=a.timeoutHandle;-1!==c&&(a.timeoutHandle=-1,Gf(c));if(null!==Y)for(c=Y.return;null!==c;){var d=c;wg(d);switch(d.tag){case 1:d=d.type.childContextTypes;null!==d&&void 0!==d&&$f();break;case 3:Jh();E(Wf);E(H);Oh();break;case 5:Lh(d);break;case 4:Jh();break;case 13:E(M);break;case 19:E(M);break;case 10:Rg(d.type._context);break;case 22:case 23:Ij();}c=c.return;}R=a;Y=a=wh(a.current,null);Z=gj=b;T=0;qk=null;sk=rk=hh=0;uk=tk=null;if(null!==Wg){for(b=
	0;b<Wg.length;b++)if(c=Wg[b],d=c.interleaved,null!==d){c.interleaved=null;var e=d.next,f=c.pending;if(null!==f){var g=f.next;f.next=e;d.next=g;}c.pending=d;}Wg=null;}return a}
	function Nk(a,b){do{var c=Y;try{Qg();Ph.current=ai;if(Sh){for(var d=N.memoizedState;null!==d;){var e=d.queue;null!==e&&(e.pending=null);d=d.next;}Sh=!1;}Rh=0;P=O=N=null;Th=!1;Uh=0;ok.current=null;if(null===c||null===c.return){T=1;qk=b;Y=null;break}a:{var f=a,g=c.return,h=c,k=b;b=Z;h.flags|=32768;if(null!==k&&"object"===typeof k&&"function"===typeof k.then){var l=k,m=h,q=m.tag;if(0===(m.mode&1)&&(0===q||11===q||15===q)){var r=m.alternate;r?(m.updateQueue=r.updateQueue,m.memoizedState=r.memoizedState,
	m.lanes=r.lanes):(m.updateQueue=null,m.memoizedState=null);}var y=Vi(g);if(null!==y){y.flags&=-257;Wi(y,g,h,f,b);y.mode&1&&Ti(f,l,b);b=y;k=l;var n=b.updateQueue;if(null===n){var t=new Set;t.add(k);b.updateQueue=t;}else n.add(k);break a}else {if(0===(b&1)){Ti(f,l,b);uj();break a}k=Error(p(426));}}else if(I&&h.mode&1){var J=Vi(g);if(null!==J){0===(J.flags&65536)&&(J.flags|=256);Wi(J,g,h,f,b);Jg(Ki(k,h));break a}}f=k=Ki(k,h);4!==T&&(T=2);null===tk?tk=[f]:tk.push(f);f=g;do{switch(f.tag){case 3:f.flags|=65536;
	b&=-b;f.lanes|=b;var x=Oi(f,k,b);fh(f,x);break a;case 1:h=k;var w=f.type,u=f.stateNode;if(0===(f.flags&128)&&("function"===typeof w.getDerivedStateFromError||null!==u&&"function"===typeof u.componentDidCatch&&(null===Si||!Si.has(u)))){f.flags|=65536;b&=-b;f.lanes|=b;var F=Ri(f,h,b);fh(f,F);break a}}f=f.return;}while(null!==f)}Tk(c);}catch(na){b=na;Y===c&&null!==c&&(Y=c=c.return);continue}break}while(1)}function Kk(){var a=nk.current;nk.current=ai;return null===a?ai:a}
	function uj(){if(0===T||3===T||2===T)T=4;null===R||0===(hh&268435455)&&0===(rk&268435455)||Dk(R,Z);}function Jk(a,b){var c=K;K|=2;var d=Kk();if(R!==a||Z!==b)vk=null,Lk(a,b);do try{Uk();break}catch(e){Nk(a,e);}while(1);Qg();K=c;nk.current=d;if(null!==Y)throw Error(p(261));R=null;Z=0;return T}function Uk(){for(;null!==Y;)Vk(Y);}function Mk(){for(;null!==Y&&!cc();)Vk(Y);}function Vk(a){var b=Wk(a.alternate,a,gj);a.memoizedProps=a.pendingProps;null===b?Tk(a):Y=b;ok.current=null;}
	function Tk(a){var b=a;do{var c=b.alternate;a=b.return;if(0===(b.flags&32768)){if(c=Fj(c,b,gj),null!==c){Y=c;return}}else {c=Jj(c,b);if(null!==c){c.flags&=32767;Y=c;return}if(null!==a)a.flags|=32768,a.subtreeFlags=0,a.deletions=null;else {T=6;Y=null;return}}b=b.sibling;if(null!==b){Y=b;return}Y=b=a;}while(null!==b);0===T&&(T=5);}function Qk(a,b,c){var d=C,e=pk.transition;try{pk.transition=null,C=1,Xk(a,b,c,d);}finally{pk.transition=e,C=d;}return null}
	function Xk(a,b,c,d){do Ik();while(null!==xk);if(0!==(K&6))throw Error(p(327));c=a.finishedWork;var e=a.finishedLanes;if(null===c)return null;a.finishedWork=null;a.finishedLanes=0;if(c===a.current)throw Error(p(177));a.callbackNode=null;a.callbackPriority=0;var f=c.lanes|c.childLanes;Bc(a,f);a===R&&(Y=R=null,Z=0);0===(c.subtreeFlags&2064)&&0===(c.flags&2064)||wk||(wk=!0,Gk(hc,function(){Ik();return null}));f=0!==(c.flags&15990);if(0!==(c.subtreeFlags&15990)||f){f=pk.transition;pk.transition=null;
	var g=C;C=1;var h=K;K|=4;ok.current=null;Pj(a,c);ek(c,a);Oe(Df);dd=!!Cf;Df=Cf=null;a.current=c;ik(c);dc();K=h;C=g;pk.transition=f;}else a.current=c;wk&&(wk=!1,xk=a,yk=e);f=a.pendingLanes;0===f&&(Si=null);mc(c.stateNode);Ek(a,B());if(null!==b)for(d=a.onRecoverableError,c=0;c<b.length;c++)e=b[c],d(e.value,{componentStack:e.stack,digest:e.digest});if(Pi)throw Pi=!1,a=Qi,Qi=null,a;0!==(yk&1)&&0!==a.tag&&Ik();f=a.pendingLanes;0!==(f&1)?a===Ak?zk++:(zk=0,Ak=a):zk=0;jg();return null}
	function Ik(){if(null!==xk){var a=Dc(yk),b=pk.transition,c=C;try{pk.transition=null;C=16>a?16:a;if(null===xk)var d=!1;else {a=xk;xk=null;yk=0;if(0!==(K&6))throw Error(p(331));var e=K;K|=4;for(V=a.current;null!==V;){var f=V,g=f.child;if(0!==(V.flags&16)){var h=f.deletions;if(null!==h){for(var k=0;k<h.length;k++){var l=h[k];for(V=l;null!==V;){var m=V;switch(m.tag){case 0:case 11:case 15:Qj(8,m,f);}var q=m.child;if(null!==q)q.return=m,V=q;else for(;null!==V;){m=V;var r=m.sibling,y=m.return;Tj(m);if(m===
	l){V=null;break}if(null!==r){r.return=y;V=r;break}V=y;}}}var n=f.alternate;if(null!==n){var t=n.child;if(null!==t){n.child=null;do{var J=t.sibling;t.sibling=null;t=J;}while(null!==t)}}V=f;}}if(0!==(f.subtreeFlags&2064)&&null!==g)g.return=f,V=g;else b:for(;null!==V;){f=V;if(0!==(f.flags&2048))switch(f.tag){case 0:case 11:case 15:Qj(9,f,f.return);}var x=f.sibling;if(null!==x){x.return=f.return;V=x;break b}V=f.return;}}var w=a.current;for(V=w;null!==V;){g=V;var u=g.child;if(0!==(g.subtreeFlags&2064)&&null!==
	u)u.return=g,V=u;else b:for(g=w;null!==V;){h=V;if(0!==(h.flags&2048))try{switch(h.tag){case 0:case 11:case 15:Rj(9,h);}}catch(na){W(h,h.return,na);}if(h===g){V=null;break b}var F=h.sibling;if(null!==F){F.return=h.return;V=F;break b}V=h.return;}}K=e;jg();if(lc&&"function"===typeof lc.onPostCommitFiberRoot)try{lc.onPostCommitFiberRoot(kc,a);}catch(na){}d=!0;}return d}finally{C=c,pk.transition=b;}}return !1}function Yk(a,b,c){b=Ki(c,b);b=Oi(a,b,1);a=dh(a,b,1);b=L();null!==a&&(Ac(a,1,b),Ek(a,b));}
	function W(a,b,c){if(3===a.tag)Yk(a,a,c);else for(;null!==b;){if(3===b.tag){Yk(b,a,c);break}else if(1===b.tag){var d=b.stateNode;if("function"===typeof b.type.getDerivedStateFromError||"function"===typeof d.componentDidCatch&&(null===Si||!Si.has(d))){a=Ki(c,a);a=Ri(b,a,1);b=dh(b,a,1);a=L();null!==b&&(Ac(b,1,a),Ek(b,a));break}}b=b.return;}}
	function Ui(a,b,c){var d=a.pingCache;null!==d&&d.delete(b);b=L();a.pingedLanes|=a.suspendedLanes&c;R===a&&(Z&c)===c&&(4===T||3===T&&(Z&130023424)===Z&&500>B()-gk?Lk(a,0):sk|=c);Ek(a,b);}function Zk(a,b){0===b&&(0===(a.mode&1)?b=1:(b=sc,sc<<=1,0===(sc&130023424)&&(sc=4194304)));var c=L();a=Zg(a,b);null!==a&&(Ac(a,b,c),Ek(a,c));}function vj(a){var b=a.memoizedState,c=0;null!==b&&(c=b.retryLane);Zk(a,c);}
	function ck(a,b){var c=0;switch(a.tag){case 13:var d=a.stateNode;var e=a.memoizedState;null!==e&&(c=e.retryLane);break;case 19:d=a.stateNode;break;default:throw Error(p(314));}null!==d&&d.delete(b);Zk(a,c);}var Wk;
	Wk=function(a,b,c){if(null!==a)if(a.memoizedProps!==b.pendingProps||Wf.current)Ug=!0;else {if(0===(a.lanes&c)&&0===(b.flags&128))return Ug=!1,zj(a,b,c);Ug=0!==(a.flags&131072)?!0:!1;}else Ug=!1,I&&0!==(b.flags&1048576)&&ug(b,ng,b.index);b.lanes=0;switch(b.tag){case 2:var d=b.type;jj(a,b);a=b.pendingProps;var e=Yf(b,H.current);Tg(b,c);e=Xh(null,b,d,a,e,c);var f=bi();b.flags|=1;"object"===typeof e&&null!==e&&"function"===typeof e.render&&void 0===e.$$typeof?(b.tag=1,b.memoizedState=null,b.updateQueue=
	null,Zf(d)?(f=!0,cg(b)):f=!1,b.memoizedState=null!==e.state&&void 0!==e.state?e.state:null,ah(b),e.updater=nh,b.stateNode=e,e._reactInternals=b,rh(b,d,a,c),b=kj(null,b,d,!0,f,c)):(b.tag=0,I&&f&&vg(b),Yi(null,b,e,c),b=b.child);return b;case 16:d=b.elementType;a:{jj(a,b);a=b.pendingProps;e=d._init;d=e(d._payload);b.type=d;e=b.tag=$k(d);a=Lg(d,a);switch(e){case 0:b=dj(null,b,d,a,c);break a;case 1:b=ij(null,b,d,a,c);break a;case 11:b=Zi(null,b,d,a,c);break a;case 14:b=aj(null,b,d,Lg(d.type,a),c);break a}throw Error(p(306,
	d,""));}return b;case 0:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:Lg(d,e),dj(a,b,d,e,c);case 1:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:Lg(d,e),ij(a,b,d,e,c);case 3:a:{lj(b);if(null===a)throw Error(p(387));d=b.pendingProps;f=b.memoizedState;e=f.element;bh(a,b);gh(b,d,null,c);var g=b.memoizedState;d=g.element;if(f.isDehydrated)if(f={element:d,isDehydrated:!1,cache:g.cache,pendingSuspenseBoundaries:g.pendingSuspenseBoundaries,transitions:g.transitions},b.updateQueue.baseState=
	f,b.memoizedState=f,b.flags&256){e=Ki(Error(p(423)),b);b=mj(a,b,d,c,e);break a}else if(d!==e){e=Ki(Error(p(424)),b);b=mj(a,b,d,c,e);break a}else for(yg=Lf(b.stateNode.containerInfo.firstChild),xg=b,I=!0,zg=null,c=Ch(b,null,d,c),b.child=c;c;)c.flags=c.flags&-3|4096,c=c.sibling;else {Ig();if(d===e){b=$i(a,b,c);break a}Yi(a,b,d,c);}b=b.child;}return b;case 5:return Kh(b),null===a&&Eg(b),d=b.type,e=b.pendingProps,f=null!==a?a.memoizedProps:null,g=e.children,Ef(d,e)?g=null:null!==f&&Ef(d,f)&&(b.flags|=32),
	hj(a,b),Yi(a,b,g,c),b.child;case 6:return null===a&&Eg(b),null;case 13:return pj(a,b,c);case 4:return Ih(b,b.stateNode.containerInfo),d=b.pendingProps,null===a?b.child=Bh(b,null,d,c):Yi(a,b,d,c),b.child;case 11:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:Lg(d,e),Zi(a,b,d,e,c);case 7:return Yi(a,b,b.pendingProps,c),b.child;case 8:return Yi(a,b,b.pendingProps.children,c),b.child;case 12:return Yi(a,b,b.pendingProps.children,c),b.child;case 10:a:{d=b.type._context;e=b.pendingProps;f=b.memoizedProps;
	g=e.value;G(Mg,d._currentValue);d._currentValue=g;if(null!==f)if(He(f.value,g)){if(f.children===e.children&&!Wf.current){b=$i(a,b,c);break a}}else for(f=b.child,null!==f&&(f.return=b);null!==f;){var h=f.dependencies;if(null!==h){g=f.child;for(var k=h.firstContext;null!==k;){if(k.context===d){if(1===f.tag){k=ch(-1,c&-c);k.tag=2;var l=f.updateQueue;if(null!==l){l=l.shared;var m=l.pending;null===m?k.next=k:(k.next=m.next,m.next=k);l.pending=k;}}f.lanes|=c;k=f.alternate;null!==k&&(k.lanes|=c);Sg(f.return,
	c,b);h.lanes|=c;break}k=k.next;}}else if(10===f.tag)g=f.type===b.type?null:f.child;else if(18===f.tag){g=f.return;if(null===g)throw Error(p(341));g.lanes|=c;h=g.alternate;null!==h&&(h.lanes|=c);Sg(g,c,b);g=f.sibling;}else g=f.child;if(null!==g)g.return=f;else for(g=f;null!==g;){if(g===b){g=null;break}f=g.sibling;if(null!==f){f.return=g.return;g=f;break}g=g.return;}f=g;}Yi(a,b,e.children,c);b=b.child;}return b;case 9:return e=b.type,d=b.pendingProps.children,Tg(b,c),e=Vg(e),d=d(e),b.flags|=1,Yi(a,b,d,c),
	b.child;case 14:return d=b.type,e=Lg(d,b.pendingProps),e=Lg(d.type,e),aj(a,b,d,e,c);case 15:return cj(a,b,b.type,b.pendingProps,c);case 17:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:Lg(d,e),jj(a,b),b.tag=1,Zf(d)?(a=!0,cg(b)):a=!1,Tg(b,c),ph(b,d,e),rh(b,d,e,c),kj(null,b,d,!0,a,c);case 19:return yj(a,b,c);case 22:return ej(a,b,c)}throw Error(p(156,b.tag));};function Gk(a,b){return ac(a,b)}
	function al(a,b,c,d){this.tag=a;this.key=c;this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null;this.index=0;this.ref=null;this.pendingProps=b;this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null;this.mode=d;this.subtreeFlags=this.flags=0;this.deletions=null;this.childLanes=this.lanes=0;this.alternate=null;}function Bg(a,b,c,d){return new al(a,b,c,d)}function bj(a){a=a.prototype;return !(!a||!a.isReactComponent)}
	function $k(a){if("function"===typeof a)return bj(a)?1:0;if(void 0!==a&&null!==a){a=a.$$typeof;if(a===Da)return 11;if(a===Ga)return 14}return 2}
	function wh(a,b){var c=a.alternate;null===c?(c=Bg(a.tag,b,a.key,a.mode),c.elementType=a.elementType,c.type=a.type,c.stateNode=a.stateNode,c.alternate=a,a.alternate=c):(c.pendingProps=b,c.type=a.type,c.flags=0,c.subtreeFlags=0,c.deletions=null);c.flags=a.flags&14680064;c.childLanes=a.childLanes;c.lanes=a.lanes;c.child=a.child;c.memoizedProps=a.memoizedProps;c.memoizedState=a.memoizedState;c.updateQueue=a.updateQueue;b=a.dependencies;c.dependencies=null===b?null:{lanes:b.lanes,firstContext:b.firstContext};
	c.sibling=a.sibling;c.index=a.index;c.ref=a.ref;return c}
	function yh(a,b,c,d,e,f){var g=2;d=a;if("function"===typeof a)bj(a)&&(g=1);else if("string"===typeof a)g=5;else a:switch(a){case ya:return Ah(c.children,e,f,b);case za:g=8;e|=8;break;case Aa:return a=Bg(12,c,b,e|2),a.elementType=Aa,a.lanes=f,a;case Ea:return a=Bg(13,c,b,e),a.elementType=Ea,a.lanes=f,a;case Fa:return a=Bg(19,c,b,e),a.elementType=Fa,a.lanes=f,a;case Ia:return qj(c,e,f,b);default:if("object"===typeof a&&null!==a)switch(a.$$typeof){case Ba:g=10;break a;case Ca:g=9;break a;case Da:g=11;
	break a;case Ga:g=14;break a;case Ha:g=16;d=null;break a}throw Error(p(130,null==a?a:typeof a,""));}b=Bg(g,c,b,e);b.elementType=a;b.type=d;b.lanes=f;return b}function Ah(a,b,c,d){a=Bg(7,a,d,b);a.lanes=c;return a}function qj(a,b,c,d){a=Bg(22,a,d,b);a.elementType=Ia;a.lanes=c;a.stateNode={isHidden:!1};return a}function xh(a,b,c){a=Bg(6,a,null,b);a.lanes=c;return a}
	function zh(a,b,c){b=Bg(4,null!==a.children?a.children:[],a.key,b);b.lanes=c;b.stateNode={containerInfo:a.containerInfo,pendingChildren:null,implementation:a.implementation};return b}
	function bl(a,b,c,d,e){this.tag=b;this.containerInfo=a;this.finishedWork=this.pingCache=this.current=this.pendingChildren=null;this.timeoutHandle=-1;this.callbackNode=this.pendingContext=this.context=null;this.callbackPriority=0;this.eventTimes=zc(0);this.expirationTimes=zc(-1);this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0;this.entanglements=zc(0);this.identifierPrefix=d;this.onRecoverableError=e;this.mutableSourceEagerHydrationData=
	null;}function cl(a,b,c,d,e,f,g,h,k){a=new bl(a,b,c,h,k);1===b?(b=1,!0===f&&(b|=8)):b=0;f=Bg(3,null,null,b);a.current=f;f.stateNode=a;f.memoizedState={element:d,isDehydrated:c,cache:null,transitions:null,pendingSuspenseBoundaries:null};ah(f);return a}function dl(a,b,c){var d=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return {$$typeof:wa,key:null==d?null:""+d,children:a,containerInfo:b,implementation:c}}
	function el(a){if(!a)return Vf;a=a._reactInternals;a:{if(Vb(a)!==a||1!==a.tag)throw Error(p(170));var b=a;do{switch(b.tag){case 3:b=b.stateNode.context;break a;case 1:if(Zf(b.type)){b=b.stateNode.__reactInternalMemoizedMergedChildContext;break a}}b=b.return;}while(null!==b);throw Error(p(171));}if(1===a.tag){var c=a.type;if(Zf(c))return bg(a,c,b)}return b}
	function fl(a,b,c,d,e,f,g,h,k){a=cl(c,d,!0,a,e,f,g,h,k);a.context=el(null);c=a.current;d=L();e=lh(c);f=ch(d,e);f.callback=void 0!==b&&null!==b?b:null;dh(c,f,e);a.current.lanes=e;Ac(a,e,d);Ek(a,d);return a}function gl(a,b,c,d){var e=b.current,f=L(),g=lh(e);c=el(c);null===b.context?b.context=c:b.pendingContext=c;b=ch(f,g);b.payload={element:a};d=void 0===d?null:d;null!==d&&(b.callback=d);a=dh(e,b,g);null!==a&&(mh(a,e,g,f),eh(a,e,g));return g}
	function hl(a){a=a.current;if(!a.child)return null;switch(a.child.tag){case 5:return a.child.stateNode;default:return a.child.stateNode}}function il(a,b){a=a.memoizedState;if(null!==a&&null!==a.dehydrated){var c=a.retryLane;a.retryLane=0!==c&&c<b?c:b;}}function jl(a,b){il(a,b);(a=a.alternate)&&il(a,b);}function kl(){return null}var ll="function"===typeof reportError?reportError:function(a){console.error(a);};function ml(a){this._internalRoot=a;}
	nl.prototype.render=ml.prototype.render=function(a){var b=this._internalRoot;if(null===b)throw Error(p(409));gl(a,b,null,null);};nl.prototype.unmount=ml.prototype.unmount=function(){var a=this._internalRoot;if(null!==a){this._internalRoot=null;var b=a.containerInfo;Sk(function(){gl(null,a,null,null);});b[uf]=null;}};function nl(a){this._internalRoot=a;}
	nl.prototype.unstable_scheduleHydration=function(a){if(a){var b=Hc();a={blockedOn:null,target:a,priority:b};for(var c=0;c<Qc.length&&0!==b&&b<Qc[c].priority;c++);Qc.splice(c,0,a);0===c&&Vc(a);}};function ol(a){return !(!a||1!==a.nodeType&&9!==a.nodeType&&11!==a.nodeType)}function pl(a){return !(!a||1!==a.nodeType&&9!==a.nodeType&&11!==a.nodeType&&(8!==a.nodeType||" react-mount-point-unstable "!==a.nodeValue))}function ql(){}
	function rl(a,b,c,d,e){if(e){if("function"===typeof d){var f=d;d=function(){var a=hl(g);f.call(a);};}var g=fl(b,d,a,0,null,!1,!1,"",ql);a._reactRootContainer=g;a[uf]=g.current;sf(8===a.nodeType?a.parentNode:a);Sk();return g}for(;e=a.lastChild;)a.removeChild(e);if("function"===typeof d){var h=d;d=function(){var a=hl(k);h.call(a);};}var k=cl(a,0,!1,null,null,!1,!1,"",ql);a._reactRootContainer=k;a[uf]=k.current;sf(8===a.nodeType?a.parentNode:a);Sk(function(){gl(b,k,c,d);});return k}
	function sl(a,b,c,d,e){var f=c._reactRootContainer;if(f){var g=f;if("function"===typeof e){var h=e;e=function(){var a=hl(g);h.call(a);};}gl(b,g,a,e);}else g=rl(c,b,a,e,d);return hl(g)}Ec=function(a){switch(a.tag){case 3:var b=a.stateNode;if(b.current.memoizedState.isDehydrated){var c=tc(b.pendingLanes);0!==c&&(Cc(b,c|1),Ek(b,B()),0===(K&6)&&(Hj=B()+500,jg()));}break;case 13:Sk(function(){var b=Zg(a,1);if(null!==b){var c=L();mh(b,a,1,c);}}),jl(a,1);}};
	Fc=function(a){if(13===a.tag){var b=Zg(a,134217728);if(null!==b){var c=L();mh(b,a,134217728,c);}jl(a,134217728);}};Gc=function(a){if(13===a.tag){var b=lh(a),c=Zg(a,b);if(null!==c){var d=L();mh(c,a,b,d);}jl(a,b);}};Hc=function(){return C};Ic=function(a,b){var c=C;try{return C=a,b()}finally{C=c;}};
	yb=function(a,b,c){switch(b){case "input":bb(a,c);b=c.name;if("radio"===c.type&&null!=b){for(c=a;c.parentNode;)c=c.parentNode;c=c.querySelectorAll("input[name="+JSON.stringify(""+b)+'][type="radio"]');for(b=0;b<c.length;b++){var d=c[b];if(d!==a&&d.form===a.form){var e=Db(d);if(!e)throw Error(p(90));Wa(d);bb(d,e);}}}break;case "textarea":ib(a,c);break;case "select":b=c.value,null!=b&&fb(a,!!c.multiple,b,!1);}};Gb=Rk;Hb=Sk;
	var tl={usingClientEntryPoint:!1,Events:[Cb,ue,Db,Eb,Fb,Rk]},ul={findFiberByHostInstance:Wc,bundleType:0,version:"18.2.0",rendererPackageName:"react-dom"};
	var vl={bundleType:ul.bundleType,version:ul.version,rendererPackageName:ul.rendererPackageName,rendererConfig:ul.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setErrorHandler:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:ua.ReactCurrentDispatcher,findHostInstanceByFiber:function(a){a=Zb(a);return null===a?null:a.stateNode},findFiberByHostInstance:ul.findFiberByHostInstance||
	kl,findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null,reconcilerVersion:"18.2.0-next-9e3b772b8-20220608"};if("undefined"!==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var wl=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!wl.isDisabled&&wl.supportsFiber)try{kc=wl.inject(vl),lc=wl;}catch(a){}}reactDom_production_min.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=tl;
	reactDom_production_min.createPortal=function(a,b){var c=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!ol(b))throw Error(p(200));return dl(a,b,null,c)};reactDom_production_min.createRoot=function(a,b){if(!ol(a))throw Error(p(299));var c=!1,d="",e=ll;null!==b&&void 0!==b&&(!0===b.unstable_strictMode&&(c=!0),void 0!==b.identifierPrefix&&(d=b.identifierPrefix),void 0!==b.onRecoverableError&&(e=b.onRecoverableError));b=cl(a,1,!1,null,null,c,!1,d,e);a[uf]=b.current;sf(8===a.nodeType?a.parentNode:a);return new ml(b)};
	reactDom_production_min.findDOMNode=function(a){if(null==a)return null;if(1===a.nodeType)return a;var b=a._reactInternals;if(void 0===b){if("function"===typeof a.render)throw Error(p(188));a=Object.keys(a).join(",");throw Error(p(268,a));}a=Zb(b);a=null===a?null:a.stateNode;return a};reactDom_production_min.flushSync=function(a){return Sk(a)};reactDom_production_min.hydrate=function(a,b,c){if(!pl(b))throw Error(p(200));return sl(null,a,b,!0,c)};
	reactDom_production_min.hydrateRoot=function(a,b,c){if(!ol(a))throw Error(p(405));var d=null!=c&&c.hydratedSources||null,e=!1,f="",g=ll;null!==c&&void 0!==c&&(!0===c.unstable_strictMode&&(e=!0),void 0!==c.identifierPrefix&&(f=c.identifierPrefix),void 0!==c.onRecoverableError&&(g=c.onRecoverableError));b=fl(b,null,a,1,null!=c?c:null,e,!1,f,g);a[uf]=b.current;sf(a);if(d)for(a=0;a<d.length;a++)c=d[a],e=c._getVersion,e=e(c._source),null==b.mutableSourceEagerHydrationData?b.mutableSourceEagerHydrationData=[c,e]:b.mutableSourceEagerHydrationData.push(c,
	e);return new nl(b)};reactDom_production_min.render=function(a,b,c){if(!pl(b))throw Error(p(200));return sl(null,a,b,!1,c)};reactDom_production_min.unmountComponentAtNode=function(a){if(!pl(a))throw Error(p(40));return a._reactRootContainer?(Sk(function(){sl(null,null,a,!1,function(){a._reactRootContainer=null;a[uf]=null;});}),!0):!1};reactDom_production_min.unstable_batchedUpdates=Rk;
	reactDom_production_min.unstable_renderSubtreeIntoContainer=function(a,b,c,d){if(!pl(c))throw Error(p(200));if(null==a||void 0===a._reactInternals)throw Error(p(38));return sl(a,b,c,!1,d)};reactDom_production_min.version="18.2.0-next-9e3b772b8-20220608";
	return reactDom_production_min;
}

var define_process_env_default$3 = {};
function checkDCE() {
  if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined" || typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE !== "function") {
    return;
  }
  if (define_process_env_default$3.NODE_ENV !== "production") {
    throw new Error("^_^");
  }
  try {
    __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
  } catch (err) {
    console.error(err);
  }
}
if (define_process_env_default$3.NODE_ENV === "production") {
  checkDCE();
  reactDom.exports = requireReactDom_production_min();
} else {
  reactDom.exports = requireReactDom_development();
}

var reactDomExports = reactDom.exports;

var define_process_env_default$2 = {};
var m = reactDomExports;
if (define_process_env_default$2.NODE_ENV === "production") {
  client.createRoot = m.createRoot;
  client.hydrateRoot = m.hydrateRoot;
} else {
  var i = m.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
  client.createRoot = function(c, o) {
    i.usingClientEntryPoint = true;
    try {
      return m.createRoot(c, o);
    } finally {
      i.usingClientEntryPoint = false;
    }
  };
  client.hydrateRoot = function(c, h, o) {
    i.usingClientEntryPoint = true;
    try {
      return m.hydrateRoot(c, h, o);
    } finally {
      i.usingClientEntryPoint = false;
    }
  };
}

function cc(names) {
  if (typeof names === "string" || typeof names === "number") return "" + names

  let out = "";

  if (Array.isArray(names)) {
    for (let i = 0, tmp; i < names.length; i++) {
      if ((tmp = cc(names[i])) !== "") {
        out += (out && " ") + tmp;
      }
    }
  } else {
    for (let k in names) {
      if (names[k]) out += (out && " ") + k;
    }
  }

  return out
}

var withSelector = {exports: {}};

var withSelector_development = {};

var shim = {exports: {}};

var useSyncExternalStoreShim_development = {};

var hasRequiredUseSyncExternalStoreShim_development;

function requireUseSyncExternalStoreShim_development () {
	if (hasRequiredUseSyncExternalStoreShim_development) return useSyncExternalStoreShim_development;
	hasRequiredUseSyncExternalStoreShim_development = 1;
	var define_process_env_default = {};
	/**
	 * @license React
	 * use-sync-external-store-shim.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */
	if (define_process_env_default.NODE_ENV !== "production") {
	  (function() {
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
	    }
	    var React = reactExports;
	    var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
	    function error(format) {
	      {
	        {
	          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	            args[_key2 - 1] = arguments[_key2];
	          }
	          printWarning("error", format, args);
	        }
	      }
	    }
	    function printWarning(level, format, args) {
	      {
	        var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
	        var stack = ReactDebugCurrentFrame.getStackAddendum();
	        if (stack !== "") {
	          format += "%s";
	          args = args.concat([stack]);
	        }
	        var argsWithFormat = args.map(function(item) {
	          return String(item);
	        });
	        argsWithFormat.unshift("Warning: " + format);
	        Function.prototype.apply.call(console[level], console, argsWithFormat);
	      }
	    }
	    function is(x, y) {
	      return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
	    }
	    var objectIs = typeof Object.is === "function" ? Object.is : is;
	    var useState = React.useState, useEffect = React.useEffect, useLayoutEffect = React.useLayoutEffect, useDebugValue = React.useDebugValue;
	    var didWarnOld18Alpha = false;
	    var didWarnUncachedGetSnapshot = false;
	    function useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
	      {
	        if (!didWarnOld18Alpha) {
	          if (React.startTransition !== void 0) {
	            didWarnOld18Alpha = true;
	            error("You are using an outdated, pre-release alpha of React 18 that does not support useSyncExternalStore. The use-sync-external-store shim will not work correctly. Upgrade to a newer pre-release.");
	          }
	        }
	      }
	      var value = getSnapshot();
	      {
	        if (!didWarnUncachedGetSnapshot) {
	          var cachedValue = getSnapshot();
	          if (!objectIs(value, cachedValue)) {
	            error("The result of getSnapshot should be cached to avoid an infinite loop");
	            didWarnUncachedGetSnapshot = true;
	          }
	        }
	      }
	      var _useState = useState({
	        inst: {
	          value,
	          getSnapshot
	        }
	      }), inst = _useState[0].inst, forceUpdate = _useState[1];
	      useLayoutEffect(function() {
	        inst.value = value;
	        inst.getSnapshot = getSnapshot;
	        if (checkIfSnapshotChanged(inst)) {
	          forceUpdate({
	            inst
	          });
	        }
	      }, [subscribe, value, getSnapshot]);
	      useEffect(function() {
	        if (checkIfSnapshotChanged(inst)) {
	          forceUpdate({
	            inst
	          });
	        }
	        var handleStoreChange = function() {
	          if (checkIfSnapshotChanged(inst)) {
	            forceUpdate({
	              inst
	            });
	          }
	        };
	        return subscribe(handleStoreChange);
	      }, [subscribe]);
	      useDebugValue(value);
	      return value;
	    }
	    function checkIfSnapshotChanged(inst) {
	      var latestGetSnapshot = inst.getSnapshot;
	      var prevValue = inst.value;
	      try {
	        var nextValue = latestGetSnapshot();
	        return !objectIs(prevValue, nextValue);
	      } catch (error2) {
	        return true;
	      }
	    }
	    function useSyncExternalStore$1(subscribe, getSnapshot, getServerSnapshot) {
	      return getSnapshot();
	    }
	    var canUseDOM = !!(typeof window !== "undefined" && typeof window.document !== "undefined" && typeof window.document.createElement !== "undefined");
	    var isServerEnvironment = !canUseDOM;
	    var shim = isServerEnvironment ? useSyncExternalStore$1 : useSyncExternalStore;
	    var useSyncExternalStore$2 = React.useSyncExternalStore !== void 0 ? React.useSyncExternalStore : shim;
	    useSyncExternalStoreShim_development.useSyncExternalStore = useSyncExternalStore$2;
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
	    }
	  })();
	}
	return useSyncExternalStoreShim_development;
}

var useSyncExternalStoreShim_production_min = {};

/**
 * @license React
 * use-sync-external-store-shim.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredUseSyncExternalStoreShim_production_min;

function requireUseSyncExternalStoreShim_production_min () {
	if (hasRequiredUseSyncExternalStoreShim_production_min) return useSyncExternalStoreShim_production_min;
	hasRequiredUseSyncExternalStoreShim_production_min = 1;
var e=reactExports;function h(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var k="function"===typeof Object.is?Object.is:h,l=e.useState,m=e.useEffect,n=e.useLayoutEffect,p=e.useDebugValue;function q(a,b){var d=b(),f=l({inst:{value:d,getSnapshot:b}}),c=f[0].inst,g=f[1];n(function(){c.value=d;c.getSnapshot=b;r(c)&&g({inst:c});},[a,d,b]);m(function(){r(c)&&g({inst:c});return a(function(){r(c)&&g({inst:c});})},[a]);p(d);return d}
	function r(a){var b=a.getSnapshot;a=a.value;try{var d=b();return !k(a,d)}catch(f){return !0}}function t(a,b){return b()}var u="undefined"===typeof window||"undefined"===typeof window.document||"undefined"===typeof window.document.createElement?t:q;useSyncExternalStoreShim_production_min.useSyncExternalStore=void 0!==e.useSyncExternalStore?e.useSyncExternalStore:u;
	return useSyncExternalStoreShim_production_min;
}

var hasRequiredShim;

function requireShim () {
	if (hasRequiredShim) return shim.exports;
	hasRequiredShim = 1;
	var define_process_env_default = {};
	if (define_process_env_default.NODE_ENV === "production") {
	  shim.exports = requireUseSyncExternalStoreShim_production_min();
	} else {
	  shim.exports = requireUseSyncExternalStoreShim_development();
	}
	return shim.exports;
}

var hasRequiredWithSelector_development;

function requireWithSelector_development () {
	if (hasRequiredWithSelector_development) return withSelector_development;
	hasRequiredWithSelector_development = 1;
	var define_process_env_default = {};
	/**
	 * @license React
	 * use-sync-external-store-shim/with-selector.development.js
	 *
	 * Copyright (c) Facebook, Inc. and its affiliates.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */
	if (define_process_env_default.NODE_ENV !== "production") {
	  (function() {
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
	    }
	    var React = reactExports;
	    var shim = requireShim();
	    function is(x, y) {
	      return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
	    }
	    var objectIs = typeof Object.is === "function" ? Object.is : is;
	    var useSyncExternalStore = shim.useSyncExternalStore;
	    var useRef = React.useRef, useEffect = React.useEffect, useMemo = React.useMemo, useDebugValue = React.useDebugValue;
	    function useSyncExternalStoreWithSelector(subscribe, getSnapshot, getServerSnapshot, selector, isEqual) {
	      var instRef = useRef(null);
	      var inst;
	      if (instRef.current === null) {
	        inst = {
	          hasValue: false,
	          value: null
	        };
	        instRef.current = inst;
	      } else {
	        inst = instRef.current;
	      }
	      var _useMemo = useMemo(function() {
	        var hasMemo = false;
	        var memoizedSnapshot;
	        var memoizedSelection;
	        var memoizedSelector = function(nextSnapshot) {
	          if (!hasMemo) {
	            hasMemo = true;
	            memoizedSnapshot = nextSnapshot;
	            var _nextSelection = selector(nextSnapshot);
	            if (isEqual !== void 0) {
	              if (inst.hasValue) {
	                var currentSelection = inst.value;
	                if (isEqual(currentSelection, _nextSelection)) {
	                  memoizedSelection = currentSelection;
	                  return currentSelection;
	                }
	              }
	            }
	            memoizedSelection = _nextSelection;
	            return _nextSelection;
	          }
	          var prevSnapshot = memoizedSnapshot;
	          var prevSelection = memoizedSelection;
	          if (objectIs(prevSnapshot, nextSnapshot)) {
	            return prevSelection;
	          }
	          var nextSelection = selector(nextSnapshot);
	          if (isEqual !== void 0 && isEqual(prevSelection, nextSelection)) {
	            return prevSelection;
	          }
	          memoizedSnapshot = nextSnapshot;
	          memoizedSelection = nextSelection;
	          return nextSelection;
	        };
	        var maybeGetServerSnapshot = getServerSnapshot === void 0 ? null : getServerSnapshot;
	        var getSnapshotWithSelector = function() {
	          return memoizedSelector(getSnapshot());
	        };
	        var getServerSnapshotWithSelector = maybeGetServerSnapshot === null ? void 0 : function() {
	          return memoizedSelector(maybeGetServerSnapshot());
	        };
	        return [getSnapshotWithSelector, getServerSnapshotWithSelector];
	      }, [getSnapshot, getServerSnapshot, selector, isEqual]), getSelection = _useMemo[0], getServerSelection = _useMemo[1];
	      var value = useSyncExternalStore(subscribe, getSelection, getServerSelection);
	      useEffect(function() {
	        inst.hasValue = true;
	        inst.value = value;
	      }, [value]);
	      useDebugValue(value);
	      return value;
	    }
	    withSelector_development.useSyncExternalStoreWithSelector = useSyncExternalStoreWithSelector;
	    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop === "function") {
	      __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
	    }
	  })();
	}
	return withSelector_development;
}

var withSelector_production_min = {};

/**
 * @license React
 * use-sync-external-store-shim/with-selector.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredWithSelector_production_min;

function requireWithSelector_production_min () {
	if (hasRequiredWithSelector_production_min) return withSelector_production_min;
	hasRequiredWithSelector_production_min = 1;
var h=reactExports,n=requireShim();function p(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var q="function"===typeof Object.is?Object.is:p,r=n.useSyncExternalStore,t=h.useRef,u=h.useEffect,v=h.useMemo,w=h.useDebugValue;
	withSelector_production_min.useSyncExternalStoreWithSelector=function(a,b,e,l,g){var c=t(null);if(null===c.current){var f={hasValue:!1,value:null};c.current=f;}else f=c.current;c=v(function(){function a(a){if(!c){c=!0;d=a;a=l(a);if(void 0!==g&&f.hasValue){var b=f.value;if(g(b,a))return k=b}return k=a}b=k;if(q(d,a))return b;var e=l(a);if(void 0!==g&&g(b,e))return b;d=a;return k=e}var c=!1,d,k,m=void 0===e?null:e;return [function(){return a(b())},null===m?void 0:function(){return a(m())}]},[b,e,l,g]);var d=r(a,c[0],c[1]);
	u(function(){f.hasValue=!0;f.value=d;},[d]);w(d);return d};
	return withSelector_production_min;
}

var define_process_env_default$1 = {};
if (define_process_env_default$1.NODE_ENV === "production") {
  withSelector.exports = requireWithSelector_production_min();
} else {
  withSelector.exports = requireWithSelector_development();
}

var withSelectorExports = withSelector.exports;
const useSyncExternalStoreExports = /*@__PURE__*/getDefaultExportFromCjs(withSelectorExports);

var define_import_meta_env_default = { BASE_URL: "/", MODE: "production", DEV: false, PROD: true, SSR: false };
const createStoreImpl = (createState) => {
  let state;
  const listeners = /* @__PURE__ */ new Set();
  const setState = (partial, replace) => {
    const nextState = typeof partial === "function" ? partial(state) : partial;
    if (!Object.is(nextState, state)) {
      const previousState = state;
      state = (replace != null ? replace : typeof nextState !== "object") ? nextState : Object.assign({}, state, nextState);
      listeners.forEach((listener) => listener(state, previousState));
    }
  };
  const getState = () => state;
  const subscribe = (listener) => {
    listeners.add(listener);
    return () => listeners.delete(listener);
  };
  const destroy = () => {
    if ((define_import_meta_env_default ? "production" : void 0) !== "production") {
      console.warn(
        "[DEPRECATED] The `destroy` method will be unsupported in a future version. Instead use unsubscribe function returned by subscribe. Everything will be garbage-collected if store is garbage-collected."
      );
    }
    listeners.clear();
  };
  const api = { setState, getState, subscribe, destroy };
  state = createState(setState, getState, api);
  return api;
};
const createStore = (createState) => createState ? createStoreImpl(createState) : createStoreImpl;

const { useDebugValue } = React;
const { useSyncExternalStoreWithSelector } = useSyncExternalStoreExports;
function useStoreWithEqualityFn(api, selector = api.getState, equalityFn) {
  const slice = useSyncExternalStoreWithSelector(
    api.subscribe,
    api.getState,
    api.getServerState || api.getState,
    selector,
    equalityFn
  );
  useDebugValue(slice);
  return slice;
}
const createWithEqualityFnImpl = (createState, defaultEqualityFn) => {
  const api = createStore(createState);
  const useBoundStoreWithEqualityFn = (selector, equalityFn = defaultEqualityFn) => useStoreWithEqualityFn(api, selector, equalityFn);
  Object.assign(useBoundStoreWithEqualityFn, api);
  return useBoundStoreWithEqualityFn;
};
const createWithEqualityFn = (createState, defaultEqualityFn) => createState ? createWithEqualityFnImpl(createState, defaultEqualityFn) : createWithEqualityFnImpl;

function shallow$1(objA, objB) {
  if (Object.is(objA, objB)) {
    return true;
  }
  if (typeof objA !== "object" || objA === null || typeof objB !== "object" || objB === null) {
    return false;
  }
  if (objA instanceof Map && objB instanceof Map) {
    if (objA.size !== objB.size)
      return false;
    for (const [key, value] of objA) {
      if (!Object.is(value, objB.get(key))) {
        return false;
      }
    }
    return true;
  }
  if (objA instanceof Set && objB instanceof Set) {
    if (objA.size !== objB.size)
      return false;
    for (const value of objA) {
      if (!objB.has(value)) {
        return false;
      }
    }
    return true;
  }
  const keysA = Object.keys(objA);
  if (keysA.length !== Object.keys(objB).length) {
    return false;
  }
  for (let i = 0; i < keysA.length; i++) {
    if (!Object.prototype.hasOwnProperty.call(objB, keysA[i]) || !Object.is(objA[keysA[i]], objB[keysA[i]])) {
      return false;
    }
  }
  return true;
}

var noop$1 = {value: () => {}};

function dispatch() {
  for (var i = 0, n = arguments.length, _ = {}, t; i < n; ++i) {
    if (!(t = arguments[i] + "") || (t in _) || /[\s.]/.test(t)) throw new Error("illegal type: " + t);
    _[t] = [];
  }
  return new Dispatch(_);
}

function Dispatch(_) {
  this._ = _;
}

function parseTypenames$1(typenames, types) {
  return typenames.trim().split(/^|\s+/).map(function(t) {
    var name = "", i = t.indexOf(".");
    if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
    if (t && !types.hasOwnProperty(t)) throw new Error("unknown type: " + t);
    return {type: t, name: name};
  });
}

Dispatch.prototype = dispatch.prototype = {
  constructor: Dispatch,
  on: function(typename, callback) {
    var _ = this._,
        T = parseTypenames$1(typename + "", _),
        t,
        i = -1,
        n = T.length;

    // If no callback was specified, return the callback of the given type and name.
    if (arguments.length < 2) {
      while (++i < n) if ((t = (typename = T[i]).type) && (t = get$1(_[t], typename.name))) return t;
      return;
    }

    // If a type was specified, set the callback for the given type and name.
    // Otherwise, if a null callback was specified, remove callbacks of the given name.
    if (callback != null && typeof callback !== "function") throw new Error("invalid callback: " + callback);
    while (++i < n) {
      if (t = (typename = T[i]).type) _[t] = set$1(_[t], typename.name, callback);
      else if (callback == null) for (t in _) _[t] = set$1(_[t], typename.name, null);
    }

    return this;
  },
  copy: function() {
    var copy = {}, _ = this._;
    for (var t in _) copy[t] = _[t].slice();
    return new Dispatch(copy);
  },
  call: function(type, that) {
    if ((n = arguments.length - 2) > 0) for (var args = new Array(n), i = 0, n, t; i < n; ++i) args[i] = arguments[i + 2];
    if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
    for (t = this._[type], i = 0, n = t.length; i < n; ++i) t[i].value.apply(that, args);
  },
  apply: function(type, that, args) {
    if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
    for (var t = this._[type], i = 0, n = t.length; i < n; ++i) t[i].value.apply(that, args);
  }
};

function get$1(type, name) {
  for (var i = 0, n = type.length, c; i < n; ++i) {
    if ((c = type[i]).name === name) {
      return c.value;
    }
  }
}

function set$1(type, name, callback) {
  for (var i = 0, n = type.length; i < n; ++i) {
    if (type[i].name === name) {
      type[i] = noop$1, type = type.slice(0, i).concat(type.slice(i + 1));
      break;
    }
  }
  if (callback != null) type.push({name: name, value: callback});
  return type;
}

var xhtml = "http://www.w3.org/1999/xhtml";

const namespaces = {
  svg: "http://www.w3.org/2000/svg",
  xhtml: xhtml,
  xlink: "http://www.w3.org/1999/xlink",
  xml: "http://www.w3.org/XML/1998/namespace",
  xmlns: "http://www.w3.org/2000/xmlns/"
};

function namespace(name) {
  var prefix = name += "", i = prefix.indexOf(":");
  if (i >= 0 && (prefix = name.slice(0, i)) !== "xmlns") name = name.slice(i + 1);
  return namespaces.hasOwnProperty(prefix) ? {space: namespaces[prefix], local: name} : name; // eslint-disable-line no-prototype-builtins
}

function creatorInherit(name) {
  return function() {
    var document = this.ownerDocument,
        uri = this.namespaceURI;
    return uri === xhtml && document.documentElement.namespaceURI === xhtml
        ? document.createElement(name)
        : document.createElementNS(uri, name);
  };
}

function creatorFixed(fullname) {
  return function() {
    return this.ownerDocument.createElementNS(fullname.space, fullname.local);
  };
}

function creator(name) {
  var fullname = namespace(name);
  return (fullname.local
      ? creatorFixed
      : creatorInherit)(fullname);
}

function none() {}

function selector$1(selector) {
  return selector == null ? none : function() {
    return this.querySelector(selector);
  };
}

function selection_select(select) {
  if (typeof select !== "function") select = selector$1(select);

  for (var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, subgroup = subgroups[j] = new Array(n), node, subnode, i = 0; i < n; ++i) {
      if ((node = group[i]) && (subnode = select.call(node, node.__data__, i, group))) {
        if ("__data__" in node) subnode.__data__ = node.__data__;
        subgroup[i] = subnode;
      }
    }
  }

  return new Selection$1(subgroups, this._parents);
}

// Given something array like (or null), returns something that is strictly an
// array. This is used to ensure that array-like objects passed to d3.selectAll
// or selection.selectAll are converted into proper arrays when creating a
// selection; we don’t ever want to create a selection backed by a live
// HTMLCollection or NodeList. However, note that selection.selectAll will use a
// static NodeList as a group, since it safely derived from querySelectorAll.
function array(x) {
  return x == null ? [] : Array.isArray(x) ? x : Array.from(x);
}

function empty$1() {
  return [];
}

function selectorAll(selector) {
  return selector == null ? empty$1 : function() {
    return this.querySelectorAll(selector);
  };
}

function arrayAll(select) {
  return function() {
    return array(select.apply(this, arguments));
  };
}

function selection_selectAll(select) {
  if (typeof select === "function") select = arrayAll(select);
  else select = selectorAll(select);

  for (var groups = this._groups, m = groups.length, subgroups = [], parents = [], j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, node, i = 0; i < n; ++i) {
      if (node = group[i]) {
        subgroups.push(select.call(node, node.__data__, i, group));
        parents.push(node);
      }
    }
  }

  return new Selection$1(subgroups, parents);
}

function matcher(selector) {
  return function() {
    return this.matches(selector);
  };
}

function childMatcher(selector) {
  return function(node) {
    return node.matches(selector);
  };
}

var find = Array.prototype.find;

function childFind(match) {
  return function() {
    return find.call(this.children, match);
  };
}

function childFirst() {
  return this.firstElementChild;
}

function selection_selectChild(match) {
  return this.select(match == null ? childFirst
      : childFind(typeof match === "function" ? match : childMatcher(match)));
}

var filter = Array.prototype.filter;

function children() {
  return Array.from(this.children);
}

function childrenFilter(match) {
  return function() {
    return filter.call(this.children, match);
  };
}

function selection_selectChildren(match) {
  return this.selectAll(match == null ? children
      : childrenFilter(typeof match === "function" ? match : childMatcher(match)));
}

function selection_filter(match) {
  if (typeof match !== "function") match = matcher(match);

  for (var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, subgroup = subgroups[j] = [], node, i = 0; i < n; ++i) {
      if ((node = group[i]) && match.call(node, node.__data__, i, group)) {
        subgroup.push(node);
      }
    }
  }

  return new Selection$1(subgroups, this._parents);
}

function sparse(update) {
  return new Array(update.length);
}

function selection_enter() {
  return new Selection$1(this._enter || this._groups.map(sparse), this._parents);
}

function EnterNode(parent, datum) {
  this.ownerDocument = parent.ownerDocument;
  this.namespaceURI = parent.namespaceURI;
  this._next = null;
  this._parent = parent;
  this.__data__ = datum;
}

EnterNode.prototype = {
  constructor: EnterNode,
  appendChild: function(child) { return this._parent.insertBefore(child, this._next); },
  insertBefore: function(child, next) { return this._parent.insertBefore(child, next); },
  querySelector: function(selector) { return this._parent.querySelector(selector); },
  querySelectorAll: function(selector) { return this._parent.querySelectorAll(selector); }
};

function constant$3(x) {
  return function() {
    return x;
  };
}

function bindIndex(parent, group, enter, update, exit, data) {
  var i = 0,
      node,
      groupLength = group.length,
      dataLength = data.length;

  // Put any non-null nodes that fit into update.
  // Put any null nodes into enter.
  // Put any remaining data into enter.
  for (; i < dataLength; ++i) {
    if (node = group[i]) {
      node.__data__ = data[i];
      update[i] = node;
    } else {
      enter[i] = new EnterNode(parent, data[i]);
    }
  }

  // Put any non-null nodes that don’t fit into exit.
  for (; i < groupLength; ++i) {
    if (node = group[i]) {
      exit[i] = node;
    }
  }
}

function bindKey(parent, group, enter, update, exit, data, key) {
  var i,
      node,
      nodeByKeyValue = new Map,
      groupLength = group.length,
      dataLength = data.length,
      keyValues = new Array(groupLength),
      keyValue;

  // Compute the key for each node.
  // If multiple nodes have the same key, the duplicates are added to exit.
  for (i = 0; i < groupLength; ++i) {
    if (node = group[i]) {
      keyValues[i] = keyValue = key.call(node, node.__data__, i, group) + "";
      if (nodeByKeyValue.has(keyValue)) {
        exit[i] = node;
      } else {
        nodeByKeyValue.set(keyValue, node);
      }
    }
  }

  // Compute the key for each datum.
  // If there a node associated with this key, join and add it to update.
  // If there is not (or the key is a duplicate), add it to enter.
  for (i = 0; i < dataLength; ++i) {
    keyValue = key.call(parent, data[i], i, data) + "";
    if (node = nodeByKeyValue.get(keyValue)) {
      update[i] = node;
      node.__data__ = data[i];
      nodeByKeyValue.delete(keyValue);
    } else {
      enter[i] = new EnterNode(parent, data[i]);
    }
  }

  // Add any remaining nodes that were not bound to data to exit.
  for (i = 0; i < groupLength; ++i) {
    if ((node = group[i]) && (nodeByKeyValue.get(keyValues[i]) === node)) {
      exit[i] = node;
    }
  }
}

function datum(node) {
  return node.__data__;
}

function selection_data(value, key) {
  if (!arguments.length) return Array.from(this, datum);

  var bind = key ? bindKey : bindIndex,
      parents = this._parents,
      groups = this._groups;

  if (typeof value !== "function") value = constant$3(value);

  for (var m = groups.length, update = new Array(m), enter = new Array(m), exit = new Array(m), j = 0; j < m; ++j) {
    var parent = parents[j],
        group = groups[j],
        groupLength = group.length,
        data = arraylike(value.call(parent, parent && parent.__data__, j, parents)),
        dataLength = data.length,
        enterGroup = enter[j] = new Array(dataLength),
        updateGroup = update[j] = new Array(dataLength),
        exitGroup = exit[j] = new Array(groupLength);

    bind(parent, group, enterGroup, updateGroup, exitGroup, data, key);

    // Now connect the enter nodes to their following update node, such that
    // appendChild can insert the materialized enter node before this node,
    // rather than at the end of the parent node.
    for (var i0 = 0, i1 = 0, previous, next; i0 < dataLength; ++i0) {
      if (previous = enterGroup[i0]) {
        if (i0 >= i1) i1 = i0 + 1;
        while (!(next = updateGroup[i1]) && ++i1 < dataLength);
        previous._next = next || null;
      }
    }
  }

  update = new Selection$1(update, parents);
  update._enter = enter;
  update._exit = exit;
  return update;
}

// Given some data, this returns an array-like view of it: an object that
// exposes a length property and allows numeric indexing. Note that unlike
// selectAll, this isn’t worried about “live” collections because the resulting
// array will only be used briefly while data is being bound. (It is possible to
// cause the data to change while iterating by using a key function, but please
// don’t; we’d rather avoid a gratuitous copy.)
function arraylike(data) {
  return typeof data === "object" && "length" in data
    ? data // Array, TypedArray, NodeList, array-like
    : Array.from(data); // Map, Set, iterable, string, or anything else
}

function selection_exit() {
  return new Selection$1(this._exit || this._groups.map(sparse), this._parents);
}

function selection_join(onenter, onupdate, onexit) {
  var enter = this.enter(), update = this, exit = this.exit();
  if (typeof onenter === "function") {
    enter = onenter(enter);
    if (enter) enter = enter.selection();
  } else {
    enter = enter.append(onenter + "");
  }
  if (onupdate != null) {
    update = onupdate(update);
    if (update) update = update.selection();
  }
  if (onexit == null) exit.remove(); else onexit(exit);
  return enter && update ? enter.merge(update).order() : update;
}

function selection_merge(context) {
  var selection = context.selection ? context.selection() : context;

  for (var groups0 = this._groups, groups1 = selection._groups, m0 = groups0.length, m1 = groups1.length, m = Math.min(m0, m1), merges = new Array(m0), j = 0; j < m; ++j) {
    for (var group0 = groups0[j], group1 = groups1[j], n = group0.length, merge = merges[j] = new Array(n), node, i = 0; i < n; ++i) {
      if (node = group0[i] || group1[i]) {
        merge[i] = node;
      }
    }
  }

  for (; j < m0; ++j) {
    merges[j] = groups0[j];
  }

  return new Selection$1(merges, this._parents);
}

function selection_order() {

  for (var groups = this._groups, j = -1, m = groups.length; ++j < m;) {
    for (var group = groups[j], i = group.length - 1, next = group[i], node; --i >= 0;) {
      if (node = group[i]) {
        if (next && node.compareDocumentPosition(next) ^ 4) next.parentNode.insertBefore(node, next);
        next = node;
      }
    }
  }

  return this;
}

function selection_sort(compare) {
  if (!compare) compare = ascending;

  function compareNode(a, b) {
    return a && b ? compare(a.__data__, b.__data__) : !a - !b;
  }

  for (var groups = this._groups, m = groups.length, sortgroups = new Array(m), j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, sortgroup = sortgroups[j] = new Array(n), node, i = 0; i < n; ++i) {
      if (node = group[i]) {
        sortgroup[i] = node;
      }
    }
    sortgroup.sort(compareNode);
  }

  return new Selection$1(sortgroups, this._parents).order();
}

function ascending(a, b) {
  return a < b ? -1 : a > b ? 1 : a >= b ? 0 : NaN;
}

function selection_call() {
  var callback = arguments[0];
  arguments[0] = this;
  callback.apply(null, arguments);
  return this;
}

function selection_nodes() {
  return Array.from(this);
}

function selection_node() {

  for (var groups = this._groups, j = 0, m = groups.length; j < m; ++j) {
    for (var group = groups[j], i = 0, n = group.length; i < n; ++i) {
      var node = group[i];
      if (node) return node;
    }
  }

  return null;
}

function selection_size() {
  let size = 0;
  for (const node of this) ++size; // eslint-disable-line no-unused-vars
  return size;
}

function selection_empty() {
  return !this.node();
}

function selection_each(callback) {

  for (var groups = this._groups, j = 0, m = groups.length; j < m; ++j) {
    for (var group = groups[j], i = 0, n = group.length, node; i < n; ++i) {
      if (node = group[i]) callback.call(node, node.__data__, i, group);
    }
  }

  return this;
}

function attrRemove$1(name) {
  return function() {
    this.removeAttribute(name);
  };
}

function attrRemoveNS$1(fullname) {
  return function() {
    this.removeAttributeNS(fullname.space, fullname.local);
  };
}

function attrConstant$1(name, value) {
  return function() {
    this.setAttribute(name, value);
  };
}

function attrConstantNS$1(fullname, value) {
  return function() {
    this.setAttributeNS(fullname.space, fullname.local, value);
  };
}

function attrFunction$1(name, value) {
  return function() {
    var v = value.apply(this, arguments);
    if (v == null) this.removeAttribute(name);
    else this.setAttribute(name, v);
  };
}

function attrFunctionNS$1(fullname, value) {
  return function() {
    var v = value.apply(this, arguments);
    if (v == null) this.removeAttributeNS(fullname.space, fullname.local);
    else this.setAttributeNS(fullname.space, fullname.local, v);
  };
}

function selection_attr(name, value) {
  var fullname = namespace(name);

  if (arguments.length < 2) {
    var node = this.node();
    return fullname.local
        ? node.getAttributeNS(fullname.space, fullname.local)
        : node.getAttribute(fullname);
  }

  return this.each((value == null
      ? (fullname.local ? attrRemoveNS$1 : attrRemove$1) : (typeof value === "function"
      ? (fullname.local ? attrFunctionNS$1 : attrFunction$1)
      : (fullname.local ? attrConstantNS$1 : attrConstant$1)))(fullname, value));
}

function defaultView(node) {
  return (node.ownerDocument && node.ownerDocument.defaultView) // node is a Node
      || (node.document && node) // node is a Window
      || node.defaultView; // node is a Document
}

function styleRemove$1(name) {
  return function() {
    this.style.removeProperty(name);
  };
}

function styleConstant$1(name, value, priority) {
  return function() {
    this.style.setProperty(name, value, priority);
  };
}

function styleFunction$1(name, value, priority) {
  return function() {
    var v = value.apply(this, arguments);
    if (v == null) this.style.removeProperty(name);
    else this.style.setProperty(name, v, priority);
  };
}

function selection_style(name, value, priority) {
  return arguments.length > 1
      ? this.each((value == null
            ? styleRemove$1 : typeof value === "function"
            ? styleFunction$1
            : styleConstant$1)(name, value, priority == null ? "" : priority))
      : styleValue(this.node(), name);
}

function styleValue(node, name) {
  return node.style.getPropertyValue(name)
      || defaultView(node).getComputedStyle(node, null).getPropertyValue(name);
}

function propertyRemove(name) {
  return function() {
    delete this[name];
  };
}

function propertyConstant(name, value) {
  return function() {
    this[name] = value;
  };
}

function propertyFunction(name, value) {
  return function() {
    var v = value.apply(this, arguments);
    if (v == null) delete this[name];
    else this[name] = v;
  };
}

function selection_property(name, value) {
  return arguments.length > 1
      ? this.each((value == null
          ? propertyRemove : typeof value === "function"
          ? propertyFunction
          : propertyConstant)(name, value))
      : this.node()[name];
}

function classArray(string) {
  return string.trim().split(/^|\s+/);
}

function classList(node) {
  return node.classList || new ClassList(node);
}

function ClassList(node) {
  this._node = node;
  this._names = classArray(node.getAttribute("class") || "");
}

ClassList.prototype = {
  add: function(name) {
    var i = this._names.indexOf(name);
    if (i < 0) {
      this._names.push(name);
      this._node.setAttribute("class", this._names.join(" "));
    }
  },
  remove: function(name) {
    var i = this._names.indexOf(name);
    if (i >= 0) {
      this._names.splice(i, 1);
      this._node.setAttribute("class", this._names.join(" "));
    }
  },
  contains: function(name) {
    return this._names.indexOf(name) >= 0;
  }
};

function classedAdd(node, names) {
  var list = classList(node), i = -1, n = names.length;
  while (++i < n) list.add(names[i]);
}

function classedRemove(node, names) {
  var list = classList(node), i = -1, n = names.length;
  while (++i < n) list.remove(names[i]);
}

function classedTrue(names) {
  return function() {
    classedAdd(this, names);
  };
}

function classedFalse(names) {
  return function() {
    classedRemove(this, names);
  };
}

function classedFunction(names, value) {
  return function() {
    (value.apply(this, arguments) ? classedAdd : classedRemove)(this, names);
  };
}

function selection_classed(name, value) {
  var names = classArray(name + "");

  if (arguments.length < 2) {
    var list = classList(this.node()), i = -1, n = names.length;
    while (++i < n) if (!list.contains(names[i])) return false;
    return true;
  }

  return this.each((typeof value === "function"
      ? classedFunction : value
      ? classedTrue
      : classedFalse)(names, value));
}

function textRemove() {
  this.textContent = "";
}

function textConstant$1(value) {
  return function() {
    this.textContent = value;
  };
}

function textFunction$1(value) {
  return function() {
    var v = value.apply(this, arguments);
    this.textContent = v == null ? "" : v;
  };
}

function selection_text(value) {
  return arguments.length
      ? this.each(value == null
          ? textRemove : (typeof value === "function"
          ? textFunction$1
          : textConstant$1)(value))
      : this.node().textContent;
}

function htmlRemove() {
  this.innerHTML = "";
}

function htmlConstant(value) {
  return function() {
    this.innerHTML = value;
  };
}

function htmlFunction(value) {
  return function() {
    var v = value.apply(this, arguments);
    this.innerHTML = v == null ? "" : v;
  };
}

function selection_html(value) {
  return arguments.length
      ? this.each(value == null
          ? htmlRemove : (typeof value === "function"
          ? htmlFunction
          : htmlConstant)(value))
      : this.node().innerHTML;
}

function raise() {
  if (this.nextSibling) this.parentNode.appendChild(this);
}

function selection_raise() {
  return this.each(raise);
}

function lower() {
  if (this.previousSibling) this.parentNode.insertBefore(this, this.parentNode.firstChild);
}

function selection_lower() {
  return this.each(lower);
}

function selection_append(name) {
  var create = typeof name === "function" ? name : creator(name);
  return this.select(function() {
    return this.appendChild(create.apply(this, arguments));
  });
}

function constantNull() {
  return null;
}

function selection_insert(name, before) {
  var create = typeof name === "function" ? name : creator(name),
      select = before == null ? constantNull : typeof before === "function" ? before : selector$1(before);
  return this.select(function() {
    return this.insertBefore(create.apply(this, arguments), select.apply(this, arguments) || null);
  });
}

function remove() {
  var parent = this.parentNode;
  if (parent) parent.removeChild(this);
}

function selection_remove() {
  return this.each(remove);
}

function selection_cloneShallow() {
  var clone = this.cloneNode(false), parent = this.parentNode;
  return parent ? parent.insertBefore(clone, this.nextSibling) : clone;
}

function selection_cloneDeep() {
  var clone = this.cloneNode(true), parent = this.parentNode;
  return parent ? parent.insertBefore(clone, this.nextSibling) : clone;
}

function selection_clone(deep) {
  return this.select(deep ? selection_cloneDeep : selection_cloneShallow);
}

function selection_datum(value) {
  return arguments.length
      ? this.property("__data__", value)
      : this.node().__data__;
}

function contextListener(listener) {
  return function(event) {
    listener.call(this, event, this.__data__);
  };
}

function parseTypenames(typenames) {
  return typenames.trim().split(/^|\s+/).map(function(t) {
    var name = "", i = t.indexOf(".");
    if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
    return {type: t, name: name};
  });
}

function onRemove(typename) {
  return function() {
    var on = this.__on;
    if (!on) return;
    for (var j = 0, i = -1, m = on.length, o; j < m; ++j) {
      if (o = on[j], (!typename.type || o.type === typename.type) && o.name === typename.name) {
        this.removeEventListener(o.type, o.listener, o.options);
      } else {
        on[++i] = o;
      }
    }
    if (++i) on.length = i;
    else delete this.__on;
  };
}

function onAdd(typename, value, options) {
  return function() {
    var on = this.__on, o, listener = contextListener(value);
    if (on) for (var j = 0, m = on.length; j < m; ++j) {
      if ((o = on[j]).type === typename.type && o.name === typename.name) {
        this.removeEventListener(o.type, o.listener, o.options);
        this.addEventListener(o.type, o.listener = listener, o.options = options);
        o.value = value;
        return;
      }
    }
    this.addEventListener(typename.type, listener, options);
    o = {type: typename.type, name: typename.name, value: value, listener: listener, options: options};
    if (!on) this.__on = [o];
    else on.push(o);
  };
}

function selection_on(typename, value, options) {
  var typenames = parseTypenames(typename + ""), i, n = typenames.length, t;

  if (arguments.length < 2) {
    var on = this.node().__on;
    if (on) for (var j = 0, m = on.length, o; j < m; ++j) {
      for (i = 0, o = on[j]; i < n; ++i) {
        if ((t = typenames[i]).type === o.type && t.name === o.name) {
          return o.value;
        }
      }
    }
    return;
  }

  on = value ? onAdd : onRemove;
  for (i = 0; i < n; ++i) this.each(on(typenames[i], value, options));
  return this;
}

function dispatchEvent(node, type, params) {
  var window = defaultView(node),
      event = window.CustomEvent;

  if (typeof event === "function") {
    event = new event(type, params);
  } else {
    event = window.document.createEvent("Event");
    if (params) event.initEvent(type, params.bubbles, params.cancelable), event.detail = params.detail;
    else event.initEvent(type, false, false);
  }

  node.dispatchEvent(event);
}

function dispatchConstant(type, params) {
  return function() {
    return dispatchEvent(this, type, params);
  };
}

function dispatchFunction(type, params) {
  return function() {
    return dispatchEvent(this, type, params.apply(this, arguments));
  };
}

function selection_dispatch(type, params) {
  return this.each((typeof params === "function"
      ? dispatchFunction
      : dispatchConstant)(type, params));
}

function* selection_iterator() {
  for (var groups = this._groups, j = 0, m = groups.length; j < m; ++j) {
    for (var group = groups[j], i = 0, n = group.length, node; i < n; ++i) {
      if (node = group[i]) yield node;
    }
  }
}

var root = [null];

function Selection$1(groups, parents) {
  this._groups = groups;
  this._parents = parents;
}

function selection() {
  return new Selection$1([[document.documentElement]], root);
}

function selection_selection() {
  return this;
}

Selection$1.prototype = selection.prototype = {
  constructor: Selection$1,
  select: selection_select,
  selectAll: selection_selectAll,
  selectChild: selection_selectChild,
  selectChildren: selection_selectChildren,
  filter: selection_filter,
  data: selection_data,
  enter: selection_enter,
  exit: selection_exit,
  join: selection_join,
  merge: selection_merge,
  selection: selection_selection,
  order: selection_order,
  sort: selection_sort,
  call: selection_call,
  nodes: selection_nodes,
  node: selection_node,
  size: selection_size,
  empty: selection_empty,
  each: selection_each,
  attr: selection_attr,
  style: selection_style,
  property: selection_property,
  classed: selection_classed,
  text: selection_text,
  html: selection_html,
  raise: selection_raise,
  lower: selection_lower,
  append: selection_append,
  insert: selection_insert,
  remove: selection_remove,
  clone: selection_clone,
  datum: selection_datum,
  on: selection_on,
  dispatch: selection_dispatch,
  [Symbol.iterator]: selection_iterator
};

function select(selector) {
  return typeof selector === "string"
      ? new Selection$1([[document.querySelector(selector)]], [document.documentElement])
      : new Selection$1([[selector]], root);
}

function sourceEvent(event) {
  let sourceEvent;
  while (sourceEvent = event.sourceEvent) event = sourceEvent;
  return event;
}

function pointer(event, node) {
  event = sourceEvent(event);
  if (node === undefined) node = event.currentTarget;
  if (node) {
    var svg = node.ownerSVGElement || node;
    if (svg.createSVGPoint) {
      var point = svg.createSVGPoint();
      point.x = event.clientX, point.y = event.clientY;
      point = point.matrixTransform(node.getScreenCTM().inverse());
      return [point.x, point.y];
    }
    if (node.getBoundingClientRect) {
      var rect = node.getBoundingClientRect();
      return [event.clientX - rect.left - node.clientLeft, event.clientY - rect.top - node.clientTop];
    }
  }
  return [event.pageX, event.pageY];
}

// These are typically used in conjunction with noevent to ensure that we can
// preventDefault on the event.
const nonpassive = {passive: false};
const nonpassivecapture = {capture: true, passive: false};

function nopropagation$1(event) {
  event.stopImmediatePropagation();
}

function noevent$1(event) {
  event.preventDefault();
  event.stopImmediatePropagation();
}

function dragDisable(view) {
  var root = view.document.documentElement,
      selection = select(view).on("dragstart.drag", noevent$1, nonpassivecapture);
  if ("onselectstart" in root) {
    selection.on("selectstart.drag", noevent$1, nonpassivecapture);
  } else {
    root.__noselect = root.style.MozUserSelect;
    root.style.MozUserSelect = "none";
  }
}

function yesdrag(view, noclick) {
  var root = view.document.documentElement,
      selection = select(view).on("dragstart.drag", null);
  if (noclick) {
    selection.on("click.drag", noevent$1, nonpassivecapture);
    setTimeout(function() { selection.on("click.drag", null); }, 0);
  }
  if ("onselectstart" in root) {
    selection.on("selectstart.drag", null);
  } else {
    root.style.MozUserSelect = root.__noselect;
    delete root.__noselect;
  }
}

const constant$2 = x => () => x;

function DragEvent(type, {
  sourceEvent,
  subject,
  target,
  identifier,
  active,
  x, y, dx, dy,
  dispatch
}) {
  Object.defineProperties(this, {
    type: {value: type, enumerable: true, configurable: true},
    sourceEvent: {value: sourceEvent, enumerable: true, configurable: true},
    subject: {value: subject, enumerable: true, configurable: true},
    target: {value: target, enumerable: true, configurable: true},
    identifier: {value: identifier, enumerable: true, configurable: true},
    active: {value: active, enumerable: true, configurable: true},
    x: {value: x, enumerable: true, configurable: true},
    y: {value: y, enumerable: true, configurable: true},
    dx: {value: dx, enumerable: true, configurable: true},
    dy: {value: dy, enumerable: true, configurable: true},
    _: {value: dispatch}
  });
}

DragEvent.prototype.on = function() {
  var value = this._.on.apply(this._, arguments);
  return value === this._ ? this : value;
};

// Ignore right-click, since that should open the context menu.
function defaultFilter$1(event) {
  return !event.ctrlKey && !event.button;
}

function defaultContainer() {
  return this.parentNode;
}

function defaultSubject(event, d) {
  return d == null ? {x: event.x, y: event.y} : d;
}

function defaultTouchable$1() {
  return navigator.maxTouchPoints || ("ontouchstart" in this);
}

function drag() {
  var filter = defaultFilter$1,
      container = defaultContainer,
      subject = defaultSubject,
      touchable = defaultTouchable$1,
      gestures = {},
      listeners = dispatch("start", "drag", "end"),
      active = 0,
      mousedownx,
      mousedowny,
      mousemoving,
      touchending,
      clickDistance2 = 0;

  function drag(selection) {
    selection
        .on("mousedown.drag", mousedowned)
      .filter(touchable)
        .on("touchstart.drag", touchstarted)
        .on("touchmove.drag", touchmoved, nonpassive)
        .on("touchend.drag touchcancel.drag", touchended)
        .style("touch-action", "none")
        .style("-webkit-tap-highlight-color", "rgba(0,0,0,0)");
  }

  function mousedowned(event, d) {
    if (touchending || !filter.call(this, event, d)) return;
    var gesture = beforestart(this, container.call(this, event, d), event, d, "mouse");
    if (!gesture) return;
    select(event.view)
      .on("mousemove.drag", mousemoved, nonpassivecapture)
      .on("mouseup.drag", mouseupped, nonpassivecapture);
    dragDisable(event.view);
    nopropagation$1(event);
    mousemoving = false;
    mousedownx = event.clientX;
    mousedowny = event.clientY;
    gesture("start", event);
  }

  function mousemoved(event) {
    noevent$1(event);
    if (!mousemoving) {
      var dx = event.clientX - mousedownx, dy = event.clientY - mousedowny;
      mousemoving = dx * dx + dy * dy > clickDistance2;
    }
    gestures.mouse("drag", event);
  }

  function mouseupped(event) {
    select(event.view).on("mousemove.drag mouseup.drag", null);
    yesdrag(event.view, mousemoving);
    noevent$1(event);
    gestures.mouse("end", event);
  }

  function touchstarted(event, d) {
    if (!filter.call(this, event, d)) return;
    var touches = event.changedTouches,
        c = container.call(this, event, d),
        n = touches.length, i, gesture;

    for (i = 0; i < n; ++i) {
      if (gesture = beforestart(this, c, event, d, touches[i].identifier, touches[i])) {
        nopropagation$1(event);
        gesture("start", event, touches[i]);
      }
    }
  }

  function touchmoved(event) {
    var touches = event.changedTouches,
        n = touches.length, i, gesture;

    for (i = 0; i < n; ++i) {
      if (gesture = gestures[touches[i].identifier]) {
        noevent$1(event);
        gesture("drag", event, touches[i]);
      }
    }
  }

  function touchended(event) {
    var touches = event.changedTouches,
        n = touches.length, i, gesture;

    if (touchending) clearTimeout(touchending);
    touchending = setTimeout(function() { touchending = null; }, 500); // Ghost clicks are delayed!
    for (i = 0; i < n; ++i) {
      if (gesture = gestures[touches[i].identifier]) {
        nopropagation$1(event);
        gesture("end", event, touches[i]);
      }
    }
  }

  function beforestart(that, container, event, d, identifier, touch) {
    var dispatch = listeners.copy(),
        p = pointer(touch || event, container), dx, dy,
        s;

    if ((s = subject.call(that, new DragEvent("beforestart", {
        sourceEvent: event,
        target: drag,
        identifier,
        active,
        x: p[0],
        y: p[1],
        dx: 0,
        dy: 0,
        dispatch
      }), d)) == null) return;

    dx = s.x - p[0] || 0;
    dy = s.y - p[1] || 0;

    return function gesture(type, event, touch) {
      var p0 = p, n;
      switch (type) {
        case "start": gestures[identifier] = gesture, n = active++; break;
        case "end": delete gestures[identifier], --active; // falls through
        case "drag": p = pointer(touch || event, container), n = active; break;
      }
      dispatch.call(
        type,
        that,
        new DragEvent(type, {
          sourceEvent: event,
          subject: s,
          target: drag,
          identifier,
          active: n,
          x: p[0] + dx,
          y: p[1] + dy,
          dx: p[0] - p0[0],
          dy: p[1] - p0[1],
          dispatch
        }),
        d
      );
    };
  }

  drag.filter = function(_) {
    return arguments.length ? (filter = typeof _ === "function" ? _ : constant$2(!!_), drag) : filter;
  };

  drag.container = function(_) {
    return arguments.length ? (container = typeof _ === "function" ? _ : constant$2(_), drag) : container;
  };

  drag.subject = function(_) {
    return arguments.length ? (subject = typeof _ === "function" ? _ : constant$2(_), drag) : subject;
  };

  drag.touchable = function(_) {
    return arguments.length ? (touchable = typeof _ === "function" ? _ : constant$2(!!_), drag) : touchable;
  };

  drag.on = function() {
    var value = listeners.on.apply(listeners, arguments);
    return value === listeners ? drag : value;
  };

  drag.clickDistance = function(_) {
    return arguments.length ? (clickDistance2 = (_ = +_) * _, drag) : Math.sqrt(clickDistance2);
  };

  return drag;
}

function define(constructor, factory, prototype) {
  constructor.prototype = factory.prototype = prototype;
  prototype.constructor = constructor;
}

function extend(parent, definition) {
  var prototype = Object.create(parent.prototype);
  for (var key in definition) prototype[key] = definition[key];
  return prototype;
}

function Color() {}

var darker = 0.7;
var brighter = 1 / darker;

var reI = "\\s*([+-]?\\d+)\\s*",
    reN = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",
    reP = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",
    reHex = /^#([0-9a-f]{3,8})$/,
    reRgbInteger = new RegExp(`^rgb\\(${reI},${reI},${reI}\\)$`),
    reRgbPercent = new RegExp(`^rgb\\(${reP},${reP},${reP}\\)$`),
    reRgbaInteger = new RegExp(`^rgba\\(${reI},${reI},${reI},${reN}\\)$`),
    reRgbaPercent = new RegExp(`^rgba\\(${reP},${reP},${reP},${reN}\\)$`),
    reHslPercent = new RegExp(`^hsl\\(${reN},${reP},${reP}\\)$`),
    reHslaPercent = new RegExp(`^hsla\\(${reN},${reP},${reP},${reN}\\)$`);

var named = {
  aliceblue: 0xf0f8ff,
  antiquewhite: 0xfaebd7,
  aqua: 0x00ffff,
  aquamarine: 0x7fffd4,
  azure: 0xf0ffff,
  beige: 0xf5f5dc,
  bisque: 0xffe4c4,
  black: 0x000000,
  blanchedalmond: 0xffebcd,
  blue: 0x0000ff,
  blueviolet: 0x8a2be2,
  brown: 0xa52a2a,
  burlywood: 0xdeb887,
  cadetblue: 0x5f9ea0,
  chartreuse: 0x7fff00,
  chocolate: 0xd2691e,
  coral: 0xff7f50,
  cornflowerblue: 0x6495ed,
  cornsilk: 0xfff8dc,
  crimson: 0xdc143c,
  cyan: 0x00ffff,
  darkblue: 0x00008b,
  darkcyan: 0x008b8b,
  darkgoldenrod: 0xb8860b,
  darkgray: 0xa9a9a9,
  darkgreen: 0x006400,
  darkgrey: 0xa9a9a9,
  darkkhaki: 0xbdb76b,
  darkmagenta: 0x8b008b,
  darkolivegreen: 0x556b2f,
  darkorange: 0xff8c00,
  darkorchid: 0x9932cc,
  darkred: 0x8b0000,
  darksalmon: 0xe9967a,
  darkseagreen: 0x8fbc8f,
  darkslateblue: 0x483d8b,
  darkslategray: 0x2f4f4f,
  darkslategrey: 0x2f4f4f,
  darkturquoise: 0x00ced1,
  darkviolet: 0x9400d3,
  deeppink: 0xff1493,
  deepskyblue: 0x00bfff,
  dimgray: 0x696969,
  dimgrey: 0x696969,
  dodgerblue: 0x1e90ff,
  firebrick: 0xb22222,
  floralwhite: 0xfffaf0,
  forestgreen: 0x228b22,
  fuchsia: 0xff00ff,
  gainsboro: 0xdcdcdc,
  ghostwhite: 0xf8f8ff,
  gold: 0xffd700,
  goldenrod: 0xdaa520,
  gray: 0x808080,
  green: 0x008000,
  greenyellow: 0xadff2f,
  grey: 0x808080,
  honeydew: 0xf0fff0,
  hotpink: 0xff69b4,
  indianred: 0xcd5c5c,
  indigo: 0x4b0082,
  ivory: 0xfffff0,
  khaki: 0xf0e68c,
  lavender: 0xe6e6fa,
  lavenderblush: 0xfff0f5,
  lawngreen: 0x7cfc00,
  lemonchiffon: 0xfffacd,
  lightblue: 0xadd8e6,
  lightcoral: 0xf08080,
  lightcyan: 0xe0ffff,
  lightgoldenrodyellow: 0xfafad2,
  lightgray: 0xd3d3d3,
  lightgreen: 0x90ee90,
  lightgrey: 0xd3d3d3,
  lightpink: 0xffb6c1,
  lightsalmon: 0xffa07a,
  lightseagreen: 0x20b2aa,
  lightskyblue: 0x87cefa,
  lightslategray: 0x778899,
  lightslategrey: 0x778899,
  lightsteelblue: 0xb0c4de,
  lightyellow: 0xffffe0,
  lime: 0x00ff00,
  limegreen: 0x32cd32,
  linen: 0xfaf0e6,
  magenta: 0xff00ff,
  maroon: 0x800000,
  mediumaquamarine: 0x66cdaa,
  mediumblue: 0x0000cd,
  mediumorchid: 0xba55d3,
  mediumpurple: 0x9370db,
  mediumseagreen: 0x3cb371,
  mediumslateblue: 0x7b68ee,
  mediumspringgreen: 0x00fa9a,
  mediumturquoise: 0x48d1cc,
  mediumvioletred: 0xc71585,
  midnightblue: 0x191970,
  mintcream: 0xf5fffa,
  mistyrose: 0xffe4e1,
  moccasin: 0xffe4b5,
  navajowhite: 0xffdead,
  navy: 0x000080,
  oldlace: 0xfdf5e6,
  olive: 0x808000,
  olivedrab: 0x6b8e23,
  orange: 0xffa500,
  orangered: 0xff4500,
  orchid: 0xda70d6,
  palegoldenrod: 0xeee8aa,
  palegreen: 0x98fb98,
  paleturquoise: 0xafeeee,
  palevioletred: 0xdb7093,
  papayawhip: 0xffefd5,
  peachpuff: 0xffdab9,
  peru: 0xcd853f,
  pink: 0xffc0cb,
  plum: 0xdda0dd,
  powderblue: 0xb0e0e6,
  purple: 0x800080,
  rebeccapurple: 0x663399,
  red: 0xff0000,
  rosybrown: 0xbc8f8f,
  royalblue: 0x4169e1,
  saddlebrown: 0x8b4513,
  salmon: 0xfa8072,
  sandybrown: 0xf4a460,
  seagreen: 0x2e8b57,
  seashell: 0xfff5ee,
  sienna: 0xa0522d,
  silver: 0xc0c0c0,
  skyblue: 0x87ceeb,
  slateblue: 0x6a5acd,
  slategray: 0x708090,
  slategrey: 0x708090,
  snow: 0xfffafa,
  springgreen: 0x00ff7f,
  steelblue: 0x4682b4,
  tan: 0xd2b48c,
  teal: 0x008080,
  thistle: 0xd8bfd8,
  tomato: 0xff6347,
  turquoise: 0x40e0d0,
  violet: 0xee82ee,
  wheat: 0xf5deb3,
  white: 0xffffff,
  whitesmoke: 0xf5f5f5,
  yellow: 0xffff00,
  yellowgreen: 0x9acd32
};

define(Color, color, {
  copy(channels) {
    return Object.assign(new this.constructor, this, channels);
  },
  displayable() {
    return this.rgb().displayable();
  },
  hex: color_formatHex, // Deprecated! Use color.formatHex.
  formatHex: color_formatHex,
  formatHex8: color_formatHex8,
  formatHsl: color_formatHsl,
  formatRgb: color_formatRgb,
  toString: color_formatRgb
});

function color_formatHex() {
  return this.rgb().formatHex();
}

function color_formatHex8() {
  return this.rgb().formatHex8();
}

function color_formatHsl() {
  return hslConvert(this).formatHsl();
}

function color_formatRgb() {
  return this.rgb().formatRgb();
}

function color(format) {
  var m, l;
  format = (format + "").trim().toLowerCase();
  return (m = reHex.exec(format)) ? (l = m[1].length, m = parseInt(m[1], 16), l === 6 ? rgbn(m) // #ff0000
      : l === 3 ? new Rgb((m >> 8 & 0xf) | (m >> 4 & 0xf0), (m >> 4 & 0xf) | (m & 0xf0), ((m & 0xf) << 4) | (m & 0xf), 1) // #f00
      : l === 8 ? rgba(m >> 24 & 0xff, m >> 16 & 0xff, m >> 8 & 0xff, (m & 0xff) / 0xff) // #ff000000
      : l === 4 ? rgba((m >> 12 & 0xf) | (m >> 8 & 0xf0), (m >> 8 & 0xf) | (m >> 4 & 0xf0), (m >> 4 & 0xf) | (m & 0xf0), (((m & 0xf) << 4) | (m & 0xf)) / 0xff) // #f000
      : null) // invalid hex
      : (m = reRgbInteger.exec(format)) ? new Rgb(m[1], m[2], m[3], 1) // rgb(255, 0, 0)
      : (m = reRgbPercent.exec(format)) ? new Rgb(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, 1) // rgb(100%, 0%, 0%)
      : (m = reRgbaInteger.exec(format)) ? rgba(m[1], m[2], m[3], m[4]) // rgba(255, 0, 0, 1)
      : (m = reRgbaPercent.exec(format)) ? rgba(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, m[4]) // rgb(100%, 0%, 0%, 1)
      : (m = reHslPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, 1) // hsl(120, 50%, 50%)
      : (m = reHslaPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, m[4]) // hsla(120, 50%, 50%, 1)
      : named.hasOwnProperty(format) ? rgbn(named[format]) // eslint-disable-line no-prototype-builtins
      : format === "transparent" ? new Rgb(NaN, NaN, NaN, 0)
      : null;
}

function rgbn(n) {
  return new Rgb(n >> 16 & 0xff, n >> 8 & 0xff, n & 0xff, 1);
}

function rgba(r, g, b, a) {
  if (a <= 0) r = g = b = NaN;
  return new Rgb(r, g, b, a);
}

function rgbConvert(o) {
  if (!(o instanceof Color)) o = color(o);
  if (!o) return new Rgb;
  o = o.rgb();
  return new Rgb(o.r, o.g, o.b, o.opacity);
}

function rgb(r, g, b, opacity) {
  return arguments.length === 1 ? rgbConvert(r) : new Rgb(r, g, b, opacity == null ? 1 : opacity);
}

function Rgb(r, g, b, opacity) {
  this.r = +r;
  this.g = +g;
  this.b = +b;
  this.opacity = +opacity;
}

define(Rgb, rgb, extend(Color, {
  brighter(k) {
    k = k == null ? brighter : Math.pow(brighter, k);
    return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
  },
  darker(k) {
    k = k == null ? darker : Math.pow(darker, k);
    return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
  },
  rgb() {
    return this;
  },
  clamp() {
    return new Rgb(clampi(this.r), clampi(this.g), clampi(this.b), clampa(this.opacity));
  },
  displayable() {
    return (-0.5 <= this.r && this.r < 255.5)
        && (-0.5 <= this.g && this.g < 255.5)
        && (-0.5 <= this.b && this.b < 255.5)
        && (0 <= this.opacity && this.opacity <= 1);
  },
  hex: rgb_formatHex, // Deprecated! Use color.formatHex.
  formatHex: rgb_formatHex,
  formatHex8: rgb_formatHex8,
  formatRgb: rgb_formatRgb,
  toString: rgb_formatRgb
}));

function rgb_formatHex() {
  return `#${hex(this.r)}${hex(this.g)}${hex(this.b)}`;
}

function rgb_formatHex8() {
  return `#${hex(this.r)}${hex(this.g)}${hex(this.b)}${hex((isNaN(this.opacity) ? 1 : this.opacity) * 255)}`;
}

function rgb_formatRgb() {
  const a = clampa(this.opacity);
  return `${a === 1 ? "rgb(" : "rgba("}${clampi(this.r)}, ${clampi(this.g)}, ${clampi(this.b)}${a === 1 ? ")" : `, ${a})`}`;
}

function clampa(opacity) {
  return isNaN(opacity) ? 1 : Math.max(0, Math.min(1, opacity));
}

function clampi(value) {
  return Math.max(0, Math.min(255, Math.round(value) || 0));
}

function hex(value) {
  value = clampi(value);
  return (value < 16 ? "0" : "") + value.toString(16);
}

function hsla(h, s, l, a) {
  if (a <= 0) h = s = l = NaN;
  else if (l <= 0 || l >= 1) h = s = NaN;
  else if (s <= 0) h = NaN;
  return new Hsl(h, s, l, a);
}

function hslConvert(o) {
  if (o instanceof Hsl) return new Hsl(o.h, o.s, o.l, o.opacity);
  if (!(o instanceof Color)) o = color(o);
  if (!o) return new Hsl;
  if (o instanceof Hsl) return o;
  o = o.rgb();
  var r = o.r / 255,
      g = o.g / 255,
      b = o.b / 255,
      min = Math.min(r, g, b),
      max = Math.max(r, g, b),
      h = NaN,
      s = max - min,
      l = (max + min) / 2;
  if (s) {
    if (r === max) h = (g - b) / s + (g < b) * 6;
    else if (g === max) h = (b - r) / s + 2;
    else h = (r - g) / s + 4;
    s /= l < 0.5 ? max + min : 2 - max - min;
    h *= 60;
  } else {
    s = l > 0 && l < 1 ? 0 : h;
  }
  return new Hsl(h, s, l, o.opacity);
}

function hsl(h, s, l, opacity) {
  return arguments.length === 1 ? hslConvert(h) : new Hsl(h, s, l, opacity == null ? 1 : opacity);
}

function Hsl(h, s, l, opacity) {
  this.h = +h;
  this.s = +s;
  this.l = +l;
  this.opacity = +opacity;
}

define(Hsl, hsl, extend(Color, {
  brighter(k) {
    k = k == null ? brighter : Math.pow(brighter, k);
    return new Hsl(this.h, this.s, this.l * k, this.opacity);
  },
  darker(k) {
    k = k == null ? darker : Math.pow(darker, k);
    return new Hsl(this.h, this.s, this.l * k, this.opacity);
  },
  rgb() {
    var h = this.h % 360 + (this.h < 0) * 360,
        s = isNaN(h) || isNaN(this.s) ? 0 : this.s,
        l = this.l,
        m2 = l + (l < 0.5 ? l : 1 - l) * s,
        m1 = 2 * l - m2;
    return new Rgb(
      hsl2rgb(h >= 240 ? h - 240 : h + 120, m1, m2),
      hsl2rgb(h, m1, m2),
      hsl2rgb(h < 120 ? h + 240 : h - 120, m1, m2),
      this.opacity
    );
  },
  clamp() {
    return new Hsl(clamph(this.h), clampt(this.s), clampt(this.l), clampa(this.opacity));
  },
  displayable() {
    return (0 <= this.s && this.s <= 1 || isNaN(this.s))
        && (0 <= this.l && this.l <= 1)
        && (0 <= this.opacity && this.opacity <= 1);
  },
  formatHsl() {
    const a = clampa(this.opacity);
    return `${a === 1 ? "hsl(" : "hsla("}${clamph(this.h)}, ${clampt(this.s) * 100}%, ${clampt(this.l) * 100}%${a === 1 ? ")" : `, ${a})`}`;
  }
}));

function clamph(value) {
  value = (value || 0) % 360;
  return value < 0 ? value + 360 : value;
}

function clampt(value) {
  return Math.max(0, Math.min(1, value || 0));
}

/* From FvD 13.37, CSS Color Module Level 3 */
function hsl2rgb(h, m1, m2) {
  return (h < 60 ? m1 + (m2 - m1) * h / 60
      : h < 180 ? m2
      : h < 240 ? m1 + (m2 - m1) * (240 - h) / 60
      : m1) * 255;
}

const constant$1 = x => () => x;

function linear(a, d) {
  return function(t) {
    return a + t * d;
  };
}

function exponential(a, b, y) {
  return a = Math.pow(a, y), b = Math.pow(b, y) - a, y = 1 / y, function(t) {
    return Math.pow(a + t * b, y);
  };
}

function gamma(y) {
  return (y = +y) === 1 ? nogamma : function(a, b) {
    return b - a ? exponential(a, b, y) : constant$1(isNaN(a) ? b : a);
  };
}

function nogamma(a, b) {
  var d = b - a;
  return d ? linear(a, d) : constant$1(isNaN(a) ? b : a);
}

const interpolateRgb = (function rgbGamma(y) {
  var color = gamma(y);

  function rgb$1(start, end) {
    var r = color((start = rgb(start)).r, (end = rgb(end)).r),
        g = color(start.g, end.g),
        b = color(start.b, end.b),
        opacity = nogamma(start.opacity, end.opacity);
    return function(t) {
      start.r = r(t);
      start.g = g(t);
      start.b = b(t);
      start.opacity = opacity(t);
      return start + "";
    };
  }

  rgb$1.gamma = rgbGamma;

  return rgb$1;
})(1);

function interpolateNumber(a, b) {
  return a = +a, b = +b, function(t) {
    return a * (1 - t) + b * t;
  };
}

var reA = /[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,
    reB = new RegExp(reA.source, "g");

function zero(b) {
  return function() {
    return b;
  };
}

function one(b) {
  return function(t) {
    return b(t) + "";
  };
}

function interpolateString(a, b) {
  var bi = reA.lastIndex = reB.lastIndex = 0, // scan index for next number in b
      am, // current match in a
      bm, // current match in b
      bs, // string preceding current number in b, if any
      i = -1, // index in s
      s = [], // string constants and placeholders
      q = []; // number interpolators

  // Coerce inputs to strings.
  a = a + "", b = b + "";

  // Interpolate pairs of numbers in a & b.
  while ((am = reA.exec(a))
      && (bm = reB.exec(b))) {
    if ((bs = bm.index) > bi) { // a string precedes the next number in b
      bs = b.slice(bi, bs);
      if (s[i]) s[i] += bs; // coalesce with previous string
      else s[++i] = bs;
    }
    if ((am = am[0]) === (bm = bm[0])) { // numbers in a & b match
      if (s[i]) s[i] += bm; // coalesce with previous string
      else s[++i] = bm;
    } else { // interpolate non-matching numbers
      s[++i] = null;
      q.push({i: i, x: interpolateNumber(am, bm)});
    }
    bi = reB.lastIndex;
  }

  // Add remains of b.
  if (bi < b.length) {
    bs = b.slice(bi);
    if (s[i]) s[i] += bs; // coalesce with previous string
    else s[++i] = bs;
  }

  // Special optimization for only a single match.
  // Otherwise, interpolate each of the numbers and rejoin the string.
  return s.length < 2 ? (q[0]
      ? one(q[0].x)
      : zero(b))
      : (b = q.length, function(t) {
          for (var i = 0, o; i < b; ++i) s[(o = q[i]).i] = o.x(t);
          return s.join("");
        });
}

var degrees = 180 / Math.PI;

var identity$1 = {
  translateX: 0,
  translateY: 0,
  rotate: 0,
  skewX: 0,
  scaleX: 1,
  scaleY: 1
};

function decompose(a, b, c, d, e, f) {
  var scaleX, scaleY, skewX;
  if (scaleX = Math.sqrt(a * a + b * b)) a /= scaleX, b /= scaleX;
  if (skewX = a * c + b * d) c -= a * skewX, d -= b * skewX;
  if (scaleY = Math.sqrt(c * c + d * d)) c /= scaleY, d /= scaleY, skewX /= scaleY;
  if (a * d < b * c) a = -a, b = -b, skewX = -skewX, scaleX = -scaleX;
  return {
    translateX: e,
    translateY: f,
    rotate: Math.atan2(b, a) * degrees,
    skewX: Math.atan(skewX) * degrees,
    scaleX: scaleX,
    scaleY: scaleY
  };
}

var svgNode;

/* eslint-disable no-undef */
function parseCss(value) {
  const m = new (typeof DOMMatrix === "function" ? DOMMatrix : WebKitCSSMatrix)(value + "");
  return m.isIdentity ? identity$1 : decompose(m.a, m.b, m.c, m.d, m.e, m.f);
}

function parseSvg(value) {
  if (value == null) return identity$1;
  if (!svgNode) svgNode = document.createElementNS("http://www.w3.org/2000/svg", "g");
  svgNode.setAttribute("transform", value);
  if (!(value = svgNode.transform.baseVal.consolidate())) return identity$1;
  value = value.matrix;
  return decompose(value.a, value.b, value.c, value.d, value.e, value.f);
}

function interpolateTransform(parse, pxComma, pxParen, degParen) {

  function pop(s) {
    return s.length ? s.pop() + " " : "";
  }

  function translate(xa, ya, xb, yb, s, q) {
    if (xa !== xb || ya !== yb) {
      var i = s.push("translate(", null, pxComma, null, pxParen);
      q.push({i: i - 4, x: interpolateNumber(xa, xb)}, {i: i - 2, x: interpolateNumber(ya, yb)});
    } else if (xb || yb) {
      s.push("translate(" + xb + pxComma + yb + pxParen);
    }
  }

  function rotate(a, b, s, q) {
    if (a !== b) {
      if (a - b > 180) b += 360; else if (b - a > 180) a += 360; // shortest path
      q.push({i: s.push(pop(s) + "rotate(", null, degParen) - 2, x: interpolateNumber(a, b)});
    } else if (b) {
      s.push(pop(s) + "rotate(" + b + degParen);
    }
  }

  function skewX(a, b, s, q) {
    if (a !== b) {
      q.push({i: s.push(pop(s) + "skewX(", null, degParen) - 2, x: interpolateNumber(a, b)});
    } else if (b) {
      s.push(pop(s) + "skewX(" + b + degParen);
    }
  }

  function scale(xa, ya, xb, yb, s, q) {
    if (xa !== xb || ya !== yb) {
      var i = s.push(pop(s) + "scale(", null, ",", null, ")");
      q.push({i: i - 4, x: interpolateNumber(xa, xb)}, {i: i - 2, x: interpolateNumber(ya, yb)});
    } else if (xb !== 1 || yb !== 1) {
      s.push(pop(s) + "scale(" + xb + "," + yb + ")");
    }
  }

  return function(a, b) {
    var s = [], // string constants and placeholders
        q = []; // number interpolators
    a = parse(a), b = parse(b);
    translate(a.translateX, a.translateY, b.translateX, b.translateY, s, q);
    rotate(a.rotate, b.rotate, s, q);
    skewX(a.skewX, b.skewX, s, q);
    scale(a.scaleX, a.scaleY, b.scaleX, b.scaleY, s, q);
    a = b = null; // gc
    return function(t) {
      var i = -1, n = q.length, o;
      while (++i < n) s[(o = q[i]).i] = o.x(t);
      return s.join("");
    };
  };
}

var interpolateTransformCss = interpolateTransform(parseCss, "px, ", "px)", "deg)");
var interpolateTransformSvg = interpolateTransform(parseSvg, ", ", ")", ")");

var epsilon2 = 1e-12;

function cosh(x) {
  return ((x = Math.exp(x)) + 1 / x) / 2;
}

function sinh(x) {
  return ((x = Math.exp(x)) - 1 / x) / 2;
}

function tanh(x) {
  return ((x = Math.exp(2 * x)) - 1) / (x + 1);
}

const interpolateZoom = (function zoomRho(rho, rho2, rho4) {

  // p0 = [ux0, uy0, w0]
  // p1 = [ux1, uy1, w1]
  function zoom(p0, p1) {
    var ux0 = p0[0], uy0 = p0[1], w0 = p0[2],
        ux1 = p1[0], uy1 = p1[1], w1 = p1[2],
        dx = ux1 - ux0,
        dy = uy1 - uy0,
        d2 = dx * dx + dy * dy,
        i,
        S;

    // Special case for u0 ≅ u1.
    if (d2 < epsilon2) {
      S = Math.log(w1 / w0) / rho;
      i = function(t) {
        return [
          ux0 + t * dx,
          uy0 + t * dy,
          w0 * Math.exp(rho * t * S)
        ];
      };
    }

    // General case.
    else {
      var d1 = Math.sqrt(d2),
          b0 = (w1 * w1 - w0 * w0 + rho4 * d2) / (2 * w0 * rho2 * d1),
          b1 = (w1 * w1 - w0 * w0 - rho4 * d2) / (2 * w1 * rho2 * d1),
          r0 = Math.log(Math.sqrt(b0 * b0 + 1) - b0),
          r1 = Math.log(Math.sqrt(b1 * b1 + 1) - b1);
      S = (r1 - r0) / rho;
      i = function(t) {
        var s = t * S,
            coshr0 = cosh(r0),
            u = w0 / (rho2 * d1) * (coshr0 * tanh(rho * s + r0) - sinh(r0));
        return [
          ux0 + u * dx,
          uy0 + u * dy,
          w0 * coshr0 / cosh(rho * s + r0)
        ];
      };
    }

    i.duration = S * 1000 * rho / Math.SQRT2;

    return i;
  }

  zoom.rho = function(_) {
    var _1 = Math.max(1e-3, +_), _2 = _1 * _1, _4 = _2 * _2;
    return zoomRho(_1, _2, _4);
  };

  return zoom;
})(Math.SQRT2, 2, 4);

var frame = 0, // is an animation frame pending?
    timeout$1 = 0, // is a timeout pending?
    interval = 0, // are any timers active?
    pokeDelay = 1000, // how frequently we check for clock skew
    taskHead,
    taskTail,
    clockLast = 0,
    clockNow = 0,
    clockSkew = 0,
    clock = typeof performance === "object" && performance.now ? performance : Date,
    setFrame = typeof window === "object" && window.requestAnimationFrame ? window.requestAnimationFrame.bind(window) : function(f) { setTimeout(f, 17); };

function now() {
  return clockNow || (setFrame(clearNow), clockNow = clock.now() + clockSkew);
}

function clearNow() {
  clockNow = 0;
}

function Timer() {
  this._call =
  this._time =
  this._next = null;
}

Timer.prototype = timer.prototype = {
  constructor: Timer,
  restart: function(callback, delay, time) {
    if (typeof callback !== "function") throw new TypeError("callback is not a function");
    time = (time == null ? now() : +time) + (delay == null ? 0 : +delay);
    if (!this._next && taskTail !== this) {
      if (taskTail) taskTail._next = this;
      else taskHead = this;
      taskTail = this;
    }
    this._call = callback;
    this._time = time;
    sleep();
  },
  stop: function() {
    if (this._call) {
      this._call = null;
      this._time = Infinity;
      sleep();
    }
  }
};

function timer(callback, delay, time) {
  var t = new Timer;
  t.restart(callback, delay, time);
  return t;
}

function timerFlush() {
  now(); // Get the current time, if not already set.
  ++frame; // Pretend we’ve set an alarm, if we haven’t already.
  var t = taskHead, e;
  while (t) {
    if ((e = clockNow - t._time) >= 0) t._call.call(undefined, e);
    t = t._next;
  }
  --frame;
}

function wake() {
  clockNow = (clockLast = clock.now()) + clockSkew;
  frame = timeout$1 = 0;
  try {
    timerFlush();
  } finally {
    frame = 0;
    nap();
    clockNow = 0;
  }
}

function poke() {
  var now = clock.now(), delay = now - clockLast;
  if (delay > pokeDelay) clockSkew -= delay, clockLast = now;
}

function nap() {
  var t0, t1 = taskHead, t2, time = Infinity;
  while (t1) {
    if (t1._call) {
      if (time > t1._time) time = t1._time;
      t0 = t1, t1 = t1._next;
    } else {
      t2 = t1._next, t1._next = null;
      t1 = t0 ? t0._next = t2 : taskHead = t2;
    }
  }
  taskTail = t0;
  sleep(time);
}

function sleep(time) {
  if (frame) return; // Soonest alarm already set, or will be.
  if (timeout$1) timeout$1 = clearTimeout(timeout$1);
  var delay = time - clockNow; // Strictly less than if we recomputed clockNow.
  if (delay > 24) {
    if (time < Infinity) timeout$1 = setTimeout(wake, time - clock.now() - clockSkew);
    if (interval) interval = clearInterval(interval);
  } else {
    if (!interval) clockLast = clock.now(), interval = setInterval(poke, pokeDelay);
    frame = 1, setFrame(wake);
  }
}

function timeout(callback, delay, time) {
  var t = new Timer;
  delay = delay == null ? 0 : +delay;
  t.restart(elapsed => {
    t.stop();
    callback(elapsed + delay);
  }, delay, time);
  return t;
}

var emptyOn = dispatch("start", "end", "cancel", "interrupt");
var emptyTween = [];

var CREATED = 0;
var SCHEDULED = 1;
var STARTING = 2;
var STARTED = 3;
var RUNNING = 4;
var ENDING = 5;
var ENDED = 6;

function schedule(node, name, id, index, group, timing) {
  var schedules = node.__transition;
  if (!schedules) node.__transition = {};
  else if (id in schedules) return;
  create(node, id, {
    name: name,
    index: index, // For context during callback.
    group: group, // For context during callback.
    on: emptyOn,
    tween: emptyTween,
    time: timing.time,
    delay: timing.delay,
    duration: timing.duration,
    ease: timing.ease,
    timer: null,
    state: CREATED
  });
}

function init(node, id) {
  var schedule = get(node, id);
  if (schedule.state > CREATED) throw new Error("too late; already scheduled");
  return schedule;
}

function set(node, id) {
  var schedule = get(node, id);
  if (schedule.state > STARTED) throw new Error("too late; already running");
  return schedule;
}

function get(node, id) {
  var schedule = node.__transition;
  if (!schedule || !(schedule = schedule[id])) throw new Error("transition not found");
  return schedule;
}

function create(node, id, self) {
  var schedules = node.__transition,
      tween;

  // Initialize the self timer when the transition is created.
  // Note the actual delay is not known until the first callback!
  schedules[id] = self;
  self.timer = timer(schedule, 0, self.time);

  function schedule(elapsed) {
    self.state = SCHEDULED;
    self.timer.restart(start, self.delay, self.time);

    // If the elapsed delay is less than our first sleep, start immediately.
    if (self.delay <= elapsed) start(elapsed - self.delay);
  }

  function start(elapsed) {
    var i, j, n, o;

    // If the state is not SCHEDULED, then we previously errored on start.
    if (self.state !== SCHEDULED) return stop();

    for (i in schedules) {
      o = schedules[i];
      if (o.name !== self.name) continue;

      // While this element already has a starting transition during this frame,
      // defer starting an interrupting transition until that transition has a
      // chance to tick (and possibly end); see d3/d3-transition#54!
      if (o.state === STARTED) return timeout(start);

      // Interrupt the active transition, if any.
      if (o.state === RUNNING) {
        o.state = ENDED;
        o.timer.stop();
        o.on.call("interrupt", node, node.__data__, o.index, o.group);
        delete schedules[i];
      }

      // Cancel any pre-empted transitions.
      else if (+i < id) {
        o.state = ENDED;
        o.timer.stop();
        o.on.call("cancel", node, node.__data__, o.index, o.group);
        delete schedules[i];
      }
    }

    // Defer the first tick to end of the current frame; see d3/d3#1576.
    // Note the transition may be canceled after start and before the first tick!
    // Note this must be scheduled before the start event; see d3/d3-transition#16!
    // Assuming this is successful, subsequent callbacks go straight to tick.
    timeout(function() {
      if (self.state === STARTED) {
        self.state = RUNNING;
        self.timer.restart(tick, self.delay, self.time);
        tick(elapsed);
      }
    });

    // Dispatch the start event.
    // Note this must be done before the tween are initialized.
    self.state = STARTING;
    self.on.call("start", node, node.__data__, self.index, self.group);
    if (self.state !== STARTING) return; // interrupted
    self.state = STARTED;

    // Initialize the tween, deleting null tween.
    tween = new Array(n = self.tween.length);
    for (i = 0, j = -1; i < n; ++i) {
      if (o = self.tween[i].value.call(node, node.__data__, self.index, self.group)) {
        tween[++j] = o;
      }
    }
    tween.length = j + 1;
  }

  function tick(elapsed) {
    var t = elapsed < self.duration ? self.ease.call(null, elapsed / self.duration) : (self.timer.restart(stop), self.state = ENDING, 1),
        i = -1,
        n = tween.length;

    while (++i < n) {
      tween[i].call(node, t);
    }

    // Dispatch the end event.
    if (self.state === ENDING) {
      self.on.call("end", node, node.__data__, self.index, self.group);
      stop();
    }
  }

  function stop() {
    self.state = ENDED;
    self.timer.stop();
    delete schedules[id];
    for (var i in schedules) return; // eslint-disable-line no-unused-vars
    delete node.__transition;
  }
}

function interrupt(node, name) {
  var schedules = node.__transition,
      schedule,
      active,
      empty = true,
      i;

  if (!schedules) return;

  name = name == null ? null : name + "";

  for (i in schedules) {
    if ((schedule = schedules[i]).name !== name) { empty = false; continue; }
    active = schedule.state > STARTING && schedule.state < ENDING;
    schedule.state = ENDED;
    schedule.timer.stop();
    schedule.on.call(active ? "interrupt" : "cancel", node, node.__data__, schedule.index, schedule.group);
    delete schedules[i];
  }

  if (empty) delete node.__transition;
}

function selection_interrupt(name) {
  return this.each(function() {
    interrupt(this, name);
  });
}

function tweenRemove(id, name) {
  var tween0, tween1;
  return function() {
    var schedule = set(this, id),
        tween = schedule.tween;

    // If this node shared tween with the previous node,
    // just assign the updated shared tween and we’re done!
    // Otherwise, copy-on-write.
    if (tween !== tween0) {
      tween1 = tween0 = tween;
      for (var i = 0, n = tween1.length; i < n; ++i) {
        if (tween1[i].name === name) {
          tween1 = tween1.slice();
          tween1.splice(i, 1);
          break;
        }
      }
    }

    schedule.tween = tween1;
  };
}

function tweenFunction(id, name, value) {
  var tween0, tween1;
  if (typeof value !== "function") throw new Error;
  return function() {
    var schedule = set(this, id),
        tween = schedule.tween;

    // If this node shared tween with the previous node,
    // just assign the updated shared tween and we’re done!
    // Otherwise, copy-on-write.
    if (tween !== tween0) {
      tween1 = (tween0 = tween).slice();
      for (var t = {name: name, value: value}, i = 0, n = tween1.length; i < n; ++i) {
        if (tween1[i].name === name) {
          tween1[i] = t;
          break;
        }
      }
      if (i === n) tween1.push(t);
    }

    schedule.tween = tween1;
  };
}

function transition_tween(name, value) {
  var id = this._id;

  name += "";

  if (arguments.length < 2) {
    var tween = get(this.node(), id).tween;
    for (var i = 0, n = tween.length, t; i < n; ++i) {
      if ((t = tween[i]).name === name) {
        return t.value;
      }
    }
    return null;
  }

  return this.each((value == null ? tweenRemove : tweenFunction)(id, name, value));
}

function tweenValue(transition, name, value) {
  var id = transition._id;

  transition.each(function() {
    var schedule = set(this, id);
    (schedule.value || (schedule.value = {}))[name] = value.apply(this, arguments);
  });

  return function(node) {
    return get(node, id).value[name];
  };
}

function interpolate(a, b) {
  var c;
  return (typeof b === "number" ? interpolateNumber
      : b instanceof color ? interpolateRgb
      : (c = color(b)) ? (b = c, interpolateRgb)
      : interpolateString)(a, b);
}

function attrRemove(name) {
  return function() {
    this.removeAttribute(name);
  };
}

function attrRemoveNS(fullname) {
  return function() {
    this.removeAttributeNS(fullname.space, fullname.local);
  };
}

function attrConstant(name, interpolate, value1) {
  var string00,
      string1 = value1 + "",
      interpolate0;
  return function() {
    var string0 = this.getAttribute(name);
    return string0 === string1 ? null
        : string0 === string00 ? interpolate0
        : interpolate0 = interpolate(string00 = string0, value1);
  };
}

function attrConstantNS(fullname, interpolate, value1) {
  var string00,
      string1 = value1 + "",
      interpolate0;
  return function() {
    var string0 = this.getAttributeNS(fullname.space, fullname.local);
    return string0 === string1 ? null
        : string0 === string00 ? interpolate0
        : interpolate0 = interpolate(string00 = string0, value1);
  };
}

function attrFunction(name, interpolate, value) {
  var string00,
      string10,
      interpolate0;
  return function() {
    var string0, value1 = value(this), string1;
    if (value1 == null) return void this.removeAttribute(name);
    string0 = this.getAttribute(name);
    string1 = value1 + "";
    return string0 === string1 ? null
        : string0 === string00 && string1 === string10 ? interpolate0
        : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
  };
}

function attrFunctionNS(fullname, interpolate, value) {
  var string00,
      string10,
      interpolate0;
  return function() {
    var string0, value1 = value(this), string1;
    if (value1 == null) return void this.removeAttributeNS(fullname.space, fullname.local);
    string0 = this.getAttributeNS(fullname.space, fullname.local);
    string1 = value1 + "";
    return string0 === string1 ? null
        : string0 === string00 && string1 === string10 ? interpolate0
        : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
  };
}

function transition_attr(name, value) {
  var fullname = namespace(name), i = fullname === "transform" ? interpolateTransformSvg : interpolate;
  return this.attrTween(name, typeof value === "function"
      ? (fullname.local ? attrFunctionNS : attrFunction)(fullname, i, tweenValue(this, "attr." + name, value))
      : value == null ? (fullname.local ? attrRemoveNS : attrRemove)(fullname)
      : (fullname.local ? attrConstantNS : attrConstant)(fullname, i, value));
}

function attrInterpolate(name, i) {
  return function(t) {
    this.setAttribute(name, i.call(this, t));
  };
}

function attrInterpolateNS(fullname, i) {
  return function(t) {
    this.setAttributeNS(fullname.space, fullname.local, i.call(this, t));
  };
}

function attrTweenNS(fullname, value) {
  var t0, i0;
  function tween() {
    var i = value.apply(this, arguments);
    if (i !== i0) t0 = (i0 = i) && attrInterpolateNS(fullname, i);
    return t0;
  }
  tween._value = value;
  return tween;
}

function attrTween(name, value) {
  var t0, i0;
  function tween() {
    var i = value.apply(this, arguments);
    if (i !== i0) t0 = (i0 = i) && attrInterpolate(name, i);
    return t0;
  }
  tween._value = value;
  return tween;
}

function transition_attrTween(name, value) {
  var key = "attr." + name;
  if (arguments.length < 2) return (key = this.tween(key)) && key._value;
  if (value == null) return this.tween(key, null);
  if (typeof value !== "function") throw new Error;
  var fullname = namespace(name);
  return this.tween(key, (fullname.local ? attrTweenNS : attrTween)(fullname, value));
}

function delayFunction(id, value) {
  return function() {
    init(this, id).delay = +value.apply(this, arguments);
  };
}

function delayConstant(id, value) {
  return value = +value, function() {
    init(this, id).delay = value;
  };
}

function transition_delay(value) {
  var id = this._id;

  return arguments.length
      ? this.each((typeof value === "function"
          ? delayFunction
          : delayConstant)(id, value))
      : get(this.node(), id).delay;
}

function durationFunction(id, value) {
  return function() {
    set(this, id).duration = +value.apply(this, arguments);
  };
}

function durationConstant(id, value) {
  return value = +value, function() {
    set(this, id).duration = value;
  };
}

function transition_duration(value) {
  var id = this._id;

  return arguments.length
      ? this.each((typeof value === "function"
          ? durationFunction
          : durationConstant)(id, value))
      : get(this.node(), id).duration;
}

function easeConstant(id, value) {
  if (typeof value !== "function") throw new Error;
  return function() {
    set(this, id).ease = value;
  };
}

function transition_ease(value) {
  var id = this._id;

  return arguments.length
      ? this.each(easeConstant(id, value))
      : get(this.node(), id).ease;
}

function easeVarying(id, value) {
  return function() {
    var v = value.apply(this, arguments);
    if (typeof v !== "function") throw new Error;
    set(this, id).ease = v;
  };
}

function transition_easeVarying(value) {
  if (typeof value !== "function") throw new Error;
  return this.each(easeVarying(this._id, value));
}

function transition_filter(match) {
  if (typeof match !== "function") match = matcher(match);

  for (var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, subgroup = subgroups[j] = [], node, i = 0; i < n; ++i) {
      if ((node = group[i]) && match.call(node, node.__data__, i, group)) {
        subgroup.push(node);
      }
    }
  }

  return new Transition(subgroups, this._parents, this._name, this._id);
}

function transition_merge(transition) {
  if (transition._id !== this._id) throw new Error;

  for (var groups0 = this._groups, groups1 = transition._groups, m0 = groups0.length, m1 = groups1.length, m = Math.min(m0, m1), merges = new Array(m0), j = 0; j < m; ++j) {
    for (var group0 = groups0[j], group1 = groups1[j], n = group0.length, merge = merges[j] = new Array(n), node, i = 0; i < n; ++i) {
      if (node = group0[i] || group1[i]) {
        merge[i] = node;
      }
    }
  }

  for (; j < m0; ++j) {
    merges[j] = groups0[j];
  }

  return new Transition(merges, this._parents, this._name, this._id);
}

function start(name) {
  return (name + "").trim().split(/^|\s+/).every(function(t) {
    var i = t.indexOf(".");
    if (i >= 0) t = t.slice(0, i);
    return !t || t === "start";
  });
}

function onFunction(id, name, listener) {
  var on0, on1, sit = start(name) ? init : set;
  return function() {
    var schedule = sit(this, id),
        on = schedule.on;

    // If this node shared a dispatch with the previous node,
    // just assign the updated shared dispatch and we’re done!
    // Otherwise, copy-on-write.
    if (on !== on0) (on1 = (on0 = on).copy()).on(name, listener);

    schedule.on = on1;
  };
}

function transition_on(name, listener) {
  var id = this._id;

  return arguments.length < 2
      ? get(this.node(), id).on.on(name)
      : this.each(onFunction(id, name, listener));
}

function removeFunction(id) {
  return function() {
    var parent = this.parentNode;
    for (var i in this.__transition) if (+i !== id) return;
    if (parent) parent.removeChild(this);
  };
}

function transition_remove() {
  return this.on("end.remove", removeFunction(this._id));
}

function transition_select(select) {
  var name = this._name,
      id = this._id;

  if (typeof select !== "function") select = selector$1(select);

  for (var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, subgroup = subgroups[j] = new Array(n), node, subnode, i = 0; i < n; ++i) {
      if ((node = group[i]) && (subnode = select.call(node, node.__data__, i, group))) {
        if ("__data__" in node) subnode.__data__ = node.__data__;
        subgroup[i] = subnode;
        schedule(subgroup[i], name, id, i, subgroup, get(node, id));
      }
    }
  }

  return new Transition(subgroups, this._parents, name, id);
}

function transition_selectAll(select) {
  var name = this._name,
      id = this._id;

  if (typeof select !== "function") select = selectorAll(select);

  for (var groups = this._groups, m = groups.length, subgroups = [], parents = [], j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, node, i = 0; i < n; ++i) {
      if (node = group[i]) {
        for (var children = select.call(node, node.__data__, i, group), child, inherit = get(node, id), k = 0, l = children.length; k < l; ++k) {
          if (child = children[k]) {
            schedule(child, name, id, k, children, inherit);
          }
        }
        subgroups.push(children);
        parents.push(node);
      }
    }
  }

  return new Transition(subgroups, parents, name, id);
}

var Selection = selection.prototype.constructor;

function transition_selection() {
  return new Selection(this._groups, this._parents);
}

function styleNull(name, interpolate) {
  var string00,
      string10,
      interpolate0;
  return function() {
    var string0 = styleValue(this, name),
        string1 = (this.style.removeProperty(name), styleValue(this, name));
    return string0 === string1 ? null
        : string0 === string00 && string1 === string10 ? interpolate0
        : interpolate0 = interpolate(string00 = string0, string10 = string1);
  };
}

function styleRemove(name) {
  return function() {
    this.style.removeProperty(name);
  };
}

function styleConstant(name, interpolate, value1) {
  var string00,
      string1 = value1 + "",
      interpolate0;
  return function() {
    var string0 = styleValue(this, name);
    return string0 === string1 ? null
        : string0 === string00 ? interpolate0
        : interpolate0 = interpolate(string00 = string0, value1);
  };
}

function styleFunction(name, interpolate, value) {
  var string00,
      string10,
      interpolate0;
  return function() {
    var string0 = styleValue(this, name),
        value1 = value(this),
        string1 = value1 + "";
    if (value1 == null) string1 = value1 = (this.style.removeProperty(name), styleValue(this, name));
    return string0 === string1 ? null
        : string0 === string00 && string1 === string10 ? interpolate0
        : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
  };
}

function styleMaybeRemove(id, name) {
  var on0, on1, listener0, key = "style." + name, event = "end." + key, remove;
  return function() {
    var schedule = set(this, id),
        on = schedule.on,
        listener = schedule.value[key] == null ? remove || (remove = styleRemove(name)) : undefined;

    // If this node shared a dispatch with the previous node,
    // just assign the updated shared dispatch and we’re done!
    // Otherwise, copy-on-write.
    if (on !== on0 || listener0 !== listener) (on1 = (on0 = on).copy()).on(event, listener0 = listener);

    schedule.on = on1;
  };
}

function transition_style(name, value, priority) {
  var i = (name += "") === "transform" ? interpolateTransformCss : interpolate;
  return value == null ? this
      .styleTween(name, styleNull(name, i))
      .on("end.style." + name, styleRemove(name))
    : typeof value === "function" ? this
      .styleTween(name, styleFunction(name, i, tweenValue(this, "style." + name, value)))
      .each(styleMaybeRemove(this._id, name))
    : this
      .styleTween(name, styleConstant(name, i, value), priority)
      .on("end.style." + name, null);
}

function styleInterpolate(name, i, priority) {
  return function(t) {
    this.style.setProperty(name, i.call(this, t), priority);
  };
}

function styleTween(name, value, priority) {
  var t, i0;
  function tween() {
    var i = value.apply(this, arguments);
    if (i !== i0) t = (i0 = i) && styleInterpolate(name, i, priority);
    return t;
  }
  tween._value = value;
  return tween;
}

function transition_styleTween(name, value, priority) {
  var key = "style." + (name += "");
  if (arguments.length < 2) return (key = this.tween(key)) && key._value;
  if (value == null) return this.tween(key, null);
  if (typeof value !== "function") throw new Error;
  return this.tween(key, styleTween(name, value, priority == null ? "" : priority));
}

function textConstant(value) {
  return function() {
    this.textContent = value;
  };
}

function textFunction(value) {
  return function() {
    var value1 = value(this);
    this.textContent = value1 == null ? "" : value1;
  };
}

function transition_text(value) {
  return this.tween("text", typeof value === "function"
      ? textFunction(tweenValue(this, "text", value))
      : textConstant(value == null ? "" : value + ""));
}

function textInterpolate(i) {
  return function(t) {
    this.textContent = i.call(this, t);
  };
}

function textTween(value) {
  var t0, i0;
  function tween() {
    var i = value.apply(this, arguments);
    if (i !== i0) t0 = (i0 = i) && textInterpolate(i);
    return t0;
  }
  tween._value = value;
  return tween;
}

function transition_textTween(value) {
  var key = "text";
  if (arguments.length < 1) return (key = this.tween(key)) && key._value;
  if (value == null) return this.tween(key, null);
  if (typeof value !== "function") throw new Error;
  return this.tween(key, textTween(value));
}

function transition_transition() {
  var name = this._name,
      id0 = this._id,
      id1 = newId();

  for (var groups = this._groups, m = groups.length, j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, node, i = 0; i < n; ++i) {
      if (node = group[i]) {
        var inherit = get(node, id0);
        schedule(node, name, id1, i, group, {
          time: inherit.time + inherit.delay + inherit.duration,
          delay: 0,
          duration: inherit.duration,
          ease: inherit.ease
        });
      }
    }
  }

  return new Transition(groups, this._parents, name, id1);
}

function transition_end() {
  var on0, on1, that = this, id = that._id, size = that.size();
  return new Promise(function(resolve, reject) {
    var cancel = {value: reject},
        end = {value: function() { if (--size === 0) resolve(); }};

    that.each(function() {
      var schedule = set(this, id),
          on = schedule.on;

      // If this node shared a dispatch with the previous node,
      // just assign the updated shared dispatch and we’re done!
      // Otherwise, copy-on-write.
      if (on !== on0) {
        on1 = (on0 = on).copy();
        on1._.cancel.push(cancel);
        on1._.interrupt.push(cancel);
        on1._.end.push(end);
      }

      schedule.on = on1;
    });

    // The selection was empty, resolve end immediately
    if (size === 0) resolve();
  });
}

var id = 0;

function Transition(groups, parents, name, id) {
  this._groups = groups;
  this._parents = parents;
  this._name = name;
  this._id = id;
}

function newId() {
  return ++id;
}

var selection_prototype = selection.prototype;

Transition.prototype = {
  constructor: Transition,
  select: transition_select,
  selectAll: transition_selectAll,
  selectChild: selection_prototype.selectChild,
  selectChildren: selection_prototype.selectChildren,
  filter: transition_filter,
  merge: transition_merge,
  selection: transition_selection,
  transition: transition_transition,
  call: selection_prototype.call,
  nodes: selection_prototype.nodes,
  node: selection_prototype.node,
  size: selection_prototype.size,
  empty: selection_prototype.empty,
  each: selection_prototype.each,
  on: transition_on,
  attr: transition_attr,
  attrTween: transition_attrTween,
  style: transition_style,
  styleTween: transition_styleTween,
  text: transition_text,
  textTween: transition_textTween,
  remove: transition_remove,
  tween: transition_tween,
  delay: transition_delay,
  duration: transition_duration,
  ease: transition_ease,
  easeVarying: transition_easeVarying,
  end: transition_end,
  [Symbol.iterator]: selection_prototype[Symbol.iterator]
};

function cubicInOut(t) {
  return ((t *= 2) <= 1 ? t * t * t : (t -= 2) * t * t + 2) / 2;
}

var defaultTiming = {
  time: null, // Set on use.
  delay: 0,
  duration: 250,
  ease: cubicInOut
};

function inherit(node, id) {
  var timing;
  while (!(timing = node.__transition) || !(timing = timing[id])) {
    if (!(node = node.parentNode)) {
      throw new Error(`transition ${id} not found`);
    }
  }
  return timing;
}

function selection_transition(name) {
  var id,
      timing;

  if (name instanceof Transition) {
    id = name._id, name = name._name;
  } else {
    id = newId(), (timing = defaultTiming).time = now(), name = name == null ? null : name + "";
  }

  for (var groups = this._groups, m = groups.length, j = 0; j < m; ++j) {
    for (var group = groups[j], n = group.length, node, i = 0; i < n; ++i) {
      if (node = group[i]) {
        schedule(node, name, id, i, group, timing || inherit(node, id));
      }
    }
  }

  return new Transition(groups, this._parents, name, id);
}

selection.prototype.interrupt = selection_interrupt;
selection.prototype.transition = selection_transition;

const constant = x => () => x;

function ZoomEvent(type, {
  sourceEvent,
  target,
  transform,
  dispatch
}) {
  Object.defineProperties(this, {
    type: {value: type, enumerable: true, configurable: true},
    sourceEvent: {value: sourceEvent, enumerable: true, configurable: true},
    target: {value: target, enumerable: true, configurable: true},
    transform: {value: transform, enumerable: true, configurable: true},
    _: {value: dispatch}
  });
}

function Transform(k, x, y) {
  this.k = k;
  this.x = x;
  this.y = y;
}

Transform.prototype = {
  constructor: Transform,
  scale: function(k) {
    return k === 1 ? this : new Transform(this.k * k, this.x, this.y);
  },
  translate: function(x, y) {
    return x === 0 & y === 0 ? this : new Transform(this.k, this.x + this.k * x, this.y + this.k * y);
  },
  apply: function(point) {
    return [point[0] * this.k + this.x, point[1] * this.k + this.y];
  },
  applyX: function(x) {
    return x * this.k + this.x;
  },
  applyY: function(y) {
    return y * this.k + this.y;
  },
  invert: function(location) {
    return [(location[0] - this.x) / this.k, (location[1] - this.y) / this.k];
  },
  invertX: function(x) {
    return (x - this.x) / this.k;
  },
  invertY: function(y) {
    return (y - this.y) / this.k;
  },
  rescaleX: function(x) {
    return x.copy().domain(x.range().map(this.invertX, this).map(x.invert, x));
  },
  rescaleY: function(y) {
    return y.copy().domain(y.range().map(this.invertY, this).map(y.invert, y));
  },
  toString: function() {
    return "translate(" + this.x + "," + this.y + ") scale(" + this.k + ")";
  }
};

var identity = new Transform(1, 0, 0);

Transform.prototype;

function nopropagation(event) {
  event.stopImmediatePropagation();
}

function noevent(event) {
  event.preventDefault();
  event.stopImmediatePropagation();
}

// Ignore right-click, since that should open the context menu.
// except for pinch-to-zoom, which is sent as a wheel+ctrlKey event
function defaultFilter(event) {
  return (!event.ctrlKey || event.type === 'wheel') && !event.button;
}

function defaultExtent() {
  var e = this;
  if (e instanceof SVGElement) {
    e = e.ownerSVGElement || e;
    if (e.hasAttribute("viewBox")) {
      e = e.viewBox.baseVal;
      return [[e.x, e.y], [e.x + e.width, e.y + e.height]];
    }
    return [[0, 0], [e.width.baseVal.value, e.height.baseVal.value]];
  }
  return [[0, 0], [e.clientWidth, e.clientHeight]];
}

function defaultTransform() {
  return this.__zoom || identity;
}

function defaultWheelDelta(event) {
  return -event.deltaY * (event.deltaMode === 1 ? 0.05 : event.deltaMode ? 1 : 0.002) * (event.ctrlKey ? 10 : 1);
}

function defaultTouchable() {
  return navigator.maxTouchPoints || ("ontouchstart" in this);
}

function defaultConstrain(transform, extent, translateExtent) {
  var dx0 = transform.invertX(extent[0][0]) - translateExtent[0][0],
      dx1 = transform.invertX(extent[1][0]) - translateExtent[1][0],
      dy0 = transform.invertY(extent[0][1]) - translateExtent[0][1],
      dy1 = transform.invertY(extent[1][1]) - translateExtent[1][1];
  return transform.translate(
    dx1 > dx0 ? (dx0 + dx1) / 2 : Math.min(0, dx0) || Math.max(0, dx1),
    dy1 > dy0 ? (dy0 + dy1) / 2 : Math.min(0, dy0) || Math.max(0, dy1)
  );
}

function zoom() {
  var filter = defaultFilter,
      extent = defaultExtent,
      constrain = defaultConstrain,
      wheelDelta = defaultWheelDelta,
      touchable = defaultTouchable,
      scaleExtent = [0, Infinity],
      translateExtent = [[-Infinity, -Infinity], [Infinity, Infinity]],
      duration = 250,
      interpolate = interpolateZoom,
      listeners = dispatch("start", "zoom", "end"),
      touchstarting,
      touchfirst,
      touchending,
      touchDelay = 500,
      wheelDelay = 150,
      clickDistance2 = 0,
      tapDistance = 10;

  function zoom(selection) {
    selection
        .property("__zoom", defaultTransform)
        .on("wheel.zoom", wheeled, {passive: false})
        .on("mousedown.zoom", mousedowned)
        .on("dblclick.zoom", dblclicked)
      .filter(touchable)
        .on("touchstart.zoom", touchstarted)
        .on("touchmove.zoom", touchmoved)
        .on("touchend.zoom touchcancel.zoom", touchended)
        .style("-webkit-tap-highlight-color", "rgba(0,0,0,0)");
  }

  zoom.transform = function(collection, transform, point, event) {
    var selection = collection.selection ? collection.selection() : collection;
    selection.property("__zoom", defaultTransform);
    if (collection !== selection) {
      schedule(collection, transform, point, event);
    } else {
      selection.interrupt().each(function() {
        gesture(this, arguments)
          .event(event)
          .start()
          .zoom(null, typeof transform === "function" ? transform.apply(this, arguments) : transform)
          .end();
      });
    }
  };

  zoom.scaleBy = function(selection, k, p, event) {
    zoom.scaleTo(selection, function() {
      var k0 = this.__zoom.k,
          k1 = typeof k === "function" ? k.apply(this, arguments) : k;
      return k0 * k1;
    }, p, event);
  };

  zoom.scaleTo = function(selection, k, p, event) {
    zoom.transform(selection, function() {
      var e = extent.apply(this, arguments),
          t0 = this.__zoom,
          p0 = p == null ? centroid(e) : typeof p === "function" ? p.apply(this, arguments) : p,
          p1 = t0.invert(p0),
          k1 = typeof k === "function" ? k.apply(this, arguments) : k;
      return constrain(translate(scale(t0, k1), p0, p1), e, translateExtent);
    }, p, event);
  };

  zoom.translateBy = function(selection, x, y, event) {
    zoom.transform(selection, function() {
      return constrain(this.__zoom.translate(
        typeof x === "function" ? x.apply(this, arguments) : x,
        typeof y === "function" ? y.apply(this, arguments) : y
      ), extent.apply(this, arguments), translateExtent);
    }, null, event);
  };

  zoom.translateTo = function(selection, x, y, p, event) {
    zoom.transform(selection, function() {
      var e = extent.apply(this, arguments),
          t = this.__zoom,
          p0 = p == null ? centroid(e) : typeof p === "function" ? p.apply(this, arguments) : p;
      return constrain(identity.translate(p0[0], p0[1]).scale(t.k).translate(
        typeof x === "function" ? -x.apply(this, arguments) : -x,
        typeof y === "function" ? -y.apply(this, arguments) : -y
      ), e, translateExtent);
    }, p, event);
  };

  function scale(transform, k) {
    k = Math.max(scaleExtent[0], Math.min(scaleExtent[1], k));
    return k === transform.k ? transform : new Transform(k, transform.x, transform.y);
  }

  function translate(transform, p0, p1) {
    var x = p0[0] - p1[0] * transform.k, y = p0[1] - p1[1] * transform.k;
    return x === transform.x && y === transform.y ? transform : new Transform(transform.k, x, y);
  }

  function centroid(extent) {
    return [(+extent[0][0] + +extent[1][0]) / 2, (+extent[0][1] + +extent[1][1]) / 2];
  }

  function schedule(transition, transform, point, event) {
    transition
        .on("start.zoom", function() { gesture(this, arguments).event(event).start(); })
        .on("interrupt.zoom end.zoom", function() { gesture(this, arguments).event(event).end(); })
        .tween("zoom", function() {
          var that = this,
              args = arguments,
              g = gesture(that, args).event(event),
              e = extent.apply(that, args),
              p = point == null ? centroid(e) : typeof point === "function" ? point.apply(that, args) : point,
              w = Math.max(e[1][0] - e[0][0], e[1][1] - e[0][1]),
              a = that.__zoom,
              b = typeof transform === "function" ? transform.apply(that, args) : transform,
              i = interpolate(a.invert(p).concat(w / a.k), b.invert(p).concat(w / b.k));
          return function(t) {
            if (t === 1) t = b; // Avoid rounding error on end.
            else { var l = i(t), k = w / l[2]; t = new Transform(k, p[0] - l[0] * k, p[1] - l[1] * k); }
            g.zoom(null, t);
          };
        });
  }

  function gesture(that, args, clean) {
    return (!clean && that.__zooming) || new Gesture(that, args);
  }

  function Gesture(that, args) {
    this.that = that;
    this.args = args;
    this.active = 0;
    this.sourceEvent = null;
    this.extent = extent.apply(that, args);
    this.taps = 0;
  }

  Gesture.prototype = {
    event: function(event) {
      if (event) this.sourceEvent = event;
      return this;
    },
    start: function() {
      if (++this.active === 1) {
        this.that.__zooming = this;
        this.emit("start");
      }
      return this;
    },
    zoom: function(key, transform) {
      if (this.mouse && key !== "mouse") this.mouse[1] = transform.invert(this.mouse[0]);
      if (this.touch0 && key !== "touch") this.touch0[1] = transform.invert(this.touch0[0]);
      if (this.touch1 && key !== "touch") this.touch1[1] = transform.invert(this.touch1[0]);
      this.that.__zoom = transform;
      this.emit("zoom");
      return this;
    },
    end: function() {
      if (--this.active === 0) {
        delete this.that.__zooming;
        this.emit("end");
      }
      return this;
    },
    emit: function(type) {
      var d = select(this.that).datum();
      listeners.call(
        type,
        this.that,
        new ZoomEvent(type, {
          sourceEvent: this.sourceEvent,
          target: zoom,
          type,
          transform: this.that.__zoom,
          dispatch: listeners
        }),
        d
      );
    }
  };

  function wheeled(event, ...args) {
    if (!filter.apply(this, arguments)) return;
    var g = gesture(this, args).event(event),
        t = this.__zoom,
        k = Math.max(scaleExtent[0], Math.min(scaleExtent[1], t.k * Math.pow(2, wheelDelta.apply(this, arguments)))),
        p = pointer(event);

    // If the mouse is in the same location as before, reuse it.
    // If there were recent wheel events, reset the wheel idle timeout.
    if (g.wheel) {
      if (g.mouse[0][0] !== p[0] || g.mouse[0][1] !== p[1]) {
        g.mouse[1] = t.invert(g.mouse[0] = p);
      }
      clearTimeout(g.wheel);
    }

    // If this wheel event won’t trigger a transform change, ignore it.
    else if (t.k === k) return;

    // Otherwise, capture the mouse point and location at the start.
    else {
      g.mouse = [p, t.invert(p)];
      interrupt(this);
      g.start();
    }

    noevent(event);
    g.wheel = setTimeout(wheelidled, wheelDelay);
    g.zoom("mouse", constrain(translate(scale(t, k), g.mouse[0], g.mouse[1]), g.extent, translateExtent));

    function wheelidled() {
      g.wheel = null;
      g.end();
    }
  }

  function mousedowned(event, ...args) {
    if (touchending || !filter.apply(this, arguments)) return;
    var currentTarget = event.currentTarget,
        g = gesture(this, args, true).event(event),
        v = select(event.view).on("mousemove.zoom", mousemoved, true).on("mouseup.zoom", mouseupped, true),
        p = pointer(event, currentTarget),
        x0 = event.clientX,
        y0 = event.clientY;

    dragDisable(event.view);
    nopropagation(event);
    g.mouse = [p, this.__zoom.invert(p)];
    interrupt(this);
    g.start();

    function mousemoved(event) {
      noevent(event);
      if (!g.moved) {
        var dx = event.clientX - x0, dy = event.clientY - y0;
        g.moved = dx * dx + dy * dy > clickDistance2;
      }
      g.event(event)
       .zoom("mouse", constrain(translate(g.that.__zoom, g.mouse[0] = pointer(event, currentTarget), g.mouse[1]), g.extent, translateExtent));
    }

    function mouseupped(event) {
      v.on("mousemove.zoom mouseup.zoom", null);
      yesdrag(event.view, g.moved);
      noevent(event);
      g.event(event).end();
    }
  }

  function dblclicked(event, ...args) {
    if (!filter.apply(this, arguments)) return;
    var t0 = this.__zoom,
        p0 = pointer(event.changedTouches ? event.changedTouches[0] : event, this),
        p1 = t0.invert(p0),
        k1 = t0.k * (event.shiftKey ? 0.5 : 2),
        t1 = constrain(translate(scale(t0, k1), p0, p1), extent.apply(this, args), translateExtent);

    noevent(event);
    if (duration > 0) select(this).transition().duration(duration).call(schedule, t1, p0, event);
    else select(this).call(zoom.transform, t1, p0, event);
  }

  function touchstarted(event, ...args) {
    if (!filter.apply(this, arguments)) return;
    var touches = event.touches,
        n = touches.length,
        g = gesture(this, args, event.changedTouches.length === n).event(event),
        started, i, t, p;

    nopropagation(event);
    for (i = 0; i < n; ++i) {
      t = touches[i], p = pointer(t, this);
      p = [p, this.__zoom.invert(p), t.identifier];
      if (!g.touch0) g.touch0 = p, started = true, g.taps = 1 + !!touchstarting;
      else if (!g.touch1 && g.touch0[2] !== p[2]) g.touch1 = p, g.taps = 0;
    }

    if (touchstarting) touchstarting = clearTimeout(touchstarting);

    if (started) {
      if (g.taps < 2) touchfirst = p[0], touchstarting = setTimeout(function() { touchstarting = null; }, touchDelay);
      interrupt(this);
      g.start();
    }
  }

  function touchmoved(event, ...args) {
    if (!this.__zooming) return;
    var g = gesture(this, args).event(event),
        touches = event.changedTouches,
        n = touches.length, i, t, p, l;

    noevent(event);
    for (i = 0; i < n; ++i) {
      t = touches[i], p = pointer(t, this);
      if (g.touch0 && g.touch0[2] === t.identifier) g.touch0[0] = p;
      else if (g.touch1 && g.touch1[2] === t.identifier) g.touch1[0] = p;
    }
    t = g.that.__zoom;
    if (g.touch1) {
      var p0 = g.touch0[0], l0 = g.touch0[1],
          p1 = g.touch1[0], l1 = g.touch1[1],
          dp = (dp = p1[0] - p0[0]) * dp + (dp = p1[1] - p0[1]) * dp,
          dl = (dl = l1[0] - l0[0]) * dl + (dl = l1[1] - l0[1]) * dl;
      t = scale(t, Math.sqrt(dp / dl));
      p = [(p0[0] + p1[0]) / 2, (p0[1] + p1[1]) / 2];
      l = [(l0[0] + l1[0]) / 2, (l0[1] + l1[1]) / 2];
    }
    else if (g.touch0) p = g.touch0[0], l = g.touch0[1];
    else return;

    g.zoom("touch", constrain(translate(t, p, l), g.extent, translateExtent));
  }

  function touchended(event, ...args) {
    if (!this.__zooming) return;
    var g = gesture(this, args).event(event),
        touches = event.changedTouches,
        n = touches.length, i, t;

    nopropagation(event);
    if (touchending) clearTimeout(touchending);
    touchending = setTimeout(function() { touchending = null; }, touchDelay);
    for (i = 0; i < n; ++i) {
      t = touches[i];
      if (g.touch0 && g.touch0[2] === t.identifier) delete g.touch0;
      else if (g.touch1 && g.touch1[2] === t.identifier) delete g.touch1;
    }
    if (g.touch1 && !g.touch0) g.touch0 = g.touch1, delete g.touch1;
    if (g.touch0) g.touch0[1] = this.__zoom.invert(g.touch0[0]);
    else {
      g.end();
      // If this was a dbltap, reroute to the (optional) dblclick.zoom handler.
      if (g.taps === 2) {
        t = pointer(t, this);
        if (Math.hypot(touchfirst[0] - t[0], touchfirst[1] - t[1]) < tapDistance) {
          var p = select(this).on("dblclick.zoom");
          if (p) p.apply(this, arguments);
        }
      }
    }
  }

  zoom.wheelDelta = function(_) {
    return arguments.length ? (wheelDelta = typeof _ === "function" ? _ : constant(+_), zoom) : wheelDelta;
  };

  zoom.filter = function(_) {
    return arguments.length ? (filter = typeof _ === "function" ? _ : constant(!!_), zoom) : filter;
  };

  zoom.touchable = function(_) {
    return arguments.length ? (touchable = typeof _ === "function" ? _ : constant(!!_), zoom) : touchable;
  };

  zoom.extent = function(_) {
    return arguments.length ? (extent = typeof _ === "function" ? _ : constant([[+_[0][0], +_[0][1]], [+_[1][0], +_[1][1]]]), zoom) : extent;
  };

  zoom.scaleExtent = function(_) {
    return arguments.length ? (scaleExtent[0] = +_[0], scaleExtent[1] = +_[1], zoom) : [scaleExtent[0], scaleExtent[1]];
  };

  zoom.translateExtent = function(_) {
    return arguments.length ? (translateExtent[0][0] = +_[0][0], translateExtent[1][0] = +_[1][0], translateExtent[0][1] = +_[0][1], translateExtent[1][1] = +_[1][1], zoom) : [[translateExtent[0][0], translateExtent[0][1]], [translateExtent[1][0], translateExtent[1][1]]];
  };

  zoom.constrain = function(_) {
    return arguments.length ? (constrain = _, zoom) : constrain;
  };

  zoom.duration = function(_) {
    return arguments.length ? (duration = +_, zoom) : duration;
  };

  zoom.interpolate = function(_) {
    return arguments.length ? (interpolate = _, zoom) : interpolate;
  };

  zoom.on = function() {
    var value = listeners.on.apply(listeners, arguments);
    return value === listeners ? zoom : value;
  };

  zoom.clickDistance = function(_) {
    return arguments.length ? (clickDistance2 = (_ = +_) * _, zoom) : Math.sqrt(clickDistance2);
  };

  zoom.tapDistance = function(_) {
    return arguments.length ? (tapDistance = +_, zoom) : tapDistance;
  };

  return zoom;
}

var define_process_env_default = {};
const StoreContext = reactExports.createContext(null);
const Provider$1 = StoreContext.Provider;
const errorMessages = {
  error001: () => "[React Flow]: Seems like you have not used zustand provider as an ancestor. Help: https://reactflow.dev/error#001",
  error002: () => "It looks like you've created a new nodeTypes or edgeTypes object. If this wasn't on purpose please define the nodeTypes/edgeTypes outside of the component or memoize them.",
  error003: (nodeType) => `Node type "${nodeType}" not found. Using fallback type "default".`,
  error004: () => "The React Flow parent container needs a width and a height to render the graph.",
  error005: () => "Only child nodes can use a parent extent.",
  error006: () => "Can't create edge. An edge needs a source and a target.",
  error007: (id) => `The old edge with id=${id} does not exist.`,
  error009: (type) => `Marker type "${type}" doesn't exist.`,
  error008: (sourceHandle, edge) => `Couldn't create edge for ${!sourceHandle ? "source" : "target"} handle id: "${!sourceHandle ? edge.sourceHandle : edge.targetHandle}", edge id: ${edge.id}.`,
  error010: () => "Handle: No node id found. Make sure to only use a Handle inside a custom Node.",
  error011: (edgeType) => `Edge type "${edgeType}" not found. Using fallback type "default".`,
  error012: (id) => `Node with id "${id}" does not exist, it may have been removed. This can happen when a node is deleted before the "onNodeClick" handler is called.`
};
const zustandErrorMessage = errorMessages["error001"]();
function useStore(selector2, equalityFn) {
  const store = reactExports.useContext(StoreContext);
  if (store === null) {
    throw new Error(zustandErrorMessage);
  }
  return useStoreWithEqualityFn(store, selector2, equalityFn);
}
const useStoreApi = () => {
  const store = reactExports.useContext(StoreContext);
  if (store === null) {
    throw new Error(zustandErrorMessage);
  }
  return reactExports.useMemo(() => ({
    getState: store.getState,
    setState: store.setState,
    subscribe: store.subscribe,
    destroy: store.destroy
  }), [store]);
};
const selector$g = (s) => s.userSelectionActive ? "none" : "all";
function Panel({ position, children, className, style: style2, ...rest }) {
  const pointerEvents = useStore(selector$g);
  const positionClasses = `${position}`.split("-");
  return React.createElement("div", { className: cc(["react-flow__panel", className, ...positionClasses]), style: { ...style2, pointerEvents }, ...rest }, children);
}
function Attribution({ proOptions, position = "bottom-right" }) {
  if (proOptions?.hideAttribution) {
    return null;
  }
  return React.createElement(
    Panel,
    { position, className: "react-flow__attribution", "data-message": "Please only hide this attribution when you are subscribed to React Flow Pro: https://pro.reactflow.dev" },
    React.createElement("a", { href: "https://reactflow.dev", target: "_blank", rel: "noopener noreferrer", "aria-label": "React Flow attribution" }, "React Flow")
  );
}
const EdgeText = ({ x, y, label, labelStyle = {}, labelShowBg = true, labelBgStyle = {}, labelBgPadding = [2, 4], labelBgBorderRadius = 2, children, className, ...rest }) => {
  const edgeRef = reactExports.useRef(null);
  const [edgeTextBbox, setEdgeTextBbox] = reactExports.useState({ x: 0, y: 0, width: 0, height: 0 });
  const edgeTextClasses = cc(["react-flow__edge-textwrapper", className]);
  reactExports.useEffect(() => {
    if (edgeRef.current) {
      const textBbox = edgeRef.current.getBBox();
      setEdgeTextBbox({
        x: textBbox.x,
        y: textBbox.y,
        width: textBbox.width,
        height: textBbox.height
      });
    }
  }, [label]);
  if (typeof label === "undefined" || !label) {
    return null;
  }
  return React.createElement(
    "g",
    { transform: `translate(${x - edgeTextBbox.width / 2} ${y - edgeTextBbox.height / 2})`, className: edgeTextClasses, visibility: edgeTextBbox.width ? "visible" : "hidden", ...rest },
    labelShowBg && React.createElement("rect", { width: edgeTextBbox.width + 2 * labelBgPadding[0], x: -labelBgPadding[0], y: -labelBgPadding[1], height: edgeTextBbox.height + 2 * labelBgPadding[1], className: "react-flow__edge-textbg", style: labelBgStyle, rx: labelBgBorderRadius, ry: labelBgBorderRadius }),
    React.createElement("text", { className: "react-flow__edge-text", y: edgeTextBbox.height / 2, dy: "0.3em", ref: edgeRef, style: labelStyle }, label),
    children
  );
};
var EdgeText$1 = reactExports.memo(EdgeText);
const getDimensions = (node) => ({
  width: node.offsetWidth,
  height: node.offsetHeight
});
const clamp = (val, min = 0, max = 1) => Math.min(Math.max(val, min), max);
const clampPosition = (position = { x: 0, y: 0 }, extent) => ({
  x: clamp(position.x, extent[0][0], extent[1][0]),
  y: clamp(position.y, extent[0][1], extent[1][1])
});
const calcAutoPanVelocity = (value, min, max) => {
  if (value < min) {
    return clamp(Math.abs(value - min), 1, 50) / 50;
  } else if (value > max) {
    return -clamp(Math.abs(value - max), 1, 50) / 50;
  }
  return 0;
};
const calcAutoPan = (pos, bounds) => {
  const xMovement = calcAutoPanVelocity(pos.x, 35, bounds.width - 35) * 20;
  const yMovement = calcAutoPanVelocity(pos.y, 35, bounds.height - 35) * 20;
  return [xMovement, yMovement];
};
const getHostForElement = (element) => element.getRootNode?.() || window?.document;
const getBoundsOfBoxes = (box1, box2) => ({
  x: Math.min(box1.x, box2.x),
  y: Math.min(box1.y, box2.y),
  x2: Math.max(box1.x2, box2.x2),
  y2: Math.max(box1.y2, box2.y2)
});
const rectToBox = ({ x, y, width, height }) => ({
  x,
  y,
  x2: x + width,
  y2: y + height
});
const boxToRect = ({ x, y, x2, y2 }) => ({
  x,
  y,
  width: x2 - x,
  height: y2 - y
});
const nodeToRect = (node) => ({
  ...node.positionAbsolute || { x: 0, y: 0 },
  width: node.width || 0,
  height: node.height || 0
});
const getOverlappingArea = (rectA, rectB) => {
  const xOverlap = Math.max(0, Math.min(rectA.x + rectA.width, rectB.x + rectB.width) - Math.max(rectA.x, rectB.x));
  const yOverlap = Math.max(0, Math.min(rectA.y + rectA.height, rectB.y + rectB.height) - Math.max(rectA.y, rectB.y));
  return Math.ceil(xOverlap * yOverlap);
};
const isRectObject = (obj) => isNumeric(obj.width) && isNumeric(obj.height) && isNumeric(obj.x) && isNumeric(obj.y);
const isNumeric = (n) => !isNaN(n) && isFinite(n);
const internalsSymbol = Symbol.for("internals");
const elementSelectionKeys = ["Enter", " ", "Escape"];
const devWarn = (id, message) => {
  if (define_process_env_default.NODE_ENV === "development") {
    console.warn(`[React Flow]: ${message} Help: https://reactflow.dev/error#${id}`);
  }
};
const isReactKeyboardEvent = (event) => "nativeEvent" in event;
function isInputDOMNode(event) {
  const kbEvent = isReactKeyboardEvent(event) ? event.nativeEvent : event;
  const target = kbEvent.composedPath?.()?.[0] || event.target;
  const isInput = ["INPUT", "SELECT", "TEXTAREA"].includes(target?.nodeName) || target?.hasAttribute("contenteditable");
  return isInput || !!target?.closest(".nokey");
}
const isMouseEvent = (event) => "clientX" in event;
const getEventPosition = (event, bounds) => {
  const isMouseTriggered = isMouseEvent(event);
  const evtX = isMouseTriggered ? event.clientX : event.touches?.[0].clientX;
  const evtY = isMouseTriggered ? event.clientY : event.touches?.[0].clientY;
  return {
    x: evtX - (bounds?.left ?? 0),
    y: evtY - (bounds?.top ?? 0)
  };
};
const isMacOs = () => typeof navigator !== "undefined" && navigator?.userAgent?.indexOf("Mac") >= 0;
const BaseEdge = ({ id, path, labelX, labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth = 20 }) => {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement("path", { id, style: style2, d: path, fill: "none", className: "react-flow__edge-path", markerEnd, markerStart }),
    interactionWidth && React.createElement("path", { d: path, fill: "none", strokeOpacity: 0, strokeWidth: interactionWidth, className: "react-flow__edge-interaction" }),
    label && isNumeric(labelX) && isNumeric(labelY) ? React.createElement(EdgeText$1, { x: labelX, y: labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius }) : null
  );
};
BaseEdge.displayName = "BaseEdge";
function getMouseHandler$1(id, getState, handler) {
  return handler === void 0 ? handler : (event) => {
    const edge = getState().edges.find((e) => e.id === id);
    if (edge) {
      handler(event, { ...edge });
    }
  };
}
function getEdgeCenter({ sourceX, sourceY, targetX, targetY }) {
  const xOffset = Math.abs(targetX - sourceX) / 2;
  const centerX = targetX < sourceX ? targetX + xOffset : targetX - xOffset;
  const yOffset = Math.abs(targetY - sourceY) / 2;
  const centerY = targetY < sourceY ? targetY + yOffset : targetY - yOffset;
  return [centerX, centerY, xOffset, yOffset];
}
function getBezierEdgeCenter({ sourceX, sourceY, targetX, targetY, sourceControlX, sourceControlY, targetControlX, targetControlY }) {
  const centerX = sourceX * 0.125 + sourceControlX * 0.375 + targetControlX * 0.375 + targetX * 0.125;
  const centerY = sourceY * 0.125 + sourceControlY * 0.375 + targetControlY * 0.375 + targetY * 0.125;
  const offsetX = Math.abs(centerX - sourceX);
  const offsetY = Math.abs(centerY - sourceY);
  return [centerX, centerY, offsetX, offsetY];
}
var ConnectionMode;
(function(ConnectionMode2) {
  ConnectionMode2["Strict"] = "strict";
  ConnectionMode2["Loose"] = "loose";
})(ConnectionMode || (ConnectionMode = {}));
var PanOnScrollMode;
(function(PanOnScrollMode2) {
  PanOnScrollMode2["Free"] = "free";
  PanOnScrollMode2["Vertical"] = "vertical";
  PanOnScrollMode2["Horizontal"] = "horizontal";
})(PanOnScrollMode || (PanOnScrollMode = {}));
var SelectionMode;
(function(SelectionMode2) {
  SelectionMode2["Partial"] = "partial";
  SelectionMode2["Full"] = "full";
})(SelectionMode || (SelectionMode = {}));
var ConnectionLineType;
(function(ConnectionLineType2) {
  ConnectionLineType2["Bezier"] = "default";
  ConnectionLineType2["Straight"] = "straight";
  ConnectionLineType2["Step"] = "step";
  ConnectionLineType2["SmoothStep"] = "smoothstep";
  ConnectionLineType2["SimpleBezier"] = "simplebezier";
})(ConnectionLineType || (ConnectionLineType = {}));
var MarkerType;
(function(MarkerType2) {
  MarkerType2["Arrow"] = "arrow";
  MarkerType2["ArrowClosed"] = "arrowclosed";
})(MarkerType || (MarkerType = {}));
var Position;
(function(Position2) {
  Position2["Left"] = "left";
  Position2["Top"] = "top";
  Position2["Right"] = "right";
  Position2["Bottom"] = "bottom";
})(Position || (Position = {}));
function getControl({ pos, x1, y1, x2, y2 }) {
  if (pos === Position.Left || pos === Position.Right) {
    return [0.5 * (x1 + x2), y1];
  }
  return [x1, 0.5 * (y1 + y2)];
}
function getSimpleBezierPath({ sourceX, sourceY, sourcePosition = Position.Bottom, targetX, targetY, targetPosition = Position.Top }) {
  const [sourceControlX, sourceControlY] = getControl({
    pos: sourcePosition,
    x1: sourceX,
    y1: sourceY,
    x2: targetX,
    y2: targetY
  });
  const [targetControlX, targetControlY] = getControl({
    pos: targetPosition,
    x1: targetX,
    y1: targetY,
    x2: sourceX,
    y2: sourceY
  });
  const [labelX, labelY, offsetX, offsetY] = getBezierEdgeCenter({
    sourceX,
    sourceY,
    targetX,
    targetY,
    sourceControlX,
    sourceControlY,
    targetControlX,
    targetControlY
  });
  return [
    `M${sourceX},${sourceY} C${sourceControlX},${sourceControlY} ${targetControlX},${targetControlY} ${targetX},${targetY}`,
    labelX,
    labelY,
    offsetX,
    offsetY
  ];
}
const SimpleBezierEdge = reactExports.memo(({ sourceX, sourceY, targetX, targetY, sourcePosition = Position.Bottom, targetPosition = Position.Top, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth }) => {
  const [path, labelX, labelY] = getSimpleBezierPath({
    sourceX,
    sourceY,
    sourcePosition,
    targetX,
    targetY,
    targetPosition
  });
  return React.createElement(BaseEdge, { path, labelX, labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth });
});
SimpleBezierEdge.displayName = "SimpleBezierEdge";
const handleDirections = {
  [Position.Left]: { x: -1, y: 0 },
  [Position.Right]: { x: 1, y: 0 },
  [Position.Top]: { x: 0, y: -1 },
  [Position.Bottom]: { x: 0, y: 1 }
};
const getDirection$1 = ({ source, sourcePosition = Position.Bottom, target }) => {
  if (sourcePosition === Position.Left || sourcePosition === Position.Right) {
    return source.x < target.x ? { x: 1, y: 0 } : { x: -1, y: 0 };
  }
  return source.y < target.y ? { x: 0, y: 1 } : { x: 0, y: -1 };
};
const distance = (a, b) => Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
function getPoints({ source, sourcePosition = Position.Bottom, target, targetPosition = Position.Top, center, offset }) {
  const sourceDir = handleDirections[sourcePosition];
  const targetDir = handleDirections[targetPosition];
  const sourceGapped = { x: source.x + sourceDir.x * offset, y: source.y + sourceDir.y * offset };
  const targetGapped = { x: target.x + targetDir.x * offset, y: target.y + targetDir.y * offset };
  const dir = getDirection$1({
    source: sourceGapped,
    sourcePosition,
    target: targetGapped
  });
  const dirAccessor = dir.x !== 0 ? "x" : "y";
  const currDir = dir[dirAccessor];
  let points = [];
  let centerX, centerY;
  const sourceGapOffset = { x: 0, y: 0 };
  const targetGapOffset = { x: 0, y: 0 };
  const [defaultCenterX, defaultCenterY, defaultOffsetX, defaultOffsetY] = getEdgeCenter({
    sourceX: source.x,
    sourceY: source.y,
    targetX: target.x,
    targetY: target.y
  });
  if (sourceDir[dirAccessor] * targetDir[dirAccessor] === -1) {
    centerX = center.x || defaultCenterX;
    centerY = center.y || defaultCenterY;
    const verticalSplit = [
      { x: centerX, y: sourceGapped.y },
      { x: centerX, y: targetGapped.y }
    ];
    const horizontalSplit = [
      { x: sourceGapped.x, y: centerY },
      { x: targetGapped.x, y: centerY }
    ];
    if (sourceDir[dirAccessor] === currDir) {
      points = dirAccessor === "x" ? verticalSplit : horizontalSplit;
    } else {
      points = dirAccessor === "x" ? horizontalSplit : verticalSplit;
    }
  } else {
    const sourceTarget = [{ x: sourceGapped.x, y: targetGapped.y }];
    const targetSource = [{ x: targetGapped.x, y: sourceGapped.y }];
    if (dirAccessor === "x") {
      points = sourceDir.x === currDir ? targetSource : sourceTarget;
    } else {
      points = sourceDir.y === currDir ? sourceTarget : targetSource;
    }
    if (sourcePosition === targetPosition) {
      const diff = Math.abs(source[dirAccessor] - target[dirAccessor]);
      if (diff <= offset) {
        const gapOffset = Math.min(offset - 1, offset - diff);
        if (sourceDir[dirAccessor] === currDir) {
          sourceGapOffset[dirAccessor] = (sourceGapped[dirAccessor] > source[dirAccessor] ? -1 : 1) * gapOffset;
        } else {
          targetGapOffset[dirAccessor] = (targetGapped[dirAccessor] > target[dirAccessor] ? -1 : 1) * gapOffset;
        }
      }
    }
    if (sourcePosition !== targetPosition) {
      const dirAccessorOpposite = dirAccessor === "x" ? "y" : "x";
      const isSameDir = sourceDir[dirAccessor] === targetDir[dirAccessorOpposite];
      const sourceGtTargetOppo = sourceGapped[dirAccessorOpposite] > targetGapped[dirAccessorOpposite];
      const sourceLtTargetOppo = sourceGapped[dirAccessorOpposite] < targetGapped[dirAccessorOpposite];
      const flipSourceTarget = sourceDir[dirAccessor] === 1 && (!isSameDir && sourceGtTargetOppo || isSameDir && sourceLtTargetOppo) || sourceDir[dirAccessor] !== 1 && (!isSameDir && sourceLtTargetOppo || isSameDir && sourceGtTargetOppo);
      if (flipSourceTarget) {
        points = dirAccessor === "x" ? sourceTarget : targetSource;
      }
    }
    const sourceGapPoint = { x: sourceGapped.x + sourceGapOffset.x, y: sourceGapped.y + sourceGapOffset.y };
    const targetGapPoint = { x: targetGapped.x + targetGapOffset.x, y: targetGapped.y + targetGapOffset.y };
    const maxXDistance = Math.max(Math.abs(sourceGapPoint.x - points[0].x), Math.abs(targetGapPoint.x - points[0].x));
    const maxYDistance = Math.max(Math.abs(sourceGapPoint.y - points[0].y), Math.abs(targetGapPoint.y - points[0].y));
    if (maxXDistance >= maxYDistance) {
      centerX = (sourceGapPoint.x + targetGapPoint.x) / 2;
      centerY = points[0].y;
    } else {
      centerX = points[0].x;
      centerY = (sourceGapPoint.y + targetGapPoint.y) / 2;
    }
  }
  const pathPoints = [
    source,
    { x: sourceGapped.x + sourceGapOffset.x, y: sourceGapped.y + sourceGapOffset.y },
    ...points,
    { x: targetGapped.x + targetGapOffset.x, y: targetGapped.y + targetGapOffset.y },
    target
  ];
  return [pathPoints, centerX, centerY, defaultOffsetX, defaultOffsetY];
}
function getBend(a, b, c, size) {
  const bendSize = Math.min(distance(a, b) / 2, distance(b, c) / 2, size);
  const { x, y } = b;
  if (a.x === x && x === c.x || a.y === y && y === c.y) {
    return `L${x} ${y}`;
  }
  if (a.y === y) {
    const xDir2 = a.x < c.x ? -1 : 1;
    const yDir2 = a.y < c.y ? 1 : -1;
    return `L ${x + bendSize * xDir2},${y}Q ${x},${y} ${x},${y + bendSize * yDir2}`;
  }
  const xDir = a.x < c.x ? 1 : -1;
  const yDir = a.y < c.y ? -1 : 1;
  return `L ${x},${y + bendSize * yDir}Q ${x},${y} ${x + bendSize * xDir},${y}`;
}
function getSmoothStepPath({ sourceX, sourceY, sourcePosition = Position.Bottom, targetX, targetY, targetPosition = Position.Top, borderRadius = 5, centerX, centerY, offset = 20 }) {
  const [points, labelX, labelY, offsetX, offsetY] = getPoints({
    source: { x: sourceX, y: sourceY },
    sourcePosition,
    target: { x: targetX, y: targetY },
    targetPosition,
    center: { x: centerX, y: centerY },
    offset
  });
  const path = points.reduce((res, p, i) => {
    let segment = "";
    if (i > 0 && i < points.length - 1) {
      segment = getBend(points[i - 1], p, points[i + 1], borderRadius);
    } else {
      segment = `${i === 0 ? "M" : "L"}${p.x} ${p.y}`;
    }
    res += segment;
    return res;
  }, "");
  return [path, labelX, labelY, offsetX, offsetY];
}
const SmoothStepEdge = reactExports.memo(({ sourceX, sourceY, targetX, targetY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, sourcePosition = Position.Bottom, targetPosition = Position.Top, markerEnd, markerStart, pathOptions, interactionWidth }) => {
  const [path, labelX, labelY] = getSmoothStepPath({
    sourceX,
    sourceY,
    sourcePosition,
    targetX,
    targetY,
    targetPosition,
    borderRadius: pathOptions?.borderRadius,
    offset: pathOptions?.offset
  });
  return React.createElement(BaseEdge, { path, labelX, labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth });
});
SmoothStepEdge.displayName = "SmoothStepEdge";
const StepEdge = reactExports.memo((props) => React.createElement(SmoothStepEdge, { ...props, pathOptions: reactExports.useMemo(() => ({ borderRadius: 0, offset: props.pathOptions?.offset }), [props.pathOptions?.offset]) }));
StepEdge.displayName = "StepEdge";
function getStraightPath({ sourceX, sourceY, targetX, targetY }) {
  const [labelX, labelY, offsetX, offsetY] = getEdgeCenter({
    sourceX,
    sourceY,
    targetX,
    targetY
  });
  return [`M ${sourceX},${sourceY}L ${targetX},${targetY}`, labelX, labelY, offsetX, offsetY];
}
const StraightEdge = reactExports.memo(({ sourceX, sourceY, targetX, targetY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth }) => {
  const [path, labelX, labelY] = getStraightPath({ sourceX, sourceY, targetX, targetY });
  return React.createElement(BaseEdge, { path, labelX, labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth });
});
StraightEdge.displayName = "StraightEdge";
function calculateControlOffset(distance2, curvature) {
  if (distance2 >= 0) {
    return 0.5 * distance2;
  }
  return curvature * 25 * Math.sqrt(-distance2);
}
function getControlWithCurvature({ pos, x1, y1, x2, y2, c }) {
  switch (pos) {
    case Position.Left:
      return [x1 - calculateControlOffset(x1 - x2, c), y1];
    case Position.Right:
      return [x1 + calculateControlOffset(x2 - x1, c), y1];
    case Position.Top:
      return [x1, y1 - calculateControlOffset(y1 - y2, c)];
    case Position.Bottom:
      return [x1, y1 + calculateControlOffset(y2 - y1, c)];
  }
}
function getBezierPath({ sourceX, sourceY, sourcePosition = Position.Bottom, targetX, targetY, targetPosition = Position.Top, curvature = 0.25 }) {
  const [sourceControlX, sourceControlY] = getControlWithCurvature({
    pos: sourcePosition,
    x1: sourceX,
    y1: sourceY,
    x2: targetX,
    y2: targetY,
    c: curvature
  });
  const [targetControlX, targetControlY] = getControlWithCurvature({
    pos: targetPosition,
    x1: targetX,
    y1: targetY,
    x2: sourceX,
    y2: sourceY,
    c: curvature
  });
  const [labelX, labelY, offsetX, offsetY] = getBezierEdgeCenter({
    sourceX,
    sourceY,
    targetX,
    targetY,
    sourceControlX,
    sourceControlY,
    targetControlX,
    targetControlY
  });
  return [
    `M${sourceX},${sourceY} C${sourceControlX},${sourceControlY} ${targetControlX},${targetControlY} ${targetX},${targetY}`,
    labelX,
    labelY,
    offsetX,
    offsetY
  ];
}
const BezierEdge = reactExports.memo(({ sourceX, sourceY, targetX, targetY, sourcePosition = Position.Bottom, targetPosition = Position.Top, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, pathOptions, interactionWidth }) => {
  const [path, labelX, labelY] = getBezierPath({
    sourceX,
    sourceY,
    sourcePosition,
    targetX,
    targetY,
    targetPosition,
    curvature: pathOptions?.curvature
  });
  return React.createElement(BaseEdge, { path, labelX, labelY, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, markerEnd, markerStart, interactionWidth });
});
BezierEdge.displayName = "BezierEdge";
const NodeIdContext = reactExports.createContext(null);
const Provider = NodeIdContext.Provider;
NodeIdContext.Consumer;
const useNodeId = () => {
  const nodeId = reactExports.useContext(NodeIdContext);
  return nodeId;
};
const isEdge = (element) => "id" in element && "source" in element && "target" in element;
const getEdgeId = ({ source, sourceHandle, target, targetHandle }) => `reactflow__edge-${source}${sourceHandle || ""}-${target}${targetHandle || ""}`;
const getMarkerId = (marker, rfId) => {
  if (typeof marker === "undefined") {
    return "";
  }
  if (typeof marker === "string") {
    return marker;
  }
  const idPrefix = rfId ? `${rfId}__` : "";
  return `${idPrefix}${Object.keys(marker).sort().map((key) => `${key}=${marker[key]}`).join("&")}`;
};
const connectionExists = (edge, edges) => {
  return edges.some((el) => el.source === edge.source && el.target === edge.target && (el.sourceHandle === edge.sourceHandle || !el.sourceHandle && !edge.sourceHandle) && (el.targetHandle === edge.targetHandle || !el.targetHandle && !edge.targetHandle));
};
const addEdge = (edgeParams, edges) => {
  if (!edgeParams.source || !edgeParams.target) {
    devWarn("006", errorMessages["error006"]());
    return edges;
  }
  let edge;
  if (isEdge(edgeParams)) {
    edge = { ...edgeParams };
  } else {
    edge = {
      ...edgeParams,
      id: getEdgeId(edgeParams)
    };
  }
  if (connectionExists(edge, edges)) {
    return edges;
  }
  return edges.concat(edge);
};
const pointToRendererPoint = ({ x, y }, [tx, ty, tScale], snapToGrid, [snapX, snapY]) => {
  const position = {
    x: (x - tx) / tScale,
    y: (y - ty) / tScale
  };
  if (snapToGrid) {
    return {
      x: snapX * Math.round(position.x / snapX),
      y: snapY * Math.round(position.y / snapY)
    };
  }
  return position;
};
const rendererPointToPoint = ({ x, y }, [tx, ty, tScale]) => {
  return {
    x: x * tScale + tx,
    y: y * tScale + ty
  };
};
const getNodePositionWithOrigin = (node, nodeOrigin = [0, 0]) => {
  if (!node) {
    return {
      x: 0,
      y: 0,
      positionAbsolute: {
        x: 0,
        y: 0
      }
    };
  }
  const offsetX = (node.width ?? 0) * nodeOrigin[0];
  const offsetY = (node.height ?? 0) * nodeOrigin[1];
  const position = {
    x: node.position.x - offsetX,
    y: node.position.y - offsetY
  };
  return {
    ...position,
    positionAbsolute: node.positionAbsolute ? {
      x: node.positionAbsolute.x - offsetX,
      y: node.positionAbsolute.y - offsetY
    } : position
  };
};
const getRectOfNodes = (nodes, nodeOrigin = [0, 0]) => {
  if (nodes.length === 0) {
    return { x: 0, y: 0, width: 0, height: 0 };
  }
  const box = nodes.reduce((currBox, node) => {
    const { x, y } = getNodePositionWithOrigin(node, nodeOrigin).positionAbsolute;
    return getBoundsOfBoxes(currBox, rectToBox({
      x,
      y,
      width: node.width || 0,
      height: node.height || 0
    }));
  }, { x: Infinity, y: Infinity, x2: -Infinity, y2: -Infinity });
  return boxToRect(box);
};
const getNodesInside = (nodeInternals, rect, [tx, ty, tScale] = [0, 0, 1], partially = false, excludeNonSelectableNodes = false, nodeOrigin = [0, 0]) => {
  const paneRect = {
    x: (rect.x - tx) / tScale,
    y: (rect.y - ty) / tScale,
    width: rect.width / tScale,
    height: rect.height / tScale
  };
  const visibleNodes = [];
  nodeInternals.forEach((node) => {
    const { width, height, selectable = true, hidden = false } = node;
    if (excludeNonSelectableNodes && !selectable || hidden) {
      return false;
    }
    const { positionAbsolute } = getNodePositionWithOrigin(node, nodeOrigin);
    const nodeRect = {
      x: positionAbsolute.x,
      y: positionAbsolute.y,
      width: width || 0,
      height: height || 0
    };
    const overlappingArea = getOverlappingArea(paneRect, nodeRect);
    const notInitialized = typeof width === "undefined" || typeof height === "undefined" || width === null || height === null;
    const partiallyVisible = partially && overlappingArea > 0;
    const area = (width || 0) * (height || 0);
    const isVisible = notInitialized || partiallyVisible || overlappingArea >= area;
    if (isVisible || node.dragging) {
      visibleNodes.push(node);
    }
  });
  return visibleNodes;
};
const getConnectedEdges = (nodes, edges) => {
  const nodeIds = nodes.map((node) => node.id);
  return edges.filter((edge) => nodeIds.includes(edge.source) || nodeIds.includes(edge.target));
};
const getTransformForBounds = (bounds, width, height, minZoom, maxZoom, padding = 0.1) => {
  const xZoom = width / (bounds.width * (1 + padding));
  const yZoom = height / (bounds.height * (1 + padding));
  const zoom2 = Math.min(xZoom, yZoom);
  const clampedZoom = clamp(zoom2, minZoom, maxZoom);
  const boundsCenterX = bounds.x + bounds.width / 2;
  const boundsCenterY = bounds.y + bounds.height / 2;
  const x = width / 2 - boundsCenterX * clampedZoom;
  const y = height / 2 - boundsCenterY * clampedZoom;
  return [x, y, clampedZoom];
};
const getD3Transition = (selection, duration = 0) => {
  return selection.transition().duration(duration);
};
function getHandles(node, handleBounds, type, currentHandle) {
  return (handleBounds[type] || []).reduce((res, h) => {
    if (`${node.id}-${h.id}-${type}` !== currentHandle) {
      res.push({
        id: h.id || null,
        type,
        nodeId: node.id,
        x: (node.positionAbsolute?.x ?? 0) + h.x + h.width / 2,
        y: (node.positionAbsolute?.y ?? 0) + h.y + h.height / 2
      });
    }
    return res;
  }, []);
}
function getClosestHandle(event, doc, pos, connectionRadius, handles, validator) {
  const { x, y } = getEventPosition(event);
  const domNodes = doc.elementsFromPoint(x, y);
  const handleBelow = domNodes.find((el) => el.classList.contains("react-flow__handle"));
  if (handleBelow) {
    const handleNodeId = handleBelow.getAttribute("data-nodeid");
    if (handleNodeId) {
      const handleType = getHandleType(void 0, handleBelow);
      const handleId = handleBelow.getAttribute("data-handleid");
      const validHandleResult = validator({ nodeId: handleNodeId, id: handleId, type: handleType });
      if (validHandleResult) {
        return {
          handle: {
            id: handleId,
            type: handleType,
            nodeId: handleNodeId,
            x: pos.x,
            y: pos.y
          },
          validHandleResult
        };
      }
    }
  }
  let closestHandles = [];
  let minDistance = Infinity;
  handles.forEach((handle) => {
    const distance2 = Math.sqrt((handle.x - pos.x) ** 2 + (handle.y - pos.y) ** 2);
    if (distance2 <= connectionRadius) {
      const validHandleResult = validator(handle);
      if (distance2 <= minDistance) {
        if (distance2 < minDistance) {
          closestHandles = [{ handle, validHandleResult }];
        } else if (distance2 === minDistance) {
          closestHandles.push({
            handle,
            validHandleResult
          });
        }
        minDistance = distance2;
      }
    }
  });
  if (!closestHandles.length) {
    return { handle: null, validHandleResult: defaultResult() };
  }
  if (closestHandles.length === 1) {
    return closestHandles[0];
  }
  const hasValidHandle = closestHandles.some(({ validHandleResult }) => validHandleResult.isValid);
  const hasTargetHandle = closestHandles.some(({ handle }) => handle.type === "target");
  return closestHandles.find(({ handle, validHandleResult }) => hasTargetHandle ? handle.type === "target" : hasValidHandle ? validHandleResult.isValid : true) || closestHandles[0];
}
const nullConnection = { source: null, target: null, sourceHandle: null, targetHandle: null };
const defaultResult = () => ({
  handleDomNode: null,
  isValid: false,
  connection: nullConnection,
  endHandle: null
});
function isValidHandle(handle, connectionMode, fromNodeId, fromHandleId, fromType, isValidConnection, doc) {
  const isTarget = fromType === "target";
  const handleToCheck = doc.querySelector(`.react-flow__handle[data-id="${handle?.nodeId}-${handle?.id}-${handle?.type}"]`);
  const result = {
    ...defaultResult(),
    handleDomNode: handleToCheck
  };
  if (handleToCheck) {
    const handleType = getHandleType(void 0, handleToCheck);
    const handleNodeId = handleToCheck.getAttribute("data-nodeid");
    const handleId = handleToCheck.getAttribute("data-handleid");
    const connectable = handleToCheck.classList.contains("connectable");
    const connectableEnd = handleToCheck.classList.contains("connectableend");
    const connection = {
      source: isTarget ? handleNodeId : fromNodeId,
      sourceHandle: isTarget ? handleId : fromHandleId,
      target: isTarget ? fromNodeId : handleNodeId,
      targetHandle: isTarget ? fromHandleId : handleId
    };
    result.connection = connection;
    const isConnectable = connectable && connectableEnd;
    const isValid = isConnectable && (connectionMode === ConnectionMode.Strict ? isTarget && handleType === "source" || !isTarget && handleType === "target" : handleNodeId !== fromNodeId || handleId !== fromHandleId);
    if (isValid) {
      result.endHandle = {
        nodeId: handleNodeId,
        handleId,
        type: handleType
      };
      result.isValid = isValidConnection(connection);
    }
  }
  return result;
}
function getHandleLookup({ nodes, nodeId, handleId, handleType }) {
  return nodes.reduce((res, node) => {
    if (node[internalsSymbol]) {
      const { handleBounds } = node[internalsSymbol];
      let sourceHandles = [];
      let targetHandles = [];
      if (handleBounds) {
        sourceHandles = getHandles(node, handleBounds, "source", `${nodeId}-${handleId}-${handleType}`);
        targetHandles = getHandles(node, handleBounds, "target", `${nodeId}-${handleId}-${handleType}`);
      }
      res.push(...sourceHandles, ...targetHandles);
    }
    return res;
  }, []);
}
function getHandleType(edgeUpdaterType, handleDomNode) {
  if (edgeUpdaterType) {
    return edgeUpdaterType;
  } else if (handleDomNode?.classList.contains("target")) {
    return "target";
  } else if (handleDomNode?.classList.contains("source")) {
    return "source";
  }
  return null;
}
function resetRecentHandle(handleDomNode) {
  handleDomNode?.classList.remove("valid", "connecting", "react-flow__handle-valid", "react-flow__handle-connecting");
}
function getConnectionStatus(isInsideConnectionRadius, isHandleValid) {
  let connectionStatus = null;
  if (isHandleValid) {
    connectionStatus = "valid";
  } else if (isInsideConnectionRadius && !isHandleValid) {
    connectionStatus = "invalid";
  }
  return connectionStatus;
}
function handlePointerDown({ event, handleId, nodeId, onConnect, isTarget, getState, setState, isValidConnection, edgeUpdaterType, onEdgeUpdateEnd }) {
  const doc = getHostForElement(event.target);
  const { connectionMode, domNode, autoPanOnConnect, connectionRadius, onConnectStart, panBy, getNodes, cancelConnection } = getState();
  let autoPanId = 0;
  let closestHandle;
  const { x, y } = getEventPosition(event);
  const clickedHandle = doc?.elementFromPoint(x, y);
  const handleType = getHandleType(edgeUpdaterType, clickedHandle);
  const containerBounds = domNode?.getBoundingClientRect();
  if (!containerBounds || !handleType) {
    return;
  }
  let prevActiveHandle;
  let connectionPosition = getEventPosition(event, containerBounds);
  let autoPanStarted = false;
  let connection = null;
  let isValid = false;
  let handleDomNode = null;
  const handleLookup = getHandleLookup({
    nodes: getNodes(),
    nodeId,
    handleId,
    handleType
  });
  const autoPan = () => {
    if (!autoPanOnConnect) {
      return;
    }
    const [xMovement, yMovement] = calcAutoPan(connectionPosition, containerBounds);
    panBy({ x: xMovement, y: yMovement });
    autoPanId = requestAnimationFrame(autoPan);
  };
  setState({
    connectionPosition,
    connectionStatus: null,
    // connectionNodeId etc will be removed in the next major in favor of connectionStartHandle
    connectionNodeId: nodeId,
    connectionHandleId: handleId,
    connectionHandleType: handleType,
    connectionStartHandle: {
      nodeId,
      handleId,
      type: handleType
    },
    connectionEndHandle: null
  });
  onConnectStart?.(event, { nodeId, handleId, handleType });
  function onPointerMove(event2) {
    const { transform } = getState();
    connectionPosition = getEventPosition(event2, containerBounds);
    const { handle, validHandleResult } = getClosestHandle(event2, doc, pointToRendererPoint(connectionPosition, transform, false, [1, 1]), connectionRadius, handleLookup, (handle2) => isValidHandle(handle2, connectionMode, nodeId, handleId, isTarget ? "target" : "source", isValidConnection, doc));
    closestHandle = handle;
    if (!autoPanStarted) {
      autoPan();
      autoPanStarted = true;
    }
    handleDomNode = validHandleResult.handleDomNode;
    connection = validHandleResult.connection;
    isValid = validHandleResult.isValid;
    setState({
      connectionPosition: closestHandle && isValid ? rendererPointToPoint({
        x: closestHandle.x,
        y: closestHandle.y
      }, transform) : connectionPosition,
      connectionStatus: getConnectionStatus(!!closestHandle, isValid),
      connectionEndHandle: validHandleResult.endHandle
    });
    if (!closestHandle && !isValid && !handleDomNode) {
      return resetRecentHandle(prevActiveHandle);
    }
    if (connection.source !== connection.target && handleDomNode) {
      resetRecentHandle(prevActiveHandle);
      prevActiveHandle = handleDomNode;
      handleDomNode.classList.add("connecting", "react-flow__handle-connecting");
      handleDomNode.classList.toggle("valid", isValid);
      handleDomNode.classList.toggle("react-flow__handle-valid", isValid);
    }
  }
  function onPointerUp(event2) {
    if ((closestHandle || handleDomNode) && connection && isValid) {
      onConnect?.(connection);
    }
    getState().onConnectEnd?.(event2);
    if (edgeUpdaterType) {
      onEdgeUpdateEnd?.(event2);
    }
    resetRecentHandle(prevActiveHandle);
    cancelConnection();
    cancelAnimationFrame(autoPanId);
    autoPanStarted = false;
    isValid = false;
    connection = null;
    handleDomNode = null;
    doc.removeEventListener("mousemove", onPointerMove);
    doc.removeEventListener("mouseup", onPointerUp);
    doc.removeEventListener("touchmove", onPointerMove);
    doc.removeEventListener("touchend", onPointerUp);
  }
  doc.addEventListener("mousemove", onPointerMove);
  doc.addEventListener("mouseup", onPointerUp);
  doc.addEventListener("touchmove", onPointerMove);
  doc.addEventListener("touchend", onPointerUp);
}
const alwaysValid = () => true;
const selector$f = (s) => ({
  connectionStartHandle: s.connectionStartHandle,
  connectOnClick: s.connectOnClick,
  noPanClassName: s.noPanClassName
});
const connectingSelector = (nodeId, handleId, type) => (state) => {
  const { connectionStartHandle: startHandle, connectionEndHandle: endHandle, connectionClickStartHandle: clickHandle } = state;
  return {
    connecting: startHandle?.nodeId === nodeId && startHandle?.handleId === handleId && startHandle?.type === type || endHandle?.nodeId === nodeId && endHandle?.handleId === handleId && endHandle?.type === type,
    clickConnecting: clickHandle?.nodeId === nodeId && clickHandle?.handleId === handleId && clickHandle?.type === type
  };
};
const Handle = reactExports.forwardRef(({ type = "source", position = Position.Top, isValidConnection, isConnectable = true, isConnectableStart = true, isConnectableEnd = true, id, onConnect, children, className, onMouseDown, onTouchStart, ...rest }, ref) => {
  const handleId = id || null;
  const isTarget = type === "target";
  const store = useStoreApi();
  const nodeId = useNodeId();
  const { connectOnClick, noPanClassName } = useStore(selector$f, shallow$1);
  const { connecting, clickConnecting } = useStore(connectingSelector(nodeId, handleId, type), shallow$1);
  if (!nodeId) {
    store.getState().onError?.("010", errorMessages["error010"]());
  }
  const onConnectExtended = (params) => {
    const { defaultEdgeOptions, onConnect: onConnectAction, hasDefaultEdges } = store.getState();
    const edgeParams = {
      ...defaultEdgeOptions,
      ...params
    };
    if (hasDefaultEdges) {
      const { edges, setEdges } = store.getState();
      setEdges(addEdge(edgeParams, edges));
    }
    onConnectAction?.(edgeParams);
    onConnect?.(edgeParams);
  };
  const onPointerDown = (event) => {
    if (!nodeId) {
      return;
    }
    const isMouseTriggered = isMouseEvent(event);
    if (isConnectableStart && (isMouseTriggered && event.button === 0 || !isMouseTriggered)) {
      handlePointerDown({
        event,
        handleId,
        nodeId,
        onConnect: onConnectExtended,
        isTarget,
        getState: store.getState,
        setState: store.setState,
        isValidConnection: isValidConnection || store.getState().isValidConnection || alwaysValid
      });
    }
    if (isMouseTriggered) {
      onMouseDown?.(event);
    } else {
      onTouchStart?.(event);
    }
  };
  const onClick = (event) => {
    const { onClickConnectStart, onClickConnectEnd, connectionClickStartHandle, connectionMode, isValidConnection: isValidConnectionStore } = store.getState();
    if (!nodeId || !connectionClickStartHandle && !isConnectableStart) {
      return;
    }
    if (!connectionClickStartHandle) {
      onClickConnectStart?.(event, { nodeId, handleId, handleType: type });
      store.setState({ connectionClickStartHandle: { nodeId, type, handleId } });
      return;
    }
    const doc = getHostForElement(event.target);
    const isValidConnectionHandler = isValidConnection || isValidConnectionStore || alwaysValid;
    const { connection, isValid } = isValidHandle({
      nodeId,
      id: handleId,
      type
    }, connectionMode, connectionClickStartHandle.nodeId, connectionClickStartHandle.handleId || null, connectionClickStartHandle.type, isValidConnectionHandler, doc);
    if (isValid) {
      onConnectExtended(connection);
    }
    onClickConnectEnd?.(event);
    store.setState({ connectionClickStartHandle: null });
  };
  return React.createElement("div", { "data-handleid": handleId, "data-nodeid": nodeId, "data-handlepos": position, "data-id": `${nodeId}-${handleId}-${type}`, className: cc([
    "react-flow__handle",
    `react-flow__handle-${position}`,
    "nodrag",
    noPanClassName,
    className,
    {
      source: !isTarget,
      target: isTarget,
      connectable: isConnectable,
      connectablestart: isConnectableStart,
      connectableend: isConnectableEnd,
      connecting: clickConnecting,
      // this class is used to style the handle when the user is connecting
      connectionindicator: isConnectable && (isConnectableStart && !connecting || isConnectableEnd && connecting)
    }
  ]), onMouseDown: onPointerDown, onTouchStart: onPointerDown, onClick: connectOnClick ? onClick : void 0, ref, ...rest }, children);
});
Handle.displayName = "Handle";
var Handle$1 = reactExports.memo(Handle);
const DefaultNode = ({ data, isConnectable, targetPosition = Position.Top, sourcePosition = Position.Bottom }) => {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(Handle$1, { type: "target", position: targetPosition, isConnectable }),
    data?.label,
    React.createElement(Handle$1, { type: "source", position: sourcePosition, isConnectable })
  );
};
DefaultNode.displayName = "DefaultNode";
var DefaultNode$1 = reactExports.memo(DefaultNode);
const InputNode = ({ data, isConnectable, sourcePosition = Position.Bottom }) => React.createElement(
  React.Fragment,
  null,
  data?.label,
  React.createElement(Handle$1, { type: "source", position: sourcePosition, isConnectable })
);
InputNode.displayName = "InputNode";
var InputNode$1 = reactExports.memo(InputNode);
const OutputNode = ({ data, isConnectable, targetPosition = Position.Top }) => React.createElement(
  React.Fragment,
  null,
  React.createElement(Handle$1, { type: "target", position: targetPosition, isConnectable }),
  data?.label
);
OutputNode.displayName = "OutputNode";
var OutputNode$1 = reactExports.memo(OutputNode);
const GroupNode = () => null;
GroupNode.displayName = "GroupNode";
const selector$e = (s) => ({
  selectedNodes: s.getNodes().filter((n) => n.selected),
  selectedEdges: s.edges.filter((e) => e.selected)
});
const selectId = (obj) => obj.id;
function areEqual(a, b) {
  return shallow$1(a.selectedNodes.map(selectId), b.selectedNodes.map(selectId)) && shallow$1(a.selectedEdges.map(selectId), b.selectedEdges.map(selectId));
}
const SelectionListener = reactExports.memo(({ onSelectionChange }) => {
  const store = useStoreApi();
  const { selectedNodes, selectedEdges } = useStore(selector$e, areEqual);
  reactExports.useEffect(() => {
    const params = { nodes: selectedNodes, edges: selectedEdges };
    onSelectionChange?.(params);
    store.getState().onSelectionChange?.(params);
  }, [selectedNodes, selectedEdges, onSelectionChange]);
  return null;
});
SelectionListener.displayName = "SelectionListener";
const changeSelector = (s) => !!s.onSelectionChange;
function Wrapper$1({ onSelectionChange }) {
  const storeHasSelectionChange = useStore(changeSelector);
  if (onSelectionChange || storeHasSelectionChange) {
    return React.createElement(SelectionListener, { onSelectionChange });
  }
  return null;
}
const selector$d = (s) => ({
  setNodes: s.setNodes,
  setEdges: s.setEdges,
  setDefaultNodesAndEdges: s.setDefaultNodesAndEdges,
  setMinZoom: s.setMinZoom,
  setMaxZoom: s.setMaxZoom,
  setTranslateExtent: s.setTranslateExtent,
  setNodeExtent: s.setNodeExtent,
  reset: s.reset
});
function useStoreUpdater(value, setStoreState) {
  reactExports.useEffect(() => {
    if (typeof value !== "undefined") {
      setStoreState(value);
    }
  }, [value]);
}
function useDirectStoreUpdater(key, value, setState) {
  reactExports.useEffect(() => {
    if (typeof value !== "undefined") {
      setState({ [key]: value });
    }
  }, [value]);
}
const StoreUpdater = ({ nodes, edges, defaultNodes, defaultEdges, onConnect, onConnectStart, onConnectEnd, onClickConnectStart, onClickConnectEnd, nodesDraggable, nodesConnectable, nodesFocusable, edgesFocusable, edgesUpdatable, elevateNodesOnSelect, minZoom, maxZoom, nodeExtent, onNodesChange, onEdgesChange, elementsSelectable, connectionMode, snapGrid, snapToGrid, translateExtent, connectOnClick, defaultEdgeOptions, fitView: fitView2, fitViewOptions, onNodesDelete, onEdgesDelete, onNodeDrag, onNodeDragStart, onNodeDragStop, onSelectionDrag, onSelectionDragStart, onSelectionDragStop, noPanClassName, nodeOrigin, rfId, autoPanOnConnect, autoPanOnNodeDrag, onError, connectionRadius, isValidConnection, nodeDragThreshold }) => {
  const { setNodes, setEdges, setDefaultNodesAndEdges, setMinZoom, setMaxZoom, setTranslateExtent, setNodeExtent, reset } = useStore(selector$d, shallow$1);
  const store = useStoreApi();
  reactExports.useEffect(() => {
    const edgesWithDefaults = defaultEdges?.map((e) => ({ ...e, ...defaultEdgeOptions }));
    setDefaultNodesAndEdges(defaultNodes, edgesWithDefaults);
    return () => {
      reset();
    };
  }, []);
  useDirectStoreUpdater("defaultEdgeOptions", defaultEdgeOptions, store.setState);
  useDirectStoreUpdater("connectionMode", connectionMode, store.setState);
  useDirectStoreUpdater("onConnect", onConnect, store.setState);
  useDirectStoreUpdater("onConnectStart", onConnectStart, store.setState);
  useDirectStoreUpdater("onConnectEnd", onConnectEnd, store.setState);
  useDirectStoreUpdater("onClickConnectStart", onClickConnectStart, store.setState);
  useDirectStoreUpdater("onClickConnectEnd", onClickConnectEnd, store.setState);
  useDirectStoreUpdater("nodesDraggable", nodesDraggable, store.setState);
  useDirectStoreUpdater("nodesConnectable", nodesConnectable, store.setState);
  useDirectStoreUpdater("nodesFocusable", nodesFocusable, store.setState);
  useDirectStoreUpdater("edgesFocusable", edgesFocusable, store.setState);
  useDirectStoreUpdater("edgesUpdatable", edgesUpdatable, store.setState);
  useDirectStoreUpdater("elementsSelectable", elementsSelectable, store.setState);
  useDirectStoreUpdater("elevateNodesOnSelect", elevateNodesOnSelect, store.setState);
  useDirectStoreUpdater("snapToGrid", snapToGrid, store.setState);
  useDirectStoreUpdater("snapGrid", snapGrid, store.setState);
  useDirectStoreUpdater("onNodesChange", onNodesChange, store.setState);
  useDirectStoreUpdater("onEdgesChange", onEdgesChange, store.setState);
  useDirectStoreUpdater("connectOnClick", connectOnClick, store.setState);
  useDirectStoreUpdater("fitViewOnInit", fitView2, store.setState);
  useDirectStoreUpdater("fitViewOnInitOptions", fitViewOptions, store.setState);
  useDirectStoreUpdater("onNodesDelete", onNodesDelete, store.setState);
  useDirectStoreUpdater("onEdgesDelete", onEdgesDelete, store.setState);
  useDirectStoreUpdater("onNodeDrag", onNodeDrag, store.setState);
  useDirectStoreUpdater("onNodeDragStart", onNodeDragStart, store.setState);
  useDirectStoreUpdater("onNodeDragStop", onNodeDragStop, store.setState);
  useDirectStoreUpdater("onSelectionDrag", onSelectionDrag, store.setState);
  useDirectStoreUpdater("onSelectionDragStart", onSelectionDragStart, store.setState);
  useDirectStoreUpdater("onSelectionDragStop", onSelectionDragStop, store.setState);
  useDirectStoreUpdater("noPanClassName", noPanClassName, store.setState);
  useDirectStoreUpdater("nodeOrigin", nodeOrigin, store.setState);
  useDirectStoreUpdater("rfId", rfId, store.setState);
  useDirectStoreUpdater("autoPanOnConnect", autoPanOnConnect, store.setState);
  useDirectStoreUpdater("autoPanOnNodeDrag", autoPanOnNodeDrag, store.setState);
  useDirectStoreUpdater("onError", onError, store.setState);
  useDirectStoreUpdater("connectionRadius", connectionRadius, store.setState);
  useDirectStoreUpdater("isValidConnection", isValidConnection, store.setState);
  useDirectStoreUpdater("nodeDragThreshold", nodeDragThreshold, store.setState);
  useStoreUpdater(nodes, setNodes);
  useStoreUpdater(edges, setEdges);
  useStoreUpdater(minZoom, setMinZoom);
  useStoreUpdater(maxZoom, setMaxZoom);
  useStoreUpdater(translateExtent, setTranslateExtent);
  useStoreUpdater(nodeExtent, setNodeExtent);
  return null;
};
const style$1 = { display: "none" };
const ariaLiveStyle = {
  position: "absolute",
  width: 1,
  height: 1,
  margin: -1,
  border: 0,
  padding: 0,
  overflow: "hidden",
  clip: "rect(0px, 0px, 0px, 0px)",
  clipPath: "inset(100%)"
};
const ARIA_NODE_DESC_KEY = "react-flow__node-desc";
const ARIA_EDGE_DESC_KEY = "react-flow__edge-desc";
const ARIA_LIVE_MESSAGE = "react-flow__aria-live";
const selector$c = (s) => s.ariaLiveMessage;
function AriaLiveMessage({ rfId }) {
  const ariaLiveMessage = useStore(selector$c);
  return React.createElement("div", { id: `${ARIA_LIVE_MESSAGE}-${rfId}`, "aria-live": "assertive", "aria-atomic": "true", style: ariaLiveStyle }, ariaLiveMessage);
}
function A11yDescriptions({ rfId, disableKeyboardA11y }) {
  return React.createElement(
    React.Fragment,
    null,
    React.createElement(
      "div",
      { id: `${ARIA_NODE_DESC_KEY}-${rfId}`, style: style$1 },
      "Press enter or space to select a node.",
      !disableKeyboardA11y && "You can then use the arrow keys to move the node around.",
      " Press delete to remove it and escape to cancel.",
      " "
    ),
    React.createElement("div", { id: `${ARIA_EDGE_DESC_KEY}-${rfId}`, style: style$1 }, "Press enter or space to select an edge. You can then press delete to remove it or escape to cancel."),
    !disableKeyboardA11y && React.createElement(AriaLiveMessage, { rfId })
  );
}
var useKeyPress = (keyCode = null, options = { actInsideInputWithModifier: true }) => {
  const [keyPressed, setKeyPressed] = reactExports.useState(false);
  const modifierPressed = reactExports.useRef(false);
  const pressedKeys = reactExports.useRef(/* @__PURE__ */ new Set([]));
  const [keyCodes, keysToWatch] = reactExports.useMemo(() => {
    if (keyCode !== null) {
      const keyCodeArr = Array.isArray(keyCode) ? keyCode : [keyCode];
      const keys = keyCodeArr.filter((kc) => typeof kc === "string").map((kc) => kc.split("+"));
      const keysFlat = keys.reduce((res, item) => res.concat(...item), []);
      return [keys, keysFlat];
    }
    return [[], []];
  }, [keyCode]);
  reactExports.useEffect(() => {
    const doc = typeof document !== "undefined" ? document : null;
    const target = options?.target || doc;
    if (keyCode !== null) {
      const downHandler = (event) => {
        modifierPressed.current = event.ctrlKey || event.metaKey || event.shiftKey;
        const preventAction = (!modifierPressed.current || modifierPressed.current && !options.actInsideInputWithModifier) && isInputDOMNode(event);
        if (preventAction) {
          return false;
        }
        const keyOrCode = useKeyOrCode(event.code, keysToWatch);
        pressedKeys.current.add(event[keyOrCode]);
        if (isMatchingKey(keyCodes, pressedKeys.current, false)) {
          event.preventDefault();
          setKeyPressed(true);
        }
      };
      const upHandler = (event) => {
        const preventAction = (!modifierPressed.current || modifierPressed.current && !options.actInsideInputWithModifier) && isInputDOMNode(event);
        if (preventAction) {
          return false;
        }
        const keyOrCode = useKeyOrCode(event.code, keysToWatch);
        if (isMatchingKey(keyCodes, pressedKeys.current, true)) {
          setKeyPressed(false);
          pressedKeys.current.clear();
        } else {
          pressedKeys.current.delete(event[keyOrCode]);
        }
        if (event.key === "Meta") {
          pressedKeys.current.clear();
        }
        modifierPressed.current = false;
      };
      const resetHandler = () => {
        pressedKeys.current.clear();
        setKeyPressed(false);
      };
      target?.addEventListener("keydown", downHandler);
      target?.addEventListener("keyup", upHandler);
      window.addEventListener("blur", resetHandler);
      return () => {
        target?.removeEventListener("keydown", downHandler);
        target?.removeEventListener("keyup", upHandler);
        window.removeEventListener("blur", resetHandler);
      };
    }
  }, [keyCode, setKeyPressed]);
  return keyPressed;
};
function isMatchingKey(keyCodes, pressedKeys, isUp) {
  return keyCodes.filter((keys) => isUp || keys.length === pressedKeys.size).some((keys) => keys.every((k) => pressedKeys.has(k)));
}
function useKeyOrCode(eventCode, keysToWatch) {
  return keysToWatch.includes(eventCode) ? "code" : "key";
}
function calculateXYZPosition(node, nodeInternals, result, nodeOrigin) {
  if (!node.parentNode) {
    return result;
  }
  const parentNode = nodeInternals.get(node.parentNode);
  const parentNodePosition = getNodePositionWithOrigin(parentNode, nodeOrigin);
  return calculateXYZPosition(parentNode, nodeInternals, {
    x: (result.x ?? 0) + parentNodePosition.x,
    y: (result.y ?? 0) + parentNodePosition.y,
    z: (parentNode[internalsSymbol]?.z ?? 0) > (result.z ?? 0) ? parentNode[internalsSymbol]?.z ?? 0 : result.z ?? 0
  }, nodeOrigin);
}
function updateAbsoluteNodePositions(nodeInternals, nodeOrigin, parentNodes) {
  nodeInternals.forEach((node) => {
    if (node.parentNode && !nodeInternals.has(node.parentNode)) {
      throw new Error(`Parent node ${node.parentNode} not found`);
    }
    if (node.parentNode || parentNodes?.[node.id]) {
      const { x, y, z } = calculateXYZPosition(node, nodeInternals, {
        ...node.position,
        z: node[internalsSymbol]?.z ?? 0
      }, nodeOrigin);
      node.positionAbsolute = {
        x,
        y
      };
      node[internalsSymbol].z = z;
      if (parentNodes?.[node.id]) {
        node[internalsSymbol].isParent = true;
      }
    }
  });
}
function createNodeInternals(nodes, nodeInternals, nodeOrigin, elevateNodesOnSelect) {
  const nextNodeInternals = /* @__PURE__ */ new Map();
  const parentNodes = {};
  const selectedNodeZ = elevateNodesOnSelect ? 1e3 : 0;
  nodes.forEach((node) => {
    const z = (isNumeric(node.zIndex) ? node.zIndex : 0) + (node.selected ? selectedNodeZ : 0);
    const currInternals = nodeInternals.get(node.id);
    const internals = {
      width: currInternals?.width,
      height: currInternals?.height,
      ...node,
      positionAbsolute: {
        x: node.position.x,
        y: node.position.y
      }
    };
    if (node.parentNode) {
      internals.parentNode = node.parentNode;
      parentNodes[node.parentNode] = true;
    }
    Object.defineProperty(internals, internalsSymbol, {
      enumerable: false,
      value: {
        handleBounds: currInternals?.[internalsSymbol]?.handleBounds,
        z
      }
    });
    nextNodeInternals.set(node.id, internals);
  });
  updateAbsoluteNodePositions(nextNodeInternals, nodeOrigin, parentNodes);
  return nextNodeInternals;
}
function fitView(get, options = {}) {
  const { getNodes, width, height, minZoom, maxZoom, d3Zoom, d3Selection, fitViewOnInitDone, fitViewOnInit, nodeOrigin } = get();
  const isInitialFitView = options.initial && !fitViewOnInitDone && fitViewOnInit;
  const d3initialized = d3Zoom && d3Selection;
  if (d3initialized && (isInitialFitView || !options.initial)) {
    const nodes = getNodes().filter((n) => {
      const isVisible = options.includeHiddenNodes ? n.width && n.height : !n.hidden;
      if (options.nodes?.length) {
        return isVisible && options.nodes.some((optionNode) => optionNode.id === n.id);
      }
      return isVisible;
    });
    const nodesInitialized = nodes.every((n) => n.width && n.height);
    if (nodes.length > 0 && nodesInitialized) {
      const bounds = getRectOfNodes(nodes, nodeOrigin);
      const [x, y, zoom2] = getTransformForBounds(bounds, width, height, options.minZoom ?? minZoom, options.maxZoom ?? maxZoom, options.padding ?? 0.1);
      const nextTransform = identity.translate(x, y).scale(zoom2);
      if (typeof options.duration === "number" && options.duration > 0) {
        d3Zoom.transform(getD3Transition(d3Selection, options.duration), nextTransform);
      } else {
        d3Zoom.transform(d3Selection, nextTransform);
      }
      return true;
    }
  }
  return false;
}
function handleControlledNodeSelectionChange(nodeChanges, nodeInternals) {
  nodeChanges.forEach((change) => {
    const node = nodeInternals.get(change.id);
    if (node) {
      nodeInternals.set(node.id, {
        ...node,
        [internalsSymbol]: node[internalsSymbol],
        selected: change.selected
      });
    }
  });
  return new Map(nodeInternals);
}
function handleControlledEdgeSelectionChange(edgeChanges, edges) {
  return edges.map((e) => {
    const change = edgeChanges.find((change2) => change2.id === e.id);
    if (change) {
      e.selected = change.selected;
    }
    return e;
  });
}
function updateNodesAndEdgesSelections({ changedNodes, changedEdges, get, set }) {
  const { nodeInternals, edges, onNodesChange, onEdgesChange, hasDefaultNodes, hasDefaultEdges } = get();
  if (changedNodes?.length) {
    if (hasDefaultNodes) {
      set({ nodeInternals: handleControlledNodeSelectionChange(changedNodes, nodeInternals) });
    }
    onNodesChange?.(changedNodes);
  }
  if (changedEdges?.length) {
    if (hasDefaultEdges) {
      set({ edges: handleControlledEdgeSelectionChange(changedEdges, edges) });
    }
    onEdgesChange?.(changedEdges);
  }
}
const noop = () => {
};
const initialViewportHelper = {
  zoomIn: noop,
  zoomOut: noop,
  zoomTo: noop,
  getZoom: () => 1,
  setViewport: noop,
  getViewport: () => ({ x: 0, y: 0, zoom: 1 }),
  fitView: () => false,
  setCenter: noop,
  fitBounds: noop,
  project: (position) => position,
  viewportInitialized: false
};
const selector$b = (s) => ({
  d3Zoom: s.d3Zoom,
  d3Selection: s.d3Selection
});
const useViewportHelper = () => {
  const store = useStoreApi();
  const { d3Zoom, d3Selection } = useStore(selector$b, shallow$1);
  const viewportHelperFunctions = reactExports.useMemo(() => {
    if (d3Selection && d3Zoom) {
      return {
        zoomIn: (options) => d3Zoom.scaleBy(getD3Transition(d3Selection, options?.duration), 1.2),
        zoomOut: (options) => d3Zoom.scaleBy(getD3Transition(d3Selection, options?.duration), 1 / 1.2),
        zoomTo: (zoomLevel, options) => d3Zoom.scaleTo(getD3Transition(d3Selection, options?.duration), zoomLevel),
        getZoom: () => store.getState().transform[2],
        setViewport: (transform, options) => {
          const [x, y, zoom2] = store.getState().transform;
          const nextTransform = identity.translate(transform.x ?? x, transform.y ?? y).scale(transform.zoom ?? zoom2);
          d3Zoom.transform(getD3Transition(d3Selection, options?.duration), nextTransform);
        },
        getViewport: () => {
          const [x, y, zoom2] = store.getState().transform;
          return { x, y, zoom: zoom2 };
        },
        fitView: (options) => fitView(store.getState, options),
        setCenter: (x, y, options) => {
          const { width, height, maxZoom } = store.getState();
          const nextZoom = typeof options?.zoom !== "undefined" ? options.zoom : maxZoom;
          const centerX = width / 2 - x * nextZoom;
          const centerY = height / 2 - y * nextZoom;
          const transform = identity.translate(centerX, centerY).scale(nextZoom);
          d3Zoom.transform(getD3Transition(d3Selection, options?.duration), transform);
        },
        fitBounds: (bounds, options) => {
          const { width, height, minZoom, maxZoom } = store.getState();
          const [x, y, zoom2] = getTransformForBounds(bounds, width, height, minZoom, maxZoom, options?.padding ?? 0.1);
          const transform = identity.translate(x, y).scale(zoom2);
          d3Zoom.transform(getD3Transition(d3Selection, options?.duration), transform);
        },
        project: (position) => {
          const { transform, snapToGrid, snapGrid } = store.getState();
          return pointToRendererPoint(position, transform, snapToGrid, snapGrid);
        },
        viewportInitialized: true
      };
    }
    return initialViewportHelper;
  }, [d3Zoom, d3Selection]);
  return viewportHelperFunctions;
};
function useReactFlow() {
  const viewportHelper = useViewportHelper();
  const store = useStoreApi();
  const getNodes = reactExports.useCallback(() => {
    return store.getState().getNodes().map((n) => ({ ...n }));
  }, []);
  const getNode = reactExports.useCallback((id) => {
    return store.getState().nodeInternals.get(id);
  }, []);
  const getEdges = reactExports.useCallback(() => {
    const { edges = [] } = store.getState();
    return edges.map((e) => ({ ...e }));
  }, []);
  const getEdge = reactExports.useCallback((id) => {
    const { edges = [] } = store.getState();
    return edges.find((e) => e.id === id);
  }, []);
  const setNodes = reactExports.useCallback((payload) => {
    const { getNodes: getNodes2, setNodes: setNodes2, hasDefaultNodes, onNodesChange } = store.getState();
    const nodes = getNodes2();
    const nextNodes = typeof payload === "function" ? payload(nodes) : payload;
    if (hasDefaultNodes) {
      setNodes2(nextNodes);
    } else if (onNodesChange) {
      const changes = nextNodes.length === 0 ? nodes.map((node) => ({ type: "remove", id: node.id })) : nextNodes.map((node) => ({ item: node, type: "reset" }));
      onNodesChange(changes);
    }
  }, []);
  const setEdges = reactExports.useCallback((payload) => {
    const { edges = [], setEdges: setEdges2, hasDefaultEdges, onEdgesChange } = store.getState();
    const nextEdges = typeof payload === "function" ? payload(edges) : payload;
    if (hasDefaultEdges) {
      setEdges2(nextEdges);
    } else if (onEdgesChange) {
      const changes = nextEdges.length === 0 ? edges.map((edge) => ({ type: "remove", id: edge.id })) : nextEdges.map((edge) => ({ item: edge, type: "reset" }));
      onEdgesChange(changes);
    }
  }, []);
  const addNodes = reactExports.useCallback((payload) => {
    const nodes = Array.isArray(payload) ? payload : [payload];
    const { getNodes: getNodes2, setNodes: setNodes2, hasDefaultNodes, onNodesChange } = store.getState();
    if (hasDefaultNodes) {
      const currentNodes = getNodes2();
      const nextNodes = [...currentNodes, ...nodes];
      setNodes2(nextNodes);
    } else if (onNodesChange) {
      const changes = nodes.map((node) => ({ item: node, type: "add" }));
      onNodesChange(changes);
    }
  }, []);
  const addEdges = reactExports.useCallback((payload) => {
    const nextEdges = Array.isArray(payload) ? payload : [payload];
    const { edges = [], setEdges: setEdges2, hasDefaultEdges, onEdgesChange } = store.getState();
    if (hasDefaultEdges) {
      setEdges2([...edges, ...nextEdges]);
    } else if (onEdgesChange) {
      const changes = nextEdges.map((edge) => ({ item: edge, type: "add" }));
      onEdgesChange(changes);
    }
  }, []);
  const toObject = reactExports.useCallback(() => {
    const { getNodes: getNodes2, edges = [], transform } = store.getState();
    const [x, y, zoom2] = transform;
    return {
      nodes: getNodes2().map((n) => ({ ...n })),
      edges: edges.map((e) => ({ ...e })),
      viewport: {
        x,
        y,
        zoom: zoom2
      }
    };
  }, []);
  const deleteElements = reactExports.useCallback(({ nodes: nodesDeleted, edges: edgesDeleted }) => {
    const { nodeInternals, getNodes: getNodes2, edges, hasDefaultNodes, hasDefaultEdges, onNodesDelete, onEdgesDelete, onNodesChange, onEdgesChange } = store.getState();
    const nodeIds = (nodesDeleted || []).map((node) => node.id);
    const edgeIds = (edgesDeleted || []).map((edge) => edge.id);
    const nodesToRemove = getNodes2().reduce((res, node) => {
      const parentHit = !nodeIds.includes(node.id) && node.parentNode && res.find((n) => n.id === node.parentNode);
      const deletable = typeof node.deletable === "boolean" ? node.deletable : true;
      if (deletable && (nodeIds.includes(node.id) || parentHit)) {
        res.push(node);
      }
      return res;
    }, []);
    const deletableEdges = edges.filter((e) => typeof e.deletable === "boolean" ? e.deletable : true);
    const initialHitEdges = deletableEdges.filter((e) => edgeIds.includes(e.id));
    if (nodesToRemove || initialHitEdges) {
      const connectedEdges = getConnectedEdges(nodesToRemove, deletableEdges);
      const edgesToRemove = [...initialHitEdges, ...connectedEdges];
      const edgeIdsToRemove = edgesToRemove.reduce((res, edge) => {
        if (!res.includes(edge.id)) {
          res.push(edge.id);
        }
        return res;
      }, []);
      if (hasDefaultEdges || hasDefaultNodes) {
        if (hasDefaultEdges) {
          store.setState({
            edges: edges.filter((e) => !edgeIdsToRemove.includes(e.id))
          });
        }
        if (hasDefaultNodes) {
          nodesToRemove.forEach((node) => {
            nodeInternals.delete(node.id);
          });
          store.setState({
            nodeInternals: new Map(nodeInternals)
          });
        }
      }
      if (edgeIdsToRemove.length > 0) {
        onEdgesDelete?.(edgesToRemove);
        if (onEdgesChange) {
          onEdgesChange(edgeIdsToRemove.map((id) => ({
            id,
            type: "remove"
          })));
        }
      }
      if (nodesToRemove.length > 0) {
        onNodesDelete?.(nodesToRemove);
        if (onNodesChange) {
          const nodeChanges = nodesToRemove.map((n) => ({ id: n.id, type: "remove" }));
          onNodesChange(nodeChanges);
        }
      }
    }
  }, []);
  const getNodeRect = reactExports.useCallback((nodeOrRect) => {
    const isRect = isRectObject(nodeOrRect);
    const node = isRect ? null : store.getState().nodeInternals.get(nodeOrRect.id);
    const nodeRect = isRect ? nodeOrRect : nodeToRect(node);
    return [nodeRect, node, isRect];
  }, []);
  const getIntersectingNodes = reactExports.useCallback((nodeOrRect, partially = true, nodes) => {
    const [nodeRect, node, isRect] = getNodeRect(nodeOrRect);
    if (!nodeRect) {
      return [];
    }
    return (nodes || store.getState().getNodes()).filter((n) => {
      if (!isRect && (n.id === node.id || !n.positionAbsolute)) {
        return false;
      }
      const currNodeRect = nodeToRect(n);
      const overlappingArea = getOverlappingArea(currNodeRect, nodeRect);
      const partiallyVisible = partially && overlappingArea > 0;
      return partiallyVisible || overlappingArea >= nodeOrRect.width * nodeOrRect.height;
    });
  }, []);
  const isNodeIntersecting = reactExports.useCallback((nodeOrRect, area, partially = true) => {
    const [nodeRect] = getNodeRect(nodeOrRect);
    if (!nodeRect) {
      return false;
    }
    const overlappingArea = getOverlappingArea(nodeRect, area);
    const partiallyVisible = partially && overlappingArea > 0;
    return partiallyVisible || overlappingArea >= nodeOrRect.width * nodeOrRect.height;
  }, []);
  return reactExports.useMemo(() => {
    return {
      ...viewportHelper,
      getNodes,
      getNode,
      getEdges,
      getEdge,
      setNodes,
      setEdges,
      addNodes,
      addEdges,
      toObject,
      deleteElements,
      getIntersectingNodes,
      isNodeIntersecting
    };
  }, [
    viewportHelper,
    getNodes,
    getNode,
    getEdges,
    getEdge,
    setNodes,
    setEdges,
    addNodes,
    addEdges,
    toObject,
    deleteElements,
    getIntersectingNodes,
    isNodeIntersecting
  ]);
}
const deleteKeyOptions = { actInsideInputWithModifier: false };
var useGlobalKeyHandler = ({ deleteKeyCode, multiSelectionKeyCode }) => {
  const store = useStoreApi();
  const { deleteElements } = useReactFlow();
  const deleteKeyPressed = useKeyPress(deleteKeyCode, deleteKeyOptions);
  const multiSelectionKeyPressed = useKeyPress(multiSelectionKeyCode);
  reactExports.useEffect(() => {
    if (deleteKeyPressed) {
      const { edges, getNodes } = store.getState();
      const selectedNodes = getNodes().filter((node) => node.selected);
      const selectedEdges = edges.filter((edge) => edge.selected);
      deleteElements({ nodes: selectedNodes, edges: selectedEdges });
      store.setState({ nodesSelectionActive: false });
    }
  }, [deleteKeyPressed]);
  reactExports.useEffect(() => {
    store.setState({ multiSelectionActive: multiSelectionKeyPressed });
  }, [multiSelectionKeyPressed]);
};
function useResizeHandler(rendererNode) {
  const store = useStoreApi();
  reactExports.useEffect(() => {
    let resizeObserver;
    const updateDimensions = () => {
      if (!rendererNode.current) {
        return;
      }
      const size = getDimensions(rendererNode.current);
      if (size.height === 0 || size.width === 0) {
        store.getState().onError?.("004", errorMessages["error004"]());
      }
      store.setState({ width: size.width || 500, height: size.height || 500 });
    };
    updateDimensions();
    window.addEventListener("resize", updateDimensions);
    if (rendererNode.current) {
      resizeObserver = new ResizeObserver(() => updateDimensions());
      resizeObserver.observe(rendererNode.current);
    }
    return () => {
      window.removeEventListener("resize", updateDimensions);
      if (resizeObserver && rendererNode.current) {
        resizeObserver.unobserve(rendererNode.current);
      }
    };
  }, []);
}
const containerStyle = {
  position: "absolute",
  width: "100%",
  height: "100%",
  top: 0,
  left: 0
};
const viewChanged = (prevViewport, eventTransform) => prevViewport.x !== eventTransform.x || prevViewport.y !== eventTransform.y || prevViewport.zoom !== eventTransform.k;
const eventToFlowTransform = (eventTransform) => ({
  x: eventTransform.x,
  y: eventTransform.y,
  zoom: eventTransform.k
});
const isWrappedWithClass = (event, className) => event.target.closest(`.${className}`);
const isRightClickPan = (panOnDrag, usedButton) => usedButton === 2 && Array.isArray(panOnDrag) && panOnDrag.includes(2);
const wheelDelta = (event) => {
  const factor = event.ctrlKey && isMacOs() ? 10 : 1;
  return -event.deltaY * (event.deltaMode === 1 ? 0.05 : event.deltaMode ? 1 : 2e-3) * factor;
};
const selector$a = (s) => ({
  d3Zoom: s.d3Zoom,
  d3Selection: s.d3Selection,
  d3ZoomHandler: s.d3ZoomHandler,
  userSelectionActive: s.userSelectionActive
});
const ZoomPane = ({ onMove, onMoveStart, onMoveEnd, onPaneContextMenu, zoomOnScroll = true, zoomOnPinch = true, panOnScroll = false, panOnScrollSpeed = 0.5, panOnScrollMode = PanOnScrollMode.Free, zoomOnDoubleClick = true, elementsSelectable, panOnDrag = true, defaultViewport, translateExtent, minZoom, maxZoom, zoomActivationKeyCode, preventScrolling = true, children, noWheelClassName, noPanClassName }) => {
  const timerId = reactExports.useRef();
  const store = useStoreApi();
  const isZoomingOrPanning = reactExports.useRef(false);
  const zoomedWithRightMouseButton = reactExports.useRef(false);
  const zoomPane = reactExports.useRef(null);
  const prevTransform = reactExports.useRef({ x: 0, y: 0, zoom: 0 });
  const { d3Zoom, d3Selection, d3ZoomHandler, userSelectionActive } = useStore(selector$a, shallow$1);
  const zoomActivationKeyPressed = useKeyPress(zoomActivationKeyCode);
  const mouseButton = reactExports.useRef(0);
  const isPanScrolling = reactExports.useRef(false);
  const panScrollTimeout = reactExports.useRef();
  useResizeHandler(zoomPane);
  reactExports.useEffect(() => {
    if (zoomPane.current) {
      const bbox = zoomPane.current.getBoundingClientRect();
      const d3ZoomInstance = zoom().scaleExtent([minZoom, maxZoom]).translateExtent(translateExtent);
      const selection = select(zoomPane.current).call(d3ZoomInstance);
      const updatedTransform = identity.translate(defaultViewport.x, defaultViewport.y).scale(clamp(defaultViewport.zoom, minZoom, maxZoom));
      const extent = [
        [0, 0],
        [bbox.width, bbox.height]
      ];
      const constrainedTransform = d3ZoomInstance.constrain()(updatedTransform, extent, translateExtent);
      d3ZoomInstance.transform(selection, constrainedTransform);
      d3ZoomInstance.wheelDelta(wheelDelta);
      store.setState({
        d3Zoom: d3ZoomInstance,
        d3Selection: selection,
        d3ZoomHandler: selection.on("wheel.zoom"),
        // we need to pass transform because zoom handler is not registered when we set the initial transform
        transform: [constrainedTransform.x, constrainedTransform.y, constrainedTransform.k],
        domNode: zoomPane.current.closest(".react-flow")
      });
    }
  }, []);
  reactExports.useEffect(() => {
    if (d3Selection && d3Zoom) {
      if (panOnScroll && !zoomActivationKeyPressed && !userSelectionActive) {
        d3Selection.on("wheel.zoom", (event) => {
          if (isWrappedWithClass(event, noWheelClassName)) {
            return false;
          }
          event.preventDefault();
          event.stopImmediatePropagation();
          const currentZoom = d3Selection.property("__zoom").k || 1;
          const _isMacOs = isMacOs();
          if (event.ctrlKey && zoomOnPinch && _isMacOs) {
            const point = pointer(event);
            const pinchDelta = wheelDelta(event);
            const zoom2 = currentZoom * Math.pow(2, pinchDelta);
            d3Zoom.scaleTo(d3Selection, zoom2, point, event);
            return;
          }
          const deltaNormalize = event.deltaMode === 1 ? 20 : 1;
          let deltaX = panOnScrollMode === PanOnScrollMode.Vertical ? 0 : event.deltaX * deltaNormalize;
          let deltaY = panOnScrollMode === PanOnScrollMode.Horizontal ? 0 : event.deltaY * deltaNormalize;
          if (!_isMacOs && event.shiftKey && panOnScrollMode !== PanOnScrollMode.Vertical) {
            deltaX = event.deltaY * deltaNormalize;
            deltaY = 0;
          }
          d3Zoom.translateBy(
            d3Selection,
            -(deltaX / currentZoom) * panOnScrollSpeed,
            -(deltaY / currentZoom) * panOnScrollSpeed,
            // @ts-ignore
            { internal: true }
          );
          const nextViewport = eventToFlowTransform(d3Selection.property("__zoom"));
          const { onViewportChangeStart, onViewportChange, onViewportChangeEnd } = store.getState();
          clearTimeout(panScrollTimeout.current);
          if (!isPanScrolling.current) {
            isPanScrolling.current = true;
            onMoveStart?.(event, nextViewport);
            onViewportChangeStart?.(nextViewport);
          }
          if (isPanScrolling.current) {
            onMove?.(event, nextViewport);
            onViewportChange?.(nextViewport);
            panScrollTimeout.current = setTimeout(() => {
              onMoveEnd?.(event, nextViewport);
              onViewportChangeEnd?.(nextViewport);
              isPanScrolling.current = false;
            }, 150);
          }
        }, { passive: false });
      } else if (typeof d3ZoomHandler !== "undefined") {
        d3Selection.on("wheel.zoom", function(event, d) {
          if (!preventScrolling || isWrappedWithClass(event, noWheelClassName)) {
            return null;
          }
          event.preventDefault();
          d3ZoomHandler.call(this, event, d);
        }, { passive: false });
      }
    }
  }, [
    userSelectionActive,
    panOnScroll,
    panOnScrollMode,
    d3Selection,
    d3Zoom,
    d3ZoomHandler,
    zoomActivationKeyPressed,
    zoomOnPinch,
    preventScrolling,
    noWheelClassName,
    onMoveStart,
    onMove,
    onMoveEnd
  ]);
  reactExports.useEffect(() => {
    if (d3Zoom) {
      d3Zoom.on("start", (event) => {
        if (!event.sourceEvent || event.sourceEvent.internal) {
          return null;
        }
        mouseButton.current = event.sourceEvent?.button;
        const { onViewportChangeStart } = store.getState();
        const flowTransform = eventToFlowTransform(event.transform);
        isZoomingOrPanning.current = true;
        prevTransform.current = flowTransform;
        if (event.sourceEvent?.type === "mousedown") {
          store.setState({ paneDragging: true });
        }
        onViewportChangeStart?.(flowTransform);
        onMoveStart?.(event.sourceEvent, flowTransform);
      });
    }
  }, [d3Zoom, onMoveStart]);
  reactExports.useEffect(() => {
    if (d3Zoom) {
      if (userSelectionActive && !isZoomingOrPanning.current) {
        d3Zoom.on("zoom", null);
      } else if (!userSelectionActive) {
        d3Zoom.on("zoom", (event) => {
          const { onViewportChange } = store.getState();
          store.setState({ transform: [event.transform.x, event.transform.y, event.transform.k] });
          zoomedWithRightMouseButton.current = !!(onPaneContextMenu && isRightClickPan(panOnDrag, mouseButton.current ?? 0));
          if ((onMove || onViewportChange) && !event.sourceEvent?.internal) {
            const flowTransform = eventToFlowTransform(event.transform);
            onViewportChange?.(flowTransform);
            onMove?.(event.sourceEvent, flowTransform);
          }
        });
      }
    }
  }, [userSelectionActive, d3Zoom, onMove, panOnDrag, onPaneContextMenu]);
  reactExports.useEffect(() => {
    if (d3Zoom) {
      d3Zoom.on("end", (event) => {
        if (!event.sourceEvent || event.sourceEvent.internal) {
          return null;
        }
        const { onViewportChangeEnd } = store.getState();
        isZoomingOrPanning.current = false;
        store.setState({ paneDragging: false });
        if (onPaneContextMenu && isRightClickPan(panOnDrag, mouseButton.current ?? 0) && !zoomedWithRightMouseButton.current) {
          onPaneContextMenu(event.sourceEvent);
        }
        zoomedWithRightMouseButton.current = false;
        if ((onMoveEnd || onViewportChangeEnd) && viewChanged(prevTransform.current, event.transform)) {
          const flowTransform = eventToFlowTransform(event.transform);
          prevTransform.current = flowTransform;
          clearTimeout(timerId.current);
          timerId.current = setTimeout(() => {
            onViewportChangeEnd?.(flowTransform);
            onMoveEnd?.(event.sourceEvent, flowTransform);
          }, panOnScroll ? 150 : 0);
        }
      });
    }
  }, [d3Zoom, panOnScroll, panOnDrag, onMoveEnd, onPaneContextMenu]);
  reactExports.useEffect(() => {
    if (d3Zoom) {
      d3Zoom.filter((event) => {
        const zoomScroll = zoomActivationKeyPressed || zoomOnScroll;
        const pinchZoom = zoomOnPinch && event.ctrlKey;
        if ((panOnDrag === true || Array.isArray(panOnDrag) && panOnDrag.includes(1)) && event.button === 1 && event.type === "mousedown" && (isWrappedWithClass(event, "react-flow__node") || isWrappedWithClass(event, "react-flow__edge"))) {
          return true;
        }
        if (!panOnDrag && !zoomScroll && !panOnScroll && !zoomOnDoubleClick && !zoomOnPinch) {
          return false;
        }
        if (userSelectionActive) {
          return false;
        }
        if (!zoomOnDoubleClick && event.type === "dblclick") {
          return false;
        }
        if (isWrappedWithClass(event, noWheelClassName) && event.type === "wheel") {
          return false;
        }
        if (isWrappedWithClass(event, noPanClassName) && (event.type !== "wheel" || panOnScroll && event.type === "wheel")) {
          return false;
        }
        if (!zoomOnPinch && event.ctrlKey && event.type === "wheel") {
          return false;
        }
        if (!zoomScroll && !panOnScroll && !pinchZoom && event.type === "wheel") {
          return false;
        }
        if (!panOnDrag && (event.type === "mousedown" || event.type === "touchstart")) {
          return false;
        }
        if (Array.isArray(panOnDrag) && !panOnDrag.includes(event.button) && (event.type === "mousedown" || event.type === "touchstart")) {
          return false;
        }
        const buttonAllowed = Array.isArray(panOnDrag) && panOnDrag.includes(event.button) || !event.button || event.button <= 1;
        return (!event.ctrlKey || event.type === "wheel") && buttonAllowed;
      });
    }
  }, [
    userSelectionActive,
    d3Zoom,
    zoomOnScroll,
    zoomOnPinch,
    panOnScroll,
    zoomOnDoubleClick,
    panOnDrag,
    elementsSelectable,
    zoomActivationKeyPressed
  ]);
  return React.createElement("div", { className: "react-flow__renderer", ref: zoomPane, style: containerStyle }, children);
};
const selector$9 = (s) => ({
  userSelectionActive: s.userSelectionActive,
  userSelectionRect: s.userSelectionRect
});
function UserSelection() {
  const { userSelectionActive, userSelectionRect } = useStore(selector$9, shallow$1);
  const isActive = userSelectionActive && userSelectionRect;
  if (!isActive) {
    return null;
  }
  return React.createElement("div", { className: "react-flow__selection react-flow__container", style: {
    width: userSelectionRect.width,
    height: userSelectionRect.height,
    transform: `translate(${userSelectionRect.x}px, ${userSelectionRect.y}px)`
  } });
}
function handleParentExpand(res, updateItem) {
  const parent = res.find((e) => e.id === updateItem.parentNode);
  if (parent) {
    const extendWidth = updateItem.position.x + updateItem.width - parent.width;
    const extendHeight = updateItem.position.y + updateItem.height - parent.height;
    if (extendWidth > 0 || extendHeight > 0 || updateItem.position.x < 0 || updateItem.position.y < 0) {
      parent.style = { ...parent.style };
      parent.style.width = parent.style.width ?? parent.width;
      parent.style.height = parent.style.height ?? parent.height;
      if (extendWidth > 0) {
        parent.style.width += extendWidth;
      }
      if (extendHeight > 0) {
        parent.style.height += extendHeight;
      }
      if (updateItem.position.x < 0) {
        const xDiff = Math.abs(updateItem.position.x);
        parent.position.x = parent.position.x - xDiff;
        parent.style.width += xDiff;
        updateItem.position.x = 0;
      }
      if (updateItem.position.y < 0) {
        const yDiff = Math.abs(updateItem.position.y);
        parent.position.y = parent.position.y - yDiff;
        parent.style.height += yDiff;
        updateItem.position.y = 0;
      }
      parent.width = parent.style.width;
      parent.height = parent.style.height;
    }
  }
}
function applyChanges(changes, elements) {
  if (changes.some((c) => c.type === "reset")) {
    return changes.filter((c) => c.type === "reset").map((c) => c.item);
  }
  const initElements = changes.filter((c) => c.type === "add").map((c) => c.item);
  return elements.reduce((res, item) => {
    const currentChanges = changes.filter((c) => c.id === item.id);
    if (currentChanges.length === 0) {
      res.push(item);
      return res;
    }
    const updateItem = { ...item };
    for (const currentChange of currentChanges) {
      if (currentChange) {
        switch (currentChange.type) {
          case "select": {
            updateItem.selected = currentChange.selected;
            break;
          }
          case "position": {
            if (typeof currentChange.position !== "undefined") {
              updateItem.position = currentChange.position;
            }
            if (typeof currentChange.positionAbsolute !== "undefined") {
              updateItem.positionAbsolute = currentChange.positionAbsolute;
            }
            if (typeof currentChange.dragging !== "undefined") {
              updateItem.dragging = currentChange.dragging;
            }
            if (updateItem.expandParent) {
              handleParentExpand(res, updateItem);
            }
            break;
          }
          case "dimensions": {
            if (typeof currentChange.dimensions !== "undefined") {
              updateItem.width = currentChange.dimensions.width;
              updateItem.height = currentChange.dimensions.height;
            }
            if (typeof currentChange.updateStyle !== "undefined") {
              updateItem.style = { ...updateItem.style || {}, ...currentChange.dimensions };
            }
            if (typeof currentChange.resizing === "boolean") {
              updateItem.resizing = currentChange.resizing;
            }
            if (updateItem.expandParent) {
              handleParentExpand(res, updateItem);
            }
            break;
          }
          case "remove": {
            return res;
          }
        }
      }
    }
    res.push(updateItem);
    return res;
  }, initElements);
}
function applyNodeChanges(changes, nodes) {
  return applyChanges(changes, nodes);
}
function applyEdgeChanges(changes, edges) {
  return applyChanges(changes, edges);
}
const createSelectionChange = (id, selected) => ({
  id,
  type: "select",
  selected
});
function getSelectionChanges(items, selectedIds) {
  return items.reduce((res, item) => {
    const willBeSelected = selectedIds.includes(item.id);
    if (!item.selected && willBeSelected) {
      item.selected = true;
      res.push(createSelectionChange(item.id, true));
    } else if (item.selected && !willBeSelected) {
      item.selected = false;
      res.push(createSelectionChange(item.id, false));
    }
    return res;
  }, []);
}
const wrapHandler = (handler, containerRef) => {
  return (event) => {
    if (event.target !== containerRef.current) {
      return;
    }
    handler?.(event);
  };
};
const selector$8 = (s) => ({
  userSelectionActive: s.userSelectionActive,
  elementsSelectable: s.elementsSelectable,
  dragging: s.paneDragging
});
const Pane = reactExports.memo(({ isSelecting, selectionMode = SelectionMode.Full, panOnDrag, onSelectionStart, onSelectionEnd, onPaneClick, onPaneContextMenu, onPaneScroll, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, children }) => {
  const container = reactExports.useRef(null);
  const store = useStoreApi();
  const prevSelectedNodesCount = reactExports.useRef(0);
  const prevSelectedEdgesCount = reactExports.useRef(0);
  const containerBounds = reactExports.useRef();
  const { userSelectionActive, elementsSelectable, dragging } = useStore(selector$8, shallow$1);
  const resetUserSelection = () => {
    store.setState({ userSelectionActive: false, userSelectionRect: null });
    prevSelectedNodesCount.current = 0;
    prevSelectedEdgesCount.current = 0;
  };
  const onClick = (event) => {
    onPaneClick?.(event);
    store.getState().resetSelectedElements();
    store.setState({ nodesSelectionActive: false });
  };
  const onContextMenu = (event) => {
    if (Array.isArray(panOnDrag) && panOnDrag?.includes(2)) {
      event.preventDefault();
      return;
    }
    onPaneContextMenu?.(event);
  };
  const onWheel = onPaneScroll ? (event) => onPaneScroll(event) : void 0;
  const onMouseDown = (event) => {
    const { resetSelectedElements, domNode } = store.getState();
    containerBounds.current = domNode?.getBoundingClientRect();
    if (!elementsSelectable || !isSelecting || event.button !== 0 || event.target !== container.current || !containerBounds.current) {
      return;
    }
    const { x, y } = getEventPosition(event, containerBounds.current);
    resetSelectedElements();
    store.setState({
      userSelectionRect: {
        width: 0,
        height: 0,
        startX: x,
        startY: y,
        x,
        y
      }
    });
    onSelectionStart?.(event);
  };
  const onMouseMove = (event) => {
    const { userSelectionRect, nodeInternals, edges, transform, onNodesChange, onEdgesChange, nodeOrigin, getNodes } = store.getState();
    if (!isSelecting || !containerBounds.current || !userSelectionRect) {
      return;
    }
    store.setState({ userSelectionActive: true, nodesSelectionActive: false });
    const mousePos = getEventPosition(event, containerBounds.current);
    const startX = userSelectionRect.startX ?? 0;
    const startY = userSelectionRect.startY ?? 0;
    const nextUserSelectRect = {
      ...userSelectionRect,
      x: mousePos.x < startX ? mousePos.x : startX,
      y: mousePos.y < startY ? mousePos.y : startY,
      width: Math.abs(mousePos.x - startX),
      height: Math.abs(mousePos.y - startY)
    };
    const nodes = getNodes();
    const selectedNodes = getNodesInside(nodeInternals, nextUserSelectRect, transform, selectionMode === SelectionMode.Partial, true, nodeOrigin);
    const selectedEdgeIds = getConnectedEdges(selectedNodes, edges).map((e) => e.id);
    const selectedNodeIds = selectedNodes.map((n) => n.id);
    if (prevSelectedNodesCount.current !== selectedNodeIds.length) {
      prevSelectedNodesCount.current = selectedNodeIds.length;
      const changes = getSelectionChanges(nodes, selectedNodeIds);
      if (changes.length) {
        onNodesChange?.(changes);
      }
    }
    if (prevSelectedEdgesCount.current !== selectedEdgeIds.length) {
      prevSelectedEdgesCount.current = selectedEdgeIds.length;
      const changes = getSelectionChanges(edges, selectedEdgeIds);
      if (changes.length) {
        onEdgesChange?.(changes);
      }
    }
    store.setState({
      userSelectionRect: nextUserSelectRect
    });
  };
  const onMouseUp = (event) => {
    if (event.button !== 0) {
      return;
    }
    const { userSelectionRect } = store.getState();
    if (!userSelectionActive && userSelectionRect && event.target === container.current) {
      onClick?.(event);
    }
    store.setState({ nodesSelectionActive: prevSelectedNodesCount.current > 0 });
    resetUserSelection();
    onSelectionEnd?.(event);
  };
  const onMouseLeave = (event) => {
    if (userSelectionActive) {
      store.setState({ nodesSelectionActive: prevSelectedNodesCount.current > 0 });
      onSelectionEnd?.(event);
    }
    resetUserSelection();
  };
  const hasActiveSelection = elementsSelectable && (isSelecting || userSelectionActive);
  return React.createElement(
    "div",
    { className: cc(["react-flow__pane", { dragging, selection: isSelecting }]), onClick: hasActiveSelection ? void 0 : wrapHandler(onClick, container), onContextMenu: wrapHandler(onContextMenu, container), onWheel: wrapHandler(onWheel, container), onMouseEnter: hasActiveSelection ? void 0 : onPaneMouseEnter, onMouseDown: hasActiveSelection ? onMouseDown : void 0, onMouseMove: hasActiveSelection ? onMouseMove : onPaneMouseMove, onMouseUp: hasActiveSelection ? onMouseUp : void 0, onMouseLeave: hasActiveSelection ? onMouseLeave : onPaneMouseLeave, ref: container, style: containerStyle },
    children,
    React.createElement(UserSelection, null)
  );
});
Pane.displayName = "Pane";
function isParentSelected(node, nodeInternals) {
  if (!node.parentNode) {
    return false;
  }
  const parentNode = nodeInternals.get(node.parentNode);
  if (!parentNode) {
    return false;
  }
  if (parentNode.selected) {
    return true;
  }
  return isParentSelected(parentNode, nodeInternals);
}
function hasSelector(target, selector2, nodeRef) {
  let current = target;
  do {
    if (current?.matches(selector2))
      return true;
    if (current === nodeRef.current)
      return false;
    current = current.parentElement;
  } while (current);
  return false;
}
function getDragItems(nodeInternals, nodesDraggable, mousePos, nodeId) {
  return Array.from(nodeInternals.values()).filter((n) => (n.selected || n.id === nodeId) && (!n.parentNode || !isParentSelected(n, nodeInternals)) && (n.draggable || nodesDraggable && typeof n.draggable === "undefined")).map((n) => ({
    id: n.id,
    position: n.position || { x: 0, y: 0 },
    positionAbsolute: n.positionAbsolute || { x: 0, y: 0 },
    distance: {
      x: mousePos.x - (n.positionAbsolute?.x ?? 0),
      y: mousePos.y - (n.positionAbsolute?.y ?? 0)
    },
    delta: {
      x: 0,
      y: 0
    },
    extent: n.extent,
    parentNode: n.parentNode,
    width: n.width,
    height: n.height,
    expandParent: n.expandParent
  }));
}
function clampNodeExtent(node, extent) {
  if (!extent || extent === "parent") {
    return extent;
  }
  return [extent[0], [extent[1][0] - (node.width || 0), extent[1][1] - (node.height || 0)]];
}
function calcNextPosition(node, nextPosition, nodeInternals, nodeExtent, nodeOrigin = [0, 0], onError) {
  const clampedNodeExtent = clampNodeExtent(node, node.extent || nodeExtent);
  let currentExtent = clampedNodeExtent;
  if (node.extent === "parent" && !node.expandParent) {
    if (node.parentNode && node.width && node.height) {
      const parent = nodeInternals.get(node.parentNode);
      const { x: parentX, y: parentY } = getNodePositionWithOrigin(parent, nodeOrigin).positionAbsolute;
      currentExtent = parent && isNumeric(parentX) && isNumeric(parentY) && isNumeric(parent.width) && isNumeric(parent.height) ? [
        [parentX + node.width * nodeOrigin[0], parentY + node.height * nodeOrigin[1]],
        [
          parentX + parent.width - node.width + node.width * nodeOrigin[0],
          parentY + parent.height - node.height + node.height * nodeOrigin[1]
        ]
      ] : currentExtent;
    } else {
      onError?.("005", errorMessages["error005"]());
      currentExtent = clampedNodeExtent;
    }
  } else if (node.extent && node.parentNode && node.extent !== "parent") {
    const parent = nodeInternals.get(node.parentNode);
    const { x: parentX, y: parentY } = getNodePositionWithOrigin(parent, nodeOrigin).positionAbsolute;
    currentExtent = [
      [node.extent[0][0] + parentX, node.extent[0][1] + parentY],
      [node.extent[1][0] + parentX, node.extent[1][1] + parentY]
    ];
  }
  let parentPosition = { x: 0, y: 0 };
  if (node.parentNode) {
    const parentNode = nodeInternals.get(node.parentNode);
    parentPosition = getNodePositionWithOrigin(parentNode, nodeOrigin).positionAbsolute;
  }
  const positionAbsolute = currentExtent && currentExtent !== "parent" ? clampPosition(nextPosition, currentExtent) : nextPosition;
  return {
    position: {
      x: positionAbsolute.x - parentPosition.x,
      y: positionAbsolute.y - parentPosition.y
    },
    positionAbsolute
  };
}
function getEventHandlerParams({ nodeId, dragItems, nodeInternals }) {
  const extentedDragItems = dragItems.map((n) => {
    const node = nodeInternals.get(n.id);
    return {
      ...node,
      position: n.position,
      positionAbsolute: n.positionAbsolute
    };
  });
  return [nodeId ? extentedDragItems.find((n) => n.id === nodeId) : extentedDragItems[0], extentedDragItems];
}
const getHandleBounds = (selector2, nodeElement, zoom2, nodeOrigin) => {
  const handles = nodeElement.querySelectorAll(selector2);
  if (!handles || !handles.length) {
    return null;
  }
  const handlesArray = Array.from(handles);
  const nodeBounds = nodeElement.getBoundingClientRect();
  const nodeOffset = {
    x: nodeBounds.width * nodeOrigin[0],
    y: nodeBounds.height * nodeOrigin[1]
  };
  return handlesArray.map((handle) => {
    const handleBounds = handle.getBoundingClientRect();
    return {
      id: handle.getAttribute("data-handleid"),
      position: handle.getAttribute("data-handlepos"),
      x: (handleBounds.left - nodeBounds.left - nodeOffset.x) / zoom2,
      y: (handleBounds.top - nodeBounds.top - nodeOffset.y) / zoom2,
      ...getDimensions(handle)
    };
  });
};
function getMouseHandler(id, getState, handler) {
  return handler === void 0 ? handler : (event) => {
    const node = getState().nodeInternals.get(id);
    if (node) {
      handler(event, { ...node });
    }
  };
}
function handleNodeClick({ id, store, unselect = false, nodeRef }) {
  const { addSelectedNodes, unselectNodesAndEdges, multiSelectionActive, nodeInternals, onError } = store.getState();
  const node = nodeInternals.get(id);
  if (!node) {
    onError?.("012", errorMessages["error012"](id));
    return;
  }
  store.setState({ nodesSelectionActive: false });
  if (!node.selected) {
    addSelectedNodes([id]);
  } else if (unselect || node.selected && multiSelectionActive) {
    unselectNodesAndEdges({ nodes: [node], edges: [] });
    requestAnimationFrame(() => nodeRef?.current?.blur());
  }
}
function useGetPointerPosition() {
  const store = useStoreApi();
  const getPointerPosition = reactExports.useCallback(({ sourceEvent }) => {
    const { transform, snapGrid, snapToGrid } = store.getState();
    const x = sourceEvent.touches ? sourceEvent.touches[0].clientX : sourceEvent.clientX;
    const y = sourceEvent.touches ? sourceEvent.touches[0].clientY : sourceEvent.clientY;
    const pointerPos = {
      x: (x - transform[0]) / transform[2],
      y: (y - transform[1]) / transform[2]
    };
    return {
      xSnapped: snapToGrid ? snapGrid[0] * Math.round(pointerPos.x / snapGrid[0]) : pointerPos.x,
      ySnapped: snapToGrid ? snapGrid[1] * Math.round(pointerPos.y / snapGrid[1]) : pointerPos.y,
      ...pointerPos
    };
  }, []);
  return getPointerPosition;
}
function wrapSelectionDragFunc(selectionFunc) {
  return (event, _, nodes) => selectionFunc?.(event, nodes);
}
function useDrag({ nodeRef, disabled = false, noDragClassName, handleSelector, nodeId, isSelectable, selectNodesOnDrag }) {
  const store = useStoreApi();
  const [dragging, setDragging] = reactExports.useState(false);
  const dragItems = reactExports.useRef([]);
  const lastPos = reactExports.useRef({ x: null, y: null });
  const autoPanId = reactExports.useRef(0);
  const containerBounds = reactExports.useRef(null);
  const mousePosition = reactExports.useRef({ x: 0, y: 0 });
  const dragEvent = reactExports.useRef(null);
  const autoPanStarted = reactExports.useRef(false);
  const dragStarted = reactExports.useRef(false);
  const getPointerPosition = useGetPointerPosition();
  reactExports.useEffect(() => {
    if (nodeRef?.current) {
      const selection = select(nodeRef.current);
      const updateNodes = ({ x, y }) => {
        const { nodeInternals, onNodeDrag, onSelectionDrag, updateNodePositions, nodeExtent, snapGrid, snapToGrid, nodeOrigin, onError } = store.getState();
        lastPos.current = { x, y };
        let hasChange = false;
        let nodesBox = { x: 0, y: 0, x2: 0, y2: 0 };
        if (dragItems.current.length > 1 && nodeExtent) {
          const rect = getRectOfNodes(dragItems.current, nodeOrigin);
          nodesBox = rectToBox(rect);
        }
        dragItems.current = dragItems.current.map((n) => {
          const nextPosition = { x: x - n.distance.x, y: y - n.distance.y };
          if (snapToGrid) {
            nextPosition.x = snapGrid[0] * Math.round(nextPosition.x / snapGrid[0]);
            nextPosition.y = snapGrid[1] * Math.round(nextPosition.y / snapGrid[1]);
          }
          const adjustedNodeExtent = [
            [nodeExtent[0][0], nodeExtent[0][1]],
            [nodeExtent[1][0], nodeExtent[1][1]]
          ];
          if (dragItems.current.length > 1 && nodeExtent && !n.extent) {
            adjustedNodeExtent[0][0] = n.positionAbsolute.x - nodesBox.x + nodeExtent[0][0];
            adjustedNodeExtent[1][0] = n.positionAbsolute.x + (n.width ?? 0) - nodesBox.x2 + nodeExtent[1][0];
            adjustedNodeExtent[0][1] = n.positionAbsolute.y - nodesBox.y + nodeExtent[0][1];
            adjustedNodeExtent[1][1] = n.positionAbsolute.y + (n.height ?? 0) - nodesBox.y2 + nodeExtent[1][1];
          }
          const updatedPos = calcNextPosition(n, nextPosition, nodeInternals, adjustedNodeExtent, nodeOrigin, onError);
          hasChange = hasChange || n.position.x !== updatedPos.position.x || n.position.y !== updatedPos.position.y;
          n.position = updatedPos.position;
          n.positionAbsolute = updatedPos.positionAbsolute;
          return n;
        });
        if (!hasChange) {
          return;
        }
        updateNodePositions(dragItems.current, true, true);
        setDragging(true);
        const onDrag = nodeId ? onNodeDrag : wrapSelectionDragFunc(onSelectionDrag);
        if (onDrag && dragEvent.current) {
          const [currentNode, nodes] = getEventHandlerParams({
            nodeId,
            dragItems: dragItems.current,
            nodeInternals
          });
          onDrag(dragEvent.current, currentNode, nodes);
        }
      };
      const autoPan = () => {
        if (!containerBounds.current) {
          return;
        }
        const [xMovement, yMovement] = calcAutoPan(mousePosition.current, containerBounds.current);
        if (xMovement !== 0 || yMovement !== 0) {
          const { transform, panBy } = store.getState();
          lastPos.current.x = (lastPos.current.x ?? 0) - xMovement / transform[2];
          lastPos.current.y = (lastPos.current.y ?? 0) - yMovement / transform[2];
          if (panBy({ x: xMovement, y: yMovement })) {
            updateNodes(lastPos.current);
          }
        }
        autoPanId.current = requestAnimationFrame(autoPan);
      };
      const startDrag = (event) => {
        const { nodeInternals, multiSelectionActive, nodesDraggable, unselectNodesAndEdges, onNodeDragStart, onSelectionDragStart } = store.getState();
        dragStarted.current = true;
        const onStart = nodeId ? onNodeDragStart : wrapSelectionDragFunc(onSelectionDragStart);
        if ((!selectNodesOnDrag || !isSelectable) && !multiSelectionActive && nodeId) {
          if (!nodeInternals.get(nodeId)?.selected) {
            unselectNodesAndEdges();
          }
        }
        if (nodeId && isSelectable && selectNodesOnDrag) {
          handleNodeClick({
            id: nodeId,
            store,
            nodeRef
          });
        }
        const pointerPos = getPointerPosition(event);
        lastPos.current = pointerPos;
        dragItems.current = getDragItems(nodeInternals, nodesDraggable, pointerPos, nodeId);
        if (onStart && dragItems.current) {
          const [currentNode, nodes] = getEventHandlerParams({
            nodeId,
            dragItems: dragItems.current,
            nodeInternals
          });
          onStart(event.sourceEvent, currentNode, nodes);
        }
      };
      if (disabled) {
        selection.on(".drag", null);
      } else {
        const dragHandler = drag().on("start", (event) => {
          const { domNode, nodeDragThreshold } = store.getState();
          if (nodeDragThreshold === 0) {
            startDrag(event);
          }
          const pointerPos = getPointerPosition(event);
          lastPos.current = pointerPos;
          containerBounds.current = domNode?.getBoundingClientRect() || null;
          mousePosition.current = getEventPosition(event.sourceEvent, containerBounds.current);
        }).on("drag", (event) => {
          const pointerPos = getPointerPosition(event);
          const { autoPanOnNodeDrag, nodeDragThreshold } = store.getState();
          if (!autoPanStarted.current && dragStarted.current && autoPanOnNodeDrag) {
            autoPanStarted.current = true;
            autoPan();
          }
          if (!dragStarted.current) {
            const x = pointerPos.xSnapped - (lastPos?.current?.x ?? 0);
            const y = pointerPos.ySnapped - (lastPos?.current?.y ?? 0);
            const distance2 = Math.sqrt(x * x + y * y);
            if (distance2 > nodeDragThreshold) {
              startDrag(event);
            }
          }
          if ((lastPos.current.x !== pointerPos.xSnapped || lastPos.current.y !== pointerPos.ySnapped) && dragItems.current && dragStarted.current) {
            dragEvent.current = event.sourceEvent;
            mousePosition.current = getEventPosition(event.sourceEvent, containerBounds.current);
            updateNodes(pointerPos);
          }
        }).on("end", (event) => {
          if (!dragStarted.current) {
            return;
          }
          setDragging(false);
          autoPanStarted.current = false;
          dragStarted.current = false;
          cancelAnimationFrame(autoPanId.current);
          if (dragItems.current) {
            const { updateNodePositions, nodeInternals, onNodeDragStop, onSelectionDragStop } = store.getState();
            const onStop = nodeId ? onNodeDragStop : wrapSelectionDragFunc(onSelectionDragStop);
            updateNodePositions(dragItems.current, false, false);
            if (onStop) {
              const [currentNode, nodes] = getEventHandlerParams({
                nodeId,
                dragItems: dragItems.current,
                nodeInternals
              });
              onStop(event.sourceEvent, currentNode, nodes);
            }
          }
        }).filter((event) => {
          const target = event.target;
          const isDraggable = !event.button && (!noDragClassName || !hasSelector(target, `.${noDragClassName}`, nodeRef)) && (!handleSelector || hasSelector(target, handleSelector, nodeRef));
          return isDraggable;
        });
        selection.call(dragHandler);
        return () => {
          selection.on(".drag", null);
        };
      }
    }
  }, [
    nodeRef,
    disabled,
    noDragClassName,
    handleSelector,
    isSelectable,
    store,
    nodeId,
    selectNodesOnDrag,
    getPointerPosition
  ]);
  return dragging;
}
function useUpdateNodePositions() {
  const store = useStoreApi();
  const updatePositions = reactExports.useCallback((params) => {
    const { nodeInternals, nodeExtent, updateNodePositions, getNodes, snapToGrid, snapGrid, onError, nodesDraggable } = store.getState();
    const selectedNodes = getNodes().filter((n) => n.selected && (n.draggable || nodesDraggable && typeof n.draggable === "undefined"));
    const xVelo = snapToGrid ? snapGrid[0] : 5;
    const yVelo = snapToGrid ? snapGrid[1] : 5;
    const factor = params.isShiftPressed ? 4 : 1;
    const positionDiffX = params.x * xVelo * factor;
    const positionDiffY = params.y * yVelo * factor;
    const nodeUpdates = selectedNodes.map((n) => {
      if (n.positionAbsolute) {
        const nextPosition = { x: n.positionAbsolute.x + positionDiffX, y: n.positionAbsolute.y + positionDiffY };
        if (snapToGrid) {
          nextPosition.x = snapGrid[0] * Math.round(nextPosition.x / snapGrid[0]);
          nextPosition.y = snapGrid[1] * Math.round(nextPosition.y / snapGrid[1]);
        }
        const { positionAbsolute, position } = calcNextPosition(n, nextPosition, nodeInternals, nodeExtent, void 0, onError);
        n.position = position;
        n.positionAbsolute = positionAbsolute;
      }
      return n;
    });
    updateNodePositions(nodeUpdates, true, false);
  }, []);
  return updatePositions;
}
const arrowKeyDiffs = {
  ArrowUp: { x: 0, y: -1 },
  ArrowDown: { x: 0, y: 1 },
  ArrowLeft: { x: -1, y: 0 },
  ArrowRight: { x: 1, y: 0 }
};
var wrapNode = (NodeComponent) => {
  const NodeWrapper = ({ id, type, data, xPos, yPos, xPosOrigin, yPosOrigin, selected, onClick, onMouseEnter, onMouseMove, onMouseLeave, onContextMenu, onDoubleClick, style: style2, className, isDraggable, isSelectable, isConnectable, isFocusable, selectNodesOnDrag, sourcePosition, targetPosition, hidden, resizeObserver, dragHandle, zIndex, isParent, noDragClassName, noPanClassName, initialized, disableKeyboardA11y, ariaLabel, rfId }) => {
    const store = useStoreApi();
    const nodeRef = reactExports.useRef(null);
    const prevSourcePosition = reactExports.useRef(sourcePosition);
    const prevTargetPosition = reactExports.useRef(targetPosition);
    const prevType = reactExports.useRef(type);
    const hasPointerEvents = isSelectable || isDraggable || onClick || onMouseEnter || onMouseMove || onMouseLeave;
    const updatePositions = useUpdateNodePositions();
    const onMouseEnterHandler = getMouseHandler(id, store.getState, onMouseEnter);
    const onMouseMoveHandler = getMouseHandler(id, store.getState, onMouseMove);
    const onMouseLeaveHandler = getMouseHandler(id, store.getState, onMouseLeave);
    const onContextMenuHandler = getMouseHandler(id, store.getState, onContextMenu);
    const onDoubleClickHandler = getMouseHandler(id, store.getState, onDoubleClick);
    const onSelectNodeHandler = (event) => {
      const { nodeDragThreshold } = store.getState();
      if (isSelectable && (!selectNodesOnDrag || !isDraggable || nodeDragThreshold > 0)) {
        handleNodeClick({
          id,
          store,
          nodeRef
        });
      }
      if (onClick) {
        const node = store.getState().nodeInternals.get(id);
        if (node) {
          onClick(event, { ...node });
        }
      }
    };
    const onKeyDown = (event) => {
      if (isInputDOMNode(event)) {
        return;
      }
      if (elementSelectionKeys.includes(event.key) && isSelectable) {
        const unselect = event.key === "Escape";
        handleNodeClick({
          id,
          store,
          unselect,
          nodeRef
        });
      } else if (!disableKeyboardA11y && isDraggable && selected && Object.prototype.hasOwnProperty.call(arrowKeyDiffs, event.key)) {
        store.setState({
          ariaLiveMessage: `Moved selected node ${event.key.replace("Arrow", "").toLowerCase()}. New position, x: ${~~xPos}, y: ${~~yPos}`
        });
        updatePositions({
          x: arrowKeyDiffs[event.key].x,
          y: arrowKeyDiffs[event.key].y,
          isShiftPressed: event.shiftKey
        });
      }
    };
    reactExports.useEffect(() => {
      if (nodeRef.current && !hidden) {
        const currNode = nodeRef.current;
        resizeObserver?.observe(currNode);
        return () => resizeObserver?.unobserve(currNode);
      }
    }, [hidden]);
    reactExports.useEffect(() => {
      const typeChanged = prevType.current !== type;
      const sourcePosChanged = prevSourcePosition.current !== sourcePosition;
      const targetPosChanged = prevTargetPosition.current !== targetPosition;
      if (nodeRef.current && (typeChanged || sourcePosChanged || targetPosChanged)) {
        if (typeChanged) {
          prevType.current = type;
        }
        if (sourcePosChanged) {
          prevSourcePosition.current = sourcePosition;
        }
        if (targetPosChanged) {
          prevTargetPosition.current = targetPosition;
        }
        store.getState().updateNodeDimensions([{ id, nodeElement: nodeRef.current, forceUpdate: true }]);
      }
    }, [id, type, sourcePosition, targetPosition]);
    const dragging = useDrag({
      nodeRef,
      disabled: hidden || !isDraggable,
      noDragClassName,
      handleSelector: dragHandle,
      nodeId: id,
      isSelectable,
      selectNodesOnDrag
    });
    if (hidden) {
      return null;
    }
    return React.createElement(
      "div",
      { className: cc([
        "react-flow__node",
        `react-flow__node-${type}`,
        {
          // this is overwritable by passing `nopan` as a class name
          [noPanClassName]: isDraggable
        },
        className,
        {
          selected,
          selectable: isSelectable,
          parent: isParent,
          dragging
        }
      ]), ref: nodeRef, style: {
        zIndex,
        transform: `translate(${xPosOrigin}px,${yPosOrigin}px)`,
        pointerEvents: hasPointerEvents ? "all" : "none",
        visibility: initialized ? "visible" : "hidden",
        ...style2
      }, "data-id": id, "data-testid": `rf__node-${id}`, onMouseEnter: onMouseEnterHandler, onMouseMove: onMouseMoveHandler, onMouseLeave: onMouseLeaveHandler, onContextMenu: onContextMenuHandler, onClick: onSelectNodeHandler, onDoubleClick: onDoubleClickHandler, onKeyDown: isFocusable ? onKeyDown : void 0, tabIndex: isFocusable ? 0 : void 0, role: isFocusable ? "button" : void 0, "aria-describedby": disableKeyboardA11y ? void 0 : `${ARIA_NODE_DESC_KEY}-${rfId}`, "aria-label": ariaLabel },
      React.createElement(
        Provider,
        { value: id },
        React.createElement(NodeComponent, { id, data, type, xPos, yPos, selected, isConnectable, sourcePosition, targetPosition, dragging, dragHandle, zIndex })
      )
    );
  };
  NodeWrapper.displayName = "NodeWrapper";
  return reactExports.memo(NodeWrapper);
};
const selector$7 = (s) => {
  const selectedNodes = s.getNodes().filter((n) => n.selected);
  return {
    ...getRectOfNodes(selectedNodes, s.nodeOrigin),
    transformString: `translate(${s.transform[0]}px,${s.transform[1]}px) scale(${s.transform[2]})`,
    userSelectionActive: s.userSelectionActive
  };
};
function NodesSelection({ onSelectionContextMenu, noPanClassName, disableKeyboardA11y }) {
  const store = useStoreApi();
  const { width, height, x: left, y: top, transformString, userSelectionActive } = useStore(selector$7, shallow$1);
  const updatePositions = useUpdateNodePositions();
  const nodeRef = reactExports.useRef(null);
  reactExports.useEffect(() => {
    if (!disableKeyboardA11y) {
      nodeRef.current?.focus({
        preventScroll: true
      });
    }
  }, [disableKeyboardA11y]);
  useDrag({
    nodeRef
  });
  if (userSelectionActive || !width || !height) {
    return null;
  }
  const onContextMenu = onSelectionContextMenu ? (event) => {
    const selectedNodes = store.getState().getNodes().filter((n) => n.selected);
    onSelectionContextMenu(event, selectedNodes);
  } : void 0;
  const onKeyDown = (event) => {
    if (Object.prototype.hasOwnProperty.call(arrowKeyDiffs, event.key)) {
      updatePositions({
        x: arrowKeyDiffs[event.key].x,
        y: arrowKeyDiffs[event.key].y,
        isShiftPressed: event.shiftKey
      });
    }
  };
  return React.createElement(
    "div",
    { className: cc(["react-flow__nodesselection", "react-flow__container", noPanClassName]), style: {
      transform: transformString
    } },
    React.createElement("div", { ref: nodeRef, className: "react-flow__nodesselection-rect", onContextMenu, tabIndex: disableKeyboardA11y ? void 0 : -1, onKeyDown: disableKeyboardA11y ? void 0 : onKeyDown, style: {
      width,
      height,
      top,
      left
    } })
  );
}
var NodesSelection$1 = reactExports.memo(NodesSelection);
const selector$6 = (s) => s.nodesSelectionActive;
const FlowRenderer = ({ children, onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneContextMenu, onPaneScroll, deleteKeyCode, onMove, onMoveStart, onMoveEnd, selectionKeyCode, selectionOnDrag, selectionMode, onSelectionStart, onSelectionEnd, multiSelectionKeyCode, panActivationKeyCode, zoomActivationKeyCode, elementsSelectable, zoomOnScroll, zoomOnPinch, panOnScroll, panOnScrollSpeed, panOnScrollMode, zoomOnDoubleClick, panOnDrag: _panOnDrag, defaultViewport, translateExtent, minZoom, maxZoom, preventScrolling, onSelectionContextMenu, noWheelClassName, noPanClassName, disableKeyboardA11y }) => {
  const nodesSelectionActive = useStore(selector$6);
  const selectionKeyPressed = useKeyPress(selectionKeyCode);
  const panActivationKeyPressed = useKeyPress(panActivationKeyCode);
  const panOnDrag = panActivationKeyPressed || _panOnDrag;
  const isSelecting = selectionKeyPressed || selectionOnDrag && panOnDrag !== true;
  useGlobalKeyHandler({ deleteKeyCode, multiSelectionKeyCode });
  return React.createElement(
    ZoomPane,
    { onMove, onMoveStart, onMoveEnd, onPaneContextMenu, elementsSelectable, zoomOnScroll, zoomOnPinch, panOnScroll, panOnScrollSpeed, panOnScrollMode, zoomOnDoubleClick, panOnDrag: !selectionKeyPressed && panOnDrag, defaultViewport, translateExtent, minZoom, maxZoom, zoomActivationKeyCode, preventScrolling, noWheelClassName, noPanClassName },
    React.createElement(
      Pane,
      { onSelectionStart, onSelectionEnd, onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneContextMenu, onPaneScroll, panOnDrag, isSelecting: !!isSelecting, selectionMode },
      children,
      nodesSelectionActive && React.createElement(NodesSelection$1, { onSelectionContextMenu, noPanClassName, disableKeyboardA11y })
    )
  );
};
FlowRenderer.displayName = "FlowRenderer";
var FlowRenderer$1 = reactExports.memo(FlowRenderer);
function useVisibleNodes(onlyRenderVisible) {
  const nodes = useStore(reactExports.useCallback((s) => onlyRenderVisible ? getNodesInside(s.nodeInternals, { x: 0, y: 0, width: s.width, height: s.height }, s.transform, true) : s.getNodes(), [onlyRenderVisible]));
  return nodes;
}
function createNodeTypes(nodeTypes) {
  const standardTypes = {
    input: wrapNode(nodeTypes.input || InputNode$1),
    default: wrapNode(nodeTypes.default || DefaultNode$1),
    output: wrapNode(nodeTypes.output || OutputNode$1),
    group: wrapNode(nodeTypes.group || GroupNode)
  };
  const wrappedTypes = {};
  const specialTypes = Object.keys(nodeTypes).filter((k) => !["input", "default", "output", "group"].includes(k)).reduce((res, key) => {
    res[key] = wrapNode(nodeTypes[key] || DefaultNode$1);
    return res;
  }, wrappedTypes);
  return {
    ...standardTypes,
    ...specialTypes
  };
}
const getPositionWithOrigin = ({ x, y, width, height, origin }) => {
  if (!width || !height) {
    return { x, y };
  }
  if (origin[0] < 0 || origin[1] < 0 || origin[0] > 1 || origin[1] > 1) {
    return { x, y };
  }
  return {
    x: x - width * origin[0],
    y: y - height * origin[1]
  };
};
const selector$5 = (s) => ({
  nodesDraggable: s.nodesDraggable,
  nodesConnectable: s.nodesConnectable,
  nodesFocusable: s.nodesFocusable,
  elementsSelectable: s.elementsSelectable,
  updateNodeDimensions: s.updateNodeDimensions,
  onError: s.onError
});
const NodeRenderer = (props) => {
  const { nodesDraggable, nodesConnectable, nodesFocusable, elementsSelectable, updateNodeDimensions, onError } = useStore(selector$5, shallow$1);
  const nodes = useVisibleNodes(props.onlyRenderVisibleElements);
  const resizeObserverRef = reactExports.useRef();
  const resizeObserver = reactExports.useMemo(() => {
    if (typeof ResizeObserver === "undefined") {
      return null;
    }
    const observer = new ResizeObserver((entries) => {
      const updates = entries.map((entry) => ({
        id: entry.target.getAttribute("data-id"),
        nodeElement: entry.target,
        forceUpdate: true
      }));
      updateNodeDimensions(updates);
    });
    resizeObserverRef.current = observer;
    return observer;
  }, []);
  reactExports.useEffect(() => {
    return () => {
      resizeObserverRef?.current?.disconnect();
    };
  }, []);
  return React.createElement("div", { className: "react-flow__nodes", style: containerStyle }, nodes.map((node) => {
    let nodeType = node.type || "default";
    if (!props.nodeTypes[nodeType]) {
      onError?.("003", errorMessages["error003"](nodeType));
      nodeType = "default";
    }
    const NodeComponent = props.nodeTypes[nodeType] || props.nodeTypes.default;
    const isDraggable = !!(node.draggable || nodesDraggable && typeof node.draggable === "undefined");
    const isSelectable = !!(node.selectable || elementsSelectable && typeof node.selectable === "undefined");
    const isConnectable = !!(node.connectable || nodesConnectable && typeof node.connectable === "undefined");
    const isFocusable = !!(node.focusable || nodesFocusable && typeof node.focusable === "undefined");
    const clampedPosition = props.nodeExtent ? clampPosition(node.positionAbsolute, props.nodeExtent) : node.positionAbsolute;
    const posX = clampedPosition?.x ?? 0;
    const posY = clampedPosition?.y ?? 0;
    const posOrigin = getPositionWithOrigin({
      x: posX,
      y: posY,
      width: node.width ?? 0,
      height: node.height ?? 0,
      origin: props.nodeOrigin
    });
    return React.createElement(NodeComponent, { key: node.id, id: node.id, className: node.className, style: node.style, type: nodeType, data: node.data, sourcePosition: node.sourcePosition || Position.Bottom, targetPosition: node.targetPosition || Position.Top, hidden: node.hidden, xPos: posX, yPos: posY, xPosOrigin: posOrigin.x, yPosOrigin: posOrigin.y, selectNodesOnDrag: props.selectNodesOnDrag, onClick: props.onNodeClick, onMouseEnter: props.onNodeMouseEnter, onMouseMove: props.onNodeMouseMove, onMouseLeave: props.onNodeMouseLeave, onContextMenu: props.onNodeContextMenu, onDoubleClick: props.onNodeDoubleClick, selected: !!node.selected, isDraggable, isSelectable, isConnectable, isFocusable, resizeObserver, dragHandle: node.dragHandle, zIndex: node[internalsSymbol]?.z ?? 0, isParent: !!node[internalsSymbol]?.isParent, noDragClassName: props.noDragClassName, noPanClassName: props.noPanClassName, initialized: !!node.width && !!node.height, rfId: props.rfId, disableKeyboardA11y: props.disableKeyboardA11y, ariaLabel: node.ariaLabel });
  }));
};
NodeRenderer.displayName = "NodeRenderer";
var NodeRenderer$1 = reactExports.memo(NodeRenderer);
const shiftX = (x, shift, position) => {
  if (position === Position.Left)
    return x - shift;
  if (position === Position.Right)
    return x + shift;
  return x;
};
const shiftY = (y, shift, position) => {
  if (position === Position.Top)
    return y - shift;
  if (position === Position.Bottom)
    return y + shift;
  return y;
};
const EdgeUpdaterClassName = "react-flow__edgeupdater";
const EdgeAnchor = ({ position, centerX, centerY, radius = 10, onMouseDown, onMouseEnter, onMouseOut, type }) => React.createElement("circle", { onMouseDown, onMouseEnter, onMouseOut, className: cc([EdgeUpdaterClassName, `${EdgeUpdaterClassName}-${type}`]), cx: shiftX(centerX, radius, position), cy: shiftY(centerY, radius, position), r: radius, stroke: "transparent", fill: "transparent" });
const alwaysValidConnection = () => true;
var wrapEdge = (EdgeComponent) => {
  const EdgeWrapper = ({ id, className, type, data, onClick, onEdgeDoubleClick, selected, animated, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, style: style2, source, target, sourceX, sourceY, targetX, targetY, sourcePosition, targetPosition, elementsSelectable, hidden, sourceHandleId, targetHandleId, onContextMenu, onMouseEnter, onMouseMove, onMouseLeave, edgeUpdaterRadius, onEdgeUpdate, onEdgeUpdateStart, onEdgeUpdateEnd, markerEnd, markerStart, rfId, ariaLabel, isFocusable, isUpdatable, pathOptions, interactionWidth }) => {
    const edgeRef = reactExports.useRef(null);
    const [updateHover, setUpdateHover] = reactExports.useState(false);
    const [updating, setUpdating] = reactExports.useState(false);
    const store = useStoreApi();
    const markerStartUrl = reactExports.useMemo(() => `url(#${getMarkerId(markerStart, rfId)})`, [markerStart, rfId]);
    const markerEndUrl = reactExports.useMemo(() => `url(#${getMarkerId(markerEnd, rfId)})`, [markerEnd, rfId]);
    if (hidden) {
      return null;
    }
    const onEdgeClick = (event) => {
      const { edges, addSelectedEdges, unselectNodesAndEdges, multiSelectionActive } = store.getState();
      const edge = edges.find((e) => e.id === id);
      if (!edge) {
        return;
      }
      if (elementsSelectable) {
        store.setState({ nodesSelectionActive: false });
        if (edge.selected && multiSelectionActive) {
          unselectNodesAndEdges({ nodes: [], edges: [edge] });
          edgeRef.current?.blur();
        } else {
          addSelectedEdges([id]);
        }
      }
      if (onClick) {
        onClick(event, edge);
      }
    };
    const onEdgeDoubleClickHandler = getMouseHandler$1(id, store.getState, onEdgeDoubleClick);
    const onEdgeContextMenu = getMouseHandler$1(id, store.getState, onContextMenu);
    const onEdgeMouseEnter = getMouseHandler$1(id, store.getState, onMouseEnter);
    const onEdgeMouseMove = getMouseHandler$1(id, store.getState, onMouseMove);
    const onEdgeMouseLeave = getMouseHandler$1(id, store.getState, onMouseLeave);
    const handleEdgeUpdater = (event, isSourceHandle) => {
      if (event.button !== 0) {
        return;
      }
      const { edges, isValidConnection: isValidConnectionStore } = store.getState();
      const nodeId = isSourceHandle ? target : source;
      const handleId = (isSourceHandle ? targetHandleId : sourceHandleId) || null;
      const handleType = isSourceHandle ? "target" : "source";
      const isValidConnection = isValidConnectionStore || alwaysValidConnection;
      const isTarget = isSourceHandle;
      const edge = edges.find((e) => e.id === id);
      setUpdating(true);
      onEdgeUpdateStart?.(event, edge, handleType);
      const _onEdgeUpdateEnd = (evt) => {
        setUpdating(false);
        onEdgeUpdateEnd?.(evt, edge, handleType);
      };
      const onConnectEdge = (connection) => onEdgeUpdate?.(edge, connection);
      handlePointerDown({
        event,
        handleId,
        nodeId,
        onConnect: onConnectEdge,
        isTarget,
        getState: store.getState,
        setState: store.setState,
        isValidConnection,
        edgeUpdaterType: handleType,
        onEdgeUpdateEnd: _onEdgeUpdateEnd
      });
    };
    const onEdgeUpdaterSourceMouseDown = (event) => handleEdgeUpdater(event, true);
    const onEdgeUpdaterTargetMouseDown = (event) => handleEdgeUpdater(event, false);
    const onEdgeUpdaterMouseEnter = () => setUpdateHover(true);
    const onEdgeUpdaterMouseOut = () => setUpdateHover(false);
    const inactive = !elementsSelectable && !onClick;
    const onKeyDown = (event) => {
      if (elementSelectionKeys.includes(event.key) && elementsSelectable) {
        const { unselectNodesAndEdges, addSelectedEdges, edges } = store.getState();
        const unselect = event.key === "Escape";
        if (unselect) {
          edgeRef.current?.blur();
          unselectNodesAndEdges({ edges: [edges.find((e) => e.id === id)] });
        } else {
          addSelectedEdges([id]);
        }
      }
    };
    return React.createElement(
      "g",
      { className: cc([
        "react-flow__edge",
        `react-flow__edge-${type}`,
        className,
        { selected, animated, inactive, updating: updateHover }
      ]), onClick: onEdgeClick, onDoubleClick: onEdgeDoubleClickHandler, onContextMenu: onEdgeContextMenu, onMouseEnter: onEdgeMouseEnter, onMouseMove: onEdgeMouseMove, onMouseLeave: onEdgeMouseLeave, onKeyDown: isFocusable ? onKeyDown : void 0, tabIndex: isFocusable ? 0 : void 0, role: isFocusable ? "button" : "img", "data-testid": `rf__edge-${id}`, "aria-label": ariaLabel === null ? void 0 : ariaLabel ? ariaLabel : `Edge from ${source} to ${target}`, "aria-describedby": isFocusable ? `${ARIA_EDGE_DESC_KEY}-${rfId}` : void 0, ref: edgeRef },
      !updating && React.createElement(EdgeComponent, { id, source, target, selected, animated, label, labelStyle, labelShowBg, labelBgStyle, labelBgPadding, labelBgBorderRadius, data, style: style2, sourceX, sourceY, targetX, targetY, sourcePosition, targetPosition, sourceHandleId, targetHandleId, markerStart: markerStartUrl, markerEnd: markerEndUrl, pathOptions, interactionWidth }),
      isUpdatable && React.createElement(
        React.Fragment,
        null,
        (isUpdatable === "source" || isUpdatable === true) && React.createElement(EdgeAnchor, { position: sourcePosition, centerX: sourceX, centerY: sourceY, radius: edgeUpdaterRadius, onMouseDown: onEdgeUpdaterSourceMouseDown, onMouseEnter: onEdgeUpdaterMouseEnter, onMouseOut: onEdgeUpdaterMouseOut, type: "source" }),
        (isUpdatable === "target" || isUpdatable === true) && React.createElement(EdgeAnchor, { position: targetPosition, centerX: targetX, centerY: targetY, radius: edgeUpdaterRadius, onMouseDown: onEdgeUpdaterTargetMouseDown, onMouseEnter: onEdgeUpdaterMouseEnter, onMouseOut: onEdgeUpdaterMouseOut, type: "target" })
      )
    );
  };
  EdgeWrapper.displayName = "EdgeWrapper";
  return reactExports.memo(EdgeWrapper);
};
function createEdgeTypes(edgeTypes) {
  const standardTypes = {
    default: wrapEdge(edgeTypes.default || BezierEdge),
    straight: wrapEdge(edgeTypes.bezier || StraightEdge),
    step: wrapEdge(edgeTypes.step || StepEdge),
    smoothstep: wrapEdge(edgeTypes.step || SmoothStepEdge),
    simplebezier: wrapEdge(edgeTypes.simplebezier || SimpleBezierEdge)
  };
  const wrappedTypes = {};
  const specialTypes = Object.keys(edgeTypes).filter((k) => !["default", "bezier"].includes(k)).reduce((res, key) => {
    res[key] = wrapEdge(edgeTypes[key] || BezierEdge);
    return res;
  }, wrappedTypes);
  return {
    ...standardTypes,
    ...specialTypes
  };
}
function getHandlePosition(position, nodeRect, handle = null) {
  const x = (handle?.x || 0) + nodeRect.x;
  const y = (handle?.y || 0) + nodeRect.y;
  const width = handle?.width || nodeRect.width;
  const height = handle?.height || nodeRect.height;
  switch (position) {
    case Position.Top:
      return {
        x: x + width / 2,
        y
      };
    case Position.Right:
      return {
        x: x + width,
        y: y + height / 2
      };
    case Position.Bottom:
      return {
        x: x + width / 2,
        y: y + height
      };
    case Position.Left:
      return {
        x,
        y: y + height / 2
      };
  }
}
function getHandle(bounds, handleId) {
  if (!bounds) {
    return null;
  }
  if (bounds.length === 1 || !handleId) {
    return bounds[0];
  } else if (handleId) {
    return bounds.find((d) => d.id === handleId) || null;
  }
  return null;
}
const getEdgePositions = (sourceNodeRect, sourceHandle, sourcePosition, targetNodeRect, targetHandle, targetPosition) => {
  const sourceHandlePos = getHandlePosition(sourcePosition, sourceNodeRect, sourceHandle);
  const targetHandlePos = getHandlePosition(targetPosition, targetNodeRect, targetHandle);
  return {
    sourceX: sourceHandlePos.x,
    sourceY: sourceHandlePos.y,
    targetX: targetHandlePos.x,
    targetY: targetHandlePos.y
  };
};
function isEdgeVisible({ sourcePos, targetPos, sourceWidth, sourceHeight, targetWidth, targetHeight, width, height, transform }) {
  const edgeBox = {
    x: Math.min(sourcePos.x, targetPos.x),
    y: Math.min(sourcePos.y, targetPos.y),
    x2: Math.max(sourcePos.x + sourceWidth, targetPos.x + targetWidth),
    y2: Math.max(sourcePos.y + sourceHeight, targetPos.y + targetHeight)
  };
  if (edgeBox.x === edgeBox.x2) {
    edgeBox.x2 += 1;
  }
  if (edgeBox.y === edgeBox.y2) {
    edgeBox.y2 += 1;
  }
  const viewBox = rectToBox({
    x: (0 - transform[0]) / transform[2],
    y: (0 - transform[1]) / transform[2],
    width: width / transform[2],
    height: height / transform[2]
  });
  const xOverlap = Math.max(0, Math.min(viewBox.x2, edgeBox.x2) - Math.max(viewBox.x, edgeBox.x));
  const yOverlap = Math.max(0, Math.min(viewBox.y2, edgeBox.y2) - Math.max(viewBox.y, edgeBox.y));
  const overlappingArea = Math.ceil(xOverlap * yOverlap);
  return overlappingArea > 0;
}
function getNodeData(node) {
  const handleBounds = node?.[internalsSymbol]?.handleBounds || null;
  const isValid = handleBounds && node?.width && node?.height && typeof node?.positionAbsolute?.x !== "undefined" && typeof node?.positionAbsolute?.y !== "undefined";
  return [
    {
      x: node?.positionAbsolute?.x || 0,
      y: node?.positionAbsolute?.y || 0,
      width: node?.width || 0,
      height: node?.height || 0
    },
    handleBounds,
    !!isValid
  ];
}
const defaultEdgeTree = [{ level: 0, isMaxLevel: true, edges: [] }];
function groupEdgesByZLevel(edges, nodeInternals, elevateEdgesOnSelect = false) {
  let maxLevel = -1;
  const levelLookup = edges.reduce((tree, edge) => {
    const hasZIndex = isNumeric(edge.zIndex);
    let z = hasZIndex ? edge.zIndex : 0;
    if (elevateEdgesOnSelect) {
      const targetNode = nodeInternals.get(edge.target);
      const sourceNode = nodeInternals.get(edge.source);
      const edgeOrConnectedNodeSelected = edge.selected || targetNode?.selected || sourceNode?.selected;
      const selectedZIndex = Math.max(sourceNode?.[internalsSymbol]?.z || 0, targetNode?.[internalsSymbol]?.z || 0, 1e3);
      z = (hasZIndex ? edge.zIndex : 0) + (edgeOrConnectedNodeSelected ? selectedZIndex : 0);
    }
    if (tree[z]) {
      tree[z].push(edge);
    } else {
      tree[z] = [edge];
    }
    maxLevel = z > maxLevel ? z : maxLevel;
    return tree;
  }, {});
  const edgeTree = Object.entries(levelLookup).map(([key, edges2]) => {
    const level = +key;
    return {
      edges: edges2,
      level,
      isMaxLevel: level === maxLevel
    };
  });
  if (edgeTree.length === 0) {
    return defaultEdgeTree;
  }
  return edgeTree;
}
function useVisibleEdges(onlyRenderVisible, nodeInternals, elevateEdgesOnSelect) {
  const edges = useStore(reactExports.useCallback((s) => {
    if (!onlyRenderVisible) {
      return s.edges;
    }
    return s.edges.filter((e) => {
      const sourceNode = nodeInternals.get(e.source);
      const targetNode = nodeInternals.get(e.target);
      return sourceNode?.width && sourceNode?.height && targetNode?.width && targetNode?.height && isEdgeVisible({
        sourcePos: sourceNode.positionAbsolute || { x: 0, y: 0 },
        targetPos: targetNode.positionAbsolute || { x: 0, y: 0 },
        sourceWidth: sourceNode.width,
        sourceHeight: sourceNode.height,
        targetWidth: targetNode.width,
        targetHeight: targetNode.height,
        width: s.width,
        height: s.height,
        transform: s.transform
      });
    });
  }, [onlyRenderVisible, nodeInternals]));
  return groupEdgesByZLevel(edges, nodeInternals, elevateEdgesOnSelect);
}
const ArrowSymbol = ({ color = "none", strokeWidth = 1 }) => {
  return React.createElement("polyline", { style: {
    stroke: color,
    strokeWidth
  }, strokeLinecap: "round", strokeLinejoin: "round", fill: "none", points: "-5,-4 0,0 -5,4" });
};
const ArrowClosedSymbol = ({ color = "none", strokeWidth = 1 }) => {
  return React.createElement("polyline", { style: {
    stroke: color,
    fill: color,
    strokeWidth
  }, strokeLinecap: "round", strokeLinejoin: "round", points: "-5,-4 0,0 -5,4 -5,-4" });
};
const MarkerSymbols = {
  [MarkerType.Arrow]: ArrowSymbol,
  [MarkerType.ArrowClosed]: ArrowClosedSymbol
};
function useMarkerSymbol(type) {
  const store = useStoreApi();
  const symbol = reactExports.useMemo(() => {
    const symbolExists = Object.prototype.hasOwnProperty.call(MarkerSymbols, type);
    if (!symbolExists) {
      store.getState().onError?.("009", errorMessages["error009"](type));
      return null;
    }
    return MarkerSymbols[type];
  }, [type]);
  return symbol;
}
const Marker = ({ id, type, color, width = 12.5, height = 12.5, markerUnits = "strokeWidth", strokeWidth, orient = "auto-start-reverse" }) => {
  const Symbol2 = useMarkerSymbol(type);
  if (!Symbol2) {
    return null;
  }
  return React.createElement(
    "marker",
    { className: "react-flow__arrowhead", id, markerWidth: `${width}`, markerHeight: `${height}`, viewBox: "-10 -10 20 20", markerUnits, orient, refX: "0", refY: "0" },
    React.createElement(Symbol2, { color, strokeWidth })
  );
};
const markerSelector = ({ defaultColor, rfId }) => (s) => {
  const ids = [];
  return s.edges.reduce((markers, edge) => {
    [edge.markerStart, edge.markerEnd].forEach((marker) => {
      if (marker && typeof marker === "object") {
        const markerId = getMarkerId(marker, rfId);
        if (!ids.includes(markerId)) {
          markers.push({ id: markerId, color: marker.color || defaultColor, ...marker });
          ids.push(markerId);
        }
      }
    });
    return markers;
  }, []).sort((a, b) => a.id.localeCompare(b.id));
};
const MarkerDefinitions = ({ defaultColor, rfId }) => {
  const markers = useStore(
    reactExports.useCallback(markerSelector({ defaultColor, rfId }), [defaultColor, rfId]),
    // the id includes all marker options, so we just need to look at that part of the marker
    (a, b) => !(a.length !== b.length || a.some((m, i) => m.id !== b[i].id))
  );
  return React.createElement("defs", null, markers.map((marker) => React.createElement(Marker, { id: marker.id, key: marker.id, type: marker.type, color: marker.color, width: marker.width, height: marker.height, markerUnits: marker.markerUnits, strokeWidth: marker.strokeWidth, orient: marker.orient })));
};
MarkerDefinitions.displayName = "MarkerDefinitions";
var MarkerDefinitions$1 = reactExports.memo(MarkerDefinitions);
const selector$4 = (s) => ({
  nodesConnectable: s.nodesConnectable,
  edgesFocusable: s.edgesFocusable,
  edgesUpdatable: s.edgesUpdatable,
  elementsSelectable: s.elementsSelectable,
  width: s.width,
  height: s.height,
  connectionMode: s.connectionMode,
  nodeInternals: s.nodeInternals,
  onError: s.onError
});
const EdgeRenderer = ({ defaultMarkerColor, onlyRenderVisibleElements, elevateEdgesOnSelect, rfId, edgeTypes, noPanClassName, onEdgeUpdate, onEdgeContextMenu, onEdgeMouseEnter, onEdgeMouseMove, onEdgeMouseLeave, onEdgeClick, edgeUpdaterRadius, onEdgeDoubleClick, onEdgeUpdateStart, onEdgeUpdateEnd, children }) => {
  const { edgesFocusable, edgesUpdatable, elementsSelectable, width, height, connectionMode, nodeInternals, onError } = useStore(selector$4, shallow$1);
  const edgeTree = useVisibleEdges(onlyRenderVisibleElements, nodeInternals, elevateEdgesOnSelect);
  if (!width) {
    return null;
  }
  return React.createElement(
    React.Fragment,
    null,
    edgeTree.map(({ level, edges, isMaxLevel }) => React.createElement(
      "svg",
      { key: level, style: { zIndex: level }, width, height, className: "react-flow__edges react-flow__container" },
      isMaxLevel && React.createElement(MarkerDefinitions$1, { defaultColor: defaultMarkerColor, rfId }),
      React.createElement("g", null, edges.map((edge) => {
        const [sourceNodeRect, sourceHandleBounds, sourceIsValid] = getNodeData(nodeInternals.get(edge.source));
        const [targetNodeRect, targetHandleBounds, targetIsValid] = getNodeData(nodeInternals.get(edge.target));
        if (!sourceIsValid || !targetIsValid) {
          return null;
        }
        let edgeType = edge.type || "default";
        if (!edgeTypes[edgeType]) {
          onError?.("011", errorMessages["error011"](edgeType));
          edgeType = "default";
        }
        const EdgeComponent = edgeTypes[edgeType] || edgeTypes.default;
        const targetNodeHandles = connectionMode === ConnectionMode.Strict ? targetHandleBounds.target : (targetHandleBounds.target ?? []).concat(targetHandleBounds.source ?? []);
        const sourceHandle = getHandle(sourceHandleBounds.source, edge.sourceHandle);
        const targetHandle = getHandle(targetNodeHandles, edge.targetHandle);
        const sourcePosition = sourceHandle?.position || Position.Bottom;
        const targetPosition = targetHandle?.position || Position.Top;
        const isFocusable = !!(edge.focusable || edgesFocusable && typeof edge.focusable === "undefined");
        const isUpdatable = typeof onEdgeUpdate !== "undefined" && (edge.updatable || edgesUpdatable && typeof edge.updatable === "undefined");
        if (!sourceHandle || !targetHandle) {
          onError?.("008", errorMessages["error008"](sourceHandle, edge));
          return null;
        }
        const { sourceX, sourceY, targetX, targetY } = getEdgePositions(sourceNodeRect, sourceHandle, sourcePosition, targetNodeRect, targetHandle, targetPosition);
        return React.createElement(EdgeComponent, { key: edge.id, id: edge.id, className: cc([edge.className, noPanClassName]), type: edgeType, data: edge.data, selected: !!edge.selected, animated: !!edge.animated, hidden: !!edge.hidden, label: edge.label, labelStyle: edge.labelStyle, labelShowBg: edge.labelShowBg, labelBgStyle: edge.labelBgStyle, labelBgPadding: edge.labelBgPadding, labelBgBorderRadius: edge.labelBgBorderRadius, style: edge.style, source: edge.source, target: edge.target, sourceHandleId: edge.sourceHandle, targetHandleId: edge.targetHandle, markerEnd: edge.markerEnd, markerStart: edge.markerStart, sourceX, sourceY, targetX, targetY, sourcePosition, targetPosition, elementsSelectable, onEdgeUpdate, onContextMenu: onEdgeContextMenu, onMouseEnter: onEdgeMouseEnter, onMouseMove: onEdgeMouseMove, onMouseLeave: onEdgeMouseLeave, onClick: onEdgeClick, edgeUpdaterRadius, onEdgeDoubleClick, onEdgeUpdateStart, onEdgeUpdateEnd, rfId, ariaLabel: edge.ariaLabel, isFocusable, isUpdatable, pathOptions: "pathOptions" in edge ? edge.pathOptions : void 0, interactionWidth: edge.interactionWidth });
      }))
    )),
    children
  );
};
EdgeRenderer.displayName = "EdgeRenderer";
var EdgeRenderer$1 = reactExports.memo(EdgeRenderer);
const selector$3 = (s) => `translate(${s.transform[0]}px,${s.transform[1]}px) scale(${s.transform[2]})`;
function Viewport({ children }) {
  const transform = useStore(selector$3);
  return React.createElement("div", { className: "react-flow__viewport react-flow__container", style: { transform } }, children);
}
function useOnInitHandler(onInit) {
  const rfInstance = useReactFlow();
  const isInitialized = reactExports.useRef(false);
  reactExports.useEffect(() => {
    if (!isInitialized.current && rfInstance.viewportInitialized && onInit) {
      setTimeout(() => onInit(rfInstance), 1);
      isInitialized.current = true;
    }
  }, [onInit, rfInstance.viewportInitialized]);
}
const oppositePosition = {
  [Position.Left]: Position.Right,
  [Position.Right]: Position.Left,
  [Position.Top]: Position.Bottom,
  [Position.Bottom]: Position.Top
};
const ConnectionLine = ({ nodeId, handleType, style: style2, type = ConnectionLineType.Bezier, CustomComponent, connectionStatus }) => {
  const { fromNode, handleId, toX, toY, connectionMode } = useStore(reactExports.useCallback((s) => ({
    fromNode: s.nodeInternals.get(nodeId),
    handleId: s.connectionHandleId,
    toX: (s.connectionPosition.x - s.transform[0]) / s.transform[2],
    toY: (s.connectionPosition.y - s.transform[1]) / s.transform[2],
    connectionMode: s.connectionMode
  }), [nodeId]), shallow$1);
  const fromHandleBounds = fromNode?.[internalsSymbol]?.handleBounds;
  let handleBounds = fromHandleBounds?.[handleType];
  if (connectionMode === ConnectionMode.Loose) {
    handleBounds = handleBounds ? handleBounds : fromHandleBounds?.[handleType === "source" ? "target" : "source"];
  }
  if (!fromNode || !handleBounds) {
    return null;
  }
  const fromHandle = handleId ? handleBounds.find((d) => d.id === handleId) : handleBounds[0];
  const fromHandleX = fromHandle ? fromHandle.x + fromHandle.width / 2 : (fromNode.width ?? 0) / 2;
  const fromHandleY = fromHandle ? fromHandle.y + fromHandle.height / 2 : fromNode.height ?? 0;
  const fromX = (fromNode.positionAbsolute?.x ?? 0) + fromHandleX;
  const fromY = (fromNode.positionAbsolute?.y ?? 0) + fromHandleY;
  const fromPosition = fromHandle?.position;
  const toPosition = fromPosition ? oppositePosition[fromPosition] : null;
  if (!fromPosition || !toPosition) {
    return null;
  }
  if (CustomComponent) {
    return React.createElement(CustomComponent, { connectionLineType: type, connectionLineStyle: style2, fromNode, fromHandle, fromX, fromY, toX, toY, fromPosition, toPosition, connectionStatus });
  }
  let dAttr = "";
  const pathParams = {
    sourceX: fromX,
    sourceY: fromY,
    sourcePosition: fromPosition,
    targetX: toX,
    targetY: toY,
    targetPosition: toPosition
  };
  if (type === ConnectionLineType.Bezier) {
    [dAttr] = getBezierPath(pathParams);
  } else if (type === ConnectionLineType.Step) {
    [dAttr] = getSmoothStepPath({
      ...pathParams,
      borderRadius: 0
    });
  } else if (type === ConnectionLineType.SmoothStep) {
    [dAttr] = getSmoothStepPath(pathParams);
  } else if (type === ConnectionLineType.SimpleBezier) {
    [dAttr] = getSimpleBezierPath(pathParams);
  } else {
    dAttr = `M${fromX},${fromY} ${toX},${toY}`;
  }
  return React.createElement("path", { d: dAttr, fill: "none", className: "react-flow__connection-path", style: style2 });
};
ConnectionLine.displayName = "ConnectionLine";
const selector$2 = (s) => ({
  nodeId: s.connectionNodeId,
  handleType: s.connectionHandleType,
  nodesConnectable: s.nodesConnectable,
  connectionStatus: s.connectionStatus,
  width: s.width,
  height: s.height
});
function ConnectionLineWrapper({ containerStyle: containerStyle2, style: style2, type, component }) {
  const { nodeId, handleType, nodesConnectable, width, height, connectionStatus } = useStore(selector$2, shallow$1);
  const isValid = !!(nodeId && handleType && width && nodesConnectable);
  if (!isValid) {
    return null;
  }
  return React.createElement(
    "svg",
    { style: containerStyle2, width, height, className: "react-flow__edges react-flow__connectionline react-flow__container" },
    React.createElement(
      "g",
      { className: cc(["react-flow__connection", connectionStatus]) },
      React.createElement(ConnectionLine, { nodeId, handleType, style: style2, type, CustomComponent: component, connectionStatus })
    )
  );
}
function useNodeOrEdgeTypes(nodeOrEdgeTypes, createTypes) {
  const typesKeysRef = reactExports.useRef(null);
  const store = useStoreApi();
  const typesParsed = reactExports.useMemo(() => {
    if (define_process_env_default.NODE_ENV === "development") {
      const typeKeys = Object.keys(nodeOrEdgeTypes);
      if (shallow$1(typesKeysRef.current, typeKeys)) {
        store.getState().onError?.("002", errorMessages["error002"]());
      }
      typesKeysRef.current = typeKeys;
    }
    return createTypes(nodeOrEdgeTypes);
  }, [nodeOrEdgeTypes]);
  return typesParsed;
}
const GraphView = ({ nodeTypes, edgeTypes, onMove, onMoveStart, onMoveEnd, onInit, onNodeClick, onEdgeClick, onNodeDoubleClick, onEdgeDoubleClick, onNodeMouseEnter, onNodeMouseMove, onNodeMouseLeave, onNodeContextMenu, onSelectionContextMenu, onSelectionStart, onSelectionEnd, connectionLineType, connectionLineStyle, connectionLineComponent, connectionLineContainerStyle, selectionKeyCode, selectionOnDrag, selectionMode, multiSelectionKeyCode, panActivationKeyCode, zoomActivationKeyCode, deleteKeyCode, onlyRenderVisibleElements, elementsSelectable, selectNodesOnDrag, defaultViewport, translateExtent, minZoom, maxZoom, preventScrolling, defaultMarkerColor, zoomOnScroll, zoomOnPinch, panOnScroll, panOnScrollSpeed, panOnScrollMode, zoomOnDoubleClick, panOnDrag, onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneScroll, onPaneContextMenu, onEdgeUpdate, onEdgeContextMenu, onEdgeMouseEnter, onEdgeMouseMove, onEdgeMouseLeave, edgeUpdaterRadius, onEdgeUpdateStart, onEdgeUpdateEnd, noDragClassName, noWheelClassName, noPanClassName, elevateEdgesOnSelect, disableKeyboardA11y, nodeOrigin, nodeExtent, rfId }) => {
  const nodeTypesWrapped = useNodeOrEdgeTypes(nodeTypes, createNodeTypes);
  const edgeTypesWrapped = useNodeOrEdgeTypes(edgeTypes, createEdgeTypes);
  useOnInitHandler(onInit);
  return React.createElement(
    FlowRenderer$1,
    { onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneContextMenu, onPaneScroll, deleteKeyCode, selectionKeyCode, selectionOnDrag, selectionMode, onSelectionStart, onSelectionEnd, multiSelectionKeyCode, panActivationKeyCode, zoomActivationKeyCode, elementsSelectable, onMove, onMoveStart, onMoveEnd, zoomOnScroll, zoomOnPinch, zoomOnDoubleClick, panOnScroll, panOnScrollSpeed, panOnScrollMode, panOnDrag, defaultViewport, translateExtent, minZoom, maxZoom, onSelectionContextMenu, preventScrolling, noDragClassName, noWheelClassName, noPanClassName, disableKeyboardA11y },
    React.createElement(
      Viewport,
      null,
      React.createElement(
        EdgeRenderer$1,
        { edgeTypes: edgeTypesWrapped, onEdgeClick, onEdgeDoubleClick, onEdgeUpdate, onlyRenderVisibleElements, onEdgeContextMenu, onEdgeMouseEnter, onEdgeMouseMove, onEdgeMouseLeave, onEdgeUpdateStart, onEdgeUpdateEnd, edgeUpdaterRadius, defaultMarkerColor, noPanClassName, elevateEdgesOnSelect: !!elevateEdgesOnSelect, disableKeyboardA11y, rfId },
        React.createElement(ConnectionLineWrapper, { style: connectionLineStyle, type: connectionLineType, component: connectionLineComponent, containerStyle: connectionLineContainerStyle })
      ),
      React.createElement("div", { className: "react-flow__edgelabel-renderer" }),
      React.createElement(NodeRenderer$1, { nodeTypes: nodeTypesWrapped, onNodeClick, onNodeDoubleClick, onNodeMouseEnter, onNodeMouseMove, onNodeMouseLeave, onNodeContextMenu, selectNodesOnDrag, onlyRenderVisibleElements, noPanClassName, noDragClassName, disableKeyboardA11y, nodeOrigin, nodeExtent, rfId })
    )
  );
};
GraphView.displayName = "GraphView";
var GraphView$1 = reactExports.memo(GraphView);
const infiniteExtent = [
  [Number.NEGATIVE_INFINITY, Number.NEGATIVE_INFINITY],
  [Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY]
];
const initialState = {
  rfId: "1",
  width: 0,
  height: 0,
  transform: [0, 0, 1],
  nodeInternals: /* @__PURE__ */ new Map(),
  edges: [],
  onNodesChange: null,
  onEdgesChange: null,
  hasDefaultNodes: false,
  hasDefaultEdges: false,
  d3Zoom: null,
  d3Selection: null,
  d3ZoomHandler: void 0,
  minZoom: 0.5,
  maxZoom: 2,
  translateExtent: infiniteExtent,
  nodeExtent: infiniteExtent,
  nodesSelectionActive: false,
  userSelectionActive: false,
  userSelectionRect: null,
  connectionNodeId: null,
  connectionHandleId: null,
  connectionHandleType: "source",
  connectionPosition: { x: 0, y: 0 },
  connectionStatus: null,
  connectionMode: ConnectionMode.Strict,
  domNode: null,
  paneDragging: false,
  noPanClassName: "nopan",
  nodeOrigin: [0, 0],
  nodeDragThreshold: 0,
  snapGrid: [15, 15],
  snapToGrid: false,
  nodesDraggable: true,
  nodesConnectable: true,
  nodesFocusable: true,
  edgesFocusable: true,
  edgesUpdatable: true,
  elementsSelectable: true,
  elevateNodesOnSelect: true,
  fitViewOnInit: false,
  fitViewOnInitDone: false,
  fitViewOnInitOptions: void 0,
  multiSelectionActive: false,
  connectionStartHandle: null,
  connectionEndHandle: null,
  connectionClickStartHandle: null,
  connectOnClick: true,
  ariaLiveMessage: "",
  autoPanOnConnect: true,
  autoPanOnNodeDrag: true,
  connectionRadius: 20,
  onError: devWarn,
  isValidConnection: void 0
};
const createRFStore = () => createWithEqualityFn((set, get) => ({
  ...initialState,
  setNodes: (nodes) => {
    const { nodeInternals, nodeOrigin, elevateNodesOnSelect } = get();
    set({ nodeInternals: createNodeInternals(nodes, nodeInternals, nodeOrigin, elevateNodesOnSelect) });
  },
  getNodes: () => {
    return Array.from(get().nodeInternals.values());
  },
  setEdges: (edges) => {
    const { defaultEdgeOptions = {} } = get();
    set({ edges: edges.map((e) => ({ ...defaultEdgeOptions, ...e })) });
  },
  setDefaultNodesAndEdges: (nodes, edges) => {
    const hasDefaultNodes = typeof nodes !== "undefined";
    const hasDefaultEdges = typeof edges !== "undefined";
    const nodeInternals = hasDefaultNodes ? createNodeInternals(nodes, /* @__PURE__ */ new Map(), get().nodeOrigin, get().elevateNodesOnSelect) : /* @__PURE__ */ new Map();
    const nextEdges = hasDefaultEdges ? edges : [];
    set({ nodeInternals, edges: nextEdges, hasDefaultNodes, hasDefaultEdges });
  },
  updateNodeDimensions: (updates) => {
    const { onNodesChange, nodeInternals, fitViewOnInit, fitViewOnInitDone, fitViewOnInitOptions, domNode, nodeOrigin } = get();
    const viewportNode = domNode?.querySelector(".react-flow__viewport");
    if (!viewportNode) {
      return;
    }
    const style2 = window.getComputedStyle(viewportNode);
    const { m22: zoom2 } = new window.DOMMatrixReadOnly(style2.transform);
    const changes = updates.reduce((res, update) => {
      const node = nodeInternals.get(update.id);
      if (node) {
        const dimensions = getDimensions(update.nodeElement);
        const doUpdate = !!(dimensions.width && dimensions.height && (node.width !== dimensions.width || node.height !== dimensions.height || update.forceUpdate));
        if (doUpdate) {
          nodeInternals.set(node.id, {
            ...node,
            [internalsSymbol]: {
              ...node[internalsSymbol],
              handleBounds: {
                source: getHandleBounds(".source", update.nodeElement, zoom2, nodeOrigin),
                target: getHandleBounds(".target", update.nodeElement, zoom2, nodeOrigin)
              }
            },
            ...dimensions
          });
          res.push({
            id: node.id,
            type: "dimensions",
            dimensions
          });
        }
      }
      return res;
    }, []);
    updateAbsoluteNodePositions(nodeInternals, nodeOrigin);
    const nextFitViewOnInitDone = fitViewOnInitDone || fitViewOnInit && !fitViewOnInitDone && fitView(get, { initial: true, ...fitViewOnInitOptions });
    set({ nodeInternals: new Map(nodeInternals), fitViewOnInitDone: nextFitViewOnInitDone });
    if (changes?.length > 0) {
      onNodesChange?.(changes);
    }
  },
  updateNodePositions: (nodeDragItems, positionChanged = true, dragging = false) => {
    const { triggerNodeChanges } = get();
    const changes = nodeDragItems.map((node) => {
      const change = {
        id: node.id,
        type: "position",
        dragging
      };
      if (positionChanged) {
        change.positionAbsolute = node.positionAbsolute;
        change.position = node.position;
      }
      return change;
    });
    triggerNodeChanges(changes);
  },
  triggerNodeChanges: (changes) => {
    const { onNodesChange, nodeInternals, hasDefaultNodes, nodeOrigin, getNodes, elevateNodesOnSelect } = get();
    if (changes?.length) {
      if (hasDefaultNodes) {
        const nodes = applyNodeChanges(changes, getNodes());
        const nextNodeInternals = createNodeInternals(nodes, nodeInternals, nodeOrigin, elevateNodesOnSelect);
        set({ nodeInternals: nextNodeInternals });
      }
      onNodesChange?.(changes);
    }
  },
  addSelectedNodes: (selectedNodeIds) => {
    const { multiSelectionActive, edges, getNodes } = get();
    let changedNodes;
    let changedEdges = null;
    if (multiSelectionActive) {
      changedNodes = selectedNodeIds.map((nodeId) => createSelectionChange(nodeId, true));
    } else {
      changedNodes = getSelectionChanges(getNodes(), selectedNodeIds);
      changedEdges = getSelectionChanges(edges, []);
    }
    updateNodesAndEdgesSelections({
      changedNodes,
      changedEdges,
      get,
      set
    });
  },
  addSelectedEdges: (selectedEdgeIds) => {
    const { multiSelectionActive, edges, getNodes } = get();
    let changedEdges;
    let changedNodes = null;
    if (multiSelectionActive) {
      changedEdges = selectedEdgeIds.map((edgeId) => createSelectionChange(edgeId, true));
    } else {
      changedEdges = getSelectionChanges(edges, selectedEdgeIds);
      changedNodes = getSelectionChanges(getNodes(), []);
    }
    updateNodesAndEdgesSelections({
      changedNodes,
      changedEdges,
      get,
      set
    });
  },
  unselectNodesAndEdges: ({ nodes, edges } = {}) => {
    const { edges: storeEdges, getNodes } = get();
    const nodesToUnselect = nodes ? nodes : getNodes();
    const edgesToUnselect = edges ? edges : storeEdges;
    const changedNodes = nodesToUnselect.map((n) => {
      n.selected = false;
      return createSelectionChange(n.id, false);
    });
    const changedEdges = edgesToUnselect.map((edge) => createSelectionChange(edge.id, false));
    updateNodesAndEdgesSelections({
      changedNodes,
      changedEdges,
      get,
      set
    });
  },
  setMinZoom: (minZoom) => {
    const { d3Zoom, maxZoom } = get();
    d3Zoom?.scaleExtent([minZoom, maxZoom]);
    set({ minZoom });
  },
  setMaxZoom: (maxZoom) => {
    const { d3Zoom, minZoom } = get();
    d3Zoom?.scaleExtent([minZoom, maxZoom]);
    set({ maxZoom });
  },
  setTranslateExtent: (translateExtent) => {
    get().d3Zoom?.translateExtent(translateExtent);
    set({ translateExtent });
  },
  resetSelectedElements: () => {
    const { edges, getNodes } = get();
    const nodes = getNodes();
    const nodesToUnselect = nodes.filter((e) => e.selected).map((n) => createSelectionChange(n.id, false));
    const edgesToUnselect = edges.filter((e) => e.selected).map((e) => createSelectionChange(e.id, false));
    updateNodesAndEdgesSelections({
      changedNodes: nodesToUnselect,
      changedEdges: edgesToUnselect,
      get,
      set
    });
  },
  setNodeExtent: (nodeExtent) => {
    const { nodeInternals } = get();
    nodeInternals.forEach((node) => {
      node.positionAbsolute = clampPosition(node.position, nodeExtent);
    });
    set({
      nodeExtent,
      nodeInternals: new Map(nodeInternals)
    });
  },
  panBy: (delta) => {
    const { transform, width, height, d3Zoom, d3Selection, translateExtent } = get();
    if (!d3Zoom || !d3Selection || !delta.x && !delta.y) {
      return false;
    }
    const nextTransform = identity.translate(transform[0] + delta.x, transform[1] + delta.y).scale(transform[2]);
    const extent = [
      [0, 0],
      [width, height]
    ];
    const constrainedTransform = d3Zoom?.constrain()(nextTransform, extent, translateExtent);
    d3Zoom.transform(d3Selection, constrainedTransform);
    const transformChanged = transform[0] !== constrainedTransform.x || transform[1] !== constrainedTransform.y || transform[2] !== constrainedTransform.k;
    return transformChanged;
  },
  cancelConnection: () => set({
    connectionNodeId: initialState.connectionNodeId,
    connectionHandleId: initialState.connectionHandleId,
    connectionHandleType: initialState.connectionHandleType,
    connectionStatus: initialState.connectionStatus,
    connectionStartHandle: initialState.connectionStartHandle,
    connectionEndHandle: initialState.connectionEndHandle
  }),
  reset: () => set({ ...initialState })
}), Object.is);
const ReactFlowProvider = ({ children }) => {
  const storeRef = reactExports.useRef(null);
  if (!storeRef.current) {
    storeRef.current = createRFStore();
  }
  return React.createElement(Provider$1, { value: storeRef.current }, children);
};
ReactFlowProvider.displayName = "ReactFlowProvider";
const Wrapper = ({ children }) => {
  const isWrapped = reactExports.useContext(StoreContext);
  if (isWrapped) {
    return React.createElement(React.Fragment, null, children);
  }
  return React.createElement(ReactFlowProvider, null, children);
};
Wrapper.displayName = "ReactFlowWrapper";
const defaultNodeTypes = {
  input: InputNode$1,
  default: DefaultNode$1,
  output: OutputNode$1,
  group: GroupNode
};
const defaultEdgeTypes = {
  default: BezierEdge,
  straight: StraightEdge,
  step: StepEdge,
  smoothstep: SmoothStepEdge,
  simplebezier: SimpleBezierEdge
};
const initNodeOrigin = [0, 0];
const initSnapGrid = [15, 15];
const initDefaultViewport = { x: 0, y: 0, zoom: 1 };
const wrapperStyle = {
  width: "100%",
  height: "100%",
  overflow: "hidden",
  position: "relative",
  zIndex: 0
};
const ReactFlow = reactExports.forwardRef(({ nodes, edges, defaultNodes, defaultEdges, className, nodeTypes = defaultNodeTypes, edgeTypes = defaultEdgeTypes, onNodeClick, onEdgeClick, onInit, onMove, onMoveStart, onMoveEnd, onConnect, onConnectStart, onConnectEnd, onClickConnectStart, onClickConnectEnd, onNodeMouseEnter, onNodeMouseMove, onNodeMouseLeave, onNodeContextMenu, onNodeDoubleClick, onNodeDragStart, onNodeDrag, onNodeDragStop, onNodesDelete, onEdgesDelete, onSelectionChange, onSelectionDragStart, onSelectionDrag, onSelectionDragStop, onSelectionContextMenu, onSelectionStart, onSelectionEnd, connectionMode = ConnectionMode.Strict, connectionLineType = ConnectionLineType.Bezier, connectionLineStyle, connectionLineComponent, connectionLineContainerStyle, deleteKeyCode = "Backspace", selectionKeyCode = "Shift", selectionOnDrag = false, selectionMode = SelectionMode.Full, panActivationKeyCode = "Space", multiSelectionKeyCode = isMacOs() ? "Meta" : "Control", zoomActivationKeyCode = isMacOs() ? "Meta" : "Control", snapToGrid = false, snapGrid = initSnapGrid, onlyRenderVisibleElements = false, selectNodesOnDrag = true, nodesDraggable, nodesConnectable, nodesFocusable, nodeOrigin = initNodeOrigin, edgesFocusable, edgesUpdatable, elementsSelectable, defaultViewport = initDefaultViewport, minZoom = 0.5, maxZoom = 2, translateExtent = infiniteExtent, preventScrolling = true, nodeExtent, defaultMarkerColor = "#b1b1b7", zoomOnScroll = true, zoomOnPinch = true, panOnScroll = false, panOnScrollSpeed = 0.5, panOnScrollMode = PanOnScrollMode.Free, zoomOnDoubleClick = true, panOnDrag = true, onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneScroll, onPaneContextMenu, children, onEdgeUpdate, onEdgeContextMenu, onEdgeDoubleClick, onEdgeMouseEnter, onEdgeMouseMove, onEdgeMouseLeave, onEdgeUpdateStart, onEdgeUpdateEnd, edgeUpdaterRadius = 10, onNodesChange, onEdgesChange, noDragClassName = "nodrag", noWheelClassName = "nowheel", noPanClassName = "nopan", fitView: fitView2 = false, fitViewOptions, connectOnClick = true, attributionPosition, proOptions, defaultEdgeOptions, elevateNodesOnSelect = true, elevateEdgesOnSelect = false, disableKeyboardA11y = false, autoPanOnConnect = true, autoPanOnNodeDrag = true, connectionRadius = 20, isValidConnection, onError, style: style2, id, nodeDragThreshold, ...rest }, ref) => {
  const rfId = id || "1";
  return React.createElement(
    "div",
    { ...rest, style: { ...style2, ...wrapperStyle }, ref, className: cc(["react-flow", className]), "data-testid": "rf__wrapper", id },
    React.createElement(
      Wrapper,
      null,
      React.createElement(GraphView$1, { onInit, onMove, onMoveStart, onMoveEnd, onNodeClick, onEdgeClick, onNodeMouseEnter, onNodeMouseMove, onNodeMouseLeave, onNodeContextMenu, onNodeDoubleClick, nodeTypes, edgeTypes, connectionLineType, connectionLineStyle, connectionLineComponent, connectionLineContainerStyle, selectionKeyCode, selectionOnDrag, selectionMode, deleteKeyCode, multiSelectionKeyCode, panActivationKeyCode, zoomActivationKeyCode, onlyRenderVisibleElements, selectNodesOnDrag, defaultViewport, translateExtent, minZoom, maxZoom, preventScrolling, zoomOnScroll, zoomOnPinch, zoomOnDoubleClick, panOnScroll, panOnScrollSpeed, panOnScrollMode, panOnDrag, onPaneClick, onPaneMouseEnter, onPaneMouseMove, onPaneMouseLeave, onPaneScroll, onPaneContextMenu, onSelectionContextMenu, onSelectionStart, onSelectionEnd, onEdgeUpdate, onEdgeContextMenu, onEdgeDoubleClick, onEdgeMouseEnter, onEdgeMouseMove, onEdgeMouseLeave, onEdgeUpdateStart, onEdgeUpdateEnd, edgeUpdaterRadius, defaultMarkerColor, noDragClassName, noWheelClassName, noPanClassName, elevateEdgesOnSelect, rfId, disableKeyboardA11y, nodeOrigin, nodeExtent }),
      React.createElement(StoreUpdater, { nodes, edges, defaultNodes, defaultEdges, onConnect, onConnectStart, onConnectEnd, onClickConnectStart, onClickConnectEnd, nodesDraggable, nodesConnectable, nodesFocusable, edgesFocusable, edgesUpdatable, elementsSelectable, elevateNodesOnSelect, minZoom, maxZoom, nodeExtent, onNodesChange, onEdgesChange, snapToGrid, snapGrid, connectionMode, translateExtent, connectOnClick, defaultEdgeOptions, fitView: fitView2, fitViewOptions, onNodesDelete, onEdgesDelete, onNodeDragStart, onNodeDrag, onNodeDragStop, onSelectionDrag, onSelectionDragStart, onSelectionDragStop, noPanClassName, nodeOrigin, rfId, autoPanOnConnect, autoPanOnNodeDrag, onError, connectionRadius, isValidConnection, nodeDragThreshold }),
      React.createElement(Wrapper$1, { onSelectionChange }),
      children,
      React.createElement(Attribution, { proOptions, position: attributionPosition }),
      React.createElement(A11yDescriptions, { rfId, disableKeyboardA11y })
    )
  );
});
ReactFlow.displayName = "ReactFlow";
function createUseItemsState(applyChanges2) {
  return (initialItems) => {
    const [items, setItems] = reactExports.useState(initialItems);
    const onItemsChange = reactExports.useCallback((changes) => setItems((items2) => applyChanges2(changes, items2)), []);
    return [items, setItems, onItemsChange];
  };
}
const useNodesState = createUseItemsState(applyNodeChanges);
const useEdgesState = createUseItemsState(applyEdgeChanges);

var BackgroundVariant;
(function (BackgroundVariant) {
    BackgroundVariant["Lines"] = "lines";
    BackgroundVariant["Dots"] = "dots";
    BackgroundVariant["Cross"] = "cross";
})(BackgroundVariant || (BackgroundVariant = {}));

function LinePattern({ color, dimensions, lineWidth }) {
    return (React.createElement("path", { stroke: color, strokeWidth: lineWidth, d: `M${dimensions[0] / 2} 0 V${dimensions[1]} M0 ${dimensions[1] / 2} H${dimensions[0]}` }));
}
function DotPattern({ color, radius }) {
    return React.createElement("circle", { cx: radius, cy: radius, r: radius, fill: color });
}

const defaultColor = {
    [BackgroundVariant.Dots]: '#91919a',
    [BackgroundVariant.Lines]: '#eee',
    [BackgroundVariant.Cross]: '#e2e2e2',
};
const defaultSize = {
    [BackgroundVariant.Dots]: 1,
    [BackgroundVariant.Lines]: 1,
    [BackgroundVariant.Cross]: 6,
};
const selector = (s) => ({ transform: s.transform, patternId: `pattern-${s.rfId}` });
function Background({ id, variant = BackgroundVariant.Dots, 
// only used for dots and cross
gap = 20, 
// only used for lines and cross
size, lineWidth = 1, offset = 2, color, style, className, }) {
    const ref = reactExports.useRef(null);
    const { transform, patternId } = useStore(selector, shallow$1);
    const patternColor = color || defaultColor[variant];
    const patternSize = size || defaultSize[variant];
    const isDots = variant === BackgroundVariant.Dots;
    const isCross = variant === BackgroundVariant.Cross;
    const gapXY = Array.isArray(gap) ? gap : [gap, gap];
    const scaledGap = [gapXY[0] * transform[2] || 1, gapXY[1] * transform[2] || 1];
    const scaledSize = patternSize * transform[2];
    const patternDimensions = isCross ? [scaledSize, scaledSize] : scaledGap;
    const patternOffset = isDots
        ? [scaledSize / offset, scaledSize / offset]
        : [patternDimensions[0] / offset, patternDimensions[1] / offset];
    return (React.createElement("svg", { className: cc(['react-flow__background', className]), style: {
            ...style,
            position: 'absolute',
            width: '100%',
            height: '100%',
            top: 0,
            left: 0,
        }, ref: ref, "data-testid": "rf__background" },
        React.createElement("pattern", { id: patternId + id, x: transform[0] % scaledGap[0], y: transform[1] % scaledGap[1], width: scaledGap[0], height: scaledGap[1], patternUnits: "userSpaceOnUse", patternTransform: `translate(-${patternOffset[0]},-${patternOffset[1]})` }, isDots ? (React.createElement(DotPattern, { color: patternColor, radius: scaledSize / offset })) : (React.createElement(LinePattern, { dimensions: patternDimensions, color: patternColor, lineWidth: lineWidth }))),
        React.createElement("rect", { x: "0", y: "0", width: "100%", height: "100%", fill: `url(#${patternId + id})` })));
}
Background.displayName = 'Background';
var Background$1 = reactExports.memo(Background);

var ResizeControlVariant;
(function (ResizeControlVariant) {
    ResizeControlVariant["Line"] = "line";
    ResizeControlVariant["Handle"] = "handle";
})(ResizeControlVariant || (ResizeControlVariant = {}));

// returns an array of two numbers (0, 1 or -1) representing the direction of the resize
// 0 = no change, 1 = increase, -1 = decrease
function getDirection({ width, prevWidth, height, prevHeight, invertX, invertY }) {
    const deltaWidth = width - prevWidth;
    const deltaHeight = height - prevHeight;
    const direction = [deltaWidth > 0 ? 1 : deltaWidth < 0 ? -1 : 0, deltaHeight > 0 ? 1 : deltaHeight < 0 ? -1 : 0];
    if (deltaWidth && invertX) {
        direction[0] = direction[0] * -1;
    }
    if (deltaHeight && invertY) {
        direction[1] = direction[1] * -1;
    }
    return direction;
}

const initPrevValues = { width: 0, height: 0, x: 0, y: 0 };
const initStartValues = {
    ...initPrevValues,
    pointerX: 0,
    pointerY: 0,
    aspectRatio: 1,
};
function ResizeControl({ nodeId, position, variant = ResizeControlVariant.Handle, className, style = {}, children, color, minWidth = 10, minHeight = 10, maxWidth = Number.MAX_VALUE, maxHeight = Number.MAX_VALUE, keepAspectRatio = false, shouldResize, onResizeStart, onResize, onResizeEnd, }) {
    const contextNodeId = useNodeId();
    const id = typeof nodeId === 'string' ? nodeId : contextNodeId;
    const store = useStoreApi();
    const resizeControlRef = reactExports.useRef(null);
    const startValues = reactExports.useRef(initStartValues);
    const prevValues = reactExports.useRef(initPrevValues);
    const getPointerPosition = useGetPointerPosition();
    const defaultPosition = variant === ResizeControlVariant.Line ? 'right' : 'bottom-right';
    const controlPosition = position ?? defaultPosition;
    reactExports.useEffect(() => {
        if (!resizeControlRef.current || !id) {
            return;
        }
        const selection = select(resizeControlRef.current);
        const enableX = controlPosition.includes('right') || controlPosition.includes('left');
        const enableY = controlPosition.includes('bottom') || controlPosition.includes('top');
        const invertX = controlPosition.includes('left');
        const invertY = controlPosition.includes('top');
        const dragHandler = drag()
            .on('start', (event) => {
            const node = store.getState().nodeInternals.get(id);
            const { xSnapped, ySnapped } = getPointerPosition(event);
            prevValues.current = {
                width: node?.width ?? 0,
                height: node?.height ?? 0,
                x: node?.position.x ?? 0,
                y: node?.position.y ?? 0,
            };
            startValues.current = {
                ...prevValues.current,
                pointerX: xSnapped,
                pointerY: ySnapped,
                aspectRatio: prevValues.current.width / prevValues.current.height,
            };
            onResizeStart?.(event, { ...prevValues.current });
        })
            .on('drag', (event) => {
            const { nodeInternals, triggerNodeChanges } = store.getState();
            const { xSnapped, ySnapped } = getPointerPosition(event);
            const node = nodeInternals.get(id);
            if (node) {
                const changes = [];
                const { pointerX: startX, pointerY: startY, width: startWidth, height: startHeight, x: startNodeX, y: startNodeY, aspectRatio, } = startValues.current;
                const { x: prevX, y: prevY, width: prevWidth, height: prevHeight } = prevValues.current;
                const distX = Math.floor(enableX ? xSnapped - startX : 0);
                const distY = Math.floor(enableY ? ySnapped - startY : 0);
                let width = clamp(startWidth + (invertX ? -distX : distX), minWidth, maxWidth);
                let height = clamp(startHeight + (invertY ? -distY : distY), minHeight, maxHeight);
                if (keepAspectRatio) {
                    const nextAspectRatio = width / height;
                    const isDiagonal = enableX && enableY;
                    const isHorizontal = enableX && !enableY;
                    const isVertical = enableY && !enableX;
                    width = (nextAspectRatio <= aspectRatio && isDiagonal) || isVertical ? height * aspectRatio : width;
                    height = (nextAspectRatio > aspectRatio && isDiagonal) || isHorizontal ? width / aspectRatio : height;
                    if (width >= maxWidth) {
                        width = maxWidth;
                        height = maxWidth / aspectRatio;
                    }
                    else if (width <= minWidth) {
                        width = minWidth;
                        height = minWidth / aspectRatio;
                    }
                    if (height >= maxHeight) {
                        height = maxHeight;
                        width = maxHeight * aspectRatio;
                    }
                    else if (height <= minHeight) {
                        height = minHeight;
                        width = minHeight * aspectRatio;
                    }
                }
                const isWidthChange = width !== prevWidth;
                const isHeightChange = height !== prevHeight;
                if (invertX || invertY) {
                    const x = invertX ? startNodeX - (width - startWidth) : startNodeX;
                    const y = invertY ? startNodeY - (height - startHeight) : startNodeY;
                    // only transform the node if the width or height changes
                    const isXPosChange = x !== prevX && isWidthChange;
                    const isYPosChange = y !== prevY && isHeightChange;
                    if (isXPosChange || isYPosChange) {
                        const positionChange = {
                            id: node.id,
                            type: 'position',
                            position: {
                                x: isXPosChange ? x : prevX,
                                y: isYPosChange ? y : prevY,
                            },
                        };
                        changes.push(positionChange);
                        prevValues.current.x = positionChange.position.x;
                        prevValues.current.y = positionChange.position.y;
                    }
                }
                if (isWidthChange || isHeightChange) {
                    const dimensionChange = {
                        id: id,
                        type: 'dimensions',
                        updateStyle: true,
                        resizing: true,
                        dimensions: {
                            width: width,
                            height: height,
                        },
                    };
                    changes.push(dimensionChange);
                    prevValues.current.width = width;
                    prevValues.current.height = height;
                }
                if (changes.length === 0) {
                    return;
                }
                const direction = getDirection({
                    width: prevValues.current.width,
                    prevWidth,
                    height: prevValues.current.height,
                    prevHeight,
                    invertX,
                    invertY,
                });
                const nextValues = { ...prevValues.current, direction };
                const callResize = shouldResize?.(event, nextValues);
                if (callResize === false) {
                    return;
                }
                onResize?.(event, nextValues);
                triggerNodeChanges(changes);
            }
        })
            .on('end', (event) => {
            const dimensionChange = {
                id: id,
                type: 'dimensions',
                resizing: false,
            };
            onResizeEnd?.(event, { ...prevValues.current });
            store.getState().triggerNodeChanges([dimensionChange]);
        });
        selection.call(dragHandler);
        return () => {
            selection.on('.drag', null);
        };
    }, [
        id,
        controlPosition,
        minWidth,
        minHeight,
        maxWidth,
        maxHeight,
        keepAspectRatio,
        getPointerPosition,
        onResizeStart,
        onResize,
        onResizeEnd,
    ]);
    const positionClassNames = controlPosition.split('-');
    const colorStyleProp = variant === ResizeControlVariant.Line ? 'borderColor' : 'backgroundColor';
    const controlStyle = color ? { ...style, [colorStyleProp]: color } : style;
    return (React.createElement("div", { className: cc(['react-flow__resize-control', 'nodrag', ...positionClassNames, variant, className]), ref: resizeControlRef, style: controlStyle }, children));
}
var ResizeControl$1 = reactExports.memo(ResizeControl);

const handleControls = ['top-left', 'top-right', 'bottom-left', 'bottom-right'];
const lineControls = ['top', 'right', 'bottom', 'left'];
function NodeResizer({ nodeId, isVisible = true, handleClassName, handleStyle, lineClassName, lineStyle, color, minWidth = 10, minHeight = 10, maxWidth = Number.MAX_VALUE, maxHeight = Number.MAX_VALUE, keepAspectRatio = false, shouldResize, onResizeStart, onResize, onResizeEnd, }) {
    if (!isVisible) {
        return null;
    }
    return (React.createElement(React.Fragment, null,
        lineControls.map((c) => (React.createElement(ResizeControl$1, { key: c, className: lineClassName, style: lineStyle, nodeId: nodeId, position: c, variant: ResizeControlVariant.Line, color: color, minWidth: minWidth, minHeight: minHeight, maxWidth: maxWidth, maxHeight: maxHeight, onResizeStart: onResizeStart, keepAspectRatio: keepAspectRatio, shouldResize: shouldResize, onResize: onResize, onResizeEnd: onResizeEnd }))),
        handleControls.map((c) => (React.createElement(ResizeControl$1, { key: c, className: handleClassName, style: handleStyle, nodeId: nodeId, position: c, color: color, minWidth: minWidth, minHeight: minHeight, maxWidth: maxWidth, maxHeight: maxHeight, onResizeStart: onResizeStart, keepAspectRatio: keepAspectRatio, shouldResize: shouldResize, onResize: onResize, onResizeEnd: onResizeEnd })))));
}

const container = "_container_d5krf_1";
const buttonGroup = "_buttonGroup_d5krf_16";
const styles$2 = {
	container: container,
	buttonGroup: buttonGroup
};

function r$1(e){var t,f,n="";if("string"==typeof e||"number"==typeof e)n+=e;else if("object"==typeof e)if(Array.isArray(e))for(t=0;t<e.length;t++)e[t]&&(f=r$1(e[t]))&&(n&&(n+=" "),n+=f);else for(t in e)e[t]&&(n&&(n+=" "),n+=t);return n}function clsx$1(){for(var e,t,f=0,n="";f<arguments.length;)(e=arguments[f++])&&(t=r$1(e))&&(n&&(n+=" "),n+=t);return n}

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = React.createContext && React.createContext(DefaultContext);

var __assign = undefined && undefined.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = undefined && undefined.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function Tree2Element(tree) {
  return tree && tree.map(function (node, i) {
    return React.createElement(node.tag, __assign({
      key: i
    }, node.attr), Tree2Element(node.child));
  });
}
function GenIcon(data) {
  // eslint-disable-next-line react/display-name
  return function (props) {
    return React.createElement(IconBase, __assign({
      attr: __assign({}, data.attr)
    }, props), Tree2Element(data.child));
  };
}
function IconBase(props) {
  var elem = function (conf) {
    var attr = props.attr,
      size = props.size,
      title = props.title,
      svgProps = __rest(props, ["attr", "size", "title"]);
    var computedSize = size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + " " : "") + props.className;
    return React.createElement("svg", __assign({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: __assign(__assign({
        color: props.color || conf.color
      }, conf.style), props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), title && React.createElement("title", null, title), props.children);
  };
  return IconContext !== undefined ? React.createElement(IconContext.Consumer, null, function (conf) {
    return elem(conf);
  }) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
function PiCaretRightBold (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 256 256","fill":"currentColor"},"child":[{"tag":"path","attr":{"d":"M184.49,136.49l-80,80a12,12,0,0,1-17-17L159,128,87.51,56.49a12,12,0,1,1,17-17l80,80A12,12,0,0,1,184.49,136.49Z"}}]})(props);
}

const node = "_node_9bsyb_1";
const expanded = "_expanded_9bsyb_97";
const empty = "_empty_9bsyb_117";
const styles$1 = {
	node: node,
	expanded: expanded,
	empty: empty
};

const codeBlock = "_codeBlock_7tmir_1";
const lineNumber = "_lineNumber_7tmir_12";
const styles = {
	codeBlock: codeBlock,
	lineNumber: lineNumber
};

function r(e){var t,f,n="";if("string"==typeof e||"number"==typeof e)n+=e;else if("object"==typeof e)if(Array.isArray(e))for(t=0;t<e.length;t++)e[t]&&(f=r(e[t]))&&(n&&(n+=" "),n+=f);else for(t in e)e[t]&&(n&&(n+=" "),n+=t);return n}function clsx(){for(var e,t,f=0,n="";f<arguments.length;)(e=arguments[f++])&&(t=r(e))&&(n&&(n+=" "),n+=t);return n}

var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../node_modules/.pnpm/prismjs@1.29.0_patch_hash=vrxx3pzkik6jpmgpayxfjunetu/node_modules/prismjs/prism.js
var require_prism = __commonJS({
  "../../node_modules/.pnpm/prismjs@1.29.0_patch_hash=vrxx3pzkik6jpmgpayxfjunetu/node_modules/prismjs/prism.js"(exports, module) {
    var Prism2 = function() {
      var lang = /(?:^|\s)lang(?:uage)?-([\w-]+)(?=\s|$)/i;
      var uniqueId = 0;
      var plainTextGrammar = {};
      var _ = {
        /**
         * A namespace for utility methods.
         *
         * All function in this namespace that are not explicitly marked as _public_ are for __internal use only__ and may
         * change or disappear at any time.
         *
         * @namespace
         * @memberof Prism
         */
        util: {
          encode: function encode(tokens) {
            if (tokens instanceof Token) {
              return new Token(tokens.type, encode(tokens.content), tokens.alias);
            } else if (Array.isArray(tokens)) {
              return tokens.map(encode);
            } else {
              return tokens.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/\u00a0/g, " ");
            }
          },
          /**
           * Returns the name of the type of the given value.
           *
           * @param {any} o
           * @returns {string}
           * @example
           * type(null)      === 'Null'
           * type(undefined) === 'Undefined'
           * type(123)       === 'Number'
           * type('foo')     === 'String'
           * type(true)      === 'Boolean'
           * type([1, 2])    === 'Array'
           * type({})        === 'Object'
           * type(String)    === 'Function'
           * type(/abc+/)    === 'RegExp'
           */
          type: function(o) {
            return Object.prototype.toString.call(o).slice(8, -1);
          },
          /**
           * Returns a unique number for the given object. Later calls will still return the same number.
           *
           * @param {Object} obj
           * @returns {number}
           */
          objId: function(obj) {
            if (!obj["__id"]) {
              Object.defineProperty(obj, "__id", { value: ++uniqueId });
            }
            return obj["__id"];
          },
          /**
           * Creates a deep clone of the given object.
           *
           * The main intended use of this function is to clone language definitions.
           *
           * @param {T} o
           * @param {Record<number, any>} [visited]
           * @returns {T}
           * @template T
           */
          clone: function deepClone(o, visited) {
            visited = visited || {};
            var clone;
            var id;
            switch (_.util.type(o)) {
              case "Object":
                id = _.util.objId(o);
                if (visited[id]) {
                  return visited[id];
                }
                clone = /** @type {Record<string, any>} */
                {};
                visited[id] = clone;
                for (var key in o) {
                  if (o.hasOwnProperty(key)) {
                    clone[key] = deepClone(o[key], visited);
                  }
                }
                return (
                  /** @type {any} */
                  clone
                );
              case "Array":
                id = _.util.objId(o);
                if (visited[id]) {
                  return visited[id];
                }
                clone = [];
                visited[id] = clone;
                /** @type {Array} */
                /** @type {any} */
                o.forEach(function(v, i) {
                  clone[i] = deepClone(v, visited);
                });
                return (
                  /** @type {any} */
                  clone
                );
              default:
                return o;
            }
          },
          /**
           * Returns the Prism language of the given element set by a `language-xxxx` or `lang-xxxx` class.
           *
           * If no language is set for the element or the element is `null` or `undefined`, `none` will be returned.
           *
           * @param {Element} element
           * @returns {string}
           */
          getLanguage: function(element) {
            while (element) {
              var m = lang.exec(element.className);
              if (m) {
                return m[1].toLowerCase();
              }
              element = element.parentElement;
            }
            return "none";
          },
          /**
           * Sets the Prism `language-xxxx` class of the given element.
           *
           * @param {Element} element
           * @param {string} language
           * @returns {void}
           */
          setLanguage: function(element, language) {
            element.className = element.className.replace(RegExp(lang, "gi"), "");
            element.classList.add("language-" + language);
          },
          /**
           * Returns whether a given class is active for `element`.
           *
           * The class can be activated if `element` or one of its ancestors has the given class and it can be deactivated
           * if `element` or one of its ancestors has the negated version of the given class. The _negated version_ of the
           * given class is just the given class with a `no-` prefix.
           *
           * Whether the class is active is determined by the closest ancestor of `element` (where `element` itself is
           * closest ancestor) that has the given class or the negated version of it. If neither `element` nor any of its
           * ancestors have the given class or the negated version of it, then the default activation will be returned.
           *
           * In the paradoxical situation where the closest ancestor contains __both__ the given class and the negated
           * version of it, the class is considered active.
           *
           * @param {Element} element
           * @param {string} className
           * @param {boolean} [defaultActivation=false]
           * @returns {boolean}
           */
          isActive: function(element, className, defaultActivation) {
            var no = "no-" + className;
            while (element) {
              var classList = element.classList;
              if (classList.contains(className)) {
                return true;
              }
              if (classList.contains(no)) {
                return false;
              }
              element = element.parentElement;
            }
            return !!defaultActivation;
          }
        },
        /**
         * This namespace contains all currently loaded languages and the some helper functions to create and modify languages.
         *
         * @namespace
         * @memberof Prism
         * @public
         */
        languages: {
          /**
           * The grammar for plain, unformatted text.
           */
          plain: plainTextGrammar,
          plaintext: plainTextGrammar,
          text: plainTextGrammar,
          txt: plainTextGrammar,
          /**
           * Creates a deep copy of the language with the given id and appends the given tokens.
           *
           * If a token in `redef` also appears in the copied language, then the existing token in the copied language
           * will be overwritten at its original position.
           *
           * ## Best practices
           *
           * Since the position of overwriting tokens (token in `redef` that overwrite tokens in the copied language)
           * doesn't matter, they can technically be in any order. However, this can be confusing to others that trying to
           * understand the language definition because, normally, the order of tokens matters in Prism grammars.
           *
           * Therefore, it is encouraged to order overwriting tokens according to the positions of the overwritten tokens.
           * Furthermore, all non-overwriting tokens should be placed after the overwriting ones.
           *
           * @param {string} id The id of the language to extend. This has to be a key in `Prism.languages`.
           * @param {Grammar} redef The new tokens to append.
           * @returns {Grammar} The new language created.
           * @public
           * @example
           * Prism.languages['css-with-colors'] = Prism.languages.extend('css', {
           *     // Prism.languages.css already has a 'comment' token, so this token will overwrite CSS' 'comment' token
           *     // at its original position
           *     'comment': { ... },
           *     // CSS doesn't have a 'color' token, so this token will be appended
           *     'color': /\b(?:red|green|blue)\b/
           * });
           */
          extend: function(id, redef) {
            var lang2 = _.util.clone(_.languages[id]);
            for (var key in redef) {
              lang2[key] = redef[key];
            }
            return lang2;
          },
          /**
           * Inserts tokens _before_ another token in a language definition or any other grammar.
           *
           * ## Usage
           *
           * This helper method makes it easy to modify existing languages. For example, the CSS language definition
           * not only defines CSS highlighting for CSS documents, but also needs to define highlighting for CSS embedded
           * in HTML through `<style>` elements. To do this, it needs to modify `Prism.languages.markup` and add the
           * appropriate tokens. However, `Prism.languages.markup` is a regular JavaScript object literal, so if you do
           * this:
           *
           * ```js
           * Prism.languages.markup.style = {
           *     // token
           * };
           * ```
           *
           * then the `style` token will be added (and processed) at the end. `insertBefore` allows you to insert tokens
           * before existing tokens. For the CSS example above, you would use it like this:
           *
           * ```js
           * Prism.languages.insertBefore('markup', 'cdata', {
           *     'style': {
           *         // token
           *     }
           * });
           * ```
           *
           * ## Special cases
           *
           * If the grammars of `inside` and `insert` have tokens with the same name, the tokens in `inside`'s grammar
           * will be ignored.
           *
           * This behavior can be used to insert tokens after `before`:
           *
           * ```js
           * Prism.languages.insertBefore('markup', 'comment', {
           *     'comment': Prism.languages.markup.comment,
           *     // tokens after 'comment'
           * });
           * ```
           *
           * ## Limitations
           *
           * The main problem `insertBefore` has to solve is iteration order. Since ES2015, the iteration order for object
           * properties is guaranteed to be the insertion order (except for integer keys) but some browsers behave
           * differently when keys are deleted and re-inserted. So `insertBefore` can't be implemented by temporarily
           * deleting properties which is necessary to insert at arbitrary positions.
           *
           * To solve this problem, `insertBefore` doesn't actually insert the given tokens into the target object.
           * Instead, it will create a new object and replace all references to the target object with the new one. This
           * can be done without temporarily deleting properties, so the iteration order is well-defined.
           *
           * However, only references that can be reached from `Prism.languages` or `insert` will be replaced. I.e. if
           * you hold the target object in a variable, then the value of the variable will not change.
           *
           * ```js
           * var oldMarkup = Prism.languages.markup;
           * var newMarkup = Prism.languages.insertBefore('markup', 'comment', { ... });
           *
           * assert(oldMarkup !== Prism.languages.markup);
           * assert(newMarkup === Prism.languages.markup);
           * ```
           *
           * @param {string} inside The property of `root` (e.g. a language id in `Prism.languages`) that contains the
           * object to be modified.
           * @param {string} before The key to insert before.
           * @param {Grammar} insert An object containing the key-value pairs to be inserted.
           * @param {Object<string, any>} [root] The object containing `inside`, i.e. the object that contains the
           * object to be modified.
           *
           * Defaults to `Prism.languages`.
           * @returns {Grammar} The new grammar object.
           * @public
           */
          insertBefore: function(inside, before, insert, root) {
            root = root || /** @type {any} */
            _.languages;
            var grammar = root[inside];
            var ret = {};
            for (var token in grammar) {
              if (grammar.hasOwnProperty(token)) {
                if (token == before) {
                  for (var newToken in insert) {
                    if (insert.hasOwnProperty(newToken)) {
                      ret[newToken] = insert[newToken];
                    }
                  }
                }
                if (!insert.hasOwnProperty(token)) {
                  ret[token] = grammar[token];
                }
              }
            }
            var old = root[inside];
            root[inside] = ret;
            _.languages.DFS(_.languages, function(key, value) {
              if (value === old && key != inside) {
                this[key] = ret;
              }
            });
            return ret;
          },
          // Traverse a language definition with Depth First Search
          DFS: function DFS(o, callback, type, visited) {
            visited = visited || {};
            var objId = _.util.objId;
            for (var i in o) {
              if (o.hasOwnProperty(i)) {
                callback.call(o, i, o[i], type || i);
                var property = o[i];
                var propertyType = _.util.type(property);
                if (propertyType === "Object" && !visited[objId(property)]) {
                  visited[objId(property)] = true;
                  DFS(property, callback, null, visited);
                } else if (propertyType === "Array" && !visited[objId(property)]) {
                  visited[objId(property)] = true;
                  DFS(property, callback, i, visited);
                }
              }
            }
          }
        },
        plugins: {},
        /**
         * Low-level function, only use if you know what you’re doing. It accepts a string of text as input
         * and the language definitions to use, and returns a string with the HTML produced.
         *
         * The following hooks will be run:
         * 1. `before-tokenize`
         * 2. `after-tokenize`
         * 3. `wrap`: On each {@link Token}.
         *
         * @param {string} text A string with the code to be highlighted.
         * @param {Grammar} grammar An object containing the tokens to use.
         *
         * Usually a language definition like `Prism.languages.markup`.
         * @param {string} language The name of the language definition passed to `grammar`.
         * @returns {string} The highlighted HTML.
         * @memberof Prism
         * @public
         * @example
         * Prism.highlight('var foo = true;', Prism.languages.javascript, 'javascript');
         */
        highlight: function(text, grammar, language) {
          var env = {
            code: text,
            grammar,
            language
          };
          _.hooks.run("before-tokenize", env);
          if (!env.grammar) {
            throw new Error('The language "' + env.language + '" has no grammar.');
          }
          env.tokens = _.tokenize(env.code, env.grammar);
          _.hooks.run("after-tokenize", env);
          return Token.stringify(_.util.encode(env.tokens), env.language);
        },
        /**
         * This is the heart of Prism, and the most low-level function you can use. It accepts a string of text as input
         * and the language definitions to use, and returns an array with the tokenized code.
         *
         * When the language definition includes nested tokens, the function is called recursively on each of these tokens.
         *
         * This method could be useful in other contexts as well, as a very crude parser.
         *
         * @param {string} text A string with the code to be highlighted.
         * @param {Grammar} grammar An object containing the tokens to use.
         *
         * Usually a language definition like `Prism.languages.markup`.
         * @returns {TokenStream} An array of strings and tokens, a token stream.
         * @memberof Prism
         * @public
         * @example
         * let code = `var foo = 0;`;
         * let tokens = Prism.tokenize(code, Prism.languages.javascript);
         * tokens.forEach(token => {
         *     if (token instanceof Prism.Token && token.type === 'number') {
         *         console.log(`Found numeric literal: ${token.content}`);
         *     }
         * });
         */
        tokenize: function(text, grammar) {
          var rest = grammar.rest;
          if (rest) {
            for (var token in rest) {
              grammar[token] = rest[token];
            }
            delete grammar.rest;
          }
          var tokenList = new LinkedList();
          addAfter(tokenList, tokenList.head, text);
          matchGrammar(text, tokenList, grammar, tokenList.head, 0);
          return toArray(tokenList);
        },
        /**
         * @namespace
         * @memberof Prism
         * @public
         */
        hooks: {
          all: {},
          /**
           * Adds the given callback to the list of callbacks for the given hook.
           *
           * The callback will be invoked when the hook it is registered for is run.
           * Hooks are usually directly run by a highlight function but you can also run hooks yourself.
           *
           * One callback function can be registered to multiple hooks and the same hook multiple times.
           *
           * @param {string} name The name of the hook.
           * @param {HookCallback} callback The callback function which is given environment variables.
           * @public
           */
          add: function(name, callback) {
            var hooks2 = _.hooks.all;
            hooks2[name] = hooks2[name] || [];
            hooks2[name].push(callback);
          },
          /**
           * Runs a hook invoking all registered callbacks with the given environment variables.
           *
           * Callbacks will be invoked synchronously and in the order in which they were registered.
           *
           * @param {string} name The name of the hook.
           * @param {Object<string, any>} env The environment variables of the hook passed to all callbacks registered.
           * @public
           */
          run: function(name, env) {
            var callbacks = _.hooks.all[name];
            if (!callbacks || !callbacks.length) {
              return;
            }
            for (var i = 0, callback; callback = callbacks[i++]; ) {
              callback(env);
            }
          }
        },
        Token
      };
      function Token(type, content, alias, matchedStr) {
        this.type = type;
        this.content = content;
        this.alias = alias;
        this.length = (matchedStr || "").length | 0;
      }
      Token.stringify = function stringify(o, language) {
        if (typeof o == "string") {
          return o;
        }
        if (Array.isArray(o)) {
          var s = "";
          o.forEach(function(e) {
            s += stringify(e, language);
          });
          return s;
        }
        var env = {
          type: o.type,
          content: stringify(o.content, language),
          tag: "span",
          classes: ["token", o.type],
          attributes: {},
          language
        };
        var aliases = o.alias;
        if (aliases) {
          if (Array.isArray(aliases)) {
            Array.prototype.push.apply(env.classes, aliases);
          } else {
            env.classes.push(aliases);
          }
        }
        _.hooks.run("wrap", env);
        var attributes = "";
        for (var name in env.attributes) {
          attributes += " " + name + '="' + (env.attributes[name] || "").replace(/"/g, "&quot;") + '"';
        }
        return "<" + env.tag + ' class="' + env.classes.join(" ") + '"' + attributes + ">" + env.content + "</" + env.tag + ">";
      };
      function matchPattern(pattern, pos, text, lookbehind) {
        pattern.lastIndex = pos;
        var match = pattern.exec(text);
        if (match && lookbehind && match[1]) {
          var lookbehindLength = match[1].length;
          match.index += lookbehindLength;
          match[0] = match[0].slice(lookbehindLength);
        }
        return match;
      }
      function matchGrammar(text, tokenList, grammar, startNode, startPos, rematch) {
        for (var token in grammar) {
          if (!grammar.hasOwnProperty(token) || !grammar[token]) {
            continue;
          }
          var patterns = grammar[token];
          patterns = Array.isArray(patterns) ? patterns : [patterns];
          for (var j = 0; j < patterns.length; ++j) {
            if (rematch && rematch.cause == token + "," + j) {
              return;
            }
            var patternObj = patterns[j];
            var inside = patternObj.inside;
            var lookbehind = !!patternObj.lookbehind;
            var greedy = !!patternObj.greedy;
            var alias = patternObj.alias;
            if (greedy && !patternObj.pattern.global) {
              var flags = patternObj.pattern.toString().match(/[imsuy]*$/)[0];
              patternObj.pattern = RegExp(patternObj.pattern.source, flags + "g");
            }
            var pattern = patternObj.pattern || patternObj;
            for (var currentNode = startNode.next, pos = startPos; currentNode !== tokenList.tail; pos += currentNode.value.length, currentNode = currentNode.next) {
              if (rematch && pos >= rematch.reach) {
                break;
              }
              var str = currentNode.value;
              if (tokenList.length > text.length) {
                return;
              }
              if (str instanceof Token) {
                continue;
              }
              var removeCount = 1;
              var match;
              if (greedy) {
                match = matchPattern(pattern, pos, text, lookbehind);
                if (!match || match.index >= text.length) {
                  break;
                }
                var from = match.index;
                var to = match.index + match[0].length;
                var p = pos;
                p += currentNode.value.length;
                while (from >= p) {
                  currentNode = currentNode.next;
                  p += currentNode.value.length;
                }
                p -= currentNode.value.length;
                pos = p;
                if (currentNode.value instanceof Token) {
                  continue;
                }
                for (var k = currentNode; k !== tokenList.tail && (p < to || typeof k.value === "string"); k = k.next) {
                  removeCount++;
                  p += k.value.length;
                }
                removeCount--;
                str = text.slice(pos, p);
                match.index -= pos;
              } else {
                match = matchPattern(pattern, 0, str, lookbehind);
                if (!match) {
                  continue;
                }
              }
              var from = match.index;
              var matchStr = match[0];
              var before = str.slice(0, from);
              var after = str.slice(from + matchStr.length);
              var reach = pos + str.length;
              if (rematch && reach > rematch.reach) {
                rematch.reach = reach;
              }
              var removeFrom = currentNode.prev;
              if (before) {
                removeFrom = addAfter(tokenList, removeFrom, before);
                pos += before.length;
              }
              removeRange(tokenList, removeFrom, removeCount);
              var wrapped = new Token(token, inside ? _.tokenize(matchStr, inside) : matchStr, alias, matchStr);
              currentNode = addAfter(tokenList, removeFrom, wrapped);
              if (after) {
                addAfter(tokenList, currentNode, after);
              }
              if (removeCount > 1) {
                var nestedRematch = {
                  cause: token + "," + j,
                  reach
                };
                matchGrammar(text, tokenList, grammar, currentNode.prev, pos, nestedRematch);
                if (rematch && nestedRematch.reach > rematch.reach) {
                  rematch.reach = nestedRematch.reach;
                }
              }
            }
          }
        }
      }
      function LinkedList() {
        var head = { value: null, prev: null, next: null };
        var tail = { value: null, prev: head, next: null };
        head.next = tail;
        this.head = head;
        this.tail = tail;
        this.length = 0;
      }
      function addAfter(list, node, value) {
        var next = node.next;
        var newNode = { value, prev: node, next };
        node.next = newNode;
        next.prev = newNode;
        list.length++;
        return newNode;
      }
      function removeRange(list, node, count) {
        var next = node.next;
        for (var i = 0; i < count && next !== list.tail; i++) {
          next = next.next;
        }
        node.next = next;
        next.prev = node;
        list.length -= i;
      }
      function toArray(list) {
        var array = [];
        var node = list.head.next;
        while (node !== list.tail) {
          array.push(node.value);
          node = node.next;
        }
        return array;
      }
      return _;
    }();
    module.exports = Prism2;
    Prism2.default = Prism2;
  }
});

// src/prism-langs.ts
var Prism = __toESM(require_prism());
!function(e) {
  var n = { pattern: /\\[\\(){}[\]^$+*?|.]/, alias: "escape" }, t = /\\(?:x[\da-fA-F]{2}|u[\da-fA-F]{4}|u\{[\da-fA-F]+\}|0[0-7]{0,2}|[123][0-7]{2}|c[a-zA-Z]|.)/, a = "(?:[^\\\\-]|" + t.source + ")", a = RegExp(a + "-" + a), r = { pattern: /(<|')[^<>']+(?=[>']$)/, lookbehind: true, alias: "variable" };
  e.languages.regex = { "char-class": { pattern: /((?:^|[^\\])(?:\\\\)*)\[(?:[^\\\]]|\\[\s\S])*\]/, lookbehind: true, inside: { "char-class-negation": { pattern: /(^\[)\^/, lookbehind: true, alias: "operator" }, "char-class-punctuation": { pattern: /^\[|\]$/, alias: "punctuation" }, range: { pattern: a, inside: { escape: t, "range-punctuation": { pattern: /-/, alias: "operator" } } }, "special-escape": n, "char-set": { pattern: /\\[wsd]|\\p\{[^{}]+\}/i, alias: "class-name" }, escape: t } }, "special-escape": n, "char-set": { pattern: /\.|\\[wsd]|\\p\{[^{}]+\}/i, alias: "class-name" }, backreference: [{ pattern: /\\(?![123][0-7]{2})[1-9]/, alias: "keyword" }, { pattern: /\\k<[^<>']+>/, alias: "keyword", inside: { "group-name": r } }], anchor: { pattern: /[$^]|\\[ABbGZz]/, alias: "function" }, escape: t, group: [{ pattern: /\((?:\?(?:<[^<>']+>|'[^<>']+'|[>:]|<?[=!]|[idmnsuxU]+(?:-[idmnsuxU]+)?:?))?/, alias: "punctuation", inside: { "group-name": r } }, { pattern: /\)/, alias: "punctuation" }], quantifier: { pattern: /(?:[+*?]|\{\d+(?:,\d*)?\})[?+]?/, alias: "number" }, alternation: { pattern: /\|/, alias: "keyword" } };
}(Prism), Prism.languages.clike = { comment: [{ pattern: /(^|[^\\])\/\*[\s\S]*?(?:\*\/|$)/, lookbehind: true, greedy: true }, { pattern: /(^|[^\\:])\/\/.*/, lookbehind: true, greedy: true }], string: { pattern: /(["'])(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/, greedy: true }, "class-name": { pattern: /(\b(?:class|extends|implements|instanceof|interface|new|trait)\s+|\bcatch\s+\()[\w.\\]+/i, lookbehind: true, inside: { punctuation: /[.\\]/ } }, keyword: /\b(?:break|catch|continue|do|else|finally|for|function|if|in|instanceof|new|null|return|throw|try|while)\b/, boolean: /\b(?:false|true)\b/, function: /\b\w+(?=\()/, number: /\b0x[\da-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?/i, operator: /[<>]=?|[!=]=?=?|--?|\+\+?|&&?|\|\|?|[?*/~^%]/, punctuation: /[{}[\];(),.:]/ }, Prism.languages.javascript = Prism.languages.extend("clike", { "class-name": [Prism.languages.clike["class-name"], { pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$A-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\.(?:constructor|prototype))/, lookbehind: true }], keyword: [{ pattern: /((?:^|\})\s*)catch\b/, lookbehind: true }, { pattern: /(^|[^.]|\.\.\.\s*)\b(?:as|assert(?=\s*\{)|async(?=\s*(?:function\b|\(|[$\w\xA0-\uFFFF]|$))|await|break|case|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally(?=\s*(?:\{|$))|for|from(?=\s*(?:['"]|$))|function|(?:get|set)(?=\s*(?:[#\[$\w\xA0-\uFFFF]|$))|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)\b/, lookbehind: true }], function: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*(?:\.\s*(?:apply|bind|call)\s*)?\()/, number: { pattern: RegExp(/(^|[^\w$])/.source + "(?:" + /NaN|Infinity/.source + "|" + /0[bB][01]+(?:_[01]+)*n?/.source + "|" + /0[oO][0-7]+(?:_[0-7]+)*n?/.source + "|" + /0[xX][\dA-Fa-f]+(?:_[\dA-Fa-f]+)*n?/.source + "|" + /\d+(?:_\d+)*n/.source + "|" + /(?:\d+(?:_\d+)*(?:\.(?:\d+(?:_\d+)*)?)?|\.\d+(?:_\d+)*)(?:[Ee][+-]?\d+(?:_\d+)*)?/.source + ")" + /(?![\w$])/.source), lookbehind: true }, operator: /--|\+\+|\*\*=?|=>|&&=?|\|\|=?|[!=]==|<<=?|>>>?=?|[-+*/%&|^!=<>]=?|\.{3}|\?\?=?|\?\.?|[~:]/ }), Prism.languages.javascript["class-name"][0].pattern = /(\b(?:class|extends|implements|instanceof|interface|new)\s+)[\w.\\]+/, Prism.languages.insertBefore("javascript", "keyword", { regex: { pattern: RegExp(/((?:^|[^$\w\xA0-\uFFFF."'\])\s]|\b(?:return|yield))\s*)/.source + /\//.source + "(?:" + /(?:\[(?:[^\]\\\r\n]|\\.)*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}/.source + "|" + /(?:\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.|\[(?:[^[\]\\\r\n]|\\.)*\])*\])*\]|\\.|[^/\\\[\r\n])+\/[dgimyus]{0,7}v[dgimyus]{0,7}/.source + ")" + /(?=(?:\s|\/\*(?:[^*]|\*(?!\/))*\*\/)*(?:$|[\r\n,.;:})\]]|\/\/))/.source), lookbehind: true, greedy: true, inside: { "regex-source": { pattern: /^(\/)[\s\S]+(?=\/[a-z]*$)/, lookbehind: true, alias: "language-regex", inside: Prism.languages.regex }, "regex-delimiter": /^\/|\/$/, "regex-flags": /^[a-z]+$/ } }, "function-variable": { pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*[=:]\s*(?:async\s*)?(?:\bfunction\b|(?:\((?:[^()]|\([^()]*\))*\)|(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/, alias: "function" }, parameter: [{ pattern: /(function(?:\s+(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)?\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\))/, lookbehind: true, inside: Prism.languages.javascript }, { pattern: /(^|[^$\w\xA0-\uFFFF])(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=>)/i, lookbehind: true, inside: Prism.languages.javascript }, { pattern: /(\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*=>)/, lookbehind: true, inside: Prism.languages.javascript }, { pattern: /((?:\b|\s|^)(?!(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|undefined|var|void|while|with|yield)(?![$\w\xA0-\uFFFF]))(?:(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*)\(\s*|\]\s*\(\s*)(?!\s)(?:[^()\s]|\s+(?![\s)])|\([^()]*\))+(?=\s*\)\s*\{)/, lookbehind: true, inside: Prism.languages.javascript }], constant: /\b[A-Z](?:[A-Z_]|\dx?)*\b/ }), Prism.languages.insertBefore("javascript", "string", { hashbang: { pattern: /^#!.*/, greedy: true, alias: "comment" }, "template-string": { pattern: /`(?:\\[\s\S]|\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}|(?!\$\{)[^\\`])*`/, greedy: true, inside: { "template-punctuation": { pattern: /^`|`$/, alias: "string" }, interpolation: { pattern: /((?:^|[^\\])(?:\\{2})*)\$\{(?:[^{}]|\{(?:[^{}]|\{[^}]*\})*\})+\}/, lookbehind: true, inside: { "interpolation-punctuation": { pattern: /^\$\{|\}$/, alias: "punctuation" }, rest: Prism.languages.javascript } }, string: /[\s\S]+/ } }, "string-property": { pattern: /((?:^|[,{])[ \t]*)(["'])(?:\\(?:\r\n|[\s\S])|(?!\2)[^\\\r\n])*\2(?=\s*:)/m, lookbehind: true, greedy: true, alias: "property" } }), Prism.languages.insertBefore("javascript", "operator", { "literal-property": { pattern: /((?:^|[,{])[ \t]*)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*:)/m, lookbehind: true, alias: "property" } }), Prism.languages.markup && (Prism.languages.markup.tag.addInlined("script", "javascript"), Prism.languages.markup.tag.addAttribute(/on(?:abort|blur|change|click|composition(?:end|start|update)|dblclick|error|focus(?:in|out)?|key(?:down|up)|load|mouse(?:down|enter|leave|move|out|over|up)|reset|resize|scroll|select|slotchange|submit|unload|wheel)/.source, "javascript")), Prism.languages.js = Prism.languages.javascript, Prism.languages.actionscript = Prism.languages.extend("javascript", { keyword: /\b(?:as|break|case|catch|class|const|default|delete|do|dynamic|each|else|extends|final|finally|for|function|get|if|implements|import|in|include|instanceof|interface|internal|is|namespace|native|new|null|override|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|use|var|void|while|with)\b/, operator: /\+\+|--|(?:[+\-*\/%^]|&&?|\|\|?|<<?|>>?>?|[!=]=?)=?|[~?@]/ }), Prism.languages.actionscript["class-name"].alias = "function", delete Prism.languages.actionscript.parameter, delete Prism.languages.actionscript["literal-property"], Prism.languages.markup && Prism.languages.insertBefore("actionscript", "string", { xml: { pattern: /(^|[^.])<\/?\w+(?:\s+[^\s>\/=]+=("|')(?:\\[\s\S]|(?!\2)[^\\])*\2)*\s*\/?>/, lookbehind: true, inside: Prism.languages.markup } }), function(e) {
  var n = /#(?!\{).+/, t = { pattern: /#\{[^}]+\}/, alias: "variable" };
  e.languages.coffeescript = e.languages.extend("javascript", { comment: n, string: [{ pattern: /'(?:\\[\s\S]|[^\\'])*'/, greedy: true }, { pattern: /"(?:\\[\s\S]|[^\\"])*"/, greedy: true, inside: { interpolation: t } }], keyword: /\b(?:and|break|by|catch|class|continue|debugger|delete|do|each|else|extend|extends|false|finally|for|if|in|instanceof|is|isnt|let|loop|namespace|new|no|not|null|of|off|on|or|own|return|super|switch|then|this|throw|true|try|typeof|undefined|unless|until|when|while|window|with|yes|yield)\b/, "class-member": { pattern: /@(?!\d)\w+/, alias: "variable" } }), e.languages.insertBefore("coffeescript", "comment", { "multiline-comment": { pattern: /###[\s\S]+?###/, alias: "comment" }, "block-regex": { pattern: /\/{3}[\s\S]*?\/{3}/, alias: "regex", inside: { comment: n, interpolation: t } } }), e.languages.insertBefore("coffeescript", "string", { "inline-javascript": { pattern: /`(?:\\[\s\S]|[^\\`])*`/, inside: { delimiter: { pattern: /^`|`$/, alias: "punctuation" }, script: { pattern: /[\s\S]+/, alias: "language-javascript", inside: e.languages.javascript } } }, "multiline-string": [{ pattern: /'''[\s\S]*?'''/, greedy: true, alias: "string" }, { pattern: /"""[\s\S]*?"""/, greedy: true, alias: "string", inside: { interpolation: t } }] }), e.languages.insertBefore("coffeescript", "keyword", { property: /(?!\d)\w+(?=\s*:(?!:))/ }), delete e.languages.coffeescript["template-string"], e.languages.coffee = e.languages.coffeescript;
}(Prism), function(l) {
  var e = l.languages.javadoclike = { parameter: { pattern: /(^[\t ]*(?:\/{3}|\*|\/\*\*)\s*@(?:arg|arguments|param)\s+)\w+/m, lookbehind: true }, keyword: { pattern: /(^[\t ]*(?:\/{3}|\*|\/\*\*)\s*|\{)@[a-z][a-zA-Z-]+\b/m, lookbehind: true }, punctuation: /[{}]/ };
  Object.defineProperty(e, "addSupport", { value: function(e2, o) {
    (e2 = "string" == typeof e2 ? [e2] : e2).forEach(function(e3) {
      var n = function(e4) {
        e4.inside || (e4.inside = {}), e4.inside.rest = o;
      }, t = "doc-comment";
      if (a = l.languages[e3]) {
        var a, r = a[t];
        if ((r = r ? r : (a = l.languages.insertBefore(e3, "comment", { "doc-comment": { pattern: /(^|[^\\])\/\*\*[^/][\s\S]*?(?:\*\/|$)/, lookbehind: true, alias: "comment" } }))[t]) instanceof RegExp && (r = a[t] = { pattern: r }), Array.isArray(r))
          for (var s = 0, i = r.length; s < i; s++)
            r[s] instanceof RegExp && (r[s] = { pattern: r[s] }), n(r[s]);
        else
          n(r);
      }
    });
  } }), e.addSupport(["java", "javascript", "php"], e);
}(Prism), function(e) {
  var n = /(?:"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n])*')/, n = (e.languages.css = { comment: /\/\*[\s\S]*?\*\//, atrule: { pattern: RegExp("@[\\w-](?:" + /[^;{\s"']|\s+(?!\s)/.source + "|" + n.source + ")*?" + /(?:;|(?=\s*\{))/.source), inside: { rule: /^@[\w-]+/, "selector-function-argument": { pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/, lookbehind: true, alias: "selector" }, keyword: { pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/, lookbehind: true } } }, url: { pattern: RegExp("\\burl\\((?:" + n.source + "|" + /(?:[^\\\r\n()"']|\\[\s\S])*/.source + ")\\)", "i"), greedy: true, inside: { function: /^url/i, punctuation: /^\(|\)$/, string: { pattern: RegExp("^" + n.source + "$"), alias: "url" } } }, selector: { pattern: RegExp(`(^|[{}\\s])[^{}\\s](?:[^{};"'\\s]|\\s+(?![\\s{])|` + n.source + ")*(?=\\s*\\{)"), lookbehind: true }, string: { pattern: n, greedy: true }, property: { pattern: /(^|[^-\w\xA0-\uFFFF])(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i, lookbehind: true }, important: /!important\b/i, function: { pattern: /(^|[^-a-z0-9])[-a-z0-9]+(?=\()/i, lookbehind: true }, punctuation: /[(){};:,]/ }, e.languages.css.atrule.inside.rest = e.languages.css, e.languages.markup);
  n && (n.tag.addInlined("style", "css"), n.tag.addAttribute("style", "css"));
}(Prism), function(e) {
  var n = /("|')(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/, n = (e.languages.css.selector = { pattern: e.languages.css.selector.pattern, lookbehind: true, inside: n = { "pseudo-element": /:(?:after|before|first-letter|first-line|selection)|::[-\w]+/, "pseudo-class": /:[-\w]+/, class: /\.[-\w]+/, id: /#[-\w]+/, attribute: { pattern: RegExp(`\\[(?:[^[\\]"']|` + n.source + ")*\\]"), greedy: true, inside: { punctuation: /^\[|\]$/, "case-sensitivity": { pattern: /(\s)[si]$/i, lookbehind: true, alias: "keyword" }, namespace: { pattern: /^(\s*)(?:(?!\s)[-*\w\xA0-\uFFFF])*\|(?!=)/, lookbehind: true, inside: { punctuation: /\|$/ } }, "attr-name": { pattern: /^(\s*)(?:(?!\s)[-\w\xA0-\uFFFF])+/, lookbehind: true }, "attr-value": [n, { pattern: /(=\s*)(?:(?!\s)[-\w\xA0-\uFFFF])+(?=\s*$)/, lookbehind: true }], operator: /[|~*^$]?=/ } }, "n-th": [{ pattern: /(\(\s*)[+-]?\d*[\dn](?:\s*[+-]\s*\d+)?(?=\s*\))/, lookbehind: true, inside: { number: /[\dn]+/, operator: /[+-]/ } }, { pattern: /(\(\s*)(?:even|odd)(?=\s*\))/i, lookbehind: true }], combinator: />|\+|~|\|\|/, punctuation: /[(),]/ } }, e.languages.css.atrule.inside["selector-function-argument"].inside = n, e.languages.insertBefore("css", "property", { variable: { pattern: /(^|[^-\w\xA0-\uFFFF])--(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*/i, lookbehind: true } }), { pattern: /(\b\d+)(?:%|[a-z]+(?![\w-]))/, lookbehind: true }), t = { pattern: /(^|[^\w.-])-?(?:\d+(?:\.\d+)?|\.\d+)/, lookbehind: true };
  e.languages.insertBefore("css", "function", { operator: { pattern: /(\s)[+\-*\/](?=\s)/, lookbehind: true }, hexcode: { pattern: /\B#[\da-f]{3,8}\b/i, alias: "color" }, color: [{ pattern: /(^|[^\w-])(?:AliceBlue|AntiqueWhite|Aqua|Aquamarine|Azure|Beige|Bisque|Black|BlanchedAlmond|Blue|BlueViolet|Brown|BurlyWood|CadetBlue|Chartreuse|Chocolate|Coral|CornflowerBlue|Cornsilk|Crimson|Cyan|DarkBlue|DarkCyan|DarkGoldenRod|DarkGr[ae]y|DarkGreen|DarkKhaki|DarkMagenta|DarkOliveGreen|DarkOrange|DarkOrchid|DarkRed|DarkSalmon|DarkSeaGreen|DarkSlateBlue|DarkSlateGr[ae]y|DarkTurquoise|DarkViolet|DeepPink|DeepSkyBlue|DimGr[ae]y|DodgerBlue|FireBrick|FloralWhite|ForestGreen|Fuchsia|Gainsboro|GhostWhite|Gold|GoldenRod|Gr[ae]y|Green|GreenYellow|HoneyDew|HotPink|IndianRed|Indigo|Ivory|Khaki|Lavender|LavenderBlush|LawnGreen|LemonChiffon|LightBlue|LightCoral|LightCyan|LightGoldenRodYellow|LightGr[ae]y|LightGreen|LightPink|LightSalmon|LightSeaGreen|LightSkyBlue|LightSlateGr[ae]y|LightSteelBlue|LightYellow|Lime|LimeGreen|Linen|Magenta|Maroon|MediumAquaMarine|MediumBlue|MediumOrchid|MediumPurple|MediumSeaGreen|MediumSlateBlue|MediumSpringGreen|MediumTurquoise|MediumVioletRed|MidnightBlue|MintCream|MistyRose|Moccasin|NavajoWhite|Navy|OldLace|Olive|OliveDrab|Orange|OrangeRed|Orchid|PaleGoldenRod|PaleGreen|PaleTurquoise|PaleVioletRed|PapayaWhip|PeachPuff|Peru|Pink|Plum|PowderBlue|Purple|RebeccaPurple|Red|RosyBrown|RoyalBlue|SaddleBrown|Salmon|SandyBrown|SeaGreen|SeaShell|Sienna|Silver|SkyBlue|SlateBlue|SlateGr[ae]y|Snow|SpringGreen|SteelBlue|Tan|Teal|Thistle|Tomato|Transparent|Turquoise|Violet|Wheat|White|WhiteSmoke|Yellow|YellowGreen)(?![\w-])/i, lookbehind: true }, { pattern: /\b(?:hsl|rgb)\(\s*\d{1,3}\s*,\s*\d{1,3}%?\s*,\s*\d{1,3}%?\s*\)\B|\b(?:hsl|rgb)a\(\s*\d{1,3}\s*,\s*\d{1,3}%?\s*,\s*\d{1,3}%?\s*,\s*(?:0|0?\.\d+|1)\s*\)\B/i, inside: { unit: n, number: t, function: /[\w-]+(?=\()/, punctuation: /[(),]/ } }], entity: /\\[\da-f]{1,8}/i, unit: n, number: t });
}(Prism), function(e) {
  var n = /[*&][^\s[\]{},]+/, t = /!(?:<[\w\-%#;/?:@&=+$,.!~*'()[\]]+>|(?:[a-zA-Z\d-]*!)?[\w\-%#;/?:@&=+$.~*'()]+)?/, a = "(?:" + t.source + "(?:[ 	]+" + n.source + ")?|" + n.source + "(?:[ 	]+" + t.source + ")?)", r = /(?:[^\s\x00-\x08\x0e-\x1f!"#%&'*,\-:>?@[\]`{|}\x7f-\x84\x86-\x9f\ud800-\udfff\ufffe\uffff]|[?:-]<PLAIN>)(?:[ \t]*(?:(?![#:])<PLAIN>|:<PLAIN>))*/.source.replace(/<PLAIN>/g, function() {
    return /[^\s\x00-\x08\x0e-\x1f,[\]{}\x7f-\x84\x86-\x9f\ud800-\udfff\ufffe\uffff]/.source;
  }), s = /"(?:[^"\\\r\n]|\\.)*"|'(?:[^'\\\r\n]|\\.)*'/.source;
  function i(e2, n2) {
    n2 = (n2 || "").replace(/m/g, "") + "m";
    var t2 = /([:\-,[{]\s*(?:\s<<prop>>[ \t]+)?)(?:<<value>>)(?=[ \t]*(?:$|,|\]|\}|(?:[\r\n]\s*)?#))/.source.replace(/<<prop>>/g, function() {
      return a;
    }).replace(/<<value>>/g, function() {
      return e2;
    });
    return RegExp(t2, n2);
  }
  e.languages.yaml = { scalar: { pattern: RegExp(/([\-:]\s*(?:\s<<prop>>[ \t]+)?[|>])[ \t]*(?:((?:\r?\n|\r)[ \t]+)\S[^\r\n]*(?:\2[^\r\n]+)*)/.source.replace(/<<prop>>/g, function() {
    return a;
  })), lookbehind: true, alias: "string" }, comment: /#.*/, key: { pattern: RegExp(/((?:^|[:\-,[{\r\n?])[ \t]*(?:<<prop>>[ \t]+)?)<<key>>(?=\s*:\s)/.source.replace(/<<prop>>/g, function() {
    return a;
  }).replace(/<<key>>/g, function() {
    return "(?:" + r + "|" + s + ")";
  })), lookbehind: true, greedy: true, alias: "atrule" }, directive: { pattern: /(^[ \t]*)%.+/m, lookbehind: true, alias: "important" }, datetime: { pattern: i(/\d{4}-\d\d?-\d\d?(?:[tT]|[ \t]+)\d\d?:\d{2}:\d{2}(?:\.\d*)?(?:[ \t]*(?:Z|[-+]\d\d?(?::\d{2})?))?|\d{4}-\d{2}-\d{2}|\d\d?:\d{2}(?::\d{2}(?:\.\d*)?)?/.source), lookbehind: true, alias: "number" }, boolean: { pattern: i(/false|true/.source, "i"), lookbehind: true, alias: "important" }, null: { pattern: i(/null|~/.source, "i"), lookbehind: true, alias: "important" }, string: { pattern: i(s), lookbehind: true, greedy: true }, number: { pattern: i(/[+-]?(?:0x[\da-f]+|0o[0-7]+|(?:\d+(?:\.\d*)?|\.\d+)(?:e[+-]?\d+)?|\.inf|\.nan)/.source, "i"), lookbehind: true }, tag: t, important: n, punctuation: /---|[:[\]{}\-,|>?]|\.\.\./ }, e.languages.yml = e.languages.yaml;
}(Prism), Prism.languages.markup = { comment: { pattern: /<!--(?:(?!<!--)[\s\S])*?-->/, greedy: true }, prolog: { pattern: /<\?[\s\S]+?\?>/, greedy: true }, doctype: { pattern: /<!DOCTYPE(?:[^>"'[\]]|"[^"]*"|'[^']*')+(?:\[(?:[^<"'\]]|"[^"]*"|'[^']*'|<(?!!--)|<!--(?:[^-]|-(?!->))*-->)*\]\s*)?>/i, greedy: true, inside: { "internal-subset": { pattern: /(^[^\[]*\[)[\s\S]+(?=\]>$)/, lookbehind: true, greedy: true, inside: null }, string: { pattern: /"[^"]*"|'[^']*'/, greedy: true }, punctuation: /^<!|>$|[[\]]/, "doctype-tag": /^DOCTYPE/i, name: /[^\s<>'"]+/ } }, cdata: { pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i, greedy: true }, tag: { pattern: /<\/?(?!\d)[^\s>\/=$<%]+(?:\s(?:\s*[^\s>\/=]+(?:\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))|(?=[\s/>])))+)?\s*\/?>/, greedy: true, inside: { tag: { pattern: /^<\/?[^\s>\/]+/, inside: { punctuation: /^<\/?/, namespace: /^[^\s>\/:]+:/ } }, "special-attr": [], "attr-value": { pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/, inside: { punctuation: [{ pattern: /^=/, alias: "attr-equals" }, { pattern: /^(\s*)["']|["']$/, lookbehind: true }] } }, punctuation: /\/?>/, "attr-name": { pattern: /[^\s>\/]+/, inside: { namespace: /^[^\s>\/:]+:/ } } } }, entity: [{ pattern: /&[\da-z]{1,8};/i, alias: "named-entity" }, /&#x?[\da-f]{1,8};/i] }, Prism.languages.markup.tag.inside["attr-value"].inside.entity = Prism.languages.markup.entity, Prism.languages.markup.doctype.inside["internal-subset"].inside = Prism.languages.markup, Prism.hooks.add("wrap", function(e) {
  "entity" === e.type && (e.attributes.title = e.content.replace(/&amp;/, "&"));
}), Object.defineProperty(Prism.languages.markup.tag, "addInlined", { value: function(e, n) {
  var t = {}, t = (t["language-" + n] = { pattern: /(^<!\[CDATA\[)[\s\S]+?(?=\]\]>$)/i, lookbehind: true, inside: Prism.languages[n] }, t.cdata = /^<!\[CDATA\[|\]\]>$/i, { "included-cdata": { pattern: /<!\[CDATA\[[\s\S]*?\]\]>/i, inside: t } }), n = (t["language-" + n] = { pattern: /[\s\S]+/, inside: Prism.languages[n] }, {});
  n[e] = { pattern: RegExp(/(<__[^>]*>)(?:<!\[CDATA\[(?:[^\]]|\](?!\]>))*\]\]>|(?!<!\[CDATA\[)[\s\S])*?(?=<\/__>)/.source.replace(/__/g, function() {
    return e;
  }), "i"), lookbehind: true, greedy: true, inside: t }, Prism.languages.insertBefore("markup", "cdata", n);
} }), Object.defineProperty(Prism.languages.markup.tag, "addAttribute", { value: function(e, n) {
  Prism.languages.markup.tag.inside["special-attr"].push({ pattern: RegExp(/(^|["'\s])/.source + "(?:" + e + ")" + /\s*=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+(?=[\s>]))/.source, "i"), lookbehind: true, inside: { "attr-name": /^[^\s=]+/, "attr-value": { pattern: /=[\s\S]+/, inside: { value: { pattern: /(^=\s*(["']|(?!["'])))\S[\s\S]*(?=\2$)/, lookbehind: true, alias: [n, "language-" + n], inside: Prism.languages[n] }, punctuation: [{ pattern: /^=/, alias: "attr-equals" }, /"|'/] } } } });
} }), Prism.languages.html = Prism.languages.markup, Prism.languages.mathml = Prism.languages.markup, Prism.languages.svg = Prism.languages.markup, Prism.languages.xml = Prism.languages.extend("markup", {}), Prism.languages.ssml = Prism.languages.xml, Prism.languages.atom = Prism.languages.xml, Prism.languages.rss = Prism.languages.xml, function(o) {
  var n = /(?:\\.|[^\\\n\r]|(?:\n|\r\n?)(?![\r\n]))/.source;
  function e(e2) {
    return e2 = e2.replace(/<inner>/g, function() {
      return n;
    }), RegExp(/((?:^|[^\\])(?:\\{2})*)/.source + "(?:" + e2 + ")");
  }
  var t = /(?:\\.|``(?:[^`\r\n]|`(?!`))+``|`[^`\r\n]+`|[^\\|\r\n`])+/.source, a = /\|?__(?:\|__)+\|?(?:(?:\n|\r\n?)|(?![\s\S]))/.source.replace(/__/g, function() {
    return t;
  }), r = /\|?[ \t]*:?-{3,}:?[ \t]*(?:\|[ \t]*:?-{3,}:?[ \t]*)+\|?(?:\n|\r\n?)/.source, l = (o.languages.markdown = o.languages.extend("markup", {}), o.languages.insertBefore("markdown", "prolog", { "front-matter-block": { pattern: /(^(?:\s*[\r\n])?)---(?!.)[\s\S]*?[\r\n]---(?!.)/, lookbehind: true, greedy: true, inside: { punctuation: /^---|---$/, "front-matter": { pattern: /\S+(?:\s+\S+)*/, alias: ["yaml", "language-yaml"], inside: o.languages.yaml } } }, blockquote: { pattern: /^>(?:[\t ]*>)*/m, alias: "punctuation" }, table: { pattern: RegExp("^" + a + r + "(?:" + a + ")*", "m"), inside: { "table-data-rows": { pattern: RegExp("^(" + a + r + ")(?:" + a + ")*$"), lookbehind: true, inside: { "table-data": { pattern: RegExp(t), inside: o.languages.markdown }, punctuation: /\|/ } }, "table-line": { pattern: RegExp("^(" + a + ")" + r + "$"), lookbehind: true, inside: { punctuation: /\||:?-{3,}:?/ } }, "table-header-row": { pattern: RegExp("^" + a + "$"), inside: { "table-header": { pattern: RegExp(t), alias: "important", inside: o.languages.markdown }, punctuation: /\|/ } } } }, code: [{ pattern: /((?:^|\n)[ \t]*\n|(?:^|\r\n?)[ \t]*\r\n?)(?: {4}|\t).+(?:(?:\n|\r\n?)(?: {4}|\t).+)*/, lookbehind: true, alias: "keyword" }, { pattern: /^```[\s\S]*?^```$/m, greedy: true, inside: { "code-block": { pattern: /^(```.*(?:\n|\r\n?))[\s\S]+?(?=(?:\n|\r\n?)^```$)/m, lookbehind: true }, "code-language": { pattern: /^(```).+/, lookbehind: true }, punctuation: /```/ } }], title: [{ pattern: /\S.*(?:\n|\r\n?)(?:==+|--+)(?=[ \t]*$)/m, alias: "important", inside: { punctuation: /==+$|--+$/ } }, { pattern: /(^\s*)#.+/m, lookbehind: true, alias: "important", inside: { punctuation: /^#+|#+$/ } }], hr: { pattern: /(^\s*)([*-])(?:[\t ]*\2){2,}(?=\s*$)/m, lookbehind: true, alias: "punctuation" }, list: { pattern: /(^\s*)(?:[*+-]|\d+\.)(?=[\t ].)/m, lookbehind: true, alias: "punctuation" }, "url-reference": { pattern: /!?\[[^\]]+\]:[\t ]+(?:\S+|<(?:\\.|[^>\\])+>)(?:[\t ]+(?:"(?:\\.|[^"\\])*"|'(?:\\.|[^'\\])*'|\((?:\\.|[^)\\])*\)))?/, inside: { variable: { pattern: /^(!?\[)[^\]]+/, lookbehind: true }, string: /(?:"(?:\\.|[^"\\])*"|'(?:\\.|[^'\\])*'|\((?:\\.|[^)\\])*\))$/, punctuation: /^[\[\]!:]|[<>]/ }, alias: "url" }, bold: { pattern: e(/\b__(?:(?!_)<inner>|_(?:(?!_)<inner>)+_)+__\b|\*\*(?:(?!\*)<inner>|\*(?:(?!\*)<inner>)+\*)+\*\*/.source), lookbehind: true, greedy: true, inside: { content: { pattern: /(^..)[\s\S]+(?=..$)/, lookbehind: true, inside: {} }, punctuation: /\*\*|__/ } }, italic: { pattern: e(/\b_(?:(?!_)<inner>|__(?:(?!_)<inner>)+__)+_\b|\*(?:(?!\*)<inner>|\*\*(?:(?!\*)<inner>)+\*\*)+\*/.source), lookbehind: true, greedy: true, inside: { content: { pattern: /(^.)[\s\S]+(?=.$)/, lookbehind: true, inside: {} }, punctuation: /[*_]/ } }, strike: { pattern: e(/(~~?)(?:(?!~)<inner>)+\2/.source), lookbehind: true, greedy: true, inside: { content: { pattern: /(^~~?)[\s\S]+(?=\1$)/, lookbehind: true, inside: {} }, punctuation: /~~?/ } }, "code-snippet": { pattern: /(^|[^\\`])(?:``[^`\r\n]+(?:`[^`\r\n]+)*``(?!`)|`[^`\r\n]+`(?!`))/, lookbehind: true, greedy: true, alias: ["code", "keyword"] }, url: { pattern: e(/!?\[(?:(?!\])<inner>)+\](?:\([^\s)]+(?:[\t ]+"(?:\\.|[^"\\])*")?\)|[ \t]?\[(?:(?!\])<inner>)+\])/.source), lookbehind: true, greedy: true, inside: { operator: /^!/, content: { pattern: /(^\[)[^\]]+(?=\])/, lookbehind: true, inside: {} }, variable: { pattern: /(^\][ \t]?\[)[^\]]+(?=\]$)/, lookbehind: true }, url: { pattern: /(^\]\()[^\s)]+/, lookbehind: true }, string: { pattern: /(^[ \t]+)"(?:\\.|[^"\\])*"(?=\)$)/, lookbehind: true } } } }), ["url", "bold", "italic", "strike"].forEach(function(n2) {
    ["url", "bold", "italic", "strike", "code-snippet"].forEach(function(e2) {
      n2 !== e2 && (o.languages.markdown[n2].inside.content.inside[e2] = o.languages.markdown[e2]);
    });
  }), o.hooks.add("after-tokenize", function(e2) {
    "markdown" !== e2.language && "md" !== e2.language || !function e3(n2) {
      if (n2 && "string" != typeof n2)
        for (var t2 = 0, a2 = n2.length; t2 < a2; t2++) {
          var r2, s = n2[t2];
          "code" !== s.type ? e3(s.content) : (r2 = s.content[1], s = s.content[3], r2 && s && "code-language" === r2.type && "code-block" === s.type && "string" == typeof r2.content && (r2 = r2.content.replace(/\b#/g, "sharp").replace(/\b\+\+/g, "pp"), r2 = "language-" + (r2 = (/[a-z][\w-]*/i.exec(r2) || [""])[0].toLowerCase()), s.alias ? "string" == typeof s.alias ? s.alias = [s.alias, r2] : s.alias.push(r2) : s.alias = [r2]));
        }
    }(e2.tokens);
  }), o.hooks.add("wrap", function(e2) {
    if ("code-block" === e2.type) {
      for (var n2 = "", t2 = 0, a2 = e2.classes.length; t2 < a2; t2++) {
        var r2 = e2.classes[t2], r2 = /language-(.+)/.exec(r2);
        if (r2) {
          n2 = r2[1];
          break;
        }
      }
      var s, i = o.languages[n2];
      i ? e2.content = o.highlight(function(e3) {
        e3 = e3.replace(l, "");
        return e3 = e3.replace(/&(\w{1,8}|#x?[\da-f]{1,8});/gi, function(e4, n3) {
          var t3;
          return "#" === (n3 = n3.toLowerCase())[0] ? (t3 = "x" === n3[1] ? parseInt(n3.slice(2), 16) : Number(n3.slice(1)), c(t3)) : u[n3] || e4;
        });
      }(e2.content), i, n2) : n2 && "none" !== n2 && o.plugins.autoloader && (s = "md-" + (/* @__PURE__ */ new Date()).valueOf() + "-" + Math.floor(1e16 * Math.random()), e2.attributes.id = s, o.plugins.autoloader.loadLanguages(n2, function() {
        var e3 = document.getElementById(s);
        e3 && (e3.innerHTML = o.highlight(e3.textContent, o.languages[n2], n2));
      }));
    }
  }), RegExp(o.languages.markup.tag.pattern.source, "gi")), u = { amp: "&", lt: "<", gt: ">", quot: '"' }, c = String.fromCodePoint || String.fromCharCode;
  o.languages.md = o.languages.markdown;
}(Prism), Prism.languages.graphql = { comment: /#.*/, description: { pattern: /(?:"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*")(?=\s*[a-z_])/i, greedy: true, alias: "string", inside: { "language-markdown": { pattern: /(^"(?:"")?)(?!\1)[\s\S]+(?=\1$)/, lookbehind: true, inside: Prism.languages.markdown } } }, string: { pattern: /"""(?:[^"]|(?!""")")*"""|"(?:\\.|[^\\"\r\n])*"/, greedy: true }, number: /(?:\B-|\b)\d+(?:\.\d+)?(?:e[+-]?\d+)?\b/i, boolean: /\b(?:false|true)\b/, variable: /\$[a-z_]\w*/i, directive: { pattern: /@[a-z_]\w*/i, alias: "function" }, "attr-name": { pattern: /\b[a-z_]\w*(?=\s*(?:\((?:[^()"]|"(?:\\.|[^\\"\r\n])*")*\))?:)/i, greedy: true }, "atom-input": { pattern: /\b[A-Z]\w*Input\b/, alias: "class-name" }, scalar: /\b(?:Boolean|Float|ID|Int|String)\b/, constant: /\b[A-Z][A-Z_\d]*\b/, "class-name": { pattern: /(\b(?:enum|implements|interface|on|scalar|type|union)\s+|&\s*|:\s*|\[)[A-Z_]\w*/, lookbehind: true }, fragment: { pattern: /(\bfragment\s+|\.{3}\s*(?!on\b))[a-zA-Z_]\w*/, lookbehind: true, alias: "function" }, "definition-mutation": { pattern: /(\bmutation\s+)[a-zA-Z_]\w*/, lookbehind: true, alias: "function" }, "definition-query": { pattern: /(\bquery\s+)[a-zA-Z_]\w*/, lookbehind: true, alias: "function" }, keyword: /\b(?:directive|enum|extend|fragment|implements|input|interface|mutation|on|query|repeatable|scalar|schema|subscription|type|union)\b/, operator: /[!=|&]|\.{3}/, "property-query": /\w+(?=\s*\()/, object: /\w+(?=\s*\{)/, punctuation: /[!(){}\[\]:=,]/, property: /\w+/ }, Prism.hooks.add("after-tokenize", function(e) {
  if ("graphql" === e.language)
    for (var i = e.tokens.filter(function(e2) {
      return "string" != typeof e2 && "comment" !== e2.type && "scalar" !== e2.type;
    }), o = 0; o < i.length; ) {
      var n = i[o++];
      if ("keyword" === n.type && "mutation" === n.content) {
        var t = [];
        if (p(["definition-mutation", "punctuation"]) && "(" === c(1).content) {
          o += 2;
          var a = d(/^\($/, /^\)$/);
          if (-1 === a)
            continue;
          for (; o < a; o++) {
            var r = c(0);
            "variable" === r.type && (g(r, "variable-input"), t.push(r.content));
          }
          o = a + 1;
        }
        if (p(["punctuation", "property-query"]) && "{" === c(0).content && (o++, g(c(0), "property-mutation"), 0 < t.length)) {
          var s = d(/^\{$/, /^\}$/);
          if (-1 !== s)
            for (var l = o; l < s; l++) {
              var u = i[l];
              "variable" === u.type && 0 <= t.indexOf(u.content) && g(u, "variable-input");
            }
        }
      }
    }
  function c(e2) {
    return i[o + e2];
  }
  function p(e2, n2) {
    n2 = n2 || 0;
    for (var t2 = 0; t2 < e2.length; t2++) {
      var a2 = c(t2 + n2);
      if (!a2 || a2.type !== e2[t2])
        return;
    }
    return 1;
  }
  function d(e2, n2) {
    for (var t2 = 1, a2 = o; a2 < i.length; a2++) {
      var r2 = i[a2], s2 = r2.content;
      if ("punctuation" === r2.type && "string" == typeof s2) {
        if (e2.test(s2))
          t2++;
        else if (n2.test(s2) && 0 === --t2)
          return a2;
      }
    }
    return -1;
  }
  function g(e2, n2) {
    var t2 = e2.alias;
    t2 ? Array.isArray(t2) || (e2.alias = t2 = [t2]) : e2.alias = t2 = [], t2.push(n2);
  }
}), Prism.languages.sql = { comment: { pattern: /(^|[^\\])(?:\/\*[\s\S]*?\*\/|(?:--|\/\/|#).*)/, lookbehind: true }, variable: [{ pattern: /@(["'`])(?:\\[\s\S]|(?!\1)[^\\])+\1/, greedy: true }, /@[\w.$]+/], string: { pattern: /(^|[^@\\])("|')(?:\\[\s\S]|(?!\2)[^\\]|\2\2)*\2/, greedy: true, lookbehind: true }, identifier: { pattern: /(^|[^@\\])`(?:\\[\s\S]|[^`\\]|``)*`/, greedy: true, lookbehind: true, inside: { punctuation: /^`|`$/ } }, function: /\b(?:AVG|COUNT|FIRST|FORMAT|LAST|LCASE|LEN|MAX|MID|MIN|MOD|NOW|ROUND|SUM|UCASE)(?=\s*\()/i, keyword: /\b(?:ACTION|ADD|AFTER|ALGORITHM|ALL|ALTER|ANALYZE|ANY|APPLY|AS|ASC|AUTHORIZATION|AUTO_INCREMENT|BACKUP|BDB|BEGIN|BERKELEYDB|BIGINT|BINARY|BIT|BLOB|BOOL|BOOLEAN|BREAK|BROWSE|BTREE|BULK|BY|CALL|CASCADED?|CASE|CHAIN|CHAR(?:ACTER|SET)?|CHECK(?:POINT)?|CLOSE|CLUSTERED|COALESCE|COLLATE|COLUMNS?|COMMENT|COMMIT(?:TED)?|COMPUTE|CONNECT|CONSISTENT|CONSTRAINT|CONTAINS(?:TABLE)?|CONTINUE|CONVERT|CREATE|CROSS|CURRENT(?:_DATE|_TIME|_TIMESTAMP|_USER)?|CURSOR|CYCLE|DATA(?:BASES?)?|DATE(?:TIME)?|DAY|DBCC|DEALLOCATE|DEC|DECIMAL|DECLARE|DEFAULT|DEFINER|DELAYED|DELETE|DELIMITERS?|DENY|DESC|DESCRIBE|DETERMINISTIC|DISABLE|DISCARD|DISK|DISTINCT|DISTINCTROW|DISTRIBUTED|DO|DOUBLE|DROP|DUMMY|DUMP(?:FILE)?|DUPLICATE|ELSE(?:IF)?|ENABLE|ENCLOSED|END|ENGINE|ENUM|ERRLVL|ERRORS|ESCAPED?|EXCEPT|EXEC(?:UTE)?|EXISTS|EXIT|EXPLAIN|EXTENDED|FETCH|FIELDS|FILE|FILLFACTOR|FIRST|FIXED|FLOAT|FOLLOWING|FOR(?: EACH ROW)?|FORCE|FOREIGN|FREETEXT(?:TABLE)?|FROM|FULL|FUNCTION|GEOMETRY(?:COLLECTION)?|GLOBAL|GOTO|GRANT|GROUP|HANDLER|HASH|HAVING|HOLDLOCK|HOUR|IDENTITY(?:COL|_INSERT)?|IF|IGNORE|IMPORT|INDEX|INFILE|INNER|INNODB|INOUT|INSERT|INT|INTEGER|INTERSECT|INTERVAL|INTO|INVOKER|ISOLATION|ITERATE|JOIN|KEYS?|KILL|LANGUAGE|LAST|LEAVE|LEFT|LEVEL|LIMIT|LINENO|LINES|LINESTRING|LOAD|LOCAL|LOCK|LONG(?:BLOB|TEXT)|LOOP|MATCH(?:ED)?|MEDIUM(?:BLOB|INT|TEXT)|MERGE|MIDDLEINT|MINUTE|MODE|MODIFIES|MODIFY|MONTH|MULTI(?:LINESTRING|POINT|POLYGON)|NATIONAL|NATURAL|NCHAR|NEXT|NO|NONCLUSTERED|NULLIF|NUMERIC|OFF?|OFFSETS?|ON|OPEN(?:DATASOURCE|QUERY|ROWSET)?|OPTIMIZE|OPTION(?:ALLY)?|ORDER|OUT(?:ER|FILE)?|OVER|PARTIAL|PARTITION|PERCENT|PIVOT|PLAN|POINT|POLYGON|PRECEDING|PRECISION|PREPARE|PREV|PRIMARY|PRINT|PRIVILEGES|PROC(?:EDURE)?|PUBLIC|PURGE|QUICK|RAISERROR|READS?|REAL|RECONFIGURE|REFERENCES|RELEASE|RENAME|REPEAT(?:ABLE)?|REPLACE|REPLICATION|REQUIRE|RESIGNAL|RESTORE|RESTRICT|RETURN(?:ING|S)?|REVOKE|RIGHT|ROLLBACK|ROUTINE|ROW(?:COUNT|GUIDCOL|S)?|RTREE|RULE|SAVE(?:POINT)?|SCHEMA|SECOND|SELECT|SERIAL(?:IZABLE)?|SESSION(?:_USER)?|SET(?:USER)?|SHARE|SHOW|SHUTDOWN|SIMPLE|SMALLINT|SNAPSHOT|SOME|SONAME|SQL|START(?:ING)?|STATISTICS|STATUS|STRIPED|SYSTEM_USER|TABLES?|TABLESPACE|TEMP(?:ORARY|TABLE)?|TERMINATED|TEXT(?:SIZE)?|THEN|TIME(?:STAMP)?|TINY(?:BLOB|INT|TEXT)|TOP?|TRAN(?:SACTIONS?)?|TRIGGER|TRUNCATE|TSEQUAL|TYPES?|UNBOUNDED|UNCOMMITTED|UNDEFINED|UNION|UNIQUE|UNLOCK|UNPIVOT|UNSIGNED|UPDATE(?:TEXT)?|USAGE|USE|USER|USING|VALUES?|VAR(?:BINARY|CHAR|CHARACTER|YING)|VIEW|WAITFOR|WARNINGS|WHEN|WHERE|WHILE|WITH(?: ROLLUP|IN)?|WORK|WRITE(?:TEXT)?|YEAR)\b/i, boolean: /\b(?:FALSE|NULL|TRUE)\b/i, number: /\b0x[\da-f]+\b|\b\d+(?:\.\d*)?|\B\.\d+\b/i, operator: /[-+*\/=%^~]|&&?|\|\|?|!=?|<(?:=>?|<|>)?|>[>=]?|\b(?:AND|BETWEEN|DIV|ILIKE|IN|IS|LIKE|NOT|OR|REGEXP|RLIKE|SOUNDS LIKE|XOR)\b/i, punctuation: /[;[\]()`,.]/ }, function(b) {
  var e = b.languages.javascript["template-string"], t = e.pattern.source, m = e.inside.interpolation, f = m.inside["interpolation-punctuation"], s = m.pattern.source;
  function n(e2, n2) {
    if (b.languages[e2])
      return { pattern: RegExp("((?:" + n2 + ")\\s*)" + t), lookbehind: true, greedy: true, inside: { "template-punctuation": { pattern: /^`|`$/, alias: "string" }, "embedded-code": { pattern: /[\s\S]+/, alias: e2 } } };
  }
  function h(e2, n2, t2) {
    e2 = { code: e2, grammar: n2, language: t2 };
    return b.hooks.run("before-tokenize", e2), e2.tokens = b.tokenize(e2.code, e2.grammar), b.hooks.run("after-tokenize", e2), e2.tokens;
  }
  function l(a2, e2, r) {
    var n2 = b.tokenize(a2, { interpolation: { pattern: RegExp(s), lookbehind: true } }), p = 0, d = {}, n2 = h(n2.map(function(e3) {
      if ("string" == typeof e3)
        return e3;
      for (var n3, t2, e3 = e3.content; -1 !== a2.indexOf((t2 = p++, n3 = "___" + r.toUpperCase() + "_" + t2 + "___")); )
        ;
      return d[n3] = e3, n3;
    }).join(""), e2, r), g = Object.keys(d);
    return p = 0, function e3(n3) {
      for (var t2 = 0; t2 < n3.length; t2++) {
        if (p >= g.length)
          return;
        var a3, r2, s2, i, o, l2, u2, c = n3[t2];
        "string" == typeof c || "string" == typeof c.content ? (a3 = g[p], -1 !== (u2 = (l2 = "string" == typeof c ? c : c.content).indexOf(a3)) && (++p, r2 = l2.substring(0, u2), o = d[a3], s2 = void 0, (i = {})["interpolation-punctuation"] = f, 3 === (i = b.tokenize(o, i)).length && ((s2 = [1, 1]).push.apply(s2, h(i[1], b.languages.javascript, "javascript")), i.splice.apply(i, s2)), s2 = new b.Token("interpolation", i, m.alias, o), i = l2.substring(u2 + a3.length), o = [], r2 && o.push(r2), o.push(s2), i && (e3(l2 = [i]), o.push.apply(o, l2)), "string" == typeof c ? (n3.splice.apply(n3, [t2, 1].concat(o)), t2 += o.length - 1) : c.content = o)) : (u2 = c.content, Array.isArray(u2) ? e3(u2) : e3([u2]));
      }
    }(n2), new b.Token(r, n2, "language-" + r, a2);
  }
  b.languages.javascript["template-string"] = [n("css", /\b(?:styled(?:\([^)]*\))?(?:\s*\.\s*\w+(?:\([^)]*\))*)*|css(?:\s*\.\s*(?:global|resolve))?|createGlobalStyle|keyframes)/.source), n("html", /\bhtml|\.\s*(?:inner|outer)HTML\s*\+?=/.source), n("svg", /\bsvg/.source), n("markdown", /\b(?:markdown|md)/.source), n("graphql", /\b(?:gql|graphql(?:\s*\.\s*experimental)?)/.source), n("sql", /\bsql/.source), e].filter(Boolean);
  var a = { javascript: true, js: true, typescript: true, ts: true, jsx: true, tsx: true };
  function u(e2) {
    return "string" == typeof e2 ? e2 : Array.isArray(e2) ? e2.map(u).join("") : u(e2.content);
  }
  b.hooks.add("after-tokenize", function(e2) {
    e2.language in a && !function e3(n2) {
      for (var t2 = 0, a2 = n2.length; t2 < a2; t2++) {
        var r, s2, i, o = n2[t2];
        "string" != typeof o && (r = o.content, Array.isArray(r) ? "template-string" === o.type ? (o = r[1], 3 === r.length && "string" != typeof o && "embedded-code" === o.type && (s2 = u(o), o = o.alias, o = Array.isArray(o) ? o[0] : o, i = b.languages[o]) && (r[1] = l(s2, i, o))) : e3(r) : "string" != typeof r && e3([r]));
      }
    }(e2.tokens);
  });
}(Prism), function(e) {
  e.languages.typescript = e.languages.extend("javascript", { "class-name": { pattern: /(\b(?:class|extends|implements|instanceof|interface|new|type)\s+)(?!keyof\b)(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?:\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>)?/, lookbehind: true, greedy: true, inside: null }, builtin: /\b(?:Array|Function|Promise|any|boolean|console|never|number|string|symbol|unknown)\b/ }), e.languages.typescript.keyword.push(/\b(?:abstract|declare|is|keyof|readonly|require)\b/, /\b(?:asserts|infer|interface|module|namespace|type)\b(?=\s*(?:[{_$a-zA-Z\xA0-\uFFFF]|$))/, /\btype\b(?=\s*(?:[\{*]|$))/), delete e.languages.typescript.parameter, delete e.languages.typescript["literal-property"];
  var n = e.languages.extend("typescript", {});
  delete n["class-name"], e.languages.typescript["class-name"].inside = n, e.languages.insertBefore("typescript", "function", { decorator: { pattern: /@[$\w\xA0-\uFFFF]+/, inside: { at: { pattern: /^@/, alias: "operator" }, function: /^[\s\S]+/ } }, "generic-function": { pattern: /#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>(?=\s*\()/, greedy: true, inside: { function: /^#?(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*/, generic: { pattern: /<[\s\S]+/, alias: "class-name", inside: n } } } }), e.languages.ts = e.languages.typescript;
}(Prism), function(e) {
  var n = e.languages.javascript, t = /\{(?:[^{}]|\{(?:[^{}]|\{[^{}]*\})*\})+\}/.source, a = "(@(?:arg|argument|param|property)\\s+(?:" + t + "\\s+)?)";
  e.languages.jsdoc = e.languages.extend("javadoclike", { parameter: { pattern: RegExp(a + /(?:(?!\s)[$\w\xA0-\uFFFF.])+(?=\s|$)/.source), lookbehind: true, inside: { punctuation: /\./ } } }), e.languages.insertBefore("jsdoc", "keyword", { "optional-parameter": { pattern: RegExp(a + /\[(?:(?!\s)[$\w\xA0-\uFFFF.])+(?:=[^[\]]+)?\](?=\s|$)/.source), lookbehind: true, inside: { parameter: { pattern: /(^\[)[$\w\xA0-\uFFFF\.]+/, lookbehind: true, inside: { punctuation: /\./ } }, code: { pattern: /(=)[\s\S]*(?=\]$)/, lookbehind: true, inside: n, alias: "language-javascript" }, punctuation: /[=[\]]/ } }, "class-name": [{ pattern: RegExp(/(@(?:augments|class|extends|interface|memberof!?|template|this|typedef)\s+(?:<TYPE>\s+)?)[A-Z]\w*(?:\.[A-Z]\w*)*/.source.replace(/<TYPE>/g, function() {
    return t;
  })), lookbehind: true, inside: { punctuation: /\./ } }, { pattern: RegExp("(@[a-z]+\\s+)" + t), lookbehind: true, inside: { string: n.string, number: n.number, boolean: n.boolean, keyword: e.languages.typescript.keyword, operator: /=>|\.\.\.|[&|?:*]/, punctuation: /[.,;=<>{}()[\]]/ } }], example: { pattern: /(@example\s+(?!\s))(?:[^@\s]|\s+(?!\s))+?(?=\s*(?:\*\s*)?(?:@\w|\*\/))/, lookbehind: true, inside: { code: { pattern: /^([\t ]*(?:\*\s*)?)\S.*$/m, lookbehind: true, inside: n, alias: "language-javascript" } } } }), e.languages.javadoclike.addSupport("javascript", e.languages.jsdoc);
}(Prism), function(e) {
  e.languages.flow = e.languages.extend("javascript", {}), e.languages.insertBefore("flow", "keyword", { type: [{ pattern: /\b(?:[Bb]oolean|Function|[Nn]umber|[Ss]tring|[Ss]ymbol|any|mixed|null|void)\b/, alias: "class-name" }] }), e.languages.flow["function-variable"].pattern = /(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=\s*(?:function\b|(?:\([^()]*\)(?:\s*:\s*\w+)?|(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/i, delete e.languages.flow.parameter, e.languages.insertBefore("flow", "operator", { "flow-punctuation": { pattern: /\{\||\|\}/, alias: "punctuation" } }), Array.isArray(e.languages.flow.keyword) || (e.languages.flow.keyword = [e.languages.flow.keyword]), e.languages.flow.keyword.unshift({ pattern: /(^|[^$]\b)(?:Class|declare|opaque|type)\b(?!\$)/, lookbehind: true }, { pattern: /(^|[^$]\B)\$(?:Diff|Enum|Exact|Keys|ObjMap|PropertyType|Record|Shape|Subtype|Supertype|await)\b(?!\$)/, lookbehind: true });
}(Prism), Prism.languages.n4js = Prism.languages.extend("javascript", { keyword: /\b(?:Array|any|boolean|break|case|catch|class|const|constructor|continue|debugger|declare|default|delete|do|else|enum|export|extends|false|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|module|new|null|number|package|private|protected|public|return|set|static|string|super|switch|this|throw|true|try|typeof|var|void|while|with|yield)\b/ }), Prism.languages.insertBefore("n4js", "constant", { annotation: { pattern: /@+\w+/, alias: "operator" } }), Prism.languages.n4jsd = Prism.languages.n4js, function(e) {
  function n(e2, n2) {
    return RegExp(e2.replace(/<ID>/g, function() {
      return /(?!\s)[_$a-zA-Z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*/.source;
    }), n2);
  }
  e.languages.insertBefore("javascript", "function-variable", { "method-variable": { pattern: RegExp("(\\.\\s*)" + e.languages.javascript["function-variable"].pattern.source), lookbehind: true, alias: ["function-variable", "method", "function", "property-access"] } }), e.languages.insertBefore("javascript", "function", { method: { pattern: RegExp("(\\.\\s*)" + e.languages.javascript.function.source), lookbehind: true, alias: ["function", "property-access"] } }), e.languages.insertBefore("javascript", "constant", { "known-class-name": [{ pattern: /\b(?:(?:Float(?:32|64)|(?:Int|Uint)(?:8|16|32)|Uint8Clamped)?Array|ArrayBuffer|BigInt|Boolean|DataView|Date|Error|Function|Intl|JSON|(?:Weak)?(?:Map|Set)|Math|Number|Object|Promise|Proxy|Reflect|RegExp|String|Symbol|WebAssembly)\b/, alias: "class-name" }, { pattern: /\b(?:[A-Z]\w*)Error\b/, alias: "class-name" }] }), e.languages.insertBefore("javascript", "keyword", { imports: { pattern: n(/(\bimport\b\s*)(?:<ID>(?:\s*,\s*(?:\*\s*as\s+<ID>|\{[^{}]*\}))?|\*\s*as\s+<ID>|\{[^{}]*\})(?=\s*\bfrom\b)/.source), lookbehind: true, inside: e.languages.javascript }, exports: { pattern: n(/(\bexport\b\s*)(?:\*(?:\s*as\s+<ID>)?(?=\s*\bfrom\b)|\{[^{}]*\})/.source), lookbehind: true, inside: e.languages.javascript } }), e.languages.javascript.keyword.unshift({ pattern: /\b(?:as|default|export|from|import)\b/, alias: "module" }, { pattern: /\b(?:await|break|catch|continue|do|else|finally|for|if|return|switch|throw|try|while|yield)\b/, alias: "control-flow" }, { pattern: /\bnull\b/, alias: ["null", "nil"] }, { pattern: /\bundefined\b/, alias: "nil" }), e.languages.insertBefore("javascript", "operator", { spread: { pattern: /\.{3}/, alias: "operator" }, arrow: { pattern: /=>/, alias: "operator" } }), e.languages.insertBefore("javascript", "punctuation", { "property-access": { pattern: n(/(\.\s*)#?<ID>/.source), lookbehind: true }, "maybe-class-name": { pattern: /(^|[^$\w\xA0-\uFFFF])[A-Z][$\w\xA0-\uFFFF]+/, lookbehind: true }, dom: { pattern: /\b(?:document|(?:local|session)Storage|location|navigator|performance|window)\b/, alias: "variable" }, console: { pattern: /\bconsole(?=\s*\.)/, alias: "class-name" } });
  for (var t = ["function", "function-variable", "method", "method-variable", "property-access"], a = 0; a < t.length; a++) {
    var r = t[a], s = e.languages.javascript[r], r = (s = "RegExp" === e.util.type(s) ? e.languages.javascript[r] = { pattern: s } : s).inside || {};
    (s.inside = r)["maybe-class-name"] = /^[A-Z][\s\S]*/;
  }
}(Prism), function(s) {
  var e = s.util.clone(s.languages.javascript), t = /(?:\s|\/\/.*(?!.)|\/\*(?:[^*]|\*(?!\/))\*\/)/.source, a = /(?:\{(?:\{(?:\{[^{}]*\}|[^{}])*\}|[^{}])*\})/.source, r = /(?:\{<S>*\.{3}(?:[^{}]|<BRACES>)*\})/.source;
  function n(e2, n2) {
    return e2 = e2.replace(/<S>/g, function() {
      return t;
    }).replace(/<BRACES>/g, function() {
      return a;
    }).replace(/<SPREAD>/g, function() {
      return r;
    }), RegExp(e2, n2);
  }
  r = n(r).source, s.languages.jsx = s.languages.extend("markup", e), s.languages.jsx.tag.pattern = n(/<\/?(?:[\w.:-]+(?:<S>+(?:[\w.:$-]+(?:=(?:"(?:\\[\s\S]|[^\\"])*"|'(?:\\[\s\S]|[^\\'])*'|[^\s{'"/>=]+|<BRACES>))?|<SPREAD>))*<S>*\/?)?>/.source), s.languages.jsx.tag.inside.tag.pattern = /^<\/?[^\s>\/]*/, s.languages.jsx.tag.inside["attr-value"].pattern = /=(?!\{)(?:"(?:\\[\s\S]|[^\\"])*"|'(?:\\[\s\S]|[^\\'])*'|[^\s'">]+)/, s.languages.jsx.tag.inside.tag.inside["class-name"] = /^[A-Z]\w*(?:\.[A-Z]\w*)*$/, s.languages.jsx.tag.inside.comment = e.comment, s.languages.insertBefore("inside", "attr-name", { spread: { pattern: n(/<SPREAD>/.source), inside: s.languages.jsx } }, s.languages.jsx.tag), s.languages.insertBefore("inside", "special-attr", { script: { pattern: n(/=<BRACES>/.source), alias: "language-javascript", inside: { "script-punctuation": { pattern: /^=(?=\{)/, alias: "punctuation" }, rest: s.languages.jsx } } }, s.languages.jsx.tag);
  function i(e2) {
    for (var n2 = [], t2 = 0; t2 < e2.length; t2++) {
      var a2 = e2[t2], r2 = false;
      "string" != typeof a2 && ("tag" === a2.type && a2.content[0] && "tag" === a2.content[0].type ? "</" === a2.content[0].content[0].content ? 0 < n2.length && n2[n2.length - 1].tagName === o(a2.content[0].content[1]) && n2.pop() : "/>" !== a2.content[a2.content.length - 1].content && n2.push({ tagName: o(a2.content[0].content[1]), openedBraces: 0 }) : 0 < n2.length && "punctuation" === a2.type && "{" === a2.content ? n2[n2.length - 1].openedBraces++ : 0 < n2.length && 0 < n2[n2.length - 1].openedBraces && "punctuation" === a2.type && "}" === a2.content ? n2[n2.length - 1].openedBraces-- : r2 = true), (r2 || "string" == typeof a2) && 0 < n2.length && 0 === n2[n2.length - 1].openedBraces && (r2 = o(a2), t2 < e2.length - 1 && ("string" == typeof e2[t2 + 1] || "plain-text" === e2[t2 + 1].type) && (r2 += o(e2[t2 + 1]), e2.splice(t2 + 1, 1)), 0 < t2 && ("string" == typeof e2[t2 - 1] || "plain-text" === e2[t2 - 1].type) && (r2 = o(e2[t2 - 1]) + r2, e2.splice(t2 - 1, 1), t2--), e2[t2] = new s.Token("plain-text", r2, null, r2)), a2.content && "string" != typeof a2.content && i(a2.content);
    }
  }
  var o = function(e2) {
    return e2 ? "string" == typeof e2 ? e2 : "string" == typeof e2.content ? e2.content : e2.content.map(o).join("") : "";
  };
  s.hooks.add("after-tokenize", function(e2) {
    "jsx" !== e2.language && "tsx" !== e2.language || i(e2.tokens);
  });
}(Prism), function(e) {
  var n = e.util.clone(e.languages.typescript), n = (e.languages.tsx = e.languages.extend("jsx", n), delete e.languages.tsx.parameter, delete e.languages.tsx["literal-property"], e.languages.tsx.tag);
  n.pattern = RegExp(/(^|[^\w$]|(?=<\/))/.source + "(?:" + n.pattern.source + ")", n.pattern.flags), n.lookbehind = true;
}(Prism), Prism.languages.swift = { comment: { pattern: /(^|[^\\:])(?:\/\/.*|\/\*(?:[^/*]|\/(?!\*)|\*(?!\/)|\/\*(?:[^*]|\*(?!\/))*\*\/)*\*\/)/, lookbehind: true, greedy: true }, "string-literal": [{ pattern: RegExp(/(^|[^"#])/.source + "(?:" + /"(?:\\(?:\((?:[^()]|\([^()]*\))*\)|\r\n|[^(])|[^\\\r\n"])*"/.source + "|" + /"""(?:\\(?:\((?:[^()]|\([^()]*\))*\)|[^(])|[^\\"]|"(?!""))*"""/.source + ")" + /(?!["#])/.source), lookbehind: true, greedy: true, inside: { interpolation: { pattern: /(\\\()(?:[^()]|\([^()]*\))*(?=\))/, lookbehind: true, inside: null }, "interpolation-punctuation": { pattern: /^\)|\\\($/, alias: "punctuation" }, punctuation: /\\(?=[\r\n])/, string: /[\s\S]+/ } }, { pattern: RegExp(/(^|[^"#])(#+)/.source + "(?:" + /"(?:\\(?:#+\((?:[^()]|\([^()]*\))*\)|\r\n|[^#])|[^\\\r\n])*?"/.source + "|" + /"""(?:\\(?:#+\((?:[^()]|\([^()]*\))*\)|[^#])|[^\\])*?"""/.source + ")\\2"), lookbehind: true, greedy: true, inside: { interpolation: { pattern: /(\\#+\()(?:[^()]|\([^()]*\))*(?=\))/, lookbehind: true, inside: null }, "interpolation-punctuation": { pattern: /^\)|\\#+\($/, alias: "punctuation" }, string: /[\s\S]+/ } }], directive: { pattern: RegExp(/#/.source + "(?:" + /(?:elseif|if)\b/.source + "(?:[ 	]*" + /(?:![ \t]*)?(?:\b\w+\b(?:[ \t]*\((?:[^()]|\([^()]*\))*\))?|\((?:[^()]|\([^()]*\))*\))(?:[ \t]*(?:&&|\|\|))?/.source + ")+|" + /(?:else|endif)\b/.source + ")"), alias: "property", inside: { "directive-name": /^#\w+/, boolean: /\b(?:false|true)\b/, number: /\b\d+(?:\.\d+)*\b/, operator: /!|&&|\|\||[<>]=?/, punctuation: /[(),]/ } }, literal: { pattern: /#(?:colorLiteral|column|dsohandle|file(?:ID|Literal|Path)?|function|imageLiteral|line)\b/, alias: "constant" }, "other-directive": { pattern: /#\w+\b/, alias: "property" }, attribute: { pattern: /@\w+/, alias: "atrule" }, "function-definition": { pattern: /(\bfunc\s+)\w+/, lookbehind: true, alias: "function" }, label: { pattern: /\b(break|continue)\s+\w+|\b[a-zA-Z_]\w*(?=\s*:\s*(?:for|repeat|while)\b)/, lookbehind: true, alias: "important" }, keyword: /\b(?:Any|Protocol|Self|Type|actor|as|assignment|associatedtype|associativity|async|await|break|case|catch|class|continue|convenience|default|defer|deinit|didSet|do|dynamic|else|enum|extension|fallthrough|fileprivate|final|for|func|get|guard|higherThan|if|import|in|indirect|infix|init|inout|internal|is|isolated|lazy|left|let|lowerThan|mutating|none|nonisolated|nonmutating|open|operator|optional|override|postfix|precedencegroup|prefix|private|protocol|public|repeat|required|rethrows|return|right|safe|self|set|some|static|struct|subscript|super|switch|throw|throws|try|typealias|unowned|unsafe|var|weak|where|while|willSet)\b/, boolean: /\b(?:false|true)\b/, nil: { pattern: /\bnil\b/, alias: "constant" }, "short-argument": /\$\d+\b/, omit: { pattern: /\b_\b/, alias: "keyword" }, number: /\b(?:[\d_]+(?:\.[\de_]+)?|0x[a-f0-9_]+(?:\.[a-f0-9p_]+)?|0b[01_]+|0o[0-7_]+)\b/i, "class-name": /\b[A-Z](?:[A-Z_\d]*[a-z]\w*)?\b/, function: /\b[a-z_]\w*(?=\s*\()/i, constant: /\b(?:[A-Z_]{2,}|k[A-Z][A-Za-z_]+)\b/, operator: /[-+*/%=!<>&|^~?]+|\.[.\-+*/%=!<>&|^~?]+/, punctuation: /[{}[\]();,.:\\]/ }, Prism.languages.swift["string-literal"].forEach(function(e) {
  e.inside.interpolation.inside = Prism.languages.swift;
}), function(e) {
  e.languages.kotlin = e.languages.extend("clike", { keyword: { pattern: /(^|[^.])\b(?:abstract|actual|annotation|as|break|by|catch|class|companion|const|constructor|continue|crossinline|data|do|dynamic|else|enum|expect|external|final|finally|for|fun|get|if|import|in|infix|init|inline|inner|interface|internal|is|lateinit|noinline|null|object|open|operator|out|override|package|private|protected|public|reified|return|sealed|set|super|suspend|tailrec|this|throw|to|try|typealias|val|var|vararg|when|where|while)\b/, lookbehind: true }, function: [{ pattern: /(?:`[^\r\n`]+`|\b\w+)(?=\s*\()/, greedy: true }, { pattern: /(\.)(?:`[^\r\n`]+`|\w+)(?=\s*\{)/, lookbehind: true, greedy: true }], number: /\b(?:0[xX][\da-fA-F]+(?:_[\da-fA-F]+)*|0[bB][01]+(?:_[01]+)*|\d+(?:_\d+)*(?:\.\d+(?:_\d+)*)?(?:[eE][+-]?\d+(?:_\d+)*)?[fFL]?)\b/, operator: /\+[+=]?|-[-=>]?|==?=?|!(?:!|==?)?|[\/*%<>]=?|[?:]:?|\.\.|&&|\|\||\b(?:and|inv|or|shl|shr|ushr|xor)\b/ }), delete e.languages.kotlin["class-name"];
  var n = { "interpolation-punctuation": { pattern: /^\$\{?|\}$/, alias: "punctuation" }, expression: { pattern: /[\s\S]+/, inside: e.languages.kotlin } };
  e.languages.insertBefore("kotlin", "string", { "string-literal": [{ pattern: /"""(?:[^$]|\$(?:(?!\{)|\{[^{}]*\}))*?"""/, alias: "multiline", inside: { interpolation: { pattern: /\$(?:[a-z_]\w*|\{[^{}]*\})/i, inside: n }, string: /[\s\S]+/ } }, { pattern: /"(?:[^"\\\r\n$]|\\.|\$(?:(?!\{)|\{[^{}]*\}))*"/, alias: "singleline", inside: { interpolation: { pattern: /((?:^|[^\\])(?:\\{2})*)\$(?:[a-z_]\w*|\{[^{}]*\})/i, lookbehind: true, inside: n }, string: /[\s\S]+/ } }], char: { pattern: /'(?:[^'\\\r\n]|\\(?:.|u[a-fA-F0-9]{0,4}))'/, greedy: true } }), delete e.languages.kotlin.string, e.languages.insertBefore("kotlin", "keyword", { annotation: { pattern: /\B@(?:\w+:)?(?:[A-Z]\w*|\[[^\]]+\])/, alias: "builtin" } }), e.languages.insertBefore("kotlin", "function", { label: { pattern: /\b\w+@|@\w+\b/, alias: "symbol" } }), e.languages.kt = e.languages.kotlin, e.languages.kts = e.languages.kotlin;
}(Prism), Prism.languages.c = Prism.languages.extend("clike", { comment: { pattern: /\/\/(?:[^\r\n\\]|\\(?:\r\n?|\n|(?![\r\n])))*|\/\*[\s\S]*?(?:\*\/|$)/, greedy: true }, string: { pattern: /"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"/, greedy: true }, "class-name": { pattern: /(\b(?:enum|struct)\s+(?:__attribute__\s*\(\([\s\S]*?\)\)\s*)?)\w+|\b[a-z]\w*_t\b/, lookbehind: true }, keyword: /\b(?:_Alignas|_Alignof|_Atomic|_Bool|_Complex|_Generic|_Imaginary|_Noreturn|_Static_assert|_Thread_local|__attribute__|asm|auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto|if|inline|int|long|register|return|short|signed|sizeof|static|struct|switch|typedef|typeof|union|unsigned|void|volatile|while)\b/, function: /\b[a-z_]\w*(?=\s*\()/i, number: /(?:\b0x(?:[\da-f]+(?:\.[\da-f]*)?|\.[\da-f]+)(?:p[+-]?\d+)?|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:e[+-]?\d+)?)[ful]{0,4}/i, operator: />>=?|<<=?|->|([-+&|:])\1|[?:~]|[-+*/%&|^!=<>]=?/ }), Prism.languages.insertBefore("c", "string", { char: { pattern: /'(?:\\(?:\r\n|[\s\S])|[^'\\\r\n]){0,32}'/, greedy: true } }), Prism.languages.insertBefore("c", "string", { macro: { pattern: /(^[\t ]*)#\s*[a-z](?:[^\r\n\\/]|\/(?!\*)|\/\*(?:[^*]|\*(?!\/))*\*\/|\\(?:\r\n|[\s\S]))*/im, lookbehind: true, greedy: true, alias: "property", inside: { string: [{ pattern: /^(#\s*include\s*)<[^>]+>/, lookbehind: true }, Prism.languages.c.string], char: Prism.languages.c.char, comment: Prism.languages.c.comment, "macro-name": [{ pattern: /(^#\s*define\s+)\w+\b(?!\()/i, lookbehind: true }, { pattern: /(^#\s*define\s+)\w+\b(?=\()/i, lookbehind: true, alias: "function" }], directive: { pattern: /^(#\s*)[a-z]+/, lookbehind: true, alias: "keyword" }, "directive-hash": /^#/, punctuation: /##|\\(?=[\r\n])/, expression: { pattern: /\S[\s\S]*/, inside: Prism.languages.c } } } }), Prism.languages.insertBefore("c", "function", { constant: /\b(?:EOF|NULL|SEEK_CUR|SEEK_END|SEEK_SET|__DATE__|__FILE__|__LINE__|__TIMESTAMP__|__TIME__|__func__|stderr|stdin|stdout)\b/ }), delete Prism.languages.c.boolean, Prism.languages.objectivec = Prism.languages.extend("c", { string: { pattern: /@?"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"/, greedy: true }, keyword: /\b(?:asm|auto|break|case|char|const|continue|default|do|double|else|enum|extern|float|for|goto|if|in|inline|int|long|register|return|self|short|signed|sizeof|static|struct|super|switch|typedef|typeof|union|unsigned|void|volatile|while)\b|(?:@interface|@end|@implementation|@protocol|@class|@public|@protected|@private|@property|@try|@catch|@finally|@throw|@synthesize|@dynamic|@selector)\b/, operator: /-[->]?|\+\+?|!=?|<<?=?|>>?=?|==?|&&?|\|\|?|[~^%?*\/@]/ }), delete Prism.languages.objectivec["class-name"], Prism.languages.objc = Prism.languages.objectivec, Prism.languages.reason = Prism.languages.extend("clike", { string: { pattern: /"(?:\\(?:\r\n|[\s\S])|[^\\\r\n"])*"/, greedy: true }, "class-name": /\b[A-Z]\w*/, keyword: /\b(?:and|as|assert|begin|class|constraint|do|done|downto|else|end|exception|external|for|fun|function|functor|if|in|include|inherit|initializer|lazy|let|method|module|mutable|new|nonrec|object|of|open|or|private|rec|sig|struct|switch|then|to|try|type|val|virtual|when|while|with)\b/, operator: /\.{3}|:[:=]|\|>|->|=(?:==?|>)?|<=?|>=?|[|^?'#!~`]|[+\-*\/]\.?|\b(?:asr|land|lor|lsl|lsr|lxor|mod)\b/ }), Prism.languages.insertBefore("reason", "class-name", { char: { pattern: /'(?:\\x[\da-f]{2}|\\o[0-3][0-7][0-7]|\\\d{3}|\\.|[^'\\\r\n])'/, greedy: true }, constructor: /\b[A-Z]\w*\b(?!\s*\.)/, label: { pattern: /\b[a-z]\w*(?=::)/, alias: "symbol" } }), delete Prism.languages.reason.function, function(e) {
  for (var n = /\/\*(?:[^*/]|\*(?!\/)|\/(?!\*)|<self>)*\*\//.source, t = 0; t < 2; t++)
    n = n.replace(/<self>/g, function() {
      return n;
    });
  n = n.replace(/<self>/g, function() {
    return /[^\s\S]/.source;
  }), e.languages.rust = { comment: [{ pattern: RegExp(/(^|[^\\])/.source + n), lookbehind: true, greedy: true }, { pattern: /(^|[^\\:])\/\/.*/, lookbehind: true, greedy: true }], string: { pattern: /b?"(?:\\[\s\S]|[^\\"])*"|b?r(#*)"(?:[^"]|"(?!\1))*"\1/, greedy: true }, char: { pattern: /b?'(?:\\(?:x[0-7][\da-fA-F]|u\{(?:[\da-fA-F]_*){1,6}\}|.)|[^\\\r\n\t'])'/, greedy: true }, attribute: { pattern: /#!?\[(?:[^\[\]"]|"(?:\\[\s\S]|[^\\"])*")*\]/, greedy: true, alias: "attr-name", inside: { string: null } }, "closure-params": { pattern: /([=(,:]\s*|\bmove\s*)\|[^|]*\||\|[^|]*\|(?=\s*(?:\{|->))/, lookbehind: true, greedy: true, inside: { "closure-punctuation": { pattern: /^\||\|$/, alias: "punctuation" }, rest: null } }, "lifetime-annotation": { pattern: /'\w+/, alias: "symbol" }, "fragment-specifier": { pattern: /(\$\w+:)[a-z]+/, lookbehind: true, alias: "punctuation" }, variable: /\$\w+/, "function-definition": { pattern: /(\bfn\s+)\w+/, lookbehind: true, alias: "function" }, "type-definition": { pattern: /(\b(?:enum|struct|trait|type|union)\s+)\w+/, lookbehind: true, alias: "class-name" }, "module-declaration": [{ pattern: /(\b(?:crate|mod)\s+)[a-z][a-z_\d]*/, lookbehind: true, alias: "namespace" }, { pattern: /(\b(?:crate|self|super)\s*)::\s*[a-z][a-z_\d]*\b(?:\s*::(?:\s*[a-z][a-z_\d]*\s*::)*)?/, lookbehind: true, alias: "namespace", inside: { punctuation: /::/ } }], keyword: [/\b(?:Self|abstract|as|async|await|become|box|break|const|continue|crate|do|dyn|else|enum|extern|final|fn|for|if|impl|in|let|loop|macro|match|mod|move|mut|override|priv|pub|ref|return|self|static|struct|super|trait|try|type|typeof|union|unsafe|unsized|use|virtual|where|while|yield)\b/, /\b(?:bool|char|f(?:32|64)|[ui](?:8|16|32|64|128|size)|str)\b/], function: /\b[a-z_]\w*(?=\s*(?:::\s*<|\())/, macro: { pattern: /\b\w+!/, alias: "property" }, constant: /\b[A-Z_][A-Z_\d]+\b/, "class-name": /\b[A-Z]\w*\b/, namespace: { pattern: /(?:\b[a-z][a-z_\d]*\s*::\s*)*\b[a-z][a-z_\d]*\s*::(?!\s*<)/, inside: { punctuation: /::/ } }, number: /\b(?:0x[\dA-Fa-f](?:_?[\dA-Fa-f])*|0o[0-7](?:_?[0-7])*|0b[01](?:_?[01])*|(?:(?:\d(?:_?\d)*)?\.)?\d(?:_?\d)*(?:[Ee][+-]?\d+)?)(?:_?(?:f32|f64|[iu](?:8|16|32|64|size)?))?\b/, boolean: /\b(?:false|true)\b/, punctuation: /->|\.\.=|\.{1,3}|::|[{}[\];(),:]/, operator: /[-+*\/%!^]=?|=[=>]?|&[&=]?|\|[|=]?|<<?=?|>>?=?|[@?]/ }, e.languages.rust["closure-params"].inside.rest = e.languages.rust, e.languages.rust.attribute.inside.string = e.languages.rust.string;
}(Prism), Prism.languages.go = Prism.languages.extend("clike", { string: { pattern: /(^|[^\\])"(?:\\.|[^"\\\r\n])*"|`[^`]*`/, lookbehind: true, greedy: true }, keyword: /\b(?:break|case|chan|const|continue|default|defer|else|fallthrough|for|func|go(?:to)?|if|import|interface|map|package|range|return|select|struct|switch|type|var)\b/, boolean: /\b(?:_|false|iota|nil|true)\b/, number: [/\b0(?:b[01_]+|o[0-7_]+)i?\b/i, /\b0x(?:[a-f\d_]+(?:\.[a-f\d_]*)?|\.[a-f\d_]+)(?:p[+-]?\d+(?:_\d+)*)?i?(?!\w)/i, /(?:\b\d[\d_]*(?:\.[\d_]*)?|\B\.\d[\d_]*)(?:e[+-]?[\d_]+)?i?(?!\w)/i], operator: /[*\/%^!=]=?|\+[=+]?|-[=-]?|\|[=|]?|&(?:=|&|\^=?)?|>(?:>=?|=)?|<(?:<=?|=|-)?|:=|\.\.\./, builtin: /\b(?:append|bool|byte|cap|close|complex|complex(?:64|128)|copy|delete|error|float(?:32|64)|u?int(?:8|16|32|64)?|imag|len|make|new|panic|print(?:ln)?|real|recover|rune|string|uintptr)\b/ }), Prism.languages.insertBefore("go", "string", { char: { pattern: /'(?:\\.|[^'\\\r\n]){0,10}'/, greedy: true } }), delete Prism.languages.go["class-name"], function(e) {
  var n = /\b(?:alignas|alignof|asm|auto|bool|break|case|catch|char|char16_t|char32_t|char8_t|class|co_await|co_return|co_yield|compl|concept|const|const_cast|consteval|constexpr|constinit|continue|decltype|default|delete|do|double|dynamic_cast|else|enum|explicit|export|extern|final|float|for|friend|goto|if|import|inline|int|int16_t|int32_t|int64_t|int8_t|long|module|mutable|namespace|new|noexcept|nullptr|operator|override|private|protected|public|register|reinterpret_cast|requires|return|short|signed|sizeof|static|static_assert|static_cast|struct|switch|template|this|thread_local|throw|try|typedef|typeid|typename|uint16_t|uint32_t|uint64_t|uint8_t|union|unsigned|using|virtual|void|volatile|wchar_t|while)\b/, t = /\b(?!<keyword>)\w+(?:\s*\.\s*\w+)*\b/.source.replace(/<keyword>/g, function() {
    return n.source;
  });
  e.languages.cpp = e.languages.extend("c", { "class-name": [{ pattern: RegExp(/(\b(?:class|concept|enum|struct|typename)\s+)(?!<keyword>)\w+/.source.replace(/<keyword>/g, function() {
    return n.source;
  })), lookbehind: true }, /\b[A-Z]\w*(?=\s*::\s*\w+\s*\()/, /\b[A-Z_]\w*(?=\s*::\s*~\w+\s*\()/i, /\b\w+(?=\s*<(?:[^<>]|<(?:[^<>]|<[^<>]*>)*>)*>\s*::\s*\w+\s*\()/], keyword: n, number: { pattern: /(?:\b0b[01']+|\b0x(?:[\da-f']+(?:\.[\da-f']*)?|\.[\da-f']+)(?:p[+-]?[\d']+)?|(?:\b[\d']+(?:\.[\d']*)?|\B\.[\d']+)(?:e[+-]?[\d']+)?)[ful]{0,4}/i, greedy: true }, operator: />>=?|<<=?|->|--|\+\+|&&|\|\||[?:~]|<=>|[-+*/%&|^!=<>]=?|\b(?:and|and_eq|bitand|bitor|not|not_eq|or|or_eq|xor|xor_eq)\b/, boolean: /\b(?:false|true)\b/ }), e.languages.insertBefore("cpp", "string", { module: { pattern: RegExp(/(\b(?:import|module)\s+)/.source + "(?:" + /"(?:\\(?:\r\n|[\s\S])|[^"\\\r\n])*"|<[^<>\r\n]*>/.source + "|" + /<mod-name>(?:\s*:\s*<mod-name>)?|:\s*<mod-name>/.source.replace(/<mod-name>/g, function() {
    return t;
  }) + ")"), lookbehind: true, greedy: true, inside: { string: /^[<"][\s\S]+/, operator: /:/, punctuation: /\./ } }, "raw-string": { pattern: /R"([^()\\ ]{0,16})\([\s\S]*?\)\1"/, alias: "string", greedy: true } }), e.languages.insertBefore("cpp", "keyword", { "generic-function": { pattern: /\b(?!operator\b)[a-z_]\w*\s*<(?:[^<>]|<[^<>]*>)*>(?=\s*\()/i, inside: { function: /^\w+/, generic: { pattern: /<[\s\S]+/, alias: "class-name", inside: e.languages.cpp } } } }), e.languages.insertBefore("cpp", "operator", { "double-colon": { pattern: /::/, alias: "punctuation" } }), e.languages.insertBefore("cpp", "class-name", { "base-clause": { pattern: /(\b(?:class|struct)\s+\w+\s*:\s*)[^;{}"'\s]+(?:\s+[^;{}"'\s]+)*(?=\s*[;{])/, lookbehind: true, greedy: true, inside: e.languages.extend("cpp", {}) } }), e.languages.insertBefore("inside", "double-colon", { "class-name": /\b[a-z_]\w*\b(?!\s*::)/i }, e.languages.cpp["base-clause"]);
}(Prism);

// src/themes/index.ts
var themes_exports = {};
__export(themes_exports, {
  dracula: () => dracula_default,
  duotoneDark: () => duotoneDark_default,
  duotoneLight: () => duotoneLight_default,
  github: () => github_default,
  jettwaveDark: () => jettwaveDark_default,
  jettwaveLight: () => jettwaveLight_default,
  nightOwl: () => nightOwl_default,
  nightOwlLight: () => nightOwlLight_default,
  oceanicNext: () => oceanicNext_default,
  okaidia: () => okaidia_default,
  oneDark: () => oneDark_default,
  oneLight: () => oneLight_default,
  palenight: () => palenight_default,
  shadesOfPurple: () => shadesOfPurple_default,
  synthwave84: () => synthwave84_default,
  ultramin: () => ultramin_default,
  vsDark: () => vsDark_default,
  vsLight: () => vsLight_default
});

// src/themes/dracula.ts
var theme = {
  plain: {
    color: "#F8F8F2",
    backgroundColor: "#282A36"
  },
  styles: [
    {
      types: ["prolog", "constant", "builtin"],
      style: {
        color: "rgb(189, 147, 249)"
      }
    },
    {
      types: ["inserted", "function"],
      style: {
        color: "rgb(80, 250, 123)"
      }
    },
    {
      types: ["deleted"],
      style: {
        color: "rgb(255, 85, 85)"
      }
    },
    {
      types: ["changed"],
      style: {
        color: "rgb(255, 184, 108)"
      }
    },
    {
      types: ["punctuation", "symbol"],
      style: {
        color: "rgb(248, 248, 242)"
      }
    },
    {
      types: ["string", "char", "tag", "selector"],
      style: {
        color: "rgb(255, 121, 198)"
      }
    },
    {
      types: ["keyword", "variable"],
      style: {
        color: "rgb(189, 147, 249)",
        fontStyle: "italic"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "rgb(98, 114, 164)"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "rgb(241, 250, 140)"
      }
    }
  ]
};
var dracula_default = theme;

// src/themes/duotoneDark.ts
var theme2 = {
  plain: {
    backgroundColor: "#2a2734",
    color: "#9a86fd"
  },
  styles: [
    {
      types: ["comment", "prolog", "doctype", "cdata", "punctuation"],
      style: {
        color: "#6c6783"
      }
    },
    {
      types: ["namespace"],
      style: {
        opacity: 0.7
      }
    },
    {
      types: ["tag", "operator", "number"],
      style: {
        color: "#e09142"
      }
    },
    {
      types: ["property", "function"],
      style: {
        color: "#9a86fd"
      }
    },
    {
      types: ["tag-id", "selector", "atrule-id"],
      style: {
        color: "#eeebff"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "#c4b9fe"
      }
    },
    {
      types: [
        "boolean",
        "string",
        "entity",
        "url",
        "attr-value",
        "keyword",
        "control",
        "directive",
        "unit",
        "statement",
        "regex",
        "atrule",
        "placeholder",
        "variable"
      ],
      style: {
        color: "#ffcc99"
      }
    },
    {
      types: ["deleted"],
      style: {
        textDecorationLine: "line-through"
      }
    },
    {
      types: ["inserted"],
      style: {
        textDecorationLine: "underline"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["important", "bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["important"],
      style: {
        color: "#c4b9fe"
      }
    }
  ]
};
var duotoneDark_default = theme2;

// src/themes/duotoneLight.ts
var theme3 = {
  plain: {
    backgroundColor: "#faf8f5",
    color: "#728fcb"
  },
  styles: [
    {
      types: ["comment", "prolog", "doctype", "cdata", "punctuation"],
      style: {
        color: "#b6ad9a"
      }
    },
    {
      types: ["namespace"],
      style: {
        opacity: 0.7
      }
    },
    {
      types: ["tag", "operator", "number"],
      style: {
        color: "#063289"
      }
    },
    {
      types: ["property", "function"],
      style: {
        color: "#b29762"
      }
    },
    {
      types: ["tag-id", "selector", "atrule-id"],
      style: {
        color: "#2d2006"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "#896724"
      }
    },
    {
      types: [
        "boolean",
        "string",
        "entity",
        "url",
        "attr-value",
        "keyword",
        "control",
        "directive",
        "unit",
        "statement",
        "regex",
        "atrule"
      ],
      style: {
        color: "#728fcb"
      }
    },
    {
      types: ["placeholder", "variable"],
      style: {
        color: "#93abdc"
      }
    },
    {
      types: ["deleted"],
      style: {
        textDecorationLine: "line-through"
      }
    },
    {
      types: ["inserted"],
      style: {
        textDecorationLine: "underline"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["important", "bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["important"],
      style: {
        color: "#896724"
      }
    }
  ]
};
var duotoneLight_default = theme3;

// src/themes/github.ts
var theme4 = {
  plain: {
    color: "#393A34",
    backgroundColor: "#f6f8fa"
  },
  styles: [
    {
      types: ["comment", "prolog", "doctype", "cdata"],
      style: {
        color: "#999988",
        fontStyle: "italic"
      }
    },
    {
      types: ["namespace"],
      style: {
        opacity: 0.7
      }
    },
    {
      types: ["string", "attr-value"],
      style: {
        color: "#e3116c"
      }
    },
    {
      types: ["punctuation", "operator"],
      style: {
        color: "#393A34"
      }
    },
    {
      types: [
        "entity",
        "url",
        "symbol",
        "number",
        "boolean",
        "variable",
        "constant",
        "property",
        "regex",
        "inserted"
      ],
      style: {
        color: "#36acaa"
      }
    },
    {
      types: ["atrule", "keyword", "attr-name", "selector"],
      style: {
        color: "#00a4db"
      }
    },
    {
      types: ["function", "deleted", "tag"],
      style: {
        color: "#d73a49"
      }
    },
    {
      types: ["function-variable"],
      style: {
        color: "#6f42c1"
      }
    },
    {
      types: ["tag", "selector", "keyword"],
      style: {
        color: "#00009f"
      }
    }
  ]
};
var github_default = theme4;

// src/themes/nightOwl.ts
var theme5 = {
  plain: {
    color: "#d6deeb",
    backgroundColor: "#011627"
  },
  styles: [
    {
      types: ["changed"],
      style: {
        color: "rgb(162, 191, 252)",
        fontStyle: "italic"
      }
    },
    {
      types: ["deleted"],
      style: {
        color: "rgba(239, 83, 80, 0.56)",
        fontStyle: "italic"
      }
    },
    {
      types: ["inserted", "attr-name"],
      style: {
        color: "rgb(173, 219, 103)",
        fontStyle: "italic"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "rgb(99, 119, 119)",
        fontStyle: "italic"
      }
    },
    {
      types: ["string", "url"],
      style: {
        color: "rgb(173, 219, 103)"
      }
    },
    {
      types: ["variable"],
      style: {
        color: "rgb(214, 222, 235)"
      }
    },
    {
      types: ["number"],
      style: {
        color: "rgb(247, 140, 108)"
      }
    },
    {
      types: ["builtin", "char", "constant", "function"],
      style: {
        color: "rgb(130, 170, 255)"
      }
    },
    {
      // This was manually added after the auto-generation
      // so that punctuations are not italicised
      types: ["punctuation"],
      style: {
        color: "rgb(199, 146, 234)"
      }
    },
    {
      types: ["selector", "doctype"],
      style: {
        color: "rgb(199, 146, 234)",
        fontStyle: "italic"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "rgb(255, 203, 139)"
      }
    },
    {
      types: ["tag", "operator", "keyword"],
      style: {
        color: "rgb(127, 219, 202)"
      }
    },
    {
      types: ["boolean"],
      style: {
        color: "rgb(255, 88, 116)"
      }
    },
    {
      types: ["property"],
      style: {
        color: "rgb(128, 203, 196)"
      }
    },
    {
      types: ["namespace"],
      style: {
        color: "rgb(178, 204, 214)"
      }
    }
  ]
};
var nightOwl_default = theme5;

// src/themes/nightOwlLight.ts
var theme6 = {
  plain: {
    color: "#403f53",
    backgroundColor: "#FBFBFB"
  },
  styles: [
    {
      types: ["changed"],
      style: {
        color: "rgb(162, 191, 252)",
        fontStyle: "italic"
      }
    },
    {
      types: ["deleted"],
      style: {
        color: "rgba(239, 83, 80, 0.56)",
        fontStyle: "italic"
      }
    },
    {
      types: ["inserted", "attr-name"],
      style: {
        color: "rgb(72, 118, 214)",
        fontStyle: "italic"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "rgb(152, 159, 177)",
        fontStyle: "italic"
      }
    },
    {
      types: ["string", "builtin", "char", "constant", "url"],
      style: {
        color: "rgb(72, 118, 214)"
      }
    },
    {
      types: ["variable"],
      style: {
        color: "rgb(201, 103, 101)"
      }
    },
    {
      types: ["number"],
      style: {
        color: "rgb(170, 9, 130)"
      }
    },
    {
      // This was manually added after the auto-generation
      // so that punctuations are not italicised
      types: ["punctuation"],
      style: {
        color: "rgb(153, 76, 195)"
      }
    },
    {
      types: ["function", "selector", "doctype"],
      style: {
        color: "rgb(153, 76, 195)",
        fontStyle: "italic"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "rgb(17, 17, 17)"
      }
    },
    {
      types: ["tag"],
      style: {
        color: "rgb(153, 76, 195)"
      }
    },
    {
      types: ["operator", "property", "keyword", "namespace"],
      style: {
        color: "rgb(12, 150, 155)"
      }
    },
    {
      types: ["boolean"],
      style: {
        color: "rgb(188, 84, 84)"
      }
    }
  ]
};
var nightOwlLight_default = theme6;

// src/themes/oceanicNext.ts
var colors = {
  char: "#D8DEE9",
  comment: "#999999",
  keyword: "#c5a5c5",
  primitive: "#5a9bcf",
  string: "#8dc891",
  variable: "#d7deea",
  boolean: "#ff8b50",
  punctuation: "#5FB3B3",
  tag: "#fc929e",
  function: "#79b6f2",
  className: "#FAC863",
  method: "#6699CC",
  operator: "#fc929e"
};
var theme7 = {
  plain: {
    backgroundColor: "#282c34",
    color: "#ffffff"
  },
  styles: [
    {
      types: ["attr-name"],
      style: {
        color: colors.keyword
      }
    },
    {
      types: ["attr-value"],
      style: {
        color: colors.string
      }
    },
    {
      types: [
        "comment",
        "block-comment",
        "prolog",
        "doctype",
        "cdata",
        "shebang"
      ],
      style: {
        color: colors.comment
      }
    },
    {
      types: [
        "property",
        "number",
        "function-name",
        "constant",
        "symbol",
        "deleted"
      ],
      style: {
        color: colors.primitive
      }
    },
    {
      types: ["boolean"],
      style: {
        color: colors.boolean
      }
    },
    {
      types: ["tag"],
      style: {
        color: colors.tag
      }
    },
    {
      types: ["string"],
      style: {
        color: colors.string
      }
    },
    {
      types: ["punctuation"],
      style: {
        color: colors.string
      }
    },
    {
      types: ["selector", "char", "builtin", "inserted"],
      style: {
        color: colors.char
      }
    },
    {
      types: ["function"],
      style: {
        color: colors.function
      }
    },
    {
      types: ["operator", "entity", "url", "variable"],
      style: {
        color: colors.variable
      }
    },
    {
      types: ["keyword"],
      style: {
        color: colors.keyword
      }
    },
    {
      types: ["atrule", "class-name"],
      style: {
        color: colors.className
      }
    },
    {
      types: ["important"],
      style: {
        fontWeight: "400"
      }
    },
    {
      types: ["bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["namespace"],
      style: {
        opacity: 0.7
      }
    }
  ]
};
var oceanicNext_default = theme7;

// src/themes/okaidia.ts
var theme8 = {
  plain: {
    color: "#f8f8f2",
    backgroundColor: "#272822"
  },
  styles: [
    {
      types: ["changed"],
      style: {
        color: "rgb(162, 191, 252)",
        fontStyle: "italic"
      }
    },
    {
      types: ["deleted"],
      style: {
        color: "#f92672",
        fontStyle: "italic"
      }
    },
    {
      types: ["inserted"],
      style: {
        color: "rgb(173, 219, 103)",
        fontStyle: "italic"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "#8292a2",
        fontStyle: "italic"
      }
    },
    {
      types: ["string", "url"],
      style: {
        color: "#a6e22e"
      }
    },
    {
      types: ["variable"],
      style: {
        color: "#f8f8f2"
      }
    },
    {
      types: ["number"],
      style: {
        color: "#ae81ff"
      }
    },
    {
      types: ["builtin", "char", "constant", "function", "class-name"],
      style: {
        color: "#e6db74"
      }
    },
    {
      types: ["punctuation"],
      style: {
        color: "#f8f8f2"
      }
    },
    {
      types: ["selector", "doctype"],
      style: {
        color: "#a6e22e",
        fontStyle: "italic"
      }
    },
    {
      types: ["tag", "operator", "keyword"],
      style: {
        color: "#66d9ef"
      }
    },
    {
      types: ["boolean"],
      style: {
        color: "#ae81ff"
      }
    },
    {
      types: ["namespace"],
      style: {
        color: "rgb(178, 204, 214)",
        opacity: 0.7
      }
    },
    {
      types: ["tag", "property"],
      style: {
        color: "#f92672"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "#a6e22e !important"
      }
    },
    {
      types: ["doctype"],
      style: {
        color: "#8292a2"
      }
    },
    {
      types: ["rule"],
      style: {
        color: "#e6db74"
      }
    }
  ]
};
var okaidia_default = theme8;

// src/themes/palenight.ts
var theme9 = {
  plain: {
    color: "#bfc7d5",
    backgroundColor: "#292d3e"
  },
  styles: [
    {
      types: ["comment"],
      style: {
        color: "rgb(105, 112, 152)",
        fontStyle: "italic"
      }
    },
    {
      types: ["string", "inserted"],
      style: {
        color: "rgb(195, 232, 141)"
      }
    },
    {
      types: ["number"],
      style: {
        color: "rgb(247, 140, 108)"
      }
    },
    {
      types: ["builtin", "char", "constant", "function"],
      style: {
        color: "rgb(130, 170, 255)"
      }
    },
    {
      types: ["punctuation", "selector"],
      style: {
        color: "rgb(199, 146, 234)"
      }
    },
    {
      types: ["variable"],
      style: {
        color: "rgb(191, 199, 213)"
      }
    },
    {
      types: ["class-name", "attr-name"],
      style: {
        color: "rgb(255, 203, 107)"
      }
    },
    {
      types: ["tag", "deleted"],
      style: {
        color: "rgb(255, 85, 114)"
      }
    },
    {
      types: ["operator"],
      style: {
        color: "rgb(137, 221, 255)"
      }
    },
    {
      types: ["boolean"],
      style: {
        color: "rgb(255, 88, 116)"
      }
    },
    {
      types: ["keyword"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["doctype"],
      style: {
        color: "rgb(199, 146, 234)",
        fontStyle: "italic"
      }
    },
    {
      types: ["namespace"],
      style: {
        color: "rgb(178, 204, 214)"
      }
    },
    {
      types: ["url"],
      style: {
        color: "rgb(221, 221, 221)"
      }
    }
  ]
};
var palenight_default = theme9;

// src/themes/shadesOfPurple.ts
var theme10 = {
  plain: {
    color: "#9EFEFF",
    backgroundColor: "#2D2A55"
  },
  styles: [
    {
      types: ["changed"],
      style: {
        color: "rgb(255, 238, 128)"
      }
    },
    {
      types: ["deleted"],
      style: {
        color: "rgba(239, 83, 80, 0.56)"
      }
    },
    {
      types: ["inserted"],
      style: {
        color: "rgb(173, 219, 103)"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "rgb(179, 98, 255)",
        fontStyle: "italic"
      }
    },
    {
      types: ["punctuation"],
      style: {
        color: "rgb(255, 255, 255)"
      }
    },
    {
      types: ["constant"],
      style: {
        color: "rgb(255, 98, 140)"
      }
    },
    {
      types: ["string", "url"],
      style: {
        color: "rgb(165, 255, 144)"
      }
    },
    {
      types: ["variable"],
      style: {
        color: "rgb(255, 238, 128)"
      }
    },
    {
      types: ["number", "boolean"],
      style: {
        color: "rgb(255, 98, 140)"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "rgb(255, 180, 84)"
      }
    },
    {
      types: [
        "keyword",
        "operator",
        "property",
        "namespace",
        "tag",
        "selector",
        "doctype"
      ],
      style: {
        color: "rgb(255, 157, 0)"
      }
    },
    {
      types: ["builtin", "char", "constant", "function", "class-name"],
      style: {
        color: "rgb(250, 208, 0)"
      }
    }
  ]
};
var shadesOfPurple_default = theme10;

// src/themes/synthwave84.ts
var theme11 = {
  plain: {
    backgroundColor: "linear-gradient(to bottom, #2a2139 75%, #34294f)",
    backgroundImage: "#34294f",
    color: "#f92aad",
    textShadow: "0 0 2px #100c0f, 0 0 5px #dc078e33, 0 0 10px #fff3"
  },
  styles: [
    {
      types: ["comment", "block-comment", "prolog", "doctype", "cdata"],
      style: {
        color: "#495495",
        fontStyle: "italic"
      }
    },
    {
      types: ["punctuation"],
      style: {
        color: "#ccc"
      }
    },
    {
      types: [
        "tag",
        "attr-name",
        "namespace",
        "number",
        "unit",
        "hexcode",
        "deleted"
      ],
      style: {
        color: "#e2777a"
      }
    },
    {
      types: ["property", "selector"],
      style: {
        color: "#72f1b8",
        textShadow: "0 0 2px #100c0f, 0 0 10px #257c5575, 0 0 35px #21272475"
      }
    },
    {
      types: ["function-name"],
      style: {
        color: "#6196cc"
      }
    },
    {
      types: ["boolean", "selector-id", "function"],
      style: {
        color: "#fdfdfd",
        textShadow: "0 0 2px #001716, 0 0 3px #03edf975, 0 0 5px #03edf975, 0 0 8px #03edf975"
      }
    },
    {
      types: ["class-name", "maybe-class-name", "builtin"],
      style: {
        color: "#fff5f6",
        textShadow: "0 0 2px #000, 0 0 10px #fc1f2c75, 0 0 5px #fc1f2c75, 0 0 25px #fc1f2c75"
      }
    },
    {
      types: ["constant", "symbol"],
      style: {
        color: "#f92aad",
        textShadow: "0 0 2px #100c0f, 0 0 5px #dc078e33, 0 0 10px #fff3"
      }
    },
    {
      types: ["important", "atrule", "keyword", "selector-class"],
      style: {
        color: "#f4eee4",
        textShadow: "0 0 2px #393a33, 0 0 8px #f39f0575, 0 0 2px #f39f0575"
      }
    },
    {
      types: ["string", "char", "attr-value", "regex", "variable"],
      style: {
        color: "#f87c32"
      }
    },
    {
      types: ["parameter"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["entity", "url"],
      style: {
        color: "#67cdcc"
      }
    },
    {
      types: ["operator"],
      style: {
        color: "ffffffee"
      }
    },
    {
      types: ["important", "bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["entity"],
      style: {
        cursor: "help"
      }
    },
    {
      types: ["inserted"],
      style: {
        color: "green"
      }
    }
  ]
};
var synthwave84_default = theme11;

// src/themes/ultramin.ts
var theme12 = {
  plain: {
    color: "#282a2e",
    backgroundColor: "#ffffff"
  },
  styles: [
    {
      types: ["comment"],
      style: {
        color: "rgb(197, 200, 198)"
      }
    },
    {
      types: ["string", "number", "builtin", "variable"],
      style: {
        color: "rgb(150, 152, 150)"
      }
    },
    {
      types: ["class-name", "function", "tag", "attr-name"],
      style: {
        color: "rgb(40, 42, 46)"
      }
    }
  ]
};
var ultramin_default = theme12;

// src/themes/vsDark.ts
var theme13 = {
  plain: {
    color: "#9CDCFE",
    backgroundColor: "#1E1E1E"
  },
  styles: [
    {
      types: ["prolog"],
      style: {
        color: "rgb(0, 0, 128)"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "rgb(106, 153, 85)"
      }
    },
    {
      types: ["builtin", "changed", "keyword", "interpolation-punctuation"],
      style: {
        color: "rgb(86, 156, 214)"
      }
    },
    {
      types: ["number", "inserted"],
      style: {
        color: "rgb(181, 206, 168)"
      }
    },
    {
      types: ["constant"],
      style: {
        color: "rgb(100, 102, 149)"
      }
    },
    {
      types: ["attr-name", "variable"],
      style: {
        color: "rgb(156, 220, 254)"
      }
    },
    {
      types: ["deleted", "string", "attr-value", "template-punctuation"],
      style: {
        color: "rgb(206, 145, 120)"
      }
    },
    {
      types: ["selector"],
      style: {
        color: "rgb(215, 186, 125)"
      }
    },
    {
      // Fix tag color
      types: ["tag"],
      style: {
        color: "rgb(78, 201, 176)"
      }
    },
    {
      // Fix tag color for HTML
      types: ["tag"],
      languages: ["markup"],
      style: {
        color: "rgb(86, 156, 214)"
      }
    },
    {
      types: ["punctuation", "operator"],
      style: {
        color: "rgb(212, 212, 212)"
      }
    },
    {
      // Fix punctuation color for HTML
      types: ["punctuation"],
      languages: ["markup"],
      style: {
        color: "#808080"
      }
    },
    {
      types: ["function"],
      style: {
        color: "rgb(220, 220, 170)"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "rgb(78, 201, 176)"
      }
    },
    {
      types: ["char"],
      style: {
        color: "rgb(209, 105, 105)"
      }
    }
  ]
};
var vsDark_default = theme13;

// src/themes/vsLight.ts
var theme14 = {
  plain: {
    color: "#000000",
    backgroundColor: "#ffffff"
  },
  styles: [
    {
      types: ["comment"],
      style: {
        color: "rgb(0, 128, 0)"
      }
    },
    {
      types: ["builtin"],
      style: {
        color: "rgb(0, 112, 193)"
      }
    },
    {
      types: ["number", "variable", "inserted"],
      style: {
        color: "rgb(9, 134, 88)"
      }
    },
    {
      types: ["operator"],
      style: {
        color: "rgb(0, 0, 0)"
      }
    },
    {
      types: ["constant", "char"],
      style: {
        color: "rgb(129, 31, 63)"
      }
    },
    {
      types: ["tag"],
      style: {
        color: "rgb(128, 0, 0)"
      }
    },
    {
      types: ["attr-name"],
      style: {
        color: "rgb(255, 0, 0)"
      }
    },
    {
      types: ["deleted", "string"],
      style: {
        color: "rgb(163, 21, 21)"
      }
    },
    {
      types: ["changed", "punctuation"],
      style: {
        color: "rgb(4, 81, 165)"
      }
    },
    {
      types: ["function", "keyword"],
      style: {
        color: "rgb(0, 0, 255)"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "rgb(38, 127, 153)"
      }
    }
  ]
};
var vsLight_default = theme14;

// src/themes/jettwaveDark.ts
var theme15 = {
  plain: {
    color: "#f8fafc",
    backgroundColor: "#011627"
  },
  styles: [
    {
      types: ["prolog"],
      style: {
        color: "#000080"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "#6A9955"
      }
    },
    {
      types: ["builtin", "changed", "keyword", "interpolation-punctuation"],
      style: {
        color: "#569CD6"
      }
    },
    {
      types: ["number", "inserted"],
      style: {
        color: "#B5CEA8"
      }
    },
    {
      types: ["constant"],
      style: {
        color: "#f8fafc"
      }
    },
    {
      types: ["attr-name", "variable"],
      style: {
        color: "#9CDCFE"
      }
    },
    {
      types: ["deleted", "string", "attr-value", "template-punctuation"],
      style: {
        color: "#cbd5e1"
      }
    },
    {
      types: ["selector"],
      style: {
        color: "#D7BA7D"
      }
    },
    {
      types: ["tag"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["tag"],
      languages: ["markup"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["punctuation", "operator"],
      style: {
        color: "#D4D4D4"
      }
    },
    {
      types: ["punctuation"],
      languages: ["markup"],
      style: {
        color: "#808080"
      }
    },
    {
      types: ["function"],
      style: {
        color: "#7dd3fc"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["char"],
      style: {
        color: "#D16969"
      }
    }
  ]
};
var jettwaveDark_default = theme15;

// src/themes/jettwaveLight.ts
var theme16 = {
  plain: {
    color: "#0f172a",
    backgroundColor: "#f1f5f9"
  },
  styles: [
    {
      types: ["prolog"],
      style: {
        color: "#000080"
      }
    },
    {
      types: ["comment"],
      style: {
        color: "#6A9955"
      }
    },
    {
      types: ["builtin", "changed", "keyword", "interpolation-punctuation"],
      style: {
        color: "#0c4a6e"
      }
    },
    {
      types: ["number", "inserted"],
      style: {
        color: "#B5CEA8"
      }
    },
    {
      types: ["constant"],
      style: {
        color: "#0f172a"
      }
    },
    {
      types: ["attr-name", "variable"],
      style: {
        color: "#0c4a6e"
      }
    },
    {
      types: ["deleted", "string", "attr-value", "template-punctuation"],
      style: {
        color: "#64748b"
      }
    },
    {
      types: ["selector"],
      style: {
        color: "#D7BA7D"
      }
    },
    {
      types: ["tag"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["tag"],
      languages: ["markup"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["punctuation", "operator"],
      style: {
        color: "#475569"
      }
    },
    {
      types: ["punctuation"],
      languages: ["markup"],
      style: {
        color: "#808080"
      }
    },
    {
      types: ["function"],
      style: {
        color: "#0e7490"
      }
    },
    {
      types: ["class-name"],
      style: {
        color: "#0ea5e9"
      }
    },
    {
      types: ["char"],
      style: {
        color: "#D16969"
      }
    }
  ]
};
var jettwaveLight_default = theme16;

// src/themes/oneDark.ts
var theme17 = {
  plain: {
    backgroundColor: "hsl(220, 13%, 18%)",
    color: "hsl(220, 14%, 71%)",
    textShadow: "0 1px rgba(0, 0, 0, 0.3)"
  },
  styles: [
    {
      types: ["comment", "prolog", "cdata"],
      style: {
        color: "hsl(220, 10%, 40%)"
      }
    },
    {
      types: ["doctype", "punctuation", "entity"],
      style: {
        color: "hsl(220, 14%, 71%)"
      }
    },
    {
      types: [
        "attr-name",
        "class-name",
        "maybe-class-name",
        "boolean",
        "constant",
        "number",
        "atrule"
      ],
      style: { color: "hsl(29, 54%, 61%)" }
    },
    {
      types: ["keyword"],
      style: { color: "hsl(286, 60%, 67%)" }
    },
    {
      types: ["property", "tag", "symbol", "deleted", "important"],
      style: {
        color: "hsl(355, 65%, 65%)"
      }
    },
    {
      types: [
        "selector",
        "string",
        "char",
        "builtin",
        "inserted",
        "regex",
        "attr-value"
      ],
      style: {
        color: "hsl(95, 38%, 62%)"
      }
    },
    {
      types: ["variable", "operator", "function"],
      style: {
        color: "hsl(207, 82%, 66%)"
      }
    },
    {
      types: ["url"],
      style: {
        color: "hsl(187, 47%, 55%)"
      }
    },
    {
      types: ["deleted"],
      style: {
        textDecorationLine: "line-through"
      }
    },
    {
      types: ["inserted"],
      style: {
        textDecorationLine: "underline"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["important", "bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["important"],
      style: {
        color: "hsl(220, 14%, 71%)"
      }
    }
  ]
};
var oneDark_default = theme17;

// src/themes/oneLight.ts
var theme18 = {
  plain: {
    backgroundColor: "hsl(230, 1%, 98%)",
    color: "hsl(230, 8%, 24%)"
  },
  styles: [
    {
      types: ["comment", "prolog", "cdata"],
      style: {
        color: "hsl(230, 4%, 64%)"
      }
    },
    {
      types: ["doctype", "punctuation", "entity"],
      style: {
        color: "hsl(230, 8%, 24%)"
      }
    },
    {
      types: [
        "attr-name",
        "class-name",
        "boolean",
        "constant",
        "number",
        "atrule"
      ],
      style: {
        color: "hsl(35, 99%, 36%)"
      }
    },
    {
      types: ["keyword"],
      style: {
        color: "hsl(301, 63%, 40%)"
      }
    },
    {
      types: ["property", "tag", "symbol", "deleted", "important"],
      style: {
        color: "hsl(5, 74%, 59%)"
      }
    },
    {
      types: [
        "selector",
        "string",
        "char",
        "builtin",
        "inserted",
        "regex",
        "attr-value",
        "punctuation"
      ],
      style: {
        color: "hsl(119, 34%, 47%)"
      }
    },
    {
      types: ["variable", "operator", "function"],
      style: {
        color: "hsl(221, 87%, 60%)"
      }
    },
    {
      types: ["url"],
      style: {
        color: "hsl(198, 99%, 37%)"
      }
    },
    {
      types: ["deleted"],
      style: {
        textDecorationLine: "line-through"
      }
    },
    {
      types: ["inserted"],
      style: {
        textDecorationLine: "underline"
      }
    },
    {
      types: ["italic"],
      style: {
        fontStyle: "italic"
      }
    },
    {
      types: ["important", "bold"],
      style: {
        fontWeight: "bold"
      }
    },
    {
      types: ["important"],
      style: {
        color: "hsl(230, 8%, 24%)"
      }
    }
  ]
};
var oneLight_default = theme18;

// src/utils/themeToDict.ts
var themeToDict = (theme19, language) => {
  const { plain } = theme19;
  const themeDict = theme19.styles.reduce((acc, themeEntry) => {
    const { languages: languages2, style } = themeEntry;
    if (languages2 && !languages2.includes(language)) {
      return acc;
    }
    themeEntry.types.forEach((type) => {
      const accStyle = __spreadValues(__spreadValues({}, acc[type]), style);
      acc[type] = accStyle;
    });
    return acc;
  }, {});
  themeDict.root = plain;
  themeDict.plain = __spreadProps(__spreadValues({}, plain), { backgroundColor: void 0 });
  return themeDict;
};
var themeToDict_default = themeToDict;

// src/components/useThemeDictionary.ts
var useThemeDictionary = (language, theme19) => {
  const [themeDictionary, setThemeDictionary] = reactExports.useState(
    themeToDict_default(theme19, language)
  );
  const previousTheme = reactExports.useRef();
  const previousLanguage = reactExports.useRef();
  reactExports.useEffect(() => {
    if (theme19 !== previousTheme.current || language !== previousLanguage.current) {
      previousTheme.current = theme19;
      previousLanguage.current = language;
      setThemeDictionary(themeToDict_default(theme19, language));
    }
  }, [language, theme19]);
  return themeDictionary;
};
var useGetLineProps = (themeDictionary) => reactExports.useCallback(
  (_a) => {
    var _b = _a, { className, style, line } = _b, rest = __objRest(_b, ["className", "style", "line"]);
    const output = __spreadProps(__spreadValues({}, rest), {
      className: clsx("token-line", className)
    });
    if (typeof themeDictionary === "object" && "plain" in themeDictionary)
      output.style = themeDictionary.plain;
    if (typeof style === "object")
      output.style = __spreadValues(__spreadValues({}, output.style || {}), style);
    return output;
  },
  [themeDictionary]
);
var useGetTokenProps = (themeDictionary) => {
  const styleForToken = reactExports.useCallback(
    ({ types, empty }) => {
      if (themeDictionary == null)
        return void 0;
      else if (types.length === 1 && types[0] === "plain") {
        return empty != null ? { display: "inline-block" } : void 0;
      } else if (types.length === 1 && empty != null) {
        return themeDictionary[types[0]];
      }
      return Object.assign(
        empty != null ? { display: "inline-block" } : {},
        ...types.map((type) => themeDictionary[type])
      );
    },
    [themeDictionary]
  );
  return reactExports.useCallback(
    (_a) => {
      var _b = _a, { token, className, style } = _b, rest = __objRest(_b, ["token", "className", "style"]);
      const output = __spreadProps(__spreadValues({}, rest), {
        className: clsx("token", ...token.types, className),
        children: token.content,
        style: styleForToken(token)
      });
      if (style != null) {
        output.style = __spreadValues(__spreadValues({}, output.style || {}), style);
      }
      return output;
    },
    [styleForToken]
  );
};

// src/utils/normalizeTokens.ts
var newlineRe = /\r\n|\r|\n/;
var normalizeEmptyLines = (line) => {
  if (line.length === 0) {
    line.push({
      types: ["plain"],
      content: "\n",
      empty: true
    });
  } else if (line.length === 1 && line[0].content === "") {
    line[0].content = "\n";
    line[0].empty = true;
  }
};
var appendTypes = (types, add) => {
  const typesSize = types.length;
  if (typesSize > 0 && types[typesSize - 1] === add) {
    return types;
  }
  return types.concat(add);
};
var normalizeTokens = (tokens) => {
  const typeArrStack = [[]];
  const tokenArrStack = [tokens];
  const tokenArrIndexStack = [0];
  const tokenArrSizeStack = [tokens.length];
  let i = 0;
  let stackIndex = 0;
  let currentLine = [];
  const acc = [currentLine];
  while (stackIndex > -1) {
    while ((i = tokenArrIndexStack[stackIndex]++) < tokenArrSizeStack[stackIndex]) {
      let content;
      let types = typeArrStack[stackIndex];
      const tokenArr = tokenArrStack[stackIndex];
      const token = tokenArr[i];
      if (typeof token === "string") {
        types = stackIndex > 0 ? types : ["plain"];
        content = token;
      } else {
        types = appendTypes(types, token.type);
        if (token.alias) {
          types = appendTypes(types, token.alias);
        }
        content = token.content;
      }
      if (typeof content !== "string") {
        stackIndex++;
        typeArrStack.push(types);
        tokenArrStack.push(content);
        tokenArrIndexStack.push(0);
        tokenArrSizeStack.push(content.length);
        continue;
      }
      const splitByNewlines = content.split(newlineRe);
      const newlineCount = splitByNewlines.length;
      currentLine.push({
        types,
        content: splitByNewlines[0]
      });
      for (let i2 = 1; i2 < newlineCount; i2++) {
        normalizeEmptyLines(currentLine);
        acc.push(currentLine = []);
        currentLine.push({
          types,
          content: splitByNewlines[i2]
        });
      }
    }
    stackIndex--;
    typeArrStack.pop();
    tokenArrStack.pop();
    tokenArrIndexStack.pop();
    tokenArrSizeStack.pop();
  }
  normalizeEmptyLines(currentLine);
  return acc;
};
var normalizeTokens_default = normalizeTokens;
var useTokenize = ({ prism, code, grammar, language }) => {
  const prismRef = reactExports.useRef(prism);
  return reactExports.useMemo(() => {
    if (grammar == null)
      return normalizeTokens_default([code]);
    const prismConfig = {
      code,
      grammar,
      language,
      tokens: []
    };
    prismRef.current.hooks.run("before-tokenize", prismConfig);
    prismConfig.tokens = prismRef.current.tokenize(code, grammar);
    prismRef.current.hooks.run("after-tokenize", prismConfig);
    return normalizeTokens_default(prismConfig.tokens);
  }, [code, grammar, language]);
};

// src/components/highlight.ts
var Highlight = ({
  children,
  language: _language,
  code,
  theme: theme19,
  prism
}) => {
  const language = _language.toLowerCase();
  const themeDictionary = useThemeDictionary(language, theme19);
  const getLineProps = useGetLineProps(themeDictionary);
  const getTokenProps = useGetTokenProps(themeDictionary);
  const grammar = prism.languages[language];
  const tokens = useTokenize({ prism, language, code, grammar });
  return children({
    tokens,
    className: `prism-code language-${language}`,
    style: themeDictionary != null ? themeDictionary.root : {},
    getLineProps,
    getTokenProps
  });
};

// src/index.ts
var Highlight2 = (props) => reactExports.createElement(Highlight, __spreadProps(__spreadValues({}, props), {
  prism: props.prism || Prism,
  theme: props.theme || vsDark_default,
  code: props.code,
  language: props.language
}));
/*! Bundled license information:

prismjs/prism.js:
  (**
   * Prism: Lightweight, robust, elegant syntax highlighting
   *
   * @license MIT <https://opensource.org/licenses/MIT>
   * @author Lea Verou <https://lea.verou.me>
   * @namespace
   * @public
   *)
*/

function CodeBlock({ code = "", language = "text" }) {
  const loadTheLanguages = reactExports.useCallback(async () => {
    (typeof global !== "undefined" ? global : window).Prism = Prism;
    const loadLanguages = await import('https://esm.sh/prismjs/components/index.js');
    console.log(loadLanguages);
    loadLanguages.default(["python"]);
  }, []);
  reactExports.useEffect(() => {
    loadTheLanguages();
  }, [loadTheLanguages]);
  return /* @__PURE__ */ jsxRuntimeExports.jsx(
    Highlight2,
    {
      theme: themes_exports.github,
      code,
      language,
      children: ({ className, style, tokens, getLineProps, getTokenProps }) => /* @__PURE__ */ jsxRuntimeExports.jsx("pre", { style, className: clsx$1(styles.codeBlock, "nodrag"), children: tokens.map((line, i) => /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { ...getLineProps({ line }), children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx("span", { className: styles.lineNumber, children: i + 1 }),
        line.map((token, key) => /* @__PURE__ */ jsxRuntimeExports.jsx("span", { ...getTokenProps({ token }) }, key))
      ] }, i)) })
    }
  );
}

function DiagraphNode({ data: {
  node,
  inEdges,
  outEdges
} }) {
  const layout = reactExports.useContext(LayoutContext);
  const [expanded, setExpanded] = reactExports.useState(false);
  const handleClick = reactExports.useCallback(() => {
    setExpanded((e) => !e);
  }, []);
  const sections = reactExports.useMemo(() => [
    { label: "Function", value: node.fn, language: "python" },
    { label: "Prompt", value: node.prompt },
    { label: "Result", value: node.result }
  ], [node.fn, node.prompt, node.result]);
  const getStyle = reactExports.useCallback((i, total) => {
    const key = layout === "LR" ? "top" : "left";
    return { [key]: `${getPosition(i, total) * 100}%` };
  }, [layout]);
  return /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: clsx$1(styles$1.node, { [styles$1.expanded]: expanded }), children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx(NodeResizer, { isVisible: expanded, minWidth: 150, minHeight: 50 }),
    /* @__PURE__ */ jsxRuntimeExports.jsxs("header", { children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx("button", { onClick: handleClick, children: /* @__PURE__ */ jsxRuntimeExports.jsx(PiCaretRightBold, { className: "nodrag" }) }),
      /* @__PURE__ */ jsxRuntimeExports.jsx("label", { children: node.label })
    ] }),
    /* @__PURE__ */ jsxRuntimeExports.jsx("main", { children: sections.map(({ label, value, language }) => /* @__PURE__ */ jsxRuntimeExports.jsxs("section", { children: [
      /* @__PURE__ */ jsxRuntimeExports.jsx("label", { children: label }),
      value ? /* @__PURE__ */ jsxRuntimeExports.jsx(CodeBlock, { code: value, language }) : /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: styles$1.empty, children: "--" })
    ] }, label)) }),
    inEdges.map((edge, i) => /* @__PURE__ */ jsxRuntimeExports.jsx(
      Handle$1,
      {
        type: "target",
        position: layout === "LR" ? Position.Left : Position.Top,
        id: edge,
        style: getStyle(i, inEdges.length)
      },
      edge
    )),
    outEdges.map((edge, i) => /* @__PURE__ */ jsxRuntimeExports.jsx(
      Handle$1,
      {
        type: "source",
        position: layout === "LR" ? Position.Right : Position.Bottom,
        id: edge,
        style: getStyle(i, outEdges.length)
      },
      edge
    ))
  ] });
}
const getPosition = (i, total) => {
  if (total === 1) {
    return 0.5;
  }
  const blockSize = 1 / total;
  return i * blockSize + blockSize / 2;
};

var DEFAULT_EDGE_NAME = "\x00";
var GRAPH_NODE = "\x00";
var EDGE_KEY_DELIM = "\x01";

// Implementation notes:
//
//  * Node id query functions should return string ids for the nodes
//  * Edge id query functions should return an "edgeObj", edge object, that is
//    composed of enough information to uniquely identify an edge: {v, w, name}.
//  * Internally we use an "edgeId", a stringified form of the edgeObj, to
//    reference edges. This is because we need a performant way to look these
//    edges up and, object properties, which have string keys, are the closest
//    we're going to get to a performant hashtable in JavaScript.

let Graph$a = class Graph {
  #isDirected = true;
  #isMultigraph = false;
  #isCompound = false;

  // Label for the graph itself
  #label;

  // Defaults to be set when creating a new node
  #defaultNodeLabelFn = () => undefined;

  // Defaults to be set when creating a new edge
  #defaultEdgeLabelFn = () => undefined;

  // v -> label
  #nodes = {};

  // v -> edgeObj
  #in = {};

  // u -> v -> Number
  #preds = {};

  // v -> edgeObj
  #out = {};

  // v -> w -> Number
  #sucs = {};

  // e -> edgeObj
  #edgeObjs = {};

  // e -> label
  #edgeLabels = {};

  /* Number of nodes in the graph. Should only be changed by the implementation. */
  #nodeCount = 0;

  /* Number of edges in the graph. Should only be changed by the implementation. */
  #edgeCount = 0;

  #parent;

  #children;

  constructor(opts) {
    if (opts) {
      this.#isDirected = opts.hasOwnProperty("directed") ? opts.directed : true;
      this.#isMultigraph = opts.hasOwnProperty("multigraph") ? opts.multigraph : false;
      this.#isCompound = opts.hasOwnProperty("compound") ? opts.compound : false;
    }

    if (this.#isCompound) {
      // v -> parent
      this.#parent = {};

      // v -> children
      this.#children = {};
      this.#children[GRAPH_NODE] = {};
    }
  }

  /* === Graph functions ========= */

  /**
   * Whether graph was created with 'directed' flag set to true or not.
   */
  isDirected() {
    return this.#isDirected;
  }

  /**
   * Whether graph was created with 'multigraph' flag set to true or not.
   */
  isMultigraph() {
    return this.#isMultigraph;
  }

  /**
   * Whether graph was created with 'compound' flag set to true or not.
   */
  isCompound() {
    return this.#isCompound;
  }

  /**
   * Sets the label of the graph.
   */
  setGraph(label) {
    this.#label = label;
    return this;
  }

  /**
   * Gets the graph label.
   */
  graph() {
    return this.#label;
  }


  /* === Node functions ========== */

  /**
   * Sets the default node label. If newDefault is a function, it will be
   * invoked ach time when setting a label for a node. Otherwise, this label
   * will be assigned as default label in case if no label was specified while
   * setting a node.
   * Complexity: O(1).
   */
  setDefaultNodeLabel(newDefault) {
    this.#defaultNodeLabelFn = newDefault;
    if (typeof newDefault !== 'function') {
      this.#defaultNodeLabelFn = () => newDefault;
    }

    return this;
  }

  /**
   * Gets the number of nodes in the graph.
   * Complexity: O(1).
   */
  nodeCount() {
    return this.#nodeCount;
  }

  /**
   * Gets all nodes of the graph. Note, the in case of compound graph subnodes are
   * not included in list.
   * Complexity: O(1).
   */
  nodes() {
    return Object.keys(this.#nodes);
  }

  /**
   * Gets list of nodes without in-edges.
   * Complexity: O(|V|).
   */
  sources() {
    var self = this;
    return this.nodes().filter(v => Object.keys(self.#in[v]).length === 0);
  }

  /**
   * Gets list of nodes without out-edges.
   * Complexity: O(|V|).
   */
  sinks() {
    var self = this;
    return this.nodes().filter(v => Object.keys(self.#out[v]).length === 0);
  }

  /**
   * Invokes setNode method for each node in names list.
   * Complexity: O(|names|).
   */
  setNodes(vs, value) {
    var args = arguments;
    var self = this;
    vs.forEach(function(v) {
      if (args.length > 1) {
        self.setNode(v, value);
      } else {
        self.setNode(v);
      }
    });
    return this;
  }

  /**
   * Creates or updates the value for the node v in the graph. If label is supplied
   * it is set as the value for the node. If label is not supplied and the node was
   * created by this call then the default node label will be assigned.
   * Complexity: O(1).
   */
  setNode(v, value) {
    if (this.#nodes.hasOwnProperty(v)) {
      if (arguments.length > 1) {
        this.#nodes[v] = value;
      }
      return this;
    }

    this.#nodes[v] = arguments.length > 1 ? value : this.#defaultNodeLabelFn(v);
    if (this.#isCompound) {
      this.#parent[v] = GRAPH_NODE;
      this.#children[v] = {};
      this.#children[GRAPH_NODE][v] = true;
    }
    this.#in[v] = {};
    this.#preds[v] = {};
    this.#out[v] = {};
    this.#sucs[v] = {};
    ++this.#nodeCount;
    return this;
  }

  /**
   * Gets the label of node with specified name.
   * Complexity: O(|V|).
   */
  node(v) {
    return this.#nodes[v];
  }

  /**
   * Detects whether graph has a node with specified name or not.
   */
  hasNode(v) {
    return this.#nodes.hasOwnProperty(v);
  }

  /**
   * Remove the node with the name from the graph or do nothing if the node is not in
   * the graph. If the node was removed this function also removes any incident
   * edges.
   * Complexity: O(1).
   */
  removeNode(v) {
    var self = this;
    if (this.#nodes.hasOwnProperty(v)) {
      var removeEdge = e => self.removeEdge(self.#edgeObjs[e]);
      delete this.#nodes[v];
      if (this.#isCompound) {
        this.#removeFromParentsChildList(v);
        delete this.#parent[v];
        this.children(v).forEach(function(child) {
          self.setParent(child);
        });
        delete this.#children[v];
      }
      Object.keys(this.#in[v]).forEach(removeEdge);
      delete this.#in[v];
      delete this.#preds[v];
      Object.keys(this.#out[v]).forEach(removeEdge);
      delete this.#out[v];
      delete this.#sucs[v];
      --this.#nodeCount;
    }
    return this;
  }

  /**
   * Sets node p as a parent for node v if it is defined, or removes the
   * parent for v if p is undefined. Method throws an exception in case of
   * invoking it in context of noncompound graph.
   * Average-case complexity: O(1).
   */
  setParent(v, parent) {
    if (!this.#isCompound) {
      throw new Error("Cannot set parent in a non-compound graph");
    }

    if (parent === undefined) {
      parent = GRAPH_NODE;
    } else {
      // Coerce parent to string
      parent += "";
      for (var ancestor = parent; ancestor !== undefined; ancestor = this.parent(ancestor)) {
        if (ancestor === v) {
          throw new Error("Setting " + parent+ " as parent of " + v +
              " would create a cycle");
        }
      }

      this.setNode(parent);
    }

    this.setNode(v);
    this.#removeFromParentsChildList(v);
    this.#parent[v] = parent;
    this.#children[parent][v] = true;
    return this;
  }

  #removeFromParentsChildList(v) {
    delete this.#children[this.#parent[v]][v];
  }

  /**
   * Gets parent node for node v.
   * Complexity: O(1).
   */
  parent(v) {
    if (this.#isCompound) {
      var parent = this.#parent[v];
      if (parent !== GRAPH_NODE) {
        return parent;
      }
    }
  }

  /**
   * Gets list of direct children of node v.
   * Complexity: O(1).
   */
  children(v = GRAPH_NODE) {
    if (this.#isCompound) {
      var children = this.#children[v];
      if (children) {
        return Object.keys(children);
      }
    } else if (v === GRAPH_NODE) {
      return this.nodes();
    } else if (this.hasNode(v)) {
      return [];
    }
  }

  /**
   * Return all nodes that are predecessors of the specified node or undefined if node v is not in
   * the graph. Behavior is undefined for undirected graphs - use neighbors instead.
   * Complexity: O(|V|).
   */
  predecessors(v) {
    var predsV = this.#preds[v];
    if (predsV) {
      return Object.keys(predsV);
    }
  }

  /**
   * Return all nodes that are successors of the specified node or undefined if node v is not in
   * the graph. Behavior is undefined for undirected graphs - use neighbors instead.
   * Complexity: O(|V|).
   */
  successors(v) {
    var sucsV = this.#sucs[v];
    if (sucsV) {
      return Object.keys(sucsV);
    }
  }

  /**
   * Return all nodes that are predecessors or successors of the specified node or undefined if
   * node v is not in the graph.
   * Complexity: O(|V|).
   */
  neighbors(v) {
    var preds = this.predecessors(v);
    if (preds) {
      const union = new Set(preds);
      for (var succ of this.successors(v)) {
        union.add(succ);
      }

      return Array.from(union.values());
    }
  }

  isLeaf(v) {
    var neighbors;
    if (this.isDirected()) {
      neighbors = this.successors(v);
    } else {
      neighbors = this.neighbors(v);
    }
    return neighbors.length === 0;
  }

  /**
   * Creates new graph with nodes filtered via filter. Edges incident to rejected node
   * are also removed. In case of compound graph, if parent is rejected by filter,
   * than all its children are rejected too.
   * Average-case complexity: O(|E|+|V|).
   */
  filterNodes(filter) {
    var copy = new this.constructor({
      directed: this.#isDirected,
      multigraph: this.#isMultigraph,
      compound: this.#isCompound
    });

    copy.setGraph(this.graph());

    var self = this;
    Object.entries(this.#nodes).forEach(function([v, value]) {
      if (filter(v)) {
        copy.setNode(v, value);
      }
    });

    Object.values(this.#edgeObjs).forEach(function(e) {
      if (copy.hasNode(e.v) && copy.hasNode(e.w)) {
        copy.setEdge(e, self.edge(e));
      }
    });

    var parents = {};
    function findParent(v) {
      var parent = self.parent(v);
      if (parent === undefined || copy.hasNode(parent)) {
        parents[v] = parent;
        return parent;
      } else if (parent in parents) {
        return parents[parent];
      } else {
        return findParent(parent);
      }
    }

    if (this.#isCompound) {
      copy.nodes().forEach(v => copy.setParent(v, findParent(v)));
    }

    return copy;
  }

  /* === Edge functions ========== */

  /**
   * Sets the default edge label or factory function. This label will be
   * assigned as default label in case if no label was specified while setting
   * an edge or this function will be invoked each time when setting an edge
   * with no label specified and returned value * will be used as a label for edge.
   * Complexity: O(1).
   */
  setDefaultEdgeLabel(newDefault) {
    this.#defaultEdgeLabelFn = newDefault;
    if (typeof newDefault !== 'function') {
      this.#defaultEdgeLabelFn = () => newDefault;
    }

    return this;
  }

  /**
   * Gets the number of edges in the graph.
   * Complexity: O(1).
   */
  edgeCount() {
    return this.#edgeCount;
  }

  /**
   * Gets edges of the graph. In case of compound graph subgraphs are not considered.
   * Complexity: O(|E|).
   */
  edges() {
    return Object.values(this.#edgeObjs);
  }

  /**
   * Establish an edges path over the nodes in nodes list. If some edge is already
   * exists, it will update its label, otherwise it will create an edge between pair
   * of nodes with label provided or default label if no label provided.
   * Complexity: O(|nodes|).
   */
  setPath(vs, value) {
    var self = this;
    var args = arguments;
    vs.reduce(function(v, w) {
      if (args.length > 1) {
        self.setEdge(v, w, value);
      } else {
        self.setEdge(v, w);
      }
      return w;
    });
    return this;
  }

  /**
   * Creates or updates the label for the edge (v, w) with the optionally supplied
   * name. If label is supplied it is set as the value for the edge. If label is not
   * supplied and the edge was created by this call then the default edge label will
   * be assigned. The name parameter is only useful with multigraphs.
   */
  setEdge() {
    var v, w, name, value;
    var valueSpecified = false;
    var arg0 = arguments[0];

    if (typeof arg0 === "object" && arg0 !== null && "v" in arg0) {
      v = arg0.v;
      w = arg0.w;
      name = arg0.name;
      if (arguments.length === 2) {
        value = arguments[1];
        valueSpecified = true;
      }
    } else {
      v = arg0;
      w = arguments[1];
      name = arguments[3];
      if (arguments.length > 2) {
        value = arguments[2];
        valueSpecified = true;
      }
    }

    v = "" + v;
    w = "" + w;
    if (name !== undefined) {
      name = "" + name;
    }

    var e = edgeArgsToId(this.#isDirected, v, w, name);
    if (this.#edgeLabels.hasOwnProperty(e)) {
      if (valueSpecified) {
        this.#edgeLabels[e] = value;
      }
      return this;
    }

    if (name !== undefined && !this.#isMultigraph) {
      throw new Error("Cannot set a named edge when isMultigraph = false");
    }

    // It didn't exist, so we need to create it.
    // First ensure the nodes exist.
    this.setNode(v);
    this.setNode(w);

    this.#edgeLabels[e] = valueSpecified ? value : this.#defaultEdgeLabelFn(v, w, name);

    var edgeObj = edgeArgsToObj(this.#isDirected, v, w, name);
    // Ensure we add undirected edges in a consistent way.
    v = edgeObj.v;
    w = edgeObj.w;

    Object.freeze(edgeObj);
    this.#edgeObjs[e] = edgeObj;
    incrementOrInitEntry(this.#preds[w], v);
    incrementOrInitEntry(this.#sucs[v], w);
    this.#in[w][e] = edgeObj;
    this.#out[v][e] = edgeObj;
    this.#edgeCount++;
    return this;
  }

  /**
   * Gets the label for the specified edge.
   * Complexity: O(1).
   */
  edge(v, w, name) {
    var e = (arguments.length === 1
      ? edgeObjToId(this.#isDirected, arguments[0])
      : edgeArgsToId(this.#isDirected, v, w, name));
    return this.#edgeLabels[e];
  }

  /**
   * Gets the label for the specified edge and converts it to an object.
   * Complexity: O(1)
   */
  edgeAsObj() {
    const edge = this.edge(...arguments);
    if (typeof edge !== "object") {
      return {label: edge};
    }

    return edge;
  }

  /**
   * Detects whether the graph contains specified edge or not. No subgraphs are considered.
   * Complexity: O(1).
   */
  hasEdge(v, w, name) {
    var e = (arguments.length === 1
      ? edgeObjToId(this.#isDirected, arguments[0])
      : edgeArgsToId(this.#isDirected, v, w, name));
    return this.#edgeLabels.hasOwnProperty(e);
  }

  /**
   * Removes the specified edge from the graph. No subgraphs are considered.
   * Complexity: O(1).
   */
  removeEdge(v, w, name) {
    var e = (arguments.length === 1
      ? edgeObjToId(this.#isDirected, arguments[0])
      : edgeArgsToId(this.#isDirected, v, w, name));
    var edge = this.#edgeObjs[e];
    if (edge) {
      v = edge.v;
      w = edge.w;
      delete this.#edgeLabels[e];
      delete this.#edgeObjs[e];
      decrementOrRemoveEntry(this.#preds[w], v);
      decrementOrRemoveEntry(this.#sucs[v], w);
      delete this.#in[w][e];
      delete this.#out[v][e];
      this.#edgeCount--;
    }
    return this;
  }

  /**
   * Return all edges that point to the node v. Optionally filters those edges down to just those
   * coming from node u. Behavior is undefined for undirected graphs - use nodeEdges instead.
   * Complexity: O(|E|).
   */
  inEdges(v, u) {
    var inV = this.#in[v];
    if (inV) {
      var edges = Object.values(inV);
      if (!u) {
        return edges;
      }
      return edges.filter(edge => edge.v === u);
    }
  }

  /**
   * Return all edges that are pointed at by node v. Optionally filters those edges down to just
   * those point to w. Behavior is undefined for undirected graphs - use nodeEdges instead.
   * Complexity: O(|E|).
   */
  outEdges(v, w) {
    var outV = this.#out[v];
    if (outV) {
      var edges = Object.values(outV);
      if (!w) {
        return edges;
      }
      return edges.filter(edge => edge.w === w);
    }
  }

  /**
   * Returns all edges to or from node v regardless of direction. Optionally filters those edges
   * down to just those between nodes v and w regardless of direction.
   * Complexity: O(|E|).
   */
  nodeEdges(v, w) {
    var inEdges = this.inEdges(v, w);
    if (inEdges) {
      return inEdges.concat(this.outEdges(v, w));
    }
  }
};

function incrementOrInitEntry(map, k) {
  if (map[k]) {
    map[k]++;
  } else {
    map[k] = 1;
  }
}

function decrementOrRemoveEntry(map, k) {
  if (!--map[k]) { delete map[k]; }
}

function edgeArgsToId(isDirected, v_, w_, name) {
  var v = "" + v_;
  var w = "" + w_;
  if (!isDirected && v > w) {
    var tmp = v;
    v = w;
    w = tmp;
  }
  return v + EDGE_KEY_DELIM + w + EDGE_KEY_DELIM +
             (name === undefined ? DEFAULT_EDGE_NAME : name);
}

function edgeArgsToObj(isDirected, v_, w_, name) {
  var v = "" + v_;
  var w = "" + w_;
  if (!isDirected && v > w) {
    var tmp = v;
    v = w;
    w = tmp;
  }
  var edgeObj =  { v: v, w: w };
  if (name) {
    edgeObj.name = name;
  }
  return edgeObj;
}

function edgeObjToId(isDirected, edgeObj) {
  return edgeArgsToId(isDirected, edgeObj.v, edgeObj.w, edgeObj.name);
}

var graph = Graph$a;

var version$1 = '2.1.13';

// Includes only the "core" of graphlib
var lib$1 = {
  Graph: graph,
  version: version$1
};

var Graph$9 = graph;

var json = {
  write: write,
  read: read
};

/**
 * Creates a JSON representation of the graph that can be serialized to a string with
 * JSON.stringify. The graph can later be restored using json.read.
 */
function write(g) {
  var json = {
    options: {
      directed: g.isDirected(),
      multigraph: g.isMultigraph(),
      compound: g.isCompound()
    },
    nodes: writeNodes(g),
    edges: writeEdges(g)
  };

  if (g.graph() !== undefined) {
    json.value = structuredClone(g.graph());
  }
  return json;
}

function writeNodes(g) {
  return g.nodes().map(function(v) {
    var nodeValue = g.node(v);
    var parent = g.parent(v);
    var node = { v: v };
    if (nodeValue !== undefined) {
      node.value = nodeValue;
    }
    if (parent !== undefined) {
      node.parent = parent;
    }
    return node;
  });
}

function writeEdges(g) {
  return g.edges().map(function(e) {
    var edgeValue = g.edge(e);
    var edge = { v: e.v, w: e.w };
    if (e.name !== undefined) {
      edge.name = e.name;
    }
    if (edgeValue !== undefined) {
      edge.value = edgeValue;
    }
    return edge;
  });
}

/**
 * Takes JSON as input and returns the graph representation.
 *
 * @example
 * var g2 = graphlib.json.read(JSON.parse(str));
 * g2.nodes();
 * // ['a', 'b']
 * g2.edges()
 * // [ { v: 'a', w: 'b' } ]
 */
function read(json) {
  var g = new Graph$9(json.options).setGraph(json.value);
  json.nodes.forEach(function(entry) {
    g.setNode(entry.v, entry.value);
    if (entry.parent) {
      g.setParent(entry.v, entry.parent);
    }
  });
  json.edges.forEach(function(entry) {
    g.setEdge({ v: entry.v, w: entry.w, name: entry.name }, entry.value);
  });
  return g;
}

var components_1 = components;

function components(g) {
  var visited = {};
  var cmpts = [];
  var cmpt;

  function dfs(v) {
    if (visited.hasOwnProperty(v)) return;
    visited[v] = true;
    cmpt.push(v);
    g.successors(v).forEach(dfs);
    g.predecessors(v).forEach(dfs);
  }

  g.nodes().forEach(function(v) {
    cmpt = [];
    dfs(v);
    if (cmpt.length) {
      cmpts.push(cmpt);
    }
  });

  return cmpts;
}

/**
 * A min-priority queue data structure. This algorithm is derived from Cormen,
 * et al., "Introduction to Algorithms". The basic idea of a min-priority
 * queue is that you can efficiently (in O(1) time) get the smallest key in
 * the queue. Adding and removing elements takes O(log n) time. A key can
 * have its priority decreased in O(log n) time.
 */

let PriorityQueue$2 = class PriorityQueue {
  #arr = [];
  #keyIndices = {};

  /**
   * Returns the number of elements in the queue. Takes `O(1)` time.
   */
  size() {
    return this.#arr.length;
  }

  /**
   * Returns the keys that are in the queue. Takes `O(n)` time.
   */
  keys() {
    return this.#arr.map(function(x) { return x.key; });
  }

  /**
   * Returns `true` if **key** is in the queue and `false` if not.
   */
  has(key) {
    return this.#keyIndices.hasOwnProperty(key);
  }

  /**
   * Returns the priority for **key**. If **key** is not present in the queue
   * then this function returns `undefined`. Takes `O(1)` time.
   *
   * @param {Object} key
   */
  priority(key) {
    var index = this.#keyIndices[key];
    if (index !== undefined) {
      return this.#arr[index].priority;
    }
  }

  /**
   * Returns the key for the minimum element in this queue. If the queue is
   * empty this function throws an Error. Takes `O(1)` time.
   */
  min() {
    if (this.size() === 0) {
      throw new Error("Queue underflow");
    }
    return this.#arr[0].key;
  }

  /**
   * Inserts a new key into the priority queue. If the key already exists in
   * the queue this function returns `false`; otherwise it will return `true`.
   * Takes `O(n)` time.
   *
   * @param {Object} key the key to add
   * @param {Number} priority the initial priority for the key
   */
  add(key, priority) {
    var keyIndices = this.#keyIndices;
    key = String(key);
    if (!keyIndices.hasOwnProperty(key)) {
      var arr = this.#arr;
      var index = arr.length;
      keyIndices[key] = index;
      arr.push({key: key, priority: priority});
      this.#decrease(index);
      return true;
    }
    return false;
  }

  /**
   * Removes and returns the smallest key in the queue. Takes `O(log n)` time.
   */
  removeMin() {
    this.#swap(0, this.#arr.length - 1);
    var min = this.#arr.pop();
    delete this.#keyIndices[min.key];
    this.#heapify(0);
    return min.key;
  }

  /**
   * Decreases the priority for **key** to **priority**. If the new priority is
   * greater than the previous priority, this function will throw an Error.
   *
   * @param {Object} key the key for which to raise priority
   * @param {Number} priority the new priority for the key
   */
  decrease(key, priority) {
    var index = this.#keyIndices[key];
    if (priority > this.#arr[index].priority) {
      throw new Error("New priority is greater than current priority. " +
          "Key: " + key + " Old: " + this.#arr[index].priority + " New: " + priority);
    }
    this.#arr[index].priority = priority;
    this.#decrease(index);
  }

  #heapify(i) {
    var arr = this.#arr;
    var l = 2 * i;
    var r = l + 1;
    var largest = i;
    if (l < arr.length) {
      largest = arr[l].priority < arr[largest].priority ? l : largest;
      if (r < arr.length) {
        largest = arr[r].priority < arr[largest].priority ? r : largest;
      }
      if (largest !== i) {
        this.#swap(i, largest);
        this.#heapify(largest);
      }
    }
  }

  #decrease(index) {
    var arr = this.#arr;
    var priority = arr[index].priority;
    var parent;
    while (index !== 0) {
      parent = index >> 1;
      if (arr[parent].priority < priority) {
        break;
      }
      this.#swap(index, parent);
      index = parent;
    }
  }

  #swap(i, j) {
    var arr = this.#arr;
    var keyIndices = this.#keyIndices;
    var origArrI = arr[i];
    var origArrJ = arr[j];
    arr[i] = origArrJ;
    arr[j] = origArrI;
    keyIndices[origArrJ.key] = i;
    keyIndices[origArrI.key] = j;
  }
};

var priorityQueue = PriorityQueue$2;

var PriorityQueue$1 = priorityQueue;

var dijkstra_1 = dijkstra$1;

var DEFAULT_WEIGHT_FUNC$1 = () => 1;

function dijkstra$1(g, source, weightFn, edgeFn) {
  return runDijkstra(g, String(source),
    weightFn || DEFAULT_WEIGHT_FUNC$1,
    edgeFn || function(v) { return g.outEdges(v); });
}

function runDijkstra(g, source, weightFn, edgeFn) {
  var results = {};
  var pq = new PriorityQueue$1();
  var v, vEntry;

  var updateNeighbors = function(edge) {
    var w = edge.v !== v ? edge.v : edge.w;
    var wEntry = results[w];
    var weight = weightFn(edge);
    var distance = vEntry.distance + weight;

    if (weight < 0) {
      throw new Error("dijkstra does not allow negative edge weights. " +
                      "Bad edge: " + edge + " Weight: " + weight);
    }

    if (distance < wEntry.distance) {
      wEntry.distance = distance;
      wEntry.predecessor = v;
      pq.decrease(w, distance);
    }
  };

  g.nodes().forEach(function(v) {
    var distance = v === source ? 0 : Number.POSITIVE_INFINITY;
    results[v] = { distance: distance };
    pq.add(v, distance);
  });

  while (pq.size() > 0) {
    v = pq.removeMin();
    vEntry = results[v];
    if (vEntry.distance === Number.POSITIVE_INFINITY) {
      break;
    }

    edgeFn(v).forEach(updateNeighbors);
  }

  return results;
}

var dijkstra = dijkstra_1;

var dijkstraAll_1 = dijkstraAll;

function dijkstraAll(g, weightFunc, edgeFunc) {
  return g.nodes().reduce(function(acc, v) {
    acc[v] = dijkstra(g, v, weightFunc, edgeFunc);
    return acc;
  }, {});
}

var tarjan_1 = tarjan$1;

function tarjan$1(g) {
  var index = 0;
  var stack = [];
  var visited = {}; // node id -> { onStack, lowlink, index }
  var results = [];

  function dfs(v) {
    var entry = visited[v] = {
      onStack: true,
      lowlink: index,
      index: index++
    };
    stack.push(v);

    g.successors(v).forEach(function(w) {
      if (!visited.hasOwnProperty(w)) {
        dfs(w);
        entry.lowlink = Math.min(entry.lowlink, visited[w].lowlink);
      } else if (visited[w].onStack) {
        entry.lowlink = Math.min(entry.lowlink, visited[w].index);
      }
    });

    if (entry.lowlink === entry.index) {
      var cmpt = [];
      var w;
      do {
        w = stack.pop();
        visited[w].onStack = false;
        cmpt.push(w);
      } while (v !== w);
      results.push(cmpt);
    }
  }

  g.nodes().forEach(function(v) {
    if (!visited.hasOwnProperty(v)) {
      dfs(v);
    }
  });

  return results;
}

var tarjan = tarjan_1;

var findCycles_1 = findCycles;

function findCycles(g) {
  return tarjan(g).filter(function(cmpt) {
    return cmpt.length > 1 || (cmpt.length === 1 && g.hasEdge(cmpt[0], cmpt[0]));
  });
}

var floydWarshall_1 = floydWarshall;

var DEFAULT_WEIGHT_FUNC = () => 1;

function floydWarshall(g, weightFn, edgeFn) {
  return runFloydWarshall(g,
    weightFn || DEFAULT_WEIGHT_FUNC,
    edgeFn || function(v) { return g.outEdges(v); });
}

function runFloydWarshall(g, weightFn, edgeFn) {
  var results = {};
  var nodes = g.nodes();

  nodes.forEach(function(v) {
    results[v] = {};
    results[v][v] = { distance: 0 };
    nodes.forEach(function(w) {
      if (v !== w) {
        results[v][w] = { distance: Number.POSITIVE_INFINITY };
      }
    });
    edgeFn(v).forEach(function(edge) {
      var w = edge.v === v ? edge.w : edge.v;
      var d = weightFn(edge);
      results[v][w] = { distance: d, predecessor: v };
    });
  });

  nodes.forEach(function(k) {
    var rowK = results[k];
    nodes.forEach(function(i) {
      var rowI = results[i];
      nodes.forEach(function(j) {
        var ik = rowI[k];
        var kj = rowK[j];
        var ij = rowI[j];
        var altDistance = ik.distance + kj.distance;
        if (altDistance < ij.distance) {
          ij.distance = altDistance;
          ij.predecessor = kj.predecessor;
        }
      });
    });
  });

  return results;
}

function topsort$1(g) {
  var visited = {};
  var stack = {};
  var results = [];

  function visit(node) {
    if (stack.hasOwnProperty(node)) {
      throw new CycleException();
    }

    if (!visited.hasOwnProperty(node)) {
      stack[node] = true;
      visited[node] = true;
      g.predecessors(node).forEach(visit);
      delete stack[node];
      results.push(node);
    }
  }

  g.sinks().forEach(visit);

  if (Object.keys(visited).length !== g.nodeCount()) {
    throw new CycleException();
  }

  return results;
}

class CycleException extends Error {
  constructor() {
    super(...arguments);
  }
}

var topsort_1 = topsort$1;
topsort$1.CycleException = CycleException;

var topsort = topsort_1;

var isAcyclic_1 = isAcyclic;

function isAcyclic(g) {
  try {
    topsort(g);
  } catch (e) {
    if (e instanceof topsort.CycleException) {
      return false;
    }
    throw e;
  }
  return true;
}

var dfs_1 = dfs$3;

/*
 * A helper that preforms a pre- or post-order traversal on the input graph
 * and returns the nodes in the order they were visited. If the graph is
 * undirected then this algorithm will navigate using neighbors. If the graph
 * is directed then this algorithm will navigate using successors.
 *
 * If the order is not "post", it will be treated as "pre".
 */
function dfs$3(g, vs, order) {
  if (!Array.isArray(vs)) {
    vs = [vs];
  }

  var navigation = g.isDirected() ? v => g.successors(v) : v => g.neighbors(v);
  var orderFunc = order === "post" ? postOrderDfs : preOrderDfs;

  var acc = [];
  var visited = {};
  vs.forEach(v => {
    if (!g.hasNode(v)) {
      throw new Error("Graph does not have node: " + v);
    }

    orderFunc(v, navigation, visited, acc);
  });

  return acc;
}

function postOrderDfs(v, navigation, visited, acc) {
  var stack = [[v, false]];
  while (stack.length > 0) {
    var curr = stack.pop();
    if (curr[1]) {
      acc.push(curr[0]);
    } else {
      if (!visited.hasOwnProperty(curr[0])) {
        visited[curr[0]] = true;
        stack.push([curr[0], true]);
        forEachRight(navigation(curr[0]), w => stack.push([w, false]));
      }
    }
  }
}

function preOrderDfs(v, navigation, visited, acc) {
  var stack = [v];
  while (stack.length > 0) {
    var curr = stack.pop();
    if (!visited.hasOwnProperty(curr)) {
      visited[curr] = true;
      acc.push(curr);
      forEachRight(navigation(curr), w => stack.push(w));
    }
  }
}

function forEachRight(array, iteratee) {
  var length = array.length;
  while (length--) {
    iteratee(array[length], length, array);
  }

  return array;
}

var dfs$2 = dfs_1;

var postorder_1 = postorder$2;

function postorder$2(g, vs) {
  return dfs$2(g, vs, "post");
}

var dfs$1 = dfs_1;

var preorder_1 = preorder$1;

function preorder$1(g, vs) {
  return dfs$1(g, vs, "pre");
}

var Graph$8 = graph;
var PriorityQueue = priorityQueue;

var prim_1 = prim;

function prim(g, weightFunc) {
  var result = new Graph$8();
  var parents = {};
  var pq = new PriorityQueue();
  var v;

  function updateNeighbors(edge) {
    var w = edge.v === v ? edge.w : edge.v;
    var pri = pq.priority(w);
    if (pri !== undefined) {
      var edgeWeight = weightFunc(edge);
      if (edgeWeight < pri) {
        parents[w] = v;
        pq.decrease(w, edgeWeight);
      }
    }
  }

  if (g.nodeCount() === 0) {
    return result;
  }

  g.nodes().forEach(function(v) {
    pq.add(v, Number.POSITIVE_INFINITY);
    result.setNode(v);
  });

  // Start from an arbitrary node
  pq.decrease(g.nodes()[0], 0);

  var init = false;
  while (pq.size() > 0) {
    v = pq.removeMin();
    if (parents.hasOwnProperty(v)) {
      result.setEdge(v, parents[v]);
    } else if (init) {
      throw new Error("Input graph is not connected: " + g);
    } else {
      init = true;
    }

    g.nodeEdges(v).forEach(updateNeighbors);
  }

  return result;
}

var alg = {
  components: components_1,
  dijkstra: dijkstra_1,
  dijkstraAll: dijkstraAll_1,
  findCycles: findCycles_1,
  floydWarshall: floydWarshall_1,
  isAcyclic: isAcyclic_1,
  postorder: postorder_1,
  preorder: preorder_1,
  prim: prim_1,
  tarjan: tarjan_1,
  topsort: topsort_1
};

/**
 * Copyright (c) 2014, Chris Pettitt
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors
 * may be used to endorse or promote products derived from this software without
 * specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

var lib = lib$1;

var graphlib = {
  Graph: lib.Graph,
  json: json,
  alg: alg,
  version: lib.version
};

/*
 * Simple doubly linked list implementation derived from Cormen, et al.,
 * "Introduction to Algorithms".
 */

let List$1 = class List {
  constructor() {
    let sentinel = {};
    sentinel._next = sentinel._prev = sentinel;
    this._sentinel = sentinel;
  }

  dequeue() {
    let sentinel = this._sentinel;
    let entry = sentinel._prev;
    if (entry !== sentinel) {
      unlink(entry);
      return entry;
    }
  }

  enqueue(entry) {
    let sentinel = this._sentinel;
    if (entry._prev && entry._next) {
      unlink(entry);
    }
    entry._next = sentinel._next;
    sentinel._next._prev = entry;
    sentinel._next = entry;
    entry._prev = sentinel;
  }

  toString() {
    let strs = [];
    let sentinel = this._sentinel;
    let curr = sentinel._prev;
    while (curr !== sentinel) {
      strs.push(JSON.stringify(curr, filterOutLinks));
      curr = curr._prev;
    }
    return "[" + strs.join(", ") + "]";
  }
};

function unlink(entry) {
  entry._prev._next = entry._next;
  entry._next._prev = entry._prev;
  delete entry._next;
  delete entry._prev;
}

function filterOutLinks(k, v) {
  if (k !== "_next" && k !== "_prev") {
    return v;
  }
}

var list = List$1;

let Graph$7 = graphlib.Graph;
let List = list;

/*
 * A greedy heuristic for finding a feedback arc set for a graph. A feedback
 * arc set is a set of edges that can be removed to make a graph acyclic.
 * The algorithm comes from: P. Eades, X. Lin, and W. F. Smyth, "A fast and
 * effective heuristic for the feedback arc set problem." This implementation
 * adjusts that from the paper to allow for weighted edges.
 */
var greedyFas = greedyFAS$1;

let DEFAULT_WEIGHT_FN = () => 1;

function greedyFAS$1(g, weightFn) {
  if (g.nodeCount() <= 1) {
    return [];
  }
  let state = buildState(g, weightFn || DEFAULT_WEIGHT_FN);
  let results = doGreedyFAS(state.graph, state.buckets, state.zeroIdx);

  // Expand multi-edges
  return results.flatMap(e => g.outEdges(e.v, e.w));
}

function doGreedyFAS(g, buckets, zeroIdx) {
  let results = [];
  let sources = buckets[buckets.length - 1];
  let sinks = buckets[0];

  let entry;
  while (g.nodeCount()) {
    while ((entry = sinks.dequeue()))   { removeNode(g, buckets, zeroIdx, entry); }
    while ((entry = sources.dequeue())) { removeNode(g, buckets, zeroIdx, entry); }
    if (g.nodeCount()) {
      for (let i = buckets.length - 2; i > 0; --i) {
        entry = buckets[i].dequeue();
        if (entry) {
          results = results.concat(removeNode(g, buckets, zeroIdx, entry, true));
          break;
        }
      }
    }
  }

  return results;
}

function removeNode(g, buckets, zeroIdx, entry, collectPredecessors) {
  let results = collectPredecessors ? [] : undefined;

  g.inEdges(entry.v).forEach(edge => {
    let weight = g.edge(edge);
    let uEntry = g.node(edge.v);

    if (collectPredecessors) {
      results.push({ v: edge.v, w: edge.w });
    }

    uEntry.out -= weight;
    assignBucket(buckets, zeroIdx, uEntry);
  });

  g.outEdges(entry.v).forEach(edge => {
    let weight = g.edge(edge);
    let w = edge.w;
    let wEntry = g.node(w);
    wEntry["in"] -= weight;
    assignBucket(buckets, zeroIdx, wEntry);
  });

  g.removeNode(entry.v);

  return results;
}

function buildState(g, weightFn) {
  let fasGraph = new Graph$7();
  let maxIn = 0;
  let maxOut = 0;

  g.nodes().forEach(v => {
    fasGraph.setNode(v, { v: v, "in": 0, out: 0 });
  });

  // Aggregate weights on nodes, but also sum the weights across multi-edges
  // into a single edge for the fasGraph.
  g.edges().forEach(e => {
    let prevWeight = fasGraph.edge(e.v, e.w) || 0;
    let weight = weightFn(e);
    let edgeWeight = prevWeight + weight;
    fasGraph.setEdge(e.v, e.w, edgeWeight);
    maxOut = Math.max(maxOut, fasGraph.node(e.v).out += weight);
    maxIn  = Math.max(maxIn,  fasGraph.node(e.w)["in"]  += weight);
  });

  let buckets = range$1(maxOut + maxIn + 3).map(() => new List());
  let zeroIdx = maxIn + 1;

  fasGraph.nodes().forEach(v => {
    assignBucket(buckets, zeroIdx, fasGraph.node(v));
  });

  return { graph: fasGraph, buckets: buckets, zeroIdx: zeroIdx };
}

function assignBucket(buckets, zeroIdx, entry) {
  if (!entry.out) {
    buckets[0].enqueue(entry);
  } else if (!entry["in"]) {
    buckets[buckets.length - 1].enqueue(entry);
  } else {
    buckets[entry.out - entry["in"] + zeroIdx].enqueue(entry);
  }
}

function range$1(limit) {
  const range = [];
  for (let i = 0; i < limit; i++) {
    range.push(i);
  }

  return range;
}

/* eslint "no-console": off */

let Graph$6 = graphlib.Graph;

var util$d = {
  addBorderNode: addBorderNode$1,
  addDummyNode,
  asNonCompoundGraph,
  buildLayerMatrix,
  intersectRect,
  mapValues,
  maxRank,
  normalizeRanks: normalizeRanks$1,
  notime,
  partition,
  pick,
  predecessorWeights,
  range,
  removeEmptyRanks: removeEmptyRanks$1,
  simplify: simplify$1,
  successorWeights,
  time,
  uniqueId: uniqueId$1,
  zipObject: zipObject$1,
};

/*
 * Adds a dummy node to the graph and return v.
 */
function addDummyNode(g, type, attrs, name) {
  let v;
  do {
    v = uniqueId$1(name);
  } while (g.hasNode(v));

  attrs.dummy = type;
  g.setNode(v, attrs);
  return v;
}

/*
 * Returns a new graph with only simple edges. Handles aggregation of data
 * associated with multi-edges.
 */
function simplify$1(g) {
  let simplified = new Graph$6().setGraph(g.graph());
  g.nodes().forEach(v => simplified.setNode(v, g.node(v)));
  g.edges().forEach(e => {
    let simpleLabel = simplified.edge(e.v, e.w) || { weight: 0, minlen: 1 };
    let label = g.edge(e);
    simplified.setEdge(e.v, e.w, {
      weight: simpleLabel.weight + label.weight,
      minlen: Math.max(simpleLabel.minlen, label.minlen)
    });
  });
  return simplified;
}

function asNonCompoundGraph(g) {
  let simplified = new Graph$6({ multigraph: g.isMultigraph() }).setGraph(g.graph());
  g.nodes().forEach(v => {
    if (!g.children(v).length) {
      simplified.setNode(v, g.node(v));
    }
  });
  g.edges().forEach(e => {
    simplified.setEdge(e, g.edge(e));
  });
  return simplified;
}

function successorWeights(g) {
  let weightMap = g.nodes().map(v => {
    let sucs = {};
    g.outEdges(v).forEach(e => {
      sucs[e.w] = (sucs[e.w] || 0) + g.edge(e).weight;
    });
    return sucs;
  });
  return zipObject$1(g.nodes(), weightMap);
}

function predecessorWeights(g) {
  let weightMap = g.nodes().map(v => {
    let preds = {};
    g.inEdges(v).forEach(e => {
      preds[e.v] = (preds[e.v] || 0) + g.edge(e).weight;
    });
    return preds;
  });
  return zipObject$1(g.nodes(), weightMap);
}

/*
 * Finds where a line starting at point ({x, y}) would intersect a rectangle
 * ({x, y, width, height}) if it were pointing at the rectangle's center.
 */
function intersectRect(rect, point) {
  let x = rect.x;
  let y = rect.y;

  // Rectangle intersection algorithm from:
  // http://math.stackexchange.com/questions/108113/find-edge-between-two-boxes
  let dx = point.x - x;
  let dy = point.y - y;
  let w = rect.width / 2;
  let h = rect.height / 2;

  if (!dx && !dy) {
    throw new Error("Not possible to find intersection inside of the rectangle");
  }

  let sx, sy;
  if (Math.abs(dy) * w > Math.abs(dx) * h) {
    // Intersection is top or bottom of rect.
    if (dy < 0) {
      h = -h;
    }
    sx = h * dx / dy;
    sy = h;
  } else {
    // Intersection is left or right of rect.
    if (dx < 0) {
      w = -w;
    }
    sx = w;
    sy = w * dy / dx;
  }

  return { x: x + sx, y: y + sy };
}

/*
 * Given a DAG with each node assigned "rank" and "order" properties, this
 * function will produce a matrix with the ids of each node.
 */
function buildLayerMatrix(g) {
  let layering = range(maxRank(g) + 1).map(() => []);
  g.nodes().forEach(v => {
    let node = g.node(v);
    let rank = node.rank;
    if (rank !== undefined) {
      layering[rank][node.order] = v;
    }
  });
  return layering;
}

/*
 * Adjusts the ranks for all nodes in the graph such that all nodes v have
 * rank(v) >= 0 and at least one node w has rank(w) = 0.
 */
function normalizeRanks$1(g) {
  let min = Math.min(...g.nodes().map(v => {
    let rank = g.node(v).rank;
    if (rank === undefined) {
      return Number.MAX_VALUE;
    }

    return rank;
  }));
  g.nodes().forEach(v => {
    let node = g.node(v);
    if (node.hasOwnProperty("rank")) {
      node.rank -= min;
    }
  });
}

function removeEmptyRanks$1(g) {
  // Ranks may not start at 0, so we need to offset them
  let offset = Math.min(...g.nodes().map(v => g.node(v).rank));

  let layers = [];
  g.nodes().forEach(v => {
    let rank = g.node(v).rank - offset;
    if (!layers[rank]) {
      layers[rank] = [];
    }
    layers[rank].push(v);
  });

  let delta = 0;
  let nodeRankFactor = g.graph().nodeRankFactor;
  Array.from(layers).forEach((vs, i) => {
    if (vs === undefined && i % nodeRankFactor !== 0) {
      --delta;
    } else if (vs !== undefined && delta) {
      vs.forEach(v => g.node(v).rank += delta);
    }
  });
}

function addBorderNode$1(g, prefix, rank, order) {
  let node = {
    width: 0,
    height: 0
  };
  if (arguments.length >= 4) {
    node.rank = rank;
    node.order = order;
  }
  return addDummyNode(g, "border", node, prefix);
}

function maxRank(g) {
  return Math.max(...g.nodes().map(v => {
    let rank = g.node(v).rank;
    if (rank === undefined) {
      return Number.MIN_VALUE;
    }

    return rank;
  }));
}

/*
 * Partition a collection into two groups: `lhs` and `rhs`. If the supplied
 * function returns true for an entry it goes into `lhs`. Otherwise it goes
 * into `rhs.
 */
function partition(collection, fn) {
  let result = { lhs: [], rhs: [] };
  collection.forEach(value => {
    if (fn(value)) {
      result.lhs.push(value);
    } else {
      result.rhs.push(value);
    }
  });
  return result;
}

/*
 * Returns a new function that wraps `fn` with a timer. The wrapper logs the
 * time it takes to execute the function.
 */
function time(name, fn) {
  let start = Date.now();
  try {
    return fn();
  } finally {
    console.log(name + " time: " + (Date.now() - start) + "ms");
  }
}

function notime(name, fn) {
  return fn();
}

let idCounter = 0;
function uniqueId$1(prefix) {
  var id = ++idCounter;
  return toString(prefix) + id;
}

function range(start, limit, step = 1) {
  if (limit == null) {
    limit = start;
    start = 0;
  }

  let endCon = (i) => i < limit;
  if (step < 0) {
    endCon = (i) => limit < i;
  }

  const range = [];
  for (let i = start; endCon(i); i += step) {
    range.push(i);
  }

  return range;
}

function pick(source, keys) {
  const dest = {};
  for (const key of keys) {
    if (source[key] !== undefined) {
      dest[key] = source[key];
    }
  }

  return dest;
}

function mapValues(obj, funcOrProp) {
  let func = funcOrProp;
  if (typeof funcOrProp === 'string') {
    func = (val) => val[funcOrProp];
  }

  return Object.entries(obj).reduce((acc, [k, v]) => {
    acc[k] = func(v, k);
    return acc;
  }, {});
}

function zipObject$1(props, values) {
  return props.reduce((acc, key, i) => {
    acc[key] = values[i];
    return acc;
  }, {});
}

let greedyFAS = greedyFas;
let uniqueId = util$d.uniqueId;

var acyclic$1 = {
  run: run$2,
  undo: undo$2
};

function run$2(g) {
  let fas = (g.graph().acyclicer === "greedy"
    ? greedyFAS(g, weightFn(g))
    : dfsFAS(g));
  fas.forEach(e => {
    let label = g.edge(e);
    g.removeEdge(e);
    label.forwardName = e.name;
    label.reversed = true;
    g.setEdge(e.w, e.v, label, uniqueId("rev"));
  });

  function weightFn(g) {
    return e => {
      return g.edge(e).weight;
    };
  }
}

function dfsFAS(g) {
  let fas = [];
  let stack = {};
  let visited = {};

  function dfs(v) {
    if (visited.hasOwnProperty(v)) {
      return;
    }
    visited[v] = true;
    stack[v] = true;
    g.outEdges(v).forEach(e => {
      if (stack.hasOwnProperty(e.w)) {
        fas.push(e);
      } else {
        dfs(e.w);
      }
    });
    delete stack[v];
  }

  g.nodes().forEach(dfs);
  return fas;
}

function undo$2(g) {
  g.edges().forEach(e => {
    let label = g.edge(e);
    if (label.reversed) {
      g.removeEdge(e);

      let forwardName = label.forwardName;
      delete label.reversed;
      delete label.forwardName;
      g.setEdge(e.w, e.v, label, forwardName);
    }
  });
}

let util$c = util$d;

var normalize$1 = {
  run: run$1,
  undo: undo$1
};

/*
 * Breaks any long edges in the graph into short segments that span 1 layer
 * each. This operation is undoable with the denormalize function.
 *
 * Pre-conditions:
 *
 *    1. The input graph is a DAG.
 *    2. Each node in the graph has a "rank" property.
 *
 * Post-condition:
 *
 *    1. All edges in the graph have a length of 1.
 *    2. Dummy nodes are added where edges have been split into segments.
 *    3. The graph is augmented with a "dummyChains" attribute which contains
 *       the first dummy in each chain of dummy nodes produced.
 */
function run$1(g) {
  g.graph().dummyChains = [];
  g.edges().forEach(edge => normalizeEdge(g, edge));
}

function normalizeEdge(g, e) {
  let v = e.v;
  let vRank = g.node(v).rank;
  let w = e.w;
  let wRank = g.node(w).rank;
  let name = e.name;
  let edgeLabel = g.edge(e);
  let labelRank = edgeLabel.labelRank;

  if (wRank === vRank + 1) return;

  g.removeEdge(e);

  let dummy, attrs, i;
  for (i = 0, ++vRank; vRank < wRank; ++i, ++vRank) {
    edgeLabel.points = [];
    attrs = {
      width: 0, height: 0,
      edgeLabel: edgeLabel, edgeObj: e,
      rank: vRank
    };
    dummy = util$c.addDummyNode(g, "edge", attrs, "_d");
    if (vRank === labelRank) {
      attrs.width = edgeLabel.width;
      attrs.height = edgeLabel.height;
      attrs.dummy = "edge-label";
      attrs.labelpos = edgeLabel.labelpos;
    }
    g.setEdge(v, dummy, { weight: edgeLabel.weight }, name);
    if (i === 0) {
      g.graph().dummyChains.push(dummy);
    }
    v = dummy;
  }

  g.setEdge(v, w, { weight: edgeLabel.weight }, name);
}

function undo$1(g) {
  g.graph().dummyChains.forEach(v => {
    let node = g.node(v);
    let origLabel = node.edgeLabel;
    let w;
    g.setEdge(node.edgeObj, origLabel);
    while (node.dummy) {
      w = g.successors(v)[0];
      g.removeNode(v);
      origLabel.points.push({ x: node.x, y: node.y });
      if (node.dummy === "edge-label") {
        origLabel.x = node.x;
        origLabel.y = node.y;
        origLabel.width = node.width;
        origLabel.height = node.height;
      }
      v = w;
      node = g.node(v);
    }
  });
}

var util$b = {
  longestPath: longestPath$1,
  slack: slack$2
};

/*
 * Initializes ranks for the input graph using the longest path algorithm. This
 * algorithm scales well and is fast in practice, it yields rather poor
 * solutions. Nodes are pushed to the lowest layer possible, leaving the bottom
 * ranks wide and leaving edges longer than necessary. However, due to its
 * speed, this algorithm is good for getting an initial ranking that can be fed
 * into other algorithms.
 *
 * This algorithm does not normalize layers because it will be used by other
 * algorithms in most cases. If using this algorithm directly, be sure to
 * run normalize at the end.
 *
 * Pre-conditions:
 *
 *    1. Input graph is a DAG.
 *    2. Input graph node labels can be assigned properties.
 *
 * Post-conditions:
 *
 *    1. Each node will be assign an (unnormalized) "rank" property.
 */
function longestPath$1(g) {
  var visited = {};

  function dfs(v) {
    var label = g.node(v);
    if (visited.hasOwnProperty(v)) {
      return label.rank;
    }
    visited[v] = true;

    var rank = Math.min(...g.outEdges(v).map(e => {
      if (e == null) {
        return Number.POSITIVE_INFINITY;
      }

      return dfs(e.w) - g.edge(e).minlen;
    }));

    if (rank === Number.POSITIVE_INFINITY) {
      rank = 0;
    }

    return (label.rank = rank);
  }

  g.sources().forEach(dfs);
}

/*
 * Returns the amount of slack for the given edge. The slack is defined as the
 * difference between the length of the edge and its minimum length.
 */
function slack$2(g, e) {
  return g.node(e.w).rank - g.node(e.v).rank - g.edge(e).minlen;
}

var Graph$5 = graphlib.Graph;
var slack$1 = util$b.slack;

var feasibleTree_1 = feasibleTree$2;

/*
 * Constructs a spanning tree with tight edges and adjusted the input node's
 * ranks to achieve this. A tight edge is one that is has a length that matches
 * its "minlen" attribute.
 *
 * The basic structure for this function is derived from Gansner, et al., "A
 * Technique for Drawing Directed Graphs."
 *
 * Pre-conditions:
 *
 *    1. Graph must be a DAG.
 *    2. Graph must be connected.
 *    3. Graph must have at least one node.
 *    5. Graph nodes must have been previously assigned a "rank" property that
 *       respects the "minlen" property of incident edges.
 *    6. Graph edges must have a "minlen" property.
 *
 * Post-conditions:
 *
 *    - Graph nodes will have their rank adjusted to ensure that all edges are
 *      tight.
 *
 * Returns a tree (undirected graph) that is constructed using only "tight"
 * edges.
 */
function feasibleTree$2(g) {
  var t = new Graph$5({ directed: false });

  // Choose arbitrary node from which to start our tree
  var start = g.nodes()[0];
  var size = g.nodeCount();
  t.setNode(start, {});

  var edge, delta;
  while (tightTree(t, g) < size) {
    edge = findMinSlackEdge(t, g);
    delta = t.hasNode(edge.v) ? slack$1(g, edge) : -slack$1(g, edge);
    shiftRanks(t, g, delta);
  }

  return t;
}

/*
 * Finds a maximal tree of tight edges and returns the number of nodes in the
 * tree.
 */
function tightTree(t, g) {
  function dfs(v) {
    g.nodeEdges(v).forEach(e => {
      var edgeV = e.v,
        w = (v === edgeV) ? e.w : edgeV;
      if (!t.hasNode(w) && !slack$1(g, e)) {
        t.setNode(w, {});
        t.setEdge(v, w, {});
        dfs(w);
      }
    });
  }

  t.nodes().forEach(dfs);
  return t.nodeCount();
}

/*
 * Finds the edge with the smallest slack that is incident on tree and returns
 * it.
 */
function findMinSlackEdge(t, g) {
  const edges = g.edges();

  return edges.reduce((acc, edge) => {
    let edgeSlack = Number.POSITIVE_INFINITY;
    if (t.hasNode(edge.v) !== t.hasNode(edge.w)) {
      edgeSlack = slack$1(g, edge);
    }

    if (edgeSlack < acc[0]) {
      return [edgeSlack, edge];
    }

    return acc;
  }, [Number.POSITIVE_INFINITY, null])[1];
}

function shiftRanks(t, g, delta) {
  t.nodes().forEach(v => g.node(v).rank += delta);
}

var feasibleTree$1 = feasibleTree_1;
var slack = util$b.slack;
var initRank = util$b.longestPath;
var preorder = graphlib.alg.preorder;
var postorder$1 = graphlib.alg.postorder;
var simplify = util$d.simplify;

var networkSimplex_1 = networkSimplex$1;

// Expose some internals for testing purposes
networkSimplex$1.initLowLimValues = initLowLimValues;
networkSimplex$1.initCutValues = initCutValues;
networkSimplex$1.calcCutValue = calcCutValue;
networkSimplex$1.leaveEdge = leaveEdge;
networkSimplex$1.enterEdge = enterEdge;
networkSimplex$1.exchangeEdges = exchangeEdges;

/*
 * The network simplex algorithm assigns ranks to each node in the input graph
 * and iteratively improves the ranking to reduce the length of edges.
 *
 * Preconditions:
 *
 *    1. The input graph must be a DAG.
 *    2. All nodes in the graph must have an object value.
 *    3. All edges in the graph must have "minlen" and "weight" attributes.
 *
 * Postconditions:
 *
 *    1. All nodes in the graph will have an assigned "rank" attribute that has
 *       been optimized by the network simplex algorithm. Ranks start at 0.
 *
 *
 * A rough sketch of the algorithm is as follows:
 *
 *    1. Assign initial ranks to each node. We use the longest path algorithm,
 *       which assigns ranks to the lowest position possible. In general this
 *       leads to very wide bottom ranks and unnecessarily long edges.
 *    2. Construct a feasible tight tree. A tight tree is one such that all
 *       edges in the tree have no slack (difference between length of edge
 *       and minlen for the edge). This by itself greatly improves the assigned
 *       rankings by shorting edges.
 *    3. Iteratively find edges that have negative cut values. Generally a
 *       negative cut value indicates that the edge could be removed and a new
 *       tree edge could be added to produce a more compact graph.
 *
 * Much of the algorithms here are derived from Gansner, et al., "A Technique
 * for Drawing Directed Graphs." The structure of the file roughly follows the
 * structure of the overall algorithm.
 */
function networkSimplex$1(g) {
  g = simplify(g);
  initRank(g);
  var t = feasibleTree$1(g);
  initLowLimValues(t);
  initCutValues(t, g);

  var e, f;
  while ((e = leaveEdge(t))) {
    f = enterEdge(t, g, e);
    exchangeEdges(t, g, e, f);
  }
}

/*
 * Initializes cut values for all edges in the tree.
 */
function initCutValues(t, g) {
  var vs = postorder$1(t, t.nodes());
  vs = vs.slice(0, vs.length - 1);
  vs.forEach(v => assignCutValue(t, g, v));
}

function assignCutValue(t, g, child) {
  var childLab = t.node(child);
  var parent = childLab.parent;
  t.edge(child, parent).cutvalue = calcCutValue(t, g, child);
}

/*
 * Given the tight tree, its graph, and a child in the graph calculate and
 * return the cut value for the edge between the child and its parent.
 */
function calcCutValue(t, g, child) {
  var childLab = t.node(child);
  var parent = childLab.parent;
  // True if the child is on the tail end of the edge in the directed graph
  var childIsTail = true;
  // The graph's view of the tree edge we're inspecting
  var graphEdge = g.edge(child, parent);
  // The accumulated cut value for the edge between this node and its parent
  var cutValue = 0;

  if (!graphEdge) {
    childIsTail = false;
    graphEdge = g.edge(parent, child);
  }

  cutValue = graphEdge.weight;

  g.nodeEdges(child).forEach(e => {
    var isOutEdge = e.v === child,
      other = isOutEdge ? e.w : e.v;

    if (other !== parent) {
      var pointsToHead = isOutEdge === childIsTail,
        otherWeight = g.edge(e).weight;

      cutValue += pointsToHead ? otherWeight : -otherWeight;
      if (isTreeEdge(t, child, other)) {
        var otherCutValue = t.edge(child, other).cutvalue;
        cutValue += pointsToHead ? -otherCutValue : otherCutValue;
      }
    }
  });

  return cutValue;
}

function initLowLimValues(tree, root) {
  if (arguments.length < 2) {
    root = tree.nodes()[0];
  }
  dfsAssignLowLim(tree, {}, 1, root);
}

function dfsAssignLowLim(tree, visited, nextLim, v, parent) {
  var low = nextLim;
  var label = tree.node(v);

  visited[v] = true;
  tree.neighbors(v).forEach(w => {
    if (!visited.hasOwnProperty(w)) {
      nextLim = dfsAssignLowLim(tree, visited, nextLim, w, v);
    }
  });

  label.low = low;
  label.lim = nextLim++;
  if (parent) {
    label.parent = parent;
  } else {
    // TODO should be able to remove this when we incrementally update low lim
    delete label.parent;
  }

  return nextLim;
}

function leaveEdge(tree) {
  return tree.edges().find(e => tree.edge(e).cutvalue < 0);
}

function enterEdge(t, g, edge) {
  var v = edge.v;
  var w = edge.w;

  // For the rest of this function we assume that v is the tail and w is the
  // head, so if we don't have this edge in the graph we should flip it to
  // match the correct orientation.
  if (!g.hasEdge(v, w)) {
    v = edge.w;
    w = edge.v;
  }

  var vLabel = t.node(v);
  var wLabel = t.node(w);
  var tailLabel = vLabel;
  var flip = false;

  // If the root is in the tail of the edge then we need to flip the logic that
  // checks for the head and tail nodes in the candidates function below.
  if (vLabel.lim > wLabel.lim) {
    tailLabel = wLabel;
    flip = true;
  }

  var candidates = g.edges().filter(edge => {
    return flip === isDescendant(t, t.node(edge.v), tailLabel) &&
           flip !== isDescendant(t, t.node(edge.w), tailLabel);
  });

  return candidates.reduce((acc, edge) => {
    if (slack(g, edge) < slack(g, acc)) {
      return edge;
    }

    return acc;
  });
}

function exchangeEdges(t, g, e, f) {
  var v = e.v;
  var w = e.w;
  t.removeEdge(v, w);
  t.setEdge(f.v, f.w, {});
  initLowLimValues(t);
  initCutValues(t, g);
  updateRanks(t, g);
}

function updateRanks(t, g) {
  var root = t.nodes().find(v => !g.node(v).parent);
  var vs = preorder(t, root);
  vs = vs.slice(1);
  vs.forEach(v => {
    var parent = t.node(v).parent,
      edge = g.edge(v, parent),
      flipped = false;

    if (!edge) {
      edge = g.edge(parent, v);
      flipped = true;
    }

    g.node(v).rank = g.node(parent).rank + (flipped ? edge.minlen : -edge.minlen);
  });
}

/*
 * Returns true if the edge is in the tree.
 */
function isTreeEdge(tree, u, v) {
  return tree.hasEdge(u, v);
}

/*
 * Returns true if the specified node is descendant of the root node per the
 * assigned low and lim attributes in the tree.
 */
function isDescendant(tree, vLabel, rootLabel) {
  return rootLabel.low <= vLabel.lim && vLabel.lim <= rootLabel.lim;
}

var rankUtil = util$b;
var longestPath = rankUtil.longestPath;
var feasibleTree = feasibleTree_1;
var networkSimplex = networkSimplex_1;

var rank_1 = rank$1;

/*
 * Assigns a rank to each node in the input graph that respects the "minlen"
 * constraint specified on edges between nodes.
 *
 * This basic structure is derived from Gansner, et al., "A Technique for
 * Drawing Directed Graphs."
 *
 * Pre-conditions:
 *
 *    1. Graph must be a connected DAG
 *    2. Graph nodes must be objects
 *    3. Graph edges must have "weight" and "minlen" attributes
 *
 * Post-conditions:
 *
 *    1. Graph nodes will have a "rank" attribute based on the results of the
 *       algorithm. Ranks can start at any index (including negative), we'll
 *       fix them up later.
 */
function rank$1(g) {
  switch(g.graph().ranker) {
  case "network-simplex": networkSimplexRanker(g); break;
  case "tight-tree": tightTreeRanker(g); break;
  case "longest-path": longestPathRanker(g); break;
  default: networkSimplexRanker(g);
  }
}

// A fast and simple ranker, but results are far from optimal.
var longestPathRanker = longestPath;

function tightTreeRanker(g) {
  longestPath(g);
  feasibleTree(g);
}

function networkSimplexRanker(g) {
  networkSimplex(g);
}

var parentDummyChains_1 = parentDummyChains$1;

function parentDummyChains$1(g) {
  let postorderNums = postorder(g);

  g.graph().dummyChains.forEach(v => {
    let node = g.node(v);
    let edgeObj = node.edgeObj;
    let pathData = findPath(g, postorderNums, edgeObj.v, edgeObj.w);
    let path = pathData.path;
    let lca = pathData.lca;
    let pathIdx = 0;
    let pathV = path[pathIdx];
    let ascending = true;

    while (v !== edgeObj.w) {
      node = g.node(v);

      if (ascending) {
        while ((pathV = path[pathIdx]) !== lca &&
               g.node(pathV).maxRank < node.rank) {
          pathIdx++;
        }

        if (pathV === lca) {
          ascending = false;
        }
      }

      if (!ascending) {
        while (pathIdx < path.length - 1 &&
               g.node(pathV = path[pathIdx + 1]).minRank <= node.rank) {
          pathIdx++;
        }
        pathV = path[pathIdx];
      }

      g.setParent(v, pathV);
      v = g.successors(v)[0];
    }
  });
}

// Find a path from v to w through the lowest common ancestor (LCA). Return the
// full path and the LCA.
function findPath(g, postorderNums, v, w) {
  let vPath = [];
  let wPath = [];
  let low = Math.min(postorderNums[v].low, postorderNums[w].low);
  let lim = Math.max(postorderNums[v].lim, postorderNums[w].lim);
  let parent;
  let lca;

  // Traverse up from v to find the LCA
  parent = v;
  do {
    parent = g.parent(parent);
    vPath.push(parent);
  } while (parent &&
           (postorderNums[parent].low > low || lim > postorderNums[parent].lim));
  lca = parent;

  // Traverse from w to LCA
  parent = w;
  while ((parent = g.parent(parent)) !== lca) {
    wPath.push(parent);
  }

  return { path: vPath.concat(wPath.reverse()), lca: lca };
}

function postorder(g) {
  let result = {};
  let lim = 0;

  function dfs(v) {
    let low = lim;
    g.children(v).forEach(dfs);
    result[v] = { low: low, lim: lim++ };
  }
  g.children().forEach(dfs);

  return result;
}

let util$a = util$d;

var nestingGraph$1 = {
  run,
  cleanup,
};

/*
 * A nesting graph creates dummy nodes for the tops and bottoms of subgraphs,
 * adds appropriate edges to ensure that all cluster nodes are placed between
 * these boundaries, and ensures that the graph is connected.
 *
 * In addition we ensure, through the use of the minlen property, that nodes
 * and subgraph border nodes to not end up on the same rank.
 *
 * Preconditions:
 *
 *    1. Input graph is a DAG
 *    2. Nodes in the input graph has a minlen attribute
 *
 * Postconditions:
 *
 *    1. Input graph is connected.
 *    2. Dummy nodes are added for the tops and bottoms of subgraphs.
 *    3. The minlen attribute for nodes is adjusted to ensure nodes do not
 *       get placed on the same rank as subgraph border nodes.
 *
 * The nesting graph idea comes from Sander, "Layout of Compound Directed
 * Graphs."
 */
function run(g) {
  let root = util$a.addDummyNode(g, "root", {}, "_root");
  let depths = treeDepths(g);
  let height = Math.max(...Object.values(depths)) - 1; // Note: depths is an Object not an array
  let nodeSep = 2 * height + 1;

  g.graph().nestingRoot = root;

  // Multiply minlen by nodeSep to align nodes on non-border ranks.
  g.edges().forEach(e => g.edge(e).minlen *= nodeSep);

  // Calculate a weight that is sufficient to keep subgraphs vertically compact
  let weight = sumWeights(g) + 1;

  // Create border nodes and link them up
  g.children().forEach(child => dfs(g, root, nodeSep, weight, height, depths, child));

  // Save the multiplier for node layers for later removal of empty border
  // layers.
  g.graph().nodeRankFactor = nodeSep;
}

function dfs(g, root, nodeSep, weight, height, depths, v) {
  let children = g.children(v);
  if (!children.length) {
    if (v !== root) {
      g.setEdge(root, v, { weight: 0, minlen: nodeSep });
    }
    return;
  }

  let top = util$a.addBorderNode(g, "_bt");
  let bottom = util$a.addBorderNode(g, "_bb");
  let label = g.node(v);

  g.setParent(top, v);
  label.borderTop = top;
  g.setParent(bottom, v);
  label.borderBottom = bottom;

  children.forEach(child => {
    dfs(g, root, nodeSep, weight, height, depths, child);

    let childNode = g.node(child);
    let childTop = childNode.borderTop ? childNode.borderTop : child;
    let childBottom = childNode.borderBottom ? childNode.borderBottom : child;
    let thisWeight = childNode.borderTop ? weight : 2 * weight;
    let minlen = childTop !== childBottom ? 1 : height - depths[v] + 1;

    g.setEdge(top, childTop, {
      weight: thisWeight,
      minlen: minlen,
      nestingEdge: true
    });

    g.setEdge(childBottom, bottom, {
      weight: thisWeight,
      minlen: minlen,
      nestingEdge: true
    });
  });

  if (!g.parent(v)) {
    g.setEdge(root, top, { weight: 0, minlen: height + depths[v] });
  }
}

function treeDepths(g) {
  var depths = {};
  function dfs(v, depth) {
    var children = g.children(v);
    if (children && children.length) {
      children.forEach(child => dfs(child, depth + 1));
    }
    depths[v] = depth;
  }
  g.children().forEach(v => dfs(v, 1));
  return depths;
}

function sumWeights(g) {
  return g.edges().reduce((acc, e) => acc + g.edge(e).weight, 0);
}

function cleanup(g) {
  var graphLabel = g.graph();
  g.removeNode(graphLabel.nestingRoot);
  delete graphLabel.nestingRoot;
  g.edges().forEach(e => {
    var edge = g.edge(e);
    if (edge.nestingEdge) {
      g.removeEdge(e);
    }
  });
}

let util$9 = util$d;

var addBorderSegments_1 = addBorderSegments$1;

function addBorderSegments$1(g) {
  function dfs(v) {
    let children = g.children(v);
    let node = g.node(v);
    if (children.length) {
      children.forEach(dfs);
    }

    if (node.hasOwnProperty("minRank")) {
      node.borderLeft = [];
      node.borderRight = [];
      for (let rank = node.minRank, maxRank = node.maxRank + 1;
        rank < maxRank;
        ++rank) {
        addBorderNode(g, "borderLeft", "_bl", v, node, rank);
        addBorderNode(g, "borderRight", "_br", v, node, rank);
      }
    }
  }

  g.children().forEach(dfs);
}

function addBorderNode(g, prop, prefix, sg, sgNode, rank) {
  let label = { width: 0, height: 0, rank: rank, borderType: prop };
  let prev = sgNode[prop][rank - 1];
  let curr = util$9.addDummyNode(g, "border", label, prefix);
  sgNode[prop][rank] = curr;
  g.setParent(curr, sg);
  if (prev) {
    g.setEdge(prev, curr, { weight: 1 });
  }
}

var coordinateSystem$1 = {
  adjust: adjust,
  undo: undo
};

function adjust(g) {
  let rankDir = g.graph().rankdir.toLowerCase();
  if (rankDir === "lr" || rankDir === "rl") {
    swapWidthHeight(g);
  }
}

function undo(g) {
  let rankDir = g.graph().rankdir.toLowerCase();
  if (rankDir === "bt" || rankDir === "rl") {
    reverseY(g);
  }

  if (rankDir === "lr" || rankDir === "rl") {
    swapXY(g);
    swapWidthHeight(g);
  }
}

function swapWidthHeight(g) {
  g.nodes().forEach(v => swapWidthHeightOne(g.node(v)));
  g.edges().forEach(e => swapWidthHeightOne(g.edge(e)));
}

function swapWidthHeightOne(attrs) {
  let w = attrs.width;
  attrs.width = attrs.height;
  attrs.height = w;
}

function reverseY(g) {
  g.nodes().forEach(v => reverseYOne(g.node(v)));

  g.edges().forEach(e => {
    let edge = g.edge(e);
    edge.points.forEach(reverseYOne);
    if (edge.hasOwnProperty("y")) {
      reverseYOne(edge);
    }
  });
}

function reverseYOne(attrs) {
  attrs.y = -attrs.y;
}

function swapXY(g) {
  g.nodes().forEach(v => swapXYOne(g.node(v)));

  g.edges().forEach(e => {
    let edge = g.edge(e);
    edge.points.forEach(swapXYOne);
    if (edge.hasOwnProperty("x")) {
      swapXYOne(edge);
    }
  });
}

function swapXYOne(attrs) {
  let x = attrs.x;
  attrs.x = attrs.y;
  attrs.y = x;
}

let util$8 = util$d;

var initOrder_1 = initOrder$1;

/*
 * Assigns an initial order value for each node by performing a DFS search
 * starting from nodes in the first rank. Nodes are assigned an order in their
 * rank as they are first visited.
 *
 * This approach comes from Gansner, et al., "A Technique for Drawing Directed
 * Graphs."
 *
 * Returns a layering matrix with an array per layer and each layer sorted by
 * the order of its nodes.
 */
function initOrder$1(g) {
  let visited = {};
  let simpleNodes = g.nodes().filter(v => !g.children(v).length);
  let maxRank = Math.max(...simpleNodes.map(v => g.node(v).rank));
  let layers = util$8.range(maxRank + 1).map(() => []);

  function dfs(v) {
    if (visited[v]) return;
    visited[v] = true;
    let node = g.node(v);
    layers[node.rank].push(v);
    g.successors(v).forEach(dfs);
  }

  let orderedVs = simpleNodes.sort((a, b) => g.node(a).rank - g.node(b).rank);
  orderedVs.forEach(dfs);

  return layers;
}

let zipObject = util$d.zipObject;

var crossCount_1 = crossCount$1;

/*
 * A function that takes a layering (an array of layers, each with an array of
 * ordererd nodes) and a graph and returns a weighted crossing count.
 *
 * Pre-conditions:
 *
 *    1. Input graph must be simple (not a multigraph), directed, and include
 *       only simple edges.
 *    2. Edges in the input graph must have assigned weights.
 *
 * Post-conditions:
 *
 *    1. The graph and layering matrix are left unchanged.
 *
 * This algorithm is derived from Barth, et al., "Bilayer Cross Counting."
 */
function crossCount$1(g, layering) {
  let cc = 0;
  for (let i = 1; i < layering.length; ++i) {
    cc += twoLayerCrossCount(g, layering[i-1], layering[i]);
  }
  return cc;
}

function twoLayerCrossCount(g, northLayer, southLayer) {
  // Sort all of the edges between the north and south layers by their position
  // in the north layer and then the south. Map these edges to the position of
  // their head in the south layer.
  let southPos = zipObject(southLayer, southLayer.map((v, i) => i));
  let southEntries = northLayer.flatMap(v => {
    return g.outEdges(v).map(e => {
      return { pos: southPos[e.w], weight: g.edge(e).weight };
    }).sort((a, b) => a.pos - b.pos);
  });

  // Build the accumulator tree
  let firstIndex = 1;
  while (firstIndex < southLayer.length) firstIndex <<= 1;
  let treeSize = 2 * firstIndex - 1;
  firstIndex -= 1;
  let tree = new Array(treeSize).fill(0);

  // Calculate the weighted crossings
  let cc = 0;
  southEntries.forEach(entry => {
    let index = entry.pos + firstIndex;
    tree[index] += entry.weight;
    let weightSum = 0;
    while (index > 0) {
      if (index % 2) {
        weightSum += tree[index + 1];
      }
      index = (index - 1) >> 1;
      tree[index] += entry.weight;
    }
    cc += entry.weight * weightSum;
  });

  return cc;
}

var barycenter_1 = barycenter$1;

function barycenter$1(g, movable = []) {
  return movable.map(v => {
    let inV = g.inEdges(v);
    if (!inV.length) {
      return { v: v };
    } else {
      let result = inV.reduce((acc, e) => {
        let edge = g.edge(e),
          nodeU = g.node(e.v);
        return {
          sum: acc.sum + (edge.weight * nodeU.order),
          weight: acc.weight + edge.weight
        };
      }, { sum: 0, weight: 0 });

      return {
        v: v,
        barycenter: result.sum / result.weight,
        weight: result.weight
      };
    }
  });
}

let util$7 = util$d;

var resolveConflicts_1 = resolveConflicts$1;

/*
 * Given a list of entries of the form {v, barycenter, weight} and a
 * constraint graph this function will resolve any conflicts between the
 * constraint graph and the barycenters for the entries. If the barycenters for
 * an entry would violate a constraint in the constraint graph then we coalesce
 * the nodes in the conflict into a new node that respects the contraint and
 * aggregates barycenter and weight information.
 *
 * This implementation is based on the description in Forster, "A Fast and
 * Simple Hueristic for Constrained Two-Level Crossing Reduction," thought it
 * differs in some specific details.
 *
 * Pre-conditions:
 *
 *    1. Each entry has the form {v, barycenter, weight}, or if the node has
 *       no barycenter, then {v}.
 *
 * Returns:
 *
 *    A new list of entries of the form {vs, i, barycenter, weight}. The list
 *    `vs` may either be a singleton or it may be an aggregation of nodes
 *    ordered such that they do not violate constraints from the constraint
 *    graph. The property `i` is the lowest original index of any of the
 *    elements in `vs`.
 */
function resolveConflicts$1(entries, cg) {
  let mappedEntries = {};
  entries.forEach((entry, i) => {
    let tmp = mappedEntries[entry.v] = {
      indegree: 0,
      "in": [],
      out: [],
      vs: [entry.v],
      i: i
    };
    if (entry.barycenter !== undefined) {
      tmp.barycenter = entry.barycenter;
      tmp.weight = entry.weight;
    }
  });

  cg.edges().forEach(e => {
    let entryV = mappedEntries[e.v];
    let entryW = mappedEntries[e.w];
    if (entryV !== undefined && entryW !== undefined) {
      entryW.indegree++;
      entryV.out.push(mappedEntries[e.w]);
    }
  });

  let sourceSet = Object.values(mappedEntries).filter(entry => !entry.indegree);

  return doResolveConflicts(sourceSet);
}

function doResolveConflicts(sourceSet) {
  let entries = [];

  function handleIn(vEntry) {
    return uEntry => {
      if (uEntry.merged) {
        return;
      }
      if (uEntry.barycenter === undefined ||
          vEntry.barycenter === undefined ||
          uEntry.barycenter >= vEntry.barycenter) {
        mergeEntries(vEntry, uEntry);
      }
    };
  }

  function handleOut(vEntry) {
    return wEntry => {
      wEntry["in"].push(vEntry);
      if (--wEntry.indegree === 0) {
        sourceSet.push(wEntry);
      }
    };
  }

  while (sourceSet.length) {
    let entry = sourceSet.pop();
    entries.push(entry);
    entry["in"].reverse().forEach(handleIn(entry));
    entry.out.forEach(handleOut(entry));
  }

  return entries.filter(entry => !entry.merged).map(entry => {
    return util$7.pick(entry, ["vs", "i", "barycenter", "weight"]);
  });
}

function mergeEntries(target, source) {
  let sum = 0;
  let weight = 0;

  if (target.weight) {
    sum += target.barycenter * target.weight;
    weight += target.weight;
  }

  if (source.weight) {
    sum += source.barycenter * source.weight;
    weight += source.weight;
  }

  target.vs = source.vs.concat(target.vs);
  target.barycenter = sum / weight;
  target.weight = weight;
  target.i = Math.min(source.i, target.i);
  source.merged = true;
}

let util$6 = util$d;

var sort_1 = sort$1;

function sort$1(entries, biasRight) {
  let parts = util$6.partition(entries, entry => {
    return entry.hasOwnProperty("barycenter");
  });
  let sortable = parts.lhs,
    unsortable = parts.rhs.sort((a, b) => b.i - a.i),
    vs = [],
    sum = 0,
    weight = 0,
    vsIndex = 0;

  sortable.sort(compareWithBias(!!biasRight));

  vsIndex = consumeUnsortable(vs, unsortable, vsIndex);

  sortable.forEach(entry => {
    vsIndex += entry.vs.length;
    vs.push(entry.vs);
    sum += entry.barycenter * entry.weight;
    weight += entry.weight;
    vsIndex = consumeUnsortable(vs, unsortable, vsIndex);
  });

  let result = { vs: vs.flat(true) };
  if (weight) {
    result.barycenter = sum / weight;
    result.weight = weight;
  }
  return result;
}

function consumeUnsortable(vs, unsortable, index) {
  let last;
  while (unsortable.length && (last = unsortable[unsortable.length - 1]).i <= index) {
    unsortable.pop();
    vs.push(last.vs);
    index++;
  }
  return index;
}

function compareWithBias(bias) {
  return (entryV, entryW) => {
    if (entryV.barycenter < entryW.barycenter) {
      return -1;
    } else if (entryV.barycenter > entryW.barycenter) {
      return 1;
    }

    return !bias ? entryV.i - entryW.i : entryW.i - entryV.i;
  };
}

let barycenter = barycenter_1;
let resolveConflicts = resolveConflicts_1;
let sort = sort_1;

var sortSubgraph_1 = sortSubgraph$1;

function sortSubgraph$1(g, v, cg, biasRight) {
  let movable = g.children(v);
  let node = g.node(v);
  let bl = node ? node.borderLeft : undefined;
  let br = node ? node.borderRight: undefined;
  let subgraphs = {};

  if (bl) {
    movable = movable.filter(w => w !== bl && w !== br);
  }

  let barycenters = barycenter(g, movable);
  barycenters.forEach(entry => {
    if (g.children(entry.v).length) {
      let subgraphResult = sortSubgraph$1(g, entry.v, cg, biasRight);
      subgraphs[entry.v] = subgraphResult;
      if (subgraphResult.hasOwnProperty("barycenter")) {
        mergeBarycenters(entry, subgraphResult);
      }
    }
  });

  let entries = resolveConflicts(barycenters, cg);
  expandSubgraphs(entries, subgraphs);

  let result = sort(entries, biasRight);

  if (bl) {
    result.vs = [bl, result.vs, br].flat(true);
    if (g.predecessors(bl).length) {
      let blPred = g.node(g.predecessors(bl)[0]),
        brPred = g.node(g.predecessors(br)[0]);
      if (!result.hasOwnProperty("barycenter")) {
        result.barycenter = 0;
        result.weight = 0;
      }
      result.barycenter = (result.barycenter * result.weight +
                           blPred.order + brPred.order) / (result.weight + 2);
      result.weight += 2;
    }
  }

  return result;
}

function expandSubgraphs(entries, subgraphs) {
  entries.forEach(entry => {
    entry.vs = entry.vs.flatMap(v => {
      if (subgraphs[v]) {
        return subgraphs[v].vs;
      }
      return v;
    });
  });
}

function mergeBarycenters(target, other) {
  if (target.barycenter !== undefined) {
    target.barycenter = (target.barycenter * target.weight +
                         other.barycenter * other.weight) /
                        (target.weight + other.weight);
    target.weight += other.weight;
  } else {
    target.barycenter = other.barycenter;
    target.weight = other.weight;
  }
}

let Graph$4 = graphlib.Graph;
let util$5 = util$d;

var buildLayerGraph_1 = buildLayerGraph$1;

/*
 * Constructs a graph that can be used to sort a layer of nodes. The graph will
 * contain all base and subgraph nodes from the request layer in their original
 * hierarchy and any edges that are incident on these nodes and are of the type
 * requested by the "relationship" parameter.
 *
 * Nodes from the requested rank that do not have parents are assigned a root
 * node in the output graph, which is set in the root graph attribute. This
 * makes it easy to walk the hierarchy of movable nodes during ordering.
 *
 * Pre-conditions:
 *
 *    1. Input graph is a DAG
 *    2. Base nodes in the input graph have a rank attribute
 *    3. Subgraph nodes in the input graph has minRank and maxRank attributes
 *    4. Edges have an assigned weight
 *
 * Post-conditions:
 *
 *    1. Output graph has all nodes in the movable rank with preserved
 *       hierarchy.
 *    2. Root nodes in the movable layer are made children of the node
 *       indicated by the root attribute of the graph.
 *    3. Non-movable nodes incident on movable nodes, selected by the
 *       relationship parameter, are included in the graph (without hierarchy).
 *    4. Edges incident on movable nodes, selected by the relationship
 *       parameter, are added to the output graph.
 *    5. The weights for copied edges are aggregated as need, since the output
 *       graph is not a multi-graph.
 */
function buildLayerGraph$1(g, rank, relationship) {
  let root = createRootNode(g),
    result = new Graph$4({ compound: true }).setGraph({ root: root })
      .setDefaultNodeLabel(v => g.node(v));

  g.nodes().forEach(v => {
    let node = g.node(v),
      parent = g.parent(v);

    if (node.rank === rank || node.minRank <= rank && rank <= node.maxRank) {
      result.setNode(v);
      result.setParent(v, parent || root);

      // This assumes we have only short edges!
      g[relationship](v).forEach(e => {
        let u = e.v === v ? e.w : e.v,
          edge = result.edge(u, v),
          weight = edge !== undefined ? edge.weight : 0;
        result.setEdge(u, v, { weight: g.edge(e).weight + weight });
      });

      if (node.hasOwnProperty("minRank")) {
        result.setNode(v, {
          borderLeft: node.borderLeft[rank],
          borderRight: node.borderRight[rank]
        });
      }
    }
  });

  return result;
}

function createRootNode(g) {
  var v;
  while (g.hasNode((v = util$5.uniqueId("_root"))));
  return v;
}

var addSubgraphConstraints_1 = addSubgraphConstraints$1;

function addSubgraphConstraints$1(g, cg, vs) {
  let prev = {},
    rootPrev;

  vs.forEach(v => {
    let child = g.parent(v),
      parent,
      prevChild;
    while (child) {
      parent = g.parent(child);
      if (parent) {
        prevChild = prev[parent];
        prev[parent] = child;
      } else {
        prevChild = rootPrev;
        rootPrev = child;
      }
      if (prevChild && prevChild !== child) {
        cg.setEdge(prevChild, child);
        return;
      }
      child = parent;
    }
  });

  /*
  function dfs(v) {
    var children = v ? g.children(v) : g.children();
    if (children.length) {
      var min = Number.POSITIVE_INFINITY,
          subgraphs = [];
      children.forEach(function(child) {
        var childMin = dfs(child);
        if (g.children(child).length) {
          subgraphs.push({ v: child, order: childMin });
        }
        min = Math.min(min, childMin);
      });
      _.sortBy(subgraphs, "order").reduce(function(prev, curr) {
        cg.setEdge(prev.v, curr.v);
        return curr;
      });
      return min;
    }
    return g.node(v).order;
  }
  dfs(undefined);
  */
}

let initOrder = initOrder_1;
let crossCount = crossCount_1;
let sortSubgraph = sortSubgraph_1;
let buildLayerGraph = buildLayerGraph_1;
let addSubgraphConstraints = addSubgraphConstraints_1;
let Graph$3 = graphlib.Graph;
let util$4 = util$d;

var order_1 = order$1;

/*
 * Applies heuristics to minimize edge crossings in the graph and sets the best
 * order solution as an order attribute on each node.
 *
 * Pre-conditions:
 *
 *    1. Graph must be DAG
 *    2. Graph nodes must be objects with a "rank" attribute
 *    3. Graph edges must have the "weight" attribute
 *
 * Post-conditions:
 *
 *    1. Graph nodes will have an "order" attribute based on the results of the
 *       algorithm.
 */
function order$1(g) {
  let maxRank = util$4.maxRank(g),
    downLayerGraphs = buildLayerGraphs(g, util$4.range(1, maxRank + 1), "inEdges"),
    upLayerGraphs = buildLayerGraphs(g, util$4.range(maxRank - 1, -1, -1), "outEdges");

  let layering = initOrder(g);
  assignOrder(g, layering);

  let bestCC = Number.POSITIVE_INFINITY,
    best;

  for (let i = 0, lastBest = 0; lastBest < 4; ++i, ++lastBest) {
    sweepLayerGraphs(i % 2 ? downLayerGraphs : upLayerGraphs, i % 4 >= 2);

    layering = util$4.buildLayerMatrix(g);
    let cc = crossCount(g, layering);
    if (cc < bestCC) {
      lastBest = 0;
      best = Object.assign({}, layering);
      bestCC = cc;
    }
  }

  assignOrder(g, best);
}

function buildLayerGraphs(g, ranks, relationship) {
  return ranks.map(function(rank) {
    return buildLayerGraph(g, rank, relationship);
  });
}

function sweepLayerGraphs(layerGraphs, biasRight) {
  let cg = new Graph$3();
  layerGraphs.forEach(function(lg) {
    let root = lg.graph().root;
    let sorted = sortSubgraph(lg, root, cg, biasRight);
    sorted.vs.forEach((v, i) => lg.node(v).order = i);
    addSubgraphConstraints(lg, cg, sorted.vs);
  });
}

function assignOrder(g, layering) {
  Object.values(layering).forEach(layer => layer.forEach((v, i) => g.node(v).order = i));
}

let Graph$2 = graphlib.Graph;
let util$3 = util$d;

/*
 * This module provides coordinate assignment based on Brandes and Köpf, "Fast
 * and Simple Horizontal Coordinate Assignment."
 */

var bk = {
  positionX: positionX$1,
  findType1Conflicts: findType1Conflicts,
  findType2Conflicts: findType2Conflicts,
  addConflict: addConflict,
  hasConflict: hasConflict,
  verticalAlignment: verticalAlignment,
  horizontalCompaction: horizontalCompaction,
  alignCoordinates: alignCoordinates,
  findSmallestWidthAlignment: findSmallestWidthAlignment,
  balance: balance
};

/*
 * Marks all edges in the graph with a type-1 conflict with the "type1Conflict"
 * property. A type-1 conflict is one where a non-inner segment crosses an
 * inner segment. An inner segment is an edge with both incident nodes marked
 * with the "dummy" property.
 *
 * This algorithm scans layer by layer, starting with the second, for type-1
 * conflicts between the current layer and the previous layer. For each layer
 * it scans the nodes from left to right until it reaches one that is incident
 * on an inner segment. It then scans predecessors to determine if they have
 * edges that cross that inner segment. At the end a final scan is done for all
 * nodes on the current rank to see if they cross the last visited inner
 * segment.
 *
 * This algorithm (safely) assumes that a dummy node will only be incident on a
 * single node in the layers being scanned.
 */
function findType1Conflicts(g, layering) {
  let conflicts = {};

  function visitLayer(prevLayer, layer) {
    let
      // last visited node in the previous layer that is incident on an inner
      // segment.
      k0 = 0,
      // Tracks the last node in this layer scanned for crossings with a type-1
      // segment.
      scanPos = 0,
      prevLayerLength = prevLayer.length,
      lastNode = layer[layer.length - 1];

    layer.forEach((v, i) => {
      let w = findOtherInnerSegmentNode(g, v),
        k1 = w ? g.node(w).order : prevLayerLength;

      if (w || v === lastNode) {
        layer.slice(scanPos, i+1).forEach(scanNode => {
          g.predecessors(scanNode).forEach(u => {
            let uLabel = g.node(u),
              uPos = uLabel.order;
            if ((uPos < k0 || k1 < uPos) &&
                !(uLabel.dummy && g.node(scanNode).dummy)) {
              addConflict(conflicts, u, scanNode);
            }
          });
        });
        scanPos = i + 1;
        k0 = k1;
      }
    });

    return layer;
  }

  layering.reduce(visitLayer);
  return conflicts;
}

function findType2Conflicts(g, layering) {
  let conflicts = {};

  function scan(south, southPos, southEnd, prevNorthBorder, nextNorthBorder) {
    let v;
    util$3.range(southPos, southEnd).forEach(i => {
      v = south[i];
      if (g.node(v).dummy) {
        g.predecessors(v).forEach(u => {
          let uNode = g.node(u);
          if (uNode.dummy &&
              (uNode.order < prevNorthBorder || uNode.order > nextNorthBorder)) {
            addConflict(conflicts, u, v);
          }
        });
      }
    });
  }


  function visitLayer(north, south) {
    let prevNorthPos = -1,
      nextNorthPos,
      southPos = 0;

    south.forEach((v, southLookahead) => {
      if (g.node(v).dummy === "border") {
        let predecessors = g.predecessors(v);
        if (predecessors.length) {
          nextNorthPos = g.node(predecessors[0]).order;
          scan(south, southPos, southLookahead, prevNorthPos, nextNorthPos);
          southPos = southLookahead;
          prevNorthPos = nextNorthPos;
        }
      }
      scan(south, southPos, south.length, nextNorthPos, north.length);
    });

    return south;
  }

  layering.reduce(visitLayer);
  return conflicts;
}

function findOtherInnerSegmentNode(g, v) {
  if (g.node(v).dummy) {
    return g.predecessors(v).find(u => g.node(u).dummy);
  }
}

function addConflict(conflicts, v, w) {
  if (v > w) {
    let tmp = v;
    v = w;
    w = tmp;
  }

  let conflictsV = conflicts[v];
  if (!conflictsV) {
    conflicts[v] = conflictsV = {};
  }
  conflictsV[w] = true;
}

function hasConflict(conflicts, v, w) {
  if (v > w) {
    let tmp = v;
    v = w;
    w = tmp;
  }
  return !!conflicts[v] && conflicts[v].hasOwnProperty(w);
}

/*
 * Try to align nodes into vertical "blocks" where possible. This algorithm
 * attempts to align a node with one of its median neighbors. If the edge
 * connecting a neighbor is a type-1 conflict then we ignore that possibility.
 * If a previous node has already formed a block with a node after the node
 * we're trying to form a block with, we also ignore that possibility - our
 * blocks would be split in that scenario.
 */
function verticalAlignment(g, layering, conflicts, neighborFn) {
  let root = {},
    align = {},
    pos = {};

  // We cache the position here based on the layering because the graph and
  // layering may be out of sync. The layering matrix is manipulated to
  // generate different extreme alignments.
  layering.forEach(layer => {
    layer.forEach((v, order) => {
      root[v] = v;
      align[v] = v;
      pos[v] = order;
    });
  });

  layering.forEach(layer => {
    let prevIdx = -1;
    layer.forEach(v => {
      let ws = neighborFn(v);
      if (ws.length) {
        ws = ws.sort((a, b) => pos[a] - pos[b]);
        let mp = (ws.length - 1) / 2;
        for (let i = Math.floor(mp), il = Math.ceil(mp); i <= il; ++i) {
          let w = ws[i];
          if (align[v] === v &&
              prevIdx < pos[w] &&
              !hasConflict(conflicts, v, w)) {
            align[w] = v;
            align[v] = root[v] = root[w];
            prevIdx = pos[w];
          }
        }
      }
    });
  });

  return { root: root, align: align };
}

function horizontalCompaction(g, layering, root, align, reverseSep) {
  // This portion of the algorithm differs from BK due to a number of problems.
  // Instead of their algorithm we construct a new block graph and do two
  // sweeps. The first sweep places blocks with the smallest possible
  // coordinates. The second sweep removes unused space by moving blocks to the
  // greatest coordinates without violating separation.
  let xs = {},
    blockG = buildBlockGraph(g, layering, root, reverseSep),
    borderType = reverseSep ? "borderLeft" : "borderRight";

  function iterate(setXsFunc, nextNodesFunc) {
    let stack = blockG.nodes();
    let elem = stack.pop();
    let visited = {};
    while (elem) {
      if (visited[elem]) {
        setXsFunc(elem);
      } else {
        visited[elem] = true;
        stack.push(elem);
        stack = stack.concat(nextNodesFunc(elem));
      }

      elem = stack.pop();
    }
  }

  // First pass, assign smallest coordinates
  function pass1(elem) {
    xs[elem] = blockG.inEdges(elem).reduce((acc, e) => {
      return Math.max(acc, xs[e.v] + blockG.edge(e));
    }, 0);
  }

  // Second pass, assign greatest coordinates
  function pass2(elem) {
    let min = blockG.outEdges(elem).reduce((acc, e) => {
      return Math.min(acc, xs[e.w] - blockG.edge(e));
    }, Number.POSITIVE_INFINITY);

    let node = g.node(elem);
    if (min !== Number.POSITIVE_INFINITY && node.borderType !== borderType) {
      xs[elem] = Math.max(xs[elem], min);
    }
  }

  iterate(pass1, blockG.predecessors.bind(blockG));
  iterate(pass2, blockG.successors.bind(blockG));

  // Assign x coordinates to all nodes
  Object.keys(align).forEach(v => xs[v] = xs[root[v]]);

  return xs;
}


function buildBlockGraph(g, layering, root, reverseSep) {
  let blockGraph = new Graph$2(),
    graphLabel = g.graph(),
    sepFn = sep(graphLabel.nodesep, graphLabel.edgesep, reverseSep);

  layering.forEach(layer => {
    let u;
    layer.forEach(v => {
      let vRoot = root[v];
      blockGraph.setNode(vRoot);
      if (u) {
        var uRoot = root[u],
          prevMax = blockGraph.edge(uRoot, vRoot);
        blockGraph.setEdge(uRoot, vRoot, Math.max(sepFn(g, v, u), prevMax || 0));
      }
      u = v;
    });
  });

  return blockGraph;
}

/*
 * Returns the alignment that has the smallest width of the given alignments.
 */
function findSmallestWidthAlignment(g, xss) {
  return Object.values(xss).reduce((currentMinAndXs, xs) => {
    let max = Number.NEGATIVE_INFINITY;
    let min = Number.POSITIVE_INFINITY;

    Object.entries(xs).forEach(([v, x]) => {
      let halfWidth = width(g, v) / 2;

      max = Math.max(x + halfWidth, max);
      min = Math.min(x - halfWidth, min);
    });

    const newMin = max - min;
    if (newMin < currentMinAndXs[0]) {
      currentMinAndXs = [newMin, xs];
    }
    return currentMinAndXs;
  }, [Number.POSITIVE_INFINITY, null])[1];
}

/*
 * Align the coordinates of each of the layout alignments such that
 * left-biased alignments have their minimum coordinate at the same point as
 * the minimum coordinate of the smallest width alignment and right-biased
 * alignments have their maximum coordinate at the same point as the maximum
 * coordinate of the smallest width alignment.
 */
function alignCoordinates(xss, alignTo) {
  let alignToVals = Object.values(alignTo),
    alignToMin = Math.min(...alignToVals),
    alignToMax = Math.max(...alignToVals);

  ["u", "d"].forEach(vert => {
    ["l", "r"].forEach(horiz => {
      let alignment = vert + horiz,
        xs = xss[alignment];

      if (xs === alignTo) return;

      let xsVals = Object.values(xs);
      let delta = alignToMin - Math.min(...xsVals);
      if (horiz !== "l") {
        delta = alignToMax - Math.max(...xsVals);
      }

      if (delta) {
        xss[alignment] = util$3.mapValues(xs, x => x + delta);
      }
    });
  });
}

function balance(xss, align) {
  return util$3.mapValues(xss.ul, (num, v) => {
    if (align) {
      return xss[align.toLowerCase()][v];
    } else {
      let xs = Object.values(xss).map(xs => xs[v]).sort((a, b) => a - b);
      return (xs[1] + xs[2]) / 2;
    }
  });
}

function positionX$1(g) {
  let layering = util$3.buildLayerMatrix(g);
  let conflicts = Object.assign(
    findType1Conflicts(g, layering),
    findType2Conflicts(g, layering));

  let xss = {};
  let adjustedLayering;
  ["u", "d"].forEach(vert => {
    adjustedLayering = vert === "u" ? layering : Object.values(layering).reverse();
    ["l", "r"].forEach(horiz => {
      if (horiz === "r") {
        adjustedLayering = adjustedLayering.map(inner => {
          return Object.values(inner).reverse();
        });
      }

      let neighborFn = (vert === "u" ? g.predecessors : g.successors).bind(g);
      let align = verticalAlignment(g, adjustedLayering, conflicts, neighborFn);
      let xs = horizontalCompaction(g, adjustedLayering,
        align.root, align.align, horiz === "r");
      if (horiz === "r") {
        xs = util$3.mapValues(xs, x => -x);
      }
      xss[vert + horiz] = xs;
    });
  });


  let smallestWidth = findSmallestWidthAlignment(g, xss);
  alignCoordinates(xss, smallestWidth);
  return balance(xss, g.graph().align);
}

function sep(nodeSep, edgeSep, reverseSep) {
  return (g, v, w) => {
    let vLabel = g.node(v);
    let wLabel = g.node(w);
    let sum = 0;
    let delta;

    sum += vLabel.width / 2;
    if (vLabel.hasOwnProperty("labelpos")) {
      switch (vLabel.labelpos.toLowerCase()) {
      case "l": delta = -vLabel.width / 2; break;
      case "r": delta = vLabel.width / 2; break;
      }
    }
    if (delta) {
      sum += reverseSep ? delta : -delta;
    }
    delta = 0;

    sum += (vLabel.dummy ? edgeSep : nodeSep) / 2;
    sum += (wLabel.dummy ? edgeSep : nodeSep) / 2;

    sum += wLabel.width / 2;
    if (wLabel.hasOwnProperty("labelpos")) {
      switch (wLabel.labelpos.toLowerCase()) {
      case "l": delta = wLabel.width / 2; break;
      case "r": delta = -wLabel.width / 2; break;
      }
    }
    if (delta) {
      sum += reverseSep ? delta : -delta;
    }
    delta = 0;

    return sum;
  };
}

function width(g, v) {
  return g.node(v).width;
}

let util$2 = util$d;
let positionX = bk.positionX;

var position_1 = position$1;

function position$1(g) {
  g = util$2.asNonCompoundGraph(g);

  positionY(g);
  Object.entries(positionX(g)).forEach(([v, x]) => g.node(v).x = x);
}

function positionY(g) {
  let layering = util$2.buildLayerMatrix(g);
  let rankSep = g.graph().ranksep;
  let prevY = 0;
  layering.forEach(layer => {
    const maxHeight = layer.reduce((acc, v) => {
      const height = g.node(v).height;
      if (acc > height) {
        return acc;
      } else {
        return height;
      }
    }, 0);
    layer.forEach(v => g.node(v).y = prevY + maxHeight / 2);
    prevY += maxHeight + rankSep;
  });
}

let acyclic = acyclic$1;
let normalize = normalize$1;
let rank = rank_1;
let normalizeRanks = util$d.normalizeRanks;
let parentDummyChains = parentDummyChains_1;
let removeEmptyRanks = util$d.removeEmptyRanks;
let nestingGraph = nestingGraph$1;
let addBorderSegments = addBorderSegments_1;
let coordinateSystem = coordinateSystem$1;
let order = order_1;
let position = position_1;
let util$1 = util$d;
let Graph$1 = graphlib.Graph;

var layout_1 = layout;

function layout(g, opts) {
  let time = opts && opts.debugTiming ? util$1.time : util$1.notime;
  time("layout", () => {
    let layoutGraph =
      time("  buildLayoutGraph", () => buildLayoutGraph(g));
    time("  runLayout",        () => runLayout(layoutGraph, time));
    time("  updateInputGraph", () => updateInputGraph(g, layoutGraph));
  });
}

function runLayout(g, time) {
  time("    makeSpaceForEdgeLabels", () => makeSpaceForEdgeLabels(g));
  time("    removeSelfEdges",        () => removeSelfEdges(g));
  time("    acyclic",                () => acyclic.run(g));
  time("    nestingGraph.run",       () => nestingGraph.run(g));
  time("    rank",                   () => rank(util$1.asNonCompoundGraph(g)));
  time("    injectEdgeLabelProxies", () => injectEdgeLabelProxies(g));
  time("    removeEmptyRanks",       () => removeEmptyRanks(g));
  time("    nestingGraph.cleanup",   () => nestingGraph.cleanup(g));
  time("    normalizeRanks",         () => normalizeRanks(g));
  time("    assignRankMinMax",       () => assignRankMinMax(g));
  time("    removeEdgeLabelProxies", () => removeEdgeLabelProxies(g));
  time("    normalize.run",          () => normalize.run(g));
  time("    parentDummyChains",      () => parentDummyChains(g));
  time("    addBorderSegments",      () => addBorderSegments(g));
  time("    order",                  () => order(g));
  time("    insertSelfEdges",        () => insertSelfEdges(g));
  time("    adjustCoordinateSystem", () => coordinateSystem.adjust(g));
  time("    position",               () => position(g));
  time("    positionSelfEdges",      () => positionSelfEdges(g));
  time("    removeBorderNodes",      () => removeBorderNodes(g));
  time("    normalize.undo",         () => normalize.undo(g));
  time("    fixupEdgeLabelCoords",   () => fixupEdgeLabelCoords(g));
  time("    undoCoordinateSystem",   () => coordinateSystem.undo(g));
  time("    translateGraph",         () => translateGraph(g));
  time("    assignNodeIntersects",   () => assignNodeIntersects(g));
  time("    reversePoints",          () => reversePointsForReversedEdges(g));
  time("    acyclic.undo",           () => acyclic.undo(g));
}

/*
 * Copies final layout information from the layout graph back to the input
 * graph. This process only copies whitelisted attributes from the layout graph
 * to the input graph, so it serves as a good place to determine what
 * attributes can influence layout.
 */
function updateInputGraph(inputGraph, layoutGraph) {
  inputGraph.nodes().forEach(v => {
    let inputLabel = inputGraph.node(v);
    let layoutLabel = layoutGraph.node(v);

    if (inputLabel) {
      inputLabel.x = layoutLabel.x;
      inputLabel.y = layoutLabel.y;
      inputLabel.rank = layoutLabel.rank;

      if (layoutGraph.children(v).length) {
        inputLabel.width = layoutLabel.width;
        inputLabel.height = layoutLabel.height;
      }
    }
  });

  inputGraph.edges().forEach(e => {
    let inputLabel = inputGraph.edge(e);
    let layoutLabel = layoutGraph.edge(e);

    inputLabel.points = layoutLabel.points;
    if (layoutLabel.hasOwnProperty("x")) {
      inputLabel.x = layoutLabel.x;
      inputLabel.y = layoutLabel.y;
    }
  });

  inputGraph.graph().width = layoutGraph.graph().width;
  inputGraph.graph().height = layoutGraph.graph().height;
}

let graphNumAttrs = ["nodesep", "edgesep", "ranksep", "marginx", "marginy"];
let graphDefaults = { ranksep: 50, edgesep: 20, nodesep: 50, rankdir: "tb" };
let graphAttrs = ["acyclicer", "ranker", "rankdir", "align"];
let nodeNumAttrs = ["width", "height"];
let nodeDefaults = { width: 0, height: 0 };
let edgeNumAttrs = ["minlen", "weight", "width", "height", "labeloffset"];
let edgeDefaults = {
  minlen: 1, weight: 1, width: 0, height: 0,
  labeloffset: 10, labelpos: "r"
};
let edgeAttrs = ["labelpos"];

/*
 * Constructs a new graph from the input graph, which can be used for layout.
 * This process copies only whitelisted attributes from the input graph to the
 * layout graph. Thus this function serves as a good place to determine what
 * attributes can influence layout.
 */
function buildLayoutGraph(inputGraph) {
  let g = new Graph$1({ multigraph: true, compound: true });
  let graph = canonicalize(inputGraph.graph());

  g.setGraph(Object.assign({},
    graphDefaults,
    selectNumberAttrs(graph, graphNumAttrs),
    util$1.pick(graph, graphAttrs)));

  inputGraph.nodes().forEach(v => {
    let node = canonicalize(inputGraph.node(v));
    const newNode = selectNumberAttrs(node, nodeNumAttrs);
    Object.keys(nodeDefaults).forEach(k => {
      if (newNode[k] === undefined) {
        newNode[k] = nodeDefaults[k];
      }
    });

    g.setNode(v, newNode);
    g.setParent(v, inputGraph.parent(v));
  });

  inputGraph.edges().forEach(e => {
    let edge = canonicalize(inputGraph.edge(e));
    g.setEdge(e, Object.assign({},
      edgeDefaults,
      selectNumberAttrs(edge, edgeNumAttrs),
      util$1.pick(edge, edgeAttrs)));
  });

  return g;
}

/*
 * This idea comes from the Gansner paper: to account for edge labels in our
 * layout we split each rank in half by doubling minlen and halving ranksep.
 * Then we can place labels at these mid-points between nodes.
 *
 * We also add some minimal padding to the width to push the label for the edge
 * away from the edge itself a bit.
 */
function makeSpaceForEdgeLabels(g) {
  let graph = g.graph();
  graph.ranksep /= 2;
  g.edges().forEach(e => {
    let edge = g.edge(e);
    edge.minlen *= 2;
    if (edge.labelpos.toLowerCase() !== "c") {
      if (graph.rankdir === "TB" || graph.rankdir === "BT") {
        edge.width += edge.labeloffset;
      } else {
        edge.height += edge.labeloffset;
      }
    }
  });
}

/*
 * Creates temporary dummy nodes that capture the rank in which each edge's
 * label is going to, if it has one of non-zero width and height. We do this
 * so that we can safely remove empty ranks while preserving balance for the
 * label's position.
 */
function injectEdgeLabelProxies(g) {
  g.edges().forEach(e => {
    let edge = g.edge(e);
    if (edge.width && edge.height) {
      let v = g.node(e.v);
      let w = g.node(e.w);
      let label = { rank: (w.rank - v.rank) / 2 + v.rank, e: e };
      util$1.addDummyNode(g, "edge-proxy", label, "_ep");
    }
  });
}

function assignRankMinMax(g) {
  let maxRank = 0;
  g.nodes().forEach(v => {
    let node = g.node(v);
    if (node.borderTop) {
      node.minRank = g.node(node.borderTop).rank;
      node.maxRank = g.node(node.borderBottom).rank;
      maxRank = Math.max(maxRank, node.maxRank);
    }
  });
  g.graph().maxRank = maxRank;
}

function removeEdgeLabelProxies(g) {
  g.nodes().forEach(v => {
    let node = g.node(v);
    if (node.dummy === "edge-proxy") {
      g.edge(node.e).labelRank = node.rank;
      g.removeNode(v);
    }
  });
}

function translateGraph(g) {
  let minX = Number.POSITIVE_INFINITY;
  let maxX = 0;
  let minY = Number.POSITIVE_INFINITY;
  let maxY = 0;
  let graphLabel = g.graph();
  let marginX = graphLabel.marginx || 0;
  let marginY = graphLabel.marginy || 0;

  function getExtremes(attrs) {
    let x = attrs.x;
    let y = attrs.y;
    let w = attrs.width;
    let h = attrs.height;
    minX = Math.min(minX, x - w / 2);
    maxX = Math.max(maxX, x + w / 2);
    minY = Math.min(minY, y - h / 2);
    maxY = Math.max(maxY, y + h / 2);
  }

  g.nodes().forEach(v => getExtremes(g.node(v)));
  g.edges().forEach(e => {
    let edge = g.edge(e);
    if (edge.hasOwnProperty("x")) {
      getExtremes(edge);
    }
  });

  minX -= marginX;
  minY -= marginY;

  g.nodes().forEach(v => {
    let node = g.node(v);
    node.x -= minX;
    node.y -= minY;
  });

  g.edges().forEach(e => {
    let edge = g.edge(e);
    edge.points.forEach(p => {
      p.x -= minX;
      p.y -= minY;
    });
    if (edge.hasOwnProperty("x")) { edge.x -= minX; }
    if (edge.hasOwnProperty("y")) { edge.y -= minY; }
  });

  graphLabel.width = maxX - minX + marginX;
  graphLabel.height = maxY - minY + marginY;
}

function assignNodeIntersects(g) {
  g.edges().forEach(e => {
    let edge = g.edge(e);
    let nodeV = g.node(e.v);
    let nodeW = g.node(e.w);
    let p1, p2;
    if (!edge.points) {
      edge.points = [];
      p1 = nodeW;
      p2 = nodeV;
    } else {
      p1 = edge.points[0];
      p2 = edge.points[edge.points.length - 1];
    }
    edge.points.unshift(util$1.intersectRect(nodeV, p1));
    edge.points.push(util$1.intersectRect(nodeW, p2));
  });
}

function fixupEdgeLabelCoords(g) {
  g.edges().forEach(e => {
    let edge = g.edge(e);
    if (edge.hasOwnProperty("x")) {
      if (edge.labelpos === "l" || edge.labelpos === "r") {
        edge.width -= edge.labeloffset;
      }
      switch (edge.labelpos) {
      case "l": edge.x -= edge.width / 2 + edge.labeloffset; break;
      case "r": edge.x += edge.width / 2 + edge.labeloffset; break;
      }
    }
  });
}

function reversePointsForReversedEdges(g) {
  g.edges().forEach(e => {
    let edge = g.edge(e);
    if (edge.reversed) {
      edge.points.reverse();
    }
  });
}

function removeBorderNodes(g) {
  g.nodes().forEach(v => {
    if (g.children(v).length) {
      let node = g.node(v);
      let t = g.node(node.borderTop);
      let b = g.node(node.borderBottom);
      let l = g.node(node.borderLeft[node.borderLeft.length - 1]);
      let r = g.node(node.borderRight[node.borderRight.length - 1]);

      node.width = Math.abs(r.x - l.x);
      node.height = Math.abs(b.y - t.y);
      node.x = l.x + node.width / 2;
      node.y = t.y + node.height / 2;
    }
  });

  g.nodes().forEach(v => {
    if (g.node(v).dummy === "border") {
      g.removeNode(v);
    }
  });
}

function removeSelfEdges(g) {
  g.edges().forEach(e => {
    if (e.v === e.w) {
      var node = g.node(e.v);
      if (!node.selfEdges) {
        node.selfEdges = [];
      }
      node.selfEdges.push({ e: e, label: g.edge(e) });
      g.removeEdge(e);
    }
  });
}

function insertSelfEdges(g) {
  var layers = util$1.buildLayerMatrix(g);
  layers.forEach(layer => {
    var orderShift = 0;
    layer.forEach((v, i) => {
      var node = g.node(v);
      node.order = i + orderShift;
      (node.selfEdges || []).forEach(selfEdge => {
        util$1.addDummyNode(g, "selfedge", {
          width: selfEdge.label.width,
          height: selfEdge.label.height,
          rank: node.rank,
          order: i + (++orderShift),
          e: selfEdge.e,
          label: selfEdge.label
        }, "_se");
      });
      delete node.selfEdges;
    });
  });
}

function positionSelfEdges(g) {
  g.nodes().forEach(v => {
    var node = g.node(v);
    if (node.dummy === "selfedge") {
      var selfNode = g.node(node.e.v);
      var x = selfNode.x + selfNode.width / 2;
      var y = selfNode.y;
      var dx = node.x - x;
      var dy = selfNode.height / 2;
      g.setEdge(node.e, node.label);
      g.removeNode(v);
      node.label.points = [
        { x: x + 2 * dx / 3, y: y - dy },
        { x: x + 5 * dx / 6, y: y - dy },
        { x: x +     dx    , y: y },
        { x: x + 5 * dx / 6, y: y + dy },
        { x: x + 2 * dx / 3, y: y + dy }
      ];
      node.label.x = node.x;
      node.label.y = node.y;
    }
  });
}

function selectNumberAttrs(obj, attrs) {
  return util$1.mapValues(util$1.pick(obj, attrs), Number);
}

function canonicalize(attrs) {
  var newAttrs = {};
  if (attrs) {
    Object.entries(attrs).forEach(([k, v]) => {
      if (typeof k === "string") {
        k = k.toLowerCase();
      }

      newAttrs[k] = v;
    });
  }
  return newAttrs;
}

let util = util$d;
let Graph = graphlib.Graph;

var debug = {
  debugOrdering: debugOrdering
};

/* istanbul ignore next */
function debugOrdering(g) {
  let layerMatrix = util.buildLayerMatrix(g);

  let h = new Graph({ compound: true, multigraph: true }).setGraph({});

  g.nodes().forEach(v => {
    h.setNode(v, { label: v });
    h.setParent(v, "layer" + g.node(v).rank);
  });

  g.edges().forEach(e => h.setEdge(e.v, e.w, {}, e.name));

  layerMatrix.forEach((layer, i) => {
    let layerV = "layer" + i;
    h.setNode(layerV, { rank: "same" });
    layer.reduce((u, v) => {
      h.setEdge(u, v, { style: "invis" });
      return v;
    });
  });

  return h;
}

var version = "1.0.4";

/*
Copyright (c) 2012-2014 Chris Pettitt

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

var dagre = {
  graphlib: graphlib,

  layout: layout_1,
  debug: debug,
  util: {
    time: util$d.time,
    notime: util$d.notime
  },
  version: version
};

const dagre$1 = /*@__PURE__*/getDefaultExportFromCjs(dagre);

const useFlow = (props) => {
  const { fitView } = useReactFlow();
  const [nodes, setNodes, onNodesChange] = useNodesState([]);
  const [edges, setEdges, onEdgesChange] = useEdgesState([]);
  const [layout, setLayout] = reactExports.useState("LR");
  const switchLayout = reactExports.useCallback(
    () => {
      const rankdir = layout === "TB" ? "LR" : "TB";
      const layouted = getLayoutedElements(props, rankdir);
      setNodes([...layouted.nodes]);
      setEdges([...layouted.edges]);
      setLayout(rankdir);
      window.requestAnimationFrame(() => {
        fitView();
      });
    },
    [nodes, edges]
  );
  reactExports.useEffect(() => {
    switchLayout();
  }, []);
  return { nodes, edges, onNodesChange, onEdgesChange, switchLayout, layout };
};
const getLayoutedElements = ({ nodes, graph }, rankdir) => {
  const g = new dagre$1.graphlib.Graph().setDefaultEdgeLabel(() => ({}));
  g.setGraph({ rankdir });
  nodes.forEach((node) => {
    g.setNode(node.id, { label: node.label, width: 150, height: 150 });
  });
  const inEdges = {};
  const outEdges = {};
  Object.entries(graph).forEach(([source, targets]) => {
    targets.forEach((target) => {
      g.setEdge(source, target);
      if (!inEdges[target]) {
        inEdges[target] = /* @__PURE__ */ new Set();
      }
      if (!outEdges[source]) {
        outEdges[source] = /* @__PURE__ */ new Set();
      }
      inEdges[target].add(source);
      outEdges[source].add(target);
    });
  });
  dagre$1.layout(g);
  const edges = g.edges().map(({ v, w }) => ({
    id: `e${v}${w}`,
    source: v,
    sourceHandle: w,
    target: w,
    type: "smoothstep"
    // animated: true,
  }));
  return {
    nodes: nodes.map((node) => {
      const { x, y } = g.node(node.id);
      return {
        id: node.id,
        type: "node",
        data: {
          node,
          inEdges: [...inEdges[node.id] || []],
          outEdges: [...outEdges[node.id] || []]
        },
        position: { x, y }
      };
    }),
    edges
  };
};

// THIS FILE IS AUTO GENERATED
function BiExitFullscreen (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 24 24"},"child":[{"tag":"path","attr":{"d":"M10 4H8v4H4v2h6zM8 20h2v-6H4v2h4zm12-6h-6v6h2v-4h4zm0-6h-4V4h-2v6h6z"}}]})(props);
}function BiFullscreen (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 24 24"},"child":[{"tag":"path","attr":{"d":"M5 5h5V3H3v7h2zm5 14H5v-5H3v7h7zm11-5h-2v5h-5v2h7zm-2-4h2V3h-7v2h5z"}}]})(props);
}

// THIS FILE IS AUTO GENERATED
function FaGripHorizontal (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 448 512"},"child":[{"tag":"path","attr":{"d":"M96 288H32c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32zm160 0h-64c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32zm160 0h-64c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32zM96 96H32c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32zm160 0h-64c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32zm160 0h-64c-17.67 0-32 14.33-32 32v64c0 17.67 14.33 32 32 32h64c17.67 0 32-14.33 32-32v-64c0-17.67-14.33-32-32-32z"}}]})(props);
}function FaGripLinesVertical (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 256 512"},"child":[{"tag":"path","attr":{"d":"M96 496V16c0-8.8-7.2-16-16-16H48c-8.8 0-16 7.2-16 16v480c0 8.8 7.2 16 16 16h32c8.8 0 16-7.2 16-16zm128 0V16c0-8.8-7.2-16-16-16h-32c-8.8 0-16 7.2-16 16v480c0 8.8 7.2 16 16 16h32c8.8 0 16-7.2 16-16z"}}]})(props);
}

const nodeTypes = { node: DiagraphNode };
const useFullScreen = () => {
  const ref = reactExports.useRef(null);
  const [isFullScreen, setIsFullScreen] = reactExports.useState(false);
  const listenFullScreen = reactExports.useCallback(() => {
    setIsFullScreen(!!document.fullscreenElement);
  }, [setIsFullScreen]);
  const goFullScreen = reactExports.useCallback(() => {
    if (document.fullscreenElement) {
      document.exitFullscreen();
    } else {
      if (!ref.current) {
        throw new Error("No ref found");
      }
      ref.current.requestFullscreen();
    }
  }, [ref]);
  reactExports.useEffect(() => {
    document.documentElement.addEventListener("fullscreenchange", listenFullScreen);
    return () => {
      document.documentElement.removeEventListener("fullscreenchange", listenFullScreen);
    };
  }, []);
  console.log(isFullScreen);
  return {
    containerRef: ref,
    goFullScreen,
    isFullScreen
  };
};
const LayoutContext = React.createContext("TB");
const LayoutFlow = (props) => {
  const { nodes, edges, onNodesChange, onEdgesChange, switchLayout, layout } = useFlow(props);
  const { isFullScreen, containerRef, goFullScreen } = useFullScreen();
  console.log("up");
  return /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: styles$2.container, ref: containerRef, children: /* @__PURE__ */ jsxRuntimeExports.jsx(LayoutContext.Provider, { value: layout, children: /* @__PURE__ */ jsxRuntimeExports.jsxs(
    ReactFlow,
    {
      nodes,
      edges,
      onNodesChange,
      onEdgesChange,
      zoomOnScroll: false,
      nodeTypes,
      fitView: true,
      children: [
        /* @__PURE__ */ jsxRuntimeExports.jsx(Background$1, { color: "#ccc", variant: BackgroundVariant.Dots }),
        /* @__PURE__ */ jsxRuntimeExports.jsx(Panel, { position: "top-right", children: /* @__PURE__ */ jsxRuntimeExports.jsxs("div", { className: styles$2.buttonGroup, children: [
          /* @__PURE__ */ jsxRuntimeExports.jsx("button", { title: `${isFullScreen ? "Exit" : "Go"} Full Screen`, onClick: goFullScreen, children: isFullScreen ? /* @__PURE__ */ jsxRuntimeExports.jsx(BiExitFullscreen, {}) : /* @__PURE__ */ jsxRuntimeExports.jsx(BiFullscreen, {}) }),
          /* @__PURE__ */ jsxRuntimeExports.jsx("button", { onClick: switchLayout, children: layout === "LR" ? /* @__PURE__ */ jsxRuntimeExports.jsx(FaGripLinesVertical, {}) : /* @__PURE__ */ jsxRuntimeExports.jsx(FaGripHorizontal, {}) })
        ] }) })
      ]
    }
  ) }) });
};

const style = (version) => `
.react-flow__attribution:before {
  content: 'Diagraph ${version} | Viz by ';
}
`;
function DiagraphViz(props) {
  return /* @__PURE__ */ jsxRuntimeExports.jsx(React.StrictMode, { children: /* @__PURE__ */ jsxRuntimeExports.jsxs(ReactFlowProvider, { children: [
    /* @__PURE__ */ jsxRuntimeExports.jsx("style", { children: style(props.version) }),
    /* @__PURE__ */ jsxRuntimeExports.jsx(LayoutFlow, { ...props })
  ] }) });
}
function renderDiagraphVisualization(target, props) {
  const root = client.createRoot(target);
  root.render(React.createElement(DiagraphViz, props, null));
}

export { renderDiagraphVisualization as default };
